#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 1946
#define SYMBOL_COUNT 208
#define ALIAS_COUNT 3
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 6
#define MAX_ALIAS_SEQUENCE_LENGTH 5

enum {
  sym__newline = 1,
  sym__indent = 2,
  sym__dedent = 3,
  sym__string_start = 4,
  sym__string_content = 5,
  sym__string_end = 6,
  anon_sym_import = 7,
  anon_sym_DOT = 8,
  anon_sym_from = 9,
  anon_sym_LPAREN = 10,
  anon_sym_RPAREN = 11,
  anon_sym_COMMA = 12,
  anon_sym_as = 13,
  anon_sym_STAR = 14,
  anon_sym_print = 15,
  anon_sym_GT_GT = 16,
  anon_sym_assert = 17,
  anon_sym_return = 18,
  anon_sym_del = 19,
  anon_sym_raise = 20,
  anon_sym_pass = 21,
  anon_sym_break = 22,
  anon_sym_continue = 23,
  anon_sym_if = 24,
  anon_sym_COLON = 25,
  anon_sym_elif = 26,
  anon_sym_else = 27,
  anon_sym_async = 28,
  anon_sym_for = 29,
  anon_sym_in = 30,
  anon_sym_while = 31,
  anon_sym_try = 32,
  anon_sym_except = 33,
  anon_sym_finally = 34,
  anon_sym_with = 35,
  anon_sym_def = 36,
  anon_sym_DASH_GT = 37,
  anon_sym_EQ = 38,
  anon_sym_global = 39,
  anon_sym_nonlocal = 40,
  anon_sym_exec = 41,
  anon_sym_class = 42,
  anon_sym_AT = 43,
  anon_sym_not = 44,
  anon_sym_and = 45,
  anon_sym_or = 46,
  anon_sym_PLUS = 47,
  anon_sym_DASH = 48,
  anon_sym_SLASH = 49,
  anon_sym_PERCENT = 50,
  anon_sym_SLASH_SLASH = 51,
  anon_sym_STAR_STAR = 52,
  anon_sym_PIPE = 53,
  anon_sym_AMP = 54,
  anon_sym_CARET = 55,
  anon_sym_LT_LT = 56,
  anon_sym_TILDE = 57,
  anon_sym_LT = 58,
  anon_sym_LT_EQ = 59,
  anon_sym_EQ_EQ = 60,
  anon_sym_BANG_EQ = 61,
  anon_sym_GT_EQ = 62,
  anon_sym_GT = 63,
  anon_sym_LT_GT = 64,
  anon_sym_is = 65,
  anon_sym_lambda = 66,
  anon_sym_PLUS_EQ = 67,
  anon_sym_DASH_EQ = 68,
  anon_sym_STAR_EQ = 69,
  anon_sym_SLASH_EQ = 70,
  anon_sym_AT_EQ = 71,
  anon_sym_SLASH_SLASH_EQ = 72,
  anon_sym_PERCENT_EQ = 73,
  anon_sym_STAR_STAR_EQ = 74,
  anon_sym_GT_GT_EQ = 75,
  anon_sym_LT_LT_EQ = 76,
  anon_sym_AMP_EQ = 77,
  anon_sym_CARET_EQ = 78,
  anon_sym_PIPE_EQ = 79,
  anon_sym_yield = 80,
  anon_sym_LBRACK = 81,
  anon_sym_RBRACK = 82,
  sym_ellipsis = 83,
  anon_sym_LBRACE = 84,
  anon_sym_RBRACE = 85,
  sym_escape_sequence = 86,
  sym_type_conversion = 87,
  sym_integer = 88,
  sym_float = 89,
  sym_identifier = 90,
  sym_true = 91,
  sym_false = 92,
  sym_none = 93,
  anon_sym_await = 94,
  sym_comment = 95,
  sym__semicolon = 96,
  sym_module = 97,
  sym__statement = 98,
  sym__simple_statements = 99,
  sym_import_statement = 100,
  sym_import_prefix = 101,
  sym_relative_import = 102,
  sym_import_from_statement = 103,
  sym__import_list = 104,
  sym_aliased_import = 105,
  sym_wildcard_import = 106,
  sym_print_statement = 107,
  sym_chevron = 108,
  sym_assert_statement = 109,
  sym_expression_statement = 110,
  sym_return_statement = 111,
  sym_delete_statement = 112,
  sym_raise_statement = 113,
  sym_pass_statement = 114,
  sym_break_statement = 115,
  sym_continue_statement = 116,
  sym_if_statement = 117,
  sym_elif_clause = 118,
  sym_else_clause = 119,
  sym_for_statement = 120,
  sym_while_statement = 121,
  sym_try_statement = 122,
  sym_except_clause = 123,
  sym_finally_clause = 124,
  sym_with_statement = 125,
  sym_with_item = 126,
  sym_function_definition = 127,
  sym_parameters = 128,
  sym_lambda_parameters = 129,
  sym__parameters = 130,
  sym_default_parameter = 131,
  sym_typed_default_parameter = 132,
  sym_list_splat = 133,
  sym_dictionary_splat = 134,
  sym_global_statement = 135,
  sym_nonlocal_statement = 136,
  sym_exec_statement = 137,
  sym_class_definition = 138,
  sym_argument_list = 139,
  sym_decorated_definition = 140,
  sym_decorator = 141,
  sym__suite = 142,
  sym_variables = 143,
  sym_expression_list = 144,
  sym_dotted_name = 145,
  sym__expression_within_for_in_clause = 146,
  sym__expression = 147,
  sym__primary_expression = 148,
  sym_not_operator = 149,
  sym_boolean_operator = 150,
  sym_binary_operator = 151,
  sym_unary_operator = 152,
  sym_comparison_operator = 153,
  sym_lambda = 154,
  sym_lambda_within_for_in_clause = 155,
  sym_assignment = 156,
  sym_augmented_assignment = 157,
  sym__right_hand_side = 158,
  sym_yield = 159,
  sym_attribute = 160,
  sym_subscript = 161,
  sym_slice = 162,
  sym_call = 163,
  sym_typed_parameter = 164,
  sym_type = 165,
  sym_keyword_argument = 166,
  sym_list = 167,
  sym__comprehension_body = 168,
  sym_list_comprehension = 169,
  sym_dictionary = 170,
  sym_dictionary_comprehension = 171,
  sym_pair = 172,
  sym_set = 173,
  sym_set_comprehension = 174,
  sym_parenthesized_expression = 175,
  sym_tuple = 176,
  sym_generator_expression = 177,
  sym_for_in_clause = 178,
  sym_if_clause = 179,
  sym_conditional_expression = 180,
  sym_concatenated_string = 181,
  sym_string = 182,
  sym_interpolation = 183,
  sym_await = 184,
  aux_sym_module_repeat1 = 185,
  aux_sym__simple_statements_repeat1 = 186,
  aux_sym_import_prefix_repeat1 = 187,
  aux_sym__import_list_repeat1 = 188,
  aux_sym_print_statement_repeat1 = 189,
  aux_sym_if_statement_repeat1 = 190,
  aux_sym_try_statement_repeat1 = 191,
  aux_sym_with_statement_repeat1 = 192,
  aux_sym__parameters_repeat1 = 193,
  aux_sym_global_statement_repeat1 = 194,
  aux_sym_argument_list_repeat1 = 195,
  aux_sym_decorated_definition_repeat1 = 196,
  aux_sym_variables_repeat1 = 197,
  aux_sym_dotted_name_repeat1 = 198,
  aux_sym_comparison_operator_repeat1 = 199,
  aux_sym_subscript_repeat1 = 200,
  aux_sym_list_repeat1 = 201,
  aux_sym__comprehension_body_repeat1 = 202,
  aux_sym_dictionary_repeat1 = 203,
  aux_sym_tuple_repeat1 = 204,
  aux_sym_for_in_clause_repeat1 = 205,
  aux_sym_concatenated_string_repeat1 = 206,
  aux_sym_string_repeat1 = 207,
  anon_alias_sym_DQUOTE = 208,
  alias_sym_identifier = 209,
  alias_sym_lambda = 210,
};

static const char *ts_symbol_names[] = {
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym__string_start] = "_string_start",
  [sym__string_content] = "_string_content",
  [sym__string_end] = "_string_end",
  [ts_builtin_sym_end] = "END",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_EQ] = "=",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_class] = "class",
  [anon_sym_AT] = "@",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym_ellipsis] = "ellipsis",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym_escape_sequence] = "escape_sequence",
  [sym_type_conversion] = "type_conversion",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_identifier] = "identifier",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [anon_sym_await] = "await",
  [sym_comment] = "comment",
  [sym__semicolon] = "_semicolon",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_item] = "with_item",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym__parameters] = "_parameters",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_class_definition] = "class_definition",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym__suite] = "_suite",
  [sym_variables] = "variables",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym__expression] = "_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda_within_for_in_clause",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym__comprehension_body] = "_comprehension_body",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary] = "dictionary",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_pair] = "pair",
  [sym_set] = "set",
  [sym_set_comprehension] = "set_comprehension",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple] = "tuple",
  [sym_generator_expression] = "generator_expression",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string] = "string",
  [sym_interpolation] = "interpolation",
  [sym_await] = "await",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_with_statement_repeat1] = "with_statement_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_variables_repeat1] = "variables_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
  [aux_sym__comprehension_body_repeat1] = "_comprehension_body_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [anon_alias_sym_DQUOTE] = "\"",
  [alias_sym_identifier] = "identifier",
  [alias_sym_lambda] = "lambda",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = false,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym__suite] = {
    .visible = false,
    .named = true,
  },
  [sym_variables] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_body] = {
    .visible = false,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variables_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_lambda] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[6][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_identifier,
  },
  [2] = {
    [0] = anon_alias_sym_DQUOTE,
    [1] = anon_alias_sym_DQUOTE,
  },
  [3] = {
    [0] = anon_alias_sym_DQUOTE,
    [2] = anon_alias_sym_DQUOTE,
  },
  [4] = {
    [1] = alias_sym_identifier,
  },
  [5] = {
    [0] = alias_sym_lambda,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(12);
      if (lookahead == '+')
        ADVANCE(16);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(19);
      if (lookahead == '.')
        ADVANCE(22);
      if (lookahead == '/')
        ADVANCE(31);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(52);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(59);
      if (lookahead == '@')
        ADVANCE(63);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(66);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '^')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(0);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      if (lookahead == '=')
        ADVANCE(3);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(4);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(5);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(7);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=')
        ADVANCE(9);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(15);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(17);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(21);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(23);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(25);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(29);
      END_STATE();
    case 23:
      if (lookahead == '.')
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(26);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(26);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(30);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(25);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(29);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(25);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(29);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/')
        ADVANCE(32);
      if (lookahead == '=')
        ADVANCE(34);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(30);
      if (lookahead == 'B')
        ADVANCE(36);
      if (lookahead == 'O')
        ADVANCE(40);
      if (lookahead == 'X')
        ADVANCE(43);
      if (lookahead == '_')
        ADVANCE(46);
      if (lookahead == 'b')
        ADVANCE(36);
      if (lookahead == 'o')
        ADVANCE(40);
      if (lookahead == 'x')
        ADVANCE(43);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(47);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(39);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      END_STATE();
    case 36:
      if (lookahead == '_')
        ADVANCE(37);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(38);
      END_STATE();
    case 37:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(38);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(37);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(38);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 40:
      if (lookahead == '_')
        ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(42);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(41);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == '_')
        ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(45);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(44);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(45);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(30);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(47);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(39);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      END_STATE();
    case 47:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(30);
      if (lookahead == '_')
        ADVANCE(46);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(47);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(39);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym__semicolon);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(53);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '>')
        ADVANCE(56);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(60);
      if (lookahead == '>')
        ADVANCE(61);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(62);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=')
        ADVANCE(64);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 66:
      if (lookahead == '\n')
        SKIP(0);
      if (lookahead == '\r')
        SKIP(67);
      END_STATE();
    case 67:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(77);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(78);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(79);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(77);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(79);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(77);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 81:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(86);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(81);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '.')
        ADVANCE(23);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(25);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(29);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 86:
      if (lookahead == '\n')
        SKIP(81);
      if (lookahead == '\r')
        SKIP(87);
      END_STATE();
    case 87:
      if (lookahead == '\n')
        SKIP(81);
      END_STATE();
    case 88:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(88);
      END_STATE();
    case 89:
      if (lookahead == '\n')
        ADVANCE(90);
      if (lookahead == '\r')
        ADVANCE(91);
      if (lookahead == 'U')
        ADVANCE(92);
      if (lookahead == 'o')
        ADVANCE(101);
      if (lookahead == 'u')
        ADVANCE(96);
      if (lookahead == 'x')
        ADVANCE(98);
      if (lookahead != 0)
        ADVANCE(100);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == '{')
        ADVANCE(71);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n')
        ADVANCE(90);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(93);
      END_STATE();
    case 93:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(94);
      END_STATE();
    case 94:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(95);
      END_STATE();
    case 95:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(96);
      END_STATE();
    case 96:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(97);
      END_STATE();
    case 97:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(98);
      END_STATE();
    case 98:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(99);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 101:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(102);
      END_STATE();
    case 102:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(103);
      END_STATE();
    case 103:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(100);
      END_STATE();
    case 104:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '\\')
        SKIP(106);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(104);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 106:
      if (lookahead == '\n')
        SKIP(104);
      if (lookahead == '\r')
        SKIP(107);
      END_STATE();
    case 107:
      if (lookahead == '\n')
        SKIP(104);
      END_STATE();
    case 108:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(109);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '=')
        ADVANCE(110);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(111);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(108);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 111:
      if (lookahead == '\n')
        SKIP(108);
      if (lookahead == '\r')
        SKIP(112);
      END_STATE();
    case 112:
      if (lookahead == '\n')
        SKIP(108);
      END_STATE();
    case 113:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(12);
      if (lookahead == '+')
        ADVANCE(16);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(115);
      if (lookahead == '.')
        ADVANCE(22);
      if (lookahead == '/')
        ADVANCE(31);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(52);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(59);
      if (lookahead == '@')
        ADVANCE(63);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(116);
      if (lookahead == '^')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(113);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 114:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=')
        ADVANCE(20);
      END_STATE();
    case 116:
      if (lookahead == '\n')
        SKIP(113);
      if (lookahead == '\r')
        SKIP(117);
      END_STATE();
    case 117:
      if (lookahead == '\n')
        SKIP(113);
      END_STATE();
    case 118:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(119);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(118);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 119:
      if (lookahead == '\n')
        SKIP(118);
      if (lookahead == '\r')
        SKIP(120);
      END_STATE();
    case 120:
      if (lookahead == '\n')
        SKIP(118);
      END_STATE();
    case 121:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(12);
      if (lookahead == '+')
        ADVANCE(16);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(115);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '/')
        ADVANCE(31);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(52);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(59);
      if (lookahead == '@')
        ADVANCE(63);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(122);
      if (lookahead == '^')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(121);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 122:
      if (lookahead == '\n')
        SKIP(121);
      if (lookahead == '\r')
        SKIP(123);
      END_STATE();
    case 123:
      if (lookahead == '\n')
        SKIP(121);
      END_STATE();
    case 124:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(109);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(125);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(126);
      if (lookahead == '\\')
        SKIP(127);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(124);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '>')
        ADVANCE(56);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 127:
      if (lookahead == '\n')
        SKIP(124);
      if (lookahead == '\r')
        SKIP(128);
      END_STATE();
    case 128:
      if (lookahead == '\n')
        SKIP(124);
      END_STATE();
    case 129:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(109);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(130);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(129);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 130:
      if (lookahead == '\n')
        SKIP(129);
      if (lookahead == '\r')
        SKIP(131);
      END_STATE();
    case 131:
      if (lookahead == '\n')
        SKIP(129);
      END_STATE();
    case 132:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(109);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(133);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(132);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 133:
      if (lookahead == '\n')
        SKIP(132);
      if (lookahead == '\r')
        SKIP(134);
      END_STATE();
    case 134:
      if (lookahead == '\n')
        SKIP(132);
      END_STATE();
    case 135:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(135);
      END_STATE();
    case 136:
      if (lookahead == '\n')
        SKIP(135);
      if (lookahead == '\r')
        SKIP(137);
      END_STATE();
    case 137:
      if (lookahead == '\n')
        SKIP(135);
      END_STATE();
    case 138:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '*')
        ADVANCE(141);
      if (lookahead == '+')
        ADVANCE(143);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(144);
      if (lookahead == '/')
        ADVANCE(145);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '=')
        ADVANCE(110);
      if (lookahead == '>')
        ADVANCE(149);
      if (lookahead == '@')
        ADVANCE(151);
      if (lookahead == '\\')
        SKIP(152);
      if (lookahead == '^')
        ADVANCE(154);
      if (lookahead == '|')
        ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(138);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 139:
      if (lookahead == '=')
        ADVANCE(7);
      END_STATE();
    case 140:
      if (lookahead == '=')
        ADVANCE(9);
      END_STATE();
    case 141:
      if (lookahead == '*')
        ADVANCE(142);
      if (lookahead == '=')
        ADVANCE(15);
      END_STATE();
    case 142:
      if (lookahead == '=')
        ADVANCE(14);
      END_STATE();
    case 143:
      if (lookahead == '=')
        ADVANCE(17);
      END_STATE();
    case 144:
      if (lookahead == '=')
        ADVANCE(20);
      END_STATE();
    case 145:
      if (lookahead == '/')
        ADVANCE(146);
      if (lookahead == '=')
        ADVANCE(34);
      END_STATE();
    case 146:
      if (lookahead == '=')
        ADVANCE(33);
      END_STATE();
    case 147:
      if (lookahead == '<')
        ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 149:
      if (lookahead == '>')
        ADVANCE(150);
      END_STATE();
    case 150:
      if (lookahead == '=')
        ADVANCE(62);
      END_STATE();
    case 151:
      if (lookahead == '=')
        ADVANCE(64);
      END_STATE();
    case 152:
      if (lookahead == '\n')
        SKIP(138);
      if (lookahead == '\r')
        SKIP(153);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        SKIP(138);
      END_STATE();
    case 154:
      if (lookahead == '=')
        ADVANCE(70);
      END_STATE();
    case 155:
      if (lookahead == '=')
        ADVANCE(73);
      END_STATE();
    case 156:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '\\')
        SKIP(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(156);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 157:
      if (lookahead == '\n')
        SKIP(156);
      if (lookahead == '\r')
        SKIP(158);
      END_STATE();
    case 158:
      if (lookahead == '\n')
        SKIP(156);
      END_STATE();
    case 159:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(160);
      if (lookahead == '&')
        ADVANCE(161);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(162);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(168);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(170);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '^')
        ADVANCE(172);
      if (lookahead == '|')
        ADVANCE(173);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(159);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(163);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/')
        ADVANCE(165);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(167);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '>')
        ADVANCE(56);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(60);
      if (lookahead == '>')
        ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 170:
      if (lookahead == '\n')
        SKIP(159);
      if (lookahead == '\r')
        SKIP(171);
      END_STATE();
    case 171:
      if (lookahead == '\n')
        SKIP(159);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 174:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(160);
      if (lookahead == '&')
        ADVANCE(161);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(162);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(168);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(175);
      if (lookahead == '^')
        ADVANCE(172);
      if (lookahead == '|')
        ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(174);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 175:
      if (lookahead == '\n')
        SKIP(174);
      if (lookahead == '\r')
        SKIP(176);
      END_STATE();
    case 176:
      if (lookahead == '\n')
        SKIP(174);
      END_STATE();
    case 177:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(160);
      if (lookahead == '&')
        ADVANCE(161);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(162);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(168);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(178);
      if (lookahead == '^')
        ADVANCE(172);
      if (lookahead == '|')
        ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(177);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 178:
      if (lookahead == '\n')
        SKIP(177);
      if (lookahead == '\r')
        SKIP(179);
      END_STATE();
    case 179:
      if (lookahead == '\n')
        SKIP(177);
      END_STATE();
    case 180:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(160);
      if (lookahead == '&')
        ADVANCE(161);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(162);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(168);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(182);
      if (lookahead == '^')
        ADVANCE(172);
      if (lookahead == '|')
        ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(180);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 181:
      if (lookahead == '=')
        ADVANCE(58);
      END_STATE();
    case 182:
      if (lookahead == '\n')
        SKIP(180);
      if (lookahead == '\r')
        SKIP(183);
      END_STATE();
    case 183:
      if (lookahead == '\n')
        SKIP(180);
      END_STATE();
    case 184:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '\\')
        SKIP(185);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(184);
      END_STATE();
    case 185:
      if (lookahead == '\n')
        SKIP(184);
      if (lookahead == '\r')
        SKIP(186);
      END_STATE();
    case 186:
      if (lookahead == '\n')
        SKIP(184);
      END_STATE();
    case 187:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(160);
      if (lookahead == '&')
        ADVANCE(161);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(162);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(168);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(188);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '^')
        ADVANCE(172);
      if (lookahead == '|')
        ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(187);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 188:
      if (lookahead == '\n')
        SKIP(187);
      if (lookahead == '\r')
        SKIP(189);
      END_STATE();
    case 189:
      if (lookahead == '\n')
        SKIP(187);
      END_STATE();
    case 190:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(160);
      if (lookahead == '&')
        ADVANCE(161);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(162);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(168);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(191);
      if (lookahead == '^')
        ADVANCE(172);
      if (lookahead == '|')
        ADVANCE(173);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(190);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 191:
      if (lookahead == '\n')
        SKIP(190);
      if (lookahead == '\r')
        SKIP(192);
      END_STATE();
    case 192:
      if (lookahead == '\n')
        SKIP(190);
      END_STATE();
    case 193:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(141);
      if (lookahead == '+')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(115);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '/')
        ADVANCE(145);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(147);
      if (lookahead == '=')
        ADVANCE(110);
      if (lookahead == '>')
        ADVANCE(149);
      if (lookahead == '@')
        ADVANCE(151);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(194);
      if (lookahead == '^')
        ADVANCE(154);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(155);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(193);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 194:
      if (lookahead == '\n')
        SKIP(193);
      if (lookahead == '\r')
        SKIP(195);
      END_STATE();
    case 195:
      if (lookahead == '\n')
        SKIP(193);
      END_STATE();
    case 196:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '*')
        ADVANCE(141);
      if (lookahead == '+')
        ADVANCE(143);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(144);
      if (lookahead == '/')
        ADVANCE(145);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(197);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(198);
      if (lookahead == '@')
        ADVANCE(151);
      if (lookahead == '\\')
        SKIP(199);
      if (lookahead == '^')
        ADVANCE(154);
      if (lookahead == '|')
        ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(196);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(148);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '>')
        ADVANCE(56);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(60);
      if (lookahead == '>')
        ADVANCE(150);
      END_STATE();
    case 199:
      if (lookahead == '\n')
        SKIP(196);
      if (lookahead == '\r')
        SKIP(200);
      END_STATE();
    case 200:
      if (lookahead == '\n')
        SKIP(196);
      END_STATE();
    case 201:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(160);
      if (lookahead == '&')
        ADVANCE(161);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(162);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(168);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(202);
      if (lookahead == '^')
        ADVANCE(172);
      if (lookahead == '|')
        ADVANCE(173);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(201);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 202:
      if (lookahead == '\n')
        SKIP(201);
      if (lookahead == '\r')
        SKIP(203);
      END_STATE();
    case 203:
      if (lookahead == '\n')
        SKIP(201);
      END_STATE();
    case 204:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(125);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(126);
      if (lookahead == '\\')
        SKIP(205);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(204);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 205:
      if (lookahead == '\n')
        SKIP(204);
      if (lookahead == '\r')
        SKIP(206);
      END_STATE();
    case 206:
      if (lookahead == '\n')
        SKIP(204);
      END_STATE();
    case 207:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(160);
      if (lookahead == '&')
        ADVANCE(161);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(162);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(168);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(208);
      if (lookahead == '^')
        ADVANCE(172);
      if (lookahead == '|')
        ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 208:
      if (lookahead == '\n')
        SKIP(207);
      if (lookahead == '\r')
        SKIP(209);
      END_STATE();
    case 209:
      if (lookahead == '\n')
        SKIP(207);
      END_STATE();
    case 210:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '\\')
        SKIP(212);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(210);
      END_STATE();
    case 211:
      if (lookahead == '>')
        ADVANCE(21);
      END_STATE();
    case 212:
      if (lookahead == '\n')
        SKIP(210);
      if (lookahead == '\r')
        SKIP(213);
      END_STATE();
    case 213:
      if (lookahead == '\n')
        SKIP(210);
      END_STATE();
    case 214:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '=')
        ADVANCE(110);
      if (lookahead == '\\')
        SKIP(215);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(214);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        SKIP(214);
      if (lookahead == '\r')
        SKIP(216);
      END_STATE();
    case 216:
      if (lookahead == '\n')
        SKIP(214);
      END_STATE();
    case 217:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(160);
      if (lookahead == '&')
        ADVANCE(161);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(162);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(105);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(168);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(218);
      if (lookahead == '^')
        ADVANCE(172);
      if (lookahead == '|')
        ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(217);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 218:
      if (lookahead == '\n')
        SKIP(217);
      if (lookahead == '\r')
        SKIP(219);
      END_STATE();
    case 219:
      if (lookahead == '\n')
        SKIP(217);
      END_STATE();
    case 220:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(125);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(126);
      if (lookahead == '\\')
        SKIP(221);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(220);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 221:
      if (lookahead == '\n')
        SKIP(220);
      if (lookahead == '\r')
        SKIP(222);
      END_STATE();
    case 222:
      if (lookahead == '\n')
        SKIP(220);
      END_STATE();
    case 223:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(223);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        SKIP(223);
      if (lookahead == '\r')
        SKIP(225);
      END_STATE();
    case 225:
      if (lookahead == '\n')
        SKIP(223);
      END_STATE();
    case 226:
      if (lookahead == '!')
        ADVANCE(114);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(125);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(126);
      if (lookahead == '\\')
        SKIP(227);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(226);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 227:
      if (lookahead == '\n')
        SKIP(226);
      if (lookahead == '\r')
        SKIP(228);
      END_STATE();
    case 228:
      if (lookahead == '\n')
        SKIP(226);
      END_STATE();
    case 229:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(229);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 230:
      if (lookahead == '\n')
        SKIP(229);
      if (lookahead == '\r')
        SKIP(231);
      END_STATE();
    case 231:
      if (lookahead == '\n')
        SKIP(229);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'F')
        ADVANCE(1);
      if (lookahead == 'N')
        ADVANCE(6);
      if (lookahead == 'T')
        ADVANCE(10);
      if (lookahead == 'a')
        ADVANCE(14);
      if (lookahead == 'b')
        ADVANCE(29);
      if (lookahead == 'c')
        ADVANCE(34);
      if (lookahead == 'd')
        ADVANCE(46);
      if (lookahead == 'e')
        ADVANCE(50);
      if (lookahead == 'f')
        ADVANCE(63);
      if (lookahead == 'g')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(81);
      if (lookahead == 'l')
        ADVANCE(90);
      if (lookahead == 'n')
        ADVANCE(96);
      if (lookahead == 'o')
        ADVANCE(105);
      if (lookahead == 'p')
        ADVANCE(107);
      if (lookahead == 'r')
        ADVANCE(115);
      if (lookahead == 't')
        ADVANCE(125);
      if (lookahead == 'w')
        ADVANCE(128);
      if (lookahead == 'y')
        ADVANCE(136);
      END_STATE();
    case 1:
      if (lookahead == 'a')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 'l')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 's')
        ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == 'e')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 6:
      if (lookahead == 'o')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'n')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'e')
        ADVANCE(9);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 10:
      if (lookahead == 'r')
        ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == 'u')
        ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == 'e')
        ADVANCE(13);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 14:
      if (lookahead == 'n')
        ADVANCE(15);
      if (lookahead == 's')
        ADVANCE(17);
      if (lookahead == 'w')
        ADVANCE(25);
      END_STATE();
    case 15:
      if (lookahead == 'd')
        ADVANCE(16);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's')
        ADVANCE(18);
      if (lookahead == 'y')
        ADVANCE(22);
      END_STATE();
    case 18:
      if (lookahead == 'e')
        ADVANCE(19);
      END_STATE();
    case 19:
      if (lookahead == 'r')
        ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == 't')
        ADVANCE(21);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 22:
      if (lookahead == 'n')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'c')
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 25:
      if (lookahead == 'a')
        ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == 'i')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 't')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 29:
      if (lookahead == 'r')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 'e')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'a')
        ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == 'k')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 34:
      if (lookahead == 'l')
        ADVANCE(35);
      if (lookahead == 'o')
        ADVANCE(39);
      END_STATE();
    case 35:
      if (lookahead == 'a')
        ADVANCE(36);
      END_STATE();
    case 36:
      if (lookahead == 's')
        ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == 's')
        ADVANCE(38);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 39:
      if (lookahead == 'n')
        ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == 't')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'i')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 'n')
        ADVANCE(43);
      END_STATE();
    case 43:
      if (lookahead == 'u')
        ADVANCE(44);
      END_STATE();
    case 44:
      if (lookahead == 'e')
        ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 46:
      if (lookahead == 'e')
        ADVANCE(47);
      END_STATE();
    case 47:
      if (lookahead == 'f')
        ADVANCE(48);
      if (lookahead == 'l')
        ADVANCE(49);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 50:
      if (lookahead == 'l')
        ADVANCE(51);
      if (lookahead == 'x')
        ADVANCE(56);
      END_STATE();
    case 51:
      if (lookahead == 'i')
        ADVANCE(52);
      if (lookahead == 's')
        ADVANCE(54);
      END_STATE();
    case 52:
      if (lookahead == 'f')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 54:
      if (lookahead == 'e')
        ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 56:
      if (lookahead == 'c')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(61);
      END_STATE();
    case 57:
      if (lookahead == 'e')
        ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == 'p')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 't')
        ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_except);
      END_STATE();
    case 61:
      if (lookahead == 'c')
        ADVANCE(62);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 63:
      if (lookahead == 'i')
        ADVANCE(64);
      if (lookahead == 'o')
        ADVANCE(70);
      if (lookahead == 'r')
        ADVANCE(72);
      END_STATE();
    case 64:
      if (lookahead == 'n')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'a')
        ADVANCE(66);
      END_STATE();
    case 66:
      if (lookahead == 'l')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'l')
        ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == 'y')
        ADVANCE(69);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 70:
      if (lookahead == 'r')
        ADVANCE(71);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 72:
      if (lookahead == 'o')
        ADVANCE(73);
      END_STATE();
    case 73:
      if (lookahead == 'm')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 75:
      if (lookahead == 'l')
        ADVANCE(76);
      END_STATE();
    case 76:
      if (lookahead == 'o')
        ADVANCE(77);
      END_STATE();
    case 77:
      if (lookahead == 'b')
        ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead == 'a')
        ADVANCE(79);
      END_STATE();
    case 79:
      if (lookahead == 'l')
        ADVANCE(80);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 81:
      if (lookahead == 'f')
        ADVANCE(82);
      if (lookahead == 'm')
        ADVANCE(83);
      if (lookahead == 'n')
        ADVANCE(88);
      if (lookahead == 's')
        ADVANCE(89);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 83:
      if (lookahead == 'p')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 'o')
        ADVANCE(85);
      END_STATE();
    case 85:
      if (lookahead == 'r')
        ADVANCE(86);
      END_STATE();
    case 86:
      if (lookahead == 't')
        ADVANCE(87);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 90:
      if (lookahead == 'a')
        ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 'm')
        ADVANCE(92);
      END_STATE();
    case 92:
      if (lookahead == 'b')
        ADVANCE(93);
      END_STATE();
    case 93:
      if (lookahead == 'd')
        ADVANCE(94);
      END_STATE();
    case 94:
      if (lookahead == 'a')
        ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 96:
      if (lookahead == 'o')
        ADVANCE(97);
      END_STATE();
    case 97:
      if (lookahead == 'n')
        ADVANCE(98);
      if (lookahead == 't')
        ADVANCE(104);
      END_STATE();
    case 98:
      if (lookahead == 'l')
        ADVANCE(99);
      END_STATE();
    case 99:
      if (lookahead == 'o')
        ADVANCE(100);
      END_STATE();
    case 100:
      if (lookahead == 'c')
        ADVANCE(101);
      END_STATE();
    case 101:
      if (lookahead == 'a')
        ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == 'l')
        ADVANCE(103);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 105:
      if (lookahead == 'r')
        ADVANCE(106);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 107:
      if (lookahead == 'a')
        ADVANCE(108);
      if (lookahead == 'r')
        ADVANCE(111);
      END_STATE();
    case 108:
      if (lookahead == 's')
        ADVANCE(109);
      END_STATE();
    case 109:
      if (lookahead == 's')
        ADVANCE(110);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 111:
      if (lookahead == 'i')
        ADVANCE(112);
      END_STATE();
    case 112:
      if (lookahead == 'n')
        ADVANCE(113);
      END_STATE();
    case 113:
      if (lookahead == 't')
        ADVANCE(114);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 115:
      if (lookahead == 'a')
        ADVANCE(116);
      if (lookahead == 'e')
        ADVANCE(120);
      END_STATE();
    case 116:
      if (lookahead == 'i')
        ADVANCE(117);
      END_STATE();
    case 117:
      if (lookahead == 's')
        ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == 'e')
        ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 120:
      if (lookahead == 't')
        ADVANCE(121);
      END_STATE();
    case 121:
      if (lookahead == 'u')
        ADVANCE(122);
      END_STATE();
    case 122:
      if (lookahead == 'r')
        ADVANCE(123);
      END_STATE();
    case 123:
      if (lookahead == 'n')
        ADVANCE(124);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 125:
      if (lookahead == 'r')
        ADVANCE(126);
      END_STATE();
    case 126:
      if (lookahead == 'y')
        ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 128:
      if (lookahead == 'h')
        ADVANCE(129);
      if (lookahead == 'i')
        ADVANCE(133);
      END_STATE();
    case 129:
      if (lookahead == 'i')
        ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == 'l')
        ADVANCE(131);
      END_STATE();
    case 131:
      if (lookahead == 'e')
        ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 133:
      if (lookahead == 't')
        ADVANCE(134);
      END_STATE();
    case 134:
      if (lookahead == 'h')
        ADVANCE(135);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 136:
      if (lookahead == 'i')
        ADVANCE(137);
      END_STATE();
    case 137:
      if (lookahead == 'e')
        ADVANCE(138);
      END_STATE();
    case 138:
      if (lookahead == 'l')
        ADVANCE(139);
      END_STATE();
    case 139:
      if (lookahead == 'd')
        ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 81, .external_lex_state = 2},
  [2] = {.lex_state = 88, .external_lex_state = 3},
  [3] = {.lex_state = 104},
  [4] = {.lex_state = 104},
  [5] = {.lex_state = 108, .external_lex_state = 2},
  [6] = {.lex_state = 113, .external_lex_state = 4},
  [7] = {.lex_state = 81, .external_lex_state = 2},
  [8] = {.lex_state = 118, .external_lex_state = 4},
  [9] = {.lex_state = 81, .external_lex_state = 2},
  [10] = {.lex_state = 118, .external_lex_state = 4},
  [11] = {.lex_state = 104, .external_lex_state = 5},
  [12] = {.lex_state = 104, .external_lex_state = 5},
  [13] = {.lex_state = 104, .external_lex_state = 5},
  [14] = {.lex_state = 81, .external_lex_state = 2},
  [15] = {.lex_state = 104},
  [16] = {.lex_state = 81, .external_lex_state = 2},
  [17] = {.lex_state = 81, .external_lex_state = 2},
  [18] = {.lex_state = 108},
  [19] = {.lex_state = 81, .external_lex_state = 2},
  [20] = {.lex_state = 104},
  [21] = {.lex_state = 104},
  [22] = {.lex_state = 104},
  [23] = {.lex_state = 121, .external_lex_state = 4},
  [24] = {.lex_state = 104},
  [25] = {.lex_state = 104},
  [26] = {.lex_state = 81, .external_lex_state = 2},
  [27] = {.lex_state = 81, .external_lex_state = 2},
  [28] = {.lex_state = 124},
  [29] = {.lex_state = 118, .external_lex_state = 4},
  [30] = {.lex_state = 129, .external_lex_state = 2},
  [31] = {.lex_state = 132, .external_lex_state = 2},
  [32] = {.lex_state = 81, .external_lex_state = 2},
  [33] = {.lex_state = 135},
  [34] = {.lex_state = 104, .external_lex_state = 5},
  [35] = {.lex_state = 113},
  [36] = {.lex_state = 138, .external_lex_state = 5},
  [37] = {.lex_state = 121, .external_lex_state = 5},
  [38] = {.lex_state = 104, .external_lex_state = 5},
  [39] = {.lex_state = 121, .external_lex_state = 4},
  [40] = {.lex_state = 81, .external_lex_state = 2},
  [41] = {.lex_state = 104},
  [42] = {.lex_state = 121, .external_lex_state = 4},
  [43] = {.lex_state = 81, .external_lex_state = 2},
  [44] = {.lex_state = 88, .external_lex_state = 3},
  [45] = {.lex_state = 156, .external_lex_state = 5},
  [46] = {.lex_state = 104, .external_lex_state = 5},
  [47] = {.lex_state = 156, .external_lex_state = 5},
  [48] = {.lex_state = 156, .external_lex_state = 5},
  [49] = {.lex_state = 104},
  [50] = {.lex_state = 104},
  [51] = {.lex_state = 104},
  [52] = {.lex_state = 104},
  [53] = {.lex_state = 88, .external_lex_state = 3},
  [54] = {.lex_state = 108, .external_lex_state = 2},
  [55] = {.lex_state = 121, .external_lex_state = 5},
  [56] = {.lex_state = 108},
  [57] = {.lex_state = 159},
  [58] = {.lex_state = 81, .external_lex_state = 2},
  [59] = {.lex_state = 81, .external_lex_state = 2},
  [60] = {.lex_state = 124},
  [61] = {.lex_state = 108, .external_lex_state = 2},
  [62] = {.lex_state = 129, .external_lex_state = 2},
  [63] = {.lex_state = 132, .external_lex_state = 2},
  [64] = {.lex_state = 81, .external_lex_state = 2},
  [65] = {.lex_state = 124},
  [66] = {.lex_state = 174},
  [67] = {.lex_state = 108},
  [68] = {.lex_state = 174, .external_lex_state = 2},
  [69] = {.lex_state = 88, .external_lex_state = 3},
  [70] = {.lex_state = 108, .external_lex_state = 2},
  [71] = {.lex_state = 177, .external_lex_state = 5},
  [72] = {.lex_state = 81, .external_lex_state = 2},
  [73] = {.lex_state = 81, .external_lex_state = 2},
  [74] = {.lex_state = 81, .external_lex_state = 2},
  [75] = {.lex_state = 124},
  [76] = {.lex_state = 129, .external_lex_state = 2},
  [77] = {.lex_state = 132, .external_lex_state = 2},
  [78] = {.lex_state = 81, .external_lex_state = 2},
  [79] = {.lex_state = 156, .external_lex_state = 5},
  [80] = {.lex_state = 156, .external_lex_state = 5},
  [81] = {.lex_state = 180, .external_lex_state = 5},
  [82] = {.lex_state = 180, .external_lex_state = 4},
  [83] = {.lex_state = 156, .external_lex_state = 5},
  [84] = {.lex_state = 104, .external_lex_state = 5},
  [85] = {.lex_state = 156, .external_lex_state = 5},
  [86] = {.lex_state = 104, .external_lex_state = 5},
  [87] = {.lex_state = 81, .external_lex_state = 2},
  [88] = {.lex_state = 81, .external_lex_state = 2},
  [89] = {.lex_state = 81, .external_lex_state = 2},
  [90] = {.lex_state = 124},
  [91] = {.lex_state = 81, .external_lex_state = 2},
  [92] = {.lex_state = 104, .external_lex_state = 5},
  [93] = {.lex_state = 156, .external_lex_state = 5},
  [94] = {.lex_state = 180, .external_lex_state = 5},
  [95] = {.lex_state = 180, .external_lex_state = 4},
  [96] = {.lex_state = 81, .external_lex_state = 2},
  [97] = {.lex_state = 81, .external_lex_state = 2},
  [98] = {.lex_state = 124},
  [99] = {.lex_state = 81, .external_lex_state = 2},
  [100] = {.lex_state = 121},
  [101] = {.lex_state = 174},
  [102] = {.lex_state = 174, .external_lex_state = 2},
  [103] = {.lex_state = 81, .external_lex_state = 2},
  [104] = {.lex_state = 81, .external_lex_state = 2},
  [105] = {.lex_state = 104},
  [106] = {.lex_state = 81, .external_lex_state = 2},
  [107] = {.lex_state = 104},
  [108] = {.lex_state = 174},
  [109] = {.lex_state = 174, .external_lex_state = 2},
  [110] = {.lex_state = 121},
  [111] = {.lex_state = 81, .external_lex_state = 6},
  [112] = {.lex_state = 81, .external_lex_state = 2},
  [113] = {.lex_state = 81, .external_lex_state = 2},
  [114] = {.lex_state = 124},
  [115] = {.lex_state = 81, .external_lex_state = 2},
  [116] = {.lex_state = 108},
  [117] = {.lex_state = 121},
  [118] = {.lex_state = 174},
  [119] = {.lex_state = 174, .external_lex_state = 2},
  [120] = {.lex_state = 81},
  [121] = {.lex_state = 156, .external_lex_state = 5},
  [122] = {.lex_state = 156, .external_lex_state = 5},
  [123] = {.lex_state = 88, .external_lex_state = 3},
  [124] = {.lex_state = 104, .external_lex_state = 5},
  [125] = {.lex_state = 108},
  [126] = {.lex_state = 184, .external_lex_state = 5},
  [127] = {.lex_state = 81, .external_lex_state = 5},
  [128] = {.lex_state = 121, .external_lex_state = 5},
  [129] = {.lex_state = 138, .external_lex_state = 5},
  [130] = {.lex_state = 121, .external_lex_state = 5},
  [131] = {.lex_state = 108, .external_lex_state = 2},
  [132] = {.lex_state = 108, .external_lex_state = 2},
  [133] = {.lex_state = 108},
  [134] = {.lex_state = 81, .external_lex_state = 2},
  [135] = {.lex_state = 108},
  [136] = {.lex_state = 108},
  [137] = {.lex_state = 108},
  [138] = {.lex_state = 108},
  [139] = {.lex_state = 108},
  [140] = {.lex_state = 81, .external_lex_state = 2},
  [141] = {.lex_state = 104, .external_lex_state = 5},
  [142] = {.lex_state = 129},
  [143] = {.lex_state = 129, .external_lex_state = 2},
  [144] = {.lex_state = 81, .external_lex_state = 2},
  [145] = {.lex_state = 81, .external_lex_state = 2},
  [146] = {.lex_state = 124},
  [147] = {.lex_state = 121, .external_lex_state = 5},
  [148] = {.lex_state = 81, .external_lex_state = 2},
  [149] = {.lex_state = 129},
  [150] = {.lex_state = 187},
  [151] = {.lex_state = 187},
  [152] = {.lex_state = 187, .external_lex_state = 2},
  [153] = {.lex_state = 132},
  [154] = {.lex_state = 132, .external_lex_state = 2},
  [155] = {.lex_state = 81, .external_lex_state = 2},
  [156] = {.lex_state = 81, .external_lex_state = 2},
  [157] = {.lex_state = 124},
  [158] = {.lex_state = 121, .external_lex_state = 5},
  [159] = {.lex_state = 81, .external_lex_state = 2},
  [160] = {.lex_state = 132},
  [161] = {.lex_state = 132},
  [162] = {.lex_state = 190},
  [163] = {.lex_state = 190},
  [164] = {.lex_state = 190},
  [165] = {.lex_state = 190, .external_lex_state = 2},
  [166] = {.lex_state = 138, .external_lex_state = 5},
  [167] = {.lex_state = 81, .external_lex_state = 2},
  [168] = {.lex_state = 81, .external_lex_state = 4},
  [169] = {.lex_state = 104, .external_lex_state = 5},
  [170] = {.lex_state = 81, .external_lex_state = 2},
  [171] = {.lex_state = 81, .external_lex_state = 2},
  [172] = {.lex_state = 81, .external_lex_state = 2},
  [173] = {.lex_state = 193, .external_lex_state = 4},
  [174] = {.lex_state = 81, .external_lex_state = 2},
  [175] = {.lex_state = 81, .external_lex_state = 2},
  [176] = {.lex_state = 81, .external_lex_state = 2},
  [177] = {.lex_state = 138, .external_lex_state = 5},
  [178] = {.lex_state = 104},
  [179] = {.lex_state = 108, .external_lex_state = 2},
  [180] = {.lex_state = 81, .external_lex_state = 2},
  [181] = {.lex_state = 81, .external_lex_state = 2},
  [182] = {.lex_state = 81, .external_lex_state = 2},
  [183] = {.lex_state = 104},
  [184] = {.lex_state = 81, .external_lex_state = 2},
  [185] = {.lex_state = 81, .external_lex_state = 2},
  [186] = {.lex_state = 81, .external_lex_state = 2},
  [187] = {.lex_state = 81, .external_lex_state = 2},
  [188] = {.lex_state = 81, .external_lex_state = 2},
  [189] = {.lex_state = 81, .external_lex_state = 2},
  [190] = {.lex_state = 108, .external_lex_state = 2},
  [191] = {.lex_state = 121, .external_lex_state = 5},
  [192] = {.lex_state = 196, .external_lex_state = 5},
  [193] = {.lex_state = 121, .external_lex_state = 4},
  [194] = {.lex_state = 81, .external_lex_state = 2},
  [195] = {.lex_state = 104},
  [196] = {.lex_state = 81, .external_lex_state = 2},
  [197] = {.lex_state = 104},
  [198] = {.lex_state = 81, .external_lex_state = 2},
  [199] = {.lex_state = 81, .external_lex_state = 2},
  [200] = {.lex_state = 124},
  [201] = {.lex_state = 81, .external_lex_state = 2},
  [202] = {.lex_state = 201},
  [203] = {.lex_state = 201},
  [204] = {.lex_state = 201, .external_lex_state = 2},
  [205] = {.lex_state = 121, .external_lex_state = 4},
  [206] = {.lex_state = 88, .external_lex_state = 3},
  [207] = {.lex_state = 104},
  [208] = {.lex_state = 156, .external_lex_state = 5},
  [209] = {.lex_state = 104, .external_lex_state = 5},
  [210] = {.lex_state = 156, .external_lex_state = 5},
  [211] = {.lex_state = 104},
  [212] = {.lex_state = 104},
  [213] = {.lex_state = 104},
  [214] = {.lex_state = 104},
  [215] = {.lex_state = 124},
  [216] = {.lex_state = 104},
  [217] = {.lex_state = 159, .external_lex_state = 2},
  [218] = {.lex_state = 88, .external_lex_state = 3},
  [219] = {.lex_state = 159},
  [220] = {.lex_state = 108},
  [221] = {.lex_state = 124},
  [222] = {.lex_state = 108},
  [223] = {.lex_state = 121, .external_lex_state = 5},
  [224] = {.lex_state = 124},
  [225] = {.lex_state = 159},
  [226] = {.lex_state = 81, .external_lex_state = 2},
  [227] = {.lex_state = 108},
  [228] = {.lex_state = 81, .external_lex_state = 2},
  [229] = {.lex_state = 81, .external_lex_state = 2},
  [230] = {.lex_state = 81, .external_lex_state = 2},
  [231] = {.lex_state = 124},
  [232] = {.lex_state = 81, .external_lex_state = 2},
  [233] = {.lex_state = 108},
  [234] = {.lex_state = 124},
  [235] = {.lex_state = 174},
  [236] = {.lex_state = 174, .external_lex_state = 2},
  [237] = {.lex_state = 129},
  [238] = {.lex_state = 159},
  [239] = {.lex_state = 129},
  [240] = {.lex_state = 187},
  [241] = {.lex_state = 132},
  [242] = {.lex_state = 159},
  [243] = {.lex_state = 132},
  [244] = {.lex_state = 132},
  [245] = {.lex_state = 190},
  [246] = {.lex_state = 190},
  [247] = {.lex_state = 159},
  [248] = {.lex_state = 121, .external_lex_state = 5},
  [249] = {.lex_state = 108, .external_lex_state = 2},
  [250] = {.lex_state = 81, .external_lex_state = 2},
  [251] = {.lex_state = 104},
  [252] = {.lex_state = 81, .external_lex_state = 2},
  [253] = {.lex_state = 81, .external_lex_state = 2},
  [254] = {.lex_state = 81, .external_lex_state = 2},
  [255] = {.lex_state = 108},
  [256] = {.lex_state = 124},
  [257] = {.lex_state = 108},
  [258] = {.lex_state = 104},
  [259] = {.lex_state = 108, .external_lex_state = 2},
  [260] = {.lex_state = 81, .external_lex_state = 2},
  [261] = {.lex_state = 81, .external_lex_state = 2},
  [262] = {.lex_state = 81, .external_lex_state = 2},
  [263] = {.lex_state = 104},
  [264] = {.lex_state = 81, .external_lex_state = 2},
  [265] = {.lex_state = 81, .external_lex_state = 2},
  [266] = {.lex_state = 81, .external_lex_state = 2},
  [267] = {.lex_state = 81, .external_lex_state = 2},
  [268] = {.lex_state = 81, .external_lex_state = 2},
  [269] = {.lex_state = 81, .external_lex_state = 2},
  [270] = {.lex_state = 108, .external_lex_state = 2},
  [271] = {.lex_state = 159},
  [272] = {.lex_state = 124},
  [273] = {.lex_state = 174, .external_lex_state = 2},
  [274] = {.lex_state = 177, .external_lex_state = 4},
  [275] = {.lex_state = 88, .external_lex_state = 3},
  [276] = {.lex_state = 177, .external_lex_state = 5},
  [277] = {.lex_state = 108},
  [278] = {.lex_state = 124},
  [279] = {.lex_state = 108},
  [280] = {.lex_state = 156, .external_lex_state = 5},
  [281] = {.lex_state = 156, .external_lex_state = 5},
  [282] = {.lex_state = 177, .external_lex_state = 5},
  [283] = {.lex_state = 81, .external_lex_state = 2},
  [284] = {.lex_state = 108},
  [285] = {.lex_state = 129},
  [286] = {.lex_state = 177, .external_lex_state = 5},
  [287] = {.lex_state = 129},
  [288] = {.lex_state = 187},
  [289] = {.lex_state = 132},
  [290] = {.lex_state = 177, .external_lex_state = 5},
  [291] = {.lex_state = 132},
  [292] = {.lex_state = 132},
  [293] = {.lex_state = 190},
  [294] = {.lex_state = 190},
  [295] = {.lex_state = 118, .external_lex_state = 4},
  [296] = {.lex_state = 156, .external_lex_state = 5},
  [297] = {.lex_state = 81, .external_lex_state = 2},
  [298] = {.lex_state = 81, .external_lex_state = 2},
  [299] = {.lex_state = 81, .external_lex_state = 2},
  [300] = {.lex_state = 104},
  [301] = {.lex_state = 108, .external_lex_state = 2},
  [302] = {.lex_state = 81, .external_lex_state = 2},
  [303] = {.lex_state = 81, .external_lex_state = 2},
  [304] = {.lex_state = 81, .external_lex_state = 2},
  [305] = {.lex_state = 104},
  [306] = {.lex_state = 81, .external_lex_state = 2},
  [307] = {.lex_state = 81, .external_lex_state = 2},
  [308] = {.lex_state = 81, .external_lex_state = 2},
  [309] = {.lex_state = 81, .external_lex_state = 2},
  [310] = {.lex_state = 81, .external_lex_state = 2},
  [311] = {.lex_state = 81, .external_lex_state = 2},
  [312] = {.lex_state = 108, .external_lex_state = 2},
  [313] = {.lex_state = 177, .external_lex_state = 5},
  [314] = {.lex_state = 204, .external_lex_state = 5},
  [315] = {.lex_state = 180, .external_lex_state = 4},
  [316] = {.lex_state = 81, .external_lex_state = 2},
  [317] = {.lex_state = 156, .external_lex_state = 5},
  [318] = {.lex_state = 118, .external_lex_state = 4},
  [319] = {.lex_state = 156, .external_lex_state = 5},
  [320] = {.lex_state = 81, .external_lex_state = 2},
  [321] = {.lex_state = 81, .external_lex_state = 2},
  [322] = {.lex_state = 124},
  [323] = {.lex_state = 81, .external_lex_state = 2},
  [324] = {.lex_state = 104, .external_lex_state = 5},
  [325] = {.lex_state = 207, .external_lex_state = 5},
  [326] = {.lex_state = 207, .external_lex_state = 4},
  [327] = {.lex_state = 156, .external_lex_state = 5},
  [328] = {.lex_state = 81, .external_lex_state = 2},
  [329] = {.lex_state = 108},
  [330] = {.lex_state = 81, .external_lex_state = 2},
  [331] = {.lex_state = 118, .external_lex_state = 4},
  [332] = {.lex_state = 81, .external_lex_state = 2},
  [333] = {.lex_state = 81, .external_lex_state = 2},
  [334] = {.lex_state = 81, .external_lex_state = 2},
  [335] = {.lex_state = 156, .external_lex_state = 5},
  [336] = {.lex_state = 81, .external_lex_state = 2},
  [337] = {.lex_state = 81, .external_lex_state = 2},
  [338] = {.lex_state = 81, .external_lex_state = 2},
  [339] = {.lex_state = 104},
  [340] = {.lex_state = 81, .external_lex_state = 2},
  [341] = {.lex_state = 81, .external_lex_state = 2},
  [342] = {.lex_state = 81, .external_lex_state = 2},
  [343] = {.lex_state = 81, .external_lex_state = 2},
  [344] = {.lex_state = 81, .external_lex_state = 2},
  [345] = {.lex_state = 81, .external_lex_state = 2},
  [346] = {.lex_state = 204, .external_lex_state = 5},
  [347] = {.lex_state = 180, .external_lex_state = 4},
  [348] = {.lex_state = 121},
  [349] = {.lex_state = 81, .external_lex_state = 2},
  [350] = {.lex_state = 108},
  [351] = {.lex_state = 81, .external_lex_state = 2},
  [352] = {.lex_state = 81, .external_lex_state = 6},
  [353] = {.lex_state = 81, .external_lex_state = 2},
  [354] = {.lex_state = 81, .external_lex_state = 2},
  [355] = {.lex_state = 81, .external_lex_state = 2},
  [356] = {.lex_state = 81, .external_lex_state = 2},
  [357] = {.lex_state = 81, .external_lex_state = 2},
  [358] = {.lex_state = 104},
  [359] = {.lex_state = 81, .external_lex_state = 2},
  [360] = {.lex_state = 81, .external_lex_state = 2},
  [361] = {.lex_state = 81, .external_lex_state = 2},
  [362] = {.lex_state = 81, .external_lex_state = 2},
  [363] = {.lex_state = 81, .external_lex_state = 2},
  [364] = {.lex_state = 81, .external_lex_state = 2},
  [365] = {.lex_state = 121},
  [366] = {.lex_state = 174, .external_lex_state = 2},
  [367] = {.lex_state = 104},
  [368] = {.lex_state = 108},
  [369] = {.lex_state = 81},
  [370] = {.lex_state = 81, .external_lex_state = 2},
  [371] = {.lex_state = 81, .external_lex_state = 2},
  [372] = {.lex_state = 81, .external_lex_state = 2},
  [373] = {.lex_state = 81, .external_lex_state = 2},
  [374] = {.lex_state = 81, .external_lex_state = 2},
  [375] = {.lex_state = 81, .external_lex_state = 2},
  [376] = {.lex_state = 81, .external_lex_state = 2},
  [377] = {.lex_state = 81, .external_lex_state = 2},
  [378] = {.lex_state = 81, .external_lex_state = 2},
  [379] = {.lex_state = 121},
  [380] = {.lex_state = 174, .external_lex_state = 2},
  [381] = {.lex_state = 81, .external_lex_state = 6},
  [382] = {.lex_state = 81, .external_lex_state = 7},
  [383] = {.lex_state = 104, .external_lex_state = 5},
  [384] = {.lex_state = 104},
  [385] = {.lex_state = 121},
  [386] = {.lex_state = 81, .external_lex_state = 2},
  [387] = {.lex_state = 108},
  [388] = {.lex_state = 81, .external_lex_state = 2},
  [389] = {.lex_state = 81, .external_lex_state = 6},
  [390] = {.lex_state = 108},
  [391] = {.lex_state = 81, .external_lex_state = 2},
  [392] = {.lex_state = 81, .external_lex_state = 2},
  [393] = {.lex_state = 81, .external_lex_state = 2},
  [394] = {.lex_state = 81, .external_lex_state = 2},
  [395] = {.lex_state = 81, .external_lex_state = 2},
  [396] = {.lex_state = 81, .external_lex_state = 2},
  [397] = {.lex_state = 81, .external_lex_state = 2},
  [398] = {.lex_state = 104},
  [399] = {.lex_state = 81, .external_lex_state = 2},
  [400] = {.lex_state = 81, .external_lex_state = 2},
  [401] = {.lex_state = 81, .external_lex_state = 2},
  [402] = {.lex_state = 81, .external_lex_state = 2},
  [403] = {.lex_state = 81, .external_lex_state = 2},
  [404] = {.lex_state = 81, .external_lex_state = 2},
  [405] = {.lex_state = 121},
  [406] = {.lex_state = 174, .external_lex_state = 2},
  [407] = {.lex_state = 124},
  [408] = {.lex_state = 210},
  [409] = {.lex_state = 104},
  [410] = {.lex_state = 156, .external_lex_state = 5},
  [411] = {.lex_state = 156, .external_lex_state = 5},
  [412] = {.lex_state = 104, .external_lex_state = 5},
  [413] = {.lex_state = 88, .external_lex_state = 3},
  [414] = {.lex_state = 81, .external_lex_state = 2},
  [415] = {.lex_state = 108, .external_lex_state = 2},
  [416] = {.lex_state = 81, .external_lex_state = 6},
  [417] = {.lex_state = 108},
  [418] = {.lex_state = 184, .external_lex_state = 5},
  [419] = {.lex_state = 104},
  [420] = {.lex_state = 108, .external_lex_state = 2},
  [421] = {.lex_state = 81, .external_lex_state = 5},
  [422] = {.lex_state = 124},
  [423] = {.lex_state = 108},
  [424] = {.lex_state = 81, .external_lex_state = 2},
  [425] = {.lex_state = 81, .external_lex_state = 2},
  [426] = {.lex_state = 81, .external_lex_state = 2},
  [427] = {.lex_state = 124},
  [428] = {.lex_state = 81, .external_lex_state = 2},
  [429] = {.lex_state = 121},
  [430] = {.lex_state = 174},
  [431] = {.lex_state = 174, .external_lex_state = 2},
  [432] = {.lex_state = 124},
  [433] = {.lex_state = 81, .external_lex_state = 2},
  [434] = {.lex_state = 81, .external_lex_state = 2},
  [435] = {.lex_state = 108},
  [436] = {.lex_state = 138, .external_lex_state = 5},
  [437] = {.lex_state = 124},
  [438] = {.lex_state = 81, .external_lex_state = 2},
  [439] = {.lex_state = 81, .external_lex_state = 2},
  [440] = {.lex_state = 108},
  [441] = {.lex_state = 81, .external_lex_state = 2},
  [442] = {.lex_state = 81, .external_lex_state = 2},
  [443] = {.lex_state = 104, .external_lex_state = 5},
  [444] = {.lex_state = 121, .external_lex_state = 5},
  [445] = {.lex_state = 81, .external_lex_state = 2},
  [446] = {.lex_state = 81, .external_lex_state = 2},
  [447] = {.lex_state = 124},
  [448] = {.lex_state = 81, .external_lex_state = 2},
  [449] = {.lex_state = 187},
  [450] = {.lex_state = 187},
  [451] = {.lex_state = 187, .external_lex_state = 2},
  [452] = {.lex_state = 187},
  [453] = {.lex_state = 81, .external_lex_state = 2},
  [454] = {.lex_state = 108},
  [455] = {.lex_state = 129, .external_lex_state = 2},
  [456] = {.lex_state = 129},
  [457] = {.lex_state = 81, .external_lex_state = 2},
  [458] = {.lex_state = 104},
  [459] = {.lex_state = 81, .external_lex_state = 2},
  [460] = {.lex_state = 81, .external_lex_state = 2},
  [461] = {.lex_state = 81, .external_lex_state = 2},
  [462] = {.lex_state = 129},
  [463] = {.lex_state = 187},
  [464] = {.lex_state = 81, .external_lex_state = 2},
  [465] = {.lex_state = 81, .external_lex_state = 2},
  [466] = {.lex_state = 81, .external_lex_state = 2},
  [467] = {.lex_state = 104},
  [468] = {.lex_state = 81, .external_lex_state = 2},
  [469] = {.lex_state = 81, .external_lex_state = 2},
  [470] = {.lex_state = 81, .external_lex_state = 2},
  [471] = {.lex_state = 81, .external_lex_state = 2},
  [472] = {.lex_state = 81, .external_lex_state = 2},
  [473] = {.lex_state = 81, .external_lex_state = 2},
  [474] = {.lex_state = 187},
  [475] = {.lex_state = 187, .external_lex_state = 2},
  [476] = {.lex_state = 121, .external_lex_state = 5},
  [477] = {.lex_state = 81, .external_lex_state = 2},
  [478] = {.lex_state = 81, .external_lex_state = 2},
  [479] = {.lex_state = 81, .external_lex_state = 2},
  [480] = {.lex_state = 124},
  [481] = {.lex_state = 81, .external_lex_state = 2},
  [482] = {.lex_state = 190},
  [483] = {.lex_state = 190},
  [484] = {.lex_state = 190, .external_lex_state = 2},
  [485] = {.lex_state = 190},
  [486] = {.lex_state = 81, .external_lex_state = 2},
  [487] = {.lex_state = 108},
  [488] = {.lex_state = 132, .external_lex_state = 2},
  [489] = {.lex_state = 121, .external_lex_state = 5},
  [490] = {.lex_state = 132},
  [491] = {.lex_state = 132, .external_lex_state = 2},
  [492] = {.lex_state = 132},
  [493] = {.lex_state = 81, .external_lex_state = 2},
  [494] = {.lex_state = 81, .external_lex_state = 2},
  [495] = {.lex_state = 104},
  [496] = {.lex_state = 81, .external_lex_state = 2},
  [497] = {.lex_state = 81, .external_lex_state = 2},
  [498] = {.lex_state = 81, .external_lex_state = 2},
  [499] = {.lex_state = 132},
  [500] = {.lex_state = 190},
  [501] = {.lex_state = 81, .external_lex_state = 2},
  [502] = {.lex_state = 81, .external_lex_state = 2},
  [503] = {.lex_state = 81, .external_lex_state = 2},
  [504] = {.lex_state = 104},
  [505] = {.lex_state = 81, .external_lex_state = 2},
  [506] = {.lex_state = 81, .external_lex_state = 2},
  [507] = {.lex_state = 81, .external_lex_state = 2},
  [508] = {.lex_state = 81, .external_lex_state = 2},
  [509] = {.lex_state = 81, .external_lex_state = 2},
  [510] = {.lex_state = 81, .external_lex_state = 2},
  [511] = {.lex_state = 190},
  [512] = {.lex_state = 132},
  [513] = {.lex_state = 190, .external_lex_state = 2},
  [514] = {.lex_state = 81, .external_lex_state = 2},
  [515] = {.lex_state = 104, .external_lex_state = 5},
  [516] = {.lex_state = 81, .external_lex_state = 4},
  [517] = {.lex_state = 104, .external_lex_state = 5},
  [518] = {.lex_state = 81, .external_lex_state = 2},
  [519] = {.lex_state = 81, .external_lex_state = 2},
  [520] = {.lex_state = 124},
  [521] = {.lex_state = 81, .external_lex_state = 2},
  [522] = {.lex_state = 214, .external_lex_state = 5},
  [523] = {.lex_state = 217, .external_lex_state = 5},
  [524] = {.lex_state = 214, .external_lex_state = 5},
  [525] = {.lex_state = 217, .external_lex_state = 4},
  [526] = {.lex_state = 193, .external_lex_state = 5},
  [527] = {.lex_state = 138, .external_lex_state = 5},
  [528] = {.lex_state = 104, .external_lex_state = 5},
  [529] = {.lex_state = 104, .external_lex_state = 5},
  [530] = {.lex_state = 138, .external_lex_state = 5},
  [531] = {.lex_state = 81, .external_lex_state = 2},
  [532] = {.lex_state = 81, .external_lex_state = 2},
  [533] = {.lex_state = 124},
  [534] = {.lex_state = 81, .external_lex_state = 2},
  [535] = {.lex_state = 104},
  [536] = {.lex_state = 174},
  [537] = {.lex_state = 174, .external_lex_state = 2},
  [538] = {.lex_state = 138, .external_lex_state = 5},
  [539] = {.lex_state = 138, .external_lex_state = 5},
  [540] = {.lex_state = 193, .external_lex_state = 4},
  [541] = {.lex_state = 138, .external_lex_state = 5},
  [542] = {.lex_state = 121, .external_lex_state = 5},
  [543] = {.lex_state = 121, .external_lex_state = 5},
  [544] = {.lex_state = 108},
  [545] = {.lex_state = 108, .external_lex_state = 2},
  [546] = {.lex_state = 174},
  [547] = {.lex_state = 174},
  [548] = {.lex_state = 108},
  [549] = {.lex_state = 124},
  [550] = {.lex_state = 121, .external_lex_state = 5},
  [551] = {.lex_state = 121, .external_lex_state = 5},
  [552] = {.lex_state = 121, .external_lex_state = 5},
  [553] = {.lex_state = 81, .external_lex_state = 2},
  [554] = {.lex_state = 121, .external_lex_state = 5},
  [555] = {.lex_state = 121, .external_lex_state = 5},
  [556] = {.lex_state = 121, .external_lex_state = 5},
  [557] = {.lex_state = 121, .external_lex_state = 5},
  [558] = {.lex_state = 121, .external_lex_state = 5},
  [559] = {.lex_state = 129, .external_lex_state = 2},
  [560] = {.lex_state = 81, .external_lex_state = 2},
  [561] = {.lex_state = 81, .external_lex_state = 2},
  [562] = {.lex_state = 124},
  [563] = {.lex_state = 81, .external_lex_state = 2},
  [564] = {.lex_state = 187},
  [565] = {.lex_state = 187},
  [566] = {.lex_state = 129},
  [567] = {.lex_state = 187, .external_lex_state = 2},
  [568] = {.lex_state = 196, .external_lex_state = 5},
  [569] = {.lex_state = 121, .external_lex_state = 4},
  [570] = {.lex_state = 201},
  [571] = {.lex_state = 81, .external_lex_state = 2},
  [572] = {.lex_state = 108},
  [573] = {.lex_state = 81, .external_lex_state = 2},
  [574] = {.lex_state = 81, .external_lex_state = 2},
  [575] = {.lex_state = 81, .external_lex_state = 2},
  [576] = {.lex_state = 88, .external_lex_state = 3},
  [577] = {.lex_state = 132},
  [578] = {.lex_state = 81, .external_lex_state = 2},
  [579] = {.lex_state = 81, .external_lex_state = 2},
  [580] = {.lex_state = 81, .external_lex_state = 2},
  [581] = {.lex_state = 104},
  [582] = {.lex_state = 81, .external_lex_state = 2},
  [583] = {.lex_state = 81, .external_lex_state = 2},
  [584] = {.lex_state = 81, .external_lex_state = 2},
  [585] = {.lex_state = 81, .external_lex_state = 2},
  [586] = {.lex_state = 81, .external_lex_state = 2},
  [587] = {.lex_state = 81, .external_lex_state = 2},
  [588] = {.lex_state = 201},
  [589] = {.lex_state = 201, .external_lex_state = 2},
  [590] = {.lex_state = 156, .external_lex_state = 5},
  [591] = {.lex_state = 156, .external_lex_state = 5},
  [592] = {.lex_state = 156, .external_lex_state = 5},
  [593] = {.lex_state = 156, .external_lex_state = 5},
  [594] = {.lex_state = 104, .external_lex_state = 5},
  [595] = {.lex_state = 156, .external_lex_state = 5},
  [596] = {.lex_state = 156, .external_lex_state = 5},
  [597] = {.lex_state = 124},
  [598] = {.lex_state = 104},
  [599] = {.lex_state = 104},
  [600] = {.lex_state = 104, .external_lex_state = 5},
  [601] = {.lex_state = 104, .external_lex_state = 5},
  [602] = {.lex_state = 159, .external_lex_state = 2},
  [603] = {.lex_state = 159},
  [604] = {.lex_state = 159},
  [605] = {.lex_state = 108, .external_lex_state = 2},
  [606] = {.lex_state = 108},
  [607] = {.lex_state = 108},
  [608] = {.lex_state = 124},
  [609] = {.lex_state = 81, .external_lex_state = 2},
  [610] = {.lex_state = 124},
  [611] = {.lex_state = 124},
  [612] = {.lex_state = 81, .external_lex_state = 2},
  [613] = {.lex_state = 108},
  [614] = {.lex_state = 108, .external_lex_state = 2},
  [615] = {.lex_state = 81, .external_lex_state = 2},
  [616] = {.lex_state = 81, .external_lex_state = 2},
  [617] = {.lex_state = 81, .external_lex_state = 2},
  [618] = {.lex_state = 108},
  [619] = {.lex_state = 81, .external_lex_state = 2},
  [620] = {.lex_state = 81, .external_lex_state = 2},
  [621] = {.lex_state = 81, .external_lex_state = 2},
  [622] = {.lex_state = 104},
  [623] = {.lex_state = 81, .external_lex_state = 2},
  [624] = {.lex_state = 81, .external_lex_state = 2},
  [625] = {.lex_state = 81, .external_lex_state = 2},
  [626] = {.lex_state = 81, .external_lex_state = 2},
  [627] = {.lex_state = 81, .external_lex_state = 2},
  [628] = {.lex_state = 81, .external_lex_state = 2},
  [629] = {.lex_state = 124},
  [630] = {.lex_state = 174, .external_lex_state = 2},
  [631] = {.lex_state = 159},
  [632] = {.lex_state = 129, .external_lex_state = 2},
  [633] = {.lex_state = 129},
  [634] = {.lex_state = 129},
  [635] = {.lex_state = 159},
  [636] = {.lex_state = 132, .external_lex_state = 2},
  [637] = {.lex_state = 159},
  [638] = {.lex_state = 132},
  [639] = {.lex_state = 132, .external_lex_state = 2},
  [640] = {.lex_state = 132},
  [641] = {.lex_state = 132},
  [642] = {.lex_state = 132},
  [643] = {.lex_state = 121, .external_lex_state = 5},
  [644] = {.lex_state = 124},
  [645] = {.lex_state = 108},
  [646] = {.lex_state = 104},
  [647] = {.lex_state = 81, .external_lex_state = 2},
  [648] = {.lex_state = 104},
  [649] = {.lex_state = 159},
  [650] = {.lex_state = 124},
  [651] = {.lex_state = 121, .external_lex_state = 5},
  [652] = {.lex_state = 81, .external_lex_state = 2},
  [653] = {.lex_state = 124},
  [654] = {.lex_state = 108, .external_lex_state = 2},
  [655] = {.lex_state = 108},
  [656] = {.lex_state = 159},
  [657] = {.lex_state = 159},
  [658] = {.lex_state = 108},
  [659] = {.lex_state = 108},
  [660] = {.lex_state = 124},
  [661] = {.lex_state = 174},
  [662] = {.lex_state = 174},
  [663] = {.lex_state = 174},
  [664] = {.lex_state = 81, .external_lex_state = 2},
  [665] = {.lex_state = 174},
  [666] = {.lex_state = 159},
  [667] = {.lex_state = 174},
  [668] = {.lex_state = 174},
  [669] = {.lex_state = 174},
  [670] = {.lex_state = 187},
  [671] = {.lex_state = 129},
  [672] = {.lex_state = 124},
  [673] = {.lex_state = 174, .external_lex_state = 2},
  [674] = {.lex_state = 177, .external_lex_state = 4},
  [675] = {.lex_state = 177, .external_lex_state = 5},
  [676] = {.lex_state = 177, .external_lex_state = 5},
  [677] = {.lex_state = 108, .external_lex_state = 2},
  [678] = {.lex_state = 108},
  [679] = {.lex_state = 108},
  [680] = {.lex_state = 156, .external_lex_state = 5},
  [681] = {.lex_state = 81, .external_lex_state = 2},
  [682] = {.lex_state = 177, .external_lex_state = 5},
  [683] = {.lex_state = 129, .external_lex_state = 2},
  [684] = {.lex_state = 129},
  [685] = {.lex_state = 129},
  [686] = {.lex_state = 177, .external_lex_state = 5},
  [687] = {.lex_state = 132, .external_lex_state = 2},
  [688] = {.lex_state = 177, .external_lex_state = 5},
  [689] = {.lex_state = 132},
  [690] = {.lex_state = 132, .external_lex_state = 2},
  [691] = {.lex_state = 132},
  [692] = {.lex_state = 132},
  [693] = {.lex_state = 132},
  [694] = {.lex_state = 156, .external_lex_state = 5},
  [695] = {.lex_state = 118, .external_lex_state = 4},
  [696] = {.lex_state = 156, .external_lex_state = 5},
  [697] = {.lex_state = 104},
  [698] = {.lex_state = 156, .external_lex_state = 5},
  [699] = {.lex_state = 177, .external_lex_state = 5},
  [700] = {.lex_state = 177, .external_lex_state = 5},
  [701] = {.lex_state = 108},
  [702] = {.lex_state = 108},
  [703] = {.lex_state = 124},
  [704] = {.lex_state = 180, .external_lex_state = 5},
  [705] = {.lex_state = 180, .external_lex_state = 5},
  [706] = {.lex_state = 180, .external_lex_state = 5},
  [707] = {.lex_state = 81, .external_lex_state = 2},
  [708] = {.lex_state = 180, .external_lex_state = 5},
  [709] = {.lex_state = 177, .external_lex_state = 5},
  [710] = {.lex_state = 180, .external_lex_state = 5},
  [711] = {.lex_state = 180, .external_lex_state = 5},
  [712] = {.lex_state = 180, .external_lex_state = 5},
  [713] = {.lex_state = 187},
  [714] = {.lex_state = 129},
  [715] = {.lex_state = 204, .external_lex_state = 5},
  [716] = {.lex_state = 180, .external_lex_state = 4},
  [717] = {.lex_state = 118, .external_lex_state = 4},
  [718] = {.lex_state = 104, .external_lex_state = 5},
  [719] = {.lex_state = 81, .external_lex_state = 2},
  [720] = {.lex_state = 108},
  [721] = {.lex_state = 81, .external_lex_state = 2},
  [722] = {.lex_state = 81, .external_lex_state = 2},
  [723] = {.lex_state = 81, .external_lex_state = 2},
  [724] = {.lex_state = 81, .external_lex_state = 2},
  [725] = {.lex_state = 81, .external_lex_state = 2},
  [726] = {.lex_state = 81, .external_lex_state = 2},
  [727] = {.lex_state = 104},
  [728] = {.lex_state = 81, .external_lex_state = 2},
  [729] = {.lex_state = 81, .external_lex_state = 2},
  [730] = {.lex_state = 81, .external_lex_state = 2},
  [731] = {.lex_state = 81, .external_lex_state = 2},
  [732] = {.lex_state = 81, .external_lex_state = 2},
  [733] = {.lex_state = 81, .external_lex_state = 2},
  [734] = {.lex_state = 220, .external_lex_state = 5},
  [735] = {.lex_state = 207, .external_lex_state = 4},
  [736] = {.lex_state = 156, .external_lex_state = 5},
  [737] = {.lex_state = 81, .external_lex_state = 2},
  [738] = {.lex_state = 104, .external_lex_state = 5},
  [739] = {.lex_state = 156, .external_lex_state = 5},
  [740] = {.lex_state = 104},
  [741] = {.lex_state = 156, .external_lex_state = 5},
  [742] = {.lex_state = 118, .external_lex_state = 4},
  [743] = {.lex_state = 156, .external_lex_state = 5},
  [744] = {.lex_state = 180, .external_lex_state = 5},
  [745] = {.lex_state = 180, .external_lex_state = 5},
  [746] = {.lex_state = 180, .external_lex_state = 5},
  [747] = {.lex_state = 81, .external_lex_state = 2},
  [748] = {.lex_state = 180, .external_lex_state = 5},
  [749] = {.lex_state = 180, .external_lex_state = 5},
  [750] = {.lex_state = 180, .external_lex_state = 5},
  [751] = {.lex_state = 180, .external_lex_state = 5},
  [752] = {.lex_state = 204, .external_lex_state = 5},
  [753] = {.lex_state = 180, .external_lex_state = 4},
  [754] = {.lex_state = 121},
  [755] = {.lex_state = 81, .external_lex_state = 2},
  [756] = {.lex_state = 104},
  [757] = {.lex_state = 81, .external_lex_state = 7},
  [758] = {.lex_state = 81, .external_lex_state = 2},
  [759] = {.lex_state = 121},
  [760] = {.lex_state = 174},
  [761] = {.lex_state = 174},
  [762] = {.lex_state = 174},
  [763] = {.lex_state = 81, .external_lex_state = 2},
  [764] = {.lex_state = 174},
  [765] = {.lex_state = 174},
  [766] = {.lex_state = 174},
  [767] = {.lex_state = 174},
  [768] = {.lex_state = 121},
  [769] = {.lex_state = 174, .external_lex_state = 2},
  [770] = {.lex_state = 81, .external_lex_state = 2},
  [771] = {.lex_state = 81, .external_lex_state = 6},
  [772] = {.lex_state = 108},
  [773] = {.lex_state = 210},
  [774] = {.lex_state = 108},
  [775] = {.lex_state = 121},
  [776] = {.lex_state = 174},
  [777] = {.lex_state = 174},
  [778] = {.lex_state = 174},
  [779] = {.lex_state = 174},
  [780] = {.lex_state = 174},
  [781] = {.lex_state = 174},
  [782] = {.lex_state = 174},
  [783] = {.lex_state = 81, .external_lex_state = 2},
  [784] = {.lex_state = 121},
  [785] = {.lex_state = 174, .external_lex_state = 2},
  [786] = {.lex_state = 81, .external_lex_state = 2},
  [787] = {.lex_state = 104},
  [788] = {.lex_state = 81, .external_lex_state = 2},
  [789] = {.lex_state = 104},
  [790] = {.lex_state = 81, .external_lex_state = 2},
  [791] = {.lex_state = 81, .external_lex_state = 2},
  [792] = {.lex_state = 108},
  [793] = {.lex_state = 81, .external_lex_state = 2},
  [794] = {.lex_state = 104},
  [795] = {.lex_state = 104},
  [796] = {.lex_state = 104, .external_lex_state = 5},
  [797] = {.lex_state = 81, .external_lex_state = 7},
  [798] = {.lex_state = 104},
  [799] = {.lex_state = 104},
  [800] = {.lex_state = 81, .external_lex_state = 4},
  [801] = {.lex_state = 104, .external_lex_state = 5},
  [802] = {.lex_state = 108, .external_lex_state = 2},
  [803] = {.lex_state = 108},
  [804] = {.lex_state = 81, .external_lex_state = 2},
  [805] = {.lex_state = 81, .external_lex_state = 2},
  [806] = {.lex_state = 121},
  [807] = {.lex_state = 81, .external_lex_state = 2},
  [808] = {.lex_state = 108},
  [809] = {.lex_state = 81, .external_lex_state = 2},
  [810] = {.lex_state = 108},
  [811] = {.lex_state = 121},
  [812] = {.lex_state = 104},
  [813] = {.lex_state = 121},
  [814] = {.lex_state = 174},
  [815] = {.lex_state = 174},
  [816] = {.lex_state = 174},
  [817] = {.lex_state = 81, .external_lex_state = 2},
  [818] = {.lex_state = 174},
  [819] = {.lex_state = 174},
  [820] = {.lex_state = 174},
  [821] = {.lex_state = 174},
  [822] = {.lex_state = 121},
  [823] = {.lex_state = 174, .external_lex_state = 2},
  [824] = {.lex_state = 210},
  [825] = {.lex_state = 108, .external_lex_state = 2},
  [826] = {.lex_state = 108},
  [827] = {.lex_state = 108},
  [828] = {.lex_state = 108},
  [829] = {.lex_state = 108},
  [830] = {.lex_state = 108},
  [831] = {.lex_state = 81, .external_lex_state = 6},
  [832] = {.lex_state = 81, .external_lex_state = 2},
  [833] = {.lex_state = 156, .external_lex_state = 5},
  [834] = {.lex_state = 156, .external_lex_state = 5},
  [835] = {.lex_state = 104, .external_lex_state = 5},
  [836] = {.lex_state = 156, .external_lex_state = 5},
  [837] = {.lex_state = 124},
  [838] = {.lex_state = 81, .external_lex_state = 2},
  [839] = {.lex_state = 81, .external_lex_state = 6},
  [840] = {.lex_state = 184, .external_lex_state = 5},
  [841] = {.lex_state = 124},
  [842] = {.lex_state = 104},
  [843] = {.lex_state = 121},
  [844] = {.lex_state = 121},
  [845] = {.lex_state = 81, .external_lex_state = 2},
  [846] = {.lex_state = 108},
  [847] = {.lex_state = 81, .external_lex_state = 2},
  [848] = {.lex_state = 81, .external_lex_state = 2},
  [849] = {.lex_state = 81, .external_lex_state = 2},
  [850] = {.lex_state = 81, .external_lex_state = 2},
  [851] = {.lex_state = 81, .external_lex_state = 2},
  [852] = {.lex_state = 81, .external_lex_state = 2},
  [853] = {.lex_state = 104},
  [854] = {.lex_state = 81, .external_lex_state = 2},
  [855] = {.lex_state = 81, .external_lex_state = 2},
  [856] = {.lex_state = 81, .external_lex_state = 2},
  [857] = {.lex_state = 81, .external_lex_state = 2},
  [858] = {.lex_state = 81, .external_lex_state = 2},
  [859] = {.lex_state = 81, .external_lex_state = 2},
  [860] = {.lex_state = 121},
  [861] = {.lex_state = 174, .external_lex_state = 2},
  [862] = {.lex_state = 108},
  [863] = {.lex_state = 108},
  [864] = {.lex_state = 108},
  [865] = {.lex_state = 108},
  [866] = {.lex_state = 81, .external_lex_state = 2},
  [867] = {.lex_state = 81, .external_lex_state = 2},
  [868] = {.lex_state = 124},
  [869] = {.lex_state = 81, .external_lex_state = 2},
  [870] = {.lex_state = 121},
  [871] = {.lex_state = 174},
  [872] = {.lex_state = 108},
  [873] = {.lex_state = 174, .external_lex_state = 2},
  [874] = {.lex_state = 121},
  [875] = {.lex_state = 124},
  [876] = {.lex_state = 108},
  [877] = {.lex_state = 81, .external_lex_state = 2},
  [878] = {.lex_state = 81, .external_lex_state = 2},
  [879] = {.lex_state = 124},
  [880] = {.lex_state = 81, .external_lex_state = 2},
  [881] = {.lex_state = 121},
  [882] = {.lex_state = 174},
  [883] = {.lex_state = 108},
  [884] = {.lex_state = 174, .external_lex_state = 2},
  [885] = {.lex_state = 121},
  [886] = {.lex_state = 124},
  [887] = {.lex_state = 138, .external_lex_state = 5},
  [888] = {.lex_state = 121},
  [889] = {.lex_state = 108},
  [890] = {.lex_state = 187},
  [891] = {.lex_state = 81, .external_lex_state = 2},
  [892] = {.lex_state = 108},
  [893] = {.lex_state = 81, .external_lex_state = 2},
  [894] = {.lex_state = 81, .external_lex_state = 2},
  [895] = {.lex_state = 81, .external_lex_state = 2},
  [896] = {.lex_state = 81, .external_lex_state = 2},
  [897] = {.lex_state = 81, .external_lex_state = 2},
  [898] = {.lex_state = 81, .external_lex_state = 2},
  [899] = {.lex_state = 104},
  [900] = {.lex_state = 81, .external_lex_state = 2},
  [901] = {.lex_state = 81, .external_lex_state = 2},
  [902] = {.lex_state = 81, .external_lex_state = 2},
  [903] = {.lex_state = 81, .external_lex_state = 2},
  [904] = {.lex_state = 81, .external_lex_state = 2},
  [905] = {.lex_state = 81, .external_lex_state = 2},
  [906] = {.lex_state = 187},
  [907] = {.lex_state = 187, .external_lex_state = 2},
  [908] = {.lex_state = 187},
  [909] = {.lex_state = 81, .external_lex_state = 2},
  [910] = {.lex_state = 121, .external_lex_state = 5},
  [911] = {.lex_state = 223},
  [912] = {.lex_state = 187},
  [913] = {.lex_state = 129, .external_lex_state = 2},
  [914] = {.lex_state = 129},
  [915] = {.lex_state = 104},
  [916] = {.lex_state = 81, .external_lex_state = 2},
  [917] = {.lex_state = 104},
  [918] = {.lex_state = 187},
  [919] = {.lex_state = 121, .external_lex_state = 5},
  [920] = {.lex_state = 81, .external_lex_state = 2},
  [921] = {.lex_state = 187},
  [922] = {.lex_state = 187},
  [923] = {.lex_state = 187},
  [924] = {.lex_state = 187},
  [925] = {.lex_state = 81, .external_lex_state = 2},
  [926] = {.lex_state = 187},
  [927] = {.lex_state = 187},
  [928] = {.lex_state = 187},
  [929] = {.lex_state = 187},
  [930] = {.lex_state = 187},
  [931] = {.lex_state = 187, .external_lex_state = 2},
  [932] = {.lex_state = 190},
  [933] = {.lex_state = 190},
  [934] = {.lex_state = 81, .external_lex_state = 2},
  [935] = {.lex_state = 108},
  [936] = {.lex_state = 81, .external_lex_state = 2},
  [937] = {.lex_state = 81, .external_lex_state = 2},
  [938] = {.lex_state = 81, .external_lex_state = 2},
  [939] = {.lex_state = 81, .external_lex_state = 2},
  [940] = {.lex_state = 81, .external_lex_state = 2},
  [941] = {.lex_state = 81, .external_lex_state = 2},
  [942] = {.lex_state = 104},
  [943] = {.lex_state = 81, .external_lex_state = 2},
  [944] = {.lex_state = 81, .external_lex_state = 2},
  [945] = {.lex_state = 81, .external_lex_state = 2},
  [946] = {.lex_state = 81, .external_lex_state = 2},
  [947] = {.lex_state = 81, .external_lex_state = 2},
  [948] = {.lex_state = 81, .external_lex_state = 2},
  [949] = {.lex_state = 190},
  [950] = {.lex_state = 190, .external_lex_state = 2},
  [951] = {.lex_state = 190},
  [952] = {.lex_state = 81, .external_lex_state = 2},
  [953] = {.lex_state = 132, .external_lex_state = 2},
  [954] = {.lex_state = 121, .external_lex_state = 5},
  [955] = {.lex_state = 190},
  [956] = {.lex_state = 132, .external_lex_state = 2},
  [957] = {.lex_state = 132},
  [958] = {.lex_state = 108},
  [959] = {.lex_state = 121, .external_lex_state = 5},
  [960] = {.lex_state = 132},
  [961] = {.lex_state = 121},
  [962] = {.lex_state = 132, .external_lex_state = 2},
  [963] = {.lex_state = 132},
  [964] = {.lex_state = 104},
  [965] = {.lex_state = 81, .external_lex_state = 2},
  [966] = {.lex_state = 81, .external_lex_state = 2},
  [967] = {.lex_state = 124},
  [968] = {.lex_state = 81, .external_lex_state = 2},
  [969] = {.lex_state = 190},
  [970] = {.lex_state = 190},
  [971] = {.lex_state = 190, .external_lex_state = 2},
  [972] = {.lex_state = 81, .external_lex_state = 2},
  [973] = {.lex_state = 104},
  [974] = {.lex_state = 190},
  [975] = {.lex_state = 121, .external_lex_state = 5},
  [976] = {.lex_state = 81, .external_lex_state = 2},
  [977] = {.lex_state = 190},
  [978] = {.lex_state = 190},
  [979] = {.lex_state = 190},
  [980] = {.lex_state = 190},
  [981] = {.lex_state = 81, .external_lex_state = 2},
  [982] = {.lex_state = 190},
  [983] = {.lex_state = 190},
  [984] = {.lex_state = 190},
  [985] = {.lex_state = 190},
  [986] = {.lex_state = 190},
  [987] = {.lex_state = 121, .external_lex_state = 5},
  [988] = {.lex_state = 190, .external_lex_state = 2},
  [989] = {.lex_state = 81, .external_lex_state = 2},
  [990] = {.lex_state = 81, .external_lex_state = 2},
  [991] = {.lex_state = 214, .external_lex_state = 5},
  [992] = {.lex_state = 81, .external_lex_state = 2},
  [993] = {.lex_state = 108},
  [994] = {.lex_state = 81, .external_lex_state = 2},
  [995] = {.lex_state = 81, .external_lex_state = 2},
  [996] = {.lex_state = 81, .external_lex_state = 2},
  [997] = {.lex_state = 81, .external_lex_state = 2},
  [998] = {.lex_state = 81, .external_lex_state = 2},
  [999] = {.lex_state = 81, .external_lex_state = 2},
  [1000] = {.lex_state = 104},
  [1001] = {.lex_state = 81, .external_lex_state = 2},
  [1002] = {.lex_state = 81, .external_lex_state = 2},
  [1003] = {.lex_state = 81, .external_lex_state = 2},
  [1004] = {.lex_state = 81, .external_lex_state = 2},
  [1005] = {.lex_state = 81, .external_lex_state = 2},
  [1006] = {.lex_state = 81, .external_lex_state = 2},
  [1007] = {.lex_state = 226, .external_lex_state = 5},
  [1008] = {.lex_state = 81, .external_lex_state = 2},
  [1009] = {.lex_state = 217, .external_lex_state = 4},
  [1010] = {.lex_state = 193, .external_lex_state = 4},
  [1011] = {.lex_state = 138, .external_lex_state = 5},
  [1012] = {.lex_state = 104},
  [1013] = {.lex_state = 81, .external_lex_state = 2},
  [1014] = {.lex_state = 108},
  [1015] = {.lex_state = 81, .external_lex_state = 2},
  [1016] = {.lex_state = 81, .external_lex_state = 2},
  [1017] = {.lex_state = 81, .external_lex_state = 2},
  [1018] = {.lex_state = 81, .external_lex_state = 2},
  [1019] = {.lex_state = 81, .external_lex_state = 2},
  [1020] = {.lex_state = 81, .external_lex_state = 2},
  [1021] = {.lex_state = 81, .external_lex_state = 2},
  [1022] = {.lex_state = 104},
  [1023] = {.lex_state = 81, .external_lex_state = 2},
  [1024] = {.lex_state = 81, .external_lex_state = 2},
  [1025] = {.lex_state = 81, .external_lex_state = 2},
  [1026] = {.lex_state = 81, .external_lex_state = 2},
  [1027] = {.lex_state = 81, .external_lex_state = 2},
  [1028] = {.lex_state = 81, .external_lex_state = 2},
  [1029] = {.lex_state = 121},
  [1030] = {.lex_state = 174, .external_lex_state = 2},
  [1031] = {.lex_state = 81, .external_lex_state = 2},
  [1032] = {.lex_state = 121, .external_lex_state = 5},
  [1033] = {.lex_state = 81, .external_lex_state = 2},
  [1034] = {.lex_state = 124},
  [1035] = {.lex_state = 81, .external_lex_state = 2},
  [1036] = {.lex_state = 81, .external_lex_state = 2},
  [1037] = {.lex_state = 108, .external_lex_state = 2},
  [1038] = {.lex_state = 108},
  [1039] = {.lex_state = 121, .external_lex_state = 5},
  [1040] = {.lex_state = 129, .external_lex_state = 2},
  [1041] = {.lex_state = 187},
  [1042] = {.lex_state = 187},
  [1043] = {.lex_state = 81, .external_lex_state = 2},
  [1044] = {.lex_state = 108},
  [1045] = {.lex_state = 129, .external_lex_state = 2},
  [1046] = {.lex_state = 81, .external_lex_state = 2},
  [1047] = {.lex_state = 129, .external_lex_state = 2},
  [1048] = {.lex_state = 81, .external_lex_state = 2},
  [1049] = {.lex_state = 81, .external_lex_state = 2},
  [1050] = {.lex_state = 121, .external_lex_state = 5},
  [1051] = {.lex_state = 129},
  [1052] = {.lex_state = 81, .external_lex_state = 2},
  [1053] = {.lex_state = 81, .external_lex_state = 2},
  [1054] = {.lex_state = 81, .external_lex_state = 2},
  [1055] = {.lex_state = 104},
  [1056] = {.lex_state = 81, .external_lex_state = 2},
  [1057] = {.lex_state = 81, .external_lex_state = 2},
  [1058] = {.lex_state = 81, .external_lex_state = 2},
  [1059] = {.lex_state = 81, .external_lex_state = 2},
  [1060] = {.lex_state = 81, .external_lex_state = 2},
  [1061] = {.lex_state = 81, .external_lex_state = 2},
  [1062] = {.lex_state = 187},
  [1063] = {.lex_state = 187, .external_lex_state = 2},
  [1064] = {.lex_state = 201},
  [1065] = {.lex_state = 81, .external_lex_state = 2},
  [1066] = {.lex_state = 104},
  [1067] = {.lex_state = 201},
  [1068] = {.lex_state = 88, .external_lex_state = 3},
  [1069] = {.lex_state = 201},
  [1070] = {.lex_state = 201},
  [1071] = {.lex_state = 201},
  [1072] = {.lex_state = 81, .external_lex_state = 2},
  [1073] = {.lex_state = 201},
  [1074] = {.lex_state = 201},
  [1075] = {.lex_state = 201},
  [1076] = {.lex_state = 201},
  [1077] = {.lex_state = 201},
  [1078] = {.lex_state = 201, .external_lex_state = 2},
  [1079] = {.lex_state = 104},
  [1080] = {.lex_state = 124},
  [1081] = {.lex_state = 108},
  [1082] = {.lex_state = 108},
  [1083] = {.lex_state = 124},
  [1084] = {.lex_state = 159},
  [1085] = {.lex_state = 159},
  [1086] = {.lex_state = 108, .external_lex_state = 2},
  [1087] = {.lex_state = 124},
  [1088] = {.lex_state = 124},
  [1089] = {.lex_state = 81, .external_lex_state = 2},
  [1090] = {.lex_state = 124},
  [1091] = {.lex_state = 104},
  [1092] = {.lex_state = 124},
  [1093] = {.lex_state = 108, .external_lex_state = 2},
  [1094] = {.lex_state = 108},
  [1095] = {.lex_state = 174},
  [1096] = {.lex_state = 174},
  [1097] = {.lex_state = 174},
  [1098] = {.lex_state = 81, .external_lex_state = 2},
  [1099] = {.lex_state = 174},
  [1100] = {.lex_state = 174},
  [1101] = {.lex_state = 174},
  [1102] = {.lex_state = 174},
  [1103] = {.lex_state = 124},
  [1104] = {.lex_state = 174, .external_lex_state = 2},
  [1105] = {.lex_state = 159},
  [1106] = {.lex_state = 129, .external_lex_state = 2},
  [1107] = {.lex_state = 159},
  [1108] = {.lex_state = 159},
  [1109] = {.lex_state = 132, .external_lex_state = 2},
  [1110] = {.lex_state = 159},
  [1111] = {.lex_state = 132, .external_lex_state = 2},
  [1112] = {.lex_state = 159},
  [1113] = {.lex_state = 159},
  [1114] = {.lex_state = 81, .external_lex_state = 2},
  [1115] = {.lex_state = 104},
  [1116] = {.lex_state = 81, .external_lex_state = 2},
  [1117] = {.lex_state = 81, .external_lex_state = 2},
  [1118] = {.lex_state = 81, .external_lex_state = 2},
  [1119] = {.lex_state = 124},
  [1120] = {.lex_state = 81, .external_lex_state = 2},
  [1121] = {.lex_state = 124},
  [1122] = {.lex_state = 174},
  [1123] = {.lex_state = 174, .external_lex_state = 2},
  [1124] = {.lex_state = 124},
  [1125] = {.lex_state = 121, .external_lex_state = 5},
  [1126] = {.lex_state = 81, .external_lex_state = 2},
  [1127] = {.lex_state = 159},
  [1128] = {.lex_state = 108, .external_lex_state = 2},
  [1129] = {.lex_state = 108},
  [1130] = {.lex_state = 174},
  [1131] = {.lex_state = 129, .external_lex_state = 2},
  [1132] = {.lex_state = 159},
  [1133] = {.lex_state = 129},
  [1134] = {.lex_state = 177, .external_lex_state = 5},
  [1135] = {.lex_state = 177, .external_lex_state = 5},
  [1136] = {.lex_state = 108, .external_lex_state = 2},
  [1137] = {.lex_state = 156, .external_lex_state = 5},
  [1138] = {.lex_state = 177, .external_lex_state = 5},
  [1139] = {.lex_state = 129, .external_lex_state = 2},
  [1140] = {.lex_state = 177, .external_lex_state = 5},
  [1141] = {.lex_state = 177, .external_lex_state = 5},
  [1142] = {.lex_state = 132, .external_lex_state = 2},
  [1143] = {.lex_state = 177, .external_lex_state = 5},
  [1144] = {.lex_state = 132, .external_lex_state = 2},
  [1145] = {.lex_state = 177, .external_lex_state = 5},
  [1146] = {.lex_state = 177, .external_lex_state = 5},
  [1147] = {.lex_state = 81, .external_lex_state = 2},
  [1148] = {.lex_state = 177, .external_lex_state = 5},
  [1149] = {.lex_state = 108, .external_lex_state = 2},
  [1150] = {.lex_state = 108},
  [1151] = {.lex_state = 180, .external_lex_state = 5},
  [1152] = {.lex_state = 129, .external_lex_state = 2},
  [1153] = {.lex_state = 177, .external_lex_state = 5},
  [1154] = {.lex_state = 129},
  [1155] = {.lex_state = 104, .external_lex_state = 5},
  [1156] = {.lex_state = 81, .external_lex_state = 2},
  [1157] = {.lex_state = 104},
  [1158] = {.lex_state = 104, .external_lex_state = 5},
  [1159] = {.lex_state = 207, .external_lex_state = 5},
  [1160] = {.lex_state = 207, .external_lex_state = 5},
  [1161] = {.lex_state = 207, .external_lex_state = 5},
  [1162] = {.lex_state = 81, .external_lex_state = 2},
  [1163] = {.lex_state = 207, .external_lex_state = 5},
  [1164] = {.lex_state = 207, .external_lex_state = 5},
  [1165] = {.lex_state = 207, .external_lex_state = 5},
  [1166] = {.lex_state = 207, .external_lex_state = 5},
  [1167] = {.lex_state = 220, .external_lex_state = 5},
  [1168] = {.lex_state = 207, .external_lex_state = 4},
  [1169] = {.lex_state = 156, .external_lex_state = 5},
  [1170] = {.lex_state = 81, .external_lex_state = 2},
  [1171] = {.lex_state = 81, .external_lex_state = 2},
  [1172] = {.lex_state = 180, .external_lex_state = 5},
  [1173] = {.lex_state = 121},
  [1174] = {.lex_state = 81, .external_lex_state = 2},
  [1175] = {.lex_state = 81, .external_lex_state = 2},
  [1176] = {.lex_state = 81, .external_lex_state = 7},
  [1177] = {.lex_state = 81, .external_lex_state = 2},
  [1178] = {.lex_state = 108},
  [1179] = {.lex_state = 81, .external_lex_state = 2},
  [1180] = {.lex_state = 81, .external_lex_state = 2},
  [1181] = {.lex_state = 174},
  [1182] = {.lex_state = 108},
  [1183] = {.lex_state = 81, .external_lex_state = 2},
  [1184] = {.lex_state = 81, .external_lex_state = 6},
  [1185] = {.lex_state = 81, .external_lex_state = 6},
  [1186] = {.lex_state = 81, .external_lex_state = 2},
  [1187] = {.lex_state = 81, .external_lex_state = 6},
  [1188] = {.lex_state = 108, .external_lex_state = 2},
  [1189] = {.lex_state = 108},
  [1190] = {.lex_state = 81, .external_lex_state = 2},
  [1191] = {.lex_state = 81, .external_lex_state = 2},
  [1192] = {.lex_state = 121},
  [1193] = {.lex_state = 81, .external_lex_state = 2},
  [1194] = {.lex_state = 81, .external_lex_state = 2},
  [1195] = {.lex_state = 104},
  [1196] = {.lex_state = 104},
  [1197] = {.lex_state = 121},
  [1198] = {.lex_state = 81, .external_lex_state = 6},
  [1199] = {.lex_state = 108},
  [1200] = {.lex_state = 81},
  [1201] = {.lex_state = 108},
  [1202] = {.lex_state = 81, .external_lex_state = 7},
  [1203] = {.lex_state = 81, .external_lex_state = 4},
  [1204] = {.lex_state = 104, .external_lex_state = 5},
  [1205] = {.lex_state = 104},
  [1206] = {.lex_state = 81, .external_lex_state = 7},
  [1207] = {.lex_state = 104},
  [1208] = {.lex_state = 81, .external_lex_state = 7},
  [1209] = {.lex_state = 104},
  [1210] = {.lex_state = 81, .external_lex_state = 4},
  [1211] = {.lex_state = 81, .external_lex_state = 6},
  [1212] = {.lex_state = 121},
  [1213] = {.lex_state = 81, .external_lex_state = 6},
  [1214] = {.lex_state = 81, .external_lex_state = 2},
  [1215] = {.lex_state = 81, .external_lex_state = 2},
  [1216] = {.lex_state = 81, .external_lex_state = 2},
  [1217] = {.lex_state = 121},
  [1218] = {.lex_state = 81, .external_lex_state = 2},
  [1219] = {.lex_state = 174},
  [1220] = {.lex_state = 81, .external_lex_state = 2},
  [1221] = {.lex_state = 81, .external_lex_state = 2},
  [1222] = {.lex_state = 81, .external_lex_state = 2},
  [1223] = {.lex_state = 124},
  [1224] = {.lex_state = 81, .external_lex_state = 2},
  [1225] = {.lex_state = 124},
  [1226] = {.lex_state = 174},
  [1227] = {.lex_state = 174, .external_lex_state = 2},
  [1228] = {.lex_state = 124},
  [1229] = {.lex_state = 81, .external_lex_state = 2},
  [1230] = {.lex_state = 81, .external_lex_state = 2},
  [1231] = {.lex_state = 108},
  [1232] = {.lex_state = 124},
  [1233] = {.lex_state = 81, .external_lex_state = 2},
  [1234] = {.lex_state = 81, .external_lex_state = 2},
  [1235] = {.lex_state = 108},
  [1236] = {.lex_state = 210},
  [1237] = {.lex_state = 81, .external_lex_state = 2},
  [1238] = {.lex_state = 81, .external_lex_state = 2},
  [1239] = {.lex_state = 121},
  [1240] = {.lex_state = 108},
  [1241] = {.lex_state = 156, .external_lex_state = 5},
  [1242] = {.lex_state = 81, .external_lex_state = 2},
  [1243] = {.lex_state = 121},
  [1244] = {.lex_state = 81, .external_lex_state = 2},
  [1245] = {.lex_state = 104},
  [1246] = {.lex_state = 121},
  [1247] = {.lex_state = 174},
  [1248] = {.lex_state = 174},
  [1249] = {.lex_state = 174},
  [1250] = {.lex_state = 81, .external_lex_state = 2},
  [1251] = {.lex_state = 174},
  [1252] = {.lex_state = 174},
  [1253] = {.lex_state = 174},
  [1254] = {.lex_state = 174},
  [1255] = {.lex_state = 121},
  [1256] = {.lex_state = 174, .external_lex_state = 2},
  [1257] = {.lex_state = 121},
  [1258] = {.lex_state = 81, .external_lex_state = 2},
  [1259] = {.lex_state = 108},
  [1260] = {.lex_state = 81, .external_lex_state = 2},
  [1261] = {.lex_state = 81, .external_lex_state = 2},
  [1262] = {.lex_state = 81, .external_lex_state = 2},
  [1263] = {.lex_state = 81, .external_lex_state = 2},
  [1264] = {.lex_state = 81, .external_lex_state = 2},
  [1265] = {.lex_state = 81, .external_lex_state = 2},
  [1266] = {.lex_state = 104},
  [1267] = {.lex_state = 81, .external_lex_state = 2},
  [1268] = {.lex_state = 81, .external_lex_state = 2},
  [1269] = {.lex_state = 81, .external_lex_state = 2},
  [1270] = {.lex_state = 81, .external_lex_state = 2},
  [1271] = {.lex_state = 81, .external_lex_state = 2},
  [1272] = {.lex_state = 81, .external_lex_state = 2},
  [1273] = {.lex_state = 121},
  [1274] = {.lex_state = 81, .external_lex_state = 2},
  [1275] = {.lex_state = 174, .external_lex_state = 2},
  [1276] = {.lex_state = 124},
  [1277] = {.lex_state = 121},
  [1278] = {.lex_state = 81, .external_lex_state = 2},
  [1279] = {.lex_state = 108},
  [1280] = {.lex_state = 81, .external_lex_state = 2},
  [1281] = {.lex_state = 81, .external_lex_state = 2},
  [1282] = {.lex_state = 81, .external_lex_state = 2},
  [1283] = {.lex_state = 81, .external_lex_state = 2},
  [1284] = {.lex_state = 81, .external_lex_state = 2},
  [1285] = {.lex_state = 81, .external_lex_state = 2},
  [1286] = {.lex_state = 104},
  [1287] = {.lex_state = 81, .external_lex_state = 2},
  [1288] = {.lex_state = 81, .external_lex_state = 2},
  [1289] = {.lex_state = 81, .external_lex_state = 2},
  [1290] = {.lex_state = 81, .external_lex_state = 2},
  [1291] = {.lex_state = 81, .external_lex_state = 2},
  [1292] = {.lex_state = 81, .external_lex_state = 2},
  [1293] = {.lex_state = 121},
  [1294] = {.lex_state = 81, .external_lex_state = 2},
  [1295] = {.lex_state = 174, .external_lex_state = 2},
  [1296] = {.lex_state = 187},
  [1297] = {.lex_state = 81, .external_lex_state = 2},
  [1298] = {.lex_state = 104},
  [1299] = {.lex_state = 187},
  [1300] = {.lex_state = 187},
  [1301] = {.lex_state = 187},
  [1302] = {.lex_state = 187},
  [1303] = {.lex_state = 81, .external_lex_state = 2},
  [1304] = {.lex_state = 187},
  [1305] = {.lex_state = 187},
  [1306] = {.lex_state = 187},
  [1307] = {.lex_state = 187},
  [1308] = {.lex_state = 187},
  [1309] = {.lex_state = 187, .external_lex_state = 2},
  [1310] = {.lex_state = 187},
  [1311] = {.lex_state = 121, .external_lex_state = 5},
  [1312] = {.lex_state = 108, .external_lex_state = 2},
  [1313] = {.lex_state = 81, .external_lex_state = 2},
  [1314] = {.lex_state = 104},
  [1315] = {.lex_state = 81, .external_lex_state = 2},
  [1316] = {.lex_state = 81, .external_lex_state = 2},
  [1317] = {.lex_state = 81, .external_lex_state = 2},
  [1318] = {.lex_state = 124},
  [1319] = {.lex_state = 81, .external_lex_state = 2},
  [1320] = {.lex_state = 187},
  [1321] = {.lex_state = 187},
  [1322] = {.lex_state = 187, .external_lex_state = 2},
  [1323] = {.lex_state = 187},
  [1324] = {.lex_state = 187},
  [1325] = {.lex_state = 190},
  [1326] = {.lex_state = 81, .external_lex_state = 2},
  [1327] = {.lex_state = 104},
  [1328] = {.lex_state = 190},
  [1329] = {.lex_state = 190},
  [1330] = {.lex_state = 190},
  [1331] = {.lex_state = 190},
  [1332] = {.lex_state = 81, .external_lex_state = 2},
  [1333] = {.lex_state = 190},
  [1334] = {.lex_state = 190},
  [1335] = {.lex_state = 190},
  [1336] = {.lex_state = 190},
  [1337] = {.lex_state = 190},
  [1338] = {.lex_state = 190, .external_lex_state = 2},
  [1339] = {.lex_state = 190},
  [1340] = {.lex_state = 121, .external_lex_state = 5},
  [1341] = {.lex_state = 108, .external_lex_state = 2},
  [1342] = {.lex_state = 81, .external_lex_state = 2},
  [1343] = {.lex_state = 121, .external_lex_state = 5},
  [1344] = {.lex_state = 108, .external_lex_state = 2},
  [1345] = {.lex_state = 81, .external_lex_state = 2},
  [1346] = {.lex_state = 190},
  [1347] = {.lex_state = 81, .external_lex_state = 2},
  [1348] = {.lex_state = 108},
  [1349] = {.lex_state = 81, .external_lex_state = 2},
  [1350] = {.lex_state = 81, .external_lex_state = 2},
  [1351] = {.lex_state = 81, .external_lex_state = 2},
  [1352] = {.lex_state = 81, .external_lex_state = 2},
  [1353] = {.lex_state = 81, .external_lex_state = 2},
  [1354] = {.lex_state = 81, .external_lex_state = 2},
  [1355] = {.lex_state = 104},
  [1356] = {.lex_state = 81, .external_lex_state = 2},
  [1357] = {.lex_state = 81, .external_lex_state = 2},
  [1358] = {.lex_state = 81, .external_lex_state = 2},
  [1359] = {.lex_state = 81, .external_lex_state = 2},
  [1360] = {.lex_state = 81, .external_lex_state = 2},
  [1361] = {.lex_state = 81, .external_lex_state = 2},
  [1362] = {.lex_state = 190},
  [1363] = {.lex_state = 190, .external_lex_state = 2},
  [1364] = {.lex_state = 104},
  [1365] = {.lex_state = 81, .external_lex_state = 2},
  [1366] = {.lex_state = 81, .external_lex_state = 2},
  [1367] = {.lex_state = 81, .external_lex_state = 2},
  [1368] = {.lex_state = 124},
  [1369] = {.lex_state = 81, .external_lex_state = 2},
  [1370] = {.lex_state = 190},
  [1371] = {.lex_state = 190},
  [1372] = {.lex_state = 190, .external_lex_state = 2},
  [1373] = {.lex_state = 190},
  [1374] = {.lex_state = 190},
  [1375] = {.lex_state = 214, .external_lex_state = 5},
  [1376] = {.lex_state = 81, .external_lex_state = 2},
  [1377] = {.lex_state = 104},
  [1378] = {.lex_state = 214, .external_lex_state = 5},
  [1379] = {.lex_state = 217, .external_lex_state = 5},
  [1380] = {.lex_state = 217, .external_lex_state = 5},
  [1381] = {.lex_state = 217, .external_lex_state = 5},
  [1382] = {.lex_state = 81, .external_lex_state = 2},
  [1383] = {.lex_state = 217, .external_lex_state = 5},
  [1384] = {.lex_state = 217, .external_lex_state = 5},
  [1385] = {.lex_state = 217, .external_lex_state = 5},
  [1386] = {.lex_state = 217, .external_lex_state = 5},
  [1387] = {.lex_state = 226, .external_lex_state = 5},
  [1388] = {.lex_state = 104, .external_lex_state = 5},
  [1389] = {.lex_state = 217, .external_lex_state = 4},
  [1390] = {.lex_state = 193, .external_lex_state = 4},
  [1391] = {.lex_state = 104},
  [1392] = {.lex_state = 81, .external_lex_state = 2},
  [1393] = {.lex_state = 104},
  [1394] = {.lex_state = 138, .external_lex_state = 5},
  [1395] = {.lex_state = 104},
  [1396] = {.lex_state = 174},
  [1397] = {.lex_state = 174},
  [1398] = {.lex_state = 174},
  [1399] = {.lex_state = 81, .external_lex_state = 2},
  [1400] = {.lex_state = 174},
  [1401] = {.lex_state = 174},
  [1402] = {.lex_state = 174},
  [1403] = {.lex_state = 174},
  [1404] = {.lex_state = 121},
  [1405] = {.lex_state = 174, .external_lex_state = 2},
  [1406] = {.lex_state = 124},
  [1407] = {.lex_state = 124},
  [1408] = {.lex_state = 124},
  [1409] = {.lex_state = 121, .external_lex_state = 5},
  [1410] = {.lex_state = 108},
  [1411] = {.lex_state = 124},
  [1412] = {.lex_state = 108, .external_lex_state = 2},
  [1413] = {.lex_state = 108},
  [1414] = {.lex_state = 187},
  [1415] = {.lex_state = 129, .external_lex_state = 2},
  [1416] = {.lex_state = 187},
  [1417] = {.lex_state = 81, .external_lex_state = 2},
  [1418] = {.lex_state = 121, .external_lex_state = 5},
  [1419] = {.lex_state = 187},
  [1420] = {.lex_state = 129},
  [1421] = {.lex_state = 104},
  [1422] = {.lex_state = 187},
  [1423] = {.lex_state = 187},
  [1424] = {.lex_state = 129, .external_lex_state = 2},
  [1425] = {.lex_state = 129},
  [1426] = {.lex_state = 187},
  [1427] = {.lex_state = 187},
  [1428] = {.lex_state = 187},
  [1429] = {.lex_state = 81, .external_lex_state = 2},
  [1430] = {.lex_state = 187},
  [1431] = {.lex_state = 187},
  [1432] = {.lex_state = 187},
  [1433] = {.lex_state = 187},
  [1434] = {.lex_state = 187},
  [1435] = {.lex_state = 187, .external_lex_state = 2},
  [1436] = {.lex_state = 201},
  [1437] = {.lex_state = 81, .external_lex_state = 2},
  [1438] = {.lex_state = 201},
  [1439] = {.lex_state = 124},
  [1440] = {.lex_state = 104, .external_lex_state = 5},
  [1441] = {.lex_state = 124},
  [1442] = {.lex_state = 108},
  [1443] = {.lex_state = 104},
  [1444] = {.lex_state = 159},
  [1445] = {.lex_state = 124},
  [1446] = {.lex_state = 81, .external_lex_state = 2},
  [1447] = {.lex_state = 81, .external_lex_state = 2},
  [1448] = {.lex_state = 174},
  [1449] = {.lex_state = 159},
  [1450] = {.lex_state = 159},
  [1451] = {.lex_state = 159},
  [1452] = {.lex_state = 124},
  [1453] = {.lex_state = 81, .external_lex_state = 2},
  [1454] = {.lex_state = 124},
  [1455] = {.lex_state = 124},
  [1456] = {.lex_state = 124},
  [1457] = {.lex_state = 229},
  [1458] = {.lex_state = 124},
  [1459] = {.lex_state = 81, .external_lex_state = 2},
  [1460] = {.lex_state = 108},
  [1461] = {.lex_state = 81, .external_lex_state = 2},
  [1462] = {.lex_state = 81, .external_lex_state = 2},
  [1463] = {.lex_state = 81, .external_lex_state = 2},
  [1464] = {.lex_state = 81, .external_lex_state = 2},
  [1465] = {.lex_state = 81, .external_lex_state = 2},
  [1466] = {.lex_state = 81, .external_lex_state = 2},
  [1467] = {.lex_state = 104},
  [1468] = {.lex_state = 81, .external_lex_state = 2},
  [1469] = {.lex_state = 81, .external_lex_state = 2},
  [1470] = {.lex_state = 81, .external_lex_state = 2},
  [1471] = {.lex_state = 81, .external_lex_state = 2},
  [1472] = {.lex_state = 81, .external_lex_state = 2},
  [1473] = {.lex_state = 81, .external_lex_state = 2},
  [1474] = {.lex_state = 124},
  [1475] = {.lex_state = 174, .external_lex_state = 2},
  [1476] = {.lex_state = 159},
  [1477] = {.lex_state = 108, .external_lex_state = 2},
  [1478] = {.lex_state = 159},
  [1479] = {.lex_state = 129, .external_lex_state = 2},
  [1480] = {.lex_state = 177, .external_lex_state = 5},
  [1481] = {.lex_state = 177, .external_lex_state = 5},
  [1482] = {.lex_state = 177, .external_lex_state = 5},
  [1483] = {.lex_state = 177, .external_lex_state = 5},
  [1484] = {.lex_state = 156, .external_lex_state = 5},
  [1485] = {.lex_state = 177, .external_lex_state = 5},
  [1486] = {.lex_state = 108, .external_lex_state = 2},
  [1487] = {.lex_state = 177, .external_lex_state = 5},
  [1488] = {.lex_state = 129, .external_lex_state = 2},
  [1489] = {.lex_state = 104, .external_lex_state = 5},
  [1490] = {.lex_state = 81, .external_lex_state = 2},
  [1491] = {.lex_state = 207, .external_lex_state = 5},
  [1492] = {.lex_state = 156, .external_lex_state = 5},
  [1493] = {.lex_state = 121},
  [1494] = {.lex_state = 81, .external_lex_state = 2},
  [1495] = {.lex_state = 121},
  [1496] = {.lex_state = 81, .external_lex_state = 6},
  [1497] = {.lex_state = 81, .external_lex_state = 2},
  [1498] = {.lex_state = 81, .external_lex_state = 2},
  [1499] = {.lex_state = 81, .external_lex_state = 6},
  [1500] = {.lex_state = 81, .external_lex_state = 2},
  [1501] = {.lex_state = 81, .external_lex_state = 2},
  [1502] = {.lex_state = 108},
  [1503] = {.lex_state = 81, .external_lex_state = 2},
  [1504] = {.lex_state = 121},
  [1505] = {.lex_state = 108, .external_lex_state = 2},
  [1506] = {.lex_state = 108},
  [1507] = {.lex_state = 81, .external_lex_state = 6},
  [1508] = {.lex_state = 104},
  [1509] = {.lex_state = 108},
  [1510] = {.lex_state = 81},
  [1511] = {.lex_state = 81, .external_lex_state = 2},
  [1512] = {.lex_state = 81, .external_lex_state = 6},
  [1513] = {.lex_state = 104},
  [1514] = {.lex_state = 81, .external_lex_state = 6},
  [1515] = {.lex_state = 108},
  [1516] = {.lex_state = 210},
  [1517] = {.lex_state = 81, .external_lex_state = 6},
  [1518] = {.lex_state = 108},
  [1519] = {.lex_state = 81, .external_lex_state = 7},
  [1520] = {.lex_state = 81, .external_lex_state = 4},
  [1521] = {.lex_state = 104},
  [1522] = {.lex_state = 81, .external_lex_state = 2},
  [1523] = {.lex_state = 81, .external_lex_state = 2},
  [1524] = {.lex_state = 81, .external_lex_state = 6},
  [1525] = {.lex_state = 81, .external_lex_state = 2},
  [1526] = {.lex_state = 81, .external_lex_state = 2},
  [1527] = {.lex_state = 121},
  [1528] = {.lex_state = 124},
  [1529] = {.lex_state = 124},
  [1530] = {.lex_state = 81, .external_lex_state = 2},
  [1531] = {.lex_state = 108},
  [1532] = {.lex_state = 81, .external_lex_state = 2},
  [1533] = {.lex_state = 81, .external_lex_state = 2},
  [1534] = {.lex_state = 81, .external_lex_state = 2},
  [1535] = {.lex_state = 81, .external_lex_state = 2},
  [1536] = {.lex_state = 81, .external_lex_state = 2},
  [1537] = {.lex_state = 81, .external_lex_state = 2},
  [1538] = {.lex_state = 104},
  [1539] = {.lex_state = 81, .external_lex_state = 2},
  [1540] = {.lex_state = 81, .external_lex_state = 2},
  [1541] = {.lex_state = 81, .external_lex_state = 2},
  [1542] = {.lex_state = 81, .external_lex_state = 2},
  [1543] = {.lex_state = 81, .external_lex_state = 2},
  [1544] = {.lex_state = 81, .external_lex_state = 2},
  [1545] = {.lex_state = 124},
  [1546] = {.lex_state = 174, .external_lex_state = 2},
  [1547] = {.lex_state = 108},
  [1548] = {.lex_state = 108},
  [1549] = {.lex_state = 108},
  [1550] = {.lex_state = 108},
  [1551] = {.lex_state = 124},
  [1552] = {.lex_state = 124},
  [1553] = {.lex_state = 108},
  [1554] = {.lex_state = 81, .external_lex_state = 2},
  [1555] = {.lex_state = 81, .external_lex_state = 2},
  [1556] = {.lex_state = 124},
  [1557] = {.lex_state = 81, .external_lex_state = 2},
  [1558] = {.lex_state = 124},
  [1559] = {.lex_state = 174},
  [1560] = {.lex_state = 108},
  [1561] = {.lex_state = 174, .external_lex_state = 2},
  [1562] = {.lex_state = 124},
  [1563] = {.lex_state = 124},
  [1564] = {.lex_state = 124},
  [1565] = {.lex_state = 81, .external_lex_state = 6},
  [1566] = {.lex_state = 121},
  [1567] = {.lex_state = 81, .external_lex_state = 2},
  [1568] = {.lex_state = 174},
  [1569] = {.lex_state = 121},
  [1570] = {.lex_state = 81, .external_lex_state = 2},
  [1571] = {.lex_state = 104},
  [1572] = {.lex_state = 121},
  [1573] = {.lex_state = 174},
  [1574] = {.lex_state = 174},
  [1575] = {.lex_state = 174},
  [1576] = {.lex_state = 81, .external_lex_state = 2},
  [1577] = {.lex_state = 174},
  [1578] = {.lex_state = 174},
  [1579] = {.lex_state = 174},
  [1580] = {.lex_state = 174},
  [1581] = {.lex_state = 121},
  [1582] = {.lex_state = 121},
  [1583] = {.lex_state = 174, .external_lex_state = 2},
  [1584] = {.lex_state = 121},
  [1585] = {.lex_state = 81, .external_lex_state = 2},
  [1586] = {.lex_state = 104},
  [1587] = {.lex_state = 121},
  [1588] = {.lex_state = 174},
  [1589] = {.lex_state = 174},
  [1590] = {.lex_state = 174},
  [1591] = {.lex_state = 81, .external_lex_state = 2},
  [1592] = {.lex_state = 174},
  [1593] = {.lex_state = 174},
  [1594] = {.lex_state = 174},
  [1595] = {.lex_state = 174},
  [1596] = {.lex_state = 121},
  [1597] = {.lex_state = 121},
  [1598] = {.lex_state = 174, .external_lex_state = 2},
  [1599] = {.lex_state = 187},
  [1600] = {.lex_state = 81, .external_lex_state = 2},
  [1601] = {.lex_state = 187},
  [1602] = {.lex_state = 187},
  [1603] = {.lex_state = 81, .external_lex_state = 2},
  [1604] = {.lex_state = 124},
  [1605] = {.lex_state = 187},
  [1606] = {.lex_state = 187},
  [1607] = {.lex_state = 187},
  [1608] = {.lex_state = 81, .external_lex_state = 2},
  [1609] = {.lex_state = 108},
  [1610] = {.lex_state = 81, .external_lex_state = 2},
  [1611] = {.lex_state = 81, .external_lex_state = 2},
  [1612] = {.lex_state = 81, .external_lex_state = 2},
  [1613] = {.lex_state = 81, .external_lex_state = 2},
  [1614] = {.lex_state = 81, .external_lex_state = 2},
  [1615] = {.lex_state = 81, .external_lex_state = 2},
  [1616] = {.lex_state = 104},
  [1617] = {.lex_state = 81, .external_lex_state = 2},
  [1618] = {.lex_state = 81, .external_lex_state = 2},
  [1619] = {.lex_state = 81, .external_lex_state = 2},
  [1620] = {.lex_state = 81, .external_lex_state = 2},
  [1621] = {.lex_state = 81, .external_lex_state = 2},
  [1622] = {.lex_state = 81, .external_lex_state = 2},
  [1623] = {.lex_state = 187},
  [1624] = {.lex_state = 187, .external_lex_state = 2},
  [1625] = {.lex_state = 190},
  [1626] = {.lex_state = 81, .external_lex_state = 2},
  [1627] = {.lex_state = 190},
  [1628] = {.lex_state = 190},
  [1629] = {.lex_state = 190},
  [1630] = {.lex_state = 190},
  [1631] = {.lex_state = 81, .external_lex_state = 2},
  [1632] = {.lex_state = 104},
  [1633] = {.lex_state = 190},
  [1634] = {.lex_state = 190},
  [1635] = {.lex_state = 190},
  [1636] = {.lex_state = 190},
  [1637] = {.lex_state = 81, .external_lex_state = 2},
  [1638] = {.lex_state = 190},
  [1639] = {.lex_state = 190},
  [1640] = {.lex_state = 190},
  [1641] = {.lex_state = 190},
  [1642] = {.lex_state = 190},
  [1643] = {.lex_state = 190, .external_lex_state = 2},
  [1644] = {.lex_state = 81, .external_lex_state = 2},
  [1645] = {.lex_state = 124},
  [1646] = {.lex_state = 190},
  [1647] = {.lex_state = 190},
  [1648] = {.lex_state = 190},
  [1649] = {.lex_state = 81, .external_lex_state = 2},
  [1650] = {.lex_state = 108},
  [1651] = {.lex_state = 81, .external_lex_state = 2},
  [1652] = {.lex_state = 81, .external_lex_state = 2},
  [1653] = {.lex_state = 81, .external_lex_state = 2},
  [1654] = {.lex_state = 81, .external_lex_state = 2},
  [1655] = {.lex_state = 81, .external_lex_state = 2},
  [1656] = {.lex_state = 81, .external_lex_state = 2},
  [1657] = {.lex_state = 104},
  [1658] = {.lex_state = 81, .external_lex_state = 2},
  [1659] = {.lex_state = 81, .external_lex_state = 2},
  [1660] = {.lex_state = 81, .external_lex_state = 2},
  [1661] = {.lex_state = 81, .external_lex_state = 2},
  [1662] = {.lex_state = 81, .external_lex_state = 2},
  [1663] = {.lex_state = 81, .external_lex_state = 2},
  [1664] = {.lex_state = 190},
  [1665] = {.lex_state = 190, .external_lex_state = 2},
  [1666] = {.lex_state = 214, .external_lex_state = 5},
  [1667] = {.lex_state = 81, .external_lex_state = 2},
  [1668] = {.lex_state = 217, .external_lex_state = 5},
  [1669] = {.lex_state = 104},
  [1670] = {.lex_state = 81, .external_lex_state = 2},
  [1671] = {.lex_state = 174},
  [1672] = {.lex_state = 121, .external_lex_state = 5},
  [1673] = {.lex_state = 108, .external_lex_state = 2},
  [1674] = {.lex_state = 187},
  [1675] = {.lex_state = 187},
  [1676] = {.lex_state = 81, .external_lex_state = 2},
  [1677] = {.lex_state = 129, .external_lex_state = 2},
  [1678] = {.lex_state = 121, .external_lex_state = 5},
  [1679] = {.lex_state = 108, .external_lex_state = 2},
  [1680] = {.lex_state = 187},
  [1681] = {.lex_state = 201},
  [1682] = {.lex_state = 124},
  [1683] = {.lex_state = 108},
  [1684] = {.lex_state = 124},
  [1685] = {.lex_state = 124},
  [1686] = {.lex_state = 108},
  [1687] = {.lex_state = 108},
  [1688] = {.lex_state = 124},
  [1689] = {.lex_state = 124},
  [1690] = {.lex_state = 81, .external_lex_state = 2},
  [1691] = {.lex_state = 108},
  [1692] = {.lex_state = 108, .external_lex_state = 2},
  [1693] = {.lex_state = 124},
  [1694] = {.lex_state = 124},
  [1695] = {.lex_state = 81, .external_lex_state = 2},
  [1696] = {.lex_state = 104},
  [1697] = {.lex_state = 124},
  [1698] = {.lex_state = 174},
  [1699] = {.lex_state = 174},
  [1700] = {.lex_state = 174},
  [1701] = {.lex_state = 81, .external_lex_state = 2},
  [1702] = {.lex_state = 174},
  [1703] = {.lex_state = 174},
  [1704] = {.lex_state = 174},
  [1705] = {.lex_state = 174},
  [1706] = {.lex_state = 124},
  [1707] = {.lex_state = 174, .external_lex_state = 2},
  [1708] = {.lex_state = 159},
  [1709] = {.lex_state = 159},
  [1710] = {.lex_state = 177, .external_lex_state = 5},
  [1711] = {.lex_state = 177, .external_lex_state = 5},
  [1712] = {.lex_state = 104, .external_lex_state = 5},
  [1713] = {.lex_state = 81, .external_lex_state = 6},
  [1714] = {.lex_state = 81, .external_lex_state = 2},
  [1715] = {.lex_state = 81, .external_lex_state = 2},
  [1716] = {.lex_state = 81, .external_lex_state = 6},
  [1717] = {.lex_state = 81, .external_lex_state = 2},
  [1718] = {.lex_state = 81, .external_lex_state = 2},
  [1719] = {.lex_state = 81, .external_lex_state = 7},
  [1720] = {.lex_state = 81, .external_lex_state = 7},
  [1721] = {.lex_state = 81, .external_lex_state = 2},
  [1722] = {.lex_state = 81, .external_lex_state = 6},
  [1723] = {.lex_state = 108},
  [1724] = {.lex_state = 210},
  [1725] = {.lex_state = 108},
  [1726] = {.lex_state = 81, .external_lex_state = 7},
  [1727] = {.lex_state = 108, .external_lex_state = 2},
  [1728] = {.lex_state = 108},
  [1729] = {.lex_state = 81, .external_lex_state = 7},
  [1730] = {.lex_state = 81, .external_lex_state = 7},
  [1731] = {.lex_state = 81, .external_lex_state = 7},
  [1732] = {.lex_state = 81, .external_lex_state = 6},
  [1733] = {.lex_state = 81, .external_lex_state = 2},
  [1734] = {.lex_state = 81, .external_lex_state = 7},
  [1735] = {.lex_state = 81, .external_lex_state = 6},
  [1736] = {.lex_state = 81, .external_lex_state = 7},
  [1737] = {.lex_state = 121},
  [1738] = {.lex_state = 81, .external_lex_state = 2},
  [1739] = {.lex_state = 124},
  [1740] = {.lex_state = 81, .external_lex_state = 2},
  [1741] = {.lex_state = 104},
  [1742] = {.lex_state = 124},
  [1743] = {.lex_state = 174},
  [1744] = {.lex_state = 174},
  [1745] = {.lex_state = 174},
  [1746] = {.lex_state = 81, .external_lex_state = 2},
  [1747] = {.lex_state = 174},
  [1748] = {.lex_state = 174},
  [1749] = {.lex_state = 174},
  [1750] = {.lex_state = 174},
  [1751] = {.lex_state = 124},
  [1752] = {.lex_state = 174, .external_lex_state = 2},
  [1753] = {.lex_state = 81, .external_lex_state = 2},
  [1754] = {.lex_state = 124},
  [1755] = {.lex_state = 124},
  [1756] = {.lex_state = 81, .external_lex_state = 2},
  [1757] = {.lex_state = 108},
  [1758] = {.lex_state = 81, .external_lex_state = 2},
  [1759] = {.lex_state = 81, .external_lex_state = 2},
  [1760] = {.lex_state = 81, .external_lex_state = 2},
  [1761] = {.lex_state = 81, .external_lex_state = 2},
  [1762] = {.lex_state = 81, .external_lex_state = 2},
  [1763] = {.lex_state = 81, .external_lex_state = 2},
  [1764] = {.lex_state = 104},
  [1765] = {.lex_state = 81, .external_lex_state = 2},
  [1766] = {.lex_state = 81, .external_lex_state = 2},
  [1767] = {.lex_state = 81, .external_lex_state = 2},
  [1768] = {.lex_state = 81, .external_lex_state = 2},
  [1769] = {.lex_state = 81, .external_lex_state = 2},
  [1770] = {.lex_state = 81, .external_lex_state = 2},
  [1771] = {.lex_state = 124},
  [1772] = {.lex_state = 81, .external_lex_state = 2},
  [1773] = {.lex_state = 174, .external_lex_state = 2},
  [1774] = {.lex_state = 81, .external_lex_state = 2},
  [1775] = {.lex_state = 121},
  [1776] = {.lex_state = 121},
  [1777] = {.lex_state = 81, .external_lex_state = 2},
  [1778] = {.lex_state = 174},
  [1779] = {.lex_state = 121},
  [1780] = {.lex_state = 81, .external_lex_state = 2},
  [1781] = {.lex_state = 174},
  [1782] = {.lex_state = 187},
  [1783] = {.lex_state = 187},
  [1784] = {.lex_state = 81, .external_lex_state = 2},
  [1785] = {.lex_state = 108},
  [1786] = {.lex_state = 129, .external_lex_state = 2},
  [1787] = {.lex_state = 187},
  [1788] = {.lex_state = 187},
  [1789] = {.lex_state = 81, .external_lex_state = 2},
  [1790] = {.lex_state = 104},
  [1791] = {.lex_state = 187},
  [1792] = {.lex_state = 187},
  [1793] = {.lex_state = 187},
  [1794] = {.lex_state = 187},
  [1795] = {.lex_state = 81, .external_lex_state = 2},
  [1796] = {.lex_state = 187},
  [1797] = {.lex_state = 187},
  [1798] = {.lex_state = 187},
  [1799] = {.lex_state = 187},
  [1800] = {.lex_state = 187},
  [1801] = {.lex_state = 187, .external_lex_state = 2},
  [1802] = {.lex_state = 190},
  [1803] = {.lex_state = 190},
  [1804] = {.lex_state = 81, .external_lex_state = 2},
  [1805] = {.lex_state = 190},
  [1806] = {.lex_state = 190},
  [1807] = {.lex_state = 81, .external_lex_state = 2},
  [1808] = {.lex_state = 108},
  [1809] = {.lex_state = 132, .external_lex_state = 2},
  [1810] = {.lex_state = 190},
  [1811] = {.lex_state = 190},
  [1812] = {.lex_state = 81, .external_lex_state = 2},
  [1813] = {.lex_state = 104},
  [1814] = {.lex_state = 190},
  [1815] = {.lex_state = 190},
  [1816] = {.lex_state = 190},
  [1817] = {.lex_state = 190},
  [1818] = {.lex_state = 81, .external_lex_state = 2},
  [1819] = {.lex_state = 190},
  [1820] = {.lex_state = 190},
  [1821] = {.lex_state = 190},
  [1822] = {.lex_state = 190},
  [1823] = {.lex_state = 190},
  [1824] = {.lex_state = 190, .external_lex_state = 2},
  [1825] = {.lex_state = 214, .external_lex_state = 5},
  [1826] = {.lex_state = 104},
  [1827] = {.lex_state = 187},
  [1828] = {.lex_state = 187},
  [1829] = {.lex_state = 104},
  [1830] = {.lex_state = 108, .external_lex_state = 2},
  [1831] = {.lex_state = 124},
  [1832] = {.lex_state = 229},
  [1833] = {.lex_state = 81, .external_lex_state = 2},
  [1834] = {.lex_state = 229},
  [1835] = {.lex_state = 124},
  [1836] = {.lex_state = 124},
  [1837] = {.lex_state = 81, .external_lex_state = 2},
  [1838] = {.lex_state = 174},
  [1839] = {.lex_state = 81, .external_lex_state = 2},
  [1840] = {.lex_state = 81, .external_lex_state = 2},
  [1841] = {.lex_state = 81, .external_lex_state = 2},
  [1842] = {.lex_state = 81, .external_lex_state = 7},
  [1843] = {.lex_state = 81, .external_lex_state = 7},
  [1844] = {.lex_state = 81, .external_lex_state = 2},
  [1845] = {.lex_state = 108},
  [1846] = {.lex_state = 81, .external_lex_state = 7},
  [1847] = {.lex_state = 81, .external_lex_state = 7},
  [1848] = {.lex_state = 108},
  [1849] = {.lex_state = 81, .external_lex_state = 7},
  [1850] = {.lex_state = 81, .external_lex_state = 6},
  [1851] = {.lex_state = 81, .external_lex_state = 6},
  [1852] = {.lex_state = 81, .external_lex_state = 2},
  [1853] = {.lex_state = 81, .external_lex_state = 6},
  [1854] = {.lex_state = 81, .external_lex_state = 7},
  [1855] = {.lex_state = 81, .external_lex_state = 6},
  [1856] = {.lex_state = 121},
  [1857] = {.lex_state = 81, .external_lex_state = 6},
  [1858] = {.lex_state = 81, .external_lex_state = 7},
  [1859] = {.lex_state = 81, .external_lex_state = 7},
  [1860] = {.lex_state = 81, .external_lex_state = 7},
  [1861] = {.lex_state = 81, .external_lex_state = 7},
  [1862] = {.lex_state = 108},
  [1863] = {.lex_state = 81, .external_lex_state = 7},
  [1864] = {.lex_state = 81, .external_lex_state = 6},
  [1865] = {.lex_state = 124},
  [1866] = {.lex_state = 81, .external_lex_state = 2},
  [1867] = {.lex_state = 174},
  [1868] = {.lex_state = 124},
  [1869] = {.lex_state = 124},
  [1870] = {.lex_state = 81, .external_lex_state = 2},
  [1871] = {.lex_state = 104},
  [1872] = {.lex_state = 124},
  [1873] = {.lex_state = 174},
  [1874] = {.lex_state = 174},
  [1875] = {.lex_state = 174},
  [1876] = {.lex_state = 81, .external_lex_state = 2},
  [1877] = {.lex_state = 174},
  [1878] = {.lex_state = 174},
  [1879] = {.lex_state = 174},
  [1880] = {.lex_state = 174},
  [1881] = {.lex_state = 124},
  [1882] = {.lex_state = 124},
  [1883] = {.lex_state = 174, .external_lex_state = 2},
  [1884] = {.lex_state = 121},
  [1885] = {.lex_state = 121},
  [1886] = {.lex_state = 129, .external_lex_state = 2},
  [1887] = {.lex_state = 187},
  [1888] = {.lex_state = 81, .external_lex_state = 2},
  [1889] = {.lex_state = 187},
  [1890] = {.lex_state = 187},
  [1891] = {.lex_state = 81, .external_lex_state = 2},
  [1892] = {.lex_state = 187},
  [1893] = {.lex_state = 190},
  [1894] = {.lex_state = 132, .external_lex_state = 2},
  [1895] = {.lex_state = 190},
  [1896] = {.lex_state = 81, .external_lex_state = 2},
  [1897] = {.lex_state = 190},
  [1898] = {.lex_state = 190},
  [1899] = {.lex_state = 81, .external_lex_state = 2},
  [1900] = {.lex_state = 190},
  [1901] = {.lex_state = 108, .external_lex_state = 2},
  [1902] = {.lex_state = 229},
  [1903] = {.lex_state = 81, .external_lex_state = 2},
  [1904] = {.lex_state = 124},
  [1905] = {.lex_state = 81, .external_lex_state = 7},
  [1906] = {.lex_state = 121},
  [1907] = {.lex_state = 81, .external_lex_state = 6},
  [1908] = {.lex_state = 81, .external_lex_state = 7},
  [1909] = {.lex_state = 81, .external_lex_state = 7},
  [1910] = {.lex_state = 81, .external_lex_state = 6},
  [1911] = {.lex_state = 81, .external_lex_state = 7},
  [1912] = {.lex_state = 81, .external_lex_state = 7},
  [1913] = {.lex_state = 108},
  [1914] = {.lex_state = 81, .external_lex_state = 7},
  [1915] = {.lex_state = 81, .external_lex_state = 7},
  [1916] = {.lex_state = 81, .external_lex_state = 2},
  [1917] = {.lex_state = 81, .external_lex_state = 6},
  [1918] = {.lex_state = 81, .external_lex_state = 7},
  [1919] = {.lex_state = 81, .external_lex_state = 7},
  [1920] = {.lex_state = 81, .external_lex_state = 6},
  [1921] = {.lex_state = 81, .external_lex_state = 2},
  [1922] = {.lex_state = 124},
  [1923] = {.lex_state = 124},
  [1924] = {.lex_state = 81, .external_lex_state = 2},
  [1925] = {.lex_state = 174},
  [1926] = {.lex_state = 129, .external_lex_state = 2},
  [1927] = {.lex_state = 81, .external_lex_state = 2},
  [1928] = {.lex_state = 187},
  [1929] = {.lex_state = 132, .external_lex_state = 2},
  [1930] = {.lex_state = 81, .external_lex_state = 2},
  [1931] = {.lex_state = 190},
  [1932] = {.lex_state = 81, .external_lex_state = 6},
  [1933] = {.lex_state = 81, .external_lex_state = 7},
  [1934] = {.lex_state = 81, .external_lex_state = 7},
  [1935] = {.lex_state = 81, .external_lex_state = 6},
  [1936] = {.lex_state = 81, .external_lex_state = 7},
  [1937] = {.lex_state = 121},
  [1938] = {.lex_state = 81, .external_lex_state = 7},
  [1939] = {.lex_state = 81, .external_lex_state = 7},
  [1940] = {.lex_state = 124},
  [1941] = {.lex_state = 81, .external_lex_state = 7},
  [1942] = {.lex_state = 81, .external_lex_state = 7},
  [1943] = {.lex_state = 81, .external_lex_state = 7},
  [1944] = {.lex_state = 81, .external_lex_state = 6},
  [1945] = {.lex_state = 81, .external_lex_state = 7},
};

enum {
  ts_external_token__newline,
  ts_external_token__indent,
  ts_external_token__dedent,
  ts_external_token__string_start,
  ts_external_token__string_content,
  ts_external_token__string_end,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_end] = sym__string_end,
};

static bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [2] = {
    [ts_external_token__string_start] = true,
  },
  [3] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__string_start] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
  },
  [6] = {
    [ts_external_token__indent] = true,
    [ts_external_token__string_start] = true,
  },
  [7] = {
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_from] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_print] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_assert] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_del] = ACTIONS(3),
    [anon_sym_raise] = ACTIONS(3),
    [anon_sym_pass] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(3),
    [anon_sym_continue] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_async] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(3),
    [anon_sym_except] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(3),
    [anon_sym_with] = ACTIONS(3),
    [anon_sym_def] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_global] = ACTIONS(3),
    [anon_sym_nonlocal] = ACTIONS(3),
    [anon_sym_exec] = ACTIONS(3),
    [anon_sym_class] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(3),
    [anon_sym_not] = ACTIONS(3),
    [anon_sym_and] = ACTIONS(3),
    [anon_sym_or] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_STAR_STAR] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(3),
    [anon_sym_lambda] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [sym_integer] = ACTIONS(3),
    [sym_float] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_true] = ACTIONS(3),
    [sym_false] = ACTIONS(3),
    [sym_none] = ACTIONS(3),
    [anon_sym_await] = ACTIONS(3),
    [sym_comment] = ACTIONS(1),
    [sym__semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(33),
    [sym__statement] = STATE(40),
    [sym__simple_statements] = STATE(40),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_if_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_try_statement] = STATE(40),
    [sym_with_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym_class_definition] = STATE(40),
    [sym_decorated_definition] = STATE(40),
    [sym_decorator] = STATE(41),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(40),
    [aux_sym_decorated_definition_repeat1] = STATE(41),
    [sym__string_start] = ACTIONS(5),
    [ts_builtin_sym_end] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [2] = {
    [sym_interpolation] = STATE(44),
    [aux_sym_string_repeat1] = STATE(44),
    [sym__string_content] = ACTIONS(75),
    [sym__string_end] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(81),
    [sym_comment] = ACTIONS(83),
  },
  [3] = {
    [sym__import_list] = STATE(46),
    [sym_aliased_import] = STATE(47),
    [sym_dotted_name] = STATE(48),
    [sym_identifier] = ACTIONS(85),
    [sym_comment] = ACTIONS(73),
  },
  [4] = {
    [sym_import_prefix] = STATE(50),
    [sym_relative_import] = STATE(51),
    [sym_dotted_name] = STATE(51),
    [aux_sym_import_prefix_repeat1] = STATE(52),
    [anon_sym_DOT] = ACTIONS(87),
    [sym_identifier] = ACTIONS(89),
    [sym_comment] = ACTIONS(73),
  },
  [5] = {
    [sym__expression] = STATE(65),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(65),
    [sym_boolean_operator] = STATE(65),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(65),
    [sym_lambda] = STATE(65),
    [sym_yield] = STATE(67),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(65),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(65),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [6] = {
    [sym_chevron] = STATE(79),
    [sym__expression] = STATE(80),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(80),
    [sym_boolean_operator] = STATE(80),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(80),
    [sym_lambda] = STATE(80),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(80),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(80),
    [sym__newline] = ACTIONS(119),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_GT_GT] = ACTIONS(127),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(123),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_AT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_SLASH_SLASH] = ACTIONS(123),
    [anon_sym_STAR_STAR] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(123),
    [anon_sym_LT_LT] = ACTIONS(123),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(123),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_PLUS_EQ] = ACTIONS(119),
    [anon_sym_DASH_EQ] = ACTIONS(119),
    [anon_sym_STAR_EQ] = ACTIONS(119),
    [anon_sym_SLASH_EQ] = ACTIONS(119),
    [anon_sym_AT_EQ] = ACTIONS(119),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(119),
    [anon_sym_PERCENT_EQ] = ACTIONS(119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(119),
    [anon_sym_GT_GT_EQ] = ACTIONS(119),
    [anon_sym_LT_LT_EQ] = ACTIONS(119),
    [anon_sym_AMP_EQ] = ACTIONS(119),
    [anon_sym_CARET_EQ] = ACTIONS(119),
    [anon_sym_PIPE_EQ] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(119),
  },
  [7] = {
    [sym__expression] = STATE(83),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(83),
    [sym_boolean_operator] = STATE(83),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(83),
    [sym_lambda] = STATE(83),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(83),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [8] = {
    [sym_expression_list] = STATE(84),
    [sym__expression] = STATE(85),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(85),
    [sym_boolean_operator] = STATE(85),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(85),
    [sym_lambda] = STATE(85),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(85),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(85),
    [sym__newline] = ACTIONS(147),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(147),
  },
  [9] = {
    [sym_expression_list] = STATE(86),
    [sym__expression] = STATE(85),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(85),
    [sym_boolean_operator] = STATE(85),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(85),
    [sym_lambda] = STATE(85),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(85),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(85),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [10] = {
    [sym_expression_list] = STATE(92),
    [sym__expression] = STATE(93),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(93),
    [sym_boolean_operator] = STATE(93),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(93),
    [sym_lambda] = STATE(93),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(93),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(93),
    [sym__newline] = ACTIONS(149),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(149),
  },
  [11] = {
    [sym__newline] = ACTIONS(165),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(165),
  },
  [12] = {
    [sym__newline] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(167),
  },
  [13] = {
    [sym__newline] = ACTIONS(169),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(169),
  },
  [14] = {
    [sym__expression] = STATE(100),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(100),
    [sym_boolean_operator] = STATE(100),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(100),
    [sym_lambda] = STATE(100),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(100),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(100),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [15] = {
    [anon_sym_for] = ACTIONS(183),
    [anon_sym_with] = ACTIONS(185),
    [anon_sym_def] = ACTIONS(187),
    [sym_comment] = ACTIONS(73),
  },
  [16] = {
    [sym_variables] = STATE(107),
    [sym__primary_expression] = STATE(108),
    [sym_binary_operator] = STATE(108),
    [sym_unary_operator] = STATE(108),
    [sym_attribute] = STATE(108),
    [sym_subscript] = STATE(108),
    [sym_call] = STATE(108),
    [sym_list] = STATE(108),
    [sym_list_comprehension] = STATE(108),
    [sym_dictionary] = STATE(108),
    [sym_dictionary_comprehension] = STATE(108),
    [sym_set] = STATE(108),
    [sym_set_comprehension] = STATE(108),
    [sym_parenthesized_expression] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_generator_expression] = STATE(108),
    [sym_concatenated_string] = STATE(108),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [17] = {
    [sym__expression] = STATE(110),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(110),
    [sym_boolean_operator] = STATE(110),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(110),
    [sym_lambda] = STATE(110),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(110),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [18] = {
    [anon_sym_COLON] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [19] = {
    [sym_with_item] = STATE(116),
    [sym__expression] = STATE(117),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(117),
    [sym_boolean_operator] = STATE(117),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(117),
    [sym_lambda] = STATE(117),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(117),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(117),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [20] = {
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(73),
  },
  [21] = {
    [sym_identifier] = ACTIONS(211),
    [sym_comment] = ACTIONS(73),
  },
  [22] = {
    [sym_identifier] = ACTIONS(213),
    [sym_comment] = ACTIONS(73),
  },
  [23] = {
    [sym_string] = STATE(124),
    [sym__newline] = ACTIONS(119),
    [sym__string_start] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_SLASH_SLASH] = ACTIONS(123),
    [anon_sym_STAR_STAR] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(123),
    [anon_sym_LT_LT] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(119),
    [anon_sym_PLUS_EQ] = ACTIONS(119),
    [anon_sym_DASH_EQ] = ACTIONS(119),
    [anon_sym_STAR_EQ] = ACTIONS(119),
    [anon_sym_SLASH_EQ] = ACTIONS(119),
    [anon_sym_AT_EQ] = ACTIONS(119),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(119),
    [anon_sym_PERCENT_EQ] = ACTIONS(119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(119),
    [anon_sym_GT_GT_EQ] = ACTIONS(119),
    [anon_sym_LT_LT_EQ] = ACTIONS(119),
    [anon_sym_AMP_EQ] = ACTIONS(119),
    [anon_sym_CARET_EQ] = ACTIONS(119),
    [anon_sym_PIPE_EQ] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(119),
  },
  [24] = {
    [sym_identifier] = ACTIONS(217),
    [sym_comment] = ACTIONS(73),
  },
  [25] = {
    [sym_dotted_name] = STATE(127),
    [sym_identifier] = ACTIONS(219),
    [sym_comment] = ACTIONS(73),
  },
  [26] = {
    [sym__expression] = STATE(129),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(129),
    [sym_boolean_operator] = STATE(129),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(129),
    [sym_lambda] = STATE(129),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(129),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(129),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [27] = {
    [sym__primary_expression] = STATE(130),
    [sym_binary_operator] = STATE(130),
    [sym_unary_operator] = STATE(130),
    [sym_attribute] = STATE(130),
    [sym_subscript] = STATE(130),
    [sym_call] = STATE(130),
    [sym_list] = STATE(130),
    [sym_list_comprehension] = STATE(130),
    [sym_dictionary] = STATE(130),
    [sym_dictionary_comprehension] = STATE(130),
    [sym_set] = STATE(130),
    [sym_set_comprehension] = STATE(130),
    [sym_parenthesized_expression] = STATE(130),
    [sym_tuple] = STATE(130),
    [sym_generator_expression] = STATE(130),
    [sym_concatenated_string] = STATE(130),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(225),
    [sym_float] = ACTIONS(225),
    [sym_identifier] = ACTIONS(225),
    [sym_true] = ACTIONS(225),
    [sym_false] = ACTIONS(225),
    [sym_none] = ACTIONS(225),
    [sym_comment] = ACTIONS(73),
  },
  [28] = {
    [sym_lambda_parameters] = STATE(136),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(233),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [29] = {
    [sym_expression_list] = STATE(141),
    [sym__expression] = STATE(85),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(85),
    [sym_boolean_operator] = STATE(85),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(85),
    [sym_lambda] = STATE(85),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(85),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(85),
    [sym__newline] = ACTIONS(237),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(237),
  },
  [30] = {
    [sym_list_splat] = STATE(149),
    [sym__expression] = STATE(150),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(150),
    [sym_boolean_operator] = STATE(150),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(150),
    [sym_lambda] = STATE(150),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(150),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(150),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(251),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [31] = {
    [sym_list_splat] = STATE(160),
    [sym_dictionary_splat] = STATE(161),
    [sym__expression] = STATE(162),
    [sym__primary_expression] = STATE(163),
    [sym_not_operator] = STATE(162),
    [sym_boolean_operator] = STATE(162),
    [sym_binary_operator] = STATE(163),
    [sym_unary_operator] = STATE(163),
    [sym_comparison_operator] = STATE(162),
    [sym_lambda] = STATE(162),
    [sym_attribute] = STATE(163),
    [sym_subscript] = STATE(163),
    [sym_call] = STATE(163),
    [sym_list] = STATE(163),
    [sym_list_comprehension] = STATE(163),
    [sym_dictionary] = STATE(163),
    [sym_dictionary_comprehension] = STATE(163),
    [sym_pair] = STATE(164),
    [sym_set] = STATE(163),
    [sym_set_comprehension] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_tuple] = STATE(163),
    [sym_generator_expression] = STATE(163),
    [sym_conditional_expression] = STATE(162),
    [sym_concatenated_string] = STATE(163),
    [sym_string] = STATE(165),
    [sym_await] = STATE(162),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(259),
    [anon_sym_STAR] = ACTIONS(261),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(271),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [32] = {
    [sym__expression] = STATE(166),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(166),
    [sym_boolean_operator] = STATE(166),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(166),
    [sym_lambda] = STATE(166),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(166),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(166),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [33] = {
    [ts_builtin_sym_end] = ACTIONS(277),
    [sym_comment] = ACTIONS(73),
  },
  [34] = {
    [aux_sym__simple_statements_repeat1] = STATE(169),
    [sym__newline] = ACTIONS(279),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(281),
  },
  [35] = {
    [anon_sym_COLON] = ACTIONS(283),
    [anon_sym_EQ] = ACTIONS(285),
    [anon_sym_PLUS_EQ] = ACTIONS(287),
    [anon_sym_DASH_EQ] = ACTIONS(287),
    [anon_sym_STAR_EQ] = ACTIONS(287),
    [anon_sym_SLASH_EQ] = ACTIONS(287),
    [anon_sym_AT_EQ] = ACTIONS(287),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(287),
    [anon_sym_PERCENT_EQ] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(287),
    [anon_sym_GT_GT_EQ] = ACTIONS(287),
    [anon_sym_LT_LT_EQ] = ACTIONS(287),
    [anon_sym_AMP_EQ] = ACTIONS(287),
    [anon_sym_CARET_EQ] = ACTIONS(287),
    [anon_sym_PIPE_EQ] = ACTIONS(287),
    [sym_comment] = ACTIONS(73),
  },
  [36] = {
    [aux_sym_print_statement_repeat1] = STATE(177),
    [sym__newline] = ACTIONS(289),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(295),
    [anon_sym_EQ] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(295),
    [anon_sym_DASH_EQ] = ACTIONS(295),
    [anon_sym_STAR_EQ] = ACTIONS(295),
    [anon_sym_SLASH_EQ] = ACTIONS(295),
    [anon_sym_AT_EQ] = ACTIONS(295),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(295),
    [anon_sym_PERCENT_EQ] = ACTIONS(295),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(295),
    [anon_sym_GT_GT_EQ] = ACTIONS(295),
    [anon_sym_LT_LT_EQ] = ACTIONS(295),
    [anon_sym_AMP_EQ] = ACTIONS(295),
    [anon_sym_CARET_EQ] = ACTIONS(295),
    [anon_sym_PIPE_EQ] = ACTIONS(295),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(289),
  },
  [37] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [aux_sym_comparison_operator_repeat1] = STATE(192),
    [sym__newline] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_AMP] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_LT_EQ] = ACTIONS(311),
    [anon_sym_EQ_EQ] = ACTIONS(311),
    [anon_sym_BANG_EQ] = ACTIONS(311),
    [anon_sym_GT_EQ] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_LT_GT] = ACTIONS(311),
    [anon_sym_is] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(301),
    [anon_sym_DASH_EQ] = ACTIONS(301),
    [anon_sym_STAR_EQ] = ACTIONS(301),
    [anon_sym_SLASH_EQ] = ACTIONS(301),
    [anon_sym_AT_EQ] = ACTIONS(301),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(301),
    [anon_sym_PERCENT_EQ] = ACTIONS(301),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(301),
    [anon_sym_GT_GT_EQ] = ACTIONS(301),
    [anon_sym_LT_LT_EQ] = ACTIONS(301),
    [anon_sym_AMP_EQ] = ACTIONS(301),
    [anon_sym_CARET_EQ] = ACTIONS(301),
    [anon_sym_PIPE_EQ] = ACTIONS(301),
    [anon_sym_LBRACK] = ACTIONS(331),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(301),
  },
  [38] = {
    [sym__newline] = ACTIONS(289),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(289),
  },
  [39] = {
    [sym_string] = STATE(193),
    [aux_sym_concatenated_string_repeat1] = STATE(193),
    [sym__newline] = ACTIONS(333),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(335),
    [anon_sym_SLASH_SLASH] = ACTIONS(335),
    [anon_sym_STAR_STAR] = ACTIONS(335),
    [anon_sym_PIPE] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(335),
    [anon_sym_CARET] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_AT_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(333),
  },
  [40] = {
    [sym__statement] = STATE(194),
    [sym__simple_statements] = STATE(194),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_if_statement] = STATE(194),
    [sym_for_statement] = STATE(194),
    [sym_while_statement] = STATE(194),
    [sym_try_statement] = STATE(194),
    [sym_with_statement] = STATE(194),
    [sym_function_definition] = STATE(194),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym_class_definition] = STATE(194),
    [sym_decorated_definition] = STATE(194),
    [sym_decorator] = STATE(41),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(194),
    [aux_sym_decorated_definition_repeat1] = STATE(41),
    [sym__string_start] = ACTIONS(5),
    [ts_builtin_sym_end] = ACTIONS(337),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [41] = {
    [sym_function_definition] = STATE(196),
    [sym_class_definition] = STATE(196),
    [sym_decorator] = STATE(197),
    [aux_sym_decorated_definition_repeat1] = STATE(197),
    [anon_sym_async] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_class] = ACTIONS(343),
    [anon_sym_AT] = ACTIONS(53),
    [sym_comment] = ACTIONS(73),
  },
  [42] = {
    [sym__newline] = ACTIONS(345),
    [sym__string_start] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_STAR] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_COLON] = ACTIONS(345),
    [anon_sym_in] = ACTIONS(345),
    [anon_sym_EQ] = ACTIONS(347),
    [anon_sym_AT] = ACTIONS(347),
    [anon_sym_not] = ACTIONS(345),
    [anon_sym_and] = ACTIONS(345),
    [anon_sym_or] = ACTIONS(345),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_SLASH] = ACTIONS(347),
    [anon_sym_PERCENT] = ACTIONS(347),
    [anon_sym_SLASH_SLASH] = ACTIONS(347),
    [anon_sym_STAR_STAR] = ACTIONS(347),
    [anon_sym_PIPE] = ACTIONS(347),
    [anon_sym_AMP] = ACTIONS(347),
    [anon_sym_CARET] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(347),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_LT_EQ] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_BANG_EQ] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_LT_GT] = ACTIONS(345),
    [anon_sym_is] = ACTIONS(345),
    [anon_sym_PLUS_EQ] = ACTIONS(345),
    [anon_sym_DASH_EQ] = ACTIONS(345),
    [anon_sym_STAR_EQ] = ACTIONS(345),
    [anon_sym_SLASH_EQ] = ACTIONS(345),
    [anon_sym_AT_EQ] = ACTIONS(345),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(345),
    [anon_sym_PERCENT_EQ] = ACTIONS(345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(345),
    [anon_sym_GT_GT_EQ] = ACTIONS(345),
    [anon_sym_LT_LT_EQ] = ACTIONS(345),
    [anon_sym_AMP_EQ] = ACTIONS(345),
    [anon_sym_CARET_EQ] = ACTIONS(345),
    [anon_sym_PIPE_EQ] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(345),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(345),
  },
  [43] = {
    [sym__expression] = STATE(202),
    [sym__primary_expression] = STATE(203),
    [sym_not_operator] = STATE(202),
    [sym_boolean_operator] = STATE(202),
    [sym_binary_operator] = STATE(203),
    [sym_unary_operator] = STATE(203),
    [sym_comparison_operator] = STATE(202),
    [sym_lambda] = STATE(202),
    [sym_attribute] = STATE(203),
    [sym_subscript] = STATE(203),
    [sym_call] = STATE(203),
    [sym_list] = STATE(203),
    [sym_list_comprehension] = STATE(203),
    [sym_dictionary] = STATE(203),
    [sym_dictionary_comprehension] = STATE(203),
    [sym_set] = STATE(203),
    [sym_set_comprehension] = STATE(203),
    [sym_parenthesized_expression] = STATE(203),
    [sym_tuple] = STATE(203),
    [sym_generator_expression] = STATE(203),
    [sym_conditional_expression] = STATE(202),
    [sym_concatenated_string] = STATE(203),
    [sym_string] = STATE(204),
    [sym_await] = STATE(202),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [44] = {
    [sym_interpolation] = STATE(206),
    [aux_sym_string_repeat1] = STATE(206),
    [sym__string_content] = ACTIONS(361),
    [sym__string_end] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(365),
    [sym_comment] = ACTIONS(83),
  },
  [45] = {
    [aux_sym_dotted_name_repeat1] = STATE(208),
    [sym__newline] = ACTIONS(367),
    [anon_sym_DOT] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(367),
    [anon_sym_as] = ACTIONS(367),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(367),
  },
  [46] = {
    [sym__newline] = ACTIONS(371),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(371),
  },
  [47] = {
    [aux_sym__import_list_repeat1] = STATE(210),
    [sym__newline] = ACTIONS(373),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(373),
  },
  [48] = {
    [aux_sym__import_list_repeat1] = STATE(210),
    [sym__newline] = ACTIONS(373),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_as] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(373),
  },
  [49] = {
    [aux_sym_dotted_name_repeat1] = STATE(213),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_DOT] = ACTIONS(379),
    [sym_comment] = ACTIONS(73),
  },
  [50] = {
    [sym_dotted_name] = STATE(214),
    [anon_sym_import] = ACTIONS(381),
    [sym_identifier] = ACTIONS(383),
    [sym_comment] = ACTIONS(73),
  },
  [51] = {
    [anon_sym_import] = ACTIONS(385),
    [sym_comment] = ACTIONS(73),
  },
  [52] = {
    [aux_sym_import_prefix_repeat1] = STATE(216),
    [anon_sym_import] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(389),
    [sym_identifier] = ACTIONS(387),
    [sym_comment] = ACTIONS(73),
  },
  [53] = {
    [sym_interpolation] = STATE(218),
    [aux_sym_string_repeat1] = STATE(218),
    [sym__string_content] = ACTIONS(391),
    [sym__string_end] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(395),
    [sym_comment] = ACTIONS(83),
  },
  [54] = {
    [sym__expression] = STATE(221),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(221),
    [sym_boolean_operator] = STATE(221),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(221),
    [sym_lambda] = STATE(221),
    [sym_yield] = STATE(222),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(221),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(221),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(399),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [55] = {
    [sym__newline] = ACTIONS(401),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(401),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(401),
    [anon_sym_in] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(403),
    [anon_sym_AT] = ACTIONS(403),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(401),
    [anon_sym_or] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(403),
    [anon_sym_SLASH_SLASH] = ACTIONS(403),
    [anon_sym_STAR_STAR] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_AMP] = ACTIONS(403),
    [anon_sym_CARET] = ACTIONS(403),
    [anon_sym_LT_LT] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_BANG_EQ] = ACTIONS(401),
    [anon_sym_GT_EQ] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_LT_GT] = ACTIONS(401),
    [anon_sym_is] = ACTIONS(401),
    [anon_sym_PLUS_EQ] = ACTIONS(401),
    [anon_sym_DASH_EQ] = ACTIONS(401),
    [anon_sym_STAR_EQ] = ACTIONS(401),
    [anon_sym_SLASH_EQ] = ACTIONS(401),
    [anon_sym_AT_EQ] = ACTIONS(401),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(401),
    [anon_sym_PERCENT_EQ] = ACTIONS(401),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(401),
    [anon_sym_GT_GT_EQ] = ACTIONS(401),
    [anon_sym_LT_LT_EQ] = ACTIONS(401),
    [anon_sym_AMP_EQ] = ACTIONS(401),
    [anon_sym_CARET_EQ] = ACTIONS(401),
    [anon_sym_PIPE_EQ] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(401),
  },
  [56] = {
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [57] = {
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_as] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_else] = ACTIONS(119),
    [anon_sym_async] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(119),
    [anon_sym_SLASH_SLASH] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(119),
    [anon_sym_LT_LT] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_RBRACK] = ACTIONS(119),
    [anon_sym_RBRACE] = ACTIONS(119),
    [sym_type_conversion] = ACTIONS(119),
    [sym_comment] = ACTIONS(73),
  },
  [58] = {
    [sym__expression] = STATE(224),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(224),
    [sym_boolean_operator] = STATE(224),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(224),
    [sym_lambda] = STATE(224),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(224),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(224),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [59] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [60] = {
    [sym_lambda_parameters] = STATE(227),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [61] = {
    [sym_expression_list] = STATE(233),
    [sym__expression] = STATE(234),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(234),
    [sym_boolean_operator] = STATE(234),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(234),
    [sym_lambda] = STATE(234),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(234),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(234),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_from] = ACTIONS(413),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [62] = {
    [sym_list_splat] = STATE(239),
    [sym__expression] = STATE(240),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(240),
    [sym_boolean_operator] = STATE(240),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(240),
    [sym_lambda] = STATE(240),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(240),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(240),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(429),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [63] = {
    [sym_list_splat] = STATE(243),
    [sym_dictionary_splat] = STATE(244),
    [sym__expression] = STATE(245),
    [sym__primary_expression] = STATE(163),
    [sym_not_operator] = STATE(245),
    [sym_boolean_operator] = STATE(245),
    [sym_binary_operator] = STATE(163),
    [sym_unary_operator] = STATE(163),
    [sym_comparison_operator] = STATE(245),
    [sym_lambda] = STATE(245),
    [sym_attribute] = STATE(163),
    [sym_subscript] = STATE(163),
    [sym_call] = STATE(163),
    [sym_list] = STATE(163),
    [sym_list_comprehension] = STATE(163),
    [sym_dictionary] = STATE(163),
    [sym_dictionary_comprehension] = STATE(163),
    [sym_pair] = STATE(246),
    [sym_set] = STATE(163),
    [sym_set_comprehension] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_tuple] = STATE(163),
    [sym_generator_expression] = STATE(163),
    [sym_conditional_expression] = STATE(245),
    [sym_concatenated_string] = STATE(163),
    [sym_string] = STATE(165),
    [sym_await] = STATE(245),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(431),
    [anon_sym_STAR] = ACTIONS(261),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(433),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [64] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [65] = {
    [sym__comprehension_body] = STATE(255),
    [sym_for_in_clause] = STATE(256),
    [aux_sym_tuple_repeat1] = STATE(257),
    [anon_sym_RPAREN] = ACTIONS(435),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(441),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [66] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(272),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(457),
    [anon_sym_AT] = ACTIONS(459),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(457),
    [anon_sym_EQ_EQ] = ACTIONS(457),
    [anon_sym_BANG_EQ] = ACTIONS(457),
    [anon_sym_GT_EQ] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_LT_GT] = ACTIONS(457),
    [anon_sym_is] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [67] = {
    [aux_sym_tuple_repeat1] = STATE(257),
    [anon_sym_RPAREN] = ACTIONS(435),
    [anon_sym_COMMA] = ACTIONS(437),
    [sym_comment] = ACTIONS(73),
  },
  [68] = {
    [sym_string] = STATE(273),
    [aux_sym_concatenated_string_repeat1] = STATE(273),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [69] = {
    [sym_interpolation] = STATE(275),
    [aux_sym_string_repeat1] = STATE(275),
    [sym__string_content] = ACTIONS(479),
    [sym__string_end] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(483),
    [sym_comment] = ACTIONS(83),
  },
  [70] = {
    [sym__expression] = STATE(278),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(278),
    [sym_boolean_operator] = STATE(278),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(278),
    [sym_lambda] = STATE(278),
    [sym_yield] = STATE(279),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(278),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(278),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(487),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [71] = {
    [sym__newline] = ACTIONS(119),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(119),
    [anon_sym_SLASH_SLASH] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(119),
    [anon_sym_LT_LT] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(119),
  },
  [72] = {
    [sym__expression] = STATE(280),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(280),
    [sym_boolean_operator] = STATE(280),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(280),
    [sym_lambda] = STATE(280),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(280),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(280),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [73] = {
    [sym__expression] = STATE(281),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(281),
    [sym_boolean_operator] = STATE(281),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(281),
    [sym_lambda] = STATE(281),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(281),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(281),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [74] = {
    [sym__primary_expression] = STATE(282),
    [sym_binary_operator] = STATE(282),
    [sym_unary_operator] = STATE(282),
    [sym_attribute] = STATE(282),
    [sym_subscript] = STATE(282),
    [sym_call] = STATE(282),
    [sym_list] = STATE(282),
    [sym_list_comprehension] = STATE(282),
    [sym_dictionary] = STATE(282),
    [sym_dictionary_comprehension] = STATE(282),
    [sym_set] = STATE(282),
    [sym_set_comprehension] = STATE(282),
    [sym_parenthesized_expression] = STATE(282),
    [sym_tuple] = STATE(282),
    [sym_generator_expression] = STATE(282),
    [sym_concatenated_string] = STATE(282),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(489),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(491),
    [sym_float] = ACTIONS(491),
    [sym_identifier] = ACTIONS(491),
    [sym_true] = ACTIONS(491),
    [sym_false] = ACTIONS(491),
    [sym_none] = ACTIONS(491),
    [sym_comment] = ACTIONS(73),
  },
  [75] = {
    [sym_lambda_parameters] = STATE(284),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(493),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [76] = {
    [sym_list_splat] = STATE(287),
    [sym__expression] = STATE(288),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(288),
    [sym_boolean_operator] = STATE(288),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(288),
    [sym_lambda] = STATE(288),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(288),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(288),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(497),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [77] = {
    [sym_list_splat] = STATE(291),
    [sym_dictionary_splat] = STATE(292),
    [sym__expression] = STATE(293),
    [sym__primary_expression] = STATE(163),
    [sym_not_operator] = STATE(293),
    [sym_boolean_operator] = STATE(293),
    [sym_binary_operator] = STATE(163),
    [sym_unary_operator] = STATE(163),
    [sym_comparison_operator] = STATE(293),
    [sym_lambda] = STATE(293),
    [sym_attribute] = STATE(163),
    [sym_subscript] = STATE(163),
    [sym_call] = STATE(163),
    [sym_list] = STATE(163),
    [sym_list_comprehension] = STATE(163),
    [sym_dictionary] = STATE(163),
    [sym_dictionary_comprehension] = STATE(163),
    [sym_pair] = STATE(294),
    [sym_set] = STATE(163),
    [sym_set_comprehension] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_tuple] = STATE(163),
    [sym_generator_expression] = STATE(163),
    [sym_conditional_expression] = STATE(293),
    [sym_concatenated_string] = STATE(163),
    [sym_string] = STATE(165),
    [sym_await] = STATE(293),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_STAR] = ACTIONS(261),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(501),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [78] = {
    [sym__expression] = STATE(166),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(166),
    [sym_boolean_operator] = STATE(166),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(166),
    [sym_lambda] = STATE(166),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(166),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(166),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [79] = {
    [aux_sym_print_statement_repeat1] = STATE(296),
    [sym__newline] = ACTIONS(503),
    [anon_sym_COMMA] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(503),
  },
  [80] = {
    [aux_sym_print_statement_repeat1] = STATE(296),
    [sym__newline] = ACTIONS(503),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(511),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(503),
  },
  [81] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [aux_sym_comparison_operator_repeat1] = STATE(314),
    [sym__newline] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_AT] = ACTIONS(523),
    [anon_sym_not] = ACTIONS(525),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(523),
    [anon_sym_SLASH_SLASH] = ACTIONS(523),
    [anon_sym_STAR_STAR] = ACTIONS(529),
    [anon_sym_PIPE] = ACTIONS(531),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_CARET] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(537),
    [anon_sym_LT_GT] = ACTIONS(521),
    [anon_sym_is] = ACTIONS(539),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(301),
  },
  [82] = {
    [sym_string] = STATE(315),
    [aux_sym_concatenated_string_repeat1] = STATE(315),
    [sym__newline] = ACTIONS(333),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(333),
  },
  [83] = {
    [aux_sym_print_statement_repeat1] = STATE(317),
    [sym__newline] = ACTIONS(543),
    [anon_sym_COMMA] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(511),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(543),
  },
  [84] = {
    [sym__newline] = ACTIONS(547),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(547),
  },
  [85] = {
    [aux_sym_print_statement_repeat1] = STATE(319),
    [sym__newline] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(511),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(295),
  },
  [86] = {
    [sym__newline] = ACTIONS(551),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(551),
  },
  [87] = {
    [sym__expression] = STATE(324),
    [sym__primary_expression] = STATE(325),
    [sym_not_operator] = STATE(324),
    [sym_boolean_operator] = STATE(324),
    [sym_binary_operator] = STATE(325),
    [sym_unary_operator] = STATE(325),
    [sym_comparison_operator] = STATE(324),
    [sym_lambda] = STATE(324),
    [sym_attribute] = STATE(325),
    [sym_subscript] = STATE(325),
    [sym_call] = STATE(325),
    [sym_list] = STATE(325),
    [sym_list_comprehension] = STATE(325),
    [sym_dictionary] = STATE(325),
    [sym_dictionary_comprehension] = STATE(325),
    [sym_set] = STATE(325),
    [sym_set_comprehension] = STATE(325),
    [sym_parenthesized_expression] = STATE(325),
    [sym_tuple] = STATE(325),
    [sym_generator_expression] = STATE(325),
    [sym_conditional_expression] = STATE(324),
    [sym_concatenated_string] = STATE(325),
    [sym_string] = STATE(326),
    [sym_await] = STATE(324),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_lambda] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(561),
    [sym_float] = ACTIONS(561),
    [sym_identifier] = ACTIONS(561),
    [sym_true] = ACTIONS(561),
    [sym_false] = ACTIONS(561),
    [sym_none] = ACTIONS(561),
    [anon_sym_await] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
  },
  [88] = {
    [sym__expression] = STATE(327),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(327),
    [sym_boolean_operator] = STATE(327),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(327),
    [sym_lambda] = STATE(327),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(327),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(327),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [89] = {
    [sym__primary_expression] = STATE(282),
    [sym_binary_operator] = STATE(282),
    [sym_unary_operator] = STATE(282),
    [sym_attribute] = STATE(282),
    [sym_subscript] = STATE(282),
    [sym_call] = STATE(282),
    [sym_list] = STATE(282),
    [sym_list_comprehension] = STATE(282),
    [sym_dictionary] = STATE(282),
    [sym_dictionary_comprehension] = STATE(282),
    [sym_set] = STATE(282),
    [sym_set_comprehension] = STATE(282),
    [sym_parenthesized_expression] = STATE(282),
    [sym_tuple] = STATE(282),
    [sym_generator_expression] = STATE(282),
    [sym_concatenated_string] = STATE(282),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(489),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(491),
    [sym_float] = ACTIONS(491),
    [sym_identifier] = ACTIONS(491),
    [sym_true] = ACTIONS(491),
    [sym_false] = ACTIONS(491),
    [sym_none] = ACTIONS(491),
    [sym_comment] = ACTIONS(73),
  },
  [90] = {
    [sym_lambda_parameters] = STATE(329),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(565),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [91] = {
    [sym__expression] = STATE(166),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(166),
    [sym_boolean_operator] = STATE(166),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(166),
    [sym_lambda] = STATE(166),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(166),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(166),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [92] = {
    [sym__newline] = ACTIONS(567),
    [anon_sym_from] = ACTIONS(569),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(567),
  },
  [93] = {
    [aux_sym_print_statement_repeat1] = STATE(335),
    [sym__newline] = ACTIONS(295),
    [anon_sym_from] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(577),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(295),
  },
  [94] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [aux_sym_comparison_operator_repeat1] = STATE(346),
    [sym__newline] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_from] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(587),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(579),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_SLASH_SLASH] = ACTIONS(585),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_CARET] = ACTIONS(597),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(599),
    [anon_sym_LT_EQ] = ACTIONS(583),
    [anon_sym_EQ_EQ] = ACTIONS(583),
    [anon_sym_BANG_EQ] = ACTIONS(583),
    [anon_sym_GT_EQ] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(599),
    [anon_sym_LT_GT] = ACTIONS(583),
    [anon_sym_is] = ACTIONS(601),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(301),
  },
  [95] = {
    [sym_string] = STATE(347),
    [aux_sym_concatenated_string_repeat1] = STATE(347),
    [sym__newline] = ACTIONS(333),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_from] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(333),
  },
  [96] = {
    [sym__expression] = STATE(348),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(348),
    [sym_boolean_operator] = STATE(348),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(348),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(348),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [97] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [98] = {
    [sym_lambda_parameters] = STATE(350),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [99] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [100] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(607),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [101] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(365),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(615),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(617),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_not] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_SLASH_SLASH] = ACTIONS(619),
    [anon_sym_STAR_STAR] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_CARET] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_LT_EQ] = ACTIONS(617),
    [anon_sym_EQ_EQ] = ACTIONS(617),
    [anon_sym_BANG_EQ] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(633),
    [anon_sym_LT_GT] = ACTIONS(617),
    [anon_sym_is] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [102] = {
    [sym_string] = STATE(366),
    [aux_sym_concatenated_string_repeat1] = STATE(366),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [103] = {
    [sym_variables] = STATE(367),
    [sym__primary_expression] = STATE(108),
    [sym_binary_operator] = STATE(108),
    [sym_unary_operator] = STATE(108),
    [sym_attribute] = STATE(108),
    [sym_subscript] = STATE(108),
    [sym_call] = STATE(108),
    [sym_list] = STATE(108),
    [sym_list_comprehension] = STATE(108),
    [sym_dictionary] = STATE(108),
    [sym_dictionary_comprehension] = STATE(108),
    [sym_set] = STATE(108),
    [sym_set_comprehension] = STATE(108),
    [sym_parenthesized_expression] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_generator_expression] = STATE(108),
    [sym_concatenated_string] = STATE(108),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [104] = {
    [sym_with_item] = STATE(368),
    [sym__expression] = STATE(117),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(117),
    [sym_boolean_operator] = STATE(117),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(117),
    [sym_lambda] = STATE(117),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(117),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(117),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [105] = {
    [sym_identifier] = ACTIONS(637),
    [sym_comment] = ACTIONS(73),
  },
  [106] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [107] = {
    [anon_sym_in] = ACTIONS(639),
    [sym_comment] = ACTIONS(73),
  },
  [108] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_variables_repeat1] = STATE(379),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(649),
    [anon_sym_SLASH_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [109] = {
    [sym_string] = STATE(380),
    [aux_sym_concatenated_string_repeat1] = STATE(380),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [110] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(661),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [111] = {
    [sym__simple_statements] = STATE(384),
    [sym_import_statement] = STATE(383),
    [sym_import_from_statement] = STATE(383),
    [sym_print_statement] = STATE(383),
    [sym_assert_statement] = STATE(383),
    [sym_expression_statement] = STATE(383),
    [sym_return_statement] = STATE(383),
    [sym_delete_statement] = STATE(383),
    [sym_raise_statement] = STATE(383),
    [sym_pass_statement] = STATE(383),
    [sym_break_statement] = STATE(383),
    [sym_continue_statement] = STATE(383),
    [sym_global_statement] = STATE(383),
    [sym_nonlocal_statement] = STATE(383),
    [sym_exec_statement] = STATE(383),
    [sym__suite] = STATE(384),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(663),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [112] = {
    [sym__expression] = STATE(385),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(385),
    [sym_boolean_operator] = STATE(385),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(385),
    [sym_lambda] = STATE(385),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(385),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(385),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [113] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [114] = {
    [sym_lambda_parameters] = STATE(387),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(665),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [115] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [116] = {
    [aux_sym_with_statement_repeat1] = STATE(390),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(669),
    [sym_comment] = ACTIONS(73),
  },
  [117] = {
    [anon_sym_COMMA] = ACTIONS(671),
    [anon_sym_as] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_COLON] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(679),
    [sym_comment] = ACTIONS(73),
  },
  [118] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(405),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(685),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(689),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_SLASH_SLASH] = ACTIONS(687),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(685),
    [anon_sym_EQ_EQ] = ACTIONS(685),
    [anon_sym_BANG_EQ] = ACTIONS(685),
    [anon_sym_GT_EQ] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_LT_GT] = ACTIONS(685),
    [anon_sym_is] = ACTIONS(703),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [119] = {
    [sym_string] = STATE(406),
    [aux_sym_concatenated_string_repeat1] = STATE(406),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_as] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [120] = {
    [sym_parameters] = STATE(408),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym_comment] = ACTIONS(73),
  },
  [121] = {
    [aux_sym_global_statement_repeat1] = STATE(410),
    [sym__newline] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(709),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(707),
  },
  [122] = {
    [aux_sym_global_statement_repeat1] = STATE(411),
    [sym__newline] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(709),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(711),
  },
  [123] = {
    [sym_interpolation] = STATE(413),
    [aux_sym_string_repeat1] = STATE(413),
    [sym__string_content] = ACTIONS(713),
    [sym__string_end] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(717),
    [sym_comment] = ACTIONS(83),
  },
  [124] = {
    [sym__newline] = ACTIONS(719),
    [anon_sym_in] = ACTIONS(721),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(719),
  },
  [125] = {
    [sym_argument_list] = STATE(417),
    [anon_sym_LPAREN] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(725),
    [sym_comment] = ACTIONS(73),
  },
  [126] = {
    [aux_sym_dotted_name_repeat1] = STATE(418),
    [sym__newline] = ACTIONS(367),
    [anon_sym_DOT] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [sym_comment] = ACTIONS(73),
  },
  [127] = {
    [sym_argument_list] = STATE(421),
    [sym__newline] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(73),
  },
  [128] = {
    [sym__newline] = ACTIONS(119),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_SLASH_SLASH] = ACTIONS(123),
    [anon_sym_STAR_STAR] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(123),
    [anon_sym_LT_LT] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(119),
    [anon_sym_PLUS_EQ] = ACTIONS(119),
    [anon_sym_DASH_EQ] = ACTIONS(119),
    [anon_sym_STAR_EQ] = ACTIONS(119),
    [anon_sym_SLASH_EQ] = ACTIONS(119),
    [anon_sym_AT_EQ] = ACTIONS(119),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(119),
    [anon_sym_PERCENT_EQ] = ACTIONS(119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(119),
    [anon_sym_GT_GT_EQ] = ACTIONS(119),
    [anon_sym_LT_LT_EQ] = ACTIONS(119),
    [anon_sym_AMP_EQ] = ACTIONS(119),
    [anon_sym_CARET_EQ] = ACTIONS(119),
    [anon_sym_PIPE_EQ] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(119),
  },
  [129] = {
    [sym__newline] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(731),
    [anon_sym_DASH_EQ] = ACTIONS(731),
    [anon_sym_STAR_EQ] = ACTIONS(731),
    [anon_sym_SLASH_EQ] = ACTIONS(731),
    [anon_sym_AT_EQ] = ACTIONS(731),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(731),
    [anon_sym_PERCENT_EQ] = ACTIONS(731),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(731),
    [anon_sym_GT_GT_EQ] = ACTIONS(731),
    [anon_sym_LT_LT_EQ] = ACTIONS(731),
    [anon_sym_AMP_EQ] = ACTIONS(731),
    [anon_sym_CARET_EQ] = ACTIONS(731),
    [anon_sym_PIPE_EQ] = ACTIONS(731),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(731),
  },
  [130] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [sym__newline] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_STAR] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_AT] = ACTIONS(735),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_SLASH_SLASH] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_LT_GT] = ACTIONS(733),
    [anon_sym_is] = ACTIONS(733),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_AT_EQ] = ACTIONS(733),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(733),
  },
  [131] = {
    [sym__expression] = STATE(422),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(422),
    [sym_boolean_operator] = STATE(422),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(422),
    [sym_lambda] = STATE(422),
    [sym_yield] = STATE(423),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(422),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(422),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(399),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [132] = {
    [sym__expression] = STATE(429),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(429),
    [sym_boolean_operator] = STATE(429),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(429),
    [sym_lambda] = STATE(429),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(429),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(429),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(739),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(737),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [133] = {
    [aux_sym__parameters_repeat1] = STATE(435),
    [anon_sym_COMMA] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(755),
    [anon_sym_EQ] = ACTIONS(757),
    [sym_comment] = ACTIONS(73),
  },
  [134] = {
    [sym__expression] = STATE(436),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(436),
    [sym_boolean_operator] = STATE(436),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(436),
    [sym_lambda] = STATE(436),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(436),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(436),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [135] = {
    [aux_sym__parameters_repeat1] = STATE(440),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_COLON] = ACTIONS(761),
    [anon_sym_EQ] = ACTIONS(763),
    [sym_comment] = ACTIONS(73),
  },
  [136] = {
    [anon_sym_COLON] = ACTIONS(765),
    [sym_comment] = ACTIONS(73),
  },
  [137] = {
    [anon_sym_COLON] = ACTIONS(767),
    [sym_comment] = ACTIONS(73),
  },
  [138] = {
    [aux_sym__parameters_repeat1] = STATE(440),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_COLON] = ACTIONS(761),
    [sym_comment] = ACTIONS(73),
  },
  [139] = {
    [aux_sym__parameters_repeat1] = STATE(440),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_COLON] = ACTIONS(761),
    [sym_comment] = ACTIONS(73),
  },
  [140] = {
    [sym__expression] = STATE(443),
    [sym__primary_expression] = STATE(325),
    [sym_not_operator] = STATE(443),
    [sym_boolean_operator] = STATE(443),
    [sym_binary_operator] = STATE(325),
    [sym_unary_operator] = STATE(325),
    [sym_comparison_operator] = STATE(443),
    [sym_lambda] = STATE(443),
    [sym_attribute] = STATE(325),
    [sym_subscript] = STATE(325),
    [sym_call] = STATE(325),
    [sym_list] = STATE(325),
    [sym_list_comprehension] = STATE(325),
    [sym_dictionary] = STATE(325),
    [sym_dictionary_comprehension] = STATE(325),
    [sym_set] = STATE(325),
    [sym_set_comprehension] = STATE(325),
    [sym_parenthesized_expression] = STATE(325),
    [sym_tuple] = STATE(325),
    [sym_generator_expression] = STATE(325),
    [sym_conditional_expression] = STATE(443),
    [sym_concatenated_string] = STATE(325),
    [sym_string] = STATE(326),
    [sym_await] = STATE(443),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_lambda] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(561),
    [sym_float] = ACTIONS(561),
    [sym_identifier] = ACTIONS(561),
    [sym_true] = ACTIONS(561),
    [sym_false] = ACTIONS(561),
    [sym_none] = ACTIONS(561),
    [anon_sym_await] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
  },
  [141] = {
    [sym__newline] = ACTIONS(769),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(769),
  },
  [142] = {
    [anon_sym_RBRACK] = ACTIONS(771),
    [sym_comment] = ACTIONS(73),
  },
  [143] = {
    [sym__expression] = STATE(449),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(449),
    [sym_boolean_operator] = STATE(449),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(449),
    [sym_lambda] = STATE(449),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(449),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(449),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(737),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [144] = {
    [sym__expression] = STATE(452),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(452),
    [sym_boolean_operator] = STATE(452),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(452),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(452),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [145] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [146] = {
    [sym_lambda_parameters] = STATE(454),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(785),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [147] = {
    [sym__newline] = ACTIONS(787),
    [anon_sym_DOT] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(787),
    [anon_sym_COMMA] = ACTIONS(787),
    [anon_sym_STAR] = ACTIONS(789),
    [anon_sym_GT_GT] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_COLON] = ACTIONS(787),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(789),
    [anon_sym_not] = ACTIONS(787),
    [anon_sym_and] = ACTIONS(787),
    [anon_sym_or] = ACTIONS(787),
    [anon_sym_PLUS] = ACTIONS(789),
    [anon_sym_DASH] = ACTIONS(789),
    [anon_sym_SLASH] = ACTIONS(789),
    [anon_sym_PERCENT] = ACTIONS(789),
    [anon_sym_SLASH_SLASH] = ACTIONS(789),
    [anon_sym_STAR_STAR] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(789),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_CARET] = ACTIONS(789),
    [anon_sym_LT_LT] = ACTIONS(789),
    [anon_sym_LT] = ACTIONS(789),
    [anon_sym_LT_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_GT_EQ] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(789),
    [anon_sym_LT_GT] = ACTIONS(787),
    [anon_sym_is] = ACTIONS(787),
    [anon_sym_PLUS_EQ] = ACTIONS(787),
    [anon_sym_DASH_EQ] = ACTIONS(787),
    [anon_sym_STAR_EQ] = ACTIONS(787),
    [anon_sym_SLASH_EQ] = ACTIONS(787),
    [anon_sym_AT_EQ] = ACTIONS(787),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(787),
    [anon_sym_PERCENT_EQ] = ACTIONS(787),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(787),
    [anon_sym_GT_GT_EQ] = ACTIONS(787),
    [anon_sym_LT_LT_EQ] = ACTIONS(787),
    [anon_sym_AMP_EQ] = ACTIONS(787),
    [anon_sym_CARET_EQ] = ACTIONS(787),
    [anon_sym_PIPE_EQ] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(787),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(787),
  },
  [148] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [149] = {
    [aux_sym_list_repeat1] = STATE(456),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_RBRACK] = ACTIONS(771),
    [sym_comment] = ACTIONS(73),
  },
  [150] = {
    [sym__comprehension_body] = STATE(462),
    [sym_for_in_clause] = STATE(463),
    [aux_sym_list_repeat1] = STATE(456),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(801),
    [anon_sym_RBRACK] = ACTIONS(771),
    [sym_comment] = ACTIONS(73),
  },
  [151] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(474),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(807),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_SLASH_SLASH] = ACTIONS(809),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_LT_EQ] = ACTIONS(807),
    [anon_sym_EQ_EQ] = ACTIONS(807),
    [anon_sym_BANG_EQ] = ACTIONS(807),
    [anon_sym_GT_EQ] = ACTIONS(807),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_LT_GT] = ACTIONS(807),
    [anon_sym_is] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [152] = {
    [sym_string] = STATE(475),
    [aux_sym_concatenated_string_repeat1] = STATE(475),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [153] = {
    [anon_sym_RBRACE] = ACTIONS(827),
    [sym_comment] = ACTIONS(73),
  },
  [154] = {
    [sym__expression] = STATE(482),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(482),
    [sym_boolean_operator] = STATE(482),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(482),
    [sym_lambda] = STATE(482),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(482),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(482),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(829),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(737),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [155] = {
    [sym__expression] = STATE(485),
    [sym__primary_expression] = STATE(163),
    [sym_not_operator] = STATE(485),
    [sym_boolean_operator] = STATE(485),
    [sym_binary_operator] = STATE(163),
    [sym_unary_operator] = STATE(163),
    [sym_comparison_operator] = STATE(485),
    [sym_lambda] = STATE(485),
    [sym_attribute] = STATE(163),
    [sym_subscript] = STATE(163),
    [sym_call] = STATE(163),
    [sym_list] = STATE(163),
    [sym_list_comprehension] = STATE(163),
    [sym_dictionary] = STATE(163),
    [sym_dictionary_comprehension] = STATE(163),
    [sym_set] = STATE(163),
    [sym_set_comprehension] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_tuple] = STATE(163),
    [sym_generator_expression] = STATE(163),
    [sym_conditional_expression] = STATE(485),
    [sym_concatenated_string] = STATE(163),
    [sym_string] = STATE(165),
    [sym_await] = STATE(485),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [156] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [157] = {
    [sym_lambda_parameters] = STATE(487),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [158] = {
    [sym__newline] = ACTIONS(845),
    [anon_sym_DOT] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_COLON] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(845),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(847),
    [anon_sym_not] = ACTIONS(845),
    [anon_sym_and] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(847),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_SLASH] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(847),
    [anon_sym_SLASH_SLASH] = ACTIONS(847),
    [anon_sym_STAR_STAR] = ACTIONS(847),
    [anon_sym_PIPE] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
    [anon_sym_CARET] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(845),
    [anon_sym_EQ_EQ] = ACTIONS(845),
    [anon_sym_BANG_EQ] = ACTIONS(845),
    [anon_sym_GT_EQ] = ACTIONS(845),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_LT_GT] = ACTIONS(845),
    [anon_sym_is] = ACTIONS(845),
    [anon_sym_PLUS_EQ] = ACTIONS(845),
    [anon_sym_DASH_EQ] = ACTIONS(845),
    [anon_sym_STAR_EQ] = ACTIONS(845),
    [anon_sym_SLASH_EQ] = ACTIONS(845),
    [anon_sym_AT_EQ] = ACTIONS(845),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(845),
    [anon_sym_PERCENT_EQ] = ACTIONS(845),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(845),
    [anon_sym_GT_GT_EQ] = ACTIONS(845),
    [anon_sym_LT_LT_EQ] = ACTIONS(845),
    [anon_sym_AMP_EQ] = ACTIONS(845),
    [anon_sym_CARET_EQ] = ACTIONS(845),
    [anon_sym_PIPE_EQ] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(845),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(845),
  },
  [159] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(163),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(163),
    [sym_unary_operator] = STATE(163),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(163),
    [sym_subscript] = STATE(163),
    [sym_call] = STATE(163),
    [sym_list] = STATE(163),
    [sym_list_comprehension] = STATE(163),
    [sym_dictionary] = STATE(163),
    [sym_dictionary_comprehension] = STATE(163),
    [sym_set] = STATE(163),
    [sym_set_comprehension] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_tuple] = STATE(163),
    [sym_generator_expression] = STATE(163),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(163),
    [sym_string] = STATE(165),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [160] = {
    [aux_sym_list_repeat1] = STATE(490),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_RBRACE] = ACTIONS(851),
    [sym_comment] = ACTIONS(73),
  },
  [161] = {
    [aux_sym_dictionary_repeat1] = STATE(492),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(827),
    [sym_comment] = ACTIONS(73),
  },
  [162] = {
    [sym__comprehension_body] = STATE(499),
    [sym_for_in_clause] = STATE(500),
    [aux_sym_list_repeat1] = STATE(490),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(857),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_and] = ACTIONS(863),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(851),
    [sym_comment] = ACTIONS(73),
  },
  [163] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(511),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_not] = ACTIONS(875),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(873),
    [anon_sym_SLASH_SLASH] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(881),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(869),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(871),
    [anon_sym_EQ_EQ] = ACTIONS(871),
    [anon_sym_BANG_EQ] = ACTIONS(871),
    [anon_sym_GT_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_LT_GT] = ACTIONS(871),
    [anon_sym_is] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [164] = {
    [sym__comprehension_body] = STATE(512),
    [sym_for_in_clause] = STATE(500),
    [aux_sym_dictionary_repeat1] = STATE(492),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(827),
    [sym_comment] = ACTIONS(73),
  },
  [165] = {
    [sym_string] = STATE(513),
    [aux_sym_concatenated_string_repeat1] = STATE(513),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [166] = {
    [sym__newline] = ACTIONS(891),
    [anon_sym_from] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_COLON] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(891),
    [anon_sym_and] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(891),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_AT_EQ] = ACTIONS(891),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(891),
  },
  [167] = {
    [sym__string_start] = ACTIONS(893),
    [ts_builtin_sym_end] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_print] = ACTIONS(895),
    [anon_sym_assert] = ACTIONS(895),
    [anon_sym_return] = ACTIONS(895),
    [anon_sym_del] = ACTIONS(895),
    [anon_sym_raise] = ACTIONS(895),
    [anon_sym_pass] = ACTIONS(895),
    [anon_sym_break] = ACTIONS(895),
    [anon_sym_continue] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(895),
    [anon_sym_elif] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(895),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_for] = ACTIONS(895),
    [anon_sym_while] = ACTIONS(895),
    [anon_sym_try] = ACTIONS(895),
    [anon_sym_except] = ACTIONS(895),
    [anon_sym_finally] = ACTIONS(895),
    [anon_sym_with] = ACTIONS(895),
    [anon_sym_def] = ACTIONS(895),
    [anon_sym_global] = ACTIONS(895),
    [anon_sym_nonlocal] = ACTIONS(895),
    [anon_sym_exec] = ACTIONS(895),
    [anon_sym_class] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(893),
    [anon_sym_not] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(893),
    [anon_sym_lambda] = ACTIONS(895),
    [anon_sym_yield] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(893),
    [sym_ellipsis] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [sym_integer] = ACTIONS(895),
    [sym_float] = ACTIONS(895),
    [sym_identifier] = ACTIONS(895),
    [sym_true] = ACTIONS(895),
    [sym_false] = ACTIONS(895),
    [sym_none] = ACTIONS(895),
    [anon_sym_await] = ACTIONS(895),
    [sym_comment] = ACTIONS(73),
  },
  [168] = {
    [sym_import_statement] = STATE(515),
    [sym_import_from_statement] = STATE(515),
    [sym_print_statement] = STATE(515),
    [sym_assert_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_delete_statement] = STATE(515),
    [sym_raise_statement] = STATE(515),
    [sym_pass_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_global_statement] = STATE(515),
    [sym_nonlocal_statement] = STATE(515),
    [sym_exec_statement] = STATE(515),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(897),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [169] = {
    [aux_sym__simple_statements_repeat1] = STATE(517),
    [sym__newline] = ACTIONS(897),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(899),
  },
  [170] = {
    [sym__expression] = STATE(522),
    [sym__primary_expression] = STATE(523),
    [sym_not_operator] = STATE(522),
    [sym_boolean_operator] = STATE(522),
    [sym_binary_operator] = STATE(523),
    [sym_unary_operator] = STATE(523),
    [sym_comparison_operator] = STATE(522),
    [sym_lambda] = STATE(522),
    [sym_attribute] = STATE(523),
    [sym_subscript] = STATE(523),
    [sym_call] = STATE(523),
    [sym_type] = STATE(524),
    [sym_list] = STATE(523),
    [sym_list_comprehension] = STATE(523),
    [sym_dictionary] = STATE(523),
    [sym_dictionary_comprehension] = STATE(523),
    [sym_set] = STATE(523),
    [sym_set_comprehension] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_tuple] = STATE(523),
    [sym_generator_expression] = STATE(523),
    [sym_conditional_expression] = STATE(522),
    [sym_concatenated_string] = STATE(523),
    [sym_string] = STATE(525),
    [sym_await] = STATE(522),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_lambda] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(909),
    [sym_float] = ACTIONS(909),
    [sym_identifier] = ACTIONS(909),
    [sym_true] = ACTIONS(909),
    [sym_false] = ACTIONS(909),
    [sym_none] = ACTIONS(909),
    [anon_sym_await] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
  },
  [171] = {
    [sym_expression_list] = STATE(526),
    [sym__expression] = STATE(527),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(527),
    [sym_boolean_operator] = STATE(527),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(527),
    [sym_lambda] = STATE(527),
    [sym_assignment] = STATE(528),
    [sym_augmented_assignment] = STATE(528),
    [sym__right_hand_side] = STATE(528),
    [sym_yield] = STATE(528),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(527),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(527),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [172] = {
    [sym_expression_list] = STATE(526),
    [sym__expression] = STATE(527),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(527),
    [sym_boolean_operator] = STATE(527),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(527),
    [sym_lambda] = STATE(527),
    [sym_assignment] = STATE(529),
    [sym_augmented_assignment] = STATE(529),
    [sym__right_hand_side] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(527),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(527),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [173] = {
    [sym__expression] = STATE(530),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(530),
    [sym_boolean_operator] = STATE(530),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(530),
    [sym_lambda] = STATE(530),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(530),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(530),
    [sym__newline] = ACTIONS(913),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(917),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(915),
    [anon_sym_DASH_EQ] = ACTIONS(915),
    [anon_sym_STAR_EQ] = ACTIONS(915),
    [anon_sym_SLASH_EQ] = ACTIONS(915),
    [anon_sym_AT_EQ] = ACTIONS(915),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(915),
    [anon_sym_PERCENT_EQ] = ACTIONS(915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(915),
    [anon_sym_GT_GT_EQ] = ACTIONS(915),
    [anon_sym_LT_LT_EQ] = ACTIONS(915),
    [anon_sym_AMP_EQ] = ACTIONS(915),
    [anon_sym_CARET_EQ] = ACTIONS(915),
    [anon_sym_PIPE_EQ] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(913),
  },
  [174] = {
    [sym__expression] = STATE(535),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(535),
    [sym_boolean_operator] = STATE(535),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(535),
    [sym_lambda] = STATE(535),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(535),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(535),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [175] = {
    [sym__expression] = STATE(538),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(538),
    [sym_boolean_operator] = STATE(538),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(538),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(538),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [176] = {
    [sym__expression] = STATE(539),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(539),
    [sym_boolean_operator] = STATE(539),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(539),
    [sym_lambda] = STATE(539),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(539),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(539),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [177] = {
    [aux_sym_print_statement_repeat1] = STATE(541),
    [sym__newline] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(931),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_PLUS_EQ] = ACTIONS(915),
    [anon_sym_DASH_EQ] = ACTIONS(915),
    [anon_sym_STAR_EQ] = ACTIONS(915),
    [anon_sym_SLASH_EQ] = ACTIONS(915),
    [anon_sym_AT_EQ] = ACTIONS(915),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(915),
    [anon_sym_PERCENT_EQ] = ACTIONS(915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(915),
    [anon_sym_GT_GT_EQ] = ACTIONS(915),
    [anon_sym_LT_LT_EQ] = ACTIONS(915),
    [anon_sym_AMP_EQ] = ACTIONS(915),
    [anon_sym_CARET_EQ] = ACTIONS(915),
    [anon_sym_PIPE_EQ] = ACTIONS(915),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(913),
  },
  [178] = {
    [sym_identifier] = ACTIONS(933),
    [sym_comment] = ACTIONS(73),
  },
  [179] = {
    [sym_list_splat] = STATE(548),
    [sym_dictionary_splat] = STATE(548),
    [sym__expression] = STATE(549),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(549),
    [sym_boolean_operator] = STATE(549),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(549),
    [sym_lambda] = STATE(549),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_keyword_argument] = STATE(548),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(549),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(549),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(937),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [180] = {
    [sym__primary_expression] = STATE(550),
    [sym_binary_operator] = STATE(550),
    [sym_unary_operator] = STATE(550),
    [sym_attribute] = STATE(550),
    [sym_subscript] = STATE(550),
    [sym_call] = STATE(550),
    [sym_list] = STATE(550),
    [sym_list_comprehension] = STATE(550),
    [sym_dictionary] = STATE(550),
    [sym_dictionary_comprehension] = STATE(550),
    [sym_set] = STATE(550),
    [sym_set_comprehension] = STATE(550),
    [sym_parenthesized_expression] = STATE(550),
    [sym_tuple] = STATE(550),
    [sym_generator_expression] = STATE(550),
    [sym_concatenated_string] = STATE(550),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(947),
    [sym_float] = ACTIONS(947),
    [sym_identifier] = ACTIONS(947),
    [sym_true] = ACTIONS(947),
    [sym_false] = ACTIONS(947),
    [sym_none] = ACTIONS(947),
    [sym_comment] = ACTIONS(73),
  },
  [181] = {
    [sym__primary_expression] = STATE(551),
    [sym_binary_operator] = STATE(551),
    [sym_unary_operator] = STATE(551),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(551),
    [sym_list] = STATE(551),
    [sym_list_comprehension] = STATE(551),
    [sym_dictionary] = STATE(551),
    [sym_dictionary_comprehension] = STATE(551),
    [sym_set] = STATE(551),
    [sym_set_comprehension] = STATE(551),
    [sym_parenthesized_expression] = STATE(551),
    [sym_tuple] = STATE(551),
    [sym_generator_expression] = STATE(551),
    [sym_concatenated_string] = STATE(551),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(951),
    [sym_float] = ACTIONS(951),
    [sym_identifier] = ACTIONS(951),
    [sym_true] = ACTIONS(951),
    [sym_false] = ACTIONS(951),
    [sym_none] = ACTIONS(951),
    [sym_comment] = ACTIONS(73),
  },
  [182] = {
    [sym__primary_expression] = STATE(552),
    [sym_binary_operator] = STATE(552),
    [sym_unary_operator] = STATE(552),
    [sym_attribute] = STATE(552),
    [sym_subscript] = STATE(552),
    [sym_call] = STATE(552),
    [sym_list] = STATE(552),
    [sym_list_comprehension] = STATE(552),
    [sym_dictionary] = STATE(552),
    [sym_dictionary_comprehension] = STATE(552),
    [sym_set] = STATE(552),
    [sym_set_comprehension] = STATE(552),
    [sym_parenthesized_expression] = STATE(552),
    [sym_tuple] = STATE(552),
    [sym_generator_expression] = STATE(552),
    [sym_concatenated_string] = STATE(552),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(953),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(955),
    [sym_float] = ACTIONS(955),
    [sym_identifier] = ACTIONS(955),
    [sym_true] = ACTIONS(955),
    [sym_false] = ACTIONS(955),
    [sym_none] = ACTIONS(955),
    [sym_comment] = ACTIONS(73),
  },
  [183] = {
    [anon_sym_in] = ACTIONS(957),
    [sym_comment] = ACTIONS(73),
  },
  [184] = {
    [sym__primary_expression] = STATE(554),
    [sym_binary_operator] = STATE(554),
    [sym_unary_operator] = STATE(554),
    [sym_attribute] = STATE(554),
    [sym_subscript] = STATE(554),
    [sym_call] = STATE(554),
    [sym_list] = STATE(554),
    [sym_list_comprehension] = STATE(554),
    [sym_dictionary] = STATE(554),
    [sym_dictionary_comprehension] = STATE(554),
    [sym_set] = STATE(554),
    [sym_set_comprehension] = STATE(554),
    [sym_parenthesized_expression] = STATE(554),
    [sym_tuple] = STATE(554),
    [sym_generator_expression] = STATE(554),
    [sym_concatenated_string] = STATE(554),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(961),
    [sym_float] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_true] = ACTIONS(961),
    [sym_false] = ACTIONS(961),
    [sym_none] = ACTIONS(961),
    [sym_comment] = ACTIONS(73),
  },
  [185] = {
    [sym__primary_expression] = STATE(555),
    [sym_binary_operator] = STATE(555),
    [sym_unary_operator] = STATE(555),
    [sym_attribute] = STATE(555),
    [sym_subscript] = STATE(555),
    [sym_call] = STATE(555),
    [sym_list] = STATE(555),
    [sym_list_comprehension] = STATE(555),
    [sym_dictionary] = STATE(555),
    [sym_dictionary_comprehension] = STATE(555),
    [sym_set] = STATE(555),
    [sym_set_comprehension] = STATE(555),
    [sym_parenthesized_expression] = STATE(555),
    [sym_tuple] = STATE(555),
    [sym_generator_expression] = STATE(555),
    [sym_concatenated_string] = STATE(555),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(965),
    [sym_float] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_true] = ACTIONS(965),
    [sym_false] = ACTIONS(965),
    [sym_none] = ACTIONS(965),
    [sym_comment] = ACTIONS(73),
  },
  [186] = {
    [sym__primary_expression] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_unary_operator] = STATE(556),
    [sym_attribute] = STATE(556),
    [sym_subscript] = STATE(556),
    [sym_call] = STATE(556),
    [sym_list] = STATE(556),
    [sym_list_comprehension] = STATE(556),
    [sym_dictionary] = STATE(556),
    [sym_dictionary_comprehension] = STATE(556),
    [sym_set] = STATE(556),
    [sym_set_comprehension] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_tuple] = STATE(556),
    [sym_generator_expression] = STATE(556),
    [sym_concatenated_string] = STATE(556),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(969),
    [sym_float] = ACTIONS(969),
    [sym_identifier] = ACTIONS(969),
    [sym_true] = ACTIONS(969),
    [sym_false] = ACTIONS(969),
    [sym_none] = ACTIONS(969),
    [sym_comment] = ACTIONS(73),
  },
  [187] = {
    [sym__primary_expression] = STATE(557),
    [sym_binary_operator] = STATE(557),
    [sym_unary_operator] = STATE(557),
    [sym_attribute] = STATE(557),
    [sym_subscript] = STATE(557),
    [sym_call] = STATE(557),
    [sym_list] = STATE(557),
    [sym_list_comprehension] = STATE(557),
    [sym_dictionary] = STATE(557),
    [sym_dictionary_comprehension] = STATE(557),
    [sym_set] = STATE(557),
    [sym_set_comprehension] = STATE(557),
    [sym_parenthesized_expression] = STATE(557),
    [sym_tuple] = STATE(557),
    [sym_generator_expression] = STATE(557),
    [sym_concatenated_string] = STATE(557),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(973),
    [sym_float] = ACTIONS(973),
    [sym_identifier] = ACTIONS(973),
    [sym_true] = ACTIONS(973),
    [sym_false] = ACTIONS(973),
    [sym_none] = ACTIONS(973),
    [sym_comment] = ACTIONS(73),
  },
  [188] = {
    [sym__primary_expression] = STATE(558),
    [sym_binary_operator] = STATE(558),
    [sym_unary_operator] = STATE(558),
    [sym_attribute] = STATE(558),
    [sym_subscript] = STATE(558),
    [sym_call] = STATE(558),
    [sym_list] = STATE(558),
    [sym_list_comprehension] = STATE(558),
    [sym_dictionary] = STATE(558),
    [sym_dictionary_comprehension] = STATE(558),
    [sym_set] = STATE(558),
    [sym_set_comprehension] = STATE(558),
    [sym_parenthesized_expression] = STATE(558),
    [sym_tuple] = STATE(558),
    [sym_generator_expression] = STATE(558),
    [sym_concatenated_string] = STATE(558),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(977),
    [sym_float] = ACTIONS(977),
    [sym_identifier] = ACTIONS(977),
    [sym_true] = ACTIONS(977),
    [sym_false] = ACTIONS(977),
    [sym_none] = ACTIONS(977),
    [sym_comment] = ACTIONS(73),
  },
  [189] = {
    [sym__primary_expression] = STATE(552),
    [sym_binary_operator] = STATE(552),
    [sym_unary_operator] = STATE(552),
    [sym_attribute] = STATE(552),
    [sym_subscript] = STATE(552),
    [sym_call] = STATE(552),
    [sym_list] = STATE(552),
    [sym_list_comprehension] = STATE(552),
    [sym_dictionary] = STATE(552),
    [sym_dictionary_comprehension] = STATE(552),
    [sym_set] = STATE(552),
    [sym_set_comprehension] = STATE(552),
    [sym_parenthesized_expression] = STATE(552),
    [sym_tuple] = STATE(552),
    [sym_generator_expression] = STATE(552),
    [sym_concatenated_string] = STATE(552),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(979),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(953),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(955),
    [sym_float] = ACTIONS(955),
    [sym_identifier] = ACTIONS(955),
    [sym_true] = ACTIONS(955),
    [sym_false] = ACTIONS(955),
    [sym_none] = ACTIONS(955),
    [sym_comment] = ACTIONS(73),
  },
  [190] = {
    [sym__expression] = STATE(564),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(564),
    [sym_boolean_operator] = STATE(564),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(564),
    [sym_lambda] = STATE(564),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_slice] = STATE(566),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(564),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(564),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [191] = {
    [sym__newline] = ACTIONS(995),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(997),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_SLASH_SLASH] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_PLUS_EQ] = ACTIONS(995),
    [anon_sym_DASH_EQ] = ACTIONS(995),
    [anon_sym_STAR_EQ] = ACTIONS(995),
    [anon_sym_SLASH_EQ] = ACTIONS(995),
    [anon_sym_AT_EQ] = ACTIONS(995),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(995),
    [anon_sym_PERCENT_EQ] = ACTIONS(995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(995),
    [anon_sym_GT_GT_EQ] = ACTIONS(995),
    [anon_sym_LT_LT_EQ] = ACTIONS(995),
    [anon_sym_AMP_EQ] = ACTIONS(995),
    [anon_sym_CARET_EQ] = ACTIONS(995),
    [anon_sym_PIPE_EQ] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(995),
  },
  [192] = {
    [aux_sym_comparison_operator_repeat1] = STATE(568),
    [sym__newline] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_LT_EQ] = ACTIONS(311),
    [anon_sym_EQ_EQ] = ACTIONS(311),
    [anon_sym_BANG_EQ] = ACTIONS(311),
    [anon_sym_GT_EQ] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_LT_GT] = ACTIONS(311),
    [anon_sym_is] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(999),
    [anon_sym_DASH_EQ] = ACTIONS(999),
    [anon_sym_STAR_EQ] = ACTIONS(999),
    [anon_sym_SLASH_EQ] = ACTIONS(999),
    [anon_sym_AT_EQ] = ACTIONS(999),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(999),
    [anon_sym_PERCENT_EQ] = ACTIONS(999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(999),
    [anon_sym_GT_GT_EQ] = ACTIONS(999),
    [anon_sym_LT_LT_EQ] = ACTIONS(999),
    [anon_sym_AMP_EQ] = ACTIONS(999),
    [anon_sym_CARET_EQ] = ACTIONS(999),
    [anon_sym_PIPE_EQ] = ACTIONS(999),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(999),
  },
  [193] = {
    [sym_string] = STATE(569),
    [aux_sym_concatenated_string_repeat1] = STATE(569),
    [sym__newline] = ACTIONS(1003),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_COLON] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1005),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1005),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1005),
    [anon_sym_SLASH_SLASH] = ACTIONS(1005),
    [anon_sym_STAR_STAR] = ACTIONS(1005),
    [anon_sym_PIPE] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1005),
    [anon_sym_CARET] = ACTIONS(1005),
    [anon_sym_LT_LT] = ACTIONS(1005),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_PLUS_EQ] = ACTIONS(1003),
    [anon_sym_DASH_EQ] = ACTIONS(1003),
    [anon_sym_STAR_EQ] = ACTIONS(1003),
    [anon_sym_SLASH_EQ] = ACTIONS(1003),
    [anon_sym_AT_EQ] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1003),
    [anon_sym_PERCENT_EQ] = ACTIONS(1003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1003),
    [anon_sym_GT_GT_EQ] = ACTIONS(1003),
    [anon_sym_LT_LT_EQ] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(1003),
    [anon_sym_CARET_EQ] = ACTIONS(1003),
    [anon_sym_PIPE_EQ] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1003),
  },
  [194] = {
    [sym__statement] = STATE(194),
    [sym__simple_statements] = STATE(194),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_if_statement] = STATE(194),
    [sym_for_statement] = STATE(194),
    [sym_while_statement] = STATE(194),
    [sym_try_statement] = STATE(194),
    [sym_with_statement] = STATE(194),
    [sym_function_definition] = STATE(194),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym_class_definition] = STATE(194),
    [sym_decorated_definition] = STATE(194),
    [sym_decorator] = STATE(41),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(194),
    [aux_sym_decorated_definition_repeat1] = STATE(41),
    [sym__string_start] = ACTIONS(1007),
    [ts_builtin_sym_end] = ACTIONS(1010),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_from] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_print] = ACTIONS(1021),
    [anon_sym_assert] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_del] = ACTIONS(1030),
    [anon_sym_raise] = ACTIONS(1033),
    [anon_sym_pass] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1042),
    [anon_sym_if] = ACTIONS(1045),
    [anon_sym_async] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1054),
    [anon_sym_try] = ACTIONS(1057),
    [anon_sym_with] = ACTIONS(1060),
    [anon_sym_def] = ACTIONS(1063),
    [anon_sym_global] = ACTIONS(1066),
    [anon_sym_nonlocal] = ACTIONS(1069),
    [anon_sym_exec] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(1078),
    [anon_sym_not] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_lambda] = ACTIONS(1087),
    [anon_sym_yield] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [sym_ellipsis] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [sym_integer] = ACTIONS(1102),
    [sym_float] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1102),
    [sym_true] = ACTIONS(1102),
    [sym_false] = ACTIONS(1102),
    [sym_none] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1105),
    [sym_comment] = ACTIONS(73),
  },
  [195] = {
    [anon_sym_def] = ACTIONS(187),
    [sym_comment] = ACTIONS(73),
  },
  [196] = {
    [sym__string_start] = ACTIONS(1108),
    [ts_builtin_sym_end] = ACTIONS(1108),
    [anon_sym_import] = ACTIONS(1110),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [anon_sym_print] = ACTIONS(1110),
    [anon_sym_assert] = ACTIONS(1110),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_del] = ACTIONS(1110),
    [anon_sym_raise] = ACTIONS(1110),
    [anon_sym_pass] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1110),
    [anon_sym_continue] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1110),
    [anon_sym_async] = ACTIONS(1110),
    [anon_sym_for] = ACTIONS(1110),
    [anon_sym_while] = ACTIONS(1110),
    [anon_sym_try] = ACTIONS(1110),
    [anon_sym_with] = ACTIONS(1110),
    [anon_sym_def] = ACTIONS(1110),
    [anon_sym_global] = ACTIONS(1110),
    [anon_sym_nonlocal] = ACTIONS(1110),
    [anon_sym_exec] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(1110),
    [anon_sym_AT] = ACTIONS(1108),
    [anon_sym_not] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_TILDE] = ACTIONS(1108),
    [anon_sym_lambda] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1108),
    [sym_ellipsis] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1108),
    [sym_integer] = ACTIONS(1110),
    [sym_float] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(1110),
    [sym_true] = ACTIONS(1110),
    [sym_false] = ACTIONS(1110),
    [sym_none] = ACTIONS(1110),
    [anon_sym_await] = ACTIONS(1110),
    [sym_comment] = ACTIONS(73),
  },
  [197] = {
    [sym_decorator] = STATE(197),
    [aux_sym_decorated_definition_repeat1] = STATE(197),
    [anon_sym_async] = ACTIONS(1112),
    [anon_sym_def] = ACTIONS(1112),
    [anon_sym_class] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1114),
    [sym_comment] = ACTIONS(73),
  },
  [198] = {
    [sym__expression] = STATE(570),
    [sym__primary_expression] = STATE(203),
    [sym_not_operator] = STATE(570),
    [sym_boolean_operator] = STATE(570),
    [sym_binary_operator] = STATE(203),
    [sym_unary_operator] = STATE(203),
    [sym_comparison_operator] = STATE(570),
    [sym_lambda] = STATE(570),
    [sym_attribute] = STATE(203),
    [sym_subscript] = STATE(203),
    [sym_call] = STATE(203),
    [sym_list] = STATE(203),
    [sym_list_comprehension] = STATE(203),
    [sym_dictionary] = STATE(203),
    [sym_dictionary_comprehension] = STATE(203),
    [sym_set] = STATE(203),
    [sym_set_comprehension] = STATE(203),
    [sym_parenthesized_expression] = STATE(203),
    [sym_tuple] = STATE(203),
    [sym_generator_expression] = STATE(203),
    [sym_conditional_expression] = STATE(570),
    [sym_concatenated_string] = STATE(203),
    [sym_string] = STATE(204),
    [sym_await] = STATE(570),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [199] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [200] = {
    [sym_lambda_parameters] = STATE(572),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [201] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(203),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(203),
    [sym_unary_operator] = STATE(203),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(203),
    [sym_subscript] = STATE(203),
    [sym_call] = STATE(203),
    [sym_list] = STATE(203),
    [sym_list_comprehension] = STATE(203),
    [sym_dictionary] = STATE(203),
    [sym_dictionary_comprehension] = STATE(203),
    [sym_set] = STATE(203),
    [sym_set_comprehension] = STATE(203),
    [sym_parenthesized_expression] = STATE(203),
    [sym_tuple] = STATE(203),
    [sym_generator_expression] = STATE(203),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(203),
    [sym_string] = STATE(204),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [202] = {
    [anon_sym_if] = ACTIONS(1119),
    [anon_sym_and] = ACTIONS(1121),
    [anon_sym_or] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [sym_type_conversion] = ACTIONS(1127),
    [sym_comment] = ACTIONS(73),
  },
  [203] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(588),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1149),
    [anon_sym_LT_GT] = ACTIONS(1133),
    [anon_sym_is] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(301),
    [sym_type_conversion] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [204] = {
    [sym_string] = STATE(589),
    [aux_sym_concatenated_string_repeat1] = STATE(589),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(333),
    [sym_type_conversion] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [205] = {
    [sym__newline] = ACTIONS(1153),
    [sym__string_start] = ACTIONS(1153),
    [anon_sym_DOT] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_COLON] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(1153),
    [anon_sym_EQ] = ACTIONS(1155),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_not] = ACTIONS(1153),
    [anon_sym_and] = ACTIONS(1153),
    [anon_sym_or] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_SLASH_SLASH] = ACTIONS(1155),
    [anon_sym_STAR_STAR] = ACTIONS(1155),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1155),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1153),
    [anon_sym_EQ_EQ] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_LT_GT] = ACTIONS(1153),
    [anon_sym_is] = ACTIONS(1153),
    [anon_sym_PLUS_EQ] = ACTIONS(1153),
    [anon_sym_DASH_EQ] = ACTIONS(1153),
    [anon_sym_STAR_EQ] = ACTIONS(1153),
    [anon_sym_SLASH_EQ] = ACTIONS(1153),
    [anon_sym_AT_EQ] = ACTIONS(1153),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1153),
    [anon_sym_PERCENT_EQ] = ACTIONS(1153),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1153),
    [anon_sym_GT_GT_EQ] = ACTIONS(1153),
    [anon_sym_LT_LT_EQ] = ACTIONS(1153),
    [anon_sym_AMP_EQ] = ACTIONS(1153),
    [anon_sym_CARET_EQ] = ACTIONS(1153),
    [anon_sym_PIPE_EQ] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1153),
  },
  [206] = {
    [sym_interpolation] = STATE(206),
    [aux_sym_string_repeat1] = STATE(206),
    [sym__string_content] = ACTIONS(1157),
    [sym__string_end] = ACTIONS(1160),
    [anon_sym_LBRACE] = ACTIONS(1162),
    [sym_escape_sequence] = ACTIONS(1165),
    [sym_comment] = ACTIONS(83),
  },
  [207] = {
    [sym_identifier] = ACTIONS(1168),
    [sym_comment] = ACTIONS(73),
  },
  [208] = {
    [aux_sym_dotted_name_repeat1] = STATE(591),
    [sym__newline] = ACTIONS(1170),
    [anon_sym_DOT] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(1170),
    [anon_sym_as] = ACTIONS(1170),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1170),
  },
  [209] = {
    [sym_aliased_import] = STATE(592),
    [sym_dotted_name] = STATE(593),
    [sym__newline] = ACTIONS(1172),
    [sym_identifier] = ACTIONS(85),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1172),
  },
  [210] = {
    [aux_sym__import_list_repeat1] = STATE(595),
    [sym__newline] = ACTIONS(1172),
    [anon_sym_COMMA] = ACTIONS(1174),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1172),
  },
  [211] = {
    [sym_identifier] = ACTIONS(1176),
    [sym_comment] = ACTIONS(73),
  },
  [212] = {
    [sym_identifier] = ACTIONS(1178),
    [sym_comment] = ACTIONS(73),
  },
  [213] = {
    [aux_sym_dotted_name_repeat1] = STATE(598),
    [anon_sym_import] = ACTIONS(1170),
    [anon_sym_DOT] = ACTIONS(379),
    [sym_comment] = ACTIONS(73),
  },
  [214] = {
    [anon_sym_import] = ACTIONS(1180),
    [sym_comment] = ACTIONS(73),
  },
  [215] = {
    [sym__import_list] = STATE(601),
    [sym_aliased_import] = STATE(47),
    [sym_wildcard_import] = STATE(601),
    [sym_dotted_name] = STATE(48),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [anon_sym_STAR] = ACTIONS(1184),
    [sym_identifier] = ACTIONS(85),
    [sym_comment] = ACTIONS(73),
  },
  [216] = {
    [aux_sym_import_prefix_repeat1] = STATE(216),
    [anon_sym_import] = ACTIONS(1186),
    [anon_sym_DOT] = ACTIONS(1188),
    [sym_identifier] = ACTIONS(1186),
    [sym_comment] = ACTIONS(73),
  },
  [217] = {
    [sym__string_start] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(345),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_as] = ACTIONS(347),
    [anon_sym_STAR] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(345),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_COLON] = ACTIONS(345),
    [anon_sym_else] = ACTIONS(345),
    [anon_sym_async] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(345),
    [anon_sym_in] = ACTIONS(345),
    [anon_sym_EQ] = ACTIONS(347),
    [anon_sym_AT] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(345),
    [anon_sym_and] = ACTIONS(345),
    [anon_sym_or] = ACTIONS(345),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_SLASH] = ACTIONS(347),
    [anon_sym_PERCENT] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_STAR_STAR] = ACTIONS(345),
    [anon_sym_PIPE] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(345),
    [anon_sym_CARET] = ACTIONS(345),
    [anon_sym_LT_LT] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_LT_EQ] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_BANG_EQ] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_LT_GT] = ACTIONS(345),
    [anon_sym_is] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_RBRACK] = ACTIONS(345),
    [anon_sym_RBRACE] = ACTIONS(345),
    [sym_type_conversion] = ACTIONS(345),
    [sym_comment] = ACTIONS(73),
  },
  [218] = {
    [sym_interpolation] = STATE(206),
    [aux_sym_string_repeat1] = STATE(206),
    [sym__string_content] = ACTIONS(361),
    [sym__string_end] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(365),
    [sym_comment] = ACTIONS(83),
  },
  [219] = {
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(401),
    [anon_sym_as] = ACTIONS(403),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(401),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(401),
    [anon_sym_else] = ACTIONS(401),
    [anon_sym_async] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_in] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(403),
    [anon_sym_AT] = ACTIONS(401),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(401),
    [anon_sym_or] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_SLASH] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(401),
    [anon_sym_SLASH_SLASH] = ACTIONS(401),
    [anon_sym_STAR_STAR] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_CARET] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_BANG_EQ] = ACTIONS(401),
    [anon_sym_GT_EQ] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_LT_GT] = ACTIONS(401),
    [anon_sym_is] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(401),
    [anon_sym_RBRACK] = ACTIONS(401),
    [anon_sym_RBRACE] = ACTIONS(401),
    [sym_type_conversion] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
  },
  [220] = {
    [anon_sym_RPAREN] = ACTIONS(1193),
    [sym_comment] = ACTIONS(73),
  },
  [221] = {
    [sym__comprehension_body] = STATE(606),
    [sym_for_in_clause] = STATE(256),
    [aux_sym_tuple_repeat1] = STATE(607),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(441),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [222] = {
    [aux_sym_tuple_repeat1] = STATE(607),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1197),
    [sym_comment] = ACTIONS(73),
  },
  [223] = {
    [sym__newline] = ACTIONS(1199),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1199),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_in] = ACTIONS(1199),
    [anon_sym_EQ] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1199),
    [anon_sym_or] = ACTIONS(1199),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1201),
    [anon_sym_SLASH_SLASH] = ACTIONS(1201),
    [anon_sym_STAR_STAR] = ACTIONS(1201),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1201),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_LT_GT] = ACTIONS(1199),
    [anon_sym_is] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(1199),
    [anon_sym_DASH_EQ] = ACTIONS(1199),
    [anon_sym_STAR_EQ] = ACTIONS(1199),
    [anon_sym_SLASH_EQ] = ACTIONS(1199),
    [anon_sym_AT_EQ] = ACTIONS(1199),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1199),
    [anon_sym_PERCENT_EQ] = ACTIONS(1199),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT_EQ] = ACTIONS(1199),
    [anon_sym_LT_LT_EQ] = ACTIONS(1199),
    [anon_sym_AMP_EQ] = ACTIONS(1199),
    [anon_sym_CARET_EQ] = ACTIONS(1199),
    [anon_sym_PIPE_EQ] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1199),
  },
  [224] = {
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [225] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_as] = ACTIONS(735),
    [anon_sym_STAR] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_async] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_AT] = ACTIONS(733),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_SLASH_SLASH] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_LT_GT] = ACTIONS(733),
    [anon_sym_is] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [sym_type_conversion] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
  },
  [226] = {
    [sym__expression] = STATE(608),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(608),
    [sym_boolean_operator] = STATE(608),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(608),
    [sym_lambda] = STATE(608),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(608),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(608),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [227] = {
    [anon_sym_COLON] = ACTIONS(1203),
    [sym_comment] = ACTIONS(73),
  },
  [228] = {
    [sym__expression] = STATE(610),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(610),
    [sym_boolean_operator] = STATE(610),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(610),
    [sym_lambda] = STATE(610),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(610),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(610),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [229] = {
    [sym__expression] = STATE(611),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(611),
    [sym_boolean_operator] = STATE(611),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(611),
    [sym_lambda] = STATE(611),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(611),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(611),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [230] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [231] = {
    [sym_lambda_parameters] = STATE(613),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [232] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [233] = {
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_COMMA] = ACTIONS(769),
    [sym_comment] = ACTIONS(73),
  },
  [234] = {
    [aux_sym_print_statement_repeat1] = STATE(618),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [235] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(629),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(1221),
    [anon_sym_not] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_SLASH_SLASH] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_LT_EQ] = ACTIONS(1219),
    [anon_sym_EQ_EQ] = ACTIONS(1219),
    [anon_sym_BANG_EQ] = ACTIONS(1219),
    [anon_sym_GT_EQ] = ACTIONS(1219),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_LT_GT] = ACTIONS(1219),
    [anon_sym_is] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [236] = {
    [sym_string] = STATE(630),
    [aux_sym_concatenated_string_repeat1] = STATE(630),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [237] = {
    [anon_sym_RBRACK] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
  },
  [238] = {
    [anon_sym_DOT] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(787),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_COMMA] = ACTIONS(787),
    [anon_sym_as] = ACTIONS(789),
    [anon_sym_STAR] = ACTIONS(789),
    [anon_sym_GT_GT] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_COLON] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(787),
    [anon_sym_async] = ACTIONS(787),
    [anon_sym_for] = ACTIONS(787),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(787),
    [anon_sym_not] = ACTIONS(787),
    [anon_sym_and] = ACTIONS(787),
    [anon_sym_or] = ACTIONS(787),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(789),
    [anon_sym_PERCENT] = ACTIONS(787),
    [anon_sym_SLASH_SLASH] = ACTIONS(787),
    [anon_sym_STAR_STAR] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_CARET] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(789),
    [anon_sym_LT_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_GT_EQ] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(789),
    [anon_sym_LT_GT] = ACTIONS(787),
    [anon_sym_is] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(787),
    [anon_sym_RBRACK] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(787),
    [sym_type_conversion] = ACTIONS(787),
    [sym_comment] = ACTIONS(73),
  },
  [239] = {
    [aux_sym_list_repeat1] = STATE(633),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_RBRACK] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
  },
  [240] = {
    [sym__comprehension_body] = STATE(634),
    [sym_for_in_clause] = STATE(463),
    [aux_sym_list_repeat1] = STATE(633),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(801),
    [anon_sym_RBRACK] = ACTIONS(1239),
    [sym_comment] = ACTIONS(73),
  },
  [241] = {
    [anon_sym_RBRACE] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
  },
  [242] = {
    [anon_sym_DOT] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_as] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(845),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_COLON] = ACTIONS(845),
    [anon_sym_else] = ACTIONS(845),
    [anon_sym_async] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(845),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_not] = ACTIONS(845),
    [anon_sym_and] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(845),
    [anon_sym_SLASH] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(845),
    [anon_sym_SLASH_SLASH] = ACTIONS(845),
    [anon_sym_STAR_STAR] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(845),
    [anon_sym_AMP] = ACTIONS(845),
    [anon_sym_CARET] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(845),
    [anon_sym_EQ_EQ] = ACTIONS(845),
    [anon_sym_BANG_EQ] = ACTIONS(845),
    [anon_sym_GT_EQ] = ACTIONS(845),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_LT_GT] = ACTIONS(845),
    [anon_sym_is] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(845),
    [sym_type_conversion] = ACTIONS(845),
    [sym_comment] = ACTIONS(73),
  },
  [243] = {
    [aux_sym_list_repeat1] = STATE(638),
    [anon_sym_COMMA] = ACTIONS(1245),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(73),
  },
  [244] = {
    [aux_sym_dictionary_repeat1] = STATE(640),
    [anon_sym_COMMA] = ACTIONS(1249),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
  },
  [245] = {
    [sym__comprehension_body] = STATE(641),
    [sym_for_in_clause] = STATE(500),
    [aux_sym_list_repeat1] = STATE(638),
    [anon_sym_COMMA] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(857),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_and] = ACTIONS(863),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(73),
  },
  [246] = {
    [sym__comprehension_body] = STATE(642),
    [sym_for_in_clause] = STATE(500),
    [aux_sym_dictionary_repeat1] = STATE(640),
    [anon_sym_COMMA] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [sym_comment] = ACTIONS(73),
  },
  [247] = {
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_as] = ACTIONS(1251),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_COLON] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(891),
    [anon_sym_async] = ACTIONS(891),
    [anon_sym_for] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(891),
    [anon_sym_and] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(891),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [sym_type_conversion] = ACTIONS(891),
    [sym_comment] = ACTIONS(73),
  },
  [248] = {
    [sym__newline] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_COLON] = ACTIONS(1253),
    [anon_sym_in] = ACTIONS(1253),
    [anon_sym_EQ] = ACTIONS(1255),
    [anon_sym_AT] = ACTIONS(1255),
    [anon_sym_not] = ACTIONS(1253),
    [anon_sym_and] = ACTIONS(1253),
    [anon_sym_or] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1255),
    [anon_sym_SLASH_SLASH] = ACTIONS(1255),
    [anon_sym_STAR_STAR] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_LT_EQ] = ACTIONS(1253),
    [anon_sym_EQ_EQ] = ACTIONS(1253),
    [anon_sym_BANG_EQ] = ACTIONS(1253),
    [anon_sym_GT_EQ] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_LT_GT] = ACTIONS(1253),
    [anon_sym_is] = ACTIONS(1253),
    [anon_sym_PLUS_EQ] = ACTIONS(1253),
    [anon_sym_DASH_EQ] = ACTIONS(1253),
    [anon_sym_STAR_EQ] = ACTIONS(1253),
    [anon_sym_SLASH_EQ] = ACTIONS(1253),
    [anon_sym_AT_EQ] = ACTIONS(1253),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1253),
    [anon_sym_PERCENT_EQ] = ACTIONS(1253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1253),
    [anon_sym_GT_GT_EQ] = ACTIONS(1253),
    [anon_sym_LT_LT_EQ] = ACTIONS(1253),
    [anon_sym_AMP_EQ] = ACTIONS(1253),
    [anon_sym_CARET_EQ] = ACTIONS(1253),
    [anon_sym_PIPE_EQ] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1253),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1253),
  },
  [249] = {
    [sym__expression] = STATE(644),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(644),
    [sym_boolean_operator] = STATE(644),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(644),
    [sym_lambda] = STATE(644),
    [sym_yield] = STATE(645),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(644),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(644),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [250] = {
    [sym__expression] = STATE(646),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(646),
    [sym_boolean_operator] = STATE(646),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(646),
    [sym_lambda] = STATE(646),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(646),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(646),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [251] = {
    [anon_sym_for] = ACTIONS(1259),
    [sym_comment] = ACTIONS(73),
  },
  [252] = {
    [sym_variables] = STATE(648),
    [sym__primary_expression] = STATE(108),
    [sym_binary_operator] = STATE(108),
    [sym_unary_operator] = STATE(108),
    [sym_attribute] = STATE(108),
    [sym_subscript] = STATE(108),
    [sym_call] = STATE(108),
    [sym_list] = STATE(108),
    [sym_list_comprehension] = STATE(108),
    [sym_dictionary] = STATE(108),
    [sym_dictionary_comprehension] = STATE(108),
    [sym_set] = STATE(108),
    [sym_set_comprehension] = STATE(108),
    [sym_parenthesized_expression] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_generator_expression] = STATE(108),
    [sym_concatenated_string] = STATE(108),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [253] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [254] = {
    [sym__expression] = STATE(650),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(650),
    [sym_boolean_operator] = STATE(650),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(650),
    [sym_lambda] = STATE(650),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(650),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(650),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [255] = {
    [anon_sym_RPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(73),
  },
  [256] = {
    [sym_for_in_clause] = STATE(653),
    [sym_if_clause] = STATE(653),
    [aux_sym__comprehension_body_repeat1] = STATE(653),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_async] = ACTIONS(441),
    [anon_sym_for] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [257] = {
    [aux_sym_tuple_repeat1] = STATE(655),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1267),
    [sym_comment] = ACTIONS(73),
  },
  [258] = {
    [sym_identifier] = ACTIONS(1269),
    [sym_comment] = ACTIONS(73),
  },
  [259] = {
    [sym_list_splat] = STATE(659),
    [sym_dictionary_splat] = STATE(659),
    [sym__expression] = STATE(660),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(660),
    [sym_boolean_operator] = STATE(660),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(660),
    [sym_lambda] = STATE(660),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_keyword_argument] = STATE(659),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(660),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(660),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [260] = {
    [sym__primary_expression] = STATE(661),
    [sym_binary_operator] = STATE(661),
    [sym_unary_operator] = STATE(661),
    [sym_attribute] = STATE(661),
    [sym_subscript] = STATE(661),
    [sym_call] = STATE(661),
    [sym_list] = STATE(661),
    [sym_list_comprehension] = STATE(661),
    [sym_dictionary] = STATE(661),
    [sym_dictionary_comprehension] = STATE(661),
    [sym_set] = STATE(661),
    [sym_set_comprehension] = STATE(661),
    [sym_parenthesized_expression] = STATE(661),
    [sym_tuple] = STATE(661),
    [sym_generator_expression] = STATE(661),
    [sym_concatenated_string] = STATE(661),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1275),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1277),
    [sym_float] = ACTIONS(1277),
    [sym_identifier] = ACTIONS(1277),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [sym_none] = ACTIONS(1277),
    [sym_comment] = ACTIONS(73),
  },
  [261] = {
    [sym__primary_expression] = STATE(662),
    [sym_binary_operator] = STATE(662),
    [sym_unary_operator] = STATE(662),
    [sym_attribute] = STATE(662),
    [sym_subscript] = STATE(662),
    [sym_call] = STATE(662),
    [sym_list] = STATE(662),
    [sym_list_comprehension] = STATE(662),
    [sym_dictionary] = STATE(662),
    [sym_dictionary_comprehension] = STATE(662),
    [sym_set] = STATE(662),
    [sym_set_comprehension] = STATE(662),
    [sym_parenthesized_expression] = STATE(662),
    [sym_tuple] = STATE(662),
    [sym_generator_expression] = STATE(662),
    [sym_concatenated_string] = STATE(662),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1279),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1281),
    [sym_float] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1281),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [sym_none] = ACTIONS(1281),
    [sym_comment] = ACTIONS(73),
  },
  [262] = {
    [sym__primary_expression] = STATE(663),
    [sym_binary_operator] = STATE(663),
    [sym_unary_operator] = STATE(663),
    [sym_attribute] = STATE(663),
    [sym_subscript] = STATE(663),
    [sym_call] = STATE(663),
    [sym_list] = STATE(663),
    [sym_list_comprehension] = STATE(663),
    [sym_dictionary] = STATE(663),
    [sym_dictionary_comprehension] = STATE(663),
    [sym_set] = STATE(663),
    [sym_set_comprehension] = STATE(663),
    [sym_parenthesized_expression] = STATE(663),
    [sym_tuple] = STATE(663),
    [sym_generator_expression] = STATE(663),
    [sym_concatenated_string] = STATE(663),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1285),
    [sym_float] = ACTIONS(1285),
    [sym_identifier] = ACTIONS(1285),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [sym_none] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
  },
  [263] = {
    [anon_sym_in] = ACTIONS(1287),
    [sym_comment] = ACTIONS(73),
  },
  [264] = {
    [sym__primary_expression] = STATE(665),
    [sym_binary_operator] = STATE(665),
    [sym_unary_operator] = STATE(665),
    [sym_attribute] = STATE(665),
    [sym_subscript] = STATE(665),
    [sym_call] = STATE(665),
    [sym_list] = STATE(665),
    [sym_list_comprehension] = STATE(665),
    [sym_dictionary] = STATE(665),
    [sym_dictionary_comprehension] = STATE(665),
    [sym_set] = STATE(665),
    [sym_set_comprehension] = STATE(665),
    [sym_parenthesized_expression] = STATE(665),
    [sym_tuple] = STATE(665),
    [sym_generator_expression] = STATE(665),
    [sym_concatenated_string] = STATE(665),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1291),
    [sym_float] = ACTIONS(1291),
    [sym_identifier] = ACTIONS(1291),
    [sym_true] = ACTIONS(1291),
    [sym_false] = ACTIONS(1291),
    [sym_none] = ACTIONS(1291),
    [sym_comment] = ACTIONS(73),
  },
  [265] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [266] = {
    [sym__primary_expression] = STATE(667),
    [sym_binary_operator] = STATE(667),
    [sym_unary_operator] = STATE(667),
    [sym_attribute] = STATE(667),
    [sym_subscript] = STATE(667),
    [sym_call] = STATE(667),
    [sym_list] = STATE(667),
    [sym_list_comprehension] = STATE(667),
    [sym_dictionary] = STATE(667),
    [sym_dictionary_comprehension] = STATE(667),
    [sym_set] = STATE(667),
    [sym_set_comprehension] = STATE(667),
    [sym_parenthesized_expression] = STATE(667),
    [sym_tuple] = STATE(667),
    [sym_generator_expression] = STATE(667),
    [sym_concatenated_string] = STATE(667),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1299),
    [sym_float] = ACTIONS(1299),
    [sym_identifier] = ACTIONS(1299),
    [sym_true] = ACTIONS(1299),
    [sym_false] = ACTIONS(1299),
    [sym_none] = ACTIONS(1299),
    [sym_comment] = ACTIONS(73),
  },
  [267] = {
    [sym__primary_expression] = STATE(668),
    [sym_binary_operator] = STATE(668),
    [sym_unary_operator] = STATE(668),
    [sym_attribute] = STATE(668),
    [sym_subscript] = STATE(668),
    [sym_call] = STATE(668),
    [sym_list] = STATE(668),
    [sym_list_comprehension] = STATE(668),
    [sym_dictionary] = STATE(668),
    [sym_dictionary_comprehension] = STATE(668),
    [sym_set] = STATE(668),
    [sym_set_comprehension] = STATE(668),
    [sym_parenthesized_expression] = STATE(668),
    [sym_tuple] = STATE(668),
    [sym_generator_expression] = STATE(668),
    [sym_concatenated_string] = STATE(668),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1303),
    [sym_float] = ACTIONS(1303),
    [sym_identifier] = ACTIONS(1303),
    [sym_true] = ACTIONS(1303),
    [sym_false] = ACTIONS(1303),
    [sym_none] = ACTIONS(1303),
    [sym_comment] = ACTIONS(73),
  },
  [268] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1307),
    [sym_float] = ACTIONS(1307),
    [sym_identifier] = ACTIONS(1307),
    [sym_true] = ACTIONS(1307),
    [sym_false] = ACTIONS(1307),
    [sym_none] = ACTIONS(1307),
    [sym_comment] = ACTIONS(73),
  },
  [269] = {
    [sym__primary_expression] = STATE(663),
    [sym_binary_operator] = STATE(663),
    [sym_unary_operator] = STATE(663),
    [sym_attribute] = STATE(663),
    [sym_subscript] = STATE(663),
    [sym_call] = STATE(663),
    [sym_list] = STATE(663),
    [sym_list_comprehension] = STATE(663),
    [sym_dictionary] = STATE(663),
    [sym_dictionary_comprehension] = STATE(663),
    [sym_set] = STATE(663),
    [sym_set_comprehension] = STATE(663),
    [sym_parenthesized_expression] = STATE(663),
    [sym_tuple] = STATE(663),
    [sym_generator_expression] = STATE(663),
    [sym_concatenated_string] = STATE(663),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1285),
    [sym_float] = ACTIONS(1285),
    [sym_identifier] = ACTIONS(1285),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [sym_none] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
  },
  [270] = {
    [sym__expression] = STATE(670),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(670),
    [sym_boolean_operator] = STATE(670),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(670),
    [sym_lambda] = STATE(670),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_slice] = STATE(671),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(670),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(670),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [271] = {
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_as] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_else] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACK] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [sym_type_conversion] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [272] = {
    [aux_sym_comparison_operator_repeat1] = STATE(672),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_async] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(457),
    [anon_sym_EQ_EQ] = ACTIONS(457),
    [anon_sym_BANG_EQ] = ACTIONS(457),
    [anon_sym_GT_EQ] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_LT_GT] = ACTIONS(457),
    [anon_sym_is] = ACTIONS(475),
    [sym_comment] = ACTIONS(73),
  },
  [273] = {
    [sym_string] = STATE(673),
    [aux_sym_concatenated_string_repeat1] = STATE(673),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_RPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [274] = {
    [sym__newline] = ACTIONS(345),
    [sym__string_start] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(345),
    [anon_sym_from] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_STAR] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(345),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_in] = ACTIONS(345),
    [anon_sym_EQ] = ACTIONS(347),
    [anon_sym_AT] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(345),
    [anon_sym_and] = ACTIONS(345),
    [anon_sym_or] = ACTIONS(345),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_SLASH] = ACTIONS(347),
    [anon_sym_PERCENT] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_STAR_STAR] = ACTIONS(345),
    [anon_sym_PIPE] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(345),
    [anon_sym_CARET] = ACTIONS(345),
    [anon_sym_LT_LT] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_LT_EQ] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_BANG_EQ] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_LT_GT] = ACTIONS(345),
    [anon_sym_is] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(345),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(345),
  },
  [275] = {
    [sym_interpolation] = STATE(206),
    [aux_sym_string_repeat1] = STATE(206),
    [sym__string_content] = ACTIONS(361),
    [sym__string_end] = ACTIONS(1311),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(365),
    [sym_comment] = ACTIONS(83),
  },
  [276] = {
    [sym__newline] = ACTIONS(401),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_from] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(401),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(401),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_in] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(403),
    [anon_sym_AT] = ACTIONS(401),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(401),
    [anon_sym_or] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_SLASH] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(401),
    [anon_sym_SLASH_SLASH] = ACTIONS(401),
    [anon_sym_STAR_STAR] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_CARET] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_BANG_EQ] = ACTIONS(401),
    [anon_sym_GT_EQ] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_LT_GT] = ACTIONS(401),
    [anon_sym_is] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(401),
  },
  [277] = {
    [anon_sym_RPAREN] = ACTIONS(1313),
    [sym_comment] = ACTIONS(73),
  },
  [278] = {
    [sym__comprehension_body] = STATE(678),
    [sym_for_in_clause] = STATE(256),
    [aux_sym_tuple_repeat1] = STATE(679),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_COMMA] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(441),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [279] = {
    [aux_sym_tuple_repeat1] = STATE(679),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_COMMA] = ACTIONS(1317),
    [sym_comment] = ACTIONS(73),
  },
  [280] = {
    [sym__newline] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1319),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(511),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1319),
  },
  [281] = {
    [sym__newline] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(511),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(731),
  },
  [282] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_from] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_STAR] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(735),
    [anon_sym_AT] = ACTIONS(733),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(735),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_SLASH_SLASH] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_LT_GT] = ACTIONS(733),
    [anon_sym_is] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(733),
  },
  [283] = {
    [sym__expression] = STATE(680),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(680),
    [sym_boolean_operator] = STATE(680),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(680),
    [sym_lambda] = STATE(680),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(680),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(680),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [284] = {
    [anon_sym_COLON] = ACTIONS(1321),
    [sym_comment] = ACTIONS(73),
  },
  [285] = {
    [anon_sym_RBRACK] = ACTIONS(1323),
    [sym_comment] = ACTIONS(73),
  },
  [286] = {
    [sym__newline] = ACTIONS(787),
    [anon_sym_DOT] = ACTIONS(787),
    [anon_sym_from] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(787),
    [anon_sym_COMMA] = ACTIONS(787),
    [anon_sym_STAR] = ACTIONS(789),
    [anon_sym_GT_GT] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(787),
    [anon_sym_not] = ACTIONS(787),
    [anon_sym_and] = ACTIONS(787),
    [anon_sym_or] = ACTIONS(787),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(789),
    [anon_sym_PERCENT] = ACTIONS(787),
    [anon_sym_SLASH_SLASH] = ACTIONS(787),
    [anon_sym_STAR_STAR] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_CARET] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(789),
    [anon_sym_LT_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_GT_EQ] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(789),
    [anon_sym_LT_GT] = ACTIONS(787),
    [anon_sym_is] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(787),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(787),
  },
  [287] = {
    [aux_sym_list_repeat1] = STATE(684),
    [anon_sym_COMMA] = ACTIONS(1325),
    [anon_sym_RBRACK] = ACTIONS(1323),
    [sym_comment] = ACTIONS(73),
  },
  [288] = {
    [sym__comprehension_body] = STATE(685),
    [sym_for_in_clause] = STATE(463),
    [aux_sym_list_repeat1] = STATE(684),
    [anon_sym_COMMA] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(801),
    [anon_sym_RBRACK] = ACTIONS(1323),
    [sym_comment] = ACTIONS(73),
  },
  [289] = {
    [anon_sym_RBRACE] = ACTIONS(1327),
    [sym_comment] = ACTIONS(73),
  },
  [290] = {
    [sym__newline] = ACTIONS(845),
    [anon_sym_DOT] = ACTIONS(845),
    [anon_sym_from] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(845),
    [anon_sym_if] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(845),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_not] = ACTIONS(845),
    [anon_sym_and] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(845),
    [anon_sym_SLASH] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(845),
    [anon_sym_SLASH_SLASH] = ACTIONS(845),
    [anon_sym_STAR_STAR] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(845),
    [anon_sym_AMP] = ACTIONS(845),
    [anon_sym_CARET] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(845),
    [anon_sym_EQ_EQ] = ACTIONS(845),
    [anon_sym_BANG_EQ] = ACTIONS(845),
    [anon_sym_GT_EQ] = ACTIONS(845),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_LT_GT] = ACTIONS(845),
    [anon_sym_is] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(845),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(845),
  },
  [291] = {
    [aux_sym_list_repeat1] = STATE(689),
    [anon_sym_COMMA] = ACTIONS(1329),
    [anon_sym_RBRACE] = ACTIONS(1331),
    [sym_comment] = ACTIONS(73),
  },
  [292] = {
    [aux_sym_dictionary_repeat1] = STATE(691),
    [anon_sym_COMMA] = ACTIONS(1333),
    [anon_sym_RBRACE] = ACTIONS(1327),
    [sym_comment] = ACTIONS(73),
  },
  [293] = {
    [sym__comprehension_body] = STATE(692),
    [sym_for_in_clause] = STATE(500),
    [aux_sym_list_repeat1] = STATE(689),
    [anon_sym_COMMA] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(857),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_and] = ACTIONS(863),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(1331),
    [sym_comment] = ACTIONS(73),
  },
  [294] = {
    [sym__comprehension_body] = STATE(693),
    [sym_for_in_clause] = STATE(500),
    [aux_sym_dictionary_repeat1] = STATE(691),
    [anon_sym_COMMA] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(1327),
    [sym_comment] = ACTIONS(73),
  },
  [295] = {
    [sym__expression] = STATE(694),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(694),
    [sym_boolean_operator] = STATE(694),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(694),
    [sym_lambda] = STATE(694),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(694),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(694),
    [sym__newline] = ACTIONS(1335),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1335),
  },
  [296] = {
    [aux_sym_print_statement_repeat1] = STATE(696),
    [sym__newline] = ACTIONS(1335),
    [anon_sym_COMMA] = ACTIONS(1337),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1335),
  },
  [297] = {
    [sym__expression] = STATE(697),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(697),
    [sym_boolean_operator] = STATE(697),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(697),
    [sym_lambda] = STATE(697),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(697),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(697),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [298] = {
    [sym__expression] = STATE(538),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(538),
    [sym_boolean_operator] = STATE(538),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(538),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(538),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [299] = {
    [sym__expression] = STATE(698),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(698),
    [sym_boolean_operator] = STATE(698),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(698),
    [sym_lambda] = STATE(698),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(698),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(698),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [300] = {
    [sym_identifier] = ACTIONS(1339),
    [sym_comment] = ACTIONS(73),
  },
  [301] = {
    [sym_list_splat] = STATE(702),
    [sym_dictionary_splat] = STATE(702),
    [sym__expression] = STATE(703),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(703),
    [sym_boolean_operator] = STATE(703),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(703),
    [sym_lambda] = STATE(703),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_keyword_argument] = STATE(702),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(703),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(703),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1343),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [302] = {
    [sym__primary_expression] = STATE(704),
    [sym_binary_operator] = STATE(704),
    [sym_unary_operator] = STATE(704),
    [sym_attribute] = STATE(704),
    [sym_subscript] = STATE(704),
    [sym_call] = STATE(704),
    [sym_list] = STATE(704),
    [sym_list_comprehension] = STATE(704),
    [sym_dictionary] = STATE(704),
    [sym_dictionary_comprehension] = STATE(704),
    [sym_set] = STATE(704),
    [sym_set_comprehension] = STATE(704),
    [sym_parenthesized_expression] = STATE(704),
    [sym_tuple] = STATE(704),
    [sym_generator_expression] = STATE(704),
    [sym_concatenated_string] = STATE(704),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1347),
    [sym_float] = ACTIONS(1347),
    [sym_identifier] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_none] = ACTIONS(1347),
    [sym_comment] = ACTIONS(73),
  },
  [303] = {
    [sym__primary_expression] = STATE(705),
    [sym_binary_operator] = STATE(705),
    [sym_unary_operator] = STATE(705),
    [sym_attribute] = STATE(705),
    [sym_subscript] = STATE(705),
    [sym_call] = STATE(705),
    [sym_list] = STATE(705),
    [sym_list_comprehension] = STATE(705),
    [sym_dictionary] = STATE(705),
    [sym_dictionary_comprehension] = STATE(705),
    [sym_set] = STATE(705),
    [sym_set_comprehension] = STATE(705),
    [sym_parenthesized_expression] = STATE(705),
    [sym_tuple] = STATE(705),
    [sym_generator_expression] = STATE(705),
    [sym_concatenated_string] = STATE(705),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1351),
    [sym_float] = ACTIONS(1351),
    [sym_identifier] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_none] = ACTIONS(1351),
    [sym_comment] = ACTIONS(73),
  },
  [304] = {
    [sym__primary_expression] = STATE(706),
    [sym_binary_operator] = STATE(706),
    [sym_unary_operator] = STATE(706),
    [sym_attribute] = STATE(706),
    [sym_subscript] = STATE(706),
    [sym_call] = STATE(706),
    [sym_list] = STATE(706),
    [sym_list_comprehension] = STATE(706),
    [sym_dictionary] = STATE(706),
    [sym_dictionary_comprehension] = STATE(706),
    [sym_set] = STATE(706),
    [sym_set_comprehension] = STATE(706),
    [sym_parenthesized_expression] = STATE(706),
    [sym_tuple] = STATE(706),
    [sym_generator_expression] = STATE(706),
    [sym_concatenated_string] = STATE(706),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1355),
    [sym_float] = ACTIONS(1355),
    [sym_identifier] = ACTIONS(1355),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [sym_none] = ACTIONS(1355),
    [sym_comment] = ACTIONS(73),
  },
  [305] = {
    [anon_sym_in] = ACTIONS(1357),
    [sym_comment] = ACTIONS(73),
  },
  [306] = {
    [sym__primary_expression] = STATE(708),
    [sym_binary_operator] = STATE(708),
    [sym_unary_operator] = STATE(708),
    [sym_attribute] = STATE(708),
    [sym_subscript] = STATE(708),
    [sym_call] = STATE(708),
    [sym_list] = STATE(708),
    [sym_list_comprehension] = STATE(708),
    [sym_dictionary] = STATE(708),
    [sym_dictionary_comprehension] = STATE(708),
    [sym_set] = STATE(708),
    [sym_set_comprehension] = STATE(708),
    [sym_parenthesized_expression] = STATE(708),
    [sym_tuple] = STATE(708),
    [sym_generator_expression] = STATE(708),
    [sym_concatenated_string] = STATE(708),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1361),
    [sym_float] = ACTIONS(1361),
    [sym_identifier] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_none] = ACTIONS(1361),
    [sym_comment] = ACTIONS(73),
  },
  [307] = {
    [sym__primary_expression] = STATE(709),
    [sym_binary_operator] = STATE(709),
    [sym_unary_operator] = STATE(709),
    [sym_attribute] = STATE(709),
    [sym_subscript] = STATE(709),
    [sym_call] = STATE(709),
    [sym_list] = STATE(709),
    [sym_list_comprehension] = STATE(709),
    [sym_dictionary] = STATE(709),
    [sym_dictionary_comprehension] = STATE(709),
    [sym_set] = STATE(709),
    [sym_set_comprehension] = STATE(709),
    [sym_parenthesized_expression] = STATE(709),
    [sym_tuple] = STATE(709),
    [sym_generator_expression] = STATE(709),
    [sym_concatenated_string] = STATE(709),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1363),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1365),
    [sym_float] = ACTIONS(1365),
    [sym_identifier] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_none] = ACTIONS(1365),
    [sym_comment] = ACTIONS(73),
  },
  [308] = {
    [sym__primary_expression] = STATE(710),
    [sym_binary_operator] = STATE(710),
    [sym_unary_operator] = STATE(710),
    [sym_attribute] = STATE(710),
    [sym_subscript] = STATE(710),
    [sym_call] = STATE(710),
    [sym_list] = STATE(710),
    [sym_list_comprehension] = STATE(710),
    [sym_dictionary] = STATE(710),
    [sym_dictionary_comprehension] = STATE(710),
    [sym_set] = STATE(710),
    [sym_set_comprehension] = STATE(710),
    [sym_parenthesized_expression] = STATE(710),
    [sym_tuple] = STATE(710),
    [sym_generator_expression] = STATE(710),
    [sym_concatenated_string] = STATE(710),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1369),
    [sym_float] = ACTIONS(1369),
    [sym_identifier] = ACTIONS(1369),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [sym_none] = ACTIONS(1369),
    [sym_comment] = ACTIONS(73),
  },
  [309] = {
    [sym__primary_expression] = STATE(711),
    [sym_binary_operator] = STATE(711),
    [sym_unary_operator] = STATE(711),
    [sym_attribute] = STATE(711),
    [sym_subscript] = STATE(711),
    [sym_call] = STATE(711),
    [sym_list] = STATE(711),
    [sym_list_comprehension] = STATE(711),
    [sym_dictionary] = STATE(711),
    [sym_dictionary_comprehension] = STATE(711),
    [sym_set] = STATE(711),
    [sym_set_comprehension] = STATE(711),
    [sym_parenthesized_expression] = STATE(711),
    [sym_tuple] = STATE(711),
    [sym_generator_expression] = STATE(711),
    [sym_concatenated_string] = STATE(711),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1373),
    [sym_float] = ACTIONS(1373),
    [sym_identifier] = ACTIONS(1373),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [sym_none] = ACTIONS(1373),
    [sym_comment] = ACTIONS(73),
  },
  [310] = {
    [sym__primary_expression] = STATE(712),
    [sym_binary_operator] = STATE(712),
    [sym_unary_operator] = STATE(712),
    [sym_attribute] = STATE(712),
    [sym_subscript] = STATE(712),
    [sym_call] = STATE(712),
    [sym_list] = STATE(712),
    [sym_list_comprehension] = STATE(712),
    [sym_dictionary] = STATE(712),
    [sym_dictionary_comprehension] = STATE(712),
    [sym_set] = STATE(712),
    [sym_set_comprehension] = STATE(712),
    [sym_parenthesized_expression] = STATE(712),
    [sym_tuple] = STATE(712),
    [sym_generator_expression] = STATE(712),
    [sym_concatenated_string] = STATE(712),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1377),
    [sym_float] = ACTIONS(1377),
    [sym_identifier] = ACTIONS(1377),
    [sym_true] = ACTIONS(1377),
    [sym_false] = ACTIONS(1377),
    [sym_none] = ACTIONS(1377),
    [sym_comment] = ACTIONS(73),
  },
  [311] = {
    [sym__primary_expression] = STATE(706),
    [sym_binary_operator] = STATE(706),
    [sym_unary_operator] = STATE(706),
    [sym_attribute] = STATE(706),
    [sym_subscript] = STATE(706),
    [sym_call] = STATE(706),
    [sym_list] = STATE(706),
    [sym_list_comprehension] = STATE(706),
    [sym_dictionary] = STATE(706),
    [sym_dictionary_comprehension] = STATE(706),
    [sym_set] = STATE(706),
    [sym_set_comprehension] = STATE(706),
    [sym_parenthesized_expression] = STATE(706),
    [sym_tuple] = STATE(706),
    [sym_generator_expression] = STATE(706),
    [sym_concatenated_string] = STATE(706),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1355),
    [sym_float] = ACTIONS(1355),
    [sym_identifier] = ACTIONS(1355),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [sym_none] = ACTIONS(1355),
    [sym_comment] = ACTIONS(73),
  },
  [312] = {
    [sym__expression] = STATE(713),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(713),
    [sym_boolean_operator] = STATE(713),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(713),
    [sym_lambda] = STATE(713),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_slice] = STATE(714),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(713),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(713),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [313] = {
    [sym__newline] = ACTIONS(995),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_from] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(995),
  },
  [314] = {
    [aux_sym_comparison_operator_repeat1] = STATE(715),
    [sym__newline] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_not] = ACTIONS(525),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(537),
    [anon_sym_LT_GT] = ACTIONS(521),
    [anon_sym_is] = ACTIONS(539),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(999),
  },
  [315] = {
    [sym_string] = STATE(716),
    [aux_sym_concatenated_string_repeat1] = STATE(716),
    [sym__newline] = ACTIONS(1003),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1003),
  },
  [316] = {
    [sym__expression] = STATE(694),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(694),
    [sym_boolean_operator] = STATE(694),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(694),
    [sym_lambda] = STATE(694),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(694),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(694),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [317] = {
    [aux_sym_print_statement_repeat1] = STATE(696),
    [sym__newline] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(545),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1381),
  },
  [318] = {
    [sym__expression] = STATE(694),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(694),
    [sym_boolean_operator] = STATE(694),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(694),
    [sym_lambda] = STATE(694),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(694),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(694),
    [sym__newline] = ACTIONS(915),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(915),
  },
  [319] = {
    [aux_sym_print_statement_repeat1] = STATE(696),
    [sym__newline] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1383),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(915),
  },
  [320] = {
    [sym__expression] = STATE(718),
    [sym__primary_expression] = STATE(325),
    [sym_not_operator] = STATE(718),
    [sym_boolean_operator] = STATE(718),
    [sym_binary_operator] = STATE(325),
    [sym_unary_operator] = STATE(325),
    [sym_comparison_operator] = STATE(718),
    [sym_lambda] = STATE(718),
    [sym_attribute] = STATE(325),
    [sym_subscript] = STATE(325),
    [sym_call] = STATE(325),
    [sym_list] = STATE(325),
    [sym_list_comprehension] = STATE(325),
    [sym_dictionary] = STATE(325),
    [sym_dictionary_comprehension] = STATE(325),
    [sym_set] = STATE(325),
    [sym_set_comprehension] = STATE(325),
    [sym_parenthesized_expression] = STATE(325),
    [sym_tuple] = STATE(325),
    [sym_generator_expression] = STATE(325),
    [sym_conditional_expression] = STATE(718),
    [sym_concatenated_string] = STATE(325),
    [sym_string] = STATE(326),
    [sym_await] = STATE(718),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_lambda] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(561),
    [sym_float] = ACTIONS(561),
    [sym_identifier] = ACTIONS(561),
    [sym_true] = ACTIONS(561),
    [sym_false] = ACTIONS(561),
    [sym_none] = ACTIONS(561),
    [anon_sym_await] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
  },
  [321] = {
    [sym__primary_expression] = STATE(282),
    [sym_binary_operator] = STATE(282),
    [sym_unary_operator] = STATE(282),
    [sym_attribute] = STATE(282),
    [sym_subscript] = STATE(282),
    [sym_call] = STATE(282),
    [sym_list] = STATE(282),
    [sym_list_comprehension] = STATE(282),
    [sym_dictionary] = STATE(282),
    [sym_dictionary_comprehension] = STATE(282),
    [sym_set] = STATE(282),
    [sym_set_comprehension] = STATE(282),
    [sym_parenthesized_expression] = STATE(282),
    [sym_tuple] = STATE(282),
    [sym_generator_expression] = STATE(282),
    [sym_concatenated_string] = STATE(282),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(489),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(491),
    [sym_float] = ACTIONS(491),
    [sym_identifier] = ACTIONS(491),
    [sym_true] = ACTIONS(491),
    [sym_false] = ACTIONS(491),
    [sym_none] = ACTIONS(491),
    [sym_comment] = ACTIONS(73),
  },
  [322] = {
    [sym_lambda_parameters] = STATE(720),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1385),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [323] = {
    [sym__expression] = STATE(166),
    [sym__primary_expression] = STATE(325),
    [sym_not_operator] = STATE(166),
    [sym_boolean_operator] = STATE(166),
    [sym_binary_operator] = STATE(325),
    [sym_unary_operator] = STATE(325),
    [sym_comparison_operator] = STATE(166),
    [sym_lambda] = STATE(166),
    [sym_attribute] = STATE(325),
    [sym_subscript] = STATE(325),
    [sym_call] = STATE(325),
    [sym_list] = STATE(325),
    [sym_list_comprehension] = STATE(325),
    [sym_dictionary] = STATE(325),
    [sym_dictionary_comprehension] = STATE(325),
    [sym_set] = STATE(325),
    [sym_set_comprehension] = STATE(325),
    [sym_parenthesized_expression] = STATE(325),
    [sym_tuple] = STATE(325),
    [sym_generator_expression] = STATE(325),
    [sym_conditional_expression] = STATE(166),
    [sym_concatenated_string] = STATE(325),
    [sym_string] = STATE(326),
    [sym_await] = STATE(166),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_lambda] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(561),
    [sym_float] = ACTIONS(561),
    [sym_identifier] = ACTIONS(561),
    [sym_true] = ACTIONS(561),
    [sym_false] = ACTIONS(561),
    [sym_none] = ACTIONS(561),
    [anon_sym_await] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
  },
  [324] = {
    [sym__newline] = ACTIONS(1387),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_and] = ACTIONS(1391),
    [anon_sym_or] = ACTIONS(1393),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1387),
  },
  [325] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [aux_sym_comparison_operator_repeat1] = STATE(734),
    [sym__newline] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1399),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_SLASH_SLASH] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_LT_EQ] = ACTIONS(1399),
    [anon_sym_EQ_EQ] = ACTIONS(1399),
    [anon_sym_BANG_EQ] = ACTIONS(1399),
    [anon_sym_GT_EQ] = ACTIONS(1399),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_LT_GT] = ACTIONS(1399),
    [anon_sym_is] = ACTIONS(1417),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(301),
  },
  [326] = {
    [sym_string] = STATE(735),
    [aux_sym_concatenated_string_repeat1] = STATE(735),
    [sym__newline] = ACTIONS(333),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(333),
  },
  [327] = {
    [sym__newline] = ACTIONS(731),
    [anon_sym_from] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(577),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(731),
  },
  [328] = {
    [sym__expression] = STATE(736),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(736),
    [sym_boolean_operator] = STATE(736),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(736),
    [sym_lambda] = STATE(736),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(736),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(736),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [329] = {
    [anon_sym_COLON] = ACTIONS(1419),
    [sym_comment] = ACTIONS(73),
  },
  [330] = {
    [sym__expression] = STATE(738),
    [sym__primary_expression] = STATE(325),
    [sym_not_operator] = STATE(738),
    [sym_boolean_operator] = STATE(738),
    [sym_binary_operator] = STATE(325),
    [sym_unary_operator] = STATE(325),
    [sym_comparison_operator] = STATE(738),
    [sym_lambda] = STATE(738),
    [sym_attribute] = STATE(325),
    [sym_subscript] = STATE(325),
    [sym_call] = STATE(325),
    [sym_list] = STATE(325),
    [sym_list_comprehension] = STATE(325),
    [sym_dictionary] = STATE(325),
    [sym_dictionary_comprehension] = STATE(325),
    [sym_set] = STATE(325),
    [sym_set_comprehension] = STATE(325),
    [sym_parenthesized_expression] = STATE(325),
    [sym_tuple] = STATE(325),
    [sym_generator_expression] = STATE(325),
    [sym_conditional_expression] = STATE(738),
    [sym_concatenated_string] = STATE(325),
    [sym_string] = STATE(326),
    [sym_await] = STATE(738),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_lambda] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(561),
    [sym_float] = ACTIONS(561),
    [sym_identifier] = ACTIONS(561),
    [sym_true] = ACTIONS(561),
    [sym_false] = ACTIONS(561),
    [sym_none] = ACTIONS(561),
    [anon_sym_await] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
  },
  [331] = {
    [sym__expression] = STATE(739),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(739),
    [sym_boolean_operator] = STATE(739),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(739),
    [sym_lambda] = STATE(739),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(739),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(739),
    [sym__newline] = ACTIONS(915),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(915),
  },
  [332] = {
    [sym__expression] = STATE(740),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(740),
    [sym_boolean_operator] = STATE(740),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(740),
    [sym_lambda] = STATE(740),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(740),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(740),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [333] = {
    [sym__expression] = STATE(538),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(538),
    [sym_boolean_operator] = STATE(538),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(538),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(538),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [334] = {
    [sym__expression] = STATE(741),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(741),
    [sym_boolean_operator] = STATE(741),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(741),
    [sym_lambda] = STATE(741),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(741),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(741),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [335] = {
    [aux_sym_print_statement_repeat1] = STATE(743),
    [sym__newline] = ACTIONS(915),
    [anon_sym_from] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1423),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(915),
  },
  [336] = {
    [sym__primary_expression] = STATE(744),
    [sym_binary_operator] = STATE(744),
    [sym_unary_operator] = STATE(744),
    [sym_attribute] = STATE(744),
    [sym_subscript] = STATE(744),
    [sym_call] = STATE(744),
    [sym_list] = STATE(744),
    [sym_list_comprehension] = STATE(744),
    [sym_dictionary] = STATE(744),
    [sym_dictionary_comprehension] = STATE(744),
    [sym_set] = STATE(744),
    [sym_set_comprehension] = STATE(744),
    [sym_parenthesized_expression] = STATE(744),
    [sym_tuple] = STATE(744),
    [sym_generator_expression] = STATE(744),
    [sym_concatenated_string] = STATE(744),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1427),
    [sym_float] = ACTIONS(1427),
    [sym_identifier] = ACTIONS(1427),
    [sym_true] = ACTIONS(1427),
    [sym_false] = ACTIONS(1427),
    [sym_none] = ACTIONS(1427),
    [sym_comment] = ACTIONS(73),
  },
  [337] = {
    [sym__primary_expression] = STATE(745),
    [sym_binary_operator] = STATE(745),
    [sym_unary_operator] = STATE(745),
    [sym_attribute] = STATE(745),
    [sym_subscript] = STATE(745),
    [sym_call] = STATE(745),
    [sym_list] = STATE(745),
    [sym_list_comprehension] = STATE(745),
    [sym_dictionary] = STATE(745),
    [sym_dictionary_comprehension] = STATE(745),
    [sym_set] = STATE(745),
    [sym_set_comprehension] = STATE(745),
    [sym_parenthesized_expression] = STATE(745),
    [sym_tuple] = STATE(745),
    [sym_generator_expression] = STATE(745),
    [sym_concatenated_string] = STATE(745),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1431),
    [sym_float] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1431),
    [sym_true] = ACTIONS(1431),
    [sym_false] = ACTIONS(1431),
    [sym_none] = ACTIONS(1431),
    [sym_comment] = ACTIONS(73),
  },
  [338] = {
    [sym__primary_expression] = STATE(746),
    [sym_binary_operator] = STATE(746),
    [sym_unary_operator] = STATE(746),
    [sym_attribute] = STATE(746),
    [sym_subscript] = STATE(746),
    [sym_call] = STATE(746),
    [sym_list] = STATE(746),
    [sym_list_comprehension] = STATE(746),
    [sym_dictionary] = STATE(746),
    [sym_dictionary_comprehension] = STATE(746),
    [sym_set] = STATE(746),
    [sym_set_comprehension] = STATE(746),
    [sym_parenthesized_expression] = STATE(746),
    [sym_tuple] = STATE(746),
    [sym_generator_expression] = STATE(746),
    [sym_concatenated_string] = STATE(746),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1435),
    [sym_float] = ACTIONS(1435),
    [sym_identifier] = ACTIONS(1435),
    [sym_true] = ACTIONS(1435),
    [sym_false] = ACTIONS(1435),
    [sym_none] = ACTIONS(1435),
    [sym_comment] = ACTIONS(73),
  },
  [339] = {
    [anon_sym_in] = ACTIONS(1437),
    [sym_comment] = ACTIONS(73),
  },
  [340] = {
    [sym__primary_expression] = STATE(748),
    [sym_binary_operator] = STATE(748),
    [sym_unary_operator] = STATE(748),
    [sym_attribute] = STATE(748),
    [sym_subscript] = STATE(748),
    [sym_call] = STATE(748),
    [sym_list] = STATE(748),
    [sym_list_comprehension] = STATE(748),
    [sym_dictionary] = STATE(748),
    [sym_dictionary_comprehension] = STATE(748),
    [sym_set] = STATE(748),
    [sym_set_comprehension] = STATE(748),
    [sym_parenthesized_expression] = STATE(748),
    [sym_tuple] = STATE(748),
    [sym_generator_expression] = STATE(748),
    [sym_concatenated_string] = STATE(748),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1439),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1441),
    [sym_float] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1441),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_none] = ACTIONS(1441),
    [sym_comment] = ACTIONS(73),
  },
  [341] = {
    [sym__primary_expression] = STATE(709),
    [sym_binary_operator] = STATE(709),
    [sym_unary_operator] = STATE(709),
    [sym_attribute] = STATE(709),
    [sym_subscript] = STATE(709),
    [sym_call] = STATE(709),
    [sym_list] = STATE(709),
    [sym_list_comprehension] = STATE(709),
    [sym_dictionary] = STATE(709),
    [sym_dictionary_comprehension] = STATE(709),
    [sym_set] = STATE(709),
    [sym_set_comprehension] = STATE(709),
    [sym_parenthesized_expression] = STATE(709),
    [sym_tuple] = STATE(709),
    [sym_generator_expression] = STATE(709),
    [sym_concatenated_string] = STATE(709),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1363),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1365),
    [sym_float] = ACTIONS(1365),
    [sym_identifier] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_none] = ACTIONS(1365),
    [sym_comment] = ACTIONS(73),
  },
  [342] = {
    [sym__primary_expression] = STATE(749),
    [sym_binary_operator] = STATE(749),
    [sym_unary_operator] = STATE(749),
    [sym_attribute] = STATE(749),
    [sym_subscript] = STATE(749),
    [sym_call] = STATE(749),
    [sym_list] = STATE(749),
    [sym_list_comprehension] = STATE(749),
    [sym_dictionary] = STATE(749),
    [sym_dictionary_comprehension] = STATE(749),
    [sym_set] = STATE(749),
    [sym_set_comprehension] = STATE(749),
    [sym_parenthesized_expression] = STATE(749),
    [sym_tuple] = STATE(749),
    [sym_generator_expression] = STATE(749),
    [sym_concatenated_string] = STATE(749),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1445),
    [sym_float] = ACTIONS(1445),
    [sym_identifier] = ACTIONS(1445),
    [sym_true] = ACTIONS(1445),
    [sym_false] = ACTIONS(1445),
    [sym_none] = ACTIONS(1445),
    [sym_comment] = ACTIONS(73),
  },
  [343] = {
    [sym__primary_expression] = STATE(750),
    [sym_binary_operator] = STATE(750),
    [sym_unary_operator] = STATE(750),
    [sym_attribute] = STATE(750),
    [sym_subscript] = STATE(750),
    [sym_call] = STATE(750),
    [sym_list] = STATE(750),
    [sym_list_comprehension] = STATE(750),
    [sym_dictionary] = STATE(750),
    [sym_dictionary_comprehension] = STATE(750),
    [sym_set] = STATE(750),
    [sym_set_comprehension] = STATE(750),
    [sym_parenthesized_expression] = STATE(750),
    [sym_tuple] = STATE(750),
    [sym_generator_expression] = STATE(750),
    [sym_concatenated_string] = STATE(750),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1449),
    [sym_float] = ACTIONS(1449),
    [sym_identifier] = ACTIONS(1449),
    [sym_true] = ACTIONS(1449),
    [sym_false] = ACTIONS(1449),
    [sym_none] = ACTIONS(1449),
    [sym_comment] = ACTIONS(73),
  },
  [344] = {
    [sym__primary_expression] = STATE(751),
    [sym_binary_operator] = STATE(751),
    [sym_unary_operator] = STATE(751),
    [sym_attribute] = STATE(751),
    [sym_subscript] = STATE(751),
    [sym_call] = STATE(751),
    [sym_list] = STATE(751),
    [sym_list_comprehension] = STATE(751),
    [sym_dictionary] = STATE(751),
    [sym_dictionary_comprehension] = STATE(751),
    [sym_set] = STATE(751),
    [sym_set_comprehension] = STATE(751),
    [sym_parenthesized_expression] = STATE(751),
    [sym_tuple] = STATE(751),
    [sym_generator_expression] = STATE(751),
    [sym_concatenated_string] = STATE(751),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1453),
    [sym_float] = ACTIONS(1453),
    [sym_identifier] = ACTIONS(1453),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_none] = ACTIONS(1453),
    [sym_comment] = ACTIONS(73),
  },
  [345] = {
    [sym__primary_expression] = STATE(746),
    [sym_binary_operator] = STATE(746),
    [sym_unary_operator] = STATE(746),
    [sym_attribute] = STATE(746),
    [sym_subscript] = STATE(746),
    [sym_call] = STATE(746),
    [sym_list] = STATE(746),
    [sym_list_comprehension] = STATE(746),
    [sym_dictionary] = STATE(746),
    [sym_dictionary_comprehension] = STATE(746),
    [sym_set] = STATE(746),
    [sym_set_comprehension] = STATE(746),
    [sym_parenthesized_expression] = STATE(746),
    [sym_tuple] = STATE(746),
    [sym_generator_expression] = STATE(746),
    [sym_concatenated_string] = STATE(746),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1435),
    [sym_float] = ACTIONS(1435),
    [sym_identifier] = ACTIONS(1435),
    [sym_true] = ACTIONS(1435),
    [sym_false] = ACTIONS(1435),
    [sym_none] = ACTIONS(1435),
    [sym_comment] = ACTIONS(73),
  },
  [346] = {
    [aux_sym_comparison_operator_repeat1] = STATE(752),
    [sym__newline] = ACTIONS(999),
    [anon_sym_from] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(587),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(599),
    [anon_sym_LT_EQ] = ACTIONS(583),
    [anon_sym_EQ_EQ] = ACTIONS(583),
    [anon_sym_BANG_EQ] = ACTIONS(583),
    [anon_sym_GT_EQ] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(599),
    [anon_sym_LT_GT] = ACTIONS(583),
    [anon_sym_is] = ACTIONS(601),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(999),
  },
  [347] = {
    [sym_string] = STATE(753),
    [aux_sym_concatenated_string_repeat1] = STATE(753),
    [sym__newline] = ACTIONS(1003),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_from] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1003),
  },
  [348] = {
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [349] = {
    [sym__expression] = STATE(754),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(754),
    [sym_boolean_operator] = STATE(754),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(754),
    [sym_lambda] = STATE(754),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(754),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(754),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [350] = {
    [anon_sym_COLON] = ACTIONS(1457),
    [sym_comment] = ACTIONS(73),
  },
  [351] = {
    [sym__expression] = STATE(756),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(756),
    [sym_boolean_operator] = STATE(756),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(756),
    [sym_lambda] = STATE(756),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(756),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(756),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [352] = {
    [sym__simple_statements] = STATE(758),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(758),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [353] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [354] = {
    [sym__expression] = STATE(759),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(759),
    [sym_boolean_operator] = STATE(759),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(759),
    [sym_lambda] = STATE(759),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(759),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(759),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [355] = {
    [sym__primary_expression] = STATE(760),
    [sym_binary_operator] = STATE(760),
    [sym_unary_operator] = STATE(760),
    [sym_attribute] = STATE(760),
    [sym_subscript] = STATE(760),
    [sym_call] = STATE(760),
    [sym_list] = STATE(760),
    [sym_list_comprehension] = STATE(760),
    [sym_dictionary] = STATE(760),
    [sym_dictionary_comprehension] = STATE(760),
    [sym_set] = STATE(760),
    [sym_set_comprehension] = STATE(760),
    [sym_parenthesized_expression] = STATE(760),
    [sym_tuple] = STATE(760),
    [sym_generator_expression] = STATE(760),
    [sym_concatenated_string] = STATE(760),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1463),
    [sym_float] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1463),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_none] = ACTIONS(1463),
    [sym_comment] = ACTIONS(73),
  },
  [356] = {
    [sym__primary_expression] = STATE(761),
    [sym_binary_operator] = STATE(761),
    [sym_unary_operator] = STATE(761),
    [sym_attribute] = STATE(761),
    [sym_subscript] = STATE(761),
    [sym_call] = STATE(761),
    [sym_list] = STATE(761),
    [sym_list_comprehension] = STATE(761),
    [sym_dictionary] = STATE(761),
    [sym_dictionary_comprehension] = STATE(761),
    [sym_set] = STATE(761),
    [sym_set_comprehension] = STATE(761),
    [sym_parenthesized_expression] = STATE(761),
    [sym_tuple] = STATE(761),
    [sym_generator_expression] = STATE(761),
    [sym_concatenated_string] = STATE(761),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1467),
    [sym_float] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1467),
    [sym_true] = ACTIONS(1467),
    [sym_false] = ACTIONS(1467),
    [sym_none] = ACTIONS(1467),
    [sym_comment] = ACTIONS(73),
  },
  [357] = {
    [sym__primary_expression] = STATE(762),
    [sym_binary_operator] = STATE(762),
    [sym_unary_operator] = STATE(762),
    [sym_attribute] = STATE(762),
    [sym_subscript] = STATE(762),
    [sym_call] = STATE(762),
    [sym_list] = STATE(762),
    [sym_list_comprehension] = STATE(762),
    [sym_dictionary] = STATE(762),
    [sym_dictionary_comprehension] = STATE(762),
    [sym_set] = STATE(762),
    [sym_set_comprehension] = STATE(762),
    [sym_parenthesized_expression] = STATE(762),
    [sym_tuple] = STATE(762),
    [sym_generator_expression] = STATE(762),
    [sym_concatenated_string] = STATE(762),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1471),
    [sym_float] = ACTIONS(1471),
    [sym_identifier] = ACTIONS(1471),
    [sym_true] = ACTIONS(1471),
    [sym_false] = ACTIONS(1471),
    [sym_none] = ACTIONS(1471),
    [sym_comment] = ACTIONS(73),
  },
  [358] = {
    [anon_sym_in] = ACTIONS(1473),
    [sym_comment] = ACTIONS(73),
  },
  [359] = {
    [sym__primary_expression] = STATE(764),
    [sym_binary_operator] = STATE(764),
    [sym_unary_operator] = STATE(764),
    [sym_attribute] = STATE(764),
    [sym_subscript] = STATE(764),
    [sym_call] = STATE(764),
    [sym_list] = STATE(764),
    [sym_list_comprehension] = STATE(764),
    [sym_dictionary] = STATE(764),
    [sym_dictionary_comprehension] = STATE(764),
    [sym_set] = STATE(764),
    [sym_set_comprehension] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_tuple] = STATE(764),
    [sym_generator_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1477),
    [sym_float] = ACTIONS(1477),
    [sym_identifier] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_none] = ACTIONS(1477),
    [sym_comment] = ACTIONS(73),
  },
  [360] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [361] = {
    [sym__primary_expression] = STATE(765),
    [sym_binary_operator] = STATE(765),
    [sym_unary_operator] = STATE(765),
    [sym_attribute] = STATE(765),
    [sym_subscript] = STATE(765),
    [sym_call] = STATE(765),
    [sym_list] = STATE(765),
    [sym_list_comprehension] = STATE(765),
    [sym_dictionary] = STATE(765),
    [sym_dictionary_comprehension] = STATE(765),
    [sym_set] = STATE(765),
    [sym_set_comprehension] = STATE(765),
    [sym_parenthesized_expression] = STATE(765),
    [sym_tuple] = STATE(765),
    [sym_generator_expression] = STATE(765),
    [sym_concatenated_string] = STATE(765),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1481),
    [sym_float] = ACTIONS(1481),
    [sym_identifier] = ACTIONS(1481),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [sym_none] = ACTIONS(1481),
    [sym_comment] = ACTIONS(73),
  },
  [362] = {
    [sym__primary_expression] = STATE(766),
    [sym_binary_operator] = STATE(766),
    [sym_unary_operator] = STATE(766),
    [sym_attribute] = STATE(766),
    [sym_subscript] = STATE(766),
    [sym_call] = STATE(766),
    [sym_list] = STATE(766),
    [sym_list_comprehension] = STATE(766),
    [sym_dictionary] = STATE(766),
    [sym_dictionary_comprehension] = STATE(766),
    [sym_set] = STATE(766),
    [sym_set_comprehension] = STATE(766),
    [sym_parenthesized_expression] = STATE(766),
    [sym_tuple] = STATE(766),
    [sym_generator_expression] = STATE(766),
    [sym_concatenated_string] = STATE(766),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1485),
    [sym_float] = ACTIONS(1485),
    [sym_identifier] = ACTIONS(1485),
    [sym_true] = ACTIONS(1485),
    [sym_false] = ACTIONS(1485),
    [sym_none] = ACTIONS(1485),
    [sym_comment] = ACTIONS(73),
  },
  [363] = {
    [sym__primary_expression] = STATE(767),
    [sym_binary_operator] = STATE(767),
    [sym_unary_operator] = STATE(767),
    [sym_attribute] = STATE(767),
    [sym_subscript] = STATE(767),
    [sym_call] = STATE(767),
    [sym_list] = STATE(767),
    [sym_list_comprehension] = STATE(767),
    [sym_dictionary] = STATE(767),
    [sym_dictionary_comprehension] = STATE(767),
    [sym_set] = STATE(767),
    [sym_set_comprehension] = STATE(767),
    [sym_parenthesized_expression] = STATE(767),
    [sym_tuple] = STATE(767),
    [sym_generator_expression] = STATE(767),
    [sym_concatenated_string] = STATE(767),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1489),
    [sym_float] = ACTIONS(1489),
    [sym_identifier] = ACTIONS(1489),
    [sym_true] = ACTIONS(1489),
    [sym_false] = ACTIONS(1489),
    [sym_none] = ACTIONS(1489),
    [sym_comment] = ACTIONS(73),
  },
  [364] = {
    [sym__primary_expression] = STATE(762),
    [sym_binary_operator] = STATE(762),
    [sym_unary_operator] = STATE(762),
    [sym_attribute] = STATE(762),
    [sym_subscript] = STATE(762),
    [sym_call] = STATE(762),
    [sym_list] = STATE(762),
    [sym_list_comprehension] = STATE(762),
    [sym_dictionary] = STATE(762),
    [sym_dictionary_comprehension] = STATE(762),
    [sym_set] = STATE(762),
    [sym_set_comprehension] = STATE(762),
    [sym_parenthesized_expression] = STATE(762),
    [sym_tuple] = STATE(762),
    [sym_generator_expression] = STATE(762),
    [sym_concatenated_string] = STATE(762),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1471),
    [sym_float] = ACTIONS(1471),
    [sym_identifier] = ACTIONS(1471),
    [sym_true] = ACTIONS(1471),
    [sym_false] = ACTIONS(1471),
    [sym_none] = ACTIONS(1471),
    [sym_comment] = ACTIONS(73),
  },
  [365] = {
    [aux_sym_comparison_operator_repeat1] = STATE(768),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(617),
    [anon_sym_not] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_LT_EQ] = ACTIONS(617),
    [anon_sym_EQ_EQ] = ACTIONS(617),
    [anon_sym_BANG_EQ] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(633),
    [anon_sym_LT_GT] = ACTIONS(617),
    [anon_sym_is] = ACTIONS(635),
    [sym_comment] = ACTIONS(73),
  },
  [366] = {
    [sym_string] = STATE(769),
    [aux_sym_concatenated_string_repeat1] = STATE(769),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_COLON] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [367] = {
    [anon_sym_in] = ACTIONS(1493),
    [sym_comment] = ACTIONS(73),
  },
  [368] = {
    [aux_sym_with_statement_repeat1] = STATE(772),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(1495),
    [sym_comment] = ACTIONS(73),
  },
  [369] = {
    [sym_parameters] = STATE(773),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym_comment] = ACTIONS(73),
  },
  [370] = {
    [sym_expression_list] = STATE(774),
    [sym__expression] = STATE(775),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(775),
    [sym_boolean_operator] = STATE(775),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(775),
    [sym_lambda] = STATE(775),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(775),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(775),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [371] = {
    [sym__primary_expression] = STATE(776),
    [sym_binary_operator] = STATE(776),
    [sym_unary_operator] = STATE(776),
    [sym_attribute] = STATE(776),
    [sym_subscript] = STATE(776),
    [sym_call] = STATE(776),
    [sym_list] = STATE(776),
    [sym_list_comprehension] = STATE(776),
    [sym_dictionary] = STATE(776),
    [sym_dictionary_comprehension] = STATE(776),
    [sym_set] = STATE(776),
    [sym_set_comprehension] = STATE(776),
    [sym_parenthesized_expression] = STATE(776),
    [sym_tuple] = STATE(776),
    [sym_generator_expression] = STATE(776),
    [sym_concatenated_string] = STATE(776),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_in] = ACTIONS(1497),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1501),
    [sym_float] = ACTIONS(1501),
    [sym_identifier] = ACTIONS(1501),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [sym_none] = ACTIONS(1501),
    [sym_comment] = ACTIONS(73),
  },
  [372] = {
    [sym__primary_expression] = STATE(777),
    [sym_binary_operator] = STATE(777),
    [sym_unary_operator] = STATE(777),
    [sym_attribute] = STATE(777),
    [sym_subscript] = STATE(777),
    [sym_call] = STATE(777),
    [sym_list] = STATE(777),
    [sym_list_comprehension] = STATE(777),
    [sym_dictionary] = STATE(777),
    [sym_dictionary_comprehension] = STATE(777),
    [sym_set] = STATE(777),
    [sym_set_comprehension] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_tuple] = STATE(777),
    [sym_generator_expression] = STATE(777),
    [sym_concatenated_string] = STATE(777),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1505),
    [sym_float] = ACTIONS(1505),
    [sym_identifier] = ACTIONS(1505),
    [sym_true] = ACTIONS(1505),
    [sym_false] = ACTIONS(1505),
    [sym_none] = ACTIONS(1505),
    [sym_comment] = ACTIONS(73),
  },
  [373] = {
    [sym__primary_expression] = STATE(778),
    [sym_binary_operator] = STATE(778),
    [sym_unary_operator] = STATE(778),
    [sym_attribute] = STATE(778),
    [sym_subscript] = STATE(778),
    [sym_call] = STATE(778),
    [sym_list] = STATE(778),
    [sym_list_comprehension] = STATE(778),
    [sym_dictionary] = STATE(778),
    [sym_dictionary_comprehension] = STATE(778),
    [sym_set] = STATE(778),
    [sym_set_comprehension] = STATE(778),
    [sym_parenthesized_expression] = STATE(778),
    [sym_tuple] = STATE(778),
    [sym_generator_expression] = STATE(778),
    [sym_concatenated_string] = STATE(778),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1509),
    [sym_float] = ACTIONS(1509),
    [sym_identifier] = ACTIONS(1509),
    [sym_true] = ACTIONS(1509),
    [sym_false] = ACTIONS(1509),
    [sym_none] = ACTIONS(1509),
    [sym_comment] = ACTIONS(73),
  },
  [374] = {
    [sym__primary_expression] = STATE(779),
    [sym_binary_operator] = STATE(779),
    [sym_unary_operator] = STATE(779),
    [sym_attribute] = STATE(779),
    [sym_subscript] = STATE(779),
    [sym_call] = STATE(779),
    [sym_list] = STATE(779),
    [sym_list_comprehension] = STATE(779),
    [sym_dictionary] = STATE(779),
    [sym_dictionary_comprehension] = STATE(779),
    [sym_set] = STATE(779),
    [sym_set_comprehension] = STATE(779),
    [sym_parenthesized_expression] = STATE(779),
    [sym_tuple] = STATE(779),
    [sym_generator_expression] = STATE(779),
    [sym_concatenated_string] = STATE(779),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1513),
    [sym_float] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1513),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [sym_none] = ACTIONS(1513),
    [sym_comment] = ACTIONS(73),
  },
  [375] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [376] = {
    [sym__primary_expression] = STATE(780),
    [sym_binary_operator] = STATE(780),
    [sym_unary_operator] = STATE(780),
    [sym_attribute] = STATE(780),
    [sym_subscript] = STATE(780),
    [sym_call] = STATE(780),
    [sym_list] = STATE(780),
    [sym_list_comprehension] = STATE(780),
    [sym_dictionary] = STATE(780),
    [sym_dictionary_comprehension] = STATE(780),
    [sym_set] = STATE(780),
    [sym_set_comprehension] = STATE(780),
    [sym_parenthesized_expression] = STATE(780),
    [sym_tuple] = STATE(780),
    [sym_generator_expression] = STATE(780),
    [sym_concatenated_string] = STATE(780),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1517),
    [sym_float] = ACTIONS(1517),
    [sym_identifier] = ACTIONS(1517),
    [sym_true] = ACTIONS(1517),
    [sym_false] = ACTIONS(1517),
    [sym_none] = ACTIONS(1517),
    [sym_comment] = ACTIONS(73),
  },
  [377] = {
    [sym__primary_expression] = STATE(781),
    [sym_binary_operator] = STATE(781),
    [sym_unary_operator] = STATE(781),
    [sym_attribute] = STATE(781),
    [sym_subscript] = STATE(781),
    [sym_call] = STATE(781),
    [sym_list] = STATE(781),
    [sym_list_comprehension] = STATE(781),
    [sym_dictionary] = STATE(781),
    [sym_dictionary_comprehension] = STATE(781),
    [sym_set] = STATE(781),
    [sym_set_comprehension] = STATE(781),
    [sym_parenthesized_expression] = STATE(781),
    [sym_tuple] = STATE(781),
    [sym_generator_expression] = STATE(781),
    [sym_concatenated_string] = STATE(781),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1521),
    [sym_float] = ACTIONS(1521),
    [sym_identifier] = ACTIONS(1521),
    [sym_true] = ACTIONS(1521),
    [sym_false] = ACTIONS(1521),
    [sym_none] = ACTIONS(1521),
    [sym_comment] = ACTIONS(73),
  },
  [378] = {
    [sym__primary_expression] = STATE(782),
    [sym_binary_operator] = STATE(782),
    [sym_unary_operator] = STATE(782),
    [sym_attribute] = STATE(782),
    [sym_subscript] = STATE(782),
    [sym_call] = STATE(782),
    [sym_list] = STATE(782),
    [sym_list_comprehension] = STATE(782),
    [sym_dictionary] = STATE(782),
    [sym_dictionary_comprehension] = STATE(782),
    [sym_set] = STATE(782),
    [sym_set_comprehension] = STATE(782),
    [sym_parenthesized_expression] = STATE(782),
    [sym_tuple] = STATE(782),
    [sym_generator_expression] = STATE(782),
    [sym_concatenated_string] = STATE(782),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1525),
    [sym_float] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1525),
    [sym_true] = ACTIONS(1525),
    [sym_false] = ACTIONS(1525),
    [sym_none] = ACTIONS(1525),
    [sym_comment] = ACTIONS(73),
  },
  [379] = {
    [aux_sym_variables_repeat1] = STATE(784),
    [anon_sym_COMMA] = ACTIONS(1527),
    [anon_sym_in] = ACTIONS(1529),
    [sym_comment] = ACTIONS(73),
  },
  [380] = {
    [sym_string] = STATE(785),
    [aux_sym_concatenated_string_repeat1] = STATE(785),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [381] = {
    [sym__simple_statements] = STATE(786),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(786),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [382] = {
    [sym__statement] = STATE(797),
    [sym__simple_statements] = STATE(797),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_if_statement] = STATE(797),
    [sym_for_statement] = STATE(797),
    [sym_while_statement] = STATE(797),
    [sym_try_statement] = STATE(797),
    [sym_with_statement] = STATE(797),
    [sym_function_definition] = STATE(797),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym_class_definition] = STATE(797),
    [sym_decorated_definition] = STATE(797),
    [sym_decorator] = STATE(798),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(797),
    [aux_sym_decorated_definition_repeat1] = STATE(798),
    [sym__dedent] = ACTIONS(1531),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_try] = ACTIONS(1541),
    [anon_sym_with] = ACTIONS(1543),
    [anon_sym_def] = ACTIONS(1545),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [383] = {
    [aux_sym__simple_statements_repeat1] = STATE(801),
    [sym__newline] = ACTIONS(1549),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1551),
  },
  [384] = {
    [sym_except_clause] = STATE(805),
    [sym_finally_clause] = STATE(804),
    [aux_sym_try_statement_repeat1] = STATE(805),
    [anon_sym_except] = ACTIONS(1553),
    [anon_sym_finally] = ACTIONS(1555),
    [sym_comment] = ACTIONS(73),
  },
  [385] = {
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(679),
    [sym_comment] = ACTIONS(73),
  },
  [386] = {
    [sym__expression] = STATE(806),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(806),
    [sym_boolean_operator] = STATE(806),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(806),
    [sym_lambda] = STATE(806),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(806),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(806),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [387] = {
    [anon_sym_COLON] = ACTIONS(1557),
    [sym_comment] = ACTIONS(73),
  },
  [388] = {
    [sym_with_item] = STATE(808),
    [sym__expression] = STATE(117),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(117),
    [sym_boolean_operator] = STATE(117),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(117),
    [sym_lambda] = STATE(117),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(117),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(117),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [389] = {
    [sym__simple_statements] = STATE(809),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(809),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [390] = {
    [aux_sym_with_statement_repeat1] = STATE(810),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(1495),
    [sym_comment] = ACTIONS(73),
  },
  [391] = {
    [sym__expression] = STATE(811),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(811),
    [sym_boolean_operator] = STATE(811),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(811),
    [sym_lambda] = STATE(811),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(811),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(811),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [392] = {
    [sym__expression] = STATE(812),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(812),
    [sym_boolean_operator] = STATE(812),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(812),
    [sym_lambda] = STATE(812),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(812),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(812),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [393] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [394] = {
    [sym__expression] = STATE(813),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(813),
    [sym_boolean_operator] = STATE(813),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(813),
    [sym_lambda] = STATE(813),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(813),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(813),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [395] = {
    [sym__primary_expression] = STATE(814),
    [sym_binary_operator] = STATE(814),
    [sym_unary_operator] = STATE(814),
    [sym_attribute] = STATE(814),
    [sym_subscript] = STATE(814),
    [sym_call] = STATE(814),
    [sym_list] = STATE(814),
    [sym_list_comprehension] = STATE(814),
    [sym_dictionary] = STATE(814),
    [sym_dictionary_comprehension] = STATE(814),
    [sym_set] = STATE(814),
    [sym_set_comprehension] = STATE(814),
    [sym_parenthesized_expression] = STATE(814),
    [sym_tuple] = STATE(814),
    [sym_generator_expression] = STATE(814),
    [sym_concatenated_string] = STATE(814),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1559),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1561),
    [sym_float] = ACTIONS(1561),
    [sym_identifier] = ACTIONS(1561),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [sym_none] = ACTIONS(1561),
    [sym_comment] = ACTIONS(73),
  },
  [396] = {
    [sym__primary_expression] = STATE(815),
    [sym_binary_operator] = STATE(815),
    [sym_unary_operator] = STATE(815),
    [sym_attribute] = STATE(815),
    [sym_subscript] = STATE(815),
    [sym_call] = STATE(815),
    [sym_list] = STATE(815),
    [sym_list_comprehension] = STATE(815),
    [sym_dictionary] = STATE(815),
    [sym_dictionary_comprehension] = STATE(815),
    [sym_set] = STATE(815),
    [sym_set_comprehension] = STATE(815),
    [sym_parenthesized_expression] = STATE(815),
    [sym_tuple] = STATE(815),
    [sym_generator_expression] = STATE(815),
    [sym_concatenated_string] = STATE(815),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1565),
    [sym_float] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_true] = ACTIONS(1565),
    [sym_false] = ACTIONS(1565),
    [sym_none] = ACTIONS(1565),
    [sym_comment] = ACTIONS(73),
  },
  [397] = {
    [sym__primary_expression] = STATE(816),
    [sym_binary_operator] = STATE(816),
    [sym_unary_operator] = STATE(816),
    [sym_attribute] = STATE(816),
    [sym_subscript] = STATE(816),
    [sym_call] = STATE(816),
    [sym_list] = STATE(816),
    [sym_list_comprehension] = STATE(816),
    [sym_dictionary] = STATE(816),
    [sym_dictionary_comprehension] = STATE(816),
    [sym_set] = STATE(816),
    [sym_set_comprehension] = STATE(816),
    [sym_parenthesized_expression] = STATE(816),
    [sym_tuple] = STATE(816),
    [sym_generator_expression] = STATE(816),
    [sym_concatenated_string] = STATE(816),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1569),
    [sym_float] = ACTIONS(1569),
    [sym_identifier] = ACTIONS(1569),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [sym_none] = ACTIONS(1569),
    [sym_comment] = ACTIONS(73),
  },
  [398] = {
    [anon_sym_in] = ACTIONS(1571),
    [sym_comment] = ACTIONS(73),
  },
  [399] = {
    [sym__primary_expression] = STATE(818),
    [sym_binary_operator] = STATE(818),
    [sym_unary_operator] = STATE(818),
    [sym_attribute] = STATE(818),
    [sym_subscript] = STATE(818),
    [sym_call] = STATE(818),
    [sym_list] = STATE(818),
    [sym_list_comprehension] = STATE(818),
    [sym_dictionary] = STATE(818),
    [sym_dictionary_comprehension] = STATE(818),
    [sym_set] = STATE(818),
    [sym_set_comprehension] = STATE(818),
    [sym_parenthesized_expression] = STATE(818),
    [sym_tuple] = STATE(818),
    [sym_generator_expression] = STATE(818),
    [sym_concatenated_string] = STATE(818),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1575),
    [sym_float] = ACTIONS(1575),
    [sym_identifier] = ACTIONS(1575),
    [sym_true] = ACTIONS(1575),
    [sym_false] = ACTIONS(1575),
    [sym_none] = ACTIONS(1575),
    [sym_comment] = ACTIONS(73),
  },
  [400] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [401] = {
    [sym__primary_expression] = STATE(819),
    [sym_binary_operator] = STATE(819),
    [sym_unary_operator] = STATE(819),
    [sym_attribute] = STATE(819),
    [sym_subscript] = STATE(819),
    [sym_call] = STATE(819),
    [sym_list] = STATE(819),
    [sym_list_comprehension] = STATE(819),
    [sym_dictionary] = STATE(819),
    [sym_dictionary_comprehension] = STATE(819),
    [sym_set] = STATE(819),
    [sym_set_comprehension] = STATE(819),
    [sym_parenthesized_expression] = STATE(819),
    [sym_tuple] = STATE(819),
    [sym_generator_expression] = STATE(819),
    [sym_concatenated_string] = STATE(819),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1577),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1579),
    [sym_float] = ACTIONS(1579),
    [sym_identifier] = ACTIONS(1579),
    [sym_true] = ACTIONS(1579),
    [sym_false] = ACTIONS(1579),
    [sym_none] = ACTIONS(1579),
    [sym_comment] = ACTIONS(73),
  },
  [402] = {
    [sym__primary_expression] = STATE(820),
    [sym_binary_operator] = STATE(820),
    [sym_unary_operator] = STATE(820),
    [sym_attribute] = STATE(820),
    [sym_subscript] = STATE(820),
    [sym_call] = STATE(820),
    [sym_list] = STATE(820),
    [sym_list_comprehension] = STATE(820),
    [sym_dictionary] = STATE(820),
    [sym_dictionary_comprehension] = STATE(820),
    [sym_set] = STATE(820),
    [sym_set_comprehension] = STATE(820),
    [sym_parenthesized_expression] = STATE(820),
    [sym_tuple] = STATE(820),
    [sym_generator_expression] = STATE(820),
    [sym_concatenated_string] = STATE(820),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1583),
    [sym_float] = ACTIONS(1583),
    [sym_identifier] = ACTIONS(1583),
    [sym_true] = ACTIONS(1583),
    [sym_false] = ACTIONS(1583),
    [sym_none] = ACTIONS(1583),
    [sym_comment] = ACTIONS(73),
  },
  [403] = {
    [sym__primary_expression] = STATE(821),
    [sym_binary_operator] = STATE(821),
    [sym_unary_operator] = STATE(821),
    [sym_attribute] = STATE(821),
    [sym_subscript] = STATE(821),
    [sym_call] = STATE(821),
    [sym_list] = STATE(821),
    [sym_list_comprehension] = STATE(821),
    [sym_dictionary] = STATE(821),
    [sym_dictionary_comprehension] = STATE(821),
    [sym_set] = STATE(821),
    [sym_set_comprehension] = STATE(821),
    [sym_parenthesized_expression] = STATE(821),
    [sym_tuple] = STATE(821),
    [sym_generator_expression] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1587),
    [sym_float] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1587),
    [sym_true] = ACTIONS(1587),
    [sym_false] = ACTIONS(1587),
    [sym_none] = ACTIONS(1587),
    [sym_comment] = ACTIONS(73),
  },
  [404] = {
    [sym__primary_expression] = STATE(816),
    [sym_binary_operator] = STATE(816),
    [sym_unary_operator] = STATE(816),
    [sym_attribute] = STATE(816),
    [sym_subscript] = STATE(816),
    [sym_call] = STATE(816),
    [sym_list] = STATE(816),
    [sym_list_comprehension] = STATE(816),
    [sym_dictionary] = STATE(816),
    [sym_dictionary_comprehension] = STATE(816),
    [sym_set] = STATE(816),
    [sym_set_comprehension] = STATE(816),
    [sym_parenthesized_expression] = STATE(816),
    [sym_tuple] = STATE(816),
    [sym_generator_expression] = STATE(816),
    [sym_concatenated_string] = STATE(816),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1589),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1569),
    [sym_float] = ACTIONS(1569),
    [sym_identifier] = ACTIONS(1569),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [sym_none] = ACTIONS(1569),
    [sym_comment] = ACTIONS(73),
  },
  [405] = {
    [aux_sym_comparison_operator_repeat1] = STATE(822),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_as] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(689),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(685),
    [anon_sym_EQ_EQ] = ACTIONS(685),
    [anon_sym_BANG_EQ] = ACTIONS(685),
    [anon_sym_GT_EQ] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_LT_GT] = ACTIONS(685),
    [anon_sym_is] = ACTIONS(703),
    [sym_comment] = ACTIONS(73),
  },
  [406] = {
    [sym_string] = STATE(823),
    [aux_sym_concatenated_string_repeat1] = STATE(823),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_as] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_COLON] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [407] = {
    [sym__parameters] = STATE(828),
    [sym_default_parameter] = STATE(829),
    [sym_typed_default_parameter] = STATE(829),
    [sym_list_splat] = STATE(830),
    [sym_dictionary_splat] = STATE(830),
    [sym_typed_parameter] = STATE(829),
    [sym_tuple] = STATE(829),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_print] = ACTIONS(1595),
    [anon_sym_exec] = ACTIONS(1595),
    [sym_identifier] = ACTIONS(1597),
    [sym_comment] = ACTIONS(73),
  },
  [408] = {
    [anon_sym_COLON] = ACTIONS(1599),
    [anon_sym_DASH_GT] = ACTIONS(1601),
    [sym_comment] = ACTIONS(73),
  },
  [409] = {
    [sym_identifier] = ACTIONS(1603),
    [sym_comment] = ACTIONS(73),
  },
  [410] = {
    [aux_sym_global_statement_repeat1] = STATE(834),
    [sym__newline] = ACTIONS(1605),
    [anon_sym_COMMA] = ACTIONS(709),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1605),
  },
  [411] = {
    [aux_sym_global_statement_repeat1] = STATE(834),
    [sym__newline] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(709),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1607),
  },
  [412] = {
    [sym__newline] = ACTIONS(345),
    [anon_sym_in] = ACTIONS(345),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(345),
  },
  [413] = {
    [sym_interpolation] = STATE(206),
    [aux_sym_string_repeat1] = STATE(206),
    [sym__string_content] = ACTIONS(361),
    [sym__string_end] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(365),
    [sym_comment] = ACTIONS(83),
  },
  [414] = {
    [sym__expression] = STATE(836),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(836),
    [sym_boolean_operator] = STATE(836),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(836),
    [sym_lambda] = STATE(836),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(836),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(836),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [415] = {
    [sym_list_splat] = STATE(659),
    [sym_dictionary_splat] = STATE(659),
    [sym__expression] = STATE(837),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(837),
    [sym_boolean_operator] = STATE(837),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(837),
    [sym_lambda] = STATE(837),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_keyword_argument] = STATE(659),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(837),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(837),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [416] = {
    [sym__simple_statements] = STATE(838),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(838),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [417] = {
    [anon_sym_COLON] = ACTIONS(1611),
    [sym_comment] = ACTIONS(73),
  },
  [418] = {
    [aux_sym_dotted_name_repeat1] = STATE(840),
    [sym__newline] = ACTIONS(1170),
    [anon_sym_DOT] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(1170),
    [sym_comment] = ACTIONS(73),
  },
  [419] = {
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_def] = ACTIONS(1613),
    [anon_sym_class] = ACTIONS(1613),
    [anon_sym_AT] = ACTIONS(1613),
    [sym_comment] = ACTIONS(73),
  },
  [420] = {
    [sym_list_splat] = STATE(548),
    [sym_dictionary_splat] = STATE(548),
    [sym__expression] = STATE(841),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(841),
    [sym_boolean_operator] = STATE(841),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(841),
    [sym_lambda] = STATE(841),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_keyword_argument] = STATE(548),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(841),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(841),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(937),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [421] = {
    [sym__newline] = ACTIONS(1615),
    [sym_comment] = ACTIONS(73),
  },
  [422] = {
    [aux_sym_tuple_repeat1] = STATE(607),
    [anon_sym_RPAREN] = ACTIONS(1193),
    [anon_sym_COMMA] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [423] = {
    [aux_sym_tuple_repeat1] = STATE(607),
    [anon_sym_RPAREN] = ACTIONS(1193),
    [anon_sym_COMMA] = ACTIONS(1197),
    [sym_comment] = ACTIONS(73),
  },
  [424] = {
    [sym__expression] = STATE(843),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(843),
    [sym_boolean_operator] = STATE(843),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(843),
    [sym_lambda] = STATE(843),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(843),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(843),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [425] = {
    [sym__expression] = STATE(844),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(844),
    [sym_boolean_operator] = STATE(844),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(844),
    [sym_lambda] = STATE(844),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(844),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(844),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [426] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [427] = {
    [sym_lambda_parameters] = STATE(846),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1617),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [428] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [429] = {
    [anon_sym_COMMA] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(1619),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [430] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(860),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_GT_GT] = ACTIONS(1629),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1631),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_not] = ACTIONS(1635),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_SLASH_SLASH] = ACTIONS(1633),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1641),
    [anon_sym_AMP] = ACTIONS(1643),
    [anon_sym_CARET] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1629),
    [anon_sym_LT] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1631),
    [anon_sym_EQ_EQ] = ACTIONS(1631),
    [anon_sym_BANG_EQ] = ACTIONS(1631),
    [anon_sym_GT_EQ] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1647),
    [anon_sym_LT_GT] = ACTIONS(1631),
    [anon_sym_is] = ACTIONS(1649),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [431] = {
    [sym_string] = STATE(861),
    [aux_sym_concatenated_string_repeat1] = STATE(861),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [432] = {
    [sym_default_parameter] = STATE(864),
    [sym_typed_default_parameter] = STATE(864),
    [sym_list_splat] = STATE(865),
    [sym_dictionary_splat] = STATE(865),
    [sym_typed_parameter] = STATE(864),
    [sym_tuple] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(1651),
    [anon_sym_COLON] = ACTIONS(1653),
    [anon_sym_exec] = ACTIONS(1651),
    [sym_identifier] = ACTIONS(1655),
    [sym_comment] = ACTIONS(73),
  },
  [433] = {
    [sym__expression] = STATE(870),
    [sym__primary_expression] = STATE(871),
    [sym_not_operator] = STATE(870),
    [sym_boolean_operator] = STATE(870),
    [sym_binary_operator] = STATE(871),
    [sym_unary_operator] = STATE(871),
    [sym_comparison_operator] = STATE(870),
    [sym_lambda] = STATE(870),
    [sym_attribute] = STATE(871),
    [sym_subscript] = STATE(871),
    [sym_call] = STATE(871),
    [sym_type] = STATE(872),
    [sym_list] = STATE(871),
    [sym_list_comprehension] = STATE(871),
    [sym_dictionary] = STATE(871),
    [sym_dictionary_comprehension] = STATE(871),
    [sym_set] = STATE(871),
    [sym_set_comprehension] = STATE(871),
    [sym_parenthesized_expression] = STATE(871),
    [sym_tuple] = STATE(871),
    [sym_generator_expression] = STATE(871),
    [sym_conditional_expression] = STATE(870),
    [sym_concatenated_string] = STATE(871),
    [sym_string] = STATE(873),
    [sym_await] = STATE(870),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_lambda] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1665),
    [sym_float] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1665),
    [sym_true] = ACTIONS(1665),
    [sym_false] = ACTIONS(1665),
    [sym_none] = ACTIONS(1665),
    [anon_sym_await] = ACTIONS(1667),
    [sym_comment] = ACTIONS(73),
  },
  [434] = {
    [sym__expression] = STATE(874),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(874),
    [sym_boolean_operator] = STATE(874),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(874),
    [sym_lambda] = STATE(874),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(874),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(874),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [435] = {
    [aux_sym__parameters_repeat1] = STATE(876),
    [anon_sym_COMMA] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(1653),
    [sym_comment] = ACTIONS(73),
  },
  [436] = {
    [sym__newline] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(1671),
    [anon_sym_DASH_EQ] = ACTIONS(1671),
    [anon_sym_STAR_EQ] = ACTIONS(1671),
    [anon_sym_SLASH_EQ] = ACTIONS(1671),
    [anon_sym_AT_EQ] = ACTIONS(1671),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1671),
    [anon_sym_PERCENT_EQ] = ACTIONS(1671),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1671),
    [anon_sym_GT_GT_EQ] = ACTIONS(1671),
    [anon_sym_LT_LT_EQ] = ACTIONS(1671),
    [anon_sym_AMP_EQ] = ACTIONS(1671),
    [anon_sym_CARET_EQ] = ACTIONS(1671),
    [anon_sym_PIPE_EQ] = ACTIONS(1671),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1671),
  },
  [437] = {
    [sym_default_parameter] = STATE(864),
    [sym_typed_default_parameter] = STATE(864),
    [sym_list_splat] = STATE(865),
    [sym_dictionary_splat] = STATE(865),
    [sym_typed_parameter] = STATE(864),
    [sym_tuple] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(1651),
    [anon_sym_COLON] = ACTIONS(1673),
    [anon_sym_exec] = ACTIONS(1651),
    [sym_identifier] = ACTIONS(1655),
    [sym_comment] = ACTIONS(73),
  },
  [438] = {
    [sym__expression] = STATE(881),
    [sym__primary_expression] = STATE(882),
    [sym_not_operator] = STATE(881),
    [sym_boolean_operator] = STATE(881),
    [sym_binary_operator] = STATE(882),
    [sym_unary_operator] = STATE(882),
    [sym_comparison_operator] = STATE(881),
    [sym_lambda] = STATE(881),
    [sym_attribute] = STATE(882),
    [sym_subscript] = STATE(882),
    [sym_call] = STATE(882),
    [sym_type] = STATE(883),
    [sym_list] = STATE(882),
    [sym_list_comprehension] = STATE(882),
    [sym_dictionary] = STATE(882),
    [sym_dictionary_comprehension] = STATE(882),
    [sym_set] = STATE(882),
    [sym_set_comprehension] = STATE(882),
    [sym_parenthesized_expression] = STATE(882),
    [sym_tuple] = STATE(882),
    [sym_generator_expression] = STATE(882),
    [sym_conditional_expression] = STATE(881),
    [sym_concatenated_string] = STATE(882),
    [sym_string] = STATE(884),
    [sym_await] = STATE(881),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_lambda] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1683),
    [sym_float] = ACTIONS(1683),
    [sym_identifier] = ACTIONS(1683),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_none] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1685),
    [sym_comment] = ACTIONS(73),
  },
  [439] = {
    [sym__expression] = STATE(885),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(885),
    [sym_boolean_operator] = STATE(885),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(885),
    [sym_lambda] = STATE(885),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(885),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(885),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [440] = {
    [aux_sym__parameters_repeat1] = STATE(876),
    [anon_sym_COMMA] = ACTIONS(1687),
    [anon_sym_COLON] = ACTIONS(1673),
    [sym_comment] = ACTIONS(73),
  },
  [441] = {
    [sym__expression] = STATE(887),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(887),
    [sym_boolean_operator] = STATE(887),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(887),
    [sym_lambda] = STATE(887),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(887),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(887),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [442] = {
    [sym__expression] = STATE(888),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(888),
    [sym_boolean_operator] = STATE(888),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(888),
    [sym_lambda] = STATE(888),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_type] = STATE(889),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(888),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(888),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [443] = {
    [sym__newline] = ACTIONS(1689),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_and] = ACTIONS(1391),
    [anon_sym_or] = ACTIONS(1393),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1689),
  },
  [444] = {
    [sym__newline] = ACTIONS(1691),
    [anon_sym_DOT] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1691),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_if] = ACTIONS(1691),
    [anon_sym_COLON] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(1691),
    [anon_sym_EQ] = ACTIONS(1693),
    [anon_sym_AT] = ACTIONS(1693),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_and] = ACTIONS(1691),
    [anon_sym_or] = ACTIONS(1691),
    [anon_sym_PLUS] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_SLASH_SLASH] = ACTIONS(1693),
    [anon_sym_STAR_STAR] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym_CARET] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1691),
    [anon_sym_EQ_EQ] = ACTIONS(1691),
    [anon_sym_BANG_EQ] = ACTIONS(1691),
    [anon_sym_GT_EQ] = ACTIONS(1691),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_LT_GT] = ACTIONS(1691),
    [anon_sym_is] = ACTIONS(1691),
    [anon_sym_PLUS_EQ] = ACTIONS(1691),
    [anon_sym_DASH_EQ] = ACTIONS(1691),
    [anon_sym_STAR_EQ] = ACTIONS(1691),
    [anon_sym_SLASH_EQ] = ACTIONS(1691),
    [anon_sym_AT_EQ] = ACTIONS(1691),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1691),
    [anon_sym_PERCENT_EQ] = ACTIONS(1691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1691),
    [anon_sym_GT_GT_EQ] = ACTIONS(1691),
    [anon_sym_LT_LT_EQ] = ACTIONS(1691),
    [anon_sym_AMP_EQ] = ACTIONS(1691),
    [anon_sym_CARET_EQ] = ACTIONS(1691),
    [anon_sym_PIPE_EQ] = ACTIONS(1691),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1691),
  },
  [445] = {
    [sym__expression] = STATE(890),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(890),
    [sym_boolean_operator] = STATE(890),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(890),
    [sym_lambda] = STATE(890),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(890),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(890),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [446] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [447] = {
    [sym_lambda_parameters] = STATE(892),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [448] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [449] = {
    [anon_sym_COMMA] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(1619),
    [sym_comment] = ACTIONS(73),
  },
  [450] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(906),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1707),
    [anon_sym_AT] = ACTIONS(1709),
    [anon_sym_not] = ACTIONS(1711),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [anon_sym_SLASH_SLASH] = ACTIONS(1709),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1723),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1723),
    [anon_sym_LT_GT] = ACTIONS(1707),
    [anon_sym_is] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [451] = {
    [sym_string] = STATE(907),
    [aux_sym_concatenated_string_repeat1] = STATE(907),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [452] = {
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(801),
    [anon_sym_RBRACK] = ACTIONS(731),
    [sym_comment] = ACTIONS(73),
  },
  [453] = {
    [sym__expression] = STATE(908),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(908),
    [sym_boolean_operator] = STATE(908),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(908),
    [sym_lambda] = STATE(908),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(908),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(908),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [454] = {
    [anon_sym_COLON] = ACTIONS(1727),
    [sym_comment] = ACTIONS(73),
  },
  [455] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(912),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(1729),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [456] = {
    [aux_sym_list_repeat1] = STATE(914),
    [anon_sym_COMMA] = ACTIONS(1731),
    [anon_sym_RBRACK] = ACTIONS(1729),
    [sym_comment] = ACTIONS(73),
  },
  [457] = {
    [sym__expression] = STATE(915),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(915),
    [sym_boolean_operator] = STATE(915),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(915),
    [sym_lambda] = STATE(915),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(915),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(915),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [458] = {
    [anon_sym_for] = ACTIONS(1733),
    [sym_comment] = ACTIONS(73),
  },
  [459] = {
    [sym_variables] = STATE(917),
    [sym__primary_expression] = STATE(108),
    [sym_binary_operator] = STATE(108),
    [sym_unary_operator] = STATE(108),
    [sym_attribute] = STATE(108),
    [sym_subscript] = STATE(108),
    [sym_call] = STATE(108),
    [sym_list] = STATE(108),
    [sym_list_comprehension] = STATE(108),
    [sym_dictionary] = STATE(108),
    [sym_dictionary_comprehension] = STATE(108),
    [sym_set] = STATE(108),
    [sym_set_comprehension] = STATE(108),
    [sym_parenthesized_expression] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_generator_expression] = STATE(108),
    [sym_concatenated_string] = STATE(108),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [460] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [461] = {
    [sym__expression] = STATE(918),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(918),
    [sym_boolean_operator] = STATE(918),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(918),
    [sym_lambda] = STATE(918),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(918),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(918),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [462] = {
    [anon_sym_RBRACK] = ACTIONS(1735),
    [sym_comment] = ACTIONS(73),
  },
  [463] = {
    [sym_for_in_clause] = STATE(921),
    [sym_if_clause] = STATE(921),
    [aux_sym__comprehension_body_repeat1] = STATE(921),
    [anon_sym_if] = ACTIONS(1737),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_RBRACK] = ACTIONS(1263),
    [sym_comment] = ACTIONS(73),
  },
  [464] = {
    [sym__primary_expression] = STATE(922),
    [sym_binary_operator] = STATE(922),
    [sym_unary_operator] = STATE(922),
    [sym_attribute] = STATE(922),
    [sym_subscript] = STATE(922),
    [sym_call] = STATE(922),
    [sym_list] = STATE(922),
    [sym_list_comprehension] = STATE(922),
    [sym_dictionary] = STATE(922),
    [sym_dictionary_comprehension] = STATE(922),
    [sym_set] = STATE(922),
    [sym_set_comprehension] = STATE(922),
    [sym_parenthesized_expression] = STATE(922),
    [sym_tuple] = STATE(922),
    [sym_generator_expression] = STATE(922),
    [sym_concatenated_string] = STATE(922),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1741),
    [sym_float] = ACTIONS(1741),
    [sym_identifier] = ACTIONS(1741),
    [sym_true] = ACTIONS(1741),
    [sym_false] = ACTIONS(1741),
    [sym_none] = ACTIONS(1741),
    [sym_comment] = ACTIONS(73),
  },
  [465] = {
    [sym__primary_expression] = STATE(923),
    [sym_binary_operator] = STATE(923),
    [sym_unary_operator] = STATE(923),
    [sym_attribute] = STATE(923),
    [sym_subscript] = STATE(923),
    [sym_call] = STATE(923),
    [sym_list] = STATE(923),
    [sym_list_comprehension] = STATE(923),
    [sym_dictionary] = STATE(923),
    [sym_dictionary_comprehension] = STATE(923),
    [sym_set] = STATE(923),
    [sym_set_comprehension] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_tuple] = STATE(923),
    [sym_generator_expression] = STATE(923),
    [sym_concatenated_string] = STATE(923),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1745),
    [sym_float] = ACTIONS(1745),
    [sym_identifier] = ACTIONS(1745),
    [sym_true] = ACTIONS(1745),
    [sym_false] = ACTIONS(1745),
    [sym_none] = ACTIONS(1745),
    [sym_comment] = ACTIONS(73),
  },
  [466] = {
    [sym__primary_expression] = STATE(924),
    [sym_binary_operator] = STATE(924),
    [sym_unary_operator] = STATE(924),
    [sym_attribute] = STATE(924),
    [sym_subscript] = STATE(924),
    [sym_call] = STATE(924),
    [sym_list] = STATE(924),
    [sym_list_comprehension] = STATE(924),
    [sym_dictionary] = STATE(924),
    [sym_dictionary_comprehension] = STATE(924),
    [sym_set] = STATE(924),
    [sym_set_comprehension] = STATE(924),
    [sym_parenthesized_expression] = STATE(924),
    [sym_tuple] = STATE(924),
    [sym_generator_expression] = STATE(924),
    [sym_concatenated_string] = STATE(924),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1749),
    [sym_float] = ACTIONS(1749),
    [sym_identifier] = ACTIONS(1749),
    [sym_true] = ACTIONS(1749),
    [sym_false] = ACTIONS(1749),
    [sym_none] = ACTIONS(1749),
    [sym_comment] = ACTIONS(73),
  },
  [467] = {
    [anon_sym_in] = ACTIONS(1751),
    [sym_comment] = ACTIONS(73),
  },
  [468] = {
    [sym__primary_expression] = STATE(926),
    [sym_binary_operator] = STATE(926),
    [sym_unary_operator] = STATE(926),
    [sym_attribute] = STATE(926),
    [sym_subscript] = STATE(926),
    [sym_call] = STATE(926),
    [sym_list] = STATE(926),
    [sym_list_comprehension] = STATE(926),
    [sym_dictionary] = STATE(926),
    [sym_dictionary_comprehension] = STATE(926),
    [sym_set] = STATE(926),
    [sym_set_comprehension] = STATE(926),
    [sym_parenthesized_expression] = STATE(926),
    [sym_tuple] = STATE(926),
    [sym_generator_expression] = STATE(926),
    [sym_concatenated_string] = STATE(926),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1755),
    [sym_float] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_true] = ACTIONS(1755),
    [sym_false] = ACTIONS(1755),
    [sym_none] = ACTIONS(1755),
    [sym_comment] = ACTIONS(73),
  },
  [469] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [470] = {
    [sym__primary_expression] = STATE(927),
    [sym_binary_operator] = STATE(927),
    [sym_unary_operator] = STATE(927),
    [sym_attribute] = STATE(927),
    [sym_subscript] = STATE(927),
    [sym_call] = STATE(927),
    [sym_list] = STATE(927),
    [sym_list_comprehension] = STATE(927),
    [sym_dictionary] = STATE(927),
    [sym_dictionary_comprehension] = STATE(927),
    [sym_set] = STATE(927),
    [sym_set_comprehension] = STATE(927),
    [sym_parenthesized_expression] = STATE(927),
    [sym_tuple] = STATE(927),
    [sym_generator_expression] = STATE(927),
    [sym_concatenated_string] = STATE(927),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1757),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1759),
    [sym_float] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_true] = ACTIONS(1759),
    [sym_false] = ACTIONS(1759),
    [sym_none] = ACTIONS(1759),
    [sym_comment] = ACTIONS(73),
  },
  [471] = {
    [sym__primary_expression] = STATE(928),
    [sym_binary_operator] = STATE(928),
    [sym_unary_operator] = STATE(928),
    [sym_attribute] = STATE(928),
    [sym_subscript] = STATE(928),
    [sym_call] = STATE(928),
    [sym_list] = STATE(928),
    [sym_list_comprehension] = STATE(928),
    [sym_dictionary] = STATE(928),
    [sym_dictionary_comprehension] = STATE(928),
    [sym_set] = STATE(928),
    [sym_set_comprehension] = STATE(928),
    [sym_parenthesized_expression] = STATE(928),
    [sym_tuple] = STATE(928),
    [sym_generator_expression] = STATE(928),
    [sym_concatenated_string] = STATE(928),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1763),
    [sym_float] = ACTIONS(1763),
    [sym_identifier] = ACTIONS(1763),
    [sym_true] = ACTIONS(1763),
    [sym_false] = ACTIONS(1763),
    [sym_none] = ACTIONS(1763),
    [sym_comment] = ACTIONS(73),
  },
  [472] = {
    [sym__primary_expression] = STATE(929),
    [sym_binary_operator] = STATE(929),
    [sym_unary_operator] = STATE(929),
    [sym_attribute] = STATE(929),
    [sym_subscript] = STATE(929),
    [sym_call] = STATE(929),
    [sym_list] = STATE(929),
    [sym_list_comprehension] = STATE(929),
    [sym_dictionary] = STATE(929),
    [sym_dictionary_comprehension] = STATE(929),
    [sym_set] = STATE(929),
    [sym_set_comprehension] = STATE(929),
    [sym_parenthesized_expression] = STATE(929),
    [sym_tuple] = STATE(929),
    [sym_generator_expression] = STATE(929),
    [sym_concatenated_string] = STATE(929),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1765),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1767),
    [sym_float] = ACTIONS(1767),
    [sym_identifier] = ACTIONS(1767),
    [sym_true] = ACTIONS(1767),
    [sym_false] = ACTIONS(1767),
    [sym_none] = ACTIONS(1767),
    [sym_comment] = ACTIONS(73),
  },
  [473] = {
    [sym__primary_expression] = STATE(924),
    [sym_binary_operator] = STATE(924),
    [sym_unary_operator] = STATE(924),
    [sym_attribute] = STATE(924),
    [sym_subscript] = STATE(924),
    [sym_call] = STATE(924),
    [sym_list] = STATE(924),
    [sym_list_comprehension] = STATE(924),
    [sym_dictionary] = STATE(924),
    [sym_dictionary_comprehension] = STATE(924),
    [sym_set] = STATE(924),
    [sym_set_comprehension] = STATE(924),
    [sym_parenthesized_expression] = STATE(924),
    [sym_tuple] = STATE(924),
    [sym_generator_expression] = STATE(924),
    [sym_concatenated_string] = STATE(924),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1749),
    [sym_float] = ACTIONS(1749),
    [sym_identifier] = ACTIONS(1749),
    [sym_true] = ACTIONS(1749),
    [sym_false] = ACTIONS(1749),
    [sym_none] = ACTIONS(1749),
    [sym_comment] = ACTIONS(73),
  },
  [474] = {
    [aux_sym_comparison_operator_repeat1] = STATE(930),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_async] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(811),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_LT_EQ] = ACTIONS(807),
    [anon_sym_EQ_EQ] = ACTIONS(807),
    [anon_sym_BANG_EQ] = ACTIONS(807),
    [anon_sym_GT_EQ] = ACTIONS(807),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_LT_GT] = ACTIONS(807),
    [anon_sym_is] = ACTIONS(825),
    [anon_sym_RBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(73),
  },
  [475] = {
    [sym_string] = STATE(931),
    [aux_sym_concatenated_string_repeat1] = STATE(931),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_RBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [476] = {
    [sym__newline] = ACTIONS(1771),
    [anon_sym_DOT] = ACTIONS(1771),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1773),
    [anon_sym_GT_GT] = ACTIONS(1773),
    [anon_sym_if] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1771),
    [anon_sym_in] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1773),
    [anon_sym_AT] = ACTIONS(1773),
    [anon_sym_not] = ACTIONS(1771),
    [anon_sym_and] = ACTIONS(1771),
    [anon_sym_or] = ACTIONS(1771),
    [anon_sym_PLUS] = ACTIONS(1773),
    [anon_sym_DASH] = ACTIONS(1773),
    [anon_sym_SLASH] = ACTIONS(1773),
    [anon_sym_PERCENT] = ACTIONS(1773),
    [anon_sym_SLASH_SLASH] = ACTIONS(1773),
    [anon_sym_STAR_STAR] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1771),
    [anon_sym_EQ_EQ] = ACTIONS(1771),
    [anon_sym_BANG_EQ] = ACTIONS(1771),
    [anon_sym_GT_EQ] = ACTIONS(1771),
    [anon_sym_GT] = ACTIONS(1773),
    [anon_sym_LT_GT] = ACTIONS(1771),
    [anon_sym_is] = ACTIONS(1771),
    [anon_sym_PLUS_EQ] = ACTIONS(1771),
    [anon_sym_DASH_EQ] = ACTIONS(1771),
    [anon_sym_STAR_EQ] = ACTIONS(1771),
    [anon_sym_SLASH_EQ] = ACTIONS(1771),
    [anon_sym_AT_EQ] = ACTIONS(1771),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1771),
    [anon_sym_PERCENT_EQ] = ACTIONS(1771),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1771),
    [anon_sym_GT_GT_EQ] = ACTIONS(1771),
    [anon_sym_LT_LT_EQ] = ACTIONS(1771),
    [anon_sym_AMP_EQ] = ACTIONS(1771),
    [anon_sym_CARET_EQ] = ACTIONS(1771),
    [anon_sym_PIPE_EQ] = ACTIONS(1771),
    [anon_sym_LBRACK] = ACTIONS(1771),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1771),
  },
  [477] = {
    [sym__expression] = STATE(932),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(932),
    [sym_boolean_operator] = STATE(932),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(932),
    [sym_lambda] = STATE(932),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(932),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(932),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [478] = {
    [sym__expression] = STATE(933),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(933),
    [sym_boolean_operator] = STATE(933),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(933),
    [sym_lambda] = STATE(933),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(933),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(933),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [479] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [480] = {
    [sym_lambda_parameters] = STATE(935),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1775),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [481] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [482] = {
    [anon_sym_COMMA] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1777),
    [anon_sym_and] = ACTIONS(1779),
    [anon_sym_or] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(1619),
    [sym_comment] = ACTIONS(73),
  },
  [483] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(949),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(1783),
    [anon_sym_GT_GT] = ACTIONS(1785),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1787),
    [anon_sym_AT] = ACTIONS(1789),
    [anon_sym_not] = ACTIONS(1791),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1793),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_SLASH] = ACTIONS(1783),
    [anon_sym_PERCENT] = ACTIONS(1789),
    [anon_sym_SLASH_SLASH] = ACTIONS(1789),
    [anon_sym_STAR_STAR] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_CARET] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1803),
    [anon_sym_LT_EQ] = ACTIONS(1787),
    [anon_sym_EQ_EQ] = ACTIONS(1787),
    [anon_sym_BANG_EQ] = ACTIONS(1787),
    [anon_sym_GT_EQ] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(1803),
    [anon_sym_LT_GT] = ACTIONS(1787),
    [anon_sym_is] = ACTIONS(1805),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [484] = {
    [sym_string] = STATE(950),
    [aux_sym_concatenated_string_repeat1] = STATE(950),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [485] = {
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(863),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(731),
    [sym_comment] = ACTIONS(73),
  },
  [486] = {
    [sym__expression] = STATE(951),
    [sym__primary_expression] = STATE(163),
    [sym_not_operator] = STATE(951),
    [sym_boolean_operator] = STATE(951),
    [sym_binary_operator] = STATE(163),
    [sym_unary_operator] = STATE(163),
    [sym_comparison_operator] = STATE(951),
    [sym_lambda] = STATE(951),
    [sym_attribute] = STATE(163),
    [sym_subscript] = STATE(163),
    [sym_call] = STATE(163),
    [sym_list] = STATE(163),
    [sym_list_comprehension] = STATE(163),
    [sym_dictionary] = STATE(163),
    [sym_dictionary_comprehension] = STATE(163),
    [sym_set] = STATE(163),
    [sym_set_comprehension] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_tuple] = STATE(163),
    [sym_generator_expression] = STATE(163),
    [sym_conditional_expression] = STATE(951),
    [sym_concatenated_string] = STATE(163),
    [sym_string] = STATE(165),
    [sym_await] = STATE(951),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [487] = {
    [anon_sym_COLON] = ACTIONS(1807),
    [sym_comment] = ACTIONS(73),
  },
  [488] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(955),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(955),
    [sym_boolean_operator] = STATE(955),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(955),
    [sym_lambda] = STATE(955),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(955),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(955),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(1811),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [489] = {
    [sym__newline] = ACTIONS(1813),
    [anon_sym_DOT] = ACTIONS(1813),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_COMMA] = ACTIONS(1813),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_GT_GT] = ACTIONS(1815),
    [anon_sym_if] = ACTIONS(1813),
    [anon_sym_COLON] = ACTIONS(1813),
    [anon_sym_in] = ACTIONS(1813),
    [anon_sym_EQ] = ACTIONS(1815),
    [anon_sym_AT] = ACTIONS(1815),
    [anon_sym_not] = ACTIONS(1813),
    [anon_sym_and] = ACTIONS(1813),
    [anon_sym_or] = ACTIONS(1813),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_SLASH] = ACTIONS(1815),
    [anon_sym_PERCENT] = ACTIONS(1815),
    [anon_sym_SLASH_SLASH] = ACTIONS(1815),
    [anon_sym_STAR_STAR] = ACTIONS(1815),
    [anon_sym_PIPE] = ACTIONS(1815),
    [anon_sym_AMP] = ACTIONS(1815),
    [anon_sym_CARET] = ACTIONS(1815),
    [anon_sym_LT_LT] = ACTIONS(1815),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_LT_EQ] = ACTIONS(1813),
    [anon_sym_EQ_EQ] = ACTIONS(1813),
    [anon_sym_BANG_EQ] = ACTIONS(1813),
    [anon_sym_GT_EQ] = ACTIONS(1813),
    [anon_sym_GT] = ACTIONS(1815),
    [anon_sym_LT_GT] = ACTIONS(1813),
    [anon_sym_is] = ACTIONS(1813),
    [anon_sym_PLUS_EQ] = ACTIONS(1813),
    [anon_sym_DASH_EQ] = ACTIONS(1813),
    [anon_sym_STAR_EQ] = ACTIONS(1813),
    [anon_sym_SLASH_EQ] = ACTIONS(1813),
    [anon_sym_AT_EQ] = ACTIONS(1813),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1813),
    [anon_sym_PERCENT_EQ] = ACTIONS(1813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1813),
    [anon_sym_GT_GT_EQ] = ACTIONS(1813),
    [anon_sym_LT_LT_EQ] = ACTIONS(1813),
    [anon_sym_AMP_EQ] = ACTIONS(1813),
    [anon_sym_CARET_EQ] = ACTIONS(1813),
    [anon_sym_PIPE_EQ] = ACTIONS(1813),
    [anon_sym_LBRACK] = ACTIONS(1813),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1813),
  },
  [490] = {
    [aux_sym_list_repeat1] = STATE(957),
    [anon_sym_COMMA] = ACTIONS(1817),
    [anon_sym_RBRACE] = ACTIONS(1811),
    [sym_comment] = ACTIONS(73),
  },
  [491] = {
    [sym_dictionary_splat] = STATE(960),
    [sym__expression] = STATE(961),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(961),
    [sym_boolean_operator] = STATE(961),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(961),
    [sym_lambda] = STATE(961),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_pair] = STATE(960),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(961),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(961),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(1821),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [492] = {
    [aux_sym_dictionary_repeat1] = STATE(963),
    [anon_sym_COMMA] = ACTIONS(1823),
    [anon_sym_RBRACE] = ACTIONS(1821),
    [sym_comment] = ACTIONS(73),
  },
  [493] = {
    [sym__expression] = STATE(964),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(964),
    [sym_boolean_operator] = STATE(964),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(964),
    [sym_lambda] = STATE(964),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(964),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(964),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [494] = {
    [sym__expression] = STATE(969),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(969),
    [sym_boolean_operator] = STATE(969),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(969),
    [sym_lambda] = STATE(969),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(969),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(969),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [495] = {
    [anon_sym_for] = ACTIONS(1837),
    [sym_comment] = ACTIONS(73),
  },
  [496] = {
    [sym_variables] = STATE(973),
    [sym__primary_expression] = STATE(108),
    [sym_binary_operator] = STATE(108),
    [sym_unary_operator] = STATE(108),
    [sym_attribute] = STATE(108),
    [sym_subscript] = STATE(108),
    [sym_call] = STATE(108),
    [sym_list] = STATE(108),
    [sym_list_comprehension] = STATE(108),
    [sym_dictionary] = STATE(108),
    [sym_dictionary_comprehension] = STATE(108),
    [sym_set] = STATE(108),
    [sym_set_comprehension] = STATE(108),
    [sym_parenthesized_expression] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_generator_expression] = STATE(108),
    [sym_concatenated_string] = STATE(108),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [497] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(163),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(163),
    [sym_unary_operator] = STATE(163),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(163),
    [sym_subscript] = STATE(163),
    [sym_call] = STATE(163),
    [sym_list] = STATE(163),
    [sym_list_comprehension] = STATE(163),
    [sym_dictionary] = STATE(163),
    [sym_dictionary_comprehension] = STATE(163),
    [sym_set] = STATE(163),
    [sym_set_comprehension] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_tuple] = STATE(163),
    [sym_generator_expression] = STATE(163),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(163),
    [sym_string] = STATE(165),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [498] = {
    [sym__expression] = STATE(974),
    [sym__primary_expression] = STATE(163),
    [sym_not_operator] = STATE(974),
    [sym_boolean_operator] = STATE(974),
    [sym_binary_operator] = STATE(163),
    [sym_unary_operator] = STATE(163),
    [sym_comparison_operator] = STATE(974),
    [sym_lambda] = STATE(974),
    [sym_attribute] = STATE(163),
    [sym_subscript] = STATE(163),
    [sym_call] = STATE(163),
    [sym_list] = STATE(163),
    [sym_list_comprehension] = STATE(163),
    [sym_dictionary] = STATE(163),
    [sym_dictionary_comprehension] = STATE(163),
    [sym_set] = STATE(163),
    [sym_set_comprehension] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_tuple] = STATE(163),
    [sym_generator_expression] = STATE(163),
    [sym_conditional_expression] = STATE(974),
    [sym_concatenated_string] = STATE(163),
    [sym_string] = STATE(165),
    [sym_await] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [499] = {
    [anon_sym_RBRACE] = ACTIONS(1839),
    [sym_comment] = ACTIONS(73),
  },
  [500] = {
    [sym_for_in_clause] = STATE(977),
    [sym_if_clause] = STATE(977),
    [aux_sym__comprehension_body_repeat1] = STATE(977),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(73),
  },
  [501] = {
    [sym__primary_expression] = STATE(978),
    [sym_binary_operator] = STATE(978),
    [sym_unary_operator] = STATE(978),
    [sym_attribute] = STATE(978),
    [sym_subscript] = STATE(978),
    [sym_call] = STATE(978),
    [sym_list] = STATE(978),
    [sym_list_comprehension] = STATE(978),
    [sym_dictionary] = STATE(978),
    [sym_dictionary_comprehension] = STATE(978),
    [sym_set] = STATE(978),
    [sym_set_comprehension] = STATE(978),
    [sym_parenthesized_expression] = STATE(978),
    [sym_tuple] = STATE(978),
    [sym_generator_expression] = STATE(978),
    [sym_concatenated_string] = STATE(978),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1843),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1845),
    [sym_float] = ACTIONS(1845),
    [sym_identifier] = ACTIONS(1845),
    [sym_true] = ACTIONS(1845),
    [sym_false] = ACTIONS(1845),
    [sym_none] = ACTIONS(1845),
    [sym_comment] = ACTIONS(73),
  },
  [502] = {
    [sym__primary_expression] = STATE(979),
    [sym_binary_operator] = STATE(979),
    [sym_unary_operator] = STATE(979),
    [sym_attribute] = STATE(979),
    [sym_subscript] = STATE(979),
    [sym_call] = STATE(979),
    [sym_list] = STATE(979),
    [sym_list_comprehension] = STATE(979),
    [sym_dictionary] = STATE(979),
    [sym_dictionary_comprehension] = STATE(979),
    [sym_set] = STATE(979),
    [sym_set_comprehension] = STATE(979),
    [sym_parenthesized_expression] = STATE(979),
    [sym_tuple] = STATE(979),
    [sym_generator_expression] = STATE(979),
    [sym_concatenated_string] = STATE(979),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1849),
    [sym_float] = ACTIONS(1849),
    [sym_identifier] = ACTIONS(1849),
    [sym_true] = ACTIONS(1849),
    [sym_false] = ACTIONS(1849),
    [sym_none] = ACTIONS(1849),
    [sym_comment] = ACTIONS(73),
  },
  [503] = {
    [sym__primary_expression] = STATE(980),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_attribute] = STATE(980),
    [sym_subscript] = STATE(980),
    [sym_call] = STATE(980),
    [sym_list] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_concatenated_string] = STATE(980),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1853),
    [sym_float] = ACTIONS(1853),
    [sym_identifier] = ACTIONS(1853),
    [sym_true] = ACTIONS(1853),
    [sym_false] = ACTIONS(1853),
    [sym_none] = ACTIONS(1853),
    [sym_comment] = ACTIONS(73),
  },
  [504] = {
    [anon_sym_in] = ACTIONS(1855),
    [sym_comment] = ACTIONS(73),
  },
  [505] = {
    [sym__primary_expression] = STATE(982),
    [sym_binary_operator] = STATE(982),
    [sym_unary_operator] = STATE(982),
    [sym_attribute] = STATE(982),
    [sym_subscript] = STATE(982),
    [sym_call] = STATE(982),
    [sym_list] = STATE(982),
    [sym_list_comprehension] = STATE(982),
    [sym_dictionary] = STATE(982),
    [sym_dictionary_comprehension] = STATE(982),
    [sym_set] = STATE(982),
    [sym_set_comprehension] = STATE(982),
    [sym_parenthesized_expression] = STATE(982),
    [sym_tuple] = STATE(982),
    [sym_generator_expression] = STATE(982),
    [sym_concatenated_string] = STATE(982),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1859),
    [sym_float] = ACTIONS(1859),
    [sym_identifier] = ACTIONS(1859),
    [sym_true] = ACTIONS(1859),
    [sym_false] = ACTIONS(1859),
    [sym_none] = ACTIONS(1859),
    [sym_comment] = ACTIONS(73),
  },
  [506] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [507] = {
    [sym__primary_expression] = STATE(983),
    [sym_binary_operator] = STATE(983),
    [sym_unary_operator] = STATE(983),
    [sym_attribute] = STATE(983),
    [sym_subscript] = STATE(983),
    [sym_call] = STATE(983),
    [sym_list] = STATE(983),
    [sym_list_comprehension] = STATE(983),
    [sym_dictionary] = STATE(983),
    [sym_dictionary_comprehension] = STATE(983),
    [sym_set] = STATE(983),
    [sym_set_comprehension] = STATE(983),
    [sym_parenthesized_expression] = STATE(983),
    [sym_tuple] = STATE(983),
    [sym_generator_expression] = STATE(983),
    [sym_concatenated_string] = STATE(983),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1863),
    [sym_float] = ACTIONS(1863),
    [sym_identifier] = ACTIONS(1863),
    [sym_true] = ACTIONS(1863),
    [sym_false] = ACTIONS(1863),
    [sym_none] = ACTIONS(1863),
    [sym_comment] = ACTIONS(73),
  },
  [508] = {
    [sym__primary_expression] = STATE(984),
    [sym_binary_operator] = STATE(984),
    [sym_unary_operator] = STATE(984),
    [sym_attribute] = STATE(984),
    [sym_subscript] = STATE(984),
    [sym_call] = STATE(984),
    [sym_list] = STATE(984),
    [sym_list_comprehension] = STATE(984),
    [sym_dictionary] = STATE(984),
    [sym_dictionary_comprehension] = STATE(984),
    [sym_set] = STATE(984),
    [sym_set_comprehension] = STATE(984),
    [sym_parenthesized_expression] = STATE(984),
    [sym_tuple] = STATE(984),
    [sym_generator_expression] = STATE(984),
    [sym_concatenated_string] = STATE(984),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1867),
    [sym_float] = ACTIONS(1867),
    [sym_identifier] = ACTIONS(1867),
    [sym_true] = ACTIONS(1867),
    [sym_false] = ACTIONS(1867),
    [sym_none] = ACTIONS(1867),
    [sym_comment] = ACTIONS(73),
  },
  [509] = {
    [sym__primary_expression] = STATE(985),
    [sym_binary_operator] = STATE(985),
    [sym_unary_operator] = STATE(985),
    [sym_attribute] = STATE(985),
    [sym_subscript] = STATE(985),
    [sym_call] = STATE(985),
    [sym_list] = STATE(985),
    [sym_list_comprehension] = STATE(985),
    [sym_dictionary] = STATE(985),
    [sym_dictionary_comprehension] = STATE(985),
    [sym_set] = STATE(985),
    [sym_set_comprehension] = STATE(985),
    [sym_parenthesized_expression] = STATE(985),
    [sym_tuple] = STATE(985),
    [sym_generator_expression] = STATE(985),
    [sym_concatenated_string] = STATE(985),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1871),
    [sym_float] = ACTIONS(1871),
    [sym_identifier] = ACTIONS(1871),
    [sym_true] = ACTIONS(1871),
    [sym_false] = ACTIONS(1871),
    [sym_none] = ACTIONS(1871),
    [sym_comment] = ACTIONS(73),
  },
  [510] = {
    [sym__primary_expression] = STATE(980),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_attribute] = STATE(980),
    [sym_subscript] = STATE(980),
    [sym_call] = STATE(980),
    [sym_list] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_concatenated_string] = STATE(980),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1873),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1853),
    [sym_float] = ACTIONS(1853),
    [sym_identifier] = ACTIONS(1853),
    [sym_true] = ACTIONS(1853),
    [sym_false] = ACTIONS(1853),
    [sym_none] = ACTIONS(1853),
    [sym_comment] = ACTIONS(73),
  },
  [511] = {
    [aux_sym_comparison_operator_repeat1] = STATE(986),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_async] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(871),
    [anon_sym_not] = ACTIONS(875),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(871),
    [anon_sym_EQ_EQ] = ACTIONS(871),
    [anon_sym_BANG_EQ] = ACTIONS(871),
    [anon_sym_GT_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_LT_GT] = ACTIONS(871),
    [anon_sym_is] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(999),
    [sym_comment] = ACTIONS(73),
  },
  [512] = {
    [anon_sym_RBRACE] = ACTIONS(1875),
    [sym_comment] = ACTIONS(73),
  },
  [513] = {
    [sym_string] = STATE(988),
    [aux_sym_concatenated_string_repeat1] = STATE(988),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_COLON] = ACTIONS(1003),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [514] = {
    [sym__string_start] = ACTIONS(1877),
    [ts_builtin_sym_end] = ACTIONS(1877),
    [anon_sym_import] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_print] = ACTIONS(1879),
    [anon_sym_assert] = ACTIONS(1879),
    [anon_sym_return] = ACTIONS(1879),
    [anon_sym_del] = ACTIONS(1879),
    [anon_sym_raise] = ACTIONS(1879),
    [anon_sym_pass] = ACTIONS(1879),
    [anon_sym_break] = ACTIONS(1879),
    [anon_sym_continue] = ACTIONS(1879),
    [anon_sym_if] = ACTIONS(1879),
    [anon_sym_elif] = ACTIONS(1879),
    [anon_sym_else] = ACTIONS(1879),
    [anon_sym_async] = ACTIONS(1879),
    [anon_sym_for] = ACTIONS(1879),
    [anon_sym_while] = ACTIONS(1879),
    [anon_sym_try] = ACTIONS(1879),
    [anon_sym_except] = ACTIONS(1879),
    [anon_sym_finally] = ACTIONS(1879),
    [anon_sym_with] = ACTIONS(1879),
    [anon_sym_def] = ACTIONS(1879),
    [anon_sym_global] = ACTIONS(1879),
    [anon_sym_nonlocal] = ACTIONS(1879),
    [anon_sym_exec] = ACTIONS(1879),
    [anon_sym_class] = ACTIONS(1879),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_not] = ACTIONS(1879),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_lambda] = ACTIONS(1879),
    [anon_sym_yield] = ACTIONS(1879),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [sym_ellipsis] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1877),
    [sym_integer] = ACTIONS(1879),
    [sym_float] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_true] = ACTIONS(1879),
    [sym_false] = ACTIONS(1879),
    [sym_none] = ACTIONS(1879),
    [anon_sym_await] = ACTIONS(1879),
    [sym_comment] = ACTIONS(73),
  },
  [515] = {
    [sym__newline] = ACTIONS(1881),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1881),
  },
  [516] = {
    [sym_import_statement] = STATE(515),
    [sym_import_from_statement] = STATE(515),
    [sym_print_statement] = STATE(515),
    [sym_assert_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_delete_statement] = STATE(515),
    [sym_raise_statement] = STATE(515),
    [sym_pass_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_global_statement] = STATE(515),
    [sym_nonlocal_statement] = STATE(515),
    [sym_exec_statement] = STATE(515),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(1883),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [517] = {
    [aux_sym__simple_statements_repeat1] = STATE(517),
    [sym__newline] = ACTIONS(1881),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1885),
  },
  [518] = {
    [sym__expression] = STATE(991),
    [sym__primary_expression] = STATE(523),
    [sym_not_operator] = STATE(991),
    [sym_boolean_operator] = STATE(991),
    [sym_binary_operator] = STATE(523),
    [sym_unary_operator] = STATE(523),
    [sym_comparison_operator] = STATE(991),
    [sym_lambda] = STATE(991),
    [sym_attribute] = STATE(523),
    [sym_subscript] = STATE(523),
    [sym_call] = STATE(523),
    [sym_list] = STATE(523),
    [sym_list_comprehension] = STATE(523),
    [sym_dictionary] = STATE(523),
    [sym_dictionary_comprehension] = STATE(523),
    [sym_set] = STATE(523),
    [sym_set_comprehension] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_tuple] = STATE(523),
    [sym_generator_expression] = STATE(523),
    [sym_conditional_expression] = STATE(991),
    [sym_concatenated_string] = STATE(523),
    [sym_string] = STATE(525),
    [sym_await] = STATE(991),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_lambda] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(909),
    [sym_float] = ACTIONS(909),
    [sym_identifier] = ACTIONS(909),
    [sym_true] = ACTIONS(909),
    [sym_false] = ACTIONS(909),
    [sym_none] = ACTIONS(909),
    [anon_sym_await] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
  },
  [519] = {
    [sym__primary_expression] = STATE(282),
    [sym_binary_operator] = STATE(282),
    [sym_unary_operator] = STATE(282),
    [sym_attribute] = STATE(282),
    [sym_subscript] = STATE(282),
    [sym_call] = STATE(282),
    [sym_list] = STATE(282),
    [sym_list_comprehension] = STATE(282),
    [sym_dictionary] = STATE(282),
    [sym_dictionary_comprehension] = STATE(282),
    [sym_set] = STATE(282),
    [sym_set_comprehension] = STATE(282),
    [sym_parenthesized_expression] = STATE(282),
    [sym_tuple] = STATE(282),
    [sym_generator_expression] = STATE(282),
    [sym_concatenated_string] = STATE(282),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(489),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(491),
    [sym_float] = ACTIONS(491),
    [sym_identifier] = ACTIONS(491),
    [sym_true] = ACTIONS(491),
    [sym_false] = ACTIONS(491),
    [sym_none] = ACTIONS(491),
    [sym_comment] = ACTIONS(73),
  },
  [520] = {
    [sym_lambda_parameters] = STATE(993),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1888),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [521] = {
    [sym__expression] = STATE(166),
    [sym__primary_expression] = STATE(523),
    [sym_not_operator] = STATE(166),
    [sym_boolean_operator] = STATE(166),
    [sym_binary_operator] = STATE(523),
    [sym_unary_operator] = STATE(523),
    [sym_comparison_operator] = STATE(166),
    [sym_lambda] = STATE(166),
    [sym_attribute] = STATE(523),
    [sym_subscript] = STATE(523),
    [sym_call] = STATE(523),
    [sym_list] = STATE(523),
    [sym_list_comprehension] = STATE(523),
    [sym_dictionary] = STATE(523),
    [sym_dictionary_comprehension] = STATE(523),
    [sym_set] = STATE(523),
    [sym_set_comprehension] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_tuple] = STATE(523),
    [sym_generator_expression] = STATE(523),
    [sym_conditional_expression] = STATE(166),
    [sym_concatenated_string] = STATE(523),
    [sym_string] = STATE(525),
    [sym_await] = STATE(166),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_lambda] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(909),
    [sym_float] = ACTIONS(909),
    [sym_identifier] = ACTIONS(909),
    [sym_true] = ACTIONS(909),
    [sym_false] = ACTIONS(909),
    [sym_none] = ACTIONS(909),
    [anon_sym_await] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
  },
  [522] = {
    [sym__newline] = ACTIONS(1890),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_EQ] = ACTIONS(1890),
    [anon_sym_and] = ACTIONS(1894),
    [anon_sym_or] = ACTIONS(1896),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1890),
  },
  [523] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [aux_sym_comparison_operator_repeat1] = STATE(1007),
    [sym__newline] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1900),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1902),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_not] = ACTIONS(1906),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_SLASH] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_SLASH_SLASH] = ACTIONS(1904),
    [anon_sym_STAR_STAR] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_CARET] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_LT_EQ] = ACTIONS(1902),
    [anon_sym_EQ_EQ] = ACTIONS(1902),
    [anon_sym_BANG_EQ] = ACTIONS(1902),
    [anon_sym_GT_EQ] = ACTIONS(1902),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_LT_GT] = ACTIONS(1902),
    [anon_sym_is] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(301),
  },
  [524] = {
    [sym__newline] = ACTIONS(1922),
    [anon_sym_EQ] = ACTIONS(1924),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1922),
  },
  [525] = {
    [sym_string] = STATE(1009),
    [aux_sym_concatenated_string_repeat1] = STATE(1009),
    [sym__newline] = ACTIONS(333),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(333),
  },
  [526] = {
    [sym__newline] = ACTIONS(1926),
    [anon_sym_COLON] = ACTIONS(283),
    [anon_sym_EQ] = ACTIONS(285),
    [anon_sym_PLUS_EQ] = ACTIONS(287),
    [anon_sym_DASH_EQ] = ACTIONS(287),
    [anon_sym_STAR_EQ] = ACTIONS(287),
    [anon_sym_SLASH_EQ] = ACTIONS(287),
    [anon_sym_AT_EQ] = ACTIONS(287),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(287),
    [anon_sym_PERCENT_EQ] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(287),
    [anon_sym_GT_GT_EQ] = ACTIONS(287),
    [anon_sym_LT_LT_EQ] = ACTIONS(287),
    [anon_sym_AMP_EQ] = ACTIONS(287),
    [anon_sym_CARET_EQ] = ACTIONS(287),
    [anon_sym_PIPE_EQ] = ACTIONS(287),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1926),
  },
  [527] = {
    [aux_sym_print_statement_repeat1] = STATE(1011),
    [sym__newline] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1928),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(295),
    [anon_sym_EQ] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(295),
    [anon_sym_DASH_EQ] = ACTIONS(295),
    [anon_sym_STAR_EQ] = ACTIONS(295),
    [anon_sym_SLASH_EQ] = ACTIONS(295),
    [anon_sym_AT_EQ] = ACTIONS(295),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(295),
    [anon_sym_PERCENT_EQ] = ACTIONS(295),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(295),
    [anon_sym_GT_GT_EQ] = ACTIONS(295),
    [anon_sym_LT_LT_EQ] = ACTIONS(295),
    [anon_sym_AMP_EQ] = ACTIONS(295),
    [anon_sym_CARET_EQ] = ACTIONS(295),
    [anon_sym_PIPE_EQ] = ACTIONS(295),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(295),
  },
  [528] = {
    [sym__newline] = ACTIONS(1922),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1922),
  },
  [529] = {
    [sym__newline] = ACTIONS(1930),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1930),
  },
  [530] = {
    [sym__newline] = ACTIONS(1932),
    [anon_sym_COMMA] = ACTIONS(1932),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(1932),
    [anon_sym_EQ] = ACTIONS(1932),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(1932),
    [anon_sym_DASH_EQ] = ACTIONS(1932),
    [anon_sym_STAR_EQ] = ACTIONS(1932),
    [anon_sym_SLASH_EQ] = ACTIONS(1932),
    [anon_sym_AT_EQ] = ACTIONS(1932),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1932),
    [anon_sym_PERCENT_EQ] = ACTIONS(1932),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1932),
    [anon_sym_GT_GT_EQ] = ACTIONS(1932),
    [anon_sym_LT_LT_EQ] = ACTIONS(1932),
    [anon_sym_AMP_EQ] = ACTIONS(1932),
    [anon_sym_CARET_EQ] = ACTIONS(1932),
    [anon_sym_PIPE_EQ] = ACTIONS(1932),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1932),
  },
  [531] = {
    [sym__expression] = STATE(1012),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1012),
    [sym_boolean_operator] = STATE(1012),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1012),
    [sym_lambda] = STATE(1012),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1012),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1012),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [532] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [533] = {
    [sym_lambda_parameters] = STATE(1014),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1934),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [534] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [535] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(1938),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [536] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(1029),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_else] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1948),
    [anon_sym_AT] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1950),
    [anon_sym_SLASH_SLASH] = ACTIONS(1950),
    [anon_sym_STAR_STAR] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1958),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_LT_EQ] = ACTIONS(1948),
    [anon_sym_EQ_EQ] = ACTIONS(1948),
    [anon_sym_BANG_EQ] = ACTIONS(1948),
    [anon_sym_GT_EQ] = ACTIONS(1948),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_LT_GT] = ACTIONS(1948),
    [anon_sym_is] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [537] = {
    [sym_string] = STATE(1030),
    [aux_sym_concatenated_string_repeat1] = STATE(1030),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [538] = {
    [sym__newline] = ACTIONS(1968),
    [anon_sym_from] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_COLON] = ACTIONS(1968),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(1968),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_PLUS_EQ] = ACTIONS(1968),
    [anon_sym_DASH_EQ] = ACTIONS(1968),
    [anon_sym_STAR_EQ] = ACTIONS(1968),
    [anon_sym_SLASH_EQ] = ACTIONS(1968),
    [anon_sym_AT_EQ] = ACTIONS(1968),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1968),
    [anon_sym_PERCENT_EQ] = ACTIONS(1968),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1968),
    [anon_sym_GT_GT_EQ] = ACTIONS(1968),
    [anon_sym_LT_LT_EQ] = ACTIONS(1968),
    [anon_sym_AMP_EQ] = ACTIONS(1968),
    [anon_sym_CARET_EQ] = ACTIONS(1968),
    [anon_sym_PIPE_EQ] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1968),
  },
  [539] = {
    [sym__newline] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_COLON] = ACTIONS(1968),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_PLUS_EQ] = ACTIONS(1968),
    [anon_sym_DASH_EQ] = ACTIONS(1968),
    [anon_sym_STAR_EQ] = ACTIONS(1968),
    [anon_sym_SLASH_EQ] = ACTIONS(1968),
    [anon_sym_AT_EQ] = ACTIONS(1968),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1968),
    [anon_sym_PERCENT_EQ] = ACTIONS(1968),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1968),
    [anon_sym_GT_GT_EQ] = ACTIONS(1968),
    [anon_sym_LT_LT_EQ] = ACTIONS(1968),
    [anon_sym_AMP_EQ] = ACTIONS(1968),
    [anon_sym_CARET_EQ] = ACTIONS(1968),
    [anon_sym_PIPE_EQ] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1968),
  },
  [540] = {
    [sym__expression] = STATE(530),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(530),
    [sym_boolean_operator] = STATE(530),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(530),
    [sym_lambda] = STATE(530),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(530),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(530),
    [sym__newline] = ACTIONS(1970),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_COLON] = ACTIONS(1972),
    [anon_sym_EQ] = ACTIONS(1972),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(917),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(1972),
    [anon_sym_DASH_EQ] = ACTIONS(1972),
    [anon_sym_STAR_EQ] = ACTIONS(1972),
    [anon_sym_SLASH_EQ] = ACTIONS(1972),
    [anon_sym_AT_EQ] = ACTIONS(1972),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1972),
    [anon_sym_PERCENT_EQ] = ACTIONS(1972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1972),
    [anon_sym_GT_GT_EQ] = ACTIONS(1972),
    [anon_sym_LT_LT_EQ] = ACTIONS(1972),
    [anon_sym_AMP_EQ] = ACTIONS(1972),
    [anon_sym_CARET_EQ] = ACTIONS(1972),
    [anon_sym_PIPE_EQ] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1970),
  },
  [541] = {
    [aux_sym_print_statement_repeat1] = STATE(541),
    [sym__newline] = ACTIONS(1932),
    [anon_sym_COMMA] = ACTIONS(1974),
    [anon_sym_COLON] = ACTIONS(1932),
    [anon_sym_EQ] = ACTIONS(1932),
    [anon_sym_PLUS_EQ] = ACTIONS(1932),
    [anon_sym_DASH_EQ] = ACTIONS(1932),
    [anon_sym_STAR_EQ] = ACTIONS(1932),
    [anon_sym_SLASH_EQ] = ACTIONS(1932),
    [anon_sym_AT_EQ] = ACTIONS(1932),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1932),
    [anon_sym_PERCENT_EQ] = ACTIONS(1932),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1932),
    [anon_sym_GT_GT_EQ] = ACTIONS(1932),
    [anon_sym_LT_LT_EQ] = ACTIONS(1932),
    [anon_sym_AMP_EQ] = ACTIONS(1932),
    [anon_sym_CARET_EQ] = ACTIONS(1932),
    [anon_sym_PIPE_EQ] = ACTIONS(1932),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1932),
  },
  [542] = {
    [sym__newline] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1977),
    [anon_sym_COLON] = ACTIONS(1977),
    [anon_sym_in] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_AT] = ACTIONS(1979),
    [anon_sym_not] = ACTIONS(1977),
    [anon_sym_and] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1977),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_SLASH_SLASH] = ACTIONS(1979),
    [anon_sym_STAR_STAR] = ACTIONS(1979),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_EQ] = ACTIONS(1977),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_LT_GT] = ACTIONS(1977),
    [anon_sym_is] = ACTIONS(1977),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_AT_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1977),
  },
  [543] = {
    [sym__newline] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1981),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1981),
    [anon_sym_COLON] = ACTIONS(1981),
    [anon_sym_in] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_AT] = ACTIONS(1983),
    [anon_sym_not] = ACTIONS(1981),
    [anon_sym_and] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1981),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1983),
    [anon_sym_SLASH_SLASH] = ACTIONS(1983),
    [anon_sym_STAR_STAR] = ACTIONS(1983),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_EQ] = ACTIONS(1981),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_LT_GT] = ACTIONS(1981),
    [anon_sym_is] = ACTIONS(1981),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_AT_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1981),
  },
  [544] = {
    [anon_sym_RPAREN] = ACTIONS(1985),
    [sym_comment] = ACTIONS(73),
  },
  [545] = {
    [sym__expression] = STATE(1034),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1034),
    [sym_boolean_operator] = STATE(1034),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1034),
    [sym_lambda] = STATE(1034),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1034),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1034),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [546] = {
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_async] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(1989),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(119),
    [anon_sym_SLASH_SLASH] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(119),
    [anon_sym_LT_LT] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [sym_comment] = ACTIONS(73),
  },
  [547] = {
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [548] = {
    [aux_sym_argument_list_repeat1] = STATE(1038),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1993),
    [sym_comment] = ACTIONS(73),
  },
  [549] = {
    [sym__comprehension_body] = STATE(255),
    [sym_for_in_clause] = STATE(256),
    [aux_sym_argument_list_repeat1] = STATE(1038),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(441),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [550] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1997),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_SLASH_SLASH] = ACTIONS(1997),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_PLUS_EQ] = ACTIONS(1995),
    [anon_sym_DASH_EQ] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_AT_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_PERCENT_EQ] = ACTIONS(1995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1995),
    [anon_sym_GT_GT_EQ] = ACTIONS(1995),
    [anon_sym_LT_LT_EQ] = ACTIONS(1995),
    [anon_sym_AMP_EQ] = ACTIONS(1995),
    [anon_sym_CARET_EQ] = ACTIONS(1995),
    [anon_sym_PIPE_EQ] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [551] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_PLUS_EQ] = ACTIONS(1995),
    [anon_sym_DASH_EQ] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_AT_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_PERCENT_EQ] = ACTIONS(1995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1995),
    [anon_sym_GT_GT_EQ] = ACTIONS(1995),
    [anon_sym_LT_LT_EQ] = ACTIONS(1995),
    [anon_sym_AMP_EQ] = ACTIONS(1995),
    [anon_sym_CARET_EQ] = ACTIONS(1995),
    [anon_sym_PIPE_EQ] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [552] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [sym__newline] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_AMP] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_PLUS_EQ] = ACTIONS(1999),
    [anon_sym_DASH_EQ] = ACTIONS(1999),
    [anon_sym_STAR_EQ] = ACTIONS(1999),
    [anon_sym_SLASH_EQ] = ACTIONS(1999),
    [anon_sym_AT_EQ] = ACTIONS(1999),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1999),
    [anon_sym_PERCENT_EQ] = ACTIONS(1999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1999),
    [anon_sym_GT_GT_EQ] = ACTIONS(1999),
    [anon_sym_LT_LT_EQ] = ACTIONS(1999),
    [anon_sym_AMP_EQ] = ACTIONS(1999),
    [anon_sym_CARET_EQ] = ACTIONS(1999),
    [anon_sym_PIPE_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(331),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1999),
  },
  [553] = {
    [sym__primary_expression] = STATE(1039),
    [sym_binary_operator] = STATE(1039),
    [sym_unary_operator] = STATE(1039),
    [sym_attribute] = STATE(1039),
    [sym_subscript] = STATE(1039),
    [sym_call] = STATE(1039),
    [sym_list] = STATE(1039),
    [sym_list_comprehension] = STATE(1039),
    [sym_dictionary] = STATE(1039),
    [sym_dictionary_comprehension] = STATE(1039),
    [sym_set] = STATE(1039),
    [sym_set_comprehension] = STATE(1039),
    [sym_parenthesized_expression] = STATE(1039),
    [sym_tuple] = STATE(1039),
    [sym_generator_expression] = STATE(1039),
    [sym_concatenated_string] = STATE(1039),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(2005),
    [sym_float] = ACTIONS(2005),
    [sym_identifier] = ACTIONS(2005),
    [sym_true] = ACTIONS(2005),
    [sym_false] = ACTIONS(2005),
    [sym_none] = ACTIONS(2005),
    [sym_comment] = ACTIONS(73),
  },
  [554] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_PLUS_EQ] = ACTIONS(1995),
    [anon_sym_DASH_EQ] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_AT_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_PERCENT_EQ] = ACTIONS(1995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1995),
    [anon_sym_GT_GT_EQ] = ACTIONS(1995),
    [anon_sym_LT_LT_EQ] = ACTIONS(1995),
    [anon_sym_AMP_EQ] = ACTIONS(1995),
    [anon_sym_CARET_EQ] = ACTIONS(1995),
    [anon_sym_PIPE_EQ] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [555] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1997),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_SLASH_SLASH] = ACTIONS(1997),
    [anon_sym_STAR_STAR] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_PLUS_EQ] = ACTIONS(1995),
    [anon_sym_DASH_EQ] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_AT_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_PERCENT_EQ] = ACTIONS(1995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1995),
    [anon_sym_GT_GT_EQ] = ACTIONS(1995),
    [anon_sym_LT_LT_EQ] = ACTIONS(1995),
    [anon_sym_AMP_EQ] = ACTIONS(1995),
    [anon_sym_CARET_EQ] = ACTIONS(1995),
    [anon_sym_PIPE_EQ] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [556] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_PLUS_EQ] = ACTIONS(1995),
    [anon_sym_DASH_EQ] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_AT_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_PERCENT_EQ] = ACTIONS(1995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1995),
    [anon_sym_GT_GT_EQ] = ACTIONS(1995),
    [anon_sym_LT_LT_EQ] = ACTIONS(1995),
    [anon_sym_AMP_EQ] = ACTIONS(1995),
    [anon_sym_CARET_EQ] = ACTIONS(1995),
    [anon_sym_PIPE_EQ] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [557] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_PLUS_EQ] = ACTIONS(1995),
    [anon_sym_DASH_EQ] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_AT_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_PERCENT_EQ] = ACTIONS(1995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1995),
    [anon_sym_GT_GT_EQ] = ACTIONS(1995),
    [anon_sym_LT_LT_EQ] = ACTIONS(1995),
    [anon_sym_AMP_EQ] = ACTIONS(1995),
    [anon_sym_CARET_EQ] = ACTIONS(1995),
    [anon_sym_PIPE_EQ] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [558] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_PLUS_EQ] = ACTIONS(1995),
    [anon_sym_DASH_EQ] = ACTIONS(1995),
    [anon_sym_STAR_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_AT_EQ] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1995),
    [anon_sym_PERCENT_EQ] = ACTIONS(1995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1995),
    [anon_sym_GT_GT_EQ] = ACTIONS(1995),
    [anon_sym_LT_LT_EQ] = ACTIONS(1995),
    [anon_sym_AMP_EQ] = ACTIONS(1995),
    [anon_sym_CARET_EQ] = ACTIONS(1995),
    [anon_sym_PIPE_EQ] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [559] = {
    [sym__expression] = STATE(1041),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1041),
    [sym_boolean_operator] = STATE(1041),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1041),
    [sym_lambda] = STATE(1041),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1041),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1041),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(2007),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(2009),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2007),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [560] = {
    [sym__expression] = STATE(1042),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1042),
    [sym_boolean_operator] = STATE(1042),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1042),
    [sym_lambda] = STATE(1042),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1042),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1042),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [561] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [562] = {
    [sym_lambda_parameters] = STATE(1044),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [563] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [564] = {
    [aux_sym_subscript_repeat1] = STATE(1051),
    [anon_sym_COMMA] = ACTIONS(2013),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_RBRACK] = ACTIONS(2023),
    [sym_comment] = ACTIONS(73),
  },
  [565] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(1062),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(2029),
    [anon_sym_AT] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(2033),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_PERCENT] = ACTIONS(2031),
    [anon_sym_SLASH_SLASH] = ACTIONS(2031),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(2043),
    [anon_sym_LT_LT] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2029),
    [anon_sym_EQ_EQ] = ACTIONS(2029),
    [anon_sym_BANG_EQ] = ACTIONS(2029),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_GT] = ACTIONS(2045),
    [anon_sym_LT_GT] = ACTIONS(2029),
    [anon_sym_is] = ACTIONS(2047),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [566] = {
    [aux_sym_subscript_repeat1] = STATE(1051),
    [anon_sym_COMMA] = ACTIONS(2013),
    [anon_sym_RBRACK] = ACTIONS(2023),
    [sym_comment] = ACTIONS(73),
  },
  [567] = {
    [sym_string] = STATE(1063),
    [aux_sym_concatenated_string_repeat1] = STATE(1063),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [568] = {
    [aux_sym_comparison_operator_repeat1] = STATE(568),
    [sym__newline] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_not] = ACTIONS(2052),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2049),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_GT_EQ] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2049),
    [anon_sym_is] = ACTIONS(2058),
    [anon_sym_PLUS_EQ] = ACTIONS(1999),
    [anon_sym_DASH_EQ] = ACTIONS(1999),
    [anon_sym_STAR_EQ] = ACTIONS(1999),
    [anon_sym_SLASH_EQ] = ACTIONS(1999),
    [anon_sym_AT_EQ] = ACTIONS(1999),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1999),
    [anon_sym_PERCENT_EQ] = ACTIONS(1999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1999),
    [anon_sym_GT_GT_EQ] = ACTIONS(1999),
    [anon_sym_LT_LT_EQ] = ACTIONS(1999),
    [anon_sym_AMP_EQ] = ACTIONS(1999),
    [anon_sym_CARET_EQ] = ACTIONS(1999),
    [anon_sym_PIPE_EQ] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1999),
  },
  [569] = {
    [sym_string] = STATE(569),
    [aux_sym_concatenated_string_repeat1] = STATE(569),
    [sym__newline] = ACTIONS(2061),
    [sym__string_start] = ACTIONS(2063),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2066),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_EQ] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(2066),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2066),
    [anon_sym_DASH] = ACTIONS(2066),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2066),
    [anon_sym_SLASH_SLASH] = ACTIONS(2066),
    [anon_sym_STAR_STAR] = ACTIONS(2066),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2066),
    [anon_sym_CARET] = ACTIONS(2066),
    [anon_sym_LT_LT] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_PLUS_EQ] = ACTIONS(2061),
    [anon_sym_DASH_EQ] = ACTIONS(2061),
    [anon_sym_STAR_EQ] = ACTIONS(2061),
    [anon_sym_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_AT_EQ] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2061),
    [anon_sym_PERCENT_EQ] = ACTIONS(2061),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2061),
    [anon_sym_GT_GT_EQ] = ACTIONS(2061),
    [anon_sym_LT_LT_EQ] = ACTIONS(2061),
    [anon_sym_AMP_EQ] = ACTIONS(2061),
    [anon_sym_CARET_EQ] = ACTIONS(2061),
    [anon_sym_PIPE_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2061),
  },
  [570] = {
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(1121),
    [anon_sym_or] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(731),
    [sym_type_conversion] = ACTIONS(731),
    [sym_comment] = ACTIONS(73),
  },
  [571] = {
    [sym__expression] = STATE(1064),
    [sym__primary_expression] = STATE(203),
    [sym_not_operator] = STATE(1064),
    [sym_boolean_operator] = STATE(1064),
    [sym_binary_operator] = STATE(203),
    [sym_unary_operator] = STATE(203),
    [sym_comparison_operator] = STATE(1064),
    [sym_lambda] = STATE(1064),
    [sym_attribute] = STATE(203),
    [sym_subscript] = STATE(203),
    [sym_call] = STATE(203),
    [sym_list] = STATE(203),
    [sym_list_comprehension] = STATE(203),
    [sym_dictionary] = STATE(203),
    [sym_dictionary_comprehension] = STATE(203),
    [sym_set] = STATE(203),
    [sym_set_comprehension] = STATE(203),
    [sym_parenthesized_expression] = STATE(203),
    [sym_tuple] = STATE(203),
    [sym_generator_expression] = STATE(203),
    [sym_conditional_expression] = STATE(1064),
    [sym_concatenated_string] = STATE(203),
    [sym_string] = STATE(204),
    [sym_await] = STATE(1064),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [572] = {
    [anon_sym_COLON] = ACTIONS(2068),
    [sym_comment] = ACTIONS(73),
  },
  [573] = {
    [sym__expression] = STATE(1066),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1066),
    [sym_boolean_operator] = STATE(1066),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1066),
    [sym_lambda] = STATE(1066),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1066),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1066),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [574] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(203),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(203),
    [sym_unary_operator] = STATE(203),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(203),
    [sym_subscript] = STATE(203),
    [sym_call] = STATE(203),
    [sym_list] = STATE(203),
    [sym_list_comprehension] = STATE(203),
    [sym_dictionary] = STATE(203),
    [sym_dictionary_comprehension] = STATE(203),
    [sym_set] = STATE(203),
    [sym_set_comprehension] = STATE(203),
    [sym_parenthesized_expression] = STATE(203),
    [sym_tuple] = STATE(203),
    [sym_generator_expression] = STATE(203),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(203),
    [sym_string] = STATE(204),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [575] = {
    [sym__expression] = STATE(1067),
    [sym__primary_expression] = STATE(203),
    [sym_not_operator] = STATE(1067),
    [sym_boolean_operator] = STATE(1067),
    [sym_binary_operator] = STATE(203),
    [sym_unary_operator] = STATE(203),
    [sym_comparison_operator] = STATE(1067),
    [sym_lambda] = STATE(1067),
    [sym_attribute] = STATE(203),
    [sym_subscript] = STATE(203),
    [sym_call] = STATE(203),
    [sym_list] = STATE(203),
    [sym_list_comprehension] = STATE(203),
    [sym_dictionary] = STATE(203),
    [sym_dictionary_comprehension] = STATE(203),
    [sym_set] = STATE(203),
    [sym_set_comprehension] = STATE(203),
    [sym_parenthesized_expression] = STATE(203),
    [sym_tuple] = STATE(203),
    [sym_generator_expression] = STATE(203),
    [sym_conditional_expression] = STATE(1067),
    [sym_concatenated_string] = STATE(203),
    [sym_string] = STATE(204),
    [sym_await] = STATE(1067),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [576] = {
    [sym__string_content] = ACTIONS(2070),
    [sym__string_end] = ACTIONS(2070),
    [anon_sym_LBRACE] = ACTIONS(2072),
    [sym_escape_sequence] = ACTIONS(2072),
    [sym_comment] = ACTIONS(83),
  },
  [577] = {
    [anon_sym_RBRACE] = ACTIONS(2074),
    [sym_comment] = ACTIONS(73),
  },
  [578] = {
    [sym__primary_expression] = STATE(1069),
    [sym_binary_operator] = STATE(1069),
    [sym_unary_operator] = STATE(1069),
    [sym_attribute] = STATE(1069),
    [sym_subscript] = STATE(1069),
    [sym_call] = STATE(1069),
    [sym_list] = STATE(1069),
    [sym_list_comprehension] = STATE(1069),
    [sym_dictionary] = STATE(1069),
    [sym_dictionary_comprehension] = STATE(1069),
    [sym_set] = STATE(1069),
    [sym_set_comprehension] = STATE(1069),
    [sym_parenthesized_expression] = STATE(1069),
    [sym_tuple] = STATE(1069),
    [sym_generator_expression] = STATE(1069),
    [sym_concatenated_string] = STATE(1069),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2078),
    [sym_float] = ACTIONS(2078),
    [sym_identifier] = ACTIONS(2078),
    [sym_true] = ACTIONS(2078),
    [sym_false] = ACTIONS(2078),
    [sym_none] = ACTIONS(2078),
    [sym_comment] = ACTIONS(73),
  },
  [579] = {
    [sym__primary_expression] = STATE(1070),
    [sym_binary_operator] = STATE(1070),
    [sym_unary_operator] = STATE(1070),
    [sym_attribute] = STATE(1070),
    [sym_subscript] = STATE(1070),
    [sym_call] = STATE(1070),
    [sym_list] = STATE(1070),
    [sym_list_comprehension] = STATE(1070),
    [sym_dictionary] = STATE(1070),
    [sym_dictionary_comprehension] = STATE(1070),
    [sym_set] = STATE(1070),
    [sym_set_comprehension] = STATE(1070),
    [sym_parenthesized_expression] = STATE(1070),
    [sym_tuple] = STATE(1070),
    [sym_generator_expression] = STATE(1070),
    [sym_concatenated_string] = STATE(1070),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2080),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2082),
    [sym_float] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2082),
    [sym_true] = ACTIONS(2082),
    [sym_false] = ACTIONS(2082),
    [sym_none] = ACTIONS(2082),
    [sym_comment] = ACTIONS(73),
  },
  [580] = {
    [sym__primary_expression] = STATE(1071),
    [sym_binary_operator] = STATE(1071),
    [sym_unary_operator] = STATE(1071),
    [sym_attribute] = STATE(1071),
    [sym_subscript] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_list] = STATE(1071),
    [sym_list_comprehension] = STATE(1071),
    [sym_dictionary] = STATE(1071),
    [sym_dictionary_comprehension] = STATE(1071),
    [sym_set] = STATE(1071),
    [sym_set_comprehension] = STATE(1071),
    [sym_parenthesized_expression] = STATE(1071),
    [sym_tuple] = STATE(1071),
    [sym_generator_expression] = STATE(1071),
    [sym_concatenated_string] = STATE(1071),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2086),
    [sym_float] = ACTIONS(2086),
    [sym_identifier] = ACTIONS(2086),
    [sym_true] = ACTIONS(2086),
    [sym_false] = ACTIONS(2086),
    [sym_none] = ACTIONS(2086),
    [sym_comment] = ACTIONS(73),
  },
  [581] = {
    [anon_sym_in] = ACTIONS(2088),
    [sym_comment] = ACTIONS(73),
  },
  [582] = {
    [sym__primary_expression] = STATE(1073),
    [sym_binary_operator] = STATE(1073),
    [sym_unary_operator] = STATE(1073),
    [sym_attribute] = STATE(1073),
    [sym_subscript] = STATE(1073),
    [sym_call] = STATE(1073),
    [sym_list] = STATE(1073),
    [sym_list_comprehension] = STATE(1073),
    [sym_dictionary] = STATE(1073),
    [sym_dictionary_comprehension] = STATE(1073),
    [sym_set] = STATE(1073),
    [sym_set_comprehension] = STATE(1073),
    [sym_parenthesized_expression] = STATE(1073),
    [sym_tuple] = STATE(1073),
    [sym_generator_expression] = STATE(1073),
    [sym_concatenated_string] = STATE(1073),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2090),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2092),
    [sym_float] = ACTIONS(2092),
    [sym_identifier] = ACTIONS(2092),
    [sym_true] = ACTIONS(2092),
    [sym_false] = ACTIONS(2092),
    [sym_none] = ACTIONS(2092),
    [sym_comment] = ACTIONS(73),
  },
  [583] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [584] = {
    [sym__primary_expression] = STATE(1074),
    [sym_binary_operator] = STATE(1074),
    [sym_unary_operator] = STATE(1074),
    [sym_attribute] = STATE(1074),
    [sym_subscript] = STATE(1074),
    [sym_call] = STATE(1074),
    [sym_list] = STATE(1074),
    [sym_list_comprehension] = STATE(1074),
    [sym_dictionary] = STATE(1074),
    [sym_dictionary_comprehension] = STATE(1074),
    [sym_set] = STATE(1074),
    [sym_set_comprehension] = STATE(1074),
    [sym_parenthesized_expression] = STATE(1074),
    [sym_tuple] = STATE(1074),
    [sym_generator_expression] = STATE(1074),
    [sym_concatenated_string] = STATE(1074),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2094),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2096),
    [sym_float] = ACTIONS(2096),
    [sym_identifier] = ACTIONS(2096),
    [sym_true] = ACTIONS(2096),
    [sym_false] = ACTIONS(2096),
    [sym_none] = ACTIONS(2096),
    [sym_comment] = ACTIONS(73),
  },
  [585] = {
    [sym__primary_expression] = STATE(1075),
    [sym_binary_operator] = STATE(1075),
    [sym_unary_operator] = STATE(1075),
    [sym_attribute] = STATE(1075),
    [sym_subscript] = STATE(1075),
    [sym_call] = STATE(1075),
    [sym_list] = STATE(1075),
    [sym_list_comprehension] = STATE(1075),
    [sym_dictionary] = STATE(1075),
    [sym_dictionary_comprehension] = STATE(1075),
    [sym_set] = STATE(1075),
    [sym_set_comprehension] = STATE(1075),
    [sym_parenthesized_expression] = STATE(1075),
    [sym_tuple] = STATE(1075),
    [sym_generator_expression] = STATE(1075),
    [sym_concatenated_string] = STATE(1075),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2098),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2100),
    [sym_float] = ACTIONS(2100),
    [sym_identifier] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_none] = ACTIONS(2100),
    [sym_comment] = ACTIONS(73),
  },
  [586] = {
    [sym__primary_expression] = STATE(1076),
    [sym_binary_operator] = STATE(1076),
    [sym_unary_operator] = STATE(1076),
    [sym_attribute] = STATE(1076),
    [sym_subscript] = STATE(1076),
    [sym_call] = STATE(1076),
    [sym_list] = STATE(1076),
    [sym_list_comprehension] = STATE(1076),
    [sym_dictionary] = STATE(1076),
    [sym_dictionary_comprehension] = STATE(1076),
    [sym_set] = STATE(1076),
    [sym_set_comprehension] = STATE(1076),
    [sym_parenthesized_expression] = STATE(1076),
    [sym_tuple] = STATE(1076),
    [sym_generator_expression] = STATE(1076),
    [sym_concatenated_string] = STATE(1076),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2102),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2104),
    [sym_float] = ACTIONS(2104),
    [sym_identifier] = ACTIONS(2104),
    [sym_true] = ACTIONS(2104),
    [sym_false] = ACTIONS(2104),
    [sym_none] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
  },
  [587] = {
    [sym__primary_expression] = STATE(1071),
    [sym_binary_operator] = STATE(1071),
    [sym_unary_operator] = STATE(1071),
    [sym_attribute] = STATE(1071),
    [sym_subscript] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_list] = STATE(1071),
    [sym_list_comprehension] = STATE(1071),
    [sym_dictionary] = STATE(1071),
    [sym_dictionary_comprehension] = STATE(1071),
    [sym_set] = STATE(1071),
    [sym_set_comprehension] = STATE(1071),
    [sym_parenthesized_expression] = STATE(1071),
    [sym_tuple] = STATE(1071),
    [sym_generator_expression] = STATE(1071),
    [sym_concatenated_string] = STATE(1071),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2086),
    [sym_float] = ACTIONS(2086),
    [sym_identifier] = ACTIONS(2086),
    [sym_true] = ACTIONS(2086),
    [sym_false] = ACTIONS(2086),
    [sym_none] = ACTIONS(2086),
    [sym_comment] = ACTIONS(73),
  },
  [588] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1077),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1149),
    [anon_sym_LT_GT] = ACTIONS(1133),
    [anon_sym_is] = ACTIONS(1151),
    [anon_sym_RBRACE] = ACTIONS(999),
    [sym_type_conversion] = ACTIONS(999),
    [sym_comment] = ACTIONS(73),
  },
  [589] = {
    [sym_string] = STATE(1078),
    [aux_sym_concatenated_string_repeat1] = STATE(1078),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [sym_type_conversion] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [590] = {
    [sym__newline] = ACTIONS(2108),
    [anon_sym_DOT] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_COMMA] = ACTIONS(2108),
    [anon_sym_as] = ACTIONS(2108),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2108),
  },
  [591] = {
    [aux_sym_dotted_name_repeat1] = STATE(591),
    [sym__newline] = ACTIONS(2108),
    [anon_sym_DOT] = ACTIONS(2110),
    [anon_sym_COMMA] = ACTIONS(2108),
    [anon_sym_as] = ACTIONS(2108),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2108),
  },
  [592] = {
    [sym__newline] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2113),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2113),
  },
  [593] = {
    [sym__newline] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2113),
    [anon_sym_as] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2113),
  },
  [594] = {
    [sym_aliased_import] = STATE(592),
    [sym_dotted_name] = STATE(593),
    [sym__newline] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(85),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2115),
  },
  [595] = {
    [aux_sym__import_list_repeat1] = STATE(595),
    [sym__newline] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2117),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2113),
  },
  [596] = {
    [sym__newline] = ACTIONS(2120),
    [anon_sym_COMMA] = ACTIONS(2120),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2120),
  },
  [597] = {
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_DOT] = ACTIONS(2108),
    [anon_sym_RPAREN] = ACTIONS(2108),
    [anon_sym_COMMA] = ACTIONS(2108),
    [anon_sym_as] = ACTIONS(2108),
    [sym_comment] = ACTIONS(73),
  },
  [598] = {
    [aux_sym_dotted_name_repeat1] = STATE(598),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_DOT] = ACTIONS(2122),
    [sym_comment] = ACTIONS(73),
  },
  [599] = {
    [sym__import_list] = STATE(1081),
    [sym_aliased_import] = STATE(1082),
    [sym_dotted_name] = STATE(1083),
    [sym_identifier] = ACTIONS(2125),
    [sym_comment] = ACTIONS(73),
  },
  [600] = {
    [sym__newline] = ACTIONS(2127),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2127),
  },
  [601] = {
    [sym__newline] = ACTIONS(2129),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2129),
  },
  [602] = {
    [sym__string_start] = ACTIONS(1153),
    [anon_sym_DOT] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1153),
    [anon_sym_as] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_COLON] = ACTIONS(1153),
    [anon_sym_else] = ACTIONS(1153),
    [anon_sym_async] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(1153),
    [anon_sym_EQ] = ACTIONS(1155),
    [anon_sym_AT] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1153),
    [anon_sym_and] = ACTIONS(1153),
    [anon_sym_or] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1153),
    [anon_sym_DASH] = ACTIONS(1153),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1153),
    [anon_sym_SLASH_SLASH] = ACTIONS(1153),
    [anon_sym_STAR_STAR] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_LT_LT] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1153),
    [anon_sym_EQ_EQ] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_LT_GT] = ACTIONS(1153),
    [anon_sym_is] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_RBRACK] = ACTIONS(1153),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [sym_type_conversion] = ACTIONS(1153),
    [sym_comment] = ACTIONS(73),
  },
  [603] = {
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_GT_GT] = ACTIONS(1199),
    [anon_sym_if] = ACTIONS(1199),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_else] = ACTIONS(1199),
    [anon_sym_async] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1199),
    [anon_sym_in] = ACTIONS(1199),
    [anon_sym_EQ] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_not] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1199),
    [anon_sym_or] = ACTIONS(1199),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_SLASH_SLASH] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_LT_GT] = ACTIONS(1199),
    [anon_sym_is] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [sym_type_conversion] = ACTIONS(1199),
    [sym_comment] = ACTIONS(73),
  },
  [604] = {
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1253),
    [anon_sym_RPAREN] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(1255),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_COLON] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_in] = ACTIONS(1253),
    [anon_sym_EQ] = ACTIONS(1255),
    [anon_sym_AT] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1253),
    [anon_sym_and] = ACTIONS(1253),
    [anon_sym_or] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1253),
    [anon_sym_SLASH_SLASH] = ACTIONS(1253),
    [anon_sym_STAR_STAR] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_LT_EQ] = ACTIONS(1253),
    [anon_sym_EQ_EQ] = ACTIONS(1253),
    [anon_sym_BANG_EQ] = ACTIONS(1253),
    [anon_sym_GT_EQ] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_LT_GT] = ACTIONS(1253),
    [anon_sym_is] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1253),
    [anon_sym_RBRACK] = ACTIONS(1253),
    [anon_sym_RBRACE] = ACTIONS(1253),
    [sym_type_conversion] = ACTIONS(1253),
    [sym_comment] = ACTIONS(73),
  },
  [605] = {
    [sym__expression] = STATE(644),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(644),
    [sym_boolean_operator] = STATE(644),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(644),
    [sym_lambda] = STATE(644),
    [sym_yield] = STATE(645),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(644),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(644),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(2131),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [606] = {
    [anon_sym_RPAREN] = ACTIONS(2133),
    [sym_comment] = ACTIONS(73),
  },
  [607] = {
    [aux_sym_tuple_repeat1] = STATE(655),
    [anon_sym_RPAREN] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2135),
    [sym_comment] = ACTIONS(73),
  },
  [608] = {
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [609] = {
    [sym__expression] = STATE(1087),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(1087),
    [sym_boolean_operator] = STATE(1087),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(1087),
    [sym_lambda] = STATE(1087),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(1087),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(1087),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [610] = {
    [anon_sym_RPAREN] = ACTIONS(1689),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [611] = {
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [612] = {
    [sym__expression] = STATE(1088),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1088),
    [sym_boolean_operator] = STATE(1088),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1088),
    [sym_lambda] = STATE(1088),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1088),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1088),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [613] = {
    [anon_sym_COLON] = ACTIONS(2137),
    [sym_comment] = ACTIONS(73),
  },
  [614] = {
    [sym__expression] = STATE(1090),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1090),
    [sym_boolean_operator] = STATE(1090),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1090),
    [sym_lambda] = STATE(1090),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1090),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1090),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [615] = {
    [sym__expression] = STATE(1091),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1091),
    [sym_boolean_operator] = STATE(1091),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1091),
    [sym_lambda] = STATE(1091),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1091),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1091),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [616] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [617] = {
    [sym__expression] = STATE(1092),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1092),
    [sym_boolean_operator] = STATE(1092),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1092),
    [sym_lambda] = STATE(1092),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1092),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1092),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [618] = {
    [aux_sym_print_statement_repeat1] = STATE(1094),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(2139),
    [sym_comment] = ACTIONS(73),
  },
  [619] = {
    [sym__primary_expression] = STATE(1095),
    [sym_binary_operator] = STATE(1095),
    [sym_unary_operator] = STATE(1095),
    [sym_attribute] = STATE(1095),
    [sym_subscript] = STATE(1095),
    [sym_call] = STATE(1095),
    [sym_list] = STATE(1095),
    [sym_list_comprehension] = STATE(1095),
    [sym_dictionary] = STATE(1095),
    [sym_dictionary_comprehension] = STATE(1095),
    [sym_set] = STATE(1095),
    [sym_set_comprehension] = STATE(1095),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_tuple] = STATE(1095),
    [sym_generator_expression] = STATE(1095),
    [sym_concatenated_string] = STATE(1095),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2143),
    [sym_float] = ACTIONS(2143),
    [sym_identifier] = ACTIONS(2143),
    [sym_true] = ACTIONS(2143),
    [sym_false] = ACTIONS(2143),
    [sym_none] = ACTIONS(2143),
    [sym_comment] = ACTIONS(73),
  },
  [620] = {
    [sym__primary_expression] = STATE(1096),
    [sym_binary_operator] = STATE(1096),
    [sym_unary_operator] = STATE(1096),
    [sym_attribute] = STATE(1096),
    [sym_subscript] = STATE(1096),
    [sym_call] = STATE(1096),
    [sym_list] = STATE(1096),
    [sym_list_comprehension] = STATE(1096),
    [sym_dictionary] = STATE(1096),
    [sym_dictionary_comprehension] = STATE(1096),
    [sym_set] = STATE(1096),
    [sym_set_comprehension] = STATE(1096),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_tuple] = STATE(1096),
    [sym_generator_expression] = STATE(1096),
    [sym_concatenated_string] = STATE(1096),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2147),
    [sym_float] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_none] = ACTIONS(2147),
    [sym_comment] = ACTIONS(73),
  },
  [621] = {
    [sym__primary_expression] = STATE(1097),
    [sym_binary_operator] = STATE(1097),
    [sym_unary_operator] = STATE(1097),
    [sym_attribute] = STATE(1097),
    [sym_subscript] = STATE(1097),
    [sym_call] = STATE(1097),
    [sym_list] = STATE(1097),
    [sym_list_comprehension] = STATE(1097),
    [sym_dictionary] = STATE(1097),
    [sym_dictionary_comprehension] = STATE(1097),
    [sym_set] = STATE(1097),
    [sym_set_comprehension] = STATE(1097),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_tuple] = STATE(1097),
    [sym_generator_expression] = STATE(1097),
    [sym_concatenated_string] = STATE(1097),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2151),
    [sym_float] = ACTIONS(2151),
    [sym_identifier] = ACTIONS(2151),
    [sym_true] = ACTIONS(2151),
    [sym_false] = ACTIONS(2151),
    [sym_none] = ACTIONS(2151),
    [sym_comment] = ACTIONS(73),
  },
  [622] = {
    [anon_sym_in] = ACTIONS(2153),
    [sym_comment] = ACTIONS(73),
  },
  [623] = {
    [sym__primary_expression] = STATE(1099),
    [sym_binary_operator] = STATE(1099),
    [sym_unary_operator] = STATE(1099),
    [sym_attribute] = STATE(1099),
    [sym_subscript] = STATE(1099),
    [sym_call] = STATE(1099),
    [sym_list] = STATE(1099),
    [sym_list_comprehension] = STATE(1099),
    [sym_dictionary] = STATE(1099),
    [sym_dictionary_comprehension] = STATE(1099),
    [sym_set] = STATE(1099),
    [sym_set_comprehension] = STATE(1099),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_tuple] = STATE(1099),
    [sym_generator_expression] = STATE(1099),
    [sym_concatenated_string] = STATE(1099),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2157),
    [sym_float] = ACTIONS(2157),
    [sym_identifier] = ACTIONS(2157),
    [sym_true] = ACTIONS(2157),
    [sym_false] = ACTIONS(2157),
    [sym_none] = ACTIONS(2157),
    [sym_comment] = ACTIONS(73),
  },
  [624] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [625] = {
    [sym__primary_expression] = STATE(1100),
    [sym_binary_operator] = STATE(1100),
    [sym_unary_operator] = STATE(1100),
    [sym_attribute] = STATE(1100),
    [sym_subscript] = STATE(1100),
    [sym_call] = STATE(1100),
    [sym_list] = STATE(1100),
    [sym_list_comprehension] = STATE(1100),
    [sym_dictionary] = STATE(1100),
    [sym_dictionary_comprehension] = STATE(1100),
    [sym_set] = STATE(1100),
    [sym_set_comprehension] = STATE(1100),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_tuple] = STATE(1100),
    [sym_generator_expression] = STATE(1100),
    [sym_concatenated_string] = STATE(1100),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2161),
    [sym_float] = ACTIONS(2161),
    [sym_identifier] = ACTIONS(2161),
    [sym_true] = ACTIONS(2161),
    [sym_false] = ACTIONS(2161),
    [sym_none] = ACTIONS(2161),
    [sym_comment] = ACTIONS(73),
  },
  [626] = {
    [sym__primary_expression] = STATE(1101),
    [sym_binary_operator] = STATE(1101),
    [sym_unary_operator] = STATE(1101),
    [sym_attribute] = STATE(1101),
    [sym_subscript] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_list] = STATE(1101),
    [sym_list_comprehension] = STATE(1101),
    [sym_dictionary] = STATE(1101),
    [sym_dictionary_comprehension] = STATE(1101),
    [sym_set] = STATE(1101),
    [sym_set_comprehension] = STATE(1101),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_tuple] = STATE(1101),
    [sym_generator_expression] = STATE(1101),
    [sym_concatenated_string] = STATE(1101),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2165),
    [sym_float] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_true] = ACTIONS(2165),
    [sym_false] = ACTIONS(2165),
    [sym_none] = ACTIONS(2165),
    [sym_comment] = ACTIONS(73),
  },
  [627] = {
    [sym__primary_expression] = STATE(1102),
    [sym_binary_operator] = STATE(1102),
    [sym_unary_operator] = STATE(1102),
    [sym_attribute] = STATE(1102),
    [sym_subscript] = STATE(1102),
    [sym_call] = STATE(1102),
    [sym_list] = STATE(1102),
    [sym_list_comprehension] = STATE(1102),
    [sym_dictionary] = STATE(1102),
    [sym_dictionary_comprehension] = STATE(1102),
    [sym_set] = STATE(1102),
    [sym_set_comprehension] = STATE(1102),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_tuple] = STATE(1102),
    [sym_generator_expression] = STATE(1102),
    [sym_concatenated_string] = STATE(1102),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2169),
    [sym_float] = ACTIONS(2169),
    [sym_identifier] = ACTIONS(2169),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_none] = ACTIONS(2169),
    [sym_comment] = ACTIONS(73),
  },
  [628] = {
    [sym__primary_expression] = STATE(1097),
    [sym_binary_operator] = STATE(1097),
    [sym_unary_operator] = STATE(1097),
    [sym_attribute] = STATE(1097),
    [sym_subscript] = STATE(1097),
    [sym_call] = STATE(1097),
    [sym_list] = STATE(1097),
    [sym_list_comprehension] = STATE(1097),
    [sym_dictionary] = STATE(1097),
    [sym_dictionary_comprehension] = STATE(1097),
    [sym_set] = STATE(1097),
    [sym_set_comprehension] = STATE(1097),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_tuple] = STATE(1097),
    [sym_generator_expression] = STATE(1097),
    [sym_concatenated_string] = STATE(1097),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2151),
    [sym_float] = ACTIONS(2151),
    [sym_identifier] = ACTIONS(2151),
    [sym_true] = ACTIONS(2151),
    [sym_false] = ACTIONS(2151),
    [sym_none] = ACTIONS(2151),
    [sym_comment] = ACTIONS(73),
  },
  [629] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1103),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(1219),
    [anon_sym_not] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_LT_EQ] = ACTIONS(1219),
    [anon_sym_EQ_EQ] = ACTIONS(1219),
    [anon_sym_BANG_EQ] = ACTIONS(1219),
    [anon_sym_GT_EQ] = ACTIONS(1219),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_LT_GT] = ACTIONS(1219),
    [anon_sym_is] = ACTIONS(1237),
    [sym_comment] = ACTIONS(73),
  },
  [630] = {
    [sym_string] = STATE(1104),
    [aux_sym_concatenated_string_repeat1] = STATE(1104),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_RPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [631] = {
    [anon_sym_DOT] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1691),
    [anon_sym_as] = ACTIONS(1693),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1691),
    [anon_sym_if] = ACTIONS(1691),
    [anon_sym_COLON] = ACTIONS(1691),
    [anon_sym_else] = ACTIONS(1691),
    [anon_sym_async] = ACTIONS(1691),
    [anon_sym_for] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(1691),
    [anon_sym_EQ] = ACTIONS(1693),
    [anon_sym_AT] = ACTIONS(1691),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_and] = ACTIONS(1691),
    [anon_sym_or] = ACTIONS(1691),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1691),
    [anon_sym_SLASH_SLASH] = ACTIONS(1691),
    [anon_sym_STAR_STAR] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_CARET] = ACTIONS(1691),
    [anon_sym_LT_LT] = ACTIONS(1691),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1691),
    [anon_sym_EQ_EQ] = ACTIONS(1691),
    [anon_sym_BANG_EQ] = ACTIONS(1691),
    [anon_sym_GT_EQ] = ACTIONS(1691),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_LT_GT] = ACTIONS(1691),
    [anon_sym_is] = ACTIONS(1691),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_RBRACK] = ACTIONS(1691),
    [anon_sym_RBRACE] = ACTIONS(1691),
    [sym_type_conversion] = ACTIONS(1691),
    [sym_comment] = ACTIONS(73),
  },
  [632] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(912),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2173),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [633] = {
    [aux_sym_list_repeat1] = STATE(914),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACK] = ACTIONS(2173),
    [sym_comment] = ACTIONS(73),
  },
  [634] = {
    [anon_sym_RBRACK] = ACTIONS(2177),
    [sym_comment] = ACTIONS(73),
  },
  [635] = {
    [anon_sym_DOT] = ACTIONS(1771),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_RPAREN] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1771),
    [anon_sym_as] = ACTIONS(1773),
    [anon_sym_STAR] = ACTIONS(1773),
    [anon_sym_GT_GT] = ACTIONS(1771),
    [anon_sym_if] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1771),
    [anon_sym_else] = ACTIONS(1771),
    [anon_sym_async] = ACTIONS(1771),
    [anon_sym_for] = ACTIONS(1771),
    [anon_sym_in] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1773),
    [anon_sym_AT] = ACTIONS(1771),
    [anon_sym_not] = ACTIONS(1771),
    [anon_sym_and] = ACTIONS(1771),
    [anon_sym_or] = ACTIONS(1771),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_SLASH] = ACTIONS(1773),
    [anon_sym_PERCENT] = ACTIONS(1771),
    [anon_sym_SLASH_SLASH] = ACTIONS(1771),
    [anon_sym_STAR_STAR] = ACTIONS(1771),
    [anon_sym_PIPE] = ACTIONS(1771),
    [anon_sym_AMP] = ACTIONS(1771),
    [anon_sym_CARET] = ACTIONS(1771),
    [anon_sym_LT_LT] = ACTIONS(1771),
    [anon_sym_LT] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1771),
    [anon_sym_EQ_EQ] = ACTIONS(1771),
    [anon_sym_BANG_EQ] = ACTIONS(1771),
    [anon_sym_GT_EQ] = ACTIONS(1771),
    [anon_sym_GT] = ACTIONS(1773),
    [anon_sym_LT_GT] = ACTIONS(1771),
    [anon_sym_is] = ACTIONS(1771),
    [anon_sym_LBRACK] = ACTIONS(1771),
    [anon_sym_RBRACK] = ACTIONS(1771),
    [anon_sym_RBRACE] = ACTIONS(1771),
    [sym_type_conversion] = ACTIONS(1771),
    [sym_comment] = ACTIONS(73),
  },
  [636] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(955),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(955),
    [sym_boolean_operator] = STATE(955),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(955),
    [sym_lambda] = STATE(955),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(955),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(955),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2179),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [637] = {
    [anon_sym_DOT] = ACTIONS(1813),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_RPAREN] = ACTIONS(1813),
    [anon_sym_COMMA] = ACTIONS(1813),
    [anon_sym_as] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_GT_GT] = ACTIONS(1813),
    [anon_sym_if] = ACTIONS(1813),
    [anon_sym_COLON] = ACTIONS(1813),
    [anon_sym_else] = ACTIONS(1813),
    [anon_sym_async] = ACTIONS(1813),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_in] = ACTIONS(1813),
    [anon_sym_EQ] = ACTIONS(1815),
    [anon_sym_AT] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1813),
    [anon_sym_and] = ACTIONS(1813),
    [anon_sym_or] = ACTIONS(1813),
    [anon_sym_PLUS] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1813),
    [anon_sym_SLASH] = ACTIONS(1815),
    [anon_sym_PERCENT] = ACTIONS(1813),
    [anon_sym_SLASH_SLASH] = ACTIONS(1813),
    [anon_sym_STAR_STAR] = ACTIONS(1813),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_AMP] = ACTIONS(1813),
    [anon_sym_CARET] = ACTIONS(1813),
    [anon_sym_LT_LT] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_LT_EQ] = ACTIONS(1813),
    [anon_sym_EQ_EQ] = ACTIONS(1813),
    [anon_sym_BANG_EQ] = ACTIONS(1813),
    [anon_sym_GT_EQ] = ACTIONS(1813),
    [anon_sym_GT] = ACTIONS(1815),
    [anon_sym_LT_GT] = ACTIONS(1813),
    [anon_sym_is] = ACTIONS(1813),
    [anon_sym_LBRACK] = ACTIONS(1813),
    [anon_sym_RBRACK] = ACTIONS(1813),
    [anon_sym_RBRACE] = ACTIONS(1813),
    [sym_type_conversion] = ACTIONS(1813),
    [sym_comment] = ACTIONS(73),
  },
  [638] = {
    [aux_sym_list_repeat1] = STATE(957),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2179),
    [sym_comment] = ACTIONS(73),
  },
  [639] = {
    [sym_dictionary_splat] = STATE(960),
    [sym__expression] = STATE(961),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(961),
    [sym_boolean_operator] = STATE(961),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(961),
    [sym_lambda] = STATE(961),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_pair] = STATE(960),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(961),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(961),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [640] = {
    [aux_sym_dictionary_repeat1] = STATE(963),
    [anon_sym_COMMA] = ACTIONS(2185),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(73),
  },
  [641] = {
    [anon_sym_RBRACE] = ACTIONS(2187),
    [sym_comment] = ACTIONS(73),
  },
  [642] = {
    [anon_sym_RBRACE] = ACTIONS(2189),
    [sym_comment] = ACTIONS(73),
  },
  [643] = {
    [sym__newline] = ACTIONS(2191),
    [anon_sym_DOT] = ACTIONS(2191),
    [anon_sym_LPAREN] = ACTIONS(2191),
    [anon_sym_COMMA] = ACTIONS(2191),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_GT_GT] = ACTIONS(2193),
    [anon_sym_if] = ACTIONS(2191),
    [anon_sym_COLON] = ACTIONS(2191),
    [anon_sym_in] = ACTIONS(2191),
    [anon_sym_EQ] = ACTIONS(2193),
    [anon_sym_AT] = ACTIONS(2193),
    [anon_sym_not] = ACTIONS(2191),
    [anon_sym_and] = ACTIONS(2191),
    [anon_sym_or] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2193),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [anon_sym_SLASH_SLASH] = ACTIONS(2193),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2193),
    [anon_sym_CARET] = ACTIONS(2193),
    [anon_sym_LT_LT] = ACTIONS(2193),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_LT_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ] = ACTIONS(2191),
    [anon_sym_GT_EQ] = ACTIONS(2191),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_LT_GT] = ACTIONS(2191),
    [anon_sym_is] = ACTIONS(2191),
    [anon_sym_PLUS_EQ] = ACTIONS(2191),
    [anon_sym_DASH_EQ] = ACTIONS(2191),
    [anon_sym_STAR_EQ] = ACTIONS(2191),
    [anon_sym_SLASH_EQ] = ACTIONS(2191),
    [anon_sym_AT_EQ] = ACTIONS(2191),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2191),
    [anon_sym_PERCENT_EQ] = ACTIONS(2191),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2191),
    [anon_sym_GT_GT_EQ] = ACTIONS(2191),
    [anon_sym_LT_LT_EQ] = ACTIONS(2191),
    [anon_sym_AMP_EQ] = ACTIONS(2191),
    [anon_sym_CARET_EQ] = ACTIONS(2191),
    [anon_sym_PIPE_EQ] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2191),
  },
  [644] = {
    [anon_sym_RPAREN] = ACTIONS(2195),
    [anon_sym_COMMA] = ACTIONS(2195),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [645] = {
    [anon_sym_RPAREN] = ACTIONS(2195),
    [anon_sym_COMMA] = ACTIONS(2195),
    [sym_comment] = ACTIONS(73),
  },
  [646] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [647] = {
    [sym_variables] = STATE(1115),
    [sym__primary_expression] = STATE(108),
    [sym_binary_operator] = STATE(108),
    [sym_unary_operator] = STATE(108),
    [sym_attribute] = STATE(108),
    [sym_subscript] = STATE(108),
    [sym_call] = STATE(108),
    [sym_list] = STATE(108),
    [sym_list_comprehension] = STATE(108),
    [sym_dictionary] = STATE(108),
    [sym_dictionary_comprehension] = STATE(108),
    [sym_set] = STATE(108),
    [sym_set_comprehension] = STATE(108),
    [sym_parenthesized_expression] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_generator_expression] = STATE(108),
    [sym_concatenated_string] = STATE(108),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [648] = {
    [anon_sym_in] = ACTIONS(2199),
    [sym_comment] = ACTIONS(73),
  },
  [649] = {
    [anon_sym_RPAREN] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_as] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_COLON] = ACTIONS(1968),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(1968),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_RBRACK] = ACTIONS(1968),
    [anon_sym_RBRACE] = ACTIONS(1968),
    [sym_type_conversion] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [650] = {
    [anon_sym_RPAREN] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [651] = {
    [sym__newline] = ACTIONS(2203),
    [anon_sym_DOT] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_COLON] = ACTIONS(2203),
    [anon_sym_in] = ACTIONS(2203),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [anon_sym_not] = ACTIONS(2203),
    [anon_sym_and] = ACTIONS(2203),
    [anon_sym_or] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2205),
    [anon_sym_SLASH_SLASH] = ACTIONS(2205),
    [anon_sym_STAR_STAR] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [anon_sym_CARET] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ] = ACTIONS(2203),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_GT_EQ] = ACTIONS(2203),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_LT_GT] = ACTIONS(2203),
    [anon_sym_is] = ACTIONS(2203),
    [anon_sym_PLUS_EQ] = ACTIONS(2203),
    [anon_sym_DASH_EQ] = ACTIONS(2203),
    [anon_sym_STAR_EQ] = ACTIONS(2203),
    [anon_sym_SLASH_EQ] = ACTIONS(2203),
    [anon_sym_AT_EQ] = ACTIONS(2203),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2203),
    [anon_sym_PERCENT_EQ] = ACTIONS(2203),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2203),
    [anon_sym_GT_GT_EQ] = ACTIONS(2203),
    [anon_sym_LT_LT_EQ] = ACTIONS(2203),
    [anon_sym_AMP_EQ] = ACTIONS(2203),
    [anon_sym_CARET_EQ] = ACTIONS(2203),
    [anon_sym_PIPE_EQ] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2203),
  },
  [652] = {
    [sym__expression] = STATE(1121),
    [sym__primary_expression] = STATE(1122),
    [sym_not_operator] = STATE(1121),
    [sym_boolean_operator] = STATE(1121),
    [sym_binary_operator] = STATE(1122),
    [sym_unary_operator] = STATE(1122),
    [sym_comparison_operator] = STATE(1121),
    [sym_lambda] = STATE(1121),
    [sym_attribute] = STATE(1122),
    [sym_subscript] = STATE(1122),
    [sym_call] = STATE(1122),
    [sym_list] = STATE(1122),
    [sym_list_comprehension] = STATE(1122),
    [sym_dictionary] = STATE(1122),
    [sym_dictionary_comprehension] = STATE(1122),
    [sym_set] = STATE(1122),
    [sym_set_comprehension] = STATE(1122),
    [sym_parenthesized_expression] = STATE(1122),
    [sym_tuple] = STATE(1122),
    [sym_generator_expression] = STATE(1122),
    [sym_conditional_expression] = STATE(1121),
    [sym_concatenated_string] = STATE(1122),
    [sym_string] = STATE(1123),
    [sym_await] = STATE(1121),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_lambda] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2215),
    [sym_float] = ACTIONS(2215),
    [sym_identifier] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_none] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2217),
    [sym_comment] = ACTIONS(73),
  },
  [653] = {
    [sym_for_in_clause] = STATE(1124),
    [sym_if_clause] = STATE(1124),
    [aux_sym__comprehension_body_repeat1] = STATE(1124),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_async] = ACTIONS(441),
    [anon_sym_for] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [654] = {
    [sym__expression] = STATE(644),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(644),
    [sym_boolean_operator] = STATE(644),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(644),
    [sym_lambda] = STATE(644),
    [sym_yield] = STATE(645),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(644),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(644),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(2221),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [655] = {
    [aux_sym_tuple_repeat1] = STATE(655),
    [anon_sym_RPAREN] = ACTIONS(2195),
    [anon_sym_COMMA] = ACTIONS(2223),
    [sym_comment] = ACTIONS(73),
  },
  [656] = {
    [anon_sym_DOT] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_as] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1977),
    [anon_sym_if] = ACTIONS(1977),
    [anon_sym_COLON] = ACTIONS(1977),
    [anon_sym_else] = ACTIONS(1977),
    [anon_sym_async] = ACTIONS(1977),
    [anon_sym_for] = ACTIONS(1977),
    [anon_sym_in] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_AT] = ACTIONS(1977),
    [anon_sym_not] = ACTIONS(1977),
    [anon_sym_and] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1977),
    [anon_sym_PLUS] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1977),
    [anon_sym_SLASH_SLASH] = ACTIONS(1977),
    [anon_sym_STAR_STAR] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1977),
    [anon_sym_CARET] = ACTIONS(1977),
    [anon_sym_LT_LT] = ACTIONS(1977),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_EQ] = ACTIONS(1977),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_LT_GT] = ACTIONS(1977),
    [anon_sym_is] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_RBRACK] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [sym_type_conversion] = ACTIONS(1977),
    [sym_comment] = ACTIONS(73),
  },
  [657] = {
    [anon_sym_DOT] = ACTIONS(1981),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_as] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1981),
    [anon_sym_if] = ACTIONS(1981),
    [anon_sym_COLON] = ACTIONS(1981),
    [anon_sym_else] = ACTIONS(1981),
    [anon_sym_async] = ACTIONS(1981),
    [anon_sym_for] = ACTIONS(1981),
    [anon_sym_in] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_AT] = ACTIONS(1981),
    [anon_sym_not] = ACTIONS(1981),
    [anon_sym_and] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1981),
    [anon_sym_PLUS] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1981),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1981),
    [anon_sym_SLASH_SLASH] = ACTIONS(1981),
    [anon_sym_STAR_STAR] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1981),
    [anon_sym_CARET] = ACTIONS(1981),
    [anon_sym_LT_LT] = ACTIONS(1981),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_EQ] = ACTIONS(1981),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_LT_GT] = ACTIONS(1981),
    [anon_sym_is] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_RBRACK] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [sym_type_conversion] = ACTIONS(1981),
    [sym_comment] = ACTIONS(73),
  },
  [658] = {
    [anon_sym_RPAREN] = ACTIONS(2226),
    [sym_comment] = ACTIONS(73),
  },
  [659] = {
    [aux_sym_argument_list_repeat1] = STATE(1129),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2228),
    [sym_comment] = ACTIONS(73),
  },
  [660] = {
    [sym__comprehension_body] = STATE(606),
    [sym_for_in_clause] = STATE(256),
    [aux_sym_argument_list_repeat1] = STATE(1129),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(441),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [661] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [662] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(459),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [663] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(459),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [664] = {
    [sym__primary_expression] = STATE(1130),
    [sym_binary_operator] = STATE(1130),
    [sym_unary_operator] = STATE(1130),
    [sym_attribute] = STATE(1130),
    [sym_subscript] = STATE(1130),
    [sym_call] = STATE(1130),
    [sym_list] = STATE(1130),
    [sym_list_comprehension] = STATE(1130),
    [sym_dictionary] = STATE(1130),
    [sym_dictionary_comprehension] = STATE(1130),
    [sym_set] = STATE(1130),
    [sym_set_comprehension] = STATE(1130),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_tuple] = STATE(1130),
    [sym_generator_expression] = STATE(1130),
    [sym_concatenated_string] = STATE(1130),
    [sym_string] = STATE(68),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2232),
    [sym_float] = ACTIONS(2232),
    [sym_identifier] = ACTIONS(2232),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [sym_none] = ACTIONS(2232),
    [sym_comment] = ACTIONS(73),
  },
  [665] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(459),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [666] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_else] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_type_conversion] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [667] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(459),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [668] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(459),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [669] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(459),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [670] = {
    [aux_sym_subscript_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_RBRACK] = ACTIONS(2236),
    [sym_comment] = ACTIONS(73),
  },
  [671] = {
    [aux_sym_subscript_repeat1] = STATE(1133),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2236),
    [sym_comment] = ACTIONS(73),
  },
  [672] = {
    [aux_sym_comparison_operator_repeat1] = STATE(672),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2238),
    [anon_sym_not] = ACTIONS(2241),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_LT_EQ] = ACTIONS(2238),
    [anon_sym_EQ_EQ] = ACTIONS(2238),
    [anon_sym_BANG_EQ] = ACTIONS(2238),
    [anon_sym_GT_EQ] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_LT_GT] = ACTIONS(2238),
    [anon_sym_is] = ACTIONS(2247),
    [sym_comment] = ACTIONS(73),
  },
  [673] = {
    [sym_string] = STATE(673),
    [aux_sym_concatenated_string_repeat1] = STATE(673),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_async] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [674] = {
    [sym__newline] = ACTIONS(1153),
    [sym__string_start] = ACTIONS(1153),
    [anon_sym_DOT] = ACTIONS(1153),
    [anon_sym_from] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(1153),
    [anon_sym_EQ] = ACTIONS(1155),
    [anon_sym_AT] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1153),
    [anon_sym_and] = ACTIONS(1153),
    [anon_sym_or] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1153),
    [anon_sym_DASH] = ACTIONS(1153),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1153),
    [anon_sym_SLASH_SLASH] = ACTIONS(1153),
    [anon_sym_STAR_STAR] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_LT_LT] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1153),
    [anon_sym_EQ_EQ] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_LT_GT] = ACTIONS(1153),
    [anon_sym_is] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1153),
  },
  [675] = {
    [sym__newline] = ACTIONS(1199),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_from] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1201),
    [anon_sym_GT_GT] = ACTIONS(1199),
    [anon_sym_if] = ACTIONS(1199),
    [anon_sym_in] = ACTIONS(1199),
    [anon_sym_EQ] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_not] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1199),
    [anon_sym_or] = ACTIONS(1199),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_SLASH_SLASH] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_LT_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_GT_EQ] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_LT_GT] = ACTIONS(1199),
    [anon_sym_is] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1199),
  },
  [676] = {
    [sym__newline] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_from] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_in] = ACTIONS(1253),
    [anon_sym_EQ] = ACTIONS(1255),
    [anon_sym_AT] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1253),
    [anon_sym_and] = ACTIONS(1253),
    [anon_sym_or] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1253),
    [anon_sym_SLASH_SLASH] = ACTIONS(1253),
    [anon_sym_STAR_STAR] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_LT_EQ] = ACTIONS(1253),
    [anon_sym_EQ_EQ] = ACTIONS(1253),
    [anon_sym_BANG_EQ] = ACTIONS(1253),
    [anon_sym_GT_EQ] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_LT_GT] = ACTIONS(1253),
    [anon_sym_is] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1253),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1253),
  },
  [677] = {
    [sym__expression] = STATE(644),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(644),
    [sym_boolean_operator] = STATE(644),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(644),
    [sym_lambda] = STATE(644),
    [sym_yield] = STATE(645),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(644),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(644),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(2253),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [678] = {
    [anon_sym_RPAREN] = ACTIONS(2255),
    [sym_comment] = ACTIONS(73),
  },
  [679] = {
    [aux_sym_tuple_repeat1] = STATE(655),
    [anon_sym_RPAREN] = ACTIONS(2253),
    [anon_sym_COMMA] = ACTIONS(2257),
    [sym_comment] = ACTIONS(73),
  },
  [680] = {
    [sym__newline] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(511),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1671),
  },
  [681] = {
    [sym__expression] = STATE(1137),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(1137),
    [sym_boolean_operator] = STATE(1137),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(1137),
    [sym_lambda] = STATE(1137),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(1137),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(1137),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [682] = {
    [sym__newline] = ACTIONS(1691),
    [anon_sym_DOT] = ACTIONS(1691),
    [anon_sym_from] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1691),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1691),
    [anon_sym_if] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(1691),
    [anon_sym_EQ] = ACTIONS(1693),
    [anon_sym_AT] = ACTIONS(1691),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_and] = ACTIONS(1691),
    [anon_sym_or] = ACTIONS(1691),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1691),
    [anon_sym_SLASH_SLASH] = ACTIONS(1691),
    [anon_sym_STAR_STAR] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_CARET] = ACTIONS(1691),
    [anon_sym_LT_LT] = ACTIONS(1691),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1691),
    [anon_sym_EQ_EQ] = ACTIONS(1691),
    [anon_sym_BANG_EQ] = ACTIONS(1691),
    [anon_sym_GT_EQ] = ACTIONS(1691),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_LT_GT] = ACTIONS(1691),
    [anon_sym_is] = ACTIONS(1691),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1691),
  },
  [683] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(912),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2259),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [684] = {
    [aux_sym_list_repeat1] = STATE(914),
    [anon_sym_COMMA] = ACTIONS(2261),
    [anon_sym_RBRACK] = ACTIONS(2259),
    [sym_comment] = ACTIONS(73),
  },
  [685] = {
    [anon_sym_RBRACK] = ACTIONS(2263),
    [sym_comment] = ACTIONS(73),
  },
  [686] = {
    [sym__newline] = ACTIONS(1771),
    [anon_sym_DOT] = ACTIONS(1771),
    [anon_sym_from] = ACTIONS(1771),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1773),
    [anon_sym_GT_GT] = ACTIONS(1771),
    [anon_sym_if] = ACTIONS(1771),
    [anon_sym_in] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1773),
    [anon_sym_AT] = ACTIONS(1771),
    [anon_sym_not] = ACTIONS(1771),
    [anon_sym_and] = ACTIONS(1771),
    [anon_sym_or] = ACTIONS(1771),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_SLASH] = ACTIONS(1773),
    [anon_sym_PERCENT] = ACTIONS(1771),
    [anon_sym_SLASH_SLASH] = ACTIONS(1771),
    [anon_sym_STAR_STAR] = ACTIONS(1771),
    [anon_sym_PIPE] = ACTIONS(1771),
    [anon_sym_AMP] = ACTIONS(1771),
    [anon_sym_CARET] = ACTIONS(1771),
    [anon_sym_LT_LT] = ACTIONS(1771),
    [anon_sym_LT] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1771),
    [anon_sym_EQ_EQ] = ACTIONS(1771),
    [anon_sym_BANG_EQ] = ACTIONS(1771),
    [anon_sym_GT_EQ] = ACTIONS(1771),
    [anon_sym_GT] = ACTIONS(1773),
    [anon_sym_LT_GT] = ACTIONS(1771),
    [anon_sym_is] = ACTIONS(1771),
    [anon_sym_LBRACK] = ACTIONS(1771),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1771),
  },
  [687] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(955),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(955),
    [sym_boolean_operator] = STATE(955),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(955),
    [sym_lambda] = STATE(955),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(955),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(955),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2265),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [688] = {
    [sym__newline] = ACTIONS(1813),
    [anon_sym_DOT] = ACTIONS(1813),
    [anon_sym_from] = ACTIONS(1813),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_COMMA] = ACTIONS(1813),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_GT_GT] = ACTIONS(1813),
    [anon_sym_if] = ACTIONS(1813),
    [anon_sym_in] = ACTIONS(1813),
    [anon_sym_EQ] = ACTIONS(1815),
    [anon_sym_AT] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1813),
    [anon_sym_and] = ACTIONS(1813),
    [anon_sym_or] = ACTIONS(1813),
    [anon_sym_PLUS] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1813),
    [anon_sym_SLASH] = ACTIONS(1815),
    [anon_sym_PERCENT] = ACTIONS(1813),
    [anon_sym_SLASH_SLASH] = ACTIONS(1813),
    [anon_sym_STAR_STAR] = ACTIONS(1813),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_AMP] = ACTIONS(1813),
    [anon_sym_CARET] = ACTIONS(1813),
    [anon_sym_LT_LT] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_LT_EQ] = ACTIONS(1813),
    [anon_sym_EQ_EQ] = ACTIONS(1813),
    [anon_sym_BANG_EQ] = ACTIONS(1813),
    [anon_sym_GT_EQ] = ACTIONS(1813),
    [anon_sym_GT] = ACTIONS(1815),
    [anon_sym_LT_GT] = ACTIONS(1813),
    [anon_sym_is] = ACTIONS(1813),
    [anon_sym_LBRACK] = ACTIONS(1813),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1813),
  },
  [689] = {
    [aux_sym_list_repeat1] = STATE(957),
    [anon_sym_COMMA] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2265),
    [sym_comment] = ACTIONS(73),
  },
  [690] = {
    [sym_dictionary_splat] = STATE(960),
    [sym__expression] = STATE(961),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(961),
    [sym_boolean_operator] = STATE(961),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(961),
    [sym_lambda] = STATE(961),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_pair] = STATE(960),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(961),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(961),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2269),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [691] = {
    [aux_sym_dictionary_repeat1] = STATE(963),
    [anon_sym_COMMA] = ACTIONS(2271),
    [anon_sym_RBRACE] = ACTIONS(2269),
    [sym_comment] = ACTIONS(73),
  },
  [692] = {
    [anon_sym_RBRACE] = ACTIONS(2273),
    [sym_comment] = ACTIONS(73),
  },
  [693] = {
    [anon_sym_RBRACE] = ACTIONS(2275),
    [sym_comment] = ACTIONS(73),
  },
  [694] = {
    [sym__newline] = ACTIONS(1932),
    [anon_sym_COMMA] = ACTIONS(1932),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(511),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1932),
  },
  [695] = {
    [sym__expression] = STATE(694),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(694),
    [sym_boolean_operator] = STATE(694),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(694),
    [sym_lambda] = STATE(694),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(694),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(694),
    [sym__newline] = ACTIONS(2277),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2277),
  },
  [696] = {
    [aux_sym_print_statement_repeat1] = STATE(696),
    [sym__newline] = ACTIONS(1932),
    [anon_sym_COMMA] = ACTIONS(2279),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1932),
  },
  [697] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(2282),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [698] = {
    [sym__newline] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1968),
  },
  [699] = {
    [sym__newline] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1977),
    [anon_sym_from] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1977),
    [anon_sym_if] = ACTIONS(1977),
    [anon_sym_in] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_AT] = ACTIONS(1977),
    [anon_sym_not] = ACTIONS(1977),
    [anon_sym_and] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1977),
    [anon_sym_PLUS] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1977),
    [anon_sym_SLASH_SLASH] = ACTIONS(1977),
    [anon_sym_STAR_STAR] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1977),
    [anon_sym_CARET] = ACTIONS(1977),
    [anon_sym_LT_LT] = ACTIONS(1977),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_EQ] = ACTIONS(1977),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_LT_GT] = ACTIONS(1977),
    [anon_sym_is] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1977),
  },
  [700] = {
    [sym__newline] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1981),
    [anon_sym_from] = ACTIONS(1981),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1981),
    [anon_sym_if] = ACTIONS(1981),
    [anon_sym_in] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_AT] = ACTIONS(1981),
    [anon_sym_not] = ACTIONS(1981),
    [anon_sym_and] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1981),
    [anon_sym_PLUS] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1981),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1981),
    [anon_sym_SLASH_SLASH] = ACTIONS(1981),
    [anon_sym_STAR_STAR] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1981),
    [anon_sym_CARET] = ACTIONS(1981),
    [anon_sym_LT_LT] = ACTIONS(1981),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_EQ] = ACTIONS(1981),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_LT_GT] = ACTIONS(1981),
    [anon_sym_is] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1981),
  },
  [701] = {
    [anon_sym_RPAREN] = ACTIONS(2284),
    [sym_comment] = ACTIONS(73),
  },
  [702] = {
    [aux_sym_argument_list_repeat1] = STATE(1150),
    [anon_sym_RPAREN] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2286),
    [sym_comment] = ACTIONS(73),
  },
  [703] = {
    [sym__comprehension_body] = STATE(678),
    [sym_for_in_clause] = STATE(256),
    [aux_sym_argument_list_repeat1] = STATE(1150),
    [anon_sym_RPAREN] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(441),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [704] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(529),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [705] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(523),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(523),
    [anon_sym_SLASH_SLASH] = ACTIONS(523),
    [anon_sym_STAR_STAR] = ACTIONS(529),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [706] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(523),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(523),
    [anon_sym_SLASH_SLASH] = ACTIONS(523),
    [anon_sym_STAR_STAR] = ACTIONS(529),
    [anon_sym_PIPE] = ACTIONS(531),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_CARET] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1999),
  },
  [707] = {
    [sym__primary_expression] = STATE(1151),
    [sym_binary_operator] = STATE(1151),
    [sym_unary_operator] = STATE(1151),
    [sym_attribute] = STATE(1151),
    [sym_subscript] = STATE(1151),
    [sym_call] = STATE(1151),
    [sym_list] = STATE(1151),
    [sym_list_comprehension] = STATE(1151),
    [sym_dictionary] = STATE(1151),
    [sym_dictionary_comprehension] = STATE(1151),
    [sym_set] = STATE(1151),
    [sym_set_comprehension] = STATE(1151),
    [sym_parenthesized_expression] = STATE(1151),
    [sym_tuple] = STATE(1151),
    [sym_generator_expression] = STATE(1151),
    [sym_concatenated_string] = STATE(1151),
    [sym_string] = STATE(82),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2290),
    [sym_float] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2290),
    [sym_true] = ACTIONS(2290),
    [sym_false] = ACTIONS(2290),
    [sym_none] = ACTIONS(2290),
    [sym_comment] = ACTIONS(73),
  },
  [708] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(523),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(523),
    [anon_sym_SLASH_SLASH] = ACTIONS(523),
    [anon_sym_STAR_STAR] = ACTIONS(529),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [709] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_from] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [710] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(523),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(523),
    [anon_sym_SLASH_SLASH] = ACTIONS(523),
    [anon_sym_STAR_STAR] = ACTIONS(529),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_CARET] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [711] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(523),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(523),
    [anon_sym_SLASH_SLASH] = ACTIONS(523),
    [anon_sym_STAR_STAR] = ACTIONS(529),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [712] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(523),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(523),
    [anon_sym_SLASH_SLASH] = ACTIONS(523),
    [anon_sym_STAR_STAR] = ACTIONS(529),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [713] = {
    [aux_sym_subscript_repeat1] = STATE(1154),
    [anon_sym_COMMA] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_RBRACK] = ACTIONS(2294),
    [sym_comment] = ACTIONS(73),
  },
  [714] = {
    [aux_sym_subscript_repeat1] = STATE(1154),
    [anon_sym_COMMA] = ACTIONS(2292),
    [anon_sym_RBRACK] = ACTIONS(2294),
    [sym_comment] = ACTIONS(73),
  },
  [715] = {
    [aux_sym_comparison_operator_repeat1] = STATE(715),
    [sym__newline] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2296),
    [anon_sym_BANG_EQ] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2296),
    [anon_sym_GT] = ACTIONS(2302),
    [anon_sym_LT_GT] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2305),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1999),
  },
  [716] = {
    [sym_string] = STATE(716),
    [aux_sym_concatenated_string_repeat1] = STATE(716),
    [sym__newline] = ACTIONS(2061),
    [sym__string_start] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2061),
  },
  [717] = {
    [sym__expression] = STATE(694),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(694),
    [sym_boolean_operator] = STATE(694),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(694),
    [sym_lambda] = STATE(694),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(694),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(694),
    [sym__newline] = ACTIONS(1972),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1972),
  },
  [718] = {
    [sym__newline] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(1391),
    [anon_sym_or] = ACTIONS(1393),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(731),
  },
  [719] = {
    [sym__expression] = STATE(1155),
    [sym__primary_expression] = STATE(325),
    [sym_not_operator] = STATE(1155),
    [sym_boolean_operator] = STATE(1155),
    [sym_binary_operator] = STATE(325),
    [sym_unary_operator] = STATE(325),
    [sym_comparison_operator] = STATE(1155),
    [sym_lambda] = STATE(1155),
    [sym_attribute] = STATE(325),
    [sym_subscript] = STATE(325),
    [sym_call] = STATE(325),
    [sym_list] = STATE(325),
    [sym_list_comprehension] = STATE(325),
    [sym_dictionary] = STATE(325),
    [sym_dictionary_comprehension] = STATE(325),
    [sym_set] = STATE(325),
    [sym_set_comprehension] = STATE(325),
    [sym_parenthesized_expression] = STATE(325),
    [sym_tuple] = STATE(325),
    [sym_generator_expression] = STATE(325),
    [sym_conditional_expression] = STATE(1155),
    [sym_concatenated_string] = STATE(325),
    [sym_string] = STATE(326),
    [sym_await] = STATE(1155),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_lambda] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(561),
    [sym_float] = ACTIONS(561),
    [sym_identifier] = ACTIONS(561),
    [sym_true] = ACTIONS(561),
    [sym_false] = ACTIONS(561),
    [sym_none] = ACTIONS(561),
    [anon_sym_await] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
  },
  [720] = {
    [anon_sym_COLON] = ACTIONS(2311),
    [sym_comment] = ACTIONS(73),
  },
  [721] = {
    [sym__expression] = STATE(1157),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1157),
    [sym_boolean_operator] = STATE(1157),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1157),
    [sym_lambda] = STATE(1157),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1157),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1157),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [722] = {
    [sym__expression] = STATE(538),
    [sym__primary_expression] = STATE(325),
    [sym_not_operator] = STATE(538),
    [sym_boolean_operator] = STATE(538),
    [sym_binary_operator] = STATE(325),
    [sym_unary_operator] = STATE(325),
    [sym_comparison_operator] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym_attribute] = STATE(325),
    [sym_subscript] = STATE(325),
    [sym_call] = STATE(325),
    [sym_list] = STATE(325),
    [sym_list_comprehension] = STATE(325),
    [sym_dictionary] = STATE(325),
    [sym_dictionary_comprehension] = STATE(325),
    [sym_set] = STATE(325),
    [sym_set_comprehension] = STATE(325),
    [sym_parenthesized_expression] = STATE(325),
    [sym_tuple] = STATE(325),
    [sym_generator_expression] = STATE(325),
    [sym_conditional_expression] = STATE(538),
    [sym_concatenated_string] = STATE(325),
    [sym_string] = STATE(326),
    [sym_await] = STATE(538),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_lambda] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(561),
    [sym_float] = ACTIONS(561),
    [sym_identifier] = ACTIONS(561),
    [sym_true] = ACTIONS(561),
    [sym_false] = ACTIONS(561),
    [sym_none] = ACTIONS(561),
    [anon_sym_await] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
  },
  [723] = {
    [sym__expression] = STATE(1158),
    [sym__primary_expression] = STATE(325),
    [sym_not_operator] = STATE(1158),
    [sym_boolean_operator] = STATE(1158),
    [sym_binary_operator] = STATE(325),
    [sym_unary_operator] = STATE(325),
    [sym_comparison_operator] = STATE(1158),
    [sym_lambda] = STATE(1158),
    [sym_attribute] = STATE(325),
    [sym_subscript] = STATE(325),
    [sym_call] = STATE(325),
    [sym_list] = STATE(325),
    [sym_list_comprehension] = STATE(325),
    [sym_dictionary] = STATE(325),
    [sym_dictionary_comprehension] = STATE(325),
    [sym_set] = STATE(325),
    [sym_set_comprehension] = STATE(325),
    [sym_parenthesized_expression] = STATE(325),
    [sym_tuple] = STATE(325),
    [sym_generator_expression] = STATE(325),
    [sym_conditional_expression] = STATE(1158),
    [sym_concatenated_string] = STATE(325),
    [sym_string] = STATE(326),
    [sym_await] = STATE(1158),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_lambda] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(561),
    [sym_float] = ACTIONS(561),
    [sym_identifier] = ACTIONS(561),
    [sym_true] = ACTIONS(561),
    [sym_false] = ACTIONS(561),
    [sym_none] = ACTIONS(561),
    [anon_sym_await] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
  },
  [724] = {
    [sym__primary_expression] = STATE(1159),
    [sym_binary_operator] = STATE(1159),
    [sym_unary_operator] = STATE(1159),
    [sym_attribute] = STATE(1159),
    [sym_subscript] = STATE(1159),
    [sym_call] = STATE(1159),
    [sym_list] = STATE(1159),
    [sym_list_comprehension] = STATE(1159),
    [sym_dictionary] = STATE(1159),
    [sym_dictionary_comprehension] = STATE(1159),
    [sym_set] = STATE(1159),
    [sym_set_comprehension] = STATE(1159),
    [sym_parenthesized_expression] = STATE(1159),
    [sym_tuple] = STATE(1159),
    [sym_generator_expression] = STATE(1159),
    [sym_concatenated_string] = STATE(1159),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_identifier] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_none] = ACTIONS(2315),
    [sym_comment] = ACTIONS(73),
  },
  [725] = {
    [sym__primary_expression] = STATE(1160),
    [sym_binary_operator] = STATE(1160),
    [sym_unary_operator] = STATE(1160),
    [sym_attribute] = STATE(1160),
    [sym_subscript] = STATE(1160),
    [sym_call] = STATE(1160),
    [sym_list] = STATE(1160),
    [sym_list_comprehension] = STATE(1160),
    [sym_dictionary] = STATE(1160),
    [sym_dictionary_comprehension] = STATE(1160),
    [sym_set] = STATE(1160),
    [sym_set_comprehension] = STATE(1160),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_tuple] = STATE(1160),
    [sym_generator_expression] = STATE(1160),
    [sym_concatenated_string] = STATE(1160),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2317),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2319),
    [sym_float] = ACTIONS(2319),
    [sym_identifier] = ACTIONS(2319),
    [sym_true] = ACTIONS(2319),
    [sym_false] = ACTIONS(2319),
    [sym_none] = ACTIONS(2319),
    [sym_comment] = ACTIONS(73),
  },
  [726] = {
    [sym__primary_expression] = STATE(1161),
    [sym_binary_operator] = STATE(1161),
    [sym_unary_operator] = STATE(1161),
    [sym_attribute] = STATE(1161),
    [sym_subscript] = STATE(1161),
    [sym_call] = STATE(1161),
    [sym_list] = STATE(1161),
    [sym_list_comprehension] = STATE(1161),
    [sym_dictionary] = STATE(1161),
    [sym_dictionary_comprehension] = STATE(1161),
    [sym_set] = STATE(1161),
    [sym_set_comprehension] = STATE(1161),
    [sym_parenthesized_expression] = STATE(1161),
    [sym_tuple] = STATE(1161),
    [sym_generator_expression] = STATE(1161),
    [sym_concatenated_string] = STATE(1161),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2323),
    [sym_float] = ACTIONS(2323),
    [sym_identifier] = ACTIONS(2323),
    [sym_true] = ACTIONS(2323),
    [sym_false] = ACTIONS(2323),
    [sym_none] = ACTIONS(2323),
    [sym_comment] = ACTIONS(73),
  },
  [727] = {
    [anon_sym_in] = ACTIONS(2325),
    [sym_comment] = ACTIONS(73),
  },
  [728] = {
    [sym__primary_expression] = STATE(1163),
    [sym_binary_operator] = STATE(1163),
    [sym_unary_operator] = STATE(1163),
    [sym_attribute] = STATE(1163),
    [sym_subscript] = STATE(1163),
    [sym_call] = STATE(1163),
    [sym_list] = STATE(1163),
    [sym_list_comprehension] = STATE(1163),
    [sym_dictionary] = STATE(1163),
    [sym_dictionary_comprehension] = STATE(1163),
    [sym_set] = STATE(1163),
    [sym_set_comprehension] = STATE(1163),
    [sym_parenthesized_expression] = STATE(1163),
    [sym_tuple] = STATE(1163),
    [sym_generator_expression] = STATE(1163),
    [sym_concatenated_string] = STATE(1163),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2329),
    [sym_float] = ACTIONS(2329),
    [sym_identifier] = ACTIONS(2329),
    [sym_true] = ACTIONS(2329),
    [sym_false] = ACTIONS(2329),
    [sym_none] = ACTIONS(2329),
    [sym_comment] = ACTIONS(73),
  },
  [729] = {
    [sym__primary_expression] = STATE(709),
    [sym_binary_operator] = STATE(709),
    [sym_unary_operator] = STATE(709),
    [sym_attribute] = STATE(709),
    [sym_subscript] = STATE(709),
    [sym_call] = STATE(709),
    [sym_list] = STATE(709),
    [sym_list_comprehension] = STATE(709),
    [sym_dictionary] = STATE(709),
    [sym_dictionary_comprehension] = STATE(709),
    [sym_set] = STATE(709),
    [sym_set_comprehension] = STATE(709),
    [sym_parenthesized_expression] = STATE(709),
    [sym_tuple] = STATE(709),
    [sym_generator_expression] = STATE(709),
    [sym_concatenated_string] = STATE(709),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1363),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1365),
    [sym_float] = ACTIONS(1365),
    [sym_identifier] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_none] = ACTIONS(1365),
    [sym_comment] = ACTIONS(73),
  },
  [730] = {
    [sym__primary_expression] = STATE(1164),
    [sym_binary_operator] = STATE(1164),
    [sym_unary_operator] = STATE(1164),
    [sym_attribute] = STATE(1164),
    [sym_subscript] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym_list] = STATE(1164),
    [sym_list_comprehension] = STATE(1164),
    [sym_dictionary] = STATE(1164),
    [sym_dictionary_comprehension] = STATE(1164),
    [sym_set] = STATE(1164),
    [sym_set_comprehension] = STATE(1164),
    [sym_parenthesized_expression] = STATE(1164),
    [sym_tuple] = STATE(1164),
    [sym_generator_expression] = STATE(1164),
    [sym_concatenated_string] = STATE(1164),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2333),
    [sym_float] = ACTIONS(2333),
    [sym_identifier] = ACTIONS(2333),
    [sym_true] = ACTIONS(2333),
    [sym_false] = ACTIONS(2333),
    [sym_none] = ACTIONS(2333),
    [sym_comment] = ACTIONS(73),
  },
  [731] = {
    [sym__primary_expression] = STATE(1165),
    [sym_binary_operator] = STATE(1165),
    [sym_unary_operator] = STATE(1165),
    [sym_attribute] = STATE(1165),
    [sym_subscript] = STATE(1165),
    [sym_call] = STATE(1165),
    [sym_list] = STATE(1165),
    [sym_list_comprehension] = STATE(1165),
    [sym_dictionary] = STATE(1165),
    [sym_dictionary_comprehension] = STATE(1165),
    [sym_set] = STATE(1165),
    [sym_set_comprehension] = STATE(1165),
    [sym_parenthesized_expression] = STATE(1165),
    [sym_tuple] = STATE(1165),
    [sym_generator_expression] = STATE(1165),
    [sym_concatenated_string] = STATE(1165),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2337),
    [sym_float] = ACTIONS(2337),
    [sym_identifier] = ACTIONS(2337),
    [sym_true] = ACTIONS(2337),
    [sym_false] = ACTIONS(2337),
    [sym_none] = ACTIONS(2337),
    [sym_comment] = ACTIONS(73),
  },
  [732] = {
    [sym__primary_expression] = STATE(1166),
    [sym_binary_operator] = STATE(1166),
    [sym_unary_operator] = STATE(1166),
    [sym_attribute] = STATE(1166),
    [sym_subscript] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_list] = STATE(1166),
    [sym_list_comprehension] = STATE(1166),
    [sym_dictionary] = STATE(1166),
    [sym_dictionary_comprehension] = STATE(1166),
    [sym_set] = STATE(1166),
    [sym_set_comprehension] = STATE(1166),
    [sym_parenthesized_expression] = STATE(1166),
    [sym_tuple] = STATE(1166),
    [sym_generator_expression] = STATE(1166),
    [sym_concatenated_string] = STATE(1166),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2339),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2341),
    [sym_float] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(2341),
    [sym_true] = ACTIONS(2341),
    [sym_false] = ACTIONS(2341),
    [sym_none] = ACTIONS(2341),
    [sym_comment] = ACTIONS(73),
  },
  [733] = {
    [sym__primary_expression] = STATE(1161),
    [sym_binary_operator] = STATE(1161),
    [sym_unary_operator] = STATE(1161),
    [sym_attribute] = STATE(1161),
    [sym_subscript] = STATE(1161),
    [sym_call] = STATE(1161),
    [sym_list] = STATE(1161),
    [sym_list_comprehension] = STATE(1161),
    [sym_dictionary] = STATE(1161),
    [sym_dictionary_comprehension] = STATE(1161),
    [sym_set] = STATE(1161),
    [sym_set_comprehension] = STATE(1161),
    [sym_parenthesized_expression] = STATE(1161),
    [sym_tuple] = STATE(1161),
    [sym_generator_expression] = STATE(1161),
    [sym_concatenated_string] = STATE(1161),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(2343),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2323),
    [sym_float] = ACTIONS(2323),
    [sym_identifier] = ACTIONS(2323),
    [sym_true] = ACTIONS(2323),
    [sym_false] = ACTIONS(2323),
    [sym_none] = ACTIONS(2323),
    [sym_comment] = ACTIONS(73),
  },
  [734] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1167),
    [sym__newline] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(1399),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_LT_EQ] = ACTIONS(1399),
    [anon_sym_EQ_EQ] = ACTIONS(1399),
    [anon_sym_BANG_EQ] = ACTIONS(1399),
    [anon_sym_GT_EQ] = ACTIONS(1399),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_LT_GT] = ACTIONS(1399),
    [anon_sym_is] = ACTIONS(1417),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(999),
  },
  [735] = {
    [sym_string] = STATE(1168),
    [aux_sym_concatenated_string_repeat1] = STATE(1168),
    [sym__newline] = ACTIONS(1003),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1003),
  },
  [736] = {
    [sym__newline] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(577),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1671),
  },
  [737] = {
    [sym__expression] = STATE(1169),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(1169),
    [sym_boolean_operator] = STATE(1169),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(1169),
    [sym_lambda] = STATE(1169),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(1169),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(1169),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [738] = {
    [sym__newline] = ACTIONS(2345),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_and] = ACTIONS(1391),
    [anon_sym_or] = ACTIONS(1393),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2345),
  },
  [739] = {
    [sym__newline] = ACTIONS(1932),
    [anon_sym_from] = ACTIONS(1932),
    [anon_sym_COMMA] = ACTIONS(1932),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(577),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1932),
  },
  [740] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(2347),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [741] = {
    [sym__newline] = ACTIONS(1968),
    [anon_sym_from] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1968),
  },
  [742] = {
    [sym__expression] = STATE(739),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(739),
    [sym_boolean_operator] = STATE(739),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(739),
    [sym_lambda] = STATE(739),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(739),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(739),
    [sym__newline] = ACTIONS(1972),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(2349),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1972),
  },
  [743] = {
    [aux_sym_print_statement_repeat1] = STATE(743),
    [sym__newline] = ACTIONS(1932),
    [anon_sym_from] = ACTIONS(1932),
    [anon_sym_COMMA] = ACTIONS(2351),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1932),
  },
  [744] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_from] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [745] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_from] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(579),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_SLASH_SLASH] = ACTIONS(585),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [746] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_from] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(579),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_SLASH_SLASH] = ACTIONS(585),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_CARET] = ACTIONS(597),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1999),
  },
  [747] = {
    [sym__primary_expression] = STATE(1172),
    [sym_binary_operator] = STATE(1172),
    [sym_unary_operator] = STATE(1172),
    [sym_attribute] = STATE(1172),
    [sym_subscript] = STATE(1172),
    [sym_call] = STATE(1172),
    [sym_list] = STATE(1172),
    [sym_list_comprehension] = STATE(1172),
    [sym_dictionary] = STATE(1172),
    [sym_dictionary_comprehension] = STATE(1172),
    [sym_set] = STATE(1172),
    [sym_set_comprehension] = STATE(1172),
    [sym_parenthesized_expression] = STATE(1172),
    [sym_tuple] = STATE(1172),
    [sym_generator_expression] = STATE(1172),
    [sym_concatenated_string] = STATE(1172),
    [sym_string] = STATE(95),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2356),
    [sym_float] = ACTIONS(2356),
    [sym_identifier] = ACTIONS(2356),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [sym_none] = ACTIONS(2356),
    [sym_comment] = ACTIONS(73),
  },
  [748] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_from] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(579),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_SLASH_SLASH] = ACTIONS(585),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [749] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_from] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(579),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_SLASH_SLASH] = ACTIONS(585),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_CARET] = ACTIONS(597),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [750] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_from] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(579),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_SLASH_SLASH] = ACTIONS(585),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(597),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [751] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_from] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(579),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_SLASH_SLASH] = ACTIONS(585),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [752] = {
    [aux_sym_comparison_operator_repeat1] = STATE(752),
    [sym__newline] = ACTIONS(1999),
    [anon_sym_from] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2358),
    [anon_sym_not] = ACTIONS(2361),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_LT_EQ] = ACTIONS(2358),
    [anon_sym_EQ_EQ] = ACTIONS(2358),
    [anon_sym_BANG_EQ] = ACTIONS(2358),
    [anon_sym_GT_EQ] = ACTIONS(2358),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_LT_GT] = ACTIONS(2358),
    [anon_sym_is] = ACTIONS(2367),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1999),
  },
  [753] = {
    [sym_string] = STATE(753),
    [aux_sym_concatenated_string_repeat1] = STATE(753),
    [sym__newline] = ACTIONS(2061),
    [sym__string_start] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_from] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2061),
  },
  [754] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [755] = {
    [sym__expression] = STATE(1173),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1173),
    [sym_boolean_operator] = STATE(1173),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1173),
    [sym_lambda] = STATE(1173),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1173),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1173),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [756] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(2370),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [757] = {
    [sym__statement] = STATE(1176),
    [sym__simple_statements] = STATE(1176),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_if_statement] = STATE(1176),
    [sym_for_statement] = STATE(1176),
    [sym_while_statement] = STATE(1176),
    [sym_try_statement] = STATE(1176),
    [sym_with_statement] = STATE(1176),
    [sym_function_definition] = STATE(1176),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym_class_definition] = STATE(1176),
    [sym_decorated_definition] = STATE(1176),
    [sym_decorator] = STATE(798),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1176),
    [aux_sym_decorated_definition_repeat1] = STATE(798),
    [sym__dedent] = ACTIONS(2372),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_try] = ACTIONS(1541),
    [anon_sym_with] = ACTIONS(1543),
    [anon_sym_def] = ACTIONS(1545),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [758] = {
    [sym_elif_clause] = STATE(1180),
    [sym_else_clause] = STATE(1179),
    [aux_sym_if_statement_repeat1] = STATE(1180),
    [sym__string_start] = ACTIONS(2374),
    [ts_builtin_sym_end] = ACTIONS(2374),
    [anon_sym_import] = ACTIONS(2376),
    [anon_sym_from] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2374),
    [anon_sym_print] = ACTIONS(2376),
    [anon_sym_assert] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_del] = ACTIONS(2376),
    [anon_sym_raise] = ACTIONS(2376),
    [anon_sym_pass] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_elif] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_with] = ACTIONS(2376),
    [anon_sym_def] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2376),
    [anon_sym_nonlocal] = ACTIONS(2376),
    [anon_sym_exec] = ACTIONS(2376),
    [anon_sym_class] = ACTIONS(2376),
    [anon_sym_AT] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_TILDE] = ACTIONS(2374),
    [anon_sym_lambda] = ACTIONS(2376),
    [anon_sym_yield] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [sym_ellipsis] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2374),
    [sym_integer] = ACTIONS(2376),
    [sym_float] = ACTIONS(2376),
    [sym_identifier] = ACTIONS(2376),
    [sym_true] = ACTIONS(2376),
    [sym_false] = ACTIONS(2376),
    [sym_none] = ACTIONS(2376),
    [anon_sym_await] = ACTIONS(2376),
    [sym_comment] = ACTIONS(73),
  },
  [759] = {
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_COLON] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [760] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [761] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_SLASH_SLASH] = ACTIONS(619),
    [anon_sym_STAR_STAR] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [762] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(615),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_SLASH_SLASH] = ACTIONS(619),
    [anon_sym_STAR_STAR] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_CARET] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [763] = {
    [sym__primary_expression] = STATE(1181),
    [sym_binary_operator] = STATE(1181),
    [sym_unary_operator] = STATE(1181),
    [sym_attribute] = STATE(1181),
    [sym_subscript] = STATE(1181),
    [sym_call] = STATE(1181),
    [sym_list] = STATE(1181),
    [sym_list_comprehension] = STATE(1181),
    [sym_dictionary] = STATE(1181),
    [sym_dictionary_comprehension] = STATE(1181),
    [sym_set] = STATE(1181),
    [sym_set_comprehension] = STATE(1181),
    [sym_parenthesized_expression] = STATE(1181),
    [sym_tuple] = STATE(1181),
    [sym_generator_expression] = STATE(1181),
    [sym_concatenated_string] = STATE(1181),
    [sym_string] = STATE(102),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2384),
    [sym_float] = ACTIONS(2384),
    [sym_identifier] = ACTIONS(2384),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [sym_none] = ACTIONS(2384),
    [sym_comment] = ACTIONS(73),
  },
  [764] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_SLASH_SLASH] = ACTIONS(619),
    [anon_sym_STAR_STAR] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [765] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(615),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_SLASH_SLASH] = ACTIONS(619),
    [anon_sym_STAR_STAR] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_CARET] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [766] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(615),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_SLASH_SLASH] = ACTIONS(619),
    [anon_sym_STAR_STAR] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [767] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(615),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_SLASH_SLASH] = ACTIONS(619),
    [anon_sym_STAR_STAR] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [768] = {
    [aux_sym_comparison_operator_repeat1] = STATE(768),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2389),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2392),
    [anon_sym_LT_EQ] = ACTIONS(2386),
    [anon_sym_EQ_EQ] = ACTIONS(2386),
    [anon_sym_BANG_EQ] = ACTIONS(2386),
    [anon_sym_GT_EQ] = ACTIONS(2386),
    [anon_sym_GT] = ACTIONS(2392),
    [anon_sym_LT_GT] = ACTIONS(2386),
    [anon_sym_is] = ACTIONS(2395),
    [sym_comment] = ACTIONS(73),
  },
  [769] = {
    [sym_string] = STATE(769),
    [aux_sym_concatenated_string_repeat1] = STATE(769),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [770] = {
    [sym_expression_list] = STATE(1182),
    [sym__expression] = STATE(775),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(775),
    [sym_boolean_operator] = STATE(775),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(775),
    [sym_lambda] = STATE(775),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(775),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(775),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [771] = {
    [sym__simple_statements] = STATE(1183),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1183),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [772] = {
    [aux_sym_with_statement_repeat1] = STATE(810),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(2398),
    [sym_comment] = ACTIONS(73),
  },
  [773] = {
    [anon_sym_COLON] = ACTIONS(2400),
    [anon_sym_DASH_GT] = ACTIONS(2402),
    [sym_comment] = ACTIONS(73),
  },
  [774] = {
    [anon_sym_COLON] = ACTIONS(2404),
    [sym_comment] = ACTIONS(73),
  },
  [775] = {
    [aux_sym_print_statement_repeat1] = STATE(1189),
    [anon_sym_COMMA] = ACTIONS(2406),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [776] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2408),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(2408),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(649),
    [anon_sym_SLASH_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [777] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [778] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(649),
    [anon_sym_SLASH_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [779] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(649),
    [anon_sym_SLASH_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [780] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(649),
    [anon_sym_SLASH_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [781] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(649),
    [anon_sym_SLASH_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [782] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(643),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(649),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(649),
    [anon_sym_SLASH_SLASH] = ACTIONS(649),
    [anon_sym_STAR_STAR] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [783] = {
    [sym__primary_expression] = STATE(776),
    [sym_binary_operator] = STATE(776),
    [sym_unary_operator] = STATE(776),
    [sym_attribute] = STATE(776),
    [sym_subscript] = STATE(776),
    [sym_call] = STATE(776),
    [sym_list] = STATE(776),
    [sym_list_comprehension] = STATE(776),
    [sym_dictionary] = STATE(776),
    [sym_dictionary_comprehension] = STATE(776),
    [sym_set] = STATE(776),
    [sym_set_comprehension] = STATE(776),
    [sym_parenthesized_expression] = STATE(776),
    [sym_tuple] = STATE(776),
    [sym_generator_expression] = STATE(776),
    [sym_concatenated_string] = STATE(776),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1501),
    [sym_float] = ACTIONS(1501),
    [sym_identifier] = ACTIONS(1501),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [sym_none] = ACTIONS(1501),
    [sym_comment] = ACTIONS(73),
  },
  [784] = {
    [aux_sym_variables_repeat1] = STATE(784),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_in] = ACTIONS(2408),
    [sym_comment] = ACTIONS(73),
  },
  [785] = {
    [sym_string] = STATE(785),
    [aux_sym_concatenated_string_repeat1] = STATE(785),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [786] = {
    [sym_else_clause] = STATE(1191),
    [sym__string_start] = ACTIONS(2415),
    [ts_builtin_sym_end] = ACTIONS(2415),
    [anon_sym_import] = ACTIONS(2417),
    [anon_sym_from] = ACTIONS(2417),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_print] = ACTIONS(2417),
    [anon_sym_assert] = ACTIONS(2417),
    [anon_sym_return] = ACTIONS(2417),
    [anon_sym_del] = ACTIONS(2417),
    [anon_sym_raise] = ACTIONS(2417),
    [anon_sym_pass] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2417),
    [anon_sym_continue] = ACTIONS(2417),
    [anon_sym_if] = ACTIONS(2417),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2417),
    [anon_sym_for] = ACTIONS(2417),
    [anon_sym_while] = ACTIONS(2417),
    [anon_sym_try] = ACTIONS(2417),
    [anon_sym_with] = ACTIONS(2417),
    [anon_sym_def] = ACTIONS(2417),
    [anon_sym_global] = ACTIONS(2417),
    [anon_sym_nonlocal] = ACTIONS(2417),
    [anon_sym_exec] = ACTIONS(2417),
    [anon_sym_class] = ACTIONS(2417),
    [anon_sym_AT] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_PLUS] = ACTIONS(2415),
    [anon_sym_DASH] = ACTIONS(2415),
    [anon_sym_TILDE] = ACTIONS(2415),
    [anon_sym_lambda] = ACTIONS(2417),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [sym_ellipsis] = ACTIONS(2415),
    [anon_sym_LBRACE] = ACTIONS(2415),
    [sym_integer] = ACTIONS(2417),
    [sym_float] = ACTIONS(2417),
    [sym_identifier] = ACTIONS(2417),
    [sym_true] = ACTIONS(2417),
    [sym_false] = ACTIONS(2417),
    [sym_none] = ACTIONS(2417),
    [anon_sym_await] = ACTIONS(2417),
    [sym_comment] = ACTIONS(73),
  },
  [787] = {
    [anon_sym_except] = ACTIONS(2419),
    [anon_sym_finally] = ACTIONS(2419),
    [sym_comment] = ACTIONS(73),
  },
  [788] = {
    [sym__expression] = STATE(1192),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1192),
    [sym_boolean_operator] = STATE(1192),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1192),
    [sym_lambda] = STATE(1192),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1192),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1192),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [789] = {
    [anon_sym_for] = ACTIONS(2421),
    [anon_sym_with] = ACTIONS(2423),
    [anon_sym_def] = ACTIONS(2425),
    [sym_comment] = ACTIONS(73),
  },
  [790] = {
    [sym_variables] = STATE(1196),
    [sym__primary_expression] = STATE(108),
    [sym_binary_operator] = STATE(108),
    [sym_unary_operator] = STATE(108),
    [sym_attribute] = STATE(108),
    [sym_subscript] = STATE(108),
    [sym_call] = STATE(108),
    [sym_list] = STATE(108),
    [sym_list_comprehension] = STATE(108),
    [sym_dictionary] = STATE(108),
    [sym_dictionary_comprehension] = STATE(108),
    [sym_set] = STATE(108),
    [sym_set_comprehension] = STATE(108),
    [sym_parenthesized_expression] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_generator_expression] = STATE(108),
    [sym_concatenated_string] = STATE(108),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [791] = {
    [sym__expression] = STATE(1197),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1197),
    [sym_boolean_operator] = STATE(1197),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1197),
    [sym_lambda] = STATE(1197),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1197),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1197),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [792] = {
    [anon_sym_COLON] = ACTIONS(2427),
    [sym_comment] = ACTIONS(73),
  },
  [793] = {
    [sym_with_item] = STATE(1199),
    [sym__expression] = STATE(117),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(117),
    [sym_boolean_operator] = STATE(117),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(117),
    [sym_lambda] = STATE(117),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(117),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(117),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [794] = {
    [sym_identifier] = ACTIONS(2429),
    [sym_comment] = ACTIONS(73),
  },
  [795] = {
    [sym_identifier] = ACTIONS(2431),
    [sym_comment] = ACTIONS(73),
  },
  [796] = {
    [aux_sym__simple_statements_repeat1] = STATE(1204),
    [sym__newline] = ACTIONS(2433),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2435),
  },
  [797] = {
    [sym__statement] = STATE(1206),
    [sym__simple_statements] = STATE(1206),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_if_statement] = STATE(1206),
    [sym_for_statement] = STATE(1206),
    [sym_while_statement] = STATE(1206),
    [sym_try_statement] = STATE(1206),
    [sym_with_statement] = STATE(1206),
    [sym_function_definition] = STATE(1206),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym_class_definition] = STATE(1206),
    [sym_decorated_definition] = STATE(1206),
    [sym_decorator] = STATE(798),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1206),
    [aux_sym_decorated_definition_repeat1] = STATE(798),
    [sym__dedent] = ACTIONS(2437),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_try] = ACTIONS(1541),
    [anon_sym_with] = ACTIONS(1543),
    [anon_sym_def] = ACTIONS(1545),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [798] = {
    [sym_function_definition] = STATE(1208),
    [sym_class_definition] = STATE(1208),
    [sym_decorator] = STATE(197),
    [aux_sym_decorated_definition_repeat1] = STATE(197),
    [anon_sym_async] = ACTIONS(2439),
    [anon_sym_def] = ACTIONS(2441),
    [anon_sym_class] = ACTIONS(2443),
    [anon_sym_AT] = ACTIONS(53),
    [sym_comment] = ACTIONS(73),
  },
  [799] = {
    [anon_sym_except] = ACTIONS(893),
    [anon_sym_finally] = ACTIONS(893),
    [sym_comment] = ACTIONS(73),
  },
  [800] = {
    [sym_import_statement] = STATE(515),
    [sym_import_from_statement] = STATE(515),
    [sym_print_statement] = STATE(515),
    [sym_assert_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_delete_statement] = STATE(515),
    [sym_raise_statement] = STATE(515),
    [sym_pass_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_global_statement] = STATE(515),
    [sym_nonlocal_statement] = STATE(515),
    [sym_exec_statement] = STATE(515),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(2445),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [801] = {
    [aux_sym__simple_statements_repeat1] = STATE(517),
    [sym__newline] = ACTIONS(2445),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2447),
  },
  [802] = {
    [sym__expression] = STATE(1212),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(1212),
    [sym_boolean_operator] = STATE(1212),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(1212),
    [sym_lambda] = STATE(1212),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(1212),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(1212),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(2449),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [803] = {
    [anon_sym_COLON] = ACTIONS(2451),
    [sym_comment] = ACTIONS(73),
  },
  [804] = {
    [sym__string_start] = ACTIONS(2453),
    [ts_builtin_sym_end] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_from] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_print] = ACTIONS(2455),
    [anon_sym_assert] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_del] = ACTIONS(2455),
    [anon_sym_raise] = ACTIONS(2455),
    [anon_sym_pass] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_with] = ACTIONS(2455),
    [anon_sym_def] = ACTIONS(2455),
    [anon_sym_global] = ACTIONS(2455),
    [anon_sym_nonlocal] = ACTIONS(2455),
    [anon_sym_exec] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_lambda] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [sym_ellipsis] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [sym_integer] = ACTIONS(2455),
    [sym_float] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [sym_false] = ACTIONS(2455),
    [sym_none] = ACTIONS(2455),
    [anon_sym_await] = ACTIONS(2455),
    [sym_comment] = ACTIONS(73),
  },
  [805] = {
    [sym_else_clause] = STATE(1214),
    [sym_except_clause] = STATE(1216),
    [sym_finally_clause] = STATE(1215),
    [aux_sym_try_statement_repeat1] = STATE(1216),
    [sym__string_start] = ACTIONS(2453),
    [ts_builtin_sym_end] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_from] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_print] = ACTIONS(2455),
    [anon_sym_assert] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_del] = ACTIONS(2455),
    [anon_sym_raise] = ACTIONS(2455),
    [anon_sym_pass] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_except] = ACTIONS(2457),
    [anon_sym_finally] = ACTIONS(2459),
    [anon_sym_with] = ACTIONS(2455),
    [anon_sym_def] = ACTIONS(2455),
    [anon_sym_global] = ACTIONS(2455),
    [anon_sym_nonlocal] = ACTIONS(2455),
    [anon_sym_exec] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_lambda] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [sym_ellipsis] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [sym_integer] = ACTIONS(2455),
    [sym_float] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [sym_false] = ACTIONS(2455),
    [sym_none] = ACTIONS(2455),
    [anon_sym_await] = ACTIONS(2455),
    [sym_comment] = ACTIONS(73),
  },
  [806] = {
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_as] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(679),
    [sym_comment] = ACTIONS(73),
  },
  [807] = {
    [sym__expression] = STATE(1217),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(1217),
    [sym_boolean_operator] = STATE(1217),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(1217),
    [sym_lambda] = STATE(1217),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(1217),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(1217),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [808] = {
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_COLON] = ACTIONS(2461),
    [sym_comment] = ACTIONS(73),
  },
  [809] = {
    [sym__string_start] = ACTIONS(2463),
    [ts_builtin_sym_end] = ACTIONS(2463),
    [anon_sym_import] = ACTIONS(2465),
    [anon_sym_from] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2463),
    [anon_sym_print] = ACTIONS(2465),
    [anon_sym_assert] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_del] = ACTIONS(2465),
    [anon_sym_raise] = ACTIONS(2465),
    [anon_sym_pass] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_async] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_while] = ACTIONS(2465),
    [anon_sym_try] = ACTIONS(2465),
    [anon_sym_with] = ACTIONS(2465),
    [anon_sym_def] = ACTIONS(2465),
    [anon_sym_global] = ACTIONS(2465),
    [anon_sym_nonlocal] = ACTIONS(2465),
    [anon_sym_exec] = ACTIONS(2465),
    [anon_sym_class] = ACTIONS(2465),
    [anon_sym_AT] = ACTIONS(2463),
    [anon_sym_not] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2463),
    [anon_sym_DASH] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_lambda] = ACTIONS(2465),
    [anon_sym_yield] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [sym_ellipsis] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [sym_integer] = ACTIONS(2465),
    [sym_float] = ACTIONS(2465),
    [sym_identifier] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_none] = ACTIONS(2465),
    [anon_sym_await] = ACTIONS(2465),
    [sym_comment] = ACTIONS(73),
  },
  [810] = {
    [aux_sym_with_statement_repeat1] = STATE(810),
    [anon_sym_COMMA] = ACTIONS(2467),
    [anon_sym_COLON] = ACTIONS(2461),
    [sym_comment] = ACTIONS(73),
  },
  [811] = {
    [anon_sym_COMMA] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [812] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(2472),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [813] = {
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_as] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_COLON] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [814] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [815] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_SLASH_SLASH] = ACTIONS(687),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [816] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_SLASH_SLASH] = ACTIONS(687),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [817] = {
    [sym__primary_expression] = STATE(1219),
    [sym_binary_operator] = STATE(1219),
    [sym_unary_operator] = STATE(1219),
    [sym_attribute] = STATE(1219),
    [sym_subscript] = STATE(1219),
    [sym_call] = STATE(1219),
    [sym_list] = STATE(1219),
    [sym_list_comprehension] = STATE(1219),
    [sym_dictionary] = STATE(1219),
    [sym_dictionary_comprehension] = STATE(1219),
    [sym_set] = STATE(1219),
    [sym_set_comprehension] = STATE(1219),
    [sym_parenthesized_expression] = STATE(1219),
    [sym_tuple] = STATE(1219),
    [sym_generator_expression] = STATE(1219),
    [sym_concatenated_string] = STATE(1219),
    [sym_string] = STATE(119),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2476),
    [sym_float] = ACTIONS(2476),
    [sym_identifier] = ACTIONS(2476),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [sym_none] = ACTIONS(2476),
    [sym_comment] = ACTIONS(73),
  },
  [818] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_SLASH_SLASH] = ACTIONS(687),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [819] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_SLASH_SLASH] = ACTIONS(687),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [820] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_SLASH_SLASH] = ACTIONS(687),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [821] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_SLASH_SLASH] = ACTIONS(687),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [822] = {
    [aux_sym_comparison_operator_repeat1] = STATE(822),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2478),
    [anon_sym_not] = ACTIONS(2481),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_LT_EQ] = ACTIONS(2478),
    [anon_sym_EQ_EQ] = ACTIONS(2478),
    [anon_sym_BANG_EQ] = ACTIONS(2478),
    [anon_sym_GT_EQ] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2484),
    [anon_sym_LT_GT] = ACTIONS(2478),
    [anon_sym_is] = ACTIONS(2487),
    [sym_comment] = ACTIONS(73),
  },
  [823] = {
    [sym_string] = STATE(823),
    [aux_sym_concatenated_string_repeat1] = STATE(823),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_as] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [824] = {
    [anon_sym_COLON] = ACTIONS(2490),
    [anon_sym_DASH_GT] = ACTIONS(2490),
    [sym_comment] = ACTIONS(73),
  },
  [825] = {
    [sym__expression] = STATE(1225),
    [sym__primary_expression] = STATE(1226),
    [sym_not_operator] = STATE(1225),
    [sym_boolean_operator] = STATE(1225),
    [sym_binary_operator] = STATE(1226),
    [sym_unary_operator] = STATE(1226),
    [sym_comparison_operator] = STATE(1225),
    [sym_lambda] = STATE(1225),
    [sym_attribute] = STATE(1226),
    [sym_subscript] = STATE(1226),
    [sym_call] = STATE(1226),
    [sym_list] = STATE(1226),
    [sym_list_comprehension] = STATE(1226),
    [sym_dictionary] = STATE(1226),
    [sym_dictionary_comprehension] = STATE(1226),
    [sym_set] = STATE(1226),
    [sym_set_comprehension] = STATE(1226),
    [sym_parenthesized_expression] = STATE(1226),
    [sym_tuple] = STATE(1226),
    [sym_generator_expression] = STATE(1226),
    [sym_conditional_expression] = STATE(1225),
    [sym_concatenated_string] = STATE(1226),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(1225),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(737),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_lambda] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2502),
    [sym_float] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_none] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [sym_comment] = ACTIONS(73),
  },
  [826] = {
    [aux_sym__parameters_repeat1] = STATE(1231),
    [anon_sym_RPAREN] = ACTIONS(755),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_EQ] = ACTIONS(2510),
    [sym_comment] = ACTIONS(73),
  },
  [827] = {
    [aux_sym__parameters_repeat1] = STATE(1235),
    [anon_sym_RPAREN] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [sym_comment] = ACTIONS(73),
  },
  [828] = {
    [anon_sym_RPAREN] = ACTIONS(2518),
    [sym_comment] = ACTIONS(73),
  },
  [829] = {
    [aux_sym__parameters_repeat1] = STATE(1235),
    [anon_sym_RPAREN] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(2512),
    [sym_comment] = ACTIONS(73),
  },
  [830] = {
    [aux_sym__parameters_repeat1] = STATE(1235),
    [anon_sym_RPAREN] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2520),
    [sym_comment] = ACTIONS(73),
  },
  [831] = {
    [sym__simple_statements] = STATE(1238),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1238),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [832] = {
    [sym__expression] = STATE(1239),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1239),
    [sym_boolean_operator] = STATE(1239),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1239),
    [sym_lambda] = STATE(1239),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_type] = STATE(1240),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1239),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1239),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [833] = {
    [sym__newline] = ACTIONS(2522),
    [anon_sym_COMMA] = ACTIONS(2522),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2522),
  },
  [834] = {
    [aux_sym_global_statement_repeat1] = STATE(834),
    [sym__newline] = ACTIONS(2522),
    [anon_sym_COMMA] = ACTIONS(2524),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2522),
  },
  [835] = {
    [sym__newline] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(1153),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1153),
  },
  [836] = {
    [aux_sym_print_statement_repeat1] = STATE(1241),
    [sym__newline] = ACTIONS(2527),
    [anon_sym_COMMA] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(511),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2527),
  },
  [837] = {
    [aux_sym_argument_list_repeat1] = STATE(1129),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [838] = {
    [sym__string_start] = ACTIONS(2529),
    [ts_builtin_sym_end] = ACTIONS(2529),
    [anon_sym_import] = ACTIONS(2531),
    [anon_sym_from] = ACTIONS(2531),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_print] = ACTIONS(2531),
    [anon_sym_assert] = ACTIONS(2531),
    [anon_sym_return] = ACTIONS(2531),
    [anon_sym_del] = ACTIONS(2531),
    [anon_sym_raise] = ACTIONS(2531),
    [anon_sym_pass] = ACTIONS(2531),
    [anon_sym_break] = ACTIONS(2531),
    [anon_sym_continue] = ACTIONS(2531),
    [anon_sym_if] = ACTIONS(2531),
    [anon_sym_async] = ACTIONS(2531),
    [anon_sym_for] = ACTIONS(2531),
    [anon_sym_while] = ACTIONS(2531),
    [anon_sym_try] = ACTIONS(2531),
    [anon_sym_with] = ACTIONS(2531),
    [anon_sym_def] = ACTIONS(2531),
    [anon_sym_global] = ACTIONS(2531),
    [anon_sym_nonlocal] = ACTIONS(2531),
    [anon_sym_exec] = ACTIONS(2531),
    [anon_sym_class] = ACTIONS(2531),
    [anon_sym_AT] = ACTIONS(2529),
    [anon_sym_not] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_lambda] = ACTIONS(2531),
    [anon_sym_yield] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [sym_ellipsis] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(2529),
    [sym_integer] = ACTIONS(2531),
    [sym_float] = ACTIONS(2531),
    [sym_identifier] = ACTIONS(2531),
    [sym_true] = ACTIONS(2531),
    [sym_false] = ACTIONS(2531),
    [sym_none] = ACTIONS(2531),
    [anon_sym_await] = ACTIONS(2531),
    [sym_comment] = ACTIONS(73),
  },
  [839] = {
    [sym__simple_statements] = STATE(1242),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1242),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [840] = {
    [aux_sym_dotted_name_repeat1] = STATE(840),
    [sym__newline] = ACTIONS(2108),
    [anon_sym_DOT] = ACTIONS(2110),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [sym_comment] = ACTIONS(73),
  },
  [841] = {
    [aux_sym_argument_list_repeat1] = STATE(1038),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [842] = {
    [anon_sym_async] = ACTIONS(2533),
    [anon_sym_def] = ACTIONS(2533),
    [anon_sym_class] = ACTIONS(2533),
    [anon_sym_AT] = ACTIONS(2533),
    [sym_comment] = ACTIONS(73),
  },
  [843] = {
    [anon_sym_COMMA] = ACTIONS(2535),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(2535),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [844] = {
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [845] = {
    [sym__expression] = STATE(1243),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1243),
    [sym_boolean_operator] = STATE(1243),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1243),
    [sym_lambda] = STATE(1243),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1243),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(1243),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [846] = {
    [anon_sym_COLON] = ACTIONS(2537),
    [sym_comment] = ACTIONS(73),
  },
  [847] = {
    [sym__expression] = STATE(1245),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1245),
    [sym_boolean_operator] = STATE(1245),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1245),
    [sym_lambda] = STATE(1245),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1245),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1245),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [848] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [849] = {
    [sym__expression] = STATE(1246),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1246),
    [sym_boolean_operator] = STATE(1246),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1246),
    [sym_lambda] = STATE(1246),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1246),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(1246),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [850] = {
    [sym__primary_expression] = STATE(1247),
    [sym_binary_operator] = STATE(1247),
    [sym_unary_operator] = STATE(1247),
    [sym_attribute] = STATE(1247),
    [sym_subscript] = STATE(1247),
    [sym_call] = STATE(1247),
    [sym_list] = STATE(1247),
    [sym_list_comprehension] = STATE(1247),
    [sym_dictionary] = STATE(1247),
    [sym_dictionary_comprehension] = STATE(1247),
    [sym_set] = STATE(1247),
    [sym_set_comprehension] = STATE(1247),
    [sym_parenthesized_expression] = STATE(1247),
    [sym_tuple] = STATE(1247),
    [sym_generator_expression] = STATE(1247),
    [sym_concatenated_string] = STATE(1247),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2539),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2541),
    [sym_float] = ACTIONS(2541),
    [sym_identifier] = ACTIONS(2541),
    [sym_true] = ACTIONS(2541),
    [sym_false] = ACTIONS(2541),
    [sym_none] = ACTIONS(2541),
    [sym_comment] = ACTIONS(73),
  },
  [851] = {
    [sym__primary_expression] = STATE(1248),
    [sym_binary_operator] = STATE(1248),
    [sym_unary_operator] = STATE(1248),
    [sym_attribute] = STATE(1248),
    [sym_subscript] = STATE(1248),
    [sym_call] = STATE(1248),
    [sym_list] = STATE(1248),
    [sym_list_comprehension] = STATE(1248),
    [sym_dictionary] = STATE(1248),
    [sym_dictionary_comprehension] = STATE(1248),
    [sym_set] = STATE(1248),
    [sym_set_comprehension] = STATE(1248),
    [sym_parenthesized_expression] = STATE(1248),
    [sym_tuple] = STATE(1248),
    [sym_generator_expression] = STATE(1248),
    [sym_concatenated_string] = STATE(1248),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2543),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2545),
    [sym_float] = ACTIONS(2545),
    [sym_identifier] = ACTIONS(2545),
    [sym_true] = ACTIONS(2545),
    [sym_false] = ACTIONS(2545),
    [sym_none] = ACTIONS(2545),
    [sym_comment] = ACTIONS(73),
  },
  [852] = {
    [sym__primary_expression] = STATE(1249),
    [sym_binary_operator] = STATE(1249),
    [sym_unary_operator] = STATE(1249),
    [sym_attribute] = STATE(1249),
    [sym_subscript] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_list] = STATE(1249),
    [sym_list_comprehension] = STATE(1249),
    [sym_dictionary] = STATE(1249),
    [sym_dictionary_comprehension] = STATE(1249),
    [sym_set] = STATE(1249),
    [sym_set_comprehension] = STATE(1249),
    [sym_parenthesized_expression] = STATE(1249),
    [sym_tuple] = STATE(1249),
    [sym_generator_expression] = STATE(1249),
    [sym_concatenated_string] = STATE(1249),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2549),
    [sym_float] = ACTIONS(2549),
    [sym_identifier] = ACTIONS(2549),
    [sym_true] = ACTIONS(2549),
    [sym_false] = ACTIONS(2549),
    [sym_none] = ACTIONS(2549),
    [sym_comment] = ACTIONS(73),
  },
  [853] = {
    [anon_sym_in] = ACTIONS(2551),
    [sym_comment] = ACTIONS(73),
  },
  [854] = {
    [sym__primary_expression] = STATE(1251),
    [sym_binary_operator] = STATE(1251),
    [sym_unary_operator] = STATE(1251),
    [sym_attribute] = STATE(1251),
    [sym_subscript] = STATE(1251),
    [sym_call] = STATE(1251),
    [sym_list] = STATE(1251),
    [sym_list_comprehension] = STATE(1251),
    [sym_dictionary] = STATE(1251),
    [sym_dictionary_comprehension] = STATE(1251),
    [sym_set] = STATE(1251),
    [sym_set_comprehension] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_tuple] = STATE(1251),
    [sym_generator_expression] = STATE(1251),
    [sym_concatenated_string] = STATE(1251),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2555),
    [sym_float] = ACTIONS(2555),
    [sym_identifier] = ACTIONS(2555),
    [sym_true] = ACTIONS(2555),
    [sym_false] = ACTIONS(2555),
    [sym_none] = ACTIONS(2555),
    [sym_comment] = ACTIONS(73),
  },
  [855] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [856] = {
    [sym__primary_expression] = STATE(1252),
    [sym_binary_operator] = STATE(1252),
    [sym_unary_operator] = STATE(1252),
    [sym_attribute] = STATE(1252),
    [sym_subscript] = STATE(1252),
    [sym_call] = STATE(1252),
    [sym_list] = STATE(1252),
    [sym_list_comprehension] = STATE(1252),
    [sym_dictionary] = STATE(1252),
    [sym_dictionary_comprehension] = STATE(1252),
    [sym_set] = STATE(1252),
    [sym_set_comprehension] = STATE(1252),
    [sym_parenthesized_expression] = STATE(1252),
    [sym_tuple] = STATE(1252),
    [sym_generator_expression] = STATE(1252),
    [sym_concatenated_string] = STATE(1252),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2559),
    [sym_float] = ACTIONS(2559),
    [sym_identifier] = ACTIONS(2559),
    [sym_true] = ACTIONS(2559),
    [sym_false] = ACTIONS(2559),
    [sym_none] = ACTIONS(2559),
    [sym_comment] = ACTIONS(73),
  },
  [857] = {
    [sym__primary_expression] = STATE(1253),
    [sym_binary_operator] = STATE(1253),
    [sym_unary_operator] = STATE(1253),
    [sym_attribute] = STATE(1253),
    [sym_subscript] = STATE(1253),
    [sym_call] = STATE(1253),
    [sym_list] = STATE(1253),
    [sym_list_comprehension] = STATE(1253),
    [sym_dictionary] = STATE(1253),
    [sym_dictionary_comprehension] = STATE(1253),
    [sym_set] = STATE(1253),
    [sym_set_comprehension] = STATE(1253),
    [sym_parenthesized_expression] = STATE(1253),
    [sym_tuple] = STATE(1253),
    [sym_generator_expression] = STATE(1253),
    [sym_concatenated_string] = STATE(1253),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2561),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2563),
    [sym_float] = ACTIONS(2563),
    [sym_identifier] = ACTIONS(2563),
    [sym_true] = ACTIONS(2563),
    [sym_false] = ACTIONS(2563),
    [sym_none] = ACTIONS(2563),
    [sym_comment] = ACTIONS(73),
  },
  [858] = {
    [sym__primary_expression] = STATE(1254),
    [sym_binary_operator] = STATE(1254),
    [sym_unary_operator] = STATE(1254),
    [sym_attribute] = STATE(1254),
    [sym_subscript] = STATE(1254),
    [sym_call] = STATE(1254),
    [sym_list] = STATE(1254),
    [sym_list_comprehension] = STATE(1254),
    [sym_dictionary] = STATE(1254),
    [sym_dictionary_comprehension] = STATE(1254),
    [sym_set] = STATE(1254),
    [sym_set_comprehension] = STATE(1254),
    [sym_parenthesized_expression] = STATE(1254),
    [sym_tuple] = STATE(1254),
    [sym_generator_expression] = STATE(1254),
    [sym_concatenated_string] = STATE(1254),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2567),
    [sym_float] = ACTIONS(2567),
    [sym_identifier] = ACTIONS(2567),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [sym_none] = ACTIONS(2567),
    [sym_comment] = ACTIONS(73),
  },
  [859] = {
    [sym__primary_expression] = STATE(1249),
    [sym_binary_operator] = STATE(1249),
    [sym_unary_operator] = STATE(1249),
    [sym_attribute] = STATE(1249),
    [sym_subscript] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_list] = STATE(1249),
    [sym_list_comprehension] = STATE(1249),
    [sym_dictionary] = STATE(1249),
    [sym_dictionary_comprehension] = STATE(1249),
    [sym_set] = STATE(1249),
    [sym_set_comprehension] = STATE(1249),
    [sym_parenthesized_expression] = STATE(1249),
    [sym_tuple] = STATE(1249),
    [sym_generator_expression] = STATE(1249),
    [sym_concatenated_string] = STATE(1249),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2569),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2549),
    [sym_float] = ACTIONS(2549),
    [sym_identifier] = ACTIONS(2549),
    [sym_true] = ACTIONS(2549),
    [sym_false] = ACTIONS(2549),
    [sym_none] = ACTIONS(2549),
    [sym_comment] = ACTIONS(73),
  },
  [860] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1255),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(1631),
    [anon_sym_not] = ACTIONS(1635),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1631),
    [anon_sym_EQ_EQ] = ACTIONS(1631),
    [anon_sym_BANG_EQ] = ACTIONS(1631),
    [anon_sym_GT_EQ] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1647),
    [anon_sym_LT_GT] = ACTIONS(1631),
    [anon_sym_is] = ACTIONS(1649),
    [sym_comment] = ACTIONS(73),
  },
  [861] = {
    [sym_string] = STATE(1256),
    [aux_sym_concatenated_string_repeat1] = STATE(1256),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_COLON] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [862] = {
    [anon_sym_COMMA] = ACTIONS(2571),
    [anon_sym_COLON] = ACTIONS(2571),
    [anon_sym_EQ] = ACTIONS(757),
    [sym_comment] = ACTIONS(73),
  },
  [863] = {
    [anon_sym_COMMA] = ACTIONS(2573),
    [anon_sym_COLON] = ACTIONS(2573),
    [anon_sym_EQ] = ACTIONS(763),
    [sym_comment] = ACTIONS(73),
  },
  [864] = {
    [anon_sym_RPAREN] = ACTIONS(2573),
    [anon_sym_COMMA] = ACTIONS(2573),
    [anon_sym_COLON] = ACTIONS(2573),
    [sym_comment] = ACTIONS(73),
  },
  [865] = {
    [anon_sym_COMMA] = ACTIONS(2573),
    [anon_sym_COLON] = ACTIONS(2573),
    [sym_comment] = ACTIONS(73),
  },
  [866] = {
    [sym__expression] = STATE(1257),
    [sym__primary_expression] = STATE(871),
    [sym_not_operator] = STATE(1257),
    [sym_boolean_operator] = STATE(1257),
    [sym_binary_operator] = STATE(871),
    [sym_unary_operator] = STATE(871),
    [sym_comparison_operator] = STATE(1257),
    [sym_lambda] = STATE(1257),
    [sym_attribute] = STATE(871),
    [sym_subscript] = STATE(871),
    [sym_call] = STATE(871),
    [sym_list] = STATE(871),
    [sym_list_comprehension] = STATE(871),
    [sym_dictionary] = STATE(871),
    [sym_dictionary_comprehension] = STATE(871),
    [sym_set] = STATE(871),
    [sym_set_comprehension] = STATE(871),
    [sym_parenthesized_expression] = STATE(871),
    [sym_tuple] = STATE(871),
    [sym_generator_expression] = STATE(871),
    [sym_conditional_expression] = STATE(1257),
    [sym_concatenated_string] = STATE(871),
    [sym_string] = STATE(873),
    [sym_await] = STATE(1257),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_lambda] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1665),
    [sym_float] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1665),
    [sym_true] = ACTIONS(1665),
    [sym_false] = ACTIONS(1665),
    [sym_none] = ACTIONS(1665),
    [anon_sym_await] = ACTIONS(1667),
    [sym_comment] = ACTIONS(73),
  },
  [867] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [868] = {
    [sym_lambda_parameters] = STATE(1259),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(2575),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [869] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(871),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(871),
    [sym_unary_operator] = STATE(871),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(871),
    [sym_subscript] = STATE(871),
    [sym_call] = STATE(871),
    [sym_list] = STATE(871),
    [sym_list_comprehension] = STATE(871),
    [sym_dictionary] = STATE(871),
    [sym_dictionary_comprehension] = STATE(871),
    [sym_set] = STATE(871),
    [sym_set_comprehension] = STATE(871),
    [sym_parenthesized_expression] = STATE(871),
    [sym_tuple] = STATE(871),
    [sym_generator_expression] = STATE(871),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(871),
    [sym_string] = STATE(873),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_lambda] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1665),
    [sym_float] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1665),
    [sym_true] = ACTIONS(1665),
    [sym_false] = ACTIONS(1665),
    [sym_none] = ACTIONS(1665),
    [anon_sym_await] = ACTIONS(1667),
    [sym_comment] = ACTIONS(73),
  },
  [870] = {
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_EQ] = ACTIONS(1890),
    [anon_sym_and] = ACTIONS(2579),
    [anon_sym_or] = ACTIONS(2581),
    [sym_comment] = ACTIONS(73),
  },
  [871] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(1273),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(2587),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(2591),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2583),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_SLASH_SLASH] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_CARET] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2603),
    [anon_sym_LT_EQ] = ACTIONS(2587),
    [anon_sym_EQ_EQ] = ACTIONS(2587),
    [anon_sym_BANG_EQ] = ACTIONS(2587),
    [anon_sym_GT_EQ] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(2603),
    [anon_sym_LT_GT] = ACTIONS(2587),
    [anon_sym_is] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [872] = {
    [anon_sym_EQ] = ACTIONS(2607),
    [sym_comment] = ACTIONS(73),
  },
  [873] = {
    [sym_string] = STATE(1275),
    [aux_sym_concatenated_string_repeat1] = STATE(1275),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [874] = {
    [anon_sym_COMMA] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(2609),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [875] = {
    [sym_default_parameter] = STATE(864),
    [sym_typed_default_parameter] = STATE(864),
    [sym_list_splat] = STATE(865),
    [sym_dictionary_splat] = STATE(865),
    [sym_typed_parameter] = STATE(864),
    [sym_tuple] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(1651),
    [anon_sym_COLON] = ACTIONS(2611),
    [anon_sym_exec] = ACTIONS(1651),
    [sym_identifier] = ACTIONS(1655),
    [sym_comment] = ACTIONS(73),
  },
  [876] = {
    [aux_sym__parameters_repeat1] = STATE(876),
    [anon_sym_COMMA] = ACTIONS(2613),
    [anon_sym_COLON] = ACTIONS(2573),
    [sym_comment] = ACTIONS(73),
  },
  [877] = {
    [sym__expression] = STATE(1277),
    [sym__primary_expression] = STATE(882),
    [sym_not_operator] = STATE(1277),
    [sym_boolean_operator] = STATE(1277),
    [sym_binary_operator] = STATE(882),
    [sym_unary_operator] = STATE(882),
    [sym_comparison_operator] = STATE(1277),
    [sym_lambda] = STATE(1277),
    [sym_attribute] = STATE(882),
    [sym_subscript] = STATE(882),
    [sym_call] = STATE(882),
    [sym_list] = STATE(882),
    [sym_list_comprehension] = STATE(882),
    [sym_dictionary] = STATE(882),
    [sym_dictionary_comprehension] = STATE(882),
    [sym_set] = STATE(882),
    [sym_set_comprehension] = STATE(882),
    [sym_parenthesized_expression] = STATE(882),
    [sym_tuple] = STATE(882),
    [sym_generator_expression] = STATE(882),
    [sym_conditional_expression] = STATE(1277),
    [sym_concatenated_string] = STATE(882),
    [sym_string] = STATE(884),
    [sym_await] = STATE(1277),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_lambda] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1683),
    [sym_float] = ACTIONS(1683),
    [sym_identifier] = ACTIONS(1683),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_none] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1685),
    [sym_comment] = ACTIONS(73),
  },
  [878] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [879] = {
    [sym_lambda_parameters] = STATE(1279),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(2616),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [880] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(882),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(882),
    [sym_unary_operator] = STATE(882),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(882),
    [sym_subscript] = STATE(882),
    [sym_call] = STATE(882),
    [sym_list] = STATE(882),
    [sym_list_comprehension] = STATE(882),
    [sym_dictionary] = STATE(882),
    [sym_dictionary_comprehension] = STATE(882),
    [sym_set] = STATE(882),
    [sym_set_comprehension] = STATE(882),
    [sym_parenthesized_expression] = STATE(882),
    [sym_tuple] = STATE(882),
    [sym_generator_expression] = STATE(882),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(882),
    [sym_string] = STATE(884),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_lambda] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1683),
    [sym_float] = ACTIONS(1683),
    [sym_identifier] = ACTIONS(1683),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_none] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1685),
    [sym_comment] = ACTIONS(73),
  },
  [881] = {
    [anon_sym_COMMA] = ACTIONS(1890),
    [anon_sym_if] = ACTIONS(2618),
    [anon_sym_COLON] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1890),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2622),
    [sym_comment] = ACTIONS(73),
  },
  [882] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(1293),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_SLASH_SLASH] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_LT_GT] = ACTIONS(2628),
    [anon_sym_is] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [883] = {
    [anon_sym_COMMA] = ACTIONS(2648),
    [anon_sym_COLON] = ACTIONS(2648),
    [anon_sym_EQ] = ACTIONS(2650),
    [sym_comment] = ACTIONS(73),
  },
  [884] = {
    [sym_string] = STATE(1295),
    [aux_sym_concatenated_string_repeat1] = STATE(1295),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [885] = {
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(2652),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [886] = {
    [sym_default_parameter] = STATE(864),
    [sym_typed_default_parameter] = STATE(864),
    [sym_list_splat] = STATE(865),
    [sym_dictionary_splat] = STATE(865),
    [sym_typed_parameter] = STATE(864),
    [sym_tuple] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(1651),
    [anon_sym_COLON] = ACTIONS(2654),
    [anon_sym_exec] = ACTIONS(1651),
    [sym_identifier] = ACTIONS(1655),
    [sym_comment] = ACTIONS(73),
  },
  [887] = {
    [sym__newline] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_AT_EQ] = ACTIONS(2656),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2656),
  },
  [888] = {
    [anon_sym_COMMA] = ACTIONS(1890),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(1890),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [889] = {
    [anon_sym_RPAREN] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(2648),
    [anon_sym_COLON] = ACTIONS(2648),
    [sym_comment] = ACTIONS(73),
  },
  [890] = {
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(731),
    [sym_comment] = ACTIONS(73),
  },
  [891] = {
    [sym__expression] = STATE(1296),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(1296),
    [sym_boolean_operator] = STATE(1296),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(1296),
    [sym_lambda] = STATE(1296),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(1296),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(1296),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [892] = {
    [anon_sym_COLON] = ACTIONS(2658),
    [sym_comment] = ACTIONS(73),
  },
  [893] = {
    [sym__expression] = STATE(1298),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1298),
    [sym_boolean_operator] = STATE(1298),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1298),
    [sym_lambda] = STATE(1298),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1298),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1298),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [894] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [895] = {
    [sym__expression] = STATE(1299),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(1299),
    [sym_boolean_operator] = STATE(1299),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(1299),
    [sym_lambda] = STATE(1299),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(1299),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(1299),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [896] = {
    [sym__primary_expression] = STATE(1300),
    [sym_binary_operator] = STATE(1300),
    [sym_unary_operator] = STATE(1300),
    [sym_attribute] = STATE(1300),
    [sym_subscript] = STATE(1300),
    [sym_call] = STATE(1300),
    [sym_list] = STATE(1300),
    [sym_list_comprehension] = STATE(1300),
    [sym_dictionary] = STATE(1300),
    [sym_dictionary_comprehension] = STATE(1300),
    [sym_set] = STATE(1300),
    [sym_set_comprehension] = STATE(1300),
    [sym_parenthesized_expression] = STATE(1300),
    [sym_tuple] = STATE(1300),
    [sym_generator_expression] = STATE(1300),
    [sym_concatenated_string] = STATE(1300),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2662),
    [sym_float] = ACTIONS(2662),
    [sym_identifier] = ACTIONS(2662),
    [sym_true] = ACTIONS(2662),
    [sym_false] = ACTIONS(2662),
    [sym_none] = ACTIONS(2662),
    [sym_comment] = ACTIONS(73),
  },
  [897] = {
    [sym__primary_expression] = STATE(1301),
    [sym_binary_operator] = STATE(1301),
    [sym_unary_operator] = STATE(1301),
    [sym_attribute] = STATE(1301),
    [sym_subscript] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_list] = STATE(1301),
    [sym_list_comprehension] = STATE(1301),
    [sym_dictionary] = STATE(1301),
    [sym_dictionary_comprehension] = STATE(1301),
    [sym_set] = STATE(1301),
    [sym_set_comprehension] = STATE(1301),
    [sym_parenthesized_expression] = STATE(1301),
    [sym_tuple] = STATE(1301),
    [sym_generator_expression] = STATE(1301),
    [sym_concatenated_string] = STATE(1301),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2666),
    [sym_float] = ACTIONS(2666),
    [sym_identifier] = ACTIONS(2666),
    [sym_true] = ACTIONS(2666),
    [sym_false] = ACTIONS(2666),
    [sym_none] = ACTIONS(2666),
    [sym_comment] = ACTIONS(73),
  },
  [898] = {
    [sym__primary_expression] = STATE(1302),
    [sym_binary_operator] = STATE(1302),
    [sym_unary_operator] = STATE(1302),
    [sym_attribute] = STATE(1302),
    [sym_subscript] = STATE(1302),
    [sym_call] = STATE(1302),
    [sym_list] = STATE(1302),
    [sym_list_comprehension] = STATE(1302),
    [sym_dictionary] = STATE(1302),
    [sym_dictionary_comprehension] = STATE(1302),
    [sym_set] = STATE(1302),
    [sym_set_comprehension] = STATE(1302),
    [sym_parenthesized_expression] = STATE(1302),
    [sym_tuple] = STATE(1302),
    [sym_generator_expression] = STATE(1302),
    [sym_concatenated_string] = STATE(1302),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2668),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2670),
    [sym_float] = ACTIONS(2670),
    [sym_identifier] = ACTIONS(2670),
    [sym_true] = ACTIONS(2670),
    [sym_false] = ACTIONS(2670),
    [sym_none] = ACTIONS(2670),
    [sym_comment] = ACTIONS(73),
  },
  [899] = {
    [anon_sym_in] = ACTIONS(2672),
    [sym_comment] = ACTIONS(73),
  },
  [900] = {
    [sym__primary_expression] = STATE(1304),
    [sym_binary_operator] = STATE(1304),
    [sym_unary_operator] = STATE(1304),
    [sym_attribute] = STATE(1304),
    [sym_subscript] = STATE(1304),
    [sym_call] = STATE(1304),
    [sym_list] = STATE(1304),
    [sym_list_comprehension] = STATE(1304),
    [sym_dictionary] = STATE(1304),
    [sym_dictionary_comprehension] = STATE(1304),
    [sym_set] = STATE(1304),
    [sym_set_comprehension] = STATE(1304),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_tuple] = STATE(1304),
    [sym_generator_expression] = STATE(1304),
    [sym_concatenated_string] = STATE(1304),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2676),
    [sym_float] = ACTIONS(2676),
    [sym_identifier] = ACTIONS(2676),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [sym_none] = ACTIONS(2676),
    [sym_comment] = ACTIONS(73),
  },
  [901] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [902] = {
    [sym__primary_expression] = STATE(1305),
    [sym_binary_operator] = STATE(1305),
    [sym_unary_operator] = STATE(1305),
    [sym_attribute] = STATE(1305),
    [sym_subscript] = STATE(1305),
    [sym_call] = STATE(1305),
    [sym_list] = STATE(1305),
    [sym_list_comprehension] = STATE(1305),
    [sym_dictionary] = STATE(1305),
    [sym_dictionary_comprehension] = STATE(1305),
    [sym_set] = STATE(1305),
    [sym_set_comprehension] = STATE(1305),
    [sym_parenthesized_expression] = STATE(1305),
    [sym_tuple] = STATE(1305),
    [sym_generator_expression] = STATE(1305),
    [sym_concatenated_string] = STATE(1305),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2680),
    [sym_float] = ACTIONS(2680),
    [sym_identifier] = ACTIONS(2680),
    [sym_true] = ACTIONS(2680),
    [sym_false] = ACTIONS(2680),
    [sym_none] = ACTIONS(2680),
    [sym_comment] = ACTIONS(73),
  },
  [903] = {
    [sym__primary_expression] = STATE(1306),
    [sym_binary_operator] = STATE(1306),
    [sym_unary_operator] = STATE(1306),
    [sym_attribute] = STATE(1306),
    [sym_subscript] = STATE(1306),
    [sym_call] = STATE(1306),
    [sym_list] = STATE(1306),
    [sym_list_comprehension] = STATE(1306),
    [sym_dictionary] = STATE(1306),
    [sym_dictionary_comprehension] = STATE(1306),
    [sym_set] = STATE(1306),
    [sym_set_comprehension] = STATE(1306),
    [sym_parenthesized_expression] = STATE(1306),
    [sym_tuple] = STATE(1306),
    [sym_generator_expression] = STATE(1306),
    [sym_concatenated_string] = STATE(1306),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2682),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2684),
    [sym_float] = ACTIONS(2684),
    [sym_identifier] = ACTIONS(2684),
    [sym_true] = ACTIONS(2684),
    [sym_false] = ACTIONS(2684),
    [sym_none] = ACTIONS(2684),
    [sym_comment] = ACTIONS(73),
  },
  [904] = {
    [sym__primary_expression] = STATE(1307),
    [sym_binary_operator] = STATE(1307),
    [sym_unary_operator] = STATE(1307),
    [sym_attribute] = STATE(1307),
    [sym_subscript] = STATE(1307),
    [sym_call] = STATE(1307),
    [sym_list] = STATE(1307),
    [sym_list_comprehension] = STATE(1307),
    [sym_dictionary] = STATE(1307),
    [sym_dictionary_comprehension] = STATE(1307),
    [sym_set] = STATE(1307),
    [sym_set_comprehension] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple] = STATE(1307),
    [sym_generator_expression] = STATE(1307),
    [sym_concatenated_string] = STATE(1307),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2686),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2688),
    [sym_float] = ACTIONS(2688),
    [sym_identifier] = ACTIONS(2688),
    [sym_true] = ACTIONS(2688),
    [sym_false] = ACTIONS(2688),
    [sym_none] = ACTIONS(2688),
    [sym_comment] = ACTIONS(73),
  },
  [905] = {
    [sym__primary_expression] = STATE(1302),
    [sym_binary_operator] = STATE(1302),
    [sym_unary_operator] = STATE(1302),
    [sym_attribute] = STATE(1302),
    [sym_subscript] = STATE(1302),
    [sym_call] = STATE(1302),
    [sym_list] = STATE(1302),
    [sym_list_comprehension] = STATE(1302),
    [sym_dictionary] = STATE(1302),
    [sym_dictionary_comprehension] = STATE(1302),
    [sym_set] = STATE(1302),
    [sym_set_comprehension] = STATE(1302),
    [sym_parenthesized_expression] = STATE(1302),
    [sym_tuple] = STATE(1302),
    [sym_generator_expression] = STATE(1302),
    [sym_concatenated_string] = STATE(1302),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2668),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2670),
    [sym_float] = ACTIONS(2670),
    [sym_identifier] = ACTIONS(2670),
    [sym_true] = ACTIONS(2670),
    [sym_false] = ACTIONS(2670),
    [sym_none] = ACTIONS(2670),
    [sym_comment] = ACTIONS(73),
  },
  [906] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1308),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(1707),
    [anon_sym_not] = ACTIONS(1711),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1723),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1723),
    [anon_sym_LT_GT] = ACTIONS(1707),
    [anon_sym_is] = ACTIONS(1725),
    [anon_sym_RBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(73),
  },
  [907] = {
    [sym_string] = STATE(1309),
    [aux_sym_concatenated_string_repeat1] = STATE(1309),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_RBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [908] = {
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(801),
    [anon_sym_RBRACK] = ACTIONS(1671),
    [sym_comment] = ACTIONS(73),
  },
  [909] = {
    [sym__expression] = STATE(1310),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(1310),
    [sym_boolean_operator] = STATE(1310),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(1310),
    [sym_lambda] = STATE(1310),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(1310),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(1310),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [910] = {
    [sym__newline] = ACTIONS(2692),
    [anon_sym_DOT] = ACTIONS(2692),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_COMMA] = ACTIONS(2692),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2694),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_COLON] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_EQ] = ACTIONS(2694),
    [anon_sym_AT] = ACTIONS(2694),
    [anon_sym_not] = ACTIONS(2692),
    [anon_sym_and] = ACTIONS(2692),
    [anon_sym_or] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_SLASH] = ACTIONS(2694),
    [anon_sym_PERCENT] = ACTIONS(2694),
    [anon_sym_SLASH_SLASH] = ACTIONS(2694),
    [anon_sym_STAR_STAR] = ACTIONS(2694),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2694),
    [anon_sym_CARET] = ACTIONS(2694),
    [anon_sym_LT_LT] = ACTIONS(2694),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_LT_EQ] = ACTIONS(2692),
    [anon_sym_EQ_EQ] = ACTIONS(2692),
    [anon_sym_BANG_EQ] = ACTIONS(2692),
    [anon_sym_GT_EQ] = ACTIONS(2692),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_LT_GT] = ACTIONS(2692),
    [anon_sym_is] = ACTIONS(2692),
    [anon_sym_PLUS_EQ] = ACTIONS(2692),
    [anon_sym_DASH_EQ] = ACTIONS(2692),
    [anon_sym_STAR_EQ] = ACTIONS(2692),
    [anon_sym_SLASH_EQ] = ACTIONS(2692),
    [anon_sym_AT_EQ] = ACTIONS(2692),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2692),
    [anon_sym_PERCENT_EQ] = ACTIONS(2692),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2692),
    [anon_sym_GT_GT_EQ] = ACTIONS(2692),
    [anon_sym_LT_LT_EQ] = ACTIONS(2692),
    [anon_sym_AMP_EQ] = ACTIONS(2692),
    [anon_sym_CARET_EQ] = ACTIONS(2692),
    [anon_sym_PIPE_EQ] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2692),
  },
  [911] = {
    [anon_sym_COMMA] = ACTIONS(2696),
    [anon_sym_RBRACK] = ACTIONS(2696),
    [anon_sym_RBRACE] = ACTIONS(2696),
    [sym_comment] = ACTIONS(73),
  },
  [912] = {
    [anon_sym_COMMA] = ACTIONS(2696),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(2696),
    [sym_comment] = ACTIONS(73),
  },
  [913] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(912),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2698),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [914] = {
    [aux_sym_list_repeat1] = STATE(914),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_RBRACK] = ACTIONS(2696),
    [sym_comment] = ACTIONS(73),
  },
  [915] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(2703),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [916] = {
    [sym_variables] = STATE(1314),
    [sym__primary_expression] = STATE(108),
    [sym_binary_operator] = STATE(108),
    [sym_unary_operator] = STATE(108),
    [sym_attribute] = STATE(108),
    [sym_subscript] = STATE(108),
    [sym_call] = STATE(108),
    [sym_list] = STATE(108),
    [sym_list_comprehension] = STATE(108),
    [sym_dictionary] = STATE(108),
    [sym_dictionary_comprehension] = STATE(108),
    [sym_set] = STATE(108),
    [sym_set_comprehension] = STATE(108),
    [sym_parenthesized_expression] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_generator_expression] = STATE(108),
    [sym_concatenated_string] = STATE(108),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [917] = {
    [anon_sym_in] = ACTIONS(2705),
    [sym_comment] = ACTIONS(73),
  },
  [918] = {
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_RBRACK] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [919] = {
    [sym__newline] = ACTIONS(2707),
    [anon_sym_DOT] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(2707),
    [anon_sym_COMMA] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_GT_GT] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2707),
    [anon_sym_COLON] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2707),
    [anon_sym_EQ] = ACTIONS(2709),
    [anon_sym_AT] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2707),
    [anon_sym_and] = ACTIONS(2707),
    [anon_sym_or] = ACTIONS(2707),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_SLASH] = ACTIONS(2709),
    [anon_sym_PERCENT] = ACTIONS(2709),
    [anon_sym_SLASH_SLASH] = ACTIONS(2709),
    [anon_sym_STAR_STAR] = ACTIONS(2709),
    [anon_sym_PIPE] = ACTIONS(2709),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_CARET] = ACTIONS(2709),
    [anon_sym_LT_LT] = ACTIONS(2709),
    [anon_sym_LT] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2707),
    [anon_sym_BANG_EQ] = ACTIONS(2707),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2709),
    [anon_sym_LT_GT] = ACTIONS(2707),
    [anon_sym_is] = ACTIONS(2707),
    [anon_sym_PLUS_EQ] = ACTIONS(2707),
    [anon_sym_DASH_EQ] = ACTIONS(2707),
    [anon_sym_STAR_EQ] = ACTIONS(2707),
    [anon_sym_SLASH_EQ] = ACTIONS(2707),
    [anon_sym_AT_EQ] = ACTIONS(2707),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2707),
    [anon_sym_PERCENT_EQ] = ACTIONS(2707),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2707),
    [anon_sym_GT_GT_EQ] = ACTIONS(2707),
    [anon_sym_LT_LT_EQ] = ACTIONS(2707),
    [anon_sym_AMP_EQ] = ACTIONS(2707),
    [anon_sym_CARET_EQ] = ACTIONS(2707),
    [anon_sym_PIPE_EQ] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2707),
  },
  [920] = {
    [sym__expression] = STATE(1320),
    [sym__primary_expression] = STATE(1321),
    [sym_not_operator] = STATE(1320),
    [sym_boolean_operator] = STATE(1320),
    [sym_binary_operator] = STATE(1321),
    [sym_unary_operator] = STATE(1321),
    [sym_comparison_operator] = STATE(1320),
    [sym_lambda] = STATE(1320),
    [sym_attribute] = STATE(1321),
    [sym_subscript] = STATE(1321),
    [sym_call] = STATE(1321),
    [sym_list] = STATE(1321),
    [sym_list_comprehension] = STATE(1321),
    [sym_dictionary] = STATE(1321),
    [sym_dictionary_comprehension] = STATE(1321),
    [sym_set] = STATE(1321),
    [sym_set_comprehension] = STATE(1321),
    [sym_parenthesized_expression] = STATE(1321),
    [sym_tuple] = STATE(1321),
    [sym_generator_expression] = STATE(1321),
    [sym_conditional_expression] = STATE(1320),
    [sym_concatenated_string] = STATE(1321),
    [sym_string] = STATE(1322),
    [sym_await] = STATE(1320),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_lambda] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2719),
    [sym_float] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2719),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [sym_none] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(2721),
    [sym_comment] = ACTIONS(73),
  },
  [921] = {
    [sym_for_in_clause] = STATE(1323),
    [sym_if_clause] = STATE(1323),
    [aux_sym__comprehension_body_repeat1] = STATE(1323),
    [anon_sym_if] = ACTIONS(1737),
    [anon_sym_async] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_RBRACK] = ACTIONS(2219),
    [sym_comment] = ACTIONS(73),
  },
  [922] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [923] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_SLASH_SLASH] = ACTIONS(809),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [924] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_SLASH_SLASH] = ACTIONS(809),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [925] = {
    [sym__primary_expression] = STATE(1324),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_concatenated_string] = STATE(1324),
    [sym_string] = STATE(152),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2725),
    [sym_float] = ACTIONS(2725),
    [sym_identifier] = ACTIONS(2725),
    [sym_true] = ACTIONS(2725),
    [sym_false] = ACTIONS(2725),
    [sym_none] = ACTIONS(2725),
    [sym_comment] = ACTIONS(73),
  },
  [926] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_SLASH_SLASH] = ACTIONS(809),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [927] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_SLASH_SLASH] = ACTIONS(809),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(819),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [928] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_SLASH_SLASH] = ACTIONS(809),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [929] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_SLASH_SLASH] = ACTIONS(809),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [930] = {
    [aux_sym_comparison_operator_repeat1] = STATE(930),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2727),
    [anon_sym_not] = ACTIONS(2730),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2733),
    [anon_sym_LT_EQ] = ACTIONS(2727),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_GT_EQ] = ACTIONS(2727),
    [anon_sym_GT] = ACTIONS(2733),
    [anon_sym_LT_GT] = ACTIONS(2727),
    [anon_sym_is] = ACTIONS(2736),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [931] = {
    [sym_string] = STATE(931),
    [aux_sym_concatenated_string_repeat1] = STATE(931),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_async] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [932] = {
    [anon_sym_COMMA] = ACTIONS(2535),
    [anon_sym_if] = ACTIONS(1777),
    [anon_sym_and] = ACTIONS(1779),
    [anon_sym_or] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(2535),
    [sym_comment] = ACTIONS(73),
  },
  [933] = {
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(1779),
    [anon_sym_or] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(731),
    [sym_comment] = ACTIONS(73),
  },
  [934] = {
    [sym__expression] = STATE(1325),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(1325),
    [sym_boolean_operator] = STATE(1325),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(1325),
    [sym_lambda] = STATE(1325),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(1325),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [935] = {
    [anon_sym_COLON] = ACTIONS(2739),
    [sym_comment] = ACTIONS(73),
  },
  [936] = {
    [sym__expression] = STATE(1327),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1327),
    [sym_boolean_operator] = STATE(1327),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1327),
    [sym_lambda] = STATE(1327),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1327),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1327),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [937] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [938] = {
    [sym__expression] = STATE(1328),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(1328),
    [sym_boolean_operator] = STATE(1328),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(1328),
    [sym_lambda] = STATE(1328),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(1328),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [939] = {
    [sym__primary_expression] = STATE(1329),
    [sym_binary_operator] = STATE(1329),
    [sym_unary_operator] = STATE(1329),
    [sym_attribute] = STATE(1329),
    [sym_subscript] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym_list] = STATE(1329),
    [sym_list_comprehension] = STATE(1329),
    [sym_dictionary] = STATE(1329),
    [sym_dictionary_comprehension] = STATE(1329),
    [sym_set] = STATE(1329),
    [sym_set_comprehension] = STATE(1329),
    [sym_parenthesized_expression] = STATE(1329),
    [sym_tuple] = STATE(1329),
    [sym_generator_expression] = STATE(1329),
    [sym_concatenated_string] = STATE(1329),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2741),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2743),
    [sym_float] = ACTIONS(2743),
    [sym_identifier] = ACTIONS(2743),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [sym_none] = ACTIONS(2743),
    [sym_comment] = ACTIONS(73),
  },
  [940] = {
    [sym__primary_expression] = STATE(1330),
    [sym_binary_operator] = STATE(1330),
    [sym_unary_operator] = STATE(1330),
    [sym_attribute] = STATE(1330),
    [sym_subscript] = STATE(1330),
    [sym_call] = STATE(1330),
    [sym_list] = STATE(1330),
    [sym_list_comprehension] = STATE(1330),
    [sym_dictionary] = STATE(1330),
    [sym_dictionary_comprehension] = STATE(1330),
    [sym_set] = STATE(1330),
    [sym_set_comprehension] = STATE(1330),
    [sym_parenthesized_expression] = STATE(1330),
    [sym_tuple] = STATE(1330),
    [sym_generator_expression] = STATE(1330),
    [sym_concatenated_string] = STATE(1330),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2745),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2747),
    [sym_float] = ACTIONS(2747),
    [sym_identifier] = ACTIONS(2747),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [sym_none] = ACTIONS(2747),
    [sym_comment] = ACTIONS(73),
  },
  [941] = {
    [sym__primary_expression] = STATE(1331),
    [sym_binary_operator] = STATE(1331),
    [sym_unary_operator] = STATE(1331),
    [sym_attribute] = STATE(1331),
    [sym_subscript] = STATE(1331),
    [sym_call] = STATE(1331),
    [sym_list] = STATE(1331),
    [sym_list_comprehension] = STATE(1331),
    [sym_dictionary] = STATE(1331),
    [sym_dictionary_comprehension] = STATE(1331),
    [sym_set] = STATE(1331),
    [sym_set_comprehension] = STATE(1331),
    [sym_parenthesized_expression] = STATE(1331),
    [sym_tuple] = STATE(1331),
    [sym_generator_expression] = STATE(1331),
    [sym_concatenated_string] = STATE(1331),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2749),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2751),
    [sym_float] = ACTIONS(2751),
    [sym_identifier] = ACTIONS(2751),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [sym_none] = ACTIONS(2751),
    [sym_comment] = ACTIONS(73),
  },
  [942] = {
    [anon_sym_in] = ACTIONS(2753),
    [sym_comment] = ACTIONS(73),
  },
  [943] = {
    [sym__primary_expression] = STATE(1333),
    [sym_binary_operator] = STATE(1333),
    [sym_unary_operator] = STATE(1333),
    [sym_attribute] = STATE(1333),
    [sym_subscript] = STATE(1333),
    [sym_call] = STATE(1333),
    [sym_list] = STATE(1333),
    [sym_list_comprehension] = STATE(1333),
    [sym_dictionary] = STATE(1333),
    [sym_dictionary_comprehension] = STATE(1333),
    [sym_set] = STATE(1333),
    [sym_set_comprehension] = STATE(1333),
    [sym_parenthesized_expression] = STATE(1333),
    [sym_tuple] = STATE(1333),
    [sym_generator_expression] = STATE(1333),
    [sym_concatenated_string] = STATE(1333),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2757),
    [sym_float] = ACTIONS(2757),
    [sym_identifier] = ACTIONS(2757),
    [sym_true] = ACTIONS(2757),
    [sym_false] = ACTIONS(2757),
    [sym_none] = ACTIONS(2757),
    [sym_comment] = ACTIONS(73),
  },
  [944] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [945] = {
    [sym__primary_expression] = STATE(1334),
    [sym_binary_operator] = STATE(1334),
    [sym_unary_operator] = STATE(1334),
    [sym_attribute] = STATE(1334),
    [sym_subscript] = STATE(1334),
    [sym_call] = STATE(1334),
    [sym_list] = STATE(1334),
    [sym_list_comprehension] = STATE(1334),
    [sym_dictionary] = STATE(1334),
    [sym_dictionary_comprehension] = STATE(1334),
    [sym_set] = STATE(1334),
    [sym_set_comprehension] = STATE(1334),
    [sym_parenthesized_expression] = STATE(1334),
    [sym_tuple] = STATE(1334),
    [sym_generator_expression] = STATE(1334),
    [sym_concatenated_string] = STATE(1334),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2761),
    [sym_float] = ACTIONS(2761),
    [sym_identifier] = ACTIONS(2761),
    [sym_true] = ACTIONS(2761),
    [sym_false] = ACTIONS(2761),
    [sym_none] = ACTIONS(2761),
    [sym_comment] = ACTIONS(73),
  },
  [946] = {
    [sym__primary_expression] = STATE(1335),
    [sym_binary_operator] = STATE(1335),
    [sym_unary_operator] = STATE(1335),
    [sym_attribute] = STATE(1335),
    [sym_subscript] = STATE(1335),
    [sym_call] = STATE(1335),
    [sym_list] = STATE(1335),
    [sym_list_comprehension] = STATE(1335),
    [sym_dictionary] = STATE(1335),
    [sym_dictionary_comprehension] = STATE(1335),
    [sym_set] = STATE(1335),
    [sym_set_comprehension] = STATE(1335),
    [sym_parenthesized_expression] = STATE(1335),
    [sym_tuple] = STATE(1335),
    [sym_generator_expression] = STATE(1335),
    [sym_concatenated_string] = STATE(1335),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2765),
    [sym_float] = ACTIONS(2765),
    [sym_identifier] = ACTIONS(2765),
    [sym_true] = ACTIONS(2765),
    [sym_false] = ACTIONS(2765),
    [sym_none] = ACTIONS(2765),
    [sym_comment] = ACTIONS(73),
  },
  [947] = {
    [sym__primary_expression] = STATE(1336),
    [sym_binary_operator] = STATE(1336),
    [sym_unary_operator] = STATE(1336),
    [sym_attribute] = STATE(1336),
    [sym_subscript] = STATE(1336),
    [sym_call] = STATE(1336),
    [sym_list] = STATE(1336),
    [sym_list_comprehension] = STATE(1336),
    [sym_dictionary] = STATE(1336),
    [sym_dictionary_comprehension] = STATE(1336),
    [sym_set] = STATE(1336),
    [sym_set_comprehension] = STATE(1336),
    [sym_parenthesized_expression] = STATE(1336),
    [sym_tuple] = STATE(1336),
    [sym_generator_expression] = STATE(1336),
    [sym_concatenated_string] = STATE(1336),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2769),
    [sym_float] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2769),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [sym_none] = ACTIONS(2769),
    [sym_comment] = ACTIONS(73),
  },
  [948] = {
    [sym__primary_expression] = STATE(1331),
    [sym_binary_operator] = STATE(1331),
    [sym_unary_operator] = STATE(1331),
    [sym_attribute] = STATE(1331),
    [sym_subscript] = STATE(1331),
    [sym_call] = STATE(1331),
    [sym_list] = STATE(1331),
    [sym_list_comprehension] = STATE(1331),
    [sym_dictionary] = STATE(1331),
    [sym_dictionary_comprehension] = STATE(1331),
    [sym_set] = STATE(1331),
    [sym_set_comprehension] = STATE(1331),
    [sym_parenthesized_expression] = STATE(1331),
    [sym_tuple] = STATE(1331),
    [sym_generator_expression] = STATE(1331),
    [sym_concatenated_string] = STATE(1331),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2749),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2751),
    [sym_float] = ACTIONS(2751),
    [sym_identifier] = ACTIONS(2751),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [sym_none] = ACTIONS(2751),
    [sym_comment] = ACTIONS(73),
  },
  [949] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1337),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(1787),
    [anon_sym_not] = ACTIONS(1791),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1803),
    [anon_sym_LT_EQ] = ACTIONS(1787),
    [anon_sym_EQ_EQ] = ACTIONS(1787),
    [anon_sym_BANG_EQ] = ACTIONS(1787),
    [anon_sym_GT_EQ] = ACTIONS(1787),
    [anon_sym_GT] = ACTIONS(1803),
    [anon_sym_LT_GT] = ACTIONS(1787),
    [anon_sym_is] = ACTIONS(1805),
    [anon_sym_RBRACE] = ACTIONS(999),
    [sym_comment] = ACTIONS(73),
  },
  [950] = {
    [sym_string] = STATE(1338),
    [aux_sym_concatenated_string_repeat1] = STATE(1338),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [951] = {
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(863),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(1671),
    [sym_comment] = ACTIONS(73),
  },
  [952] = {
    [sym__expression] = STATE(1339),
    [sym__primary_expression] = STATE(163),
    [sym_not_operator] = STATE(1339),
    [sym_boolean_operator] = STATE(1339),
    [sym_binary_operator] = STATE(163),
    [sym_unary_operator] = STATE(163),
    [sym_comparison_operator] = STATE(1339),
    [sym_lambda] = STATE(1339),
    [sym_attribute] = STATE(163),
    [sym_subscript] = STATE(163),
    [sym_call] = STATE(163),
    [sym_list] = STATE(163),
    [sym_list_comprehension] = STATE(163),
    [sym_dictionary] = STATE(163),
    [sym_dictionary_comprehension] = STATE(163),
    [sym_set] = STATE(163),
    [sym_set_comprehension] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_tuple] = STATE(163),
    [sym_generator_expression] = STATE(163),
    [sym_conditional_expression] = STATE(1339),
    [sym_concatenated_string] = STATE(163),
    [sym_string] = STATE(165),
    [sym_await] = STATE(1339),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [953] = {
    [sym__expression] = STATE(482),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(482),
    [sym_boolean_operator] = STATE(482),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(482),
    [sym_lambda] = STATE(482),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(482),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(482),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(737),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [954] = {
    [sym__newline] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2773),
    [anon_sym_LPAREN] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_GT_GT] = ACTIONS(2775),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_COLON] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_EQ] = ACTIONS(2775),
    [anon_sym_AT] = ACTIONS(2775),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2775),
    [anon_sym_SLASH] = ACTIONS(2775),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_SLASH_SLASH] = ACTIONS(2775),
    [anon_sym_STAR_STAR] = ACTIONS(2775),
    [anon_sym_PIPE] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_CARET] = ACTIONS(2775),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_LT] = ACTIONS(2775),
    [anon_sym_LT_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ] = ACTIONS(2773),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_GT] = ACTIONS(2775),
    [anon_sym_LT_GT] = ACTIONS(2773),
    [anon_sym_is] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_AT_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2773),
  },
  [955] = {
    [anon_sym_COMMA] = ACTIONS(2696),
    [anon_sym_if] = ACTIONS(1777),
    [anon_sym_and] = ACTIONS(1779),
    [anon_sym_or] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(2696),
    [sym_comment] = ACTIONS(73),
  },
  [956] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(955),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(955),
    [sym_boolean_operator] = STATE(955),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(955),
    [sym_lambda] = STATE(955),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(955),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(955),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [957] = {
    [aux_sym_list_repeat1] = STATE(957),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_RBRACE] = ACTIONS(2696),
    [sym_comment] = ACTIONS(73),
  },
  [958] = {
    [anon_sym_STAR] = ACTIONS(829),
    [sym_comment] = ACTIONS(73),
  },
  [959] = {
    [sym__newline] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2784),
    [anon_sym_GT_GT] = ACTIONS(2784),
    [anon_sym_if] = ACTIONS(2782),
    [anon_sym_COLON] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(2782),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2784),
    [anon_sym_not] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_PERCENT] = ACTIONS(2784),
    [anon_sym_SLASH_SLASH] = ACTIONS(2784),
    [anon_sym_STAR_STAR] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_LT_GT] = ACTIONS(2782),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_PLUS_EQ] = ACTIONS(2782),
    [anon_sym_DASH_EQ] = ACTIONS(2782),
    [anon_sym_STAR_EQ] = ACTIONS(2782),
    [anon_sym_SLASH_EQ] = ACTIONS(2782),
    [anon_sym_AT_EQ] = ACTIONS(2782),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2782),
    [anon_sym_PERCENT_EQ] = ACTIONS(2782),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2782),
    [anon_sym_GT_GT_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT_EQ] = ACTIONS(2782),
    [anon_sym_AMP_EQ] = ACTIONS(2782),
    [anon_sym_CARET_EQ] = ACTIONS(2782),
    [anon_sym_PIPE_EQ] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2782),
  },
  [960] = {
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(73),
  },
  [961] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(2788),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [962] = {
    [sym_dictionary_splat] = STATE(960),
    [sym__expression] = STATE(961),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(961),
    [sym_boolean_operator] = STATE(961),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(961),
    [sym_lambda] = STATE(961),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_pair] = STATE(960),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(961),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(961),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [963] = {
    [aux_sym_dictionary_repeat1] = STATE(963),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(73),
  },
  [964] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(2795),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [965] = {
    [sym__expression] = STATE(1346),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1346),
    [sym_boolean_operator] = STATE(1346),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1346),
    [sym_lambda] = STATE(1346),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1346),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1346),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [966] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [967] = {
    [sym_lambda_parameters] = STATE(1348),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(2797),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [968] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [969] = {
    [anon_sym_COMMA] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [sym_comment] = ACTIONS(73),
  },
  [970] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(1362),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(2811),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2815),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_LT_GT] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [971] = {
    [sym_string] = STATE(1363),
    [aux_sym_concatenated_string_repeat1] = STATE(1363),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [972] = {
    [sym_variables] = STATE(1364),
    [sym__primary_expression] = STATE(108),
    [sym_binary_operator] = STATE(108),
    [sym_unary_operator] = STATE(108),
    [sym_attribute] = STATE(108),
    [sym_subscript] = STATE(108),
    [sym_call] = STATE(108),
    [sym_list] = STATE(108),
    [sym_list_comprehension] = STATE(108),
    [sym_dictionary] = STATE(108),
    [sym_dictionary_comprehension] = STATE(108),
    [sym_set] = STATE(108),
    [sym_set_comprehension] = STATE(108),
    [sym_parenthesized_expression] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_generator_expression] = STATE(108),
    [sym_concatenated_string] = STATE(108),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [973] = {
    [anon_sym_in] = ACTIONS(2831),
    [sym_comment] = ACTIONS(73),
  },
  [974] = {
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_COLON] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(863),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_RBRACE] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [975] = {
    [sym__newline] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_GT_GT] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_AT] = ACTIONS(2835),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_SLASH] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_SLASH_SLASH] = ACTIONS(2835),
    [anon_sym_STAR_STAR] = ACTIONS(2835),
    [anon_sym_PIPE] = ACTIONS(2835),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_CARET] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2835),
    [anon_sym_LT_GT] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_PLUS_EQ] = ACTIONS(2833),
    [anon_sym_DASH_EQ] = ACTIONS(2833),
    [anon_sym_STAR_EQ] = ACTIONS(2833),
    [anon_sym_SLASH_EQ] = ACTIONS(2833),
    [anon_sym_AT_EQ] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2833),
    [anon_sym_PERCENT_EQ] = ACTIONS(2833),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2833),
    [anon_sym_AMP_EQ] = ACTIONS(2833),
    [anon_sym_CARET_EQ] = ACTIONS(2833),
    [anon_sym_PIPE_EQ] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2833),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2833),
  },
  [976] = {
    [sym__expression] = STATE(1370),
    [sym__primary_expression] = STATE(1371),
    [sym_not_operator] = STATE(1370),
    [sym_boolean_operator] = STATE(1370),
    [sym_binary_operator] = STATE(1371),
    [sym_unary_operator] = STATE(1371),
    [sym_comparison_operator] = STATE(1370),
    [sym_lambda] = STATE(1370),
    [sym_attribute] = STATE(1371),
    [sym_subscript] = STATE(1371),
    [sym_call] = STATE(1371),
    [sym_list] = STATE(1371),
    [sym_list_comprehension] = STATE(1371),
    [sym_dictionary] = STATE(1371),
    [sym_dictionary_comprehension] = STATE(1371),
    [sym_set] = STATE(1371),
    [sym_set_comprehension] = STATE(1371),
    [sym_parenthesized_expression] = STATE(1371),
    [sym_tuple] = STATE(1371),
    [sym_generator_expression] = STATE(1371),
    [sym_conditional_expression] = STATE(1370),
    [sym_concatenated_string] = STATE(1371),
    [sym_string] = STATE(1372),
    [sym_await] = STATE(1370),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2845),
    [sym_float] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [anon_sym_await] = ACTIONS(2847),
    [sym_comment] = ACTIONS(73),
  },
  [977] = {
    [sym_for_in_clause] = STATE(1373),
    [sym_if_clause] = STATE(1373),
    [aux_sym__comprehension_body_repeat1] = STATE(1373),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(73),
  },
  [978] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [979] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(873),
    [anon_sym_SLASH_SLASH] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [980] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(873),
    [anon_sym_SLASH_SLASH] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(881),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(869),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [981] = {
    [sym__primary_expression] = STATE(1374),
    [sym_binary_operator] = STATE(1374),
    [sym_unary_operator] = STATE(1374),
    [sym_attribute] = STATE(1374),
    [sym_subscript] = STATE(1374),
    [sym_call] = STATE(1374),
    [sym_list] = STATE(1374),
    [sym_list_comprehension] = STATE(1374),
    [sym_dictionary] = STATE(1374),
    [sym_dictionary_comprehension] = STATE(1374),
    [sym_set] = STATE(1374),
    [sym_set_comprehension] = STATE(1374),
    [sym_parenthesized_expression] = STATE(1374),
    [sym_tuple] = STATE(1374),
    [sym_generator_expression] = STATE(1374),
    [sym_concatenated_string] = STATE(1374),
    [sym_string] = STATE(165),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2851),
    [sym_float] = ACTIONS(2851),
    [sym_identifier] = ACTIONS(2851),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [sym_none] = ACTIONS(2851),
    [sym_comment] = ACTIONS(73),
  },
  [982] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(873),
    [anon_sym_SLASH_SLASH] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [983] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(873),
    [anon_sym_SLASH_SLASH] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(869),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [984] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(873),
    [anon_sym_SLASH_SLASH] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(869),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [985] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(873),
    [anon_sym_SLASH_SLASH] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(869),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [986] = {
    [aux_sym_comparison_operator_repeat1] = STATE(986),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2859),
    [anon_sym_LT_EQ] = ACTIONS(2853),
    [anon_sym_EQ_EQ] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_GT] = ACTIONS(2859),
    [anon_sym_LT_GT] = ACTIONS(2853),
    [anon_sym_is] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [987] = {
    [sym__newline] = ACTIONS(2865),
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2865),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_EQ] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2867),
    [anon_sym_not] = ACTIONS(2865),
    [anon_sym_and] = ACTIONS(2865),
    [anon_sym_or] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_SLASH] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_SLASH_SLASH] = ACTIONS(2867),
    [anon_sym_STAR_STAR] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_CARET] = ACTIONS(2867),
    [anon_sym_LT_LT] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_LT_EQ] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_GT_EQ] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_LT_GT] = ACTIONS(2865),
    [anon_sym_is] = ACTIONS(2865),
    [anon_sym_PLUS_EQ] = ACTIONS(2865),
    [anon_sym_DASH_EQ] = ACTIONS(2865),
    [anon_sym_STAR_EQ] = ACTIONS(2865),
    [anon_sym_SLASH_EQ] = ACTIONS(2865),
    [anon_sym_AT_EQ] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2865),
    [anon_sym_PERCENT_EQ] = ACTIONS(2865),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2865),
    [anon_sym_GT_GT_EQ] = ACTIONS(2865),
    [anon_sym_LT_LT_EQ] = ACTIONS(2865),
    [anon_sym_AMP_EQ] = ACTIONS(2865),
    [anon_sym_CARET_EQ] = ACTIONS(2865),
    [anon_sym_PIPE_EQ] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2865),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2865),
  },
  [988] = {
    [sym_string] = STATE(988),
    [aux_sym_concatenated_string_repeat1] = STATE(988),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_async] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [989] = {
    [sym__string_start] = ACTIONS(2869),
    [ts_builtin_sym_end] = ACTIONS(2869),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_from] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2869),
    [anon_sym_print] = ACTIONS(2871),
    [anon_sym_assert] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_del] = ACTIONS(2871),
    [anon_sym_raise] = ACTIONS(2871),
    [anon_sym_pass] = ACTIONS(2871),
    [anon_sym_break] = ACTIONS(2871),
    [anon_sym_continue] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_elif] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2871),
    [anon_sym_async] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_except] = ACTIONS(2871),
    [anon_sym_finally] = ACTIONS(2871),
    [anon_sym_with] = ACTIONS(2871),
    [anon_sym_def] = ACTIONS(2871),
    [anon_sym_global] = ACTIONS(2871),
    [anon_sym_nonlocal] = ACTIONS(2871),
    [anon_sym_exec] = ACTIONS(2871),
    [anon_sym_class] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_not] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2869),
    [anon_sym_lambda] = ACTIONS(2871),
    [anon_sym_yield] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2869),
    [sym_ellipsis] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [sym_integer] = ACTIONS(2871),
    [sym_float] = ACTIONS(2871),
    [sym_identifier] = ACTIONS(2871),
    [sym_true] = ACTIONS(2871),
    [sym_false] = ACTIONS(2871),
    [sym_none] = ACTIONS(2871),
    [anon_sym_await] = ACTIONS(2871),
    [sym_comment] = ACTIONS(73),
  },
  [990] = {
    [sym_import_statement] = STATE(515),
    [sym_import_from_statement] = STATE(515),
    [sym_print_statement] = STATE(515),
    [sym_assert_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_delete_statement] = STATE(515),
    [sym_raise_statement] = STATE(515),
    [sym_pass_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_global_statement] = STATE(515),
    [sym_nonlocal_statement] = STATE(515),
    [sym_exec_statement] = STATE(515),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [991] = {
    [sym__newline] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(1894),
    [anon_sym_or] = ACTIONS(1896),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(731),
  },
  [992] = {
    [sym__expression] = STATE(1375),
    [sym__primary_expression] = STATE(523),
    [sym_not_operator] = STATE(1375),
    [sym_boolean_operator] = STATE(1375),
    [sym_binary_operator] = STATE(523),
    [sym_unary_operator] = STATE(523),
    [sym_comparison_operator] = STATE(1375),
    [sym_lambda] = STATE(1375),
    [sym_attribute] = STATE(523),
    [sym_subscript] = STATE(523),
    [sym_call] = STATE(523),
    [sym_list] = STATE(523),
    [sym_list_comprehension] = STATE(523),
    [sym_dictionary] = STATE(523),
    [sym_dictionary_comprehension] = STATE(523),
    [sym_set] = STATE(523),
    [sym_set_comprehension] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_tuple] = STATE(523),
    [sym_generator_expression] = STATE(523),
    [sym_conditional_expression] = STATE(1375),
    [sym_concatenated_string] = STATE(523),
    [sym_string] = STATE(525),
    [sym_await] = STATE(1375),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_lambda] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(909),
    [sym_float] = ACTIONS(909),
    [sym_identifier] = ACTIONS(909),
    [sym_true] = ACTIONS(909),
    [sym_false] = ACTIONS(909),
    [sym_none] = ACTIONS(909),
    [anon_sym_await] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
  },
  [993] = {
    [anon_sym_COLON] = ACTIONS(2873),
    [sym_comment] = ACTIONS(73),
  },
  [994] = {
    [sym__expression] = STATE(1377),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1377),
    [sym_boolean_operator] = STATE(1377),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1377),
    [sym_lambda] = STATE(1377),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1377),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1377),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [995] = {
    [sym__expression] = STATE(538),
    [sym__primary_expression] = STATE(523),
    [sym_not_operator] = STATE(538),
    [sym_boolean_operator] = STATE(538),
    [sym_binary_operator] = STATE(523),
    [sym_unary_operator] = STATE(523),
    [sym_comparison_operator] = STATE(538),
    [sym_lambda] = STATE(538),
    [sym_attribute] = STATE(523),
    [sym_subscript] = STATE(523),
    [sym_call] = STATE(523),
    [sym_list] = STATE(523),
    [sym_list_comprehension] = STATE(523),
    [sym_dictionary] = STATE(523),
    [sym_dictionary_comprehension] = STATE(523),
    [sym_set] = STATE(523),
    [sym_set_comprehension] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_tuple] = STATE(523),
    [sym_generator_expression] = STATE(523),
    [sym_conditional_expression] = STATE(538),
    [sym_concatenated_string] = STATE(523),
    [sym_string] = STATE(525),
    [sym_await] = STATE(538),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_lambda] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(909),
    [sym_float] = ACTIONS(909),
    [sym_identifier] = ACTIONS(909),
    [sym_true] = ACTIONS(909),
    [sym_false] = ACTIONS(909),
    [sym_none] = ACTIONS(909),
    [anon_sym_await] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
  },
  [996] = {
    [sym__expression] = STATE(1378),
    [sym__primary_expression] = STATE(523),
    [sym_not_operator] = STATE(1378),
    [sym_boolean_operator] = STATE(1378),
    [sym_binary_operator] = STATE(523),
    [sym_unary_operator] = STATE(523),
    [sym_comparison_operator] = STATE(1378),
    [sym_lambda] = STATE(1378),
    [sym_attribute] = STATE(523),
    [sym_subscript] = STATE(523),
    [sym_call] = STATE(523),
    [sym_list] = STATE(523),
    [sym_list_comprehension] = STATE(523),
    [sym_dictionary] = STATE(523),
    [sym_dictionary_comprehension] = STATE(523),
    [sym_set] = STATE(523),
    [sym_set_comprehension] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_tuple] = STATE(523),
    [sym_generator_expression] = STATE(523),
    [sym_conditional_expression] = STATE(1378),
    [sym_concatenated_string] = STATE(523),
    [sym_string] = STATE(525),
    [sym_await] = STATE(1378),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_lambda] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(909),
    [sym_float] = ACTIONS(909),
    [sym_identifier] = ACTIONS(909),
    [sym_true] = ACTIONS(909),
    [sym_false] = ACTIONS(909),
    [sym_none] = ACTIONS(909),
    [anon_sym_await] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
  },
  [997] = {
    [sym__primary_expression] = STATE(1379),
    [sym_binary_operator] = STATE(1379),
    [sym_unary_operator] = STATE(1379),
    [sym_attribute] = STATE(1379),
    [sym_subscript] = STATE(1379),
    [sym_call] = STATE(1379),
    [sym_list] = STATE(1379),
    [sym_list_comprehension] = STATE(1379),
    [sym_dictionary] = STATE(1379),
    [sym_dictionary_comprehension] = STATE(1379),
    [sym_set] = STATE(1379),
    [sym_set_comprehension] = STATE(1379),
    [sym_parenthesized_expression] = STATE(1379),
    [sym_tuple] = STATE(1379),
    [sym_generator_expression] = STATE(1379),
    [sym_concatenated_string] = STATE(1379),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2877),
    [sym_float] = ACTIONS(2877),
    [sym_identifier] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_none] = ACTIONS(2877),
    [sym_comment] = ACTIONS(73),
  },
  [998] = {
    [sym__primary_expression] = STATE(1380),
    [sym_binary_operator] = STATE(1380),
    [sym_unary_operator] = STATE(1380),
    [sym_attribute] = STATE(1380),
    [sym_subscript] = STATE(1380),
    [sym_call] = STATE(1380),
    [sym_list] = STATE(1380),
    [sym_list_comprehension] = STATE(1380),
    [sym_dictionary] = STATE(1380),
    [sym_dictionary_comprehension] = STATE(1380),
    [sym_set] = STATE(1380),
    [sym_set_comprehension] = STATE(1380),
    [sym_parenthesized_expression] = STATE(1380),
    [sym_tuple] = STATE(1380),
    [sym_generator_expression] = STATE(1380),
    [sym_concatenated_string] = STATE(1380),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2881),
    [sym_float] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_none] = ACTIONS(2881),
    [sym_comment] = ACTIONS(73),
  },
  [999] = {
    [sym__primary_expression] = STATE(1381),
    [sym_binary_operator] = STATE(1381),
    [sym_unary_operator] = STATE(1381),
    [sym_attribute] = STATE(1381),
    [sym_subscript] = STATE(1381),
    [sym_call] = STATE(1381),
    [sym_list] = STATE(1381),
    [sym_list_comprehension] = STATE(1381),
    [sym_dictionary] = STATE(1381),
    [sym_dictionary_comprehension] = STATE(1381),
    [sym_set] = STATE(1381),
    [sym_set_comprehension] = STATE(1381),
    [sym_parenthesized_expression] = STATE(1381),
    [sym_tuple] = STATE(1381),
    [sym_generator_expression] = STATE(1381),
    [sym_concatenated_string] = STATE(1381),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2885),
    [sym_float] = ACTIONS(2885),
    [sym_identifier] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_none] = ACTIONS(2885),
    [sym_comment] = ACTIONS(73),
  },
  [1000] = {
    [anon_sym_in] = ACTIONS(2887),
    [sym_comment] = ACTIONS(73),
  },
  [1001] = {
    [sym__primary_expression] = STATE(1383),
    [sym_binary_operator] = STATE(1383),
    [sym_unary_operator] = STATE(1383),
    [sym_attribute] = STATE(1383),
    [sym_subscript] = STATE(1383),
    [sym_call] = STATE(1383),
    [sym_list] = STATE(1383),
    [sym_list_comprehension] = STATE(1383),
    [sym_dictionary] = STATE(1383),
    [sym_dictionary_comprehension] = STATE(1383),
    [sym_set] = STATE(1383),
    [sym_set_comprehension] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1383),
    [sym_tuple] = STATE(1383),
    [sym_generator_expression] = STATE(1383),
    [sym_concatenated_string] = STATE(1383),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2891),
    [sym_float] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [sym_none] = ACTIONS(2891),
    [sym_comment] = ACTIONS(73),
  },
  [1002] = {
    [sym__primary_expression] = STATE(709),
    [sym_binary_operator] = STATE(709),
    [sym_unary_operator] = STATE(709),
    [sym_attribute] = STATE(709),
    [sym_subscript] = STATE(709),
    [sym_call] = STATE(709),
    [sym_list] = STATE(709),
    [sym_list_comprehension] = STATE(709),
    [sym_dictionary] = STATE(709),
    [sym_dictionary_comprehension] = STATE(709),
    [sym_set] = STATE(709),
    [sym_set_comprehension] = STATE(709),
    [sym_parenthesized_expression] = STATE(709),
    [sym_tuple] = STATE(709),
    [sym_generator_expression] = STATE(709),
    [sym_concatenated_string] = STATE(709),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1363),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1365),
    [sym_float] = ACTIONS(1365),
    [sym_identifier] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_none] = ACTIONS(1365),
    [sym_comment] = ACTIONS(73),
  },
  [1003] = {
    [sym__primary_expression] = STATE(1384),
    [sym_binary_operator] = STATE(1384),
    [sym_unary_operator] = STATE(1384),
    [sym_attribute] = STATE(1384),
    [sym_subscript] = STATE(1384),
    [sym_call] = STATE(1384),
    [sym_list] = STATE(1384),
    [sym_list_comprehension] = STATE(1384),
    [sym_dictionary] = STATE(1384),
    [sym_dictionary_comprehension] = STATE(1384),
    [sym_set] = STATE(1384),
    [sym_set_comprehension] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple] = STATE(1384),
    [sym_generator_expression] = STATE(1384),
    [sym_concatenated_string] = STATE(1384),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2895),
    [sym_float] = ACTIONS(2895),
    [sym_identifier] = ACTIONS(2895),
    [sym_true] = ACTIONS(2895),
    [sym_false] = ACTIONS(2895),
    [sym_none] = ACTIONS(2895),
    [sym_comment] = ACTIONS(73),
  },
  [1004] = {
    [sym__primary_expression] = STATE(1385),
    [sym_binary_operator] = STATE(1385),
    [sym_unary_operator] = STATE(1385),
    [sym_attribute] = STATE(1385),
    [sym_subscript] = STATE(1385),
    [sym_call] = STATE(1385),
    [sym_list] = STATE(1385),
    [sym_list_comprehension] = STATE(1385),
    [sym_dictionary] = STATE(1385),
    [sym_dictionary_comprehension] = STATE(1385),
    [sym_set] = STATE(1385),
    [sym_set_comprehension] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_tuple] = STATE(1385),
    [sym_generator_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2899),
    [sym_float] = ACTIONS(2899),
    [sym_identifier] = ACTIONS(2899),
    [sym_true] = ACTIONS(2899),
    [sym_false] = ACTIONS(2899),
    [sym_none] = ACTIONS(2899),
    [sym_comment] = ACTIONS(73),
  },
  [1005] = {
    [sym__primary_expression] = STATE(1386),
    [sym_binary_operator] = STATE(1386),
    [sym_unary_operator] = STATE(1386),
    [sym_attribute] = STATE(1386),
    [sym_subscript] = STATE(1386),
    [sym_call] = STATE(1386),
    [sym_list] = STATE(1386),
    [sym_list_comprehension] = STATE(1386),
    [sym_dictionary] = STATE(1386),
    [sym_dictionary_comprehension] = STATE(1386),
    [sym_set] = STATE(1386),
    [sym_set_comprehension] = STATE(1386),
    [sym_parenthesized_expression] = STATE(1386),
    [sym_tuple] = STATE(1386),
    [sym_generator_expression] = STATE(1386),
    [sym_concatenated_string] = STATE(1386),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2903),
    [sym_float] = ACTIONS(2903),
    [sym_identifier] = ACTIONS(2903),
    [sym_true] = ACTIONS(2903),
    [sym_false] = ACTIONS(2903),
    [sym_none] = ACTIONS(2903),
    [sym_comment] = ACTIONS(73),
  },
  [1006] = {
    [sym__primary_expression] = STATE(1381),
    [sym_binary_operator] = STATE(1381),
    [sym_unary_operator] = STATE(1381),
    [sym_attribute] = STATE(1381),
    [sym_subscript] = STATE(1381),
    [sym_call] = STATE(1381),
    [sym_list] = STATE(1381),
    [sym_list_comprehension] = STATE(1381),
    [sym_dictionary] = STATE(1381),
    [sym_dictionary_comprehension] = STATE(1381),
    [sym_set] = STATE(1381),
    [sym_set_comprehension] = STATE(1381),
    [sym_parenthesized_expression] = STATE(1381),
    [sym_tuple] = STATE(1381),
    [sym_generator_expression] = STATE(1381),
    [sym_concatenated_string] = STATE(1381),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2885),
    [sym_float] = ACTIONS(2885),
    [sym_identifier] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_none] = ACTIONS(2885),
    [sym_comment] = ACTIONS(73),
  },
  [1007] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1387),
    [sym__newline] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(1902),
    [anon_sym_EQ] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1906),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_LT_EQ] = ACTIONS(1902),
    [anon_sym_EQ_EQ] = ACTIONS(1902),
    [anon_sym_BANG_EQ] = ACTIONS(1902),
    [anon_sym_GT_EQ] = ACTIONS(1902),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_LT_GT] = ACTIONS(1902),
    [anon_sym_is] = ACTIONS(1920),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(999),
  },
  [1008] = {
    [sym_expression_list] = STATE(526),
    [sym__expression] = STATE(527),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(527),
    [sym_boolean_operator] = STATE(527),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(527),
    [sym_lambda] = STATE(527),
    [sym_assignment] = STATE(1388),
    [sym_augmented_assignment] = STATE(1388),
    [sym__right_hand_side] = STATE(1388),
    [sym_yield] = STATE(1388),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(527),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(527),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1009] = {
    [sym_string] = STATE(1389),
    [aux_sym_concatenated_string_repeat1] = STATE(1389),
    [sym__newline] = ACTIONS(1003),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1003),
  },
  [1010] = {
    [sym__expression] = STATE(530),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(530),
    [sym_boolean_operator] = STATE(530),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(530),
    [sym_lambda] = STATE(530),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(530),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(530),
    [sym__newline] = ACTIONS(915),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(917),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(915),
    [anon_sym_DASH_EQ] = ACTIONS(915),
    [anon_sym_STAR_EQ] = ACTIONS(915),
    [anon_sym_SLASH_EQ] = ACTIONS(915),
    [anon_sym_AT_EQ] = ACTIONS(915),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(915),
    [anon_sym_PERCENT_EQ] = ACTIONS(915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(915),
    [anon_sym_GT_GT_EQ] = ACTIONS(915),
    [anon_sym_LT_LT_EQ] = ACTIONS(915),
    [anon_sym_AMP_EQ] = ACTIONS(915),
    [anon_sym_CARET_EQ] = ACTIONS(915),
    [anon_sym_PIPE_EQ] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(915),
  },
  [1011] = {
    [aux_sym_print_statement_repeat1] = STATE(541),
    [sym__newline] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_PLUS_EQ] = ACTIONS(915),
    [anon_sym_DASH_EQ] = ACTIONS(915),
    [anon_sym_STAR_EQ] = ACTIONS(915),
    [anon_sym_SLASH_EQ] = ACTIONS(915),
    [anon_sym_AT_EQ] = ACTIONS(915),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(915),
    [anon_sym_PERCENT_EQ] = ACTIONS(915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(915),
    [anon_sym_GT_GT_EQ] = ACTIONS(915),
    [anon_sym_LT_LT_EQ] = ACTIONS(915),
    [anon_sym_AMP_EQ] = ACTIONS(915),
    [anon_sym_CARET_EQ] = ACTIONS(915),
    [anon_sym_PIPE_EQ] = ACTIONS(915),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(915),
  },
  [1012] = {
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_else] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1013] = {
    [sym__expression] = STATE(1391),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1391),
    [sym_boolean_operator] = STATE(1391),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1391),
    [sym_lambda] = STATE(1391),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1391),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1014] = {
    [anon_sym_COLON] = ACTIONS(2909),
    [sym_comment] = ACTIONS(73),
  },
  [1015] = {
    [sym__expression] = STATE(1393),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1393),
    [sym_boolean_operator] = STATE(1393),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1393),
    [sym_lambda] = STATE(1393),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1393),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1393),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1016] = {
    [sym__expression] = STATE(1394),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(1394),
    [sym_boolean_operator] = STATE(1394),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(1394),
    [sym_lambda] = STATE(1394),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(1394),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(1394),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1017] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1018] = {
    [sym__expression] = STATE(1395),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1395),
    [sym_boolean_operator] = STATE(1395),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1395),
    [sym_lambda] = STATE(1395),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1395),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1395),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1019] = {
    [sym__primary_expression] = STATE(1396),
    [sym_binary_operator] = STATE(1396),
    [sym_unary_operator] = STATE(1396),
    [sym_attribute] = STATE(1396),
    [sym_subscript] = STATE(1396),
    [sym_call] = STATE(1396),
    [sym_list] = STATE(1396),
    [sym_list_comprehension] = STATE(1396),
    [sym_dictionary] = STATE(1396),
    [sym_dictionary_comprehension] = STATE(1396),
    [sym_set] = STATE(1396),
    [sym_set_comprehension] = STATE(1396),
    [sym_parenthesized_expression] = STATE(1396),
    [sym_tuple] = STATE(1396),
    [sym_generator_expression] = STATE(1396),
    [sym_concatenated_string] = STATE(1396),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2913),
    [sym_float] = ACTIONS(2913),
    [sym_identifier] = ACTIONS(2913),
    [sym_true] = ACTIONS(2913),
    [sym_false] = ACTIONS(2913),
    [sym_none] = ACTIONS(2913),
    [sym_comment] = ACTIONS(73),
  },
  [1020] = {
    [sym__primary_expression] = STATE(1397),
    [sym_binary_operator] = STATE(1397),
    [sym_unary_operator] = STATE(1397),
    [sym_attribute] = STATE(1397),
    [sym_subscript] = STATE(1397),
    [sym_call] = STATE(1397),
    [sym_list] = STATE(1397),
    [sym_list_comprehension] = STATE(1397),
    [sym_dictionary] = STATE(1397),
    [sym_dictionary_comprehension] = STATE(1397),
    [sym_set] = STATE(1397),
    [sym_set_comprehension] = STATE(1397),
    [sym_parenthesized_expression] = STATE(1397),
    [sym_tuple] = STATE(1397),
    [sym_generator_expression] = STATE(1397),
    [sym_concatenated_string] = STATE(1397),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2917),
    [sym_float] = ACTIONS(2917),
    [sym_identifier] = ACTIONS(2917),
    [sym_true] = ACTIONS(2917),
    [sym_false] = ACTIONS(2917),
    [sym_none] = ACTIONS(2917),
    [sym_comment] = ACTIONS(73),
  },
  [1021] = {
    [sym__primary_expression] = STATE(1398),
    [sym_binary_operator] = STATE(1398),
    [sym_unary_operator] = STATE(1398),
    [sym_attribute] = STATE(1398),
    [sym_subscript] = STATE(1398),
    [sym_call] = STATE(1398),
    [sym_list] = STATE(1398),
    [sym_list_comprehension] = STATE(1398),
    [sym_dictionary] = STATE(1398),
    [sym_dictionary_comprehension] = STATE(1398),
    [sym_set] = STATE(1398),
    [sym_set_comprehension] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1398),
    [sym_tuple] = STATE(1398),
    [sym_generator_expression] = STATE(1398),
    [sym_concatenated_string] = STATE(1398),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2921),
    [sym_float] = ACTIONS(2921),
    [sym_identifier] = ACTIONS(2921),
    [sym_true] = ACTIONS(2921),
    [sym_false] = ACTIONS(2921),
    [sym_none] = ACTIONS(2921),
    [sym_comment] = ACTIONS(73),
  },
  [1022] = {
    [anon_sym_in] = ACTIONS(2923),
    [sym_comment] = ACTIONS(73),
  },
  [1023] = {
    [sym__primary_expression] = STATE(1400),
    [sym_binary_operator] = STATE(1400),
    [sym_unary_operator] = STATE(1400),
    [sym_attribute] = STATE(1400),
    [sym_subscript] = STATE(1400),
    [sym_call] = STATE(1400),
    [sym_list] = STATE(1400),
    [sym_list_comprehension] = STATE(1400),
    [sym_dictionary] = STATE(1400),
    [sym_dictionary_comprehension] = STATE(1400),
    [sym_set] = STATE(1400),
    [sym_set_comprehension] = STATE(1400),
    [sym_parenthesized_expression] = STATE(1400),
    [sym_tuple] = STATE(1400),
    [sym_generator_expression] = STATE(1400),
    [sym_concatenated_string] = STATE(1400),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2927),
    [sym_float] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2927),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_none] = ACTIONS(2927),
    [sym_comment] = ACTIONS(73),
  },
  [1024] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [1025] = {
    [sym__primary_expression] = STATE(1401),
    [sym_binary_operator] = STATE(1401),
    [sym_unary_operator] = STATE(1401),
    [sym_attribute] = STATE(1401),
    [sym_subscript] = STATE(1401),
    [sym_call] = STATE(1401),
    [sym_list] = STATE(1401),
    [sym_list_comprehension] = STATE(1401),
    [sym_dictionary] = STATE(1401),
    [sym_dictionary_comprehension] = STATE(1401),
    [sym_set] = STATE(1401),
    [sym_set_comprehension] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1401),
    [sym_tuple] = STATE(1401),
    [sym_generator_expression] = STATE(1401),
    [sym_concatenated_string] = STATE(1401),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2931),
    [sym_float] = ACTIONS(2931),
    [sym_identifier] = ACTIONS(2931),
    [sym_true] = ACTIONS(2931),
    [sym_false] = ACTIONS(2931),
    [sym_none] = ACTIONS(2931),
    [sym_comment] = ACTIONS(73),
  },
  [1026] = {
    [sym__primary_expression] = STATE(1402),
    [sym_binary_operator] = STATE(1402),
    [sym_unary_operator] = STATE(1402),
    [sym_attribute] = STATE(1402),
    [sym_subscript] = STATE(1402),
    [sym_call] = STATE(1402),
    [sym_list] = STATE(1402),
    [sym_list_comprehension] = STATE(1402),
    [sym_dictionary] = STATE(1402),
    [sym_dictionary_comprehension] = STATE(1402),
    [sym_set] = STATE(1402),
    [sym_set_comprehension] = STATE(1402),
    [sym_parenthesized_expression] = STATE(1402),
    [sym_tuple] = STATE(1402),
    [sym_generator_expression] = STATE(1402),
    [sym_concatenated_string] = STATE(1402),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2935),
    [sym_float] = ACTIONS(2935),
    [sym_identifier] = ACTIONS(2935),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [sym_none] = ACTIONS(2935),
    [sym_comment] = ACTIONS(73),
  },
  [1027] = {
    [sym__primary_expression] = STATE(1403),
    [sym_binary_operator] = STATE(1403),
    [sym_unary_operator] = STATE(1403),
    [sym_attribute] = STATE(1403),
    [sym_subscript] = STATE(1403),
    [sym_call] = STATE(1403),
    [sym_list] = STATE(1403),
    [sym_list_comprehension] = STATE(1403),
    [sym_dictionary] = STATE(1403),
    [sym_dictionary_comprehension] = STATE(1403),
    [sym_set] = STATE(1403),
    [sym_set_comprehension] = STATE(1403),
    [sym_parenthesized_expression] = STATE(1403),
    [sym_tuple] = STATE(1403),
    [sym_generator_expression] = STATE(1403),
    [sym_concatenated_string] = STATE(1403),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2939),
    [sym_float] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_true] = ACTIONS(2939),
    [sym_false] = ACTIONS(2939),
    [sym_none] = ACTIONS(2939),
    [sym_comment] = ACTIONS(73),
  },
  [1028] = {
    [sym__primary_expression] = STATE(1398),
    [sym_binary_operator] = STATE(1398),
    [sym_unary_operator] = STATE(1398),
    [sym_attribute] = STATE(1398),
    [sym_subscript] = STATE(1398),
    [sym_call] = STATE(1398),
    [sym_list] = STATE(1398),
    [sym_list_comprehension] = STATE(1398),
    [sym_dictionary] = STATE(1398),
    [sym_dictionary_comprehension] = STATE(1398),
    [sym_set] = STATE(1398),
    [sym_set_comprehension] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1398),
    [sym_tuple] = STATE(1398),
    [sym_generator_expression] = STATE(1398),
    [sym_concatenated_string] = STATE(1398),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2941),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2921),
    [sym_float] = ACTIONS(2921),
    [sym_identifier] = ACTIONS(2921),
    [sym_true] = ACTIONS(2921),
    [sym_false] = ACTIONS(2921),
    [sym_none] = ACTIONS(2921),
    [sym_comment] = ACTIONS(73),
  },
  [1029] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1404),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_else] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(1948),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_LT_EQ] = ACTIONS(1948),
    [anon_sym_EQ_EQ] = ACTIONS(1948),
    [anon_sym_BANG_EQ] = ACTIONS(1948),
    [anon_sym_GT_EQ] = ACTIONS(1948),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_LT_GT] = ACTIONS(1948),
    [anon_sym_is] = ACTIONS(1966),
    [sym_comment] = ACTIONS(73),
  },
  [1030] = {
    [sym_string] = STATE(1405),
    [aux_sym_concatenated_string_repeat1] = STATE(1405),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [1031] = {
    [sym__expression] = STATE(530),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(530),
    [sym_boolean_operator] = STATE(530),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(530),
    [sym_lambda] = STATE(530),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(530),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(530),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1032] = {
    [sym__newline] = ACTIONS(2943),
    [anon_sym_DOT] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_COMMA] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_COLON] = ACTIONS(2943),
    [anon_sym_in] = ACTIONS(2943),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_AT] = ACTIONS(2945),
    [anon_sym_not] = ACTIONS(2943),
    [anon_sym_and] = ACTIONS(2943),
    [anon_sym_or] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2945),
    [anon_sym_PERCENT] = ACTIONS(2945),
    [anon_sym_SLASH_SLASH] = ACTIONS(2945),
    [anon_sym_STAR_STAR] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_CARET] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2943),
    [anon_sym_EQ_EQ] = ACTIONS(2943),
    [anon_sym_BANG_EQ] = ACTIONS(2943),
    [anon_sym_GT_EQ] = ACTIONS(2943),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_LT_GT] = ACTIONS(2943),
    [anon_sym_is] = ACTIONS(2943),
    [anon_sym_PLUS_EQ] = ACTIONS(2943),
    [anon_sym_DASH_EQ] = ACTIONS(2943),
    [anon_sym_STAR_EQ] = ACTIONS(2943),
    [anon_sym_SLASH_EQ] = ACTIONS(2943),
    [anon_sym_AT_EQ] = ACTIONS(2943),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2943),
    [anon_sym_PERCENT_EQ] = ACTIONS(2943),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2943),
    [anon_sym_GT_GT_EQ] = ACTIONS(2943),
    [anon_sym_LT_LT_EQ] = ACTIONS(2943),
    [anon_sym_AMP_EQ] = ACTIONS(2943),
    [anon_sym_CARET_EQ] = ACTIONS(2943),
    [anon_sym_PIPE_EQ] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2943),
  },
  [1033] = {
    [sym__expression] = STATE(1406),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1406),
    [sym_boolean_operator] = STATE(1406),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1406),
    [sym_lambda] = STATE(1406),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1406),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1406),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1034] = {
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_COMMA] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1035] = {
    [sym__expression] = STATE(1407),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1407),
    [sym_boolean_operator] = STATE(1407),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1407),
    [sym_lambda] = STATE(1407),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1407),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1407),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1036] = {
    [sym__expression] = STATE(1408),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1408),
    [sym_boolean_operator] = STATE(1408),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1408),
    [sym_lambda] = STATE(1408),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1408),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1408),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1037] = {
    [sym_list_splat] = STATE(1410),
    [sym_dictionary_splat] = STATE(1410),
    [sym__expression] = STATE(1411),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1411),
    [sym_boolean_operator] = STATE(1411),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1411),
    [sym_lambda] = STATE(1411),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_keyword_argument] = STATE(1410),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1411),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1411),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1038] = {
    [aux_sym_argument_list_repeat1] = STATE(1413),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_COMMA] = ACTIONS(2949),
    [sym_comment] = ACTIONS(73),
  },
  [1039] = {
    [sym_argument_list] = STATE(191),
    [sym_generator_expression] = STATE(191),
    [sym__newline] = ACTIONS(2951),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_AMP] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_PLUS_EQ] = ACTIONS(2951),
    [anon_sym_DASH_EQ] = ACTIONS(2951),
    [anon_sym_STAR_EQ] = ACTIONS(2951),
    [anon_sym_SLASH_EQ] = ACTIONS(2951),
    [anon_sym_AT_EQ] = ACTIONS(2951),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2951),
    [anon_sym_PERCENT_EQ] = ACTIONS(2951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2951),
    [anon_sym_GT_GT_EQ] = ACTIONS(2951),
    [anon_sym_LT_LT_EQ] = ACTIONS(2951),
    [anon_sym_AMP_EQ] = ACTIONS(2951),
    [anon_sym_CARET_EQ] = ACTIONS(2951),
    [anon_sym_PIPE_EQ] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(331),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2951),
  },
  [1040] = {
    [sym__expression] = STATE(1414),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(1414),
    [sym_boolean_operator] = STATE(1414),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(1414),
    [sym_lambda] = STATE(1414),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(1414),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(1414),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(2955),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2955),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [1041] = {
    [anon_sym_COMMA] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_COLON] = ACTIONS(2957),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_RBRACK] = ACTIONS(2955),
    [sym_comment] = ACTIONS(73),
  },
  [1042] = {
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_RBRACK] = ACTIONS(731),
    [sym_comment] = ACTIONS(73),
  },
  [1043] = {
    [sym__expression] = STATE(1416),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1416),
    [sym_boolean_operator] = STATE(1416),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1416),
    [sym_lambda] = STATE(1416),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1416),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1416),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1044] = {
    [anon_sym_COLON] = ACTIONS(2959),
    [sym_comment] = ACTIONS(73),
  },
  [1045] = {
    [sym__expression] = STATE(1419),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1419),
    [sym_boolean_operator] = STATE(1419),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1419),
    [sym_lambda] = STATE(1419),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_slice] = STATE(1420),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1419),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2961),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1046] = {
    [sym__expression] = STATE(1421),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1421),
    [sym_boolean_operator] = STATE(1421),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1421),
    [sym_lambda] = STATE(1421),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1421),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1421),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1047] = {
    [sym__expression] = STATE(1422),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1422),
    [sym_boolean_operator] = STATE(1422),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1422),
    [sym_lambda] = STATE(1422),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1422),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1422),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(2955),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(2957),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2955),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1048] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1049] = {
    [sym__expression] = STATE(1423),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1423),
    [sym_boolean_operator] = STATE(1423),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1423),
    [sym_lambda] = STATE(1423),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1423),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1423),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1050] = {
    [sym__newline] = ACTIONS(2963),
    [anon_sym_DOT] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2965),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_COLON] = ACTIONS(2963),
    [anon_sym_in] = ACTIONS(2963),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_AT] = ACTIONS(2965),
    [anon_sym_not] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [anon_sym_SLASH_SLASH] = ACTIONS(2965),
    [anon_sym_STAR_STAR] = ACTIONS(2965),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_LT_LT] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_LT_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ] = ACTIONS(2963),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_LT_GT] = ACTIONS(2963),
    [anon_sym_is] = ACTIONS(2963),
    [anon_sym_PLUS_EQ] = ACTIONS(2963),
    [anon_sym_DASH_EQ] = ACTIONS(2963),
    [anon_sym_STAR_EQ] = ACTIONS(2963),
    [anon_sym_SLASH_EQ] = ACTIONS(2963),
    [anon_sym_AT_EQ] = ACTIONS(2963),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2963),
    [anon_sym_PERCENT_EQ] = ACTIONS(2963),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2963),
    [anon_sym_GT_GT_EQ] = ACTIONS(2963),
    [anon_sym_LT_LT_EQ] = ACTIONS(2963),
    [anon_sym_AMP_EQ] = ACTIONS(2963),
    [anon_sym_CARET_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2963),
  },
  [1051] = {
    [aux_sym_subscript_repeat1] = STATE(1425),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_RBRACK] = ACTIONS(2961),
    [sym_comment] = ACTIONS(73),
  },
  [1052] = {
    [sym__primary_expression] = STATE(1426),
    [sym_binary_operator] = STATE(1426),
    [sym_unary_operator] = STATE(1426),
    [sym_attribute] = STATE(1426),
    [sym_subscript] = STATE(1426),
    [sym_call] = STATE(1426),
    [sym_list] = STATE(1426),
    [sym_list_comprehension] = STATE(1426),
    [sym_dictionary] = STATE(1426),
    [sym_dictionary_comprehension] = STATE(1426),
    [sym_set] = STATE(1426),
    [sym_set_comprehension] = STATE(1426),
    [sym_parenthesized_expression] = STATE(1426),
    [sym_tuple] = STATE(1426),
    [sym_generator_expression] = STATE(1426),
    [sym_concatenated_string] = STATE(1426),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2969),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2971),
    [sym_float] = ACTIONS(2971),
    [sym_identifier] = ACTIONS(2971),
    [sym_true] = ACTIONS(2971),
    [sym_false] = ACTIONS(2971),
    [sym_none] = ACTIONS(2971),
    [sym_comment] = ACTIONS(73),
  },
  [1053] = {
    [sym__primary_expression] = STATE(1427),
    [sym_binary_operator] = STATE(1427),
    [sym_unary_operator] = STATE(1427),
    [sym_attribute] = STATE(1427),
    [sym_subscript] = STATE(1427),
    [sym_call] = STATE(1427),
    [sym_list] = STATE(1427),
    [sym_list_comprehension] = STATE(1427),
    [sym_dictionary] = STATE(1427),
    [sym_dictionary_comprehension] = STATE(1427),
    [sym_set] = STATE(1427),
    [sym_set_comprehension] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple] = STATE(1427),
    [sym_generator_expression] = STATE(1427),
    [sym_concatenated_string] = STATE(1427),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2975),
    [sym_float] = ACTIONS(2975),
    [sym_identifier] = ACTIONS(2975),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [sym_none] = ACTIONS(2975),
    [sym_comment] = ACTIONS(73),
  },
  [1054] = {
    [sym__primary_expression] = STATE(1428),
    [sym_binary_operator] = STATE(1428),
    [sym_unary_operator] = STATE(1428),
    [sym_attribute] = STATE(1428),
    [sym_subscript] = STATE(1428),
    [sym_call] = STATE(1428),
    [sym_list] = STATE(1428),
    [sym_list_comprehension] = STATE(1428),
    [sym_dictionary] = STATE(1428),
    [sym_dictionary_comprehension] = STATE(1428),
    [sym_set] = STATE(1428),
    [sym_set_comprehension] = STATE(1428),
    [sym_parenthesized_expression] = STATE(1428),
    [sym_tuple] = STATE(1428),
    [sym_generator_expression] = STATE(1428),
    [sym_concatenated_string] = STATE(1428),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2979),
    [sym_float] = ACTIONS(2979),
    [sym_identifier] = ACTIONS(2979),
    [sym_true] = ACTIONS(2979),
    [sym_false] = ACTIONS(2979),
    [sym_none] = ACTIONS(2979),
    [sym_comment] = ACTIONS(73),
  },
  [1055] = {
    [anon_sym_in] = ACTIONS(2981),
    [sym_comment] = ACTIONS(73),
  },
  [1056] = {
    [sym__primary_expression] = STATE(1430),
    [sym_binary_operator] = STATE(1430),
    [sym_unary_operator] = STATE(1430),
    [sym_attribute] = STATE(1430),
    [sym_subscript] = STATE(1430),
    [sym_call] = STATE(1430),
    [sym_list] = STATE(1430),
    [sym_list_comprehension] = STATE(1430),
    [sym_dictionary] = STATE(1430),
    [sym_dictionary_comprehension] = STATE(1430),
    [sym_set] = STATE(1430),
    [sym_set_comprehension] = STATE(1430),
    [sym_parenthesized_expression] = STATE(1430),
    [sym_tuple] = STATE(1430),
    [sym_generator_expression] = STATE(1430),
    [sym_concatenated_string] = STATE(1430),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2985),
    [sym_float] = ACTIONS(2985),
    [sym_identifier] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_none] = ACTIONS(2985),
    [sym_comment] = ACTIONS(73),
  },
  [1057] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [1058] = {
    [sym__primary_expression] = STATE(1431),
    [sym_binary_operator] = STATE(1431),
    [sym_unary_operator] = STATE(1431),
    [sym_attribute] = STATE(1431),
    [sym_subscript] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_list] = STATE(1431),
    [sym_list_comprehension] = STATE(1431),
    [sym_dictionary] = STATE(1431),
    [sym_dictionary_comprehension] = STATE(1431),
    [sym_set] = STATE(1431),
    [sym_set_comprehension] = STATE(1431),
    [sym_parenthesized_expression] = STATE(1431),
    [sym_tuple] = STATE(1431),
    [sym_generator_expression] = STATE(1431),
    [sym_concatenated_string] = STATE(1431),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2987),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2989),
    [sym_float] = ACTIONS(2989),
    [sym_identifier] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_none] = ACTIONS(2989),
    [sym_comment] = ACTIONS(73),
  },
  [1059] = {
    [sym__primary_expression] = STATE(1432),
    [sym_binary_operator] = STATE(1432),
    [sym_unary_operator] = STATE(1432),
    [sym_attribute] = STATE(1432),
    [sym_subscript] = STATE(1432),
    [sym_call] = STATE(1432),
    [sym_list] = STATE(1432),
    [sym_list_comprehension] = STATE(1432),
    [sym_dictionary] = STATE(1432),
    [sym_dictionary_comprehension] = STATE(1432),
    [sym_set] = STATE(1432),
    [sym_set_comprehension] = STATE(1432),
    [sym_parenthesized_expression] = STATE(1432),
    [sym_tuple] = STATE(1432),
    [sym_generator_expression] = STATE(1432),
    [sym_concatenated_string] = STATE(1432),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2993),
    [sym_float] = ACTIONS(2993),
    [sym_identifier] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_none] = ACTIONS(2993),
    [sym_comment] = ACTIONS(73),
  },
  [1060] = {
    [sym__primary_expression] = STATE(1433),
    [sym_binary_operator] = STATE(1433),
    [sym_unary_operator] = STATE(1433),
    [sym_attribute] = STATE(1433),
    [sym_subscript] = STATE(1433),
    [sym_call] = STATE(1433),
    [sym_list] = STATE(1433),
    [sym_list_comprehension] = STATE(1433),
    [sym_dictionary] = STATE(1433),
    [sym_dictionary_comprehension] = STATE(1433),
    [sym_set] = STATE(1433),
    [sym_set_comprehension] = STATE(1433),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_tuple] = STATE(1433),
    [sym_generator_expression] = STATE(1433),
    [sym_concatenated_string] = STATE(1433),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2995),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2997),
    [sym_float] = ACTIONS(2997),
    [sym_identifier] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_none] = ACTIONS(2997),
    [sym_comment] = ACTIONS(73),
  },
  [1061] = {
    [sym__primary_expression] = STATE(1428),
    [sym_binary_operator] = STATE(1428),
    [sym_unary_operator] = STATE(1428),
    [sym_attribute] = STATE(1428),
    [sym_subscript] = STATE(1428),
    [sym_call] = STATE(1428),
    [sym_list] = STATE(1428),
    [sym_list_comprehension] = STATE(1428),
    [sym_dictionary] = STATE(1428),
    [sym_dictionary_comprehension] = STATE(1428),
    [sym_set] = STATE(1428),
    [sym_set_comprehension] = STATE(1428),
    [sym_parenthesized_expression] = STATE(1428),
    [sym_tuple] = STATE(1428),
    [sym_generator_expression] = STATE(1428),
    [sym_concatenated_string] = STATE(1428),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2979),
    [sym_float] = ACTIONS(2979),
    [sym_identifier] = ACTIONS(2979),
    [sym_true] = ACTIONS(2979),
    [sym_false] = ACTIONS(2979),
    [sym_none] = ACTIONS(2979),
    [sym_comment] = ACTIONS(73),
  },
  [1062] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1434),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(2029),
    [anon_sym_not] = ACTIONS(2033),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2029),
    [anon_sym_EQ_EQ] = ACTIONS(2029),
    [anon_sym_BANG_EQ] = ACTIONS(2029),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_GT] = ACTIONS(2045),
    [anon_sym_LT_GT] = ACTIONS(2029),
    [anon_sym_is] = ACTIONS(2047),
    [anon_sym_RBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(73),
  },
  [1063] = {
    [sym_string] = STATE(1435),
    [aux_sym_concatenated_string_repeat1] = STATE(1435),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_COLON] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_RBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [1064] = {
    [anon_sym_if] = ACTIONS(1119),
    [anon_sym_and] = ACTIONS(1121),
    [anon_sym_or] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1671),
    [sym_type_conversion] = ACTIONS(1671),
    [sym_comment] = ACTIONS(73),
  },
  [1065] = {
    [sym__expression] = STATE(1436),
    [sym__primary_expression] = STATE(203),
    [sym_not_operator] = STATE(1436),
    [sym_boolean_operator] = STATE(1436),
    [sym_binary_operator] = STATE(203),
    [sym_unary_operator] = STATE(203),
    [sym_comparison_operator] = STATE(1436),
    [sym_lambda] = STATE(1436),
    [sym_attribute] = STATE(203),
    [sym_subscript] = STATE(203),
    [sym_call] = STATE(203),
    [sym_list] = STATE(203),
    [sym_list_comprehension] = STATE(203),
    [sym_dictionary] = STATE(203),
    [sym_dictionary_comprehension] = STATE(203),
    [sym_set] = STATE(203),
    [sym_set_comprehension] = STATE(203),
    [sym_parenthesized_expression] = STATE(203),
    [sym_tuple] = STATE(203),
    [sym_generator_expression] = STATE(203),
    [sym_conditional_expression] = STATE(1436),
    [sym_concatenated_string] = STATE(203),
    [sym_string] = STATE(204),
    [sym_await] = STATE(1436),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [1066] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1067] = {
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(1121),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_RBRACE] = ACTIONS(1968),
    [sym_type_conversion] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1068] = {
    [sym__string_content] = ACTIONS(3003),
    [sym__string_end] = ACTIONS(3003),
    [anon_sym_LBRACE] = ACTIONS(3005),
    [sym_escape_sequence] = ACTIONS(3005),
    [sym_comment] = ACTIONS(83),
  },
  [1069] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_type_conversion] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1070] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_type_conversion] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1071] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [sym_type_conversion] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1072] = {
    [sym__primary_expression] = STATE(1438),
    [sym_binary_operator] = STATE(1438),
    [sym_unary_operator] = STATE(1438),
    [sym_attribute] = STATE(1438),
    [sym_subscript] = STATE(1438),
    [sym_call] = STATE(1438),
    [sym_list] = STATE(1438),
    [sym_list_comprehension] = STATE(1438),
    [sym_dictionary] = STATE(1438),
    [sym_dictionary_comprehension] = STATE(1438),
    [sym_set] = STATE(1438),
    [sym_set_comprehension] = STATE(1438),
    [sym_parenthesized_expression] = STATE(1438),
    [sym_tuple] = STATE(1438),
    [sym_generator_expression] = STATE(1438),
    [sym_concatenated_string] = STATE(1438),
    [sym_string] = STATE(204),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3009),
    [sym_float] = ACTIONS(3009),
    [sym_identifier] = ACTIONS(3009),
    [sym_true] = ACTIONS(3009),
    [sym_false] = ACTIONS(3009),
    [sym_none] = ACTIONS(3009),
    [sym_comment] = ACTIONS(73),
  },
  [1073] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_type_conversion] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1074] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_type_conversion] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1075] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_type_conversion] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1076] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_type_conversion] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1077] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1077),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3011),
    [anon_sym_not] = ACTIONS(3014),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_LT_EQ] = ACTIONS(3011),
    [anon_sym_EQ_EQ] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_GT_EQ] = ACTIONS(3011),
    [anon_sym_GT] = ACTIONS(3017),
    [anon_sym_LT_GT] = ACTIONS(3011),
    [anon_sym_is] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [sym_type_conversion] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1078] = {
    [sym_string] = STATE(1078),
    [aux_sym_concatenated_string_repeat1] = STATE(1078),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [sym_type_conversion] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1079] = {
    [sym_aliased_import] = STATE(592),
    [sym_dotted_name] = STATE(593),
    [sym_identifier] = ACTIONS(85),
    [sym_comment] = ACTIONS(73),
  },
  [1080] = {
    [aux_sym_dotted_name_repeat1] = STATE(1439),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(367),
    [anon_sym_COMMA] = ACTIONS(367),
    [anon_sym_as] = ACTIONS(367),
    [sym_comment] = ACTIONS(73),
  },
  [1081] = {
    [anon_sym_RPAREN] = ACTIONS(3023),
    [sym_comment] = ACTIONS(73),
  },
  [1082] = {
    [aux_sym__import_list_repeat1] = STATE(1442),
    [anon_sym_RPAREN] = ACTIONS(373),
    [anon_sym_COMMA] = ACTIONS(3025),
    [sym_comment] = ACTIONS(73),
  },
  [1083] = {
    [aux_sym__import_list_repeat1] = STATE(1442),
    [anon_sym_RPAREN] = ACTIONS(373),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_as] = ACTIONS(3027),
    [sym_comment] = ACTIONS(73),
  },
  [1084] = {
    [anon_sym_DOT] = ACTIONS(2191),
    [anon_sym_LPAREN] = ACTIONS(2191),
    [anon_sym_RPAREN] = ACTIONS(2191),
    [anon_sym_COMMA] = ACTIONS(2191),
    [anon_sym_as] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_GT_GT] = ACTIONS(2191),
    [anon_sym_if] = ACTIONS(2191),
    [anon_sym_COLON] = ACTIONS(2191),
    [anon_sym_else] = ACTIONS(2191),
    [anon_sym_async] = ACTIONS(2191),
    [anon_sym_for] = ACTIONS(2191),
    [anon_sym_in] = ACTIONS(2191),
    [anon_sym_EQ] = ACTIONS(2193),
    [anon_sym_AT] = ACTIONS(2191),
    [anon_sym_not] = ACTIONS(2191),
    [anon_sym_and] = ACTIONS(2191),
    [anon_sym_or] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_DASH] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2191),
    [anon_sym_SLASH_SLASH] = ACTIONS(2191),
    [anon_sym_STAR_STAR] = ACTIONS(2191),
    [anon_sym_PIPE] = ACTIONS(2191),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2191),
    [anon_sym_LT_LT] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_LT_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ] = ACTIONS(2191),
    [anon_sym_GT_EQ] = ACTIONS(2191),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_LT_GT] = ACTIONS(2191),
    [anon_sym_is] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_RBRACK] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2191),
    [sym_type_conversion] = ACTIONS(2191),
    [sym_comment] = ACTIONS(73),
  },
  [1085] = {
    [anon_sym_DOT] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_RPAREN] = ACTIONS(2203),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_as] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2203),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_COLON] = ACTIONS(2203),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_async] = ACTIONS(2203),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_in] = ACTIONS(2203),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2203),
    [anon_sym_not] = ACTIONS(2203),
    [anon_sym_and] = ACTIONS(2203),
    [anon_sym_or] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2203),
    [anon_sym_SLASH_SLASH] = ACTIONS(2203),
    [anon_sym_STAR_STAR] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ] = ACTIONS(2203),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_GT_EQ] = ACTIONS(2203),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_LT_GT] = ACTIONS(2203),
    [anon_sym_is] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_RBRACK] = ACTIONS(2203),
    [anon_sym_RBRACE] = ACTIONS(2203),
    [sym_type_conversion] = ACTIONS(2203),
    [sym_comment] = ACTIONS(73),
  },
  [1086] = {
    [sym__expression] = STATE(644),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(644),
    [sym_boolean_operator] = STATE(644),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(644),
    [sym_lambda] = STATE(644),
    [sym_yield] = STATE(645),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(644),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(644),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3029),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1087] = {
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [1088] = {
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1089] = {
    [sym__expression] = STATE(1445),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1445),
    [sym_boolean_operator] = STATE(1445),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1445),
    [sym_lambda] = STATE(1445),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1445),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1445),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1090] = {
    [anon_sym_RPAREN] = ACTIONS(1932),
    [anon_sym_COMMA] = ACTIONS(1932),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1091] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3031),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1092] = {
    [anon_sym_RPAREN] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1093] = {
    [sym__expression] = STATE(1090),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1090),
    [sym_boolean_operator] = STATE(1090),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1090),
    [sym_lambda] = STATE(1090),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1090),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1090),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(1972),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1094] = {
    [aux_sym_print_statement_repeat1] = STATE(1094),
    [anon_sym_RPAREN] = ACTIONS(1932),
    [anon_sym_COMMA] = ACTIONS(3033),
    [sym_comment] = ACTIONS(73),
  },
  [1095] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1096] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1221),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_SLASH_SLASH] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1097] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1221),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_SLASH_SLASH] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1098] = {
    [sym__primary_expression] = STATE(1448),
    [sym_binary_operator] = STATE(1448),
    [sym_unary_operator] = STATE(1448),
    [sym_attribute] = STATE(1448),
    [sym_subscript] = STATE(1448),
    [sym_call] = STATE(1448),
    [sym_list] = STATE(1448),
    [sym_list_comprehension] = STATE(1448),
    [sym_dictionary] = STATE(1448),
    [sym_dictionary_comprehension] = STATE(1448),
    [sym_set] = STATE(1448),
    [sym_set_comprehension] = STATE(1448),
    [sym_parenthesized_expression] = STATE(1448),
    [sym_tuple] = STATE(1448),
    [sym_generator_expression] = STATE(1448),
    [sym_concatenated_string] = STATE(1448),
    [sym_string] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3038),
    [sym_float] = ACTIONS(3038),
    [sym_identifier] = ACTIONS(3038),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [sym_none] = ACTIONS(3038),
    [sym_comment] = ACTIONS(73),
  },
  [1099] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1221),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_SLASH_SLASH] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1100] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1221),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_SLASH_SLASH] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1101] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1221),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_SLASH_SLASH] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1102] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1221),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_SLASH_SLASH] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1103] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1103),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3043),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3040),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [anon_sym_GT_EQ] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3046),
    [anon_sym_LT_GT] = ACTIONS(3040),
    [anon_sym_is] = ACTIONS(3049),
    [sym_comment] = ACTIONS(73),
  },
  [1104] = {
    [sym_string] = STATE(1104),
    [aux_sym_concatenated_string_repeat1] = STATE(1104),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1105] = {
    [anon_sym_DOT] = ACTIONS(2692),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_RPAREN] = ACTIONS(2692),
    [anon_sym_COMMA] = ACTIONS(2692),
    [anon_sym_as] = ACTIONS(2694),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_COLON] = ACTIONS(2692),
    [anon_sym_else] = ACTIONS(2692),
    [anon_sym_async] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_EQ] = ACTIONS(2694),
    [anon_sym_AT] = ACTIONS(2692),
    [anon_sym_not] = ACTIONS(2692),
    [anon_sym_and] = ACTIONS(2692),
    [anon_sym_or] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_SLASH] = ACTIONS(2694),
    [anon_sym_PERCENT] = ACTIONS(2692),
    [anon_sym_SLASH_SLASH] = ACTIONS(2692),
    [anon_sym_STAR_STAR] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_CARET] = ACTIONS(2692),
    [anon_sym_LT_LT] = ACTIONS(2692),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_LT_EQ] = ACTIONS(2692),
    [anon_sym_EQ_EQ] = ACTIONS(2692),
    [anon_sym_BANG_EQ] = ACTIONS(2692),
    [anon_sym_GT_EQ] = ACTIONS(2692),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_LT_GT] = ACTIONS(2692),
    [anon_sym_is] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_RBRACK] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [sym_type_conversion] = ACTIONS(2692),
    [sym_comment] = ACTIONS(73),
  },
  [1106] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(912),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3052),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [1107] = {
    [anon_sym_DOT] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(2707),
    [anon_sym_RPAREN] = ACTIONS(2707),
    [anon_sym_COMMA] = ACTIONS(2707),
    [anon_sym_as] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_if] = ACTIONS(2707),
    [anon_sym_COLON] = ACTIONS(2707),
    [anon_sym_else] = ACTIONS(2707),
    [anon_sym_async] = ACTIONS(2707),
    [anon_sym_for] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2707),
    [anon_sym_EQ] = ACTIONS(2709),
    [anon_sym_AT] = ACTIONS(2707),
    [anon_sym_not] = ACTIONS(2707),
    [anon_sym_and] = ACTIONS(2707),
    [anon_sym_or] = ACTIONS(2707),
    [anon_sym_PLUS] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_SLASH] = ACTIONS(2709),
    [anon_sym_PERCENT] = ACTIONS(2707),
    [anon_sym_SLASH_SLASH] = ACTIONS(2707),
    [anon_sym_STAR_STAR] = ACTIONS(2707),
    [anon_sym_PIPE] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_CARET] = ACTIONS(2707),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2707),
    [anon_sym_BANG_EQ] = ACTIONS(2707),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2709),
    [anon_sym_LT_GT] = ACTIONS(2707),
    [anon_sym_is] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_RBRACK] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [sym_type_conversion] = ACTIONS(2707),
    [sym_comment] = ACTIONS(73),
  },
  [1108] = {
    [anon_sym_DOT] = ACTIONS(2773),
    [anon_sym_LPAREN] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_as] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_GT_GT] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_COLON] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_async] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_EQ] = ACTIONS(2775),
    [anon_sym_AT] = ACTIONS(2773),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_SLASH] = ACTIONS(2775),
    [anon_sym_PERCENT] = ACTIONS(2773),
    [anon_sym_SLASH_SLASH] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2773),
    [anon_sym_LT_LT] = ACTIONS(2773),
    [anon_sym_LT] = ACTIONS(2775),
    [anon_sym_LT_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ] = ACTIONS(2773),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_GT] = ACTIONS(2775),
    [anon_sym_LT_GT] = ACTIONS(2773),
    [anon_sym_is] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_RBRACK] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [sym_type_conversion] = ACTIONS(2773),
    [sym_comment] = ACTIONS(73),
  },
  [1109] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(955),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(955),
    [sym_boolean_operator] = STATE(955),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(955),
    [sym_lambda] = STATE(955),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(955),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(955),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3054),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [1110] = {
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_RPAREN] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2784),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_if] = ACTIONS(2782),
    [anon_sym_COLON] = ACTIONS(2782),
    [anon_sym_else] = ACTIONS(2782),
    [anon_sym_async] = ACTIONS(2782),
    [anon_sym_for] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(2782),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_not] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_SLASH_SLASH] = ACTIONS(2782),
    [anon_sym_STAR_STAR] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_LT_GT] = ACTIONS(2782),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_RBRACK] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [sym_type_conversion] = ACTIONS(2782),
    [sym_comment] = ACTIONS(73),
  },
  [1111] = {
    [sym_dictionary_splat] = STATE(960),
    [sym__expression] = STATE(961),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(961),
    [sym_boolean_operator] = STATE(961),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(961),
    [sym_lambda] = STATE(961),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_pair] = STATE(960),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(961),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(961),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1112] = {
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2835),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2833),
    [anon_sym_else] = ACTIONS(2833),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_AT] = ACTIONS(2833),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(2833),
    [anon_sym_STAR_STAR] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2835),
    [anon_sym_LT_GT] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2833),
    [anon_sym_RBRACK] = ACTIONS(2833),
    [anon_sym_RBRACE] = ACTIONS(2833),
    [sym_type_conversion] = ACTIONS(2833),
    [sym_comment] = ACTIONS(73),
  },
  [1113] = {
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2865),
    [anon_sym_RPAREN] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2865),
    [anon_sym_else] = ACTIONS(2865),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_EQ] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2865),
    [anon_sym_not] = ACTIONS(2865),
    [anon_sym_and] = ACTIONS(2865),
    [anon_sym_or] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(2865),
    [anon_sym_STAR_STAR] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_CARET] = ACTIONS(2865),
    [anon_sym_LT_LT] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_LT_EQ] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_GT_EQ] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_LT_GT] = ACTIONS(2865),
    [anon_sym_is] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2865),
    [anon_sym_RBRACK] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [sym_type_conversion] = ACTIONS(2865),
    [sym_comment] = ACTIONS(73),
  },
  [1114] = {
    [sym__expression] = STATE(1452),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(1452),
    [sym_boolean_operator] = STATE(1452),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(1452),
    [sym_lambda] = STATE(1452),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(1452),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(1452),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1115] = {
    [anon_sym_in] = ACTIONS(3058),
    [sym_comment] = ACTIONS(73),
  },
  [1116] = {
    [sym__expression_within_for_in_clause] = STATE(1455),
    [sym__expression] = STATE(1456),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(1456),
    [sym_boolean_operator] = STATE(1456),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(1456),
    [sym_lambda] = STATE(1456),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(1456),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(1456),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1117] = {
    [sym__expression] = STATE(1458),
    [sym__primary_expression] = STATE(1122),
    [sym_not_operator] = STATE(1458),
    [sym_boolean_operator] = STATE(1458),
    [sym_binary_operator] = STATE(1122),
    [sym_unary_operator] = STATE(1122),
    [sym_comparison_operator] = STATE(1458),
    [sym_lambda] = STATE(1458),
    [sym_attribute] = STATE(1122),
    [sym_subscript] = STATE(1122),
    [sym_call] = STATE(1122),
    [sym_list] = STATE(1122),
    [sym_list_comprehension] = STATE(1122),
    [sym_dictionary] = STATE(1122),
    [sym_dictionary_comprehension] = STATE(1122),
    [sym_set] = STATE(1122),
    [sym_set_comprehension] = STATE(1122),
    [sym_parenthesized_expression] = STATE(1122),
    [sym_tuple] = STATE(1122),
    [sym_generator_expression] = STATE(1122),
    [sym_conditional_expression] = STATE(1458),
    [sym_concatenated_string] = STATE(1122),
    [sym_string] = STATE(1123),
    [sym_await] = STATE(1458),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_lambda] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2215),
    [sym_float] = ACTIONS(2215),
    [sym_identifier] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_none] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2217),
    [sym_comment] = ACTIONS(73),
  },
  [1118] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [1119] = {
    [sym_lambda_parameters] = STATE(1460),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3062),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1120] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(1122),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(1122),
    [sym_unary_operator] = STATE(1122),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(1122),
    [sym_subscript] = STATE(1122),
    [sym_call] = STATE(1122),
    [sym_list] = STATE(1122),
    [sym_list_comprehension] = STATE(1122),
    [sym_dictionary] = STATE(1122),
    [sym_dictionary_comprehension] = STATE(1122),
    [sym_set] = STATE(1122),
    [sym_set_comprehension] = STATE(1122),
    [sym_parenthesized_expression] = STATE(1122),
    [sym_tuple] = STATE(1122),
    [sym_generator_expression] = STATE(1122),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(1122),
    [sym_string] = STATE(1123),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_lambda] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2215),
    [sym_float] = ACTIONS(2215),
    [sym_identifier] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_none] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2217),
    [sym_comment] = ACTIONS(73),
  },
  [1121] = {
    [anon_sym_RPAREN] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_async] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3068),
    [sym_comment] = ACTIONS(73),
  },
  [1122] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(1474),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_GT_GT] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(3074),
    [anon_sym_AT] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_SLASH_SLASH] = ACTIONS(3076),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_CARET] = ACTIONS(3088),
    [anon_sym_LT_LT] = ACTIONS(3072),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_LT_EQ] = ACTIONS(3074),
    [anon_sym_EQ_EQ] = ACTIONS(3074),
    [anon_sym_BANG_EQ] = ACTIONS(3074),
    [anon_sym_GT_EQ] = ACTIONS(3074),
    [anon_sym_GT] = ACTIONS(3090),
    [anon_sym_LT_GT] = ACTIONS(3074),
    [anon_sym_is] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1123] = {
    [sym_string] = STATE(1475),
    [aux_sym_concatenated_string_repeat1] = STATE(1475),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [1124] = {
    [sym_for_in_clause] = STATE(1124),
    [sym_if_clause] = STATE(1124),
    [aux_sym__comprehension_body_repeat1] = STATE(1124),
    [anon_sym_RPAREN] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_for] = ACTIONS(3102),
    [sym_comment] = ACTIONS(73),
  },
  [1125] = {
    [sym__newline] = ACTIONS(3105),
    [anon_sym_DOT] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_GT_GT] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3105),
    [anon_sym_in] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3107),
    [anon_sym_not] = ACTIONS(3105),
    [anon_sym_and] = ACTIONS(3105),
    [anon_sym_or] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_SLASH] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_SLASH_SLASH] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3107),
    [anon_sym_PIPE] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_CARET] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(3107),
    [anon_sym_LT_EQ] = ACTIONS(3105),
    [anon_sym_EQ_EQ] = ACTIONS(3105),
    [anon_sym_BANG_EQ] = ACTIONS(3105),
    [anon_sym_GT_EQ] = ACTIONS(3105),
    [anon_sym_GT] = ACTIONS(3107),
    [anon_sym_LT_GT] = ACTIONS(3105),
    [anon_sym_is] = ACTIONS(3105),
    [anon_sym_PLUS_EQ] = ACTIONS(3105),
    [anon_sym_DASH_EQ] = ACTIONS(3105),
    [anon_sym_STAR_EQ] = ACTIONS(3105),
    [anon_sym_SLASH_EQ] = ACTIONS(3105),
    [anon_sym_AT_EQ] = ACTIONS(3105),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3105),
    [anon_sym_PERCENT_EQ] = ACTIONS(3105),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3105),
    [anon_sym_GT_GT_EQ] = ACTIONS(3105),
    [anon_sym_LT_LT_EQ] = ACTIONS(3105),
    [anon_sym_AMP_EQ] = ACTIONS(3105),
    [anon_sym_CARET_EQ] = ACTIONS(3105),
    [anon_sym_PIPE_EQ] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3105),
  },
  [1126] = {
    [sym__expression] = STATE(644),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(644),
    [sym_boolean_operator] = STATE(644),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(644),
    [sym_lambda] = STATE(644),
    [sym_yield] = STATE(645),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(644),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(644),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1127] = {
    [anon_sym_DOT] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_COMMA] = ACTIONS(2943),
    [anon_sym_as] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2943),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_COLON] = ACTIONS(2943),
    [anon_sym_else] = ACTIONS(2943),
    [anon_sym_async] = ACTIONS(2943),
    [anon_sym_for] = ACTIONS(2943),
    [anon_sym_in] = ACTIONS(2943),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_AT] = ACTIONS(2943),
    [anon_sym_not] = ACTIONS(2943),
    [anon_sym_and] = ACTIONS(2943),
    [anon_sym_or] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_DASH] = ACTIONS(2943),
    [anon_sym_SLASH] = ACTIONS(2945),
    [anon_sym_PERCENT] = ACTIONS(2943),
    [anon_sym_SLASH_SLASH] = ACTIONS(2943),
    [anon_sym_STAR_STAR] = ACTIONS(2943),
    [anon_sym_PIPE] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2943),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_LT_LT] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2943),
    [anon_sym_EQ_EQ] = ACTIONS(2943),
    [anon_sym_BANG_EQ] = ACTIONS(2943),
    [anon_sym_GT_EQ] = ACTIONS(2943),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_LT_GT] = ACTIONS(2943),
    [anon_sym_is] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_RBRACK] = ACTIONS(2943),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [sym_type_conversion] = ACTIONS(2943),
    [sym_comment] = ACTIONS(73),
  },
  [1128] = {
    [sym_list_splat] = STATE(1410),
    [sym_dictionary_splat] = STATE(1410),
    [sym__expression] = STATE(1411),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1411),
    [sym_boolean_operator] = STATE(1411),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1411),
    [sym_lambda] = STATE(1411),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_keyword_argument] = STATE(1410),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1411),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1411),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3109),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1129] = {
    [aux_sym_argument_list_repeat1] = STATE(1413),
    [anon_sym_RPAREN] = ACTIONS(3109),
    [anon_sym_COMMA] = ACTIONS(3111),
    [sym_comment] = ACTIONS(73),
  },
  [1130] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_async] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(459),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH_SLASH] = ACTIONS(459),
    [anon_sym_STAR_STAR] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1131] = {
    [sym__expression] = STATE(1419),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1419),
    [sym_boolean_operator] = STATE(1419),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1419),
    [sym_lambda] = STATE(1419),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_slice] = STATE(1420),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1419),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3113),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1132] = {
    [anon_sym_DOT] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_as] = ACTIONS(2965),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_COLON] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2963),
    [anon_sym_async] = ACTIONS(2963),
    [anon_sym_for] = ACTIONS(2963),
    [anon_sym_in] = ACTIONS(2963),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_AT] = ACTIONS(2963),
    [anon_sym_not] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2963),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2963),
    [anon_sym_SLASH_SLASH] = ACTIONS(2963),
    [anon_sym_STAR_STAR] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2963),
    [anon_sym_AMP] = ACTIONS(2963),
    [anon_sym_CARET] = ACTIONS(2963),
    [anon_sym_LT_LT] = ACTIONS(2963),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_LT_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ] = ACTIONS(2963),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_LT_GT] = ACTIONS(2963),
    [anon_sym_is] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_RBRACK] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [sym_type_conversion] = ACTIONS(2963),
    [sym_comment] = ACTIONS(73),
  },
  [1133] = {
    [aux_sym_subscript_repeat1] = STATE(1425),
    [anon_sym_COMMA] = ACTIONS(3115),
    [anon_sym_RBRACK] = ACTIONS(3113),
    [sym_comment] = ACTIONS(73),
  },
  [1134] = {
    [sym__newline] = ACTIONS(2191),
    [anon_sym_DOT] = ACTIONS(2191),
    [anon_sym_from] = ACTIONS(2191),
    [anon_sym_LPAREN] = ACTIONS(2191),
    [anon_sym_COMMA] = ACTIONS(2191),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_GT_GT] = ACTIONS(2191),
    [anon_sym_if] = ACTIONS(2191),
    [anon_sym_in] = ACTIONS(2191),
    [anon_sym_EQ] = ACTIONS(2193),
    [anon_sym_AT] = ACTIONS(2191),
    [anon_sym_not] = ACTIONS(2191),
    [anon_sym_and] = ACTIONS(2191),
    [anon_sym_or] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_DASH] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2191),
    [anon_sym_SLASH_SLASH] = ACTIONS(2191),
    [anon_sym_STAR_STAR] = ACTIONS(2191),
    [anon_sym_PIPE] = ACTIONS(2191),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2191),
    [anon_sym_LT_LT] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_LT_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ] = ACTIONS(2191),
    [anon_sym_GT_EQ] = ACTIONS(2191),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_LT_GT] = ACTIONS(2191),
    [anon_sym_is] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2191),
  },
  [1135] = {
    [sym__newline] = ACTIONS(2203),
    [anon_sym_DOT] = ACTIONS(2203),
    [anon_sym_from] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_COMMA] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2203),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_in] = ACTIONS(2203),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2203),
    [anon_sym_not] = ACTIONS(2203),
    [anon_sym_and] = ACTIONS(2203),
    [anon_sym_or] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2203),
    [anon_sym_SLASH_SLASH] = ACTIONS(2203),
    [anon_sym_STAR_STAR] = ACTIONS(2203),
    [anon_sym_PIPE] = ACTIONS(2203),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_LT_LT] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_EQ] = ACTIONS(2203),
    [anon_sym_EQ_EQ] = ACTIONS(2203),
    [anon_sym_BANG_EQ] = ACTIONS(2203),
    [anon_sym_GT_EQ] = ACTIONS(2203),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_LT_GT] = ACTIONS(2203),
    [anon_sym_is] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2203),
  },
  [1136] = {
    [sym__expression] = STATE(644),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(644),
    [sym_boolean_operator] = STATE(644),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(644),
    [sym_lambda] = STATE(644),
    [sym_yield] = STATE(645),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(644),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(644),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3117),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1137] = {
    [sym__newline] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(511),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2656),
  },
  [1138] = {
    [sym__newline] = ACTIONS(2692),
    [anon_sym_DOT] = ACTIONS(2692),
    [anon_sym_from] = ACTIONS(2692),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_COMMA] = ACTIONS(2692),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_EQ] = ACTIONS(2694),
    [anon_sym_AT] = ACTIONS(2692),
    [anon_sym_not] = ACTIONS(2692),
    [anon_sym_and] = ACTIONS(2692),
    [anon_sym_or] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_SLASH] = ACTIONS(2694),
    [anon_sym_PERCENT] = ACTIONS(2692),
    [anon_sym_SLASH_SLASH] = ACTIONS(2692),
    [anon_sym_STAR_STAR] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_CARET] = ACTIONS(2692),
    [anon_sym_LT_LT] = ACTIONS(2692),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_LT_EQ] = ACTIONS(2692),
    [anon_sym_EQ_EQ] = ACTIONS(2692),
    [anon_sym_BANG_EQ] = ACTIONS(2692),
    [anon_sym_GT_EQ] = ACTIONS(2692),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_LT_GT] = ACTIONS(2692),
    [anon_sym_is] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2692),
  },
  [1139] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(912),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3119),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [1140] = {
    [sym__newline] = ACTIONS(2707),
    [anon_sym_DOT] = ACTIONS(2707),
    [anon_sym_from] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(2707),
    [anon_sym_COMMA] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_GT_GT] = ACTIONS(2707),
    [anon_sym_if] = ACTIONS(2707),
    [anon_sym_in] = ACTIONS(2707),
    [anon_sym_EQ] = ACTIONS(2709),
    [anon_sym_AT] = ACTIONS(2707),
    [anon_sym_not] = ACTIONS(2707),
    [anon_sym_and] = ACTIONS(2707),
    [anon_sym_or] = ACTIONS(2707),
    [anon_sym_PLUS] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_SLASH] = ACTIONS(2709),
    [anon_sym_PERCENT] = ACTIONS(2707),
    [anon_sym_SLASH_SLASH] = ACTIONS(2707),
    [anon_sym_STAR_STAR] = ACTIONS(2707),
    [anon_sym_PIPE] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_CARET] = ACTIONS(2707),
    [anon_sym_LT_LT] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2709),
    [anon_sym_LT_EQ] = ACTIONS(2707),
    [anon_sym_EQ_EQ] = ACTIONS(2707),
    [anon_sym_BANG_EQ] = ACTIONS(2707),
    [anon_sym_GT_EQ] = ACTIONS(2707),
    [anon_sym_GT] = ACTIONS(2709),
    [anon_sym_LT_GT] = ACTIONS(2707),
    [anon_sym_is] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2707),
  },
  [1141] = {
    [sym__newline] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2773),
    [anon_sym_from] = ACTIONS(2773),
    [anon_sym_LPAREN] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_GT_GT] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_EQ] = ACTIONS(2775),
    [anon_sym_AT] = ACTIONS(2773),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_SLASH] = ACTIONS(2775),
    [anon_sym_PERCENT] = ACTIONS(2773),
    [anon_sym_SLASH_SLASH] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2773),
    [anon_sym_LT_LT] = ACTIONS(2773),
    [anon_sym_LT] = ACTIONS(2775),
    [anon_sym_LT_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ] = ACTIONS(2773),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_GT] = ACTIONS(2775),
    [anon_sym_LT_GT] = ACTIONS(2773),
    [anon_sym_is] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2773),
  },
  [1142] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(955),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(955),
    [sym_boolean_operator] = STATE(955),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(955),
    [sym_lambda] = STATE(955),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(955),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(955),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [1143] = {
    [sym__newline] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_from] = ACTIONS(2782),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2784),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_if] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(2782),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_not] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_SLASH_SLASH] = ACTIONS(2782),
    [anon_sym_STAR_STAR] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_LT_GT] = ACTIONS(2782),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2782),
  },
  [1144] = {
    [sym_dictionary_splat] = STATE(960),
    [sym__expression] = STATE(961),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(961),
    [sym_boolean_operator] = STATE(961),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(961),
    [sym_lambda] = STATE(961),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_pair] = STATE(960),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(961),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(961),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3123),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1145] = {
    [sym__newline] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_from] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_AT] = ACTIONS(2833),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(2833),
    [anon_sym_STAR_STAR] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2835),
    [anon_sym_LT_GT] = ACTIONS(2833),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2833),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2833),
  },
  [1146] = {
    [sym__newline] = ACTIONS(2865),
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_from] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_in] = ACTIONS(2865),
    [anon_sym_EQ] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2865),
    [anon_sym_not] = ACTIONS(2865),
    [anon_sym_and] = ACTIONS(2865),
    [anon_sym_or] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(2865),
    [anon_sym_STAR_STAR] = ACTIONS(2865),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_CARET] = ACTIONS(2865),
    [anon_sym_LT_LT] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_LT_EQ] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_GT_EQ] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_LT_GT] = ACTIONS(2865),
    [anon_sym_is] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2865),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2865),
  },
  [1147] = {
    [sym__expression] = STATE(1484),
    [sym__primary_expression] = STATE(81),
    [sym_not_operator] = STATE(1484),
    [sym_boolean_operator] = STATE(1484),
    [sym_binary_operator] = STATE(81),
    [sym_unary_operator] = STATE(81),
    [sym_comparison_operator] = STATE(1484),
    [sym_lambda] = STATE(1484),
    [sym_attribute] = STATE(81),
    [sym_subscript] = STATE(81),
    [sym_call] = STATE(81),
    [sym_list] = STATE(81),
    [sym_list_comprehension] = STATE(81),
    [sym_dictionary] = STATE(81),
    [sym_dictionary_comprehension] = STATE(81),
    [sym_set] = STATE(81),
    [sym_set_comprehension] = STATE(81),
    [sym_parenthesized_expression] = STATE(81),
    [sym_tuple] = STATE(81),
    [sym_generator_expression] = STATE(81),
    [sym_conditional_expression] = STATE(1484),
    [sym_concatenated_string] = STATE(81),
    [sym_string] = STATE(82),
    [sym_await] = STATE(1484),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [1148] = {
    [sym__newline] = ACTIONS(2943),
    [anon_sym_DOT] = ACTIONS(2943),
    [anon_sym_from] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_COMMA] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2943),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_in] = ACTIONS(2943),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_AT] = ACTIONS(2943),
    [anon_sym_not] = ACTIONS(2943),
    [anon_sym_and] = ACTIONS(2943),
    [anon_sym_or] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_DASH] = ACTIONS(2943),
    [anon_sym_SLASH] = ACTIONS(2945),
    [anon_sym_PERCENT] = ACTIONS(2943),
    [anon_sym_SLASH_SLASH] = ACTIONS(2943),
    [anon_sym_STAR_STAR] = ACTIONS(2943),
    [anon_sym_PIPE] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2943),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_LT_LT] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2943),
    [anon_sym_EQ_EQ] = ACTIONS(2943),
    [anon_sym_BANG_EQ] = ACTIONS(2943),
    [anon_sym_GT_EQ] = ACTIONS(2943),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_LT_GT] = ACTIONS(2943),
    [anon_sym_is] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2943),
  },
  [1149] = {
    [sym_list_splat] = STATE(1410),
    [sym_dictionary_splat] = STATE(1410),
    [sym__expression] = STATE(1411),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1411),
    [sym_boolean_operator] = STATE(1411),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1411),
    [sym_lambda] = STATE(1411),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_keyword_argument] = STATE(1410),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1411),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1411),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3125),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1150] = {
    [aux_sym_argument_list_repeat1] = STATE(1413),
    [anon_sym_RPAREN] = ACTIONS(3125),
    [anon_sym_COMMA] = ACTIONS(3127),
    [sym_comment] = ACTIONS(73),
  },
  [1151] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(2951),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(523),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(523),
    [anon_sym_SLASH_SLASH] = ACTIONS(523),
    [anon_sym_STAR_STAR] = ACTIONS(529),
    [anon_sym_PIPE] = ACTIONS(531),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_CARET] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2951),
  },
  [1152] = {
    [sym__expression] = STATE(1419),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1419),
    [sym_boolean_operator] = STATE(1419),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1419),
    [sym_lambda] = STATE(1419),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_slice] = STATE(1420),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1419),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3129),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1153] = {
    [sym__newline] = ACTIONS(2963),
    [anon_sym_DOT] = ACTIONS(2963),
    [anon_sym_from] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_in] = ACTIONS(2963),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_AT] = ACTIONS(2963),
    [anon_sym_not] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2963),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2963),
    [anon_sym_SLASH_SLASH] = ACTIONS(2963),
    [anon_sym_STAR_STAR] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2963),
    [anon_sym_AMP] = ACTIONS(2963),
    [anon_sym_CARET] = ACTIONS(2963),
    [anon_sym_LT_LT] = ACTIONS(2963),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_LT_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ] = ACTIONS(2963),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_LT_GT] = ACTIONS(2963),
    [anon_sym_is] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2963),
  },
  [1154] = {
    [aux_sym_subscript_repeat1] = STATE(1425),
    [anon_sym_COMMA] = ACTIONS(3131),
    [anon_sym_RBRACK] = ACTIONS(3129),
    [sym_comment] = ACTIONS(73),
  },
  [1155] = {
    [sym__newline] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_and] = ACTIONS(1391),
    [anon_sym_or] = ACTIONS(1393),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1671),
  },
  [1156] = {
    [sym__expression] = STATE(1489),
    [sym__primary_expression] = STATE(325),
    [sym_not_operator] = STATE(1489),
    [sym_boolean_operator] = STATE(1489),
    [sym_binary_operator] = STATE(325),
    [sym_unary_operator] = STATE(325),
    [sym_comparison_operator] = STATE(1489),
    [sym_lambda] = STATE(1489),
    [sym_attribute] = STATE(325),
    [sym_subscript] = STATE(325),
    [sym_call] = STATE(325),
    [sym_list] = STATE(325),
    [sym_list_comprehension] = STATE(325),
    [sym_dictionary] = STATE(325),
    [sym_dictionary_comprehension] = STATE(325),
    [sym_set] = STATE(325),
    [sym_set_comprehension] = STATE(325),
    [sym_parenthesized_expression] = STATE(325),
    [sym_tuple] = STATE(325),
    [sym_generator_expression] = STATE(325),
    [sym_conditional_expression] = STATE(1489),
    [sym_concatenated_string] = STATE(325),
    [sym_string] = STATE(326),
    [sym_await] = STATE(1489),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_lambda] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(561),
    [sym_float] = ACTIONS(561),
    [sym_identifier] = ACTIONS(561),
    [sym_true] = ACTIONS(561),
    [sym_false] = ACTIONS(561),
    [sym_none] = ACTIONS(561),
    [anon_sym_await] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
  },
  [1157] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1158] = {
    [sym__newline] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(1391),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1968),
  },
  [1159] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1160] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_SLASH_SLASH] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1161] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_SLASH_SLASH] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1999),
  },
  [1162] = {
    [sym__primary_expression] = STATE(1491),
    [sym_binary_operator] = STATE(1491),
    [sym_unary_operator] = STATE(1491),
    [sym_attribute] = STATE(1491),
    [sym_subscript] = STATE(1491),
    [sym_call] = STATE(1491),
    [sym_list] = STATE(1491),
    [sym_list_comprehension] = STATE(1491),
    [sym_dictionary] = STATE(1491),
    [sym_dictionary_comprehension] = STATE(1491),
    [sym_set] = STATE(1491),
    [sym_set_comprehension] = STATE(1491),
    [sym_parenthesized_expression] = STATE(1491),
    [sym_tuple] = STATE(1491),
    [sym_generator_expression] = STATE(1491),
    [sym_concatenated_string] = STATE(1491),
    [sym_string] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(3135),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(3137),
    [sym_float] = ACTIONS(3137),
    [sym_identifier] = ACTIONS(3137),
    [sym_true] = ACTIONS(3137),
    [sym_false] = ACTIONS(3137),
    [sym_none] = ACTIONS(3137),
    [sym_comment] = ACTIONS(73),
  },
  [1163] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_SLASH_SLASH] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1164] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_SLASH_SLASH] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1165] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_SLASH_SLASH] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1166] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_SLASH_SLASH] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1167] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1167),
    [sym__newline] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3142),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3145),
    [anon_sym_LT_EQ] = ACTIONS(3139),
    [anon_sym_EQ_EQ] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_GT_EQ] = ACTIONS(3139),
    [anon_sym_GT] = ACTIONS(3145),
    [anon_sym_LT_GT] = ACTIONS(3139),
    [anon_sym_is] = ACTIONS(3148),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1999),
  },
  [1168] = {
    [sym_string] = STATE(1168),
    [aux_sym_concatenated_string_repeat1] = STATE(1168),
    [sym__newline] = ACTIONS(2061),
    [sym__string_start] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2061),
  },
  [1169] = {
    [sym__newline] = ACTIONS(2656),
    [anon_sym_from] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(577),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2656),
  },
  [1170] = {
    [sym__expression] = STATE(1492),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(1492),
    [sym_boolean_operator] = STATE(1492),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(1492),
    [sym_lambda] = STATE(1492),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(1492),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(1492),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [1171] = {
    [sym__expression] = STATE(739),
    [sym__primary_expression] = STATE(94),
    [sym_not_operator] = STATE(739),
    [sym_boolean_operator] = STATE(739),
    [sym_binary_operator] = STATE(94),
    [sym_unary_operator] = STATE(94),
    [sym_comparison_operator] = STATE(739),
    [sym_lambda] = STATE(739),
    [sym_attribute] = STATE(94),
    [sym_subscript] = STATE(94),
    [sym_call] = STATE(94),
    [sym_list] = STATE(94),
    [sym_list_comprehension] = STATE(94),
    [sym_dictionary] = STATE(94),
    [sym_dictionary_comprehension] = STATE(94),
    [sym_set] = STATE(94),
    [sym_set_comprehension] = STATE(94),
    [sym_parenthesized_expression] = STATE(94),
    [sym_tuple] = STATE(94),
    [sym_generator_expression] = STATE(94),
    [sym_conditional_expression] = STATE(739),
    [sym_concatenated_string] = STATE(94),
    [sym_string] = STATE(95),
    [sym_await] = STATE(739),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [1172] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(2951),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_from] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(585),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(579),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_SLASH_SLASH] = ACTIONS(585),
    [anon_sym_STAR_STAR] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_CARET] = ACTIONS(597),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2951),
  },
  [1173] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [1174] = {
    [sym__expression] = STATE(1493),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1493),
    [sym_boolean_operator] = STATE(1493),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1493),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1493),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1175] = {
    [sym__string_start] = ACTIONS(2419),
    [ts_builtin_sym_end] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(3151),
    [anon_sym_from] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [anon_sym_print] = ACTIONS(3151),
    [anon_sym_assert] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_del] = ACTIONS(3151),
    [anon_sym_raise] = ACTIONS(3151),
    [anon_sym_pass] = ACTIONS(3151),
    [anon_sym_break] = ACTIONS(3151),
    [anon_sym_continue] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_elif] = ACTIONS(3151),
    [anon_sym_else] = ACTIONS(3151),
    [anon_sym_async] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [anon_sym_try] = ACTIONS(3151),
    [anon_sym_except] = ACTIONS(3151),
    [anon_sym_finally] = ACTIONS(3151),
    [anon_sym_with] = ACTIONS(3151),
    [anon_sym_def] = ACTIONS(3151),
    [anon_sym_global] = ACTIONS(3151),
    [anon_sym_nonlocal] = ACTIONS(3151),
    [anon_sym_exec] = ACTIONS(3151),
    [anon_sym_class] = ACTIONS(3151),
    [anon_sym_AT] = ACTIONS(2419),
    [anon_sym_not] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(2419),
    [anon_sym_DASH] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2419),
    [anon_sym_lambda] = ACTIONS(3151),
    [anon_sym_yield] = ACTIONS(3151),
    [anon_sym_LBRACK] = ACTIONS(2419),
    [sym_ellipsis] = ACTIONS(2419),
    [anon_sym_LBRACE] = ACTIONS(2419),
    [sym_integer] = ACTIONS(3151),
    [sym_float] = ACTIONS(3151),
    [sym_identifier] = ACTIONS(3151),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_none] = ACTIONS(3151),
    [anon_sym_await] = ACTIONS(3151),
    [sym_comment] = ACTIONS(73),
  },
  [1176] = {
    [sym__statement] = STATE(1206),
    [sym__simple_statements] = STATE(1206),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_if_statement] = STATE(1206),
    [sym_for_statement] = STATE(1206),
    [sym_while_statement] = STATE(1206),
    [sym_try_statement] = STATE(1206),
    [sym_with_statement] = STATE(1206),
    [sym_function_definition] = STATE(1206),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym_class_definition] = STATE(1206),
    [sym_decorated_definition] = STATE(1206),
    [sym_decorator] = STATE(798),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1206),
    [aux_sym_decorated_definition_repeat1] = STATE(798),
    [sym__dedent] = ACTIONS(3153),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_try] = ACTIONS(1541),
    [anon_sym_with] = ACTIONS(1543),
    [anon_sym_def] = ACTIONS(1545),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1177] = {
    [sym__expression] = STATE(1495),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1495),
    [sym_boolean_operator] = STATE(1495),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1495),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1495),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1178] = {
    [anon_sym_COLON] = ACTIONS(3155),
    [sym_comment] = ACTIONS(73),
  },
  [1179] = {
    [sym__string_start] = ACTIONS(3157),
    [ts_builtin_sym_end] = ACTIONS(3157),
    [anon_sym_import] = ACTIONS(3159),
    [anon_sym_from] = ACTIONS(3159),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [anon_sym_print] = ACTIONS(3159),
    [anon_sym_assert] = ACTIONS(3159),
    [anon_sym_return] = ACTIONS(3159),
    [anon_sym_del] = ACTIONS(3159),
    [anon_sym_raise] = ACTIONS(3159),
    [anon_sym_pass] = ACTIONS(3159),
    [anon_sym_break] = ACTIONS(3159),
    [anon_sym_continue] = ACTIONS(3159),
    [anon_sym_if] = ACTIONS(3159),
    [anon_sym_async] = ACTIONS(3159),
    [anon_sym_for] = ACTIONS(3159),
    [anon_sym_while] = ACTIONS(3159),
    [anon_sym_try] = ACTIONS(3159),
    [anon_sym_with] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(3159),
    [anon_sym_global] = ACTIONS(3159),
    [anon_sym_nonlocal] = ACTIONS(3159),
    [anon_sym_exec] = ACTIONS(3159),
    [anon_sym_class] = ACTIONS(3159),
    [anon_sym_AT] = ACTIONS(3157),
    [anon_sym_not] = ACTIONS(3159),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_lambda] = ACTIONS(3159),
    [anon_sym_yield] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [sym_ellipsis] = ACTIONS(3157),
    [anon_sym_LBRACE] = ACTIONS(3157),
    [sym_integer] = ACTIONS(3159),
    [sym_float] = ACTIONS(3159),
    [sym_identifier] = ACTIONS(3159),
    [sym_true] = ACTIONS(3159),
    [sym_false] = ACTIONS(3159),
    [sym_none] = ACTIONS(3159),
    [anon_sym_await] = ACTIONS(3159),
    [sym_comment] = ACTIONS(73),
  },
  [1180] = {
    [sym_elif_clause] = STATE(1498),
    [sym_else_clause] = STATE(1497),
    [aux_sym_if_statement_repeat1] = STATE(1498),
    [sym__string_start] = ACTIONS(3157),
    [ts_builtin_sym_end] = ACTIONS(3157),
    [anon_sym_import] = ACTIONS(3159),
    [anon_sym_from] = ACTIONS(3159),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [anon_sym_print] = ACTIONS(3159),
    [anon_sym_assert] = ACTIONS(3159),
    [anon_sym_return] = ACTIONS(3159),
    [anon_sym_del] = ACTIONS(3159),
    [anon_sym_raise] = ACTIONS(3159),
    [anon_sym_pass] = ACTIONS(3159),
    [anon_sym_break] = ACTIONS(3159),
    [anon_sym_continue] = ACTIONS(3159),
    [anon_sym_if] = ACTIONS(3159),
    [anon_sym_elif] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(3159),
    [anon_sym_for] = ACTIONS(3159),
    [anon_sym_while] = ACTIONS(3159),
    [anon_sym_try] = ACTIONS(3159),
    [anon_sym_with] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(3159),
    [anon_sym_global] = ACTIONS(3159),
    [anon_sym_nonlocal] = ACTIONS(3159),
    [anon_sym_exec] = ACTIONS(3159),
    [anon_sym_class] = ACTIONS(3159),
    [anon_sym_AT] = ACTIONS(3157),
    [anon_sym_not] = ACTIONS(3159),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_lambda] = ACTIONS(3159),
    [anon_sym_yield] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [sym_ellipsis] = ACTIONS(3157),
    [anon_sym_LBRACE] = ACTIONS(3157),
    [sym_integer] = ACTIONS(3159),
    [sym_float] = ACTIONS(3159),
    [sym_identifier] = ACTIONS(3159),
    [sym_true] = ACTIONS(3159),
    [sym_false] = ACTIONS(3159),
    [sym_none] = ACTIONS(3159),
    [anon_sym_await] = ACTIONS(3159),
    [sym_comment] = ACTIONS(73),
  },
  [1181] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(615),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_SLASH_SLASH] = ACTIONS(619),
    [anon_sym_STAR_STAR] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_CARET] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1182] = {
    [anon_sym_COLON] = ACTIONS(3161),
    [sym_comment] = ACTIONS(73),
  },
  [1183] = {
    [sym__string_start] = ACTIONS(3163),
    [ts_builtin_sym_end] = ACTIONS(3163),
    [anon_sym_import] = ACTIONS(3165),
    [anon_sym_from] = ACTIONS(3165),
    [anon_sym_LPAREN] = ACTIONS(3163),
    [anon_sym_print] = ACTIONS(3165),
    [anon_sym_assert] = ACTIONS(3165),
    [anon_sym_return] = ACTIONS(3165),
    [anon_sym_del] = ACTIONS(3165),
    [anon_sym_raise] = ACTIONS(3165),
    [anon_sym_pass] = ACTIONS(3165),
    [anon_sym_break] = ACTIONS(3165),
    [anon_sym_continue] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_async] = ACTIONS(3165),
    [anon_sym_for] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [anon_sym_try] = ACTIONS(3165),
    [anon_sym_with] = ACTIONS(3165),
    [anon_sym_def] = ACTIONS(3165),
    [anon_sym_global] = ACTIONS(3165),
    [anon_sym_nonlocal] = ACTIONS(3165),
    [anon_sym_exec] = ACTIONS(3165),
    [anon_sym_class] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3163),
    [anon_sym_not] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_TILDE] = ACTIONS(3163),
    [anon_sym_lambda] = ACTIONS(3165),
    [anon_sym_yield] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3163),
    [sym_ellipsis] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3163),
    [sym_integer] = ACTIONS(3165),
    [sym_float] = ACTIONS(3165),
    [sym_identifier] = ACTIONS(3165),
    [sym_true] = ACTIONS(3165),
    [sym_false] = ACTIONS(3165),
    [sym_none] = ACTIONS(3165),
    [anon_sym_await] = ACTIONS(3165),
    [sym_comment] = ACTIONS(73),
  },
  [1184] = {
    [sym__simple_statements] = STATE(1500),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1500),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1185] = {
    [sym__simple_statements] = STATE(1501),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1501),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1186] = {
    [sym__expression] = STATE(1239),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1239),
    [sym_boolean_operator] = STATE(1239),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1239),
    [sym_lambda] = STATE(1239),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_type] = STATE(1502),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1239),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1239),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1187] = {
    [sym__simple_statements] = STATE(1503),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1503),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1188] = {
    [sym__expression] = STATE(1504),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1504),
    [sym_boolean_operator] = STATE(1504),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1504),
    [sym_lambda] = STATE(1504),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1504),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(1504),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [1189] = {
    [aux_sym_print_statement_repeat1] = STATE(1506),
    [anon_sym_COMMA] = ACTIONS(3167),
    [anon_sym_COLON] = ACTIONS(915),
    [sym_comment] = ACTIONS(73),
  },
  [1190] = {
    [sym__primary_expression] = STATE(776),
    [sym_binary_operator] = STATE(776),
    [sym_unary_operator] = STATE(776),
    [sym_attribute] = STATE(776),
    [sym_subscript] = STATE(776),
    [sym_call] = STATE(776),
    [sym_list] = STATE(776),
    [sym_list_comprehension] = STATE(776),
    [sym_dictionary] = STATE(776),
    [sym_dictionary_comprehension] = STATE(776),
    [sym_set] = STATE(776),
    [sym_set_comprehension] = STATE(776),
    [sym_parenthesized_expression] = STATE(776),
    [sym_tuple] = STATE(776),
    [sym_generator_expression] = STATE(776),
    [sym_concatenated_string] = STATE(776),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1501),
    [sym_float] = ACTIONS(1501),
    [sym_identifier] = ACTIONS(1501),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [sym_none] = ACTIONS(1501),
    [sym_comment] = ACTIONS(73),
  },
  [1191] = {
    [sym__string_start] = ACTIONS(3169),
    [ts_builtin_sym_end] = ACTIONS(3169),
    [anon_sym_import] = ACTIONS(3171),
    [anon_sym_from] = ACTIONS(3171),
    [anon_sym_LPAREN] = ACTIONS(3169),
    [anon_sym_print] = ACTIONS(3171),
    [anon_sym_assert] = ACTIONS(3171),
    [anon_sym_return] = ACTIONS(3171),
    [anon_sym_del] = ACTIONS(3171),
    [anon_sym_raise] = ACTIONS(3171),
    [anon_sym_pass] = ACTIONS(3171),
    [anon_sym_break] = ACTIONS(3171),
    [anon_sym_continue] = ACTIONS(3171),
    [anon_sym_if] = ACTIONS(3171),
    [anon_sym_async] = ACTIONS(3171),
    [anon_sym_for] = ACTIONS(3171),
    [anon_sym_while] = ACTIONS(3171),
    [anon_sym_try] = ACTIONS(3171),
    [anon_sym_with] = ACTIONS(3171),
    [anon_sym_def] = ACTIONS(3171),
    [anon_sym_global] = ACTIONS(3171),
    [anon_sym_nonlocal] = ACTIONS(3171),
    [anon_sym_exec] = ACTIONS(3171),
    [anon_sym_class] = ACTIONS(3171),
    [anon_sym_AT] = ACTIONS(3169),
    [anon_sym_not] = ACTIONS(3171),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_TILDE] = ACTIONS(3169),
    [anon_sym_lambda] = ACTIONS(3171),
    [anon_sym_yield] = ACTIONS(3171),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [sym_ellipsis] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [sym_integer] = ACTIONS(3171),
    [sym_float] = ACTIONS(3171),
    [sym_identifier] = ACTIONS(3171),
    [sym_true] = ACTIONS(3171),
    [sym_false] = ACTIONS(3171),
    [sym_none] = ACTIONS(3171),
    [anon_sym_await] = ACTIONS(3171),
    [sym_comment] = ACTIONS(73),
  },
  [1192] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(3173),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [1193] = {
    [sym_variables] = STATE(1508),
    [sym__primary_expression] = STATE(108),
    [sym_binary_operator] = STATE(108),
    [sym_unary_operator] = STATE(108),
    [sym_attribute] = STATE(108),
    [sym_subscript] = STATE(108),
    [sym_call] = STATE(108),
    [sym_list] = STATE(108),
    [sym_list_comprehension] = STATE(108),
    [sym_dictionary] = STATE(108),
    [sym_dictionary_comprehension] = STATE(108),
    [sym_set] = STATE(108),
    [sym_set_comprehension] = STATE(108),
    [sym_parenthesized_expression] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_generator_expression] = STATE(108),
    [sym_concatenated_string] = STATE(108),
    [sym_string] = STATE(109),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [1194] = {
    [sym_with_item] = STATE(1509),
    [sym__expression] = STATE(117),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(117),
    [sym_boolean_operator] = STATE(117),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(117),
    [sym_lambda] = STATE(117),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(117),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(117),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [1195] = {
    [sym_identifier] = ACTIONS(3175),
    [sym_comment] = ACTIONS(73),
  },
  [1196] = {
    [anon_sym_in] = ACTIONS(3177),
    [sym_comment] = ACTIONS(73),
  },
  [1197] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(3179),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [1198] = {
    [sym__simple_statements] = STATE(1513),
    [sym_import_statement] = STATE(383),
    [sym_import_from_statement] = STATE(383),
    [sym_print_statement] = STATE(383),
    [sym_assert_statement] = STATE(383),
    [sym_expression_statement] = STATE(383),
    [sym_return_statement] = STATE(383),
    [sym_delete_statement] = STATE(383),
    [sym_raise_statement] = STATE(383),
    [sym_pass_statement] = STATE(383),
    [sym_break_statement] = STATE(383),
    [sym_continue_statement] = STATE(383),
    [sym_global_statement] = STATE(383),
    [sym_nonlocal_statement] = STATE(383),
    [sym_exec_statement] = STATE(383),
    [sym__suite] = STATE(1513),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(663),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1199] = {
    [aux_sym_with_statement_repeat1] = STATE(1515),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(3181),
    [sym_comment] = ACTIONS(73),
  },
  [1200] = {
    [sym_parameters] = STATE(1516),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym_comment] = ACTIONS(73),
  },
  [1201] = {
    [sym_argument_list] = STATE(1518),
    [anon_sym_LPAREN] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(3183),
    [sym_comment] = ACTIONS(73),
  },
  [1202] = {
    [sym__dedent] = ACTIONS(893),
    [sym__string_start] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(895),
    [anon_sym_from] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_print] = ACTIONS(895),
    [anon_sym_assert] = ACTIONS(895),
    [anon_sym_return] = ACTIONS(895),
    [anon_sym_del] = ACTIONS(895),
    [anon_sym_raise] = ACTIONS(895),
    [anon_sym_pass] = ACTIONS(895),
    [anon_sym_break] = ACTIONS(895),
    [anon_sym_continue] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(895),
    [anon_sym_elif] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(895),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_for] = ACTIONS(895),
    [anon_sym_while] = ACTIONS(895),
    [anon_sym_try] = ACTIONS(895),
    [anon_sym_except] = ACTIONS(895),
    [anon_sym_finally] = ACTIONS(895),
    [anon_sym_with] = ACTIONS(895),
    [anon_sym_def] = ACTIONS(895),
    [anon_sym_global] = ACTIONS(895),
    [anon_sym_nonlocal] = ACTIONS(895),
    [anon_sym_exec] = ACTIONS(895),
    [anon_sym_class] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(893),
    [anon_sym_not] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(893),
    [anon_sym_lambda] = ACTIONS(895),
    [anon_sym_yield] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(893),
    [sym_ellipsis] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [sym_integer] = ACTIONS(895),
    [sym_float] = ACTIONS(895),
    [sym_identifier] = ACTIONS(895),
    [sym_true] = ACTIONS(895),
    [sym_false] = ACTIONS(895),
    [sym_none] = ACTIONS(895),
    [anon_sym_await] = ACTIONS(895),
    [sym_comment] = ACTIONS(73),
  },
  [1203] = {
    [sym_import_statement] = STATE(515),
    [sym_import_from_statement] = STATE(515),
    [sym_print_statement] = STATE(515),
    [sym_assert_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_delete_statement] = STATE(515),
    [sym_raise_statement] = STATE(515),
    [sym_pass_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_global_statement] = STATE(515),
    [sym_nonlocal_statement] = STATE(515),
    [sym_exec_statement] = STATE(515),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(3185),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1204] = {
    [aux_sym__simple_statements_repeat1] = STATE(517),
    [sym__newline] = ACTIONS(3185),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3187),
  },
  [1205] = {
    [anon_sym_except] = ACTIONS(3189),
    [anon_sym_finally] = ACTIONS(3189),
    [sym_comment] = ACTIONS(73),
  },
  [1206] = {
    [sym__statement] = STATE(1206),
    [sym__simple_statements] = STATE(1206),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_if_statement] = STATE(1206),
    [sym_for_statement] = STATE(1206),
    [sym_while_statement] = STATE(1206),
    [sym_try_statement] = STATE(1206),
    [sym_with_statement] = STATE(1206),
    [sym_function_definition] = STATE(1206),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym_class_definition] = STATE(1206),
    [sym_decorated_definition] = STATE(1206),
    [sym_decorator] = STATE(798),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1206),
    [aux_sym_decorated_definition_repeat1] = STATE(798),
    [sym__dedent] = ACTIONS(1010),
    [sym__string_start] = ACTIONS(1007),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_from] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_print] = ACTIONS(1021),
    [anon_sym_assert] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_del] = ACTIONS(1030),
    [anon_sym_raise] = ACTIONS(1033),
    [anon_sym_pass] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1042),
    [anon_sym_if] = ACTIONS(3191),
    [anon_sym_async] = ACTIONS(3194),
    [anon_sym_for] = ACTIONS(3197),
    [anon_sym_while] = ACTIONS(3200),
    [anon_sym_try] = ACTIONS(3203),
    [anon_sym_with] = ACTIONS(3206),
    [anon_sym_def] = ACTIONS(3209),
    [anon_sym_global] = ACTIONS(1066),
    [anon_sym_nonlocal] = ACTIONS(1069),
    [anon_sym_exec] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(3212),
    [anon_sym_AT] = ACTIONS(1078),
    [anon_sym_not] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_lambda] = ACTIONS(1087),
    [anon_sym_yield] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [sym_ellipsis] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [sym_integer] = ACTIONS(1102),
    [sym_float] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1102),
    [sym_true] = ACTIONS(1102),
    [sym_false] = ACTIONS(1102),
    [sym_none] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1105),
    [sym_comment] = ACTIONS(73),
  },
  [1207] = {
    [anon_sym_def] = ACTIONS(2425),
    [sym_comment] = ACTIONS(73),
  },
  [1208] = {
    [sym__dedent] = ACTIONS(1108),
    [sym__string_start] = ACTIONS(1108),
    [anon_sym_import] = ACTIONS(1110),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [anon_sym_print] = ACTIONS(1110),
    [anon_sym_assert] = ACTIONS(1110),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_del] = ACTIONS(1110),
    [anon_sym_raise] = ACTIONS(1110),
    [anon_sym_pass] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1110),
    [anon_sym_continue] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1110),
    [anon_sym_async] = ACTIONS(1110),
    [anon_sym_for] = ACTIONS(1110),
    [anon_sym_while] = ACTIONS(1110),
    [anon_sym_try] = ACTIONS(1110),
    [anon_sym_with] = ACTIONS(1110),
    [anon_sym_def] = ACTIONS(1110),
    [anon_sym_global] = ACTIONS(1110),
    [anon_sym_nonlocal] = ACTIONS(1110),
    [anon_sym_exec] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(1110),
    [anon_sym_AT] = ACTIONS(1108),
    [anon_sym_not] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_TILDE] = ACTIONS(1108),
    [anon_sym_lambda] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1108),
    [sym_ellipsis] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1108),
    [sym_integer] = ACTIONS(1110),
    [sym_float] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(1110),
    [sym_true] = ACTIONS(1110),
    [sym_false] = ACTIONS(1110),
    [sym_none] = ACTIONS(1110),
    [anon_sym_await] = ACTIONS(1110),
    [sym_comment] = ACTIONS(73),
  },
  [1209] = {
    [anon_sym_except] = ACTIONS(1877),
    [anon_sym_finally] = ACTIONS(1877),
    [sym_comment] = ACTIONS(73),
  },
  [1210] = {
    [sym_import_statement] = STATE(515),
    [sym_import_from_statement] = STATE(515),
    [sym_print_statement] = STATE(515),
    [sym_assert_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_delete_statement] = STATE(515),
    [sym_raise_statement] = STATE(515),
    [sym_pass_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_global_statement] = STATE(515),
    [sym_nonlocal_statement] = STATE(515),
    [sym_exec_statement] = STATE(515),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(3215),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1211] = {
    [sym__simple_statements] = STATE(1522),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1522),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1212] = {
    [anon_sym_COMMA] = ACTIONS(3217),
    [anon_sym_as] = ACTIONS(3217),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_COLON] = ACTIONS(3219),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(679),
    [sym_comment] = ACTIONS(73),
  },
  [1213] = {
    [sym__simple_statements] = STATE(1525),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1525),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1214] = {
    [sym_finally_clause] = STATE(1526),
    [sym__string_start] = ACTIONS(3221),
    [ts_builtin_sym_end] = ACTIONS(3221),
    [anon_sym_import] = ACTIONS(3223),
    [anon_sym_from] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_print] = ACTIONS(3223),
    [anon_sym_assert] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_del] = ACTIONS(3223),
    [anon_sym_raise] = ACTIONS(3223),
    [anon_sym_pass] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_finally] = ACTIONS(2459),
    [anon_sym_with] = ACTIONS(3223),
    [anon_sym_def] = ACTIONS(3223),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_nonlocal] = ACTIONS(3223),
    [anon_sym_exec] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_AT] = ACTIONS(3221),
    [anon_sym_not] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_lambda] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [sym_ellipsis] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [sym_integer] = ACTIONS(3223),
    [sym_float] = ACTIONS(3223),
    [sym_identifier] = ACTIONS(3223),
    [sym_true] = ACTIONS(3223),
    [sym_false] = ACTIONS(3223),
    [sym_none] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [sym_comment] = ACTIONS(73),
  },
  [1215] = {
    [sym__string_start] = ACTIONS(3221),
    [ts_builtin_sym_end] = ACTIONS(3221),
    [anon_sym_import] = ACTIONS(3223),
    [anon_sym_from] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_print] = ACTIONS(3223),
    [anon_sym_assert] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_del] = ACTIONS(3223),
    [anon_sym_raise] = ACTIONS(3223),
    [anon_sym_pass] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_with] = ACTIONS(3223),
    [anon_sym_def] = ACTIONS(3223),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_nonlocal] = ACTIONS(3223),
    [anon_sym_exec] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_AT] = ACTIONS(3221),
    [anon_sym_not] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_lambda] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [sym_ellipsis] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [sym_integer] = ACTIONS(3223),
    [sym_float] = ACTIONS(3223),
    [sym_identifier] = ACTIONS(3223),
    [sym_true] = ACTIONS(3223),
    [sym_false] = ACTIONS(3223),
    [sym_none] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [sym_comment] = ACTIONS(73),
  },
  [1216] = {
    [sym_except_clause] = STATE(1216),
    [aux_sym_try_statement_repeat1] = STATE(1216),
    [sym__string_start] = ACTIONS(3225),
    [ts_builtin_sym_end] = ACTIONS(3225),
    [anon_sym_import] = ACTIONS(3227),
    [anon_sym_from] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_print] = ACTIONS(3227),
    [anon_sym_assert] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_del] = ACTIONS(3227),
    [anon_sym_raise] = ACTIONS(3227),
    [anon_sym_pass] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_except] = ACTIONS(3229),
    [anon_sym_finally] = ACTIONS(3227),
    [anon_sym_with] = ACTIONS(3227),
    [anon_sym_def] = ACTIONS(3227),
    [anon_sym_global] = ACTIONS(3227),
    [anon_sym_nonlocal] = ACTIONS(3227),
    [anon_sym_exec] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_AT] = ACTIONS(3225),
    [anon_sym_not] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_lambda] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [sym_ellipsis] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [sym_integer] = ACTIONS(3227),
    [sym_float] = ACTIONS(3227),
    [sym_identifier] = ACTIONS(3227),
    [sym_true] = ACTIONS(3227),
    [sym_false] = ACTIONS(3227),
    [sym_none] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [sym_comment] = ACTIONS(73),
  },
  [1217] = {
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_as] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(679),
    [sym_comment] = ACTIONS(73),
  },
  [1218] = {
    [sym__expression] = STATE(1527),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(1527),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [1219] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_as] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_SLASH_SLASH] = ACTIONS(687),
    [anon_sym_STAR_STAR] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1220] = {
    [sym__expression] = STATE(1528),
    [sym__primary_expression] = STATE(1226),
    [sym_not_operator] = STATE(1528),
    [sym_boolean_operator] = STATE(1528),
    [sym_binary_operator] = STATE(1226),
    [sym_unary_operator] = STATE(1226),
    [sym_comparison_operator] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_attribute] = STATE(1226),
    [sym_subscript] = STATE(1226),
    [sym_call] = STATE(1226),
    [sym_list] = STATE(1226),
    [sym_list_comprehension] = STATE(1226),
    [sym_dictionary] = STATE(1226),
    [sym_dictionary_comprehension] = STATE(1226),
    [sym_set] = STATE(1226),
    [sym_set_comprehension] = STATE(1226),
    [sym_parenthesized_expression] = STATE(1226),
    [sym_tuple] = STATE(1226),
    [sym_generator_expression] = STATE(1226),
    [sym_conditional_expression] = STATE(1528),
    [sym_concatenated_string] = STATE(1226),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(1528),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_lambda] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2502),
    [sym_float] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_none] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [sym_comment] = ACTIONS(73),
  },
  [1221] = {
    [sym__expression] = STATE(1529),
    [sym__primary_expression] = STATE(1226),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(1226),
    [sym_unary_operator] = STATE(1226),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_attribute] = STATE(1226),
    [sym_subscript] = STATE(1226),
    [sym_call] = STATE(1226),
    [sym_list] = STATE(1226),
    [sym_list_comprehension] = STATE(1226),
    [sym_dictionary] = STATE(1226),
    [sym_dictionary_comprehension] = STATE(1226),
    [sym_set] = STATE(1226),
    [sym_set_comprehension] = STATE(1226),
    [sym_parenthesized_expression] = STATE(1226),
    [sym_tuple] = STATE(1226),
    [sym_generator_expression] = STATE(1226),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(1226),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(1529),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_lambda] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2502),
    [sym_float] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_none] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [sym_comment] = ACTIONS(73),
  },
  [1222] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [1223] = {
    [sym_lambda_parameters] = STATE(1531),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3232),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1224] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(1226),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(1226),
    [sym_unary_operator] = STATE(1226),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(1226),
    [sym_subscript] = STATE(1226),
    [sym_call] = STATE(1226),
    [sym_list] = STATE(1226),
    [sym_list_comprehension] = STATE(1226),
    [sym_dictionary] = STATE(1226),
    [sym_dictionary_comprehension] = STATE(1226),
    [sym_set] = STATE(1226),
    [sym_set_comprehension] = STATE(1226),
    [sym_parenthesized_expression] = STATE(1226),
    [sym_tuple] = STATE(1226),
    [sym_generator_expression] = STATE(1226),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(1226),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_lambda] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2502),
    [sym_float] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_none] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [sym_comment] = ACTIONS(73),
  },
  [1225] = {
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_COMMA] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_COLON] = ACTIONS(1619),
    [anon_sym_and] = ACTIONS(3236),
    [anon_sym_or] = ACTIONS(3238),
    [sym_comment] = ACTIONS(73),
  },
  [1226] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(1545),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(3244),
    [anon_sym_AT] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(3248),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3252),
    [anon_sym_PIPE] = ACTIONS(3254),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3242),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_LT_EQ] = ACTIONS(3244),
    [anon_sym_EQ_EQ] = ACTIONS(3244),
    [anon_sym_BANG_EQ] = ACTIONS(3244),
    [anon_sym_GT_EQ] = ACTIONS(3244),
    [anon_sym_GT] = ACTIONS(3260),
    [anon_sym_LT_GT] = ACTIONS(3244),
    [anon_sym_is] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1227] = {
    [sym_string] = STATE(1546),
    [aux_sym_concatenated_string_repeat1] = STATE(1546),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [1228] = {
    [sym_default_parameter] = STATE(864),
    [sym_typed_default_parameter] = STATE(864),
    [sym_list_splat] = STATE(1549),
    [sym_dictionary_splat] = STATE(1549),
    [sym_typed_parameter] = STATE(864),
    [sym_tuple] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_print] = ACTIONS(3264),
    [anon_sym_exec] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3266),
    [sym_comment] = ACTIONS(73),
  },
  [1229] = {
    [sym__expression] = STATE(870),
    [sym__primary_expression] = STATE(871),
    [sym_not_operator] = STATE(870),
    [sym_boolean_operator] = STATE(870),
    [sym_binary_operator] = STATE(871),
    [sym_unary_operator] = STATE(871),
    [sym_comparison_operator] = STATE(870),
    [sym_lambda] = STATE(870),
    [sym_attribute] = STATE(871),
    [sym_subscript] = STATE(871),
    [sym_call] = STATE(871),
    [sym_type] = STATE(1550),
    [sym_list] = STATE(871),
    [sym_list_comprehension] = STATE(871),
    [sym_dictionary] = STATE(871),
    [sym_dictionary_comprehension] = STATE(871),
    [sym_set] = STATE(871),
    [sym_set_comprehension] = STATE(871),
    [sym_parenthesized_expression] = STATE(871),
    [sym_tuple] = STATE(871),
    [sym_generator_expression] = STATE(871),
    [sym_conditional_expression] = STATE(870),
    [sym_concatenated_string] = STATE(871),
    [sym_string] = STATE(873),
    [sym_await] = STATE(870),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_lambda] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1665),
    [sym_float] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1665),
    [sym_true] = ACTIONS(1665),
    [sym_false] = ACTIONS(1665),
    [sym_none] = ACTIONS(1665),
    [anon_sym_await] = ACTIONS(1667),
    [sym_comment] = ACTIONS(73),
  },
  [1230] = {
    [sym__expression] = STATE(1551),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1551),
    [sym_boolean_operator] = STATE(1551),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1551),
    [sym_lambda] = STATE(1551),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1551),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1551),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1231] = {
    [aux_sym__parameters_repeat1] = STATE(1553),
    [anon_sym_RPAREN] = ACTIONS(1653),
    [anon_sym_COMMA] = ACTIONS(3268),
    [sym_comment] = ACTIONS(73),
  },
  [1232] = {
    [sym_default_parameter] = STATE(864),
    [sym_typed_default_parameter] = STATE(864),
    [sym_list_splat] = STATE(1549),
    [sym_dictionary_splat] = STATE(1549),
    [sym_typed_parameter] = STATE(864),
    [sym_tuple] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(1673),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_print] = ACTIONS(3264),
    [anon_sym_exec] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3266),
    [sym_comment] = ACTIONS(73),
  },
  [1233] = {
    [sym__expression] = STATE(1558),
    [sym__primary_expression] = STATE(1559),
    [sym_not_operator] = STATE(1558),
    [sym_boolean_operator] = STATE(1558),
    [sym_binary_operator] = STATE(1559),
    [sym_unary_operator] = STATE(1559),
    [sym_comparison_operator] = STATE(1558),
    [sym_lambda] = STATE(1558),
    [sym_attribute] = STATE(1559),
    [sym_subscript] = STATE(1559),
    [sym_call] = STATE(1559),
    [sym_type] = STATE(1560),
    [sym_list] = STATE(1559),
    [sym_list_comprehension] = STATE(1559),
    [sym_dictionary] = STATE(1559),
    [sym_dictionary_comprehension] = STATE(1559),
    [sym_set] = STATE(1559),
    [sym_set_comprehension] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1559),
    [sym_tuple] = STATE(1559),
    [sym_generator_expression] = STATE(1559),
    [sym_conditional_expression] = STATE(1558),
    [sym_concatenated_string] = STATE(1559),
    [sym_string] = STATE(1561),
    [sym_await] = STATE(1558),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_lambda] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3278),
    [sym_float] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_none] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3280),
    [sym_comment] = ACTIONS(73),
  },
  [1234] = {
    [sym__expression] = STATE(1562),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1562),
    [sym_boolean_operator] = STATE(1562),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1562),
    [sym_lambda] = STATE(1562),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1562),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1562),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1235] = {
    [aux_sym__parameters_repeat1] = STATE(1553),
    [anon_sym_RPAREN] = ACTIONS(1673),
    [anon_sym_COMMA] = ACTIONS(3282),
    [sym_comment] = ACTIONS(73),
  },
  [1236] = {
    [anon_sym_COLON] = ACTIONS(3284),
    [anon_sym_DASH_GT] = ACTIONS(3284),
    [sym_comment] = ACTIONS(73),
  },
  [1237] = {
    [sym__expression] = STATE(1564),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1564),
    [sym_boolean_operator] = STATE(1564),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1564),
    [sym_lambda] = STATE(1564),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_type] = STATE(889),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1564),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1564),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1238] = {
    [sym__string_start] = ACTIONS(3286),
    [ts_builtin_sym_end] = ACTIONS(3286),
    [anon_sym_import] = ACTIONS(3288),
    [anon_sym_from] = ACTIONS(3288),
    [anon_sym_LPAREN] = ACTIONS(3286),
    [anon_sym_print] = ACTIONS(3288),
    [anon_sym_assert] = ACTIONS(3288),
    [anon_sym_return] = ACTIONS(3288),
    [anon_sym_del] = ACTIONS(3288),
    [anon_sym_raise] = ACTIONS(3288),
    [anon_sym_pass] = ACTIONS(3288),
    [anon_sym_break] = ACTIONS(3288),
    [anon_sym_continue] = ACTIONS(3288),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_async] = ACTIONS(3288),
    [anon_sym_for] = ACTIONS(3288),
    [anon_sym_while] = ACTIONS(3288),
    [anon_sym_try] = ACTIONS(3288),
    [anon_sym_with] = ACTIONS(3288),
    [anon_sym_def] = ACTIONS(3288),
    [anon_sym_global] = ACTIONS(3288),
    [anon_sym_nonlocal] = ACTIONS(3288),
    [anon_sym_exec] = ACTIONS(3288),
    [anon_sym_class] = ACTIONS(3288),
    [anon_sym_AT] = ACTIONS(3286),
    [anon_sym_not] = ACTIONS(3288),
    [anon_sym_PLUS] = ACTIONS(3286),
    [anon_sym_DASH] = ACTIONS(3286),
    [anon_sym_TILDE] = ACTIONS(3286),
    [anon_sym_lambda] = ACTIONS(3288),
    [anon_sym_yield] = ACTIONS(3288),
    [anon_sym_LBRACK] = ACTIONS(3286),
    [sym_ellipsis] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3286),
    [sym_integer] = ACTIONS(3288),
    [sym_float] = ACTIONS(3288),
    [sym_identifier] = ACTIONS(3288),
    [sym_true] = ACTIONS(3288),
    [sym_false] = ACTIONS(3288),
    [sym_none] = ACTIONS(3288),
    [anon_sym_await] = ACTIONS(3288),
    [sym_comment] = ACTIONS(73),
  },
  [1239] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(1890),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [1240] = {
    [anon_sym_COLON] = ACTIONS(3290),
    [sym_comment] = ACTIONS(73),
  },
  [1241] = {
    [aux_sym_print_statement_repeat1] = STATE(696),
    [sym__newline] = ACTIONS(3292),
    [anon_sym_COMMA] = ACTIONS(545),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3292),
  },
  [1242] = {
    [sym__string_start] = ACTIONS(3294),
    [ts_builtin_sym_end] = ACTIONS(3294),
    [anon_sym_import] = ACTIONS(3296),
    [anon_sym_from] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3294),
    [anon_sym_print] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_del] = ACTIONS(3296),
    [anon_sym_raise] = ACTIONS(3296),
    [anon_sym_pass] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_async] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_def] = ACTIONS(3296),
    [anon_sym_global] = ACTIONS(3296),
    [anon_sym_nonlocal] = ACTIONS(3296),
    [anon_sym_exec] = ACTIONS(3296),
    [anon_sym_class] = ACTIONS(3296),
    [anon_sym_AT] = ACTIONS(3294),
    [anon_sym_not] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [anon_sym_lambda] = ACTIONS(3296),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [sym_ellipsis] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3294),
    [sym_integer] = ACTIONS(3296),
    [sym_float] = ACTIONS(3296),
    [sym_identifier] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_none] = ACTIONS(3296),
    [anon_sym_await] = ACTIONS(3296),
    [sym_comment] = ACTIONS(73),
  },
  [1243] = {
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [1244] = {
    [sym__expression] = STATE(1566),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1566),
    [sym_boolean_operator] = STATE(1566),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1566),
    [sym_lambda] = STATE(1566),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1566),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(1566),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [1245] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3298),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1246] = {
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_COLON] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1247] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1248] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_SLASH_SLASH] = ACTIONS(1633),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1249] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_GT_GT] = ACTIONS(1629),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_SLASH_SLASH] = ACTIONS(1633),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1641),
    [anon_sym_AMP] = ACTIONS(1643),
    [anon_sym_CARET] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1629),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1250] = {
    [sym__primary_expression] = STATE(1568),
    [sym_binary_operator] = STATE(1568),
    [sym_unary_operator] = STATE(1568),
    [sym_attribute] = STATE(1568),
    [sym_subscript] = STATE(1568),
    [sym_call] = STATE(1568),
    [sym_list] = STATE(1568),
    [sym_list_comprehension] = STATE(1568),
    [sym_dictionary] = STATE(1568),
    [sym_dictionary_comprehension] = STATE(1568),
    [sym_set] = STATE(1568),
    [sym_set_comprehension] = STATE(1568),
    [sym_parenthesized_expression] = STATE(1568),
    [sym_tuple] = STATE(1568),
    [sym_generator_expression] = STATE(1568),
    [sym_concatenated_string] = STATE(1568),
    [sym_string] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3302),
    [sym_float] = ACTIONS(3302),
    [sym_identifier] = ACTIONS(3302),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [sym_none] = ACTIONS(3302),
    [sym_comment] = ACTIONS(73),
  },
  [1251] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_SLASH_SLASH] = ACTIONS(1633),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1252] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_GT_GT] = ACTIONS(1629),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_SLASH_SLASH] = ACTIONS(1633),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1643),
    [anon_sym_CARET] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1629),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1253] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_GT_GT] = ACTIONS(1629),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_SLASH_SLASH] = ACTIONS(1633),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1629),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1254] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_GT_GT] = ACTIONS(1629),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_SLASH_SLASH] = ACTIONS(1633),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1629),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1255] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1255),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3304),
    [anon_sym_not] = ACTIONS(3307),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3310),
    [anon_sym_LT_EQ] = ACTIONS(3304),
    [anon_sym_EQ_EQ] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_GT_EQ] = ACTIONS(3304),
    [anon_sym_GT] = ACTIONS(3310),
    [anon_sym_LT_GT] = ACTIONS(3304),
    [anon_sym_is] = ACTIONS(3313),
    [sym_comment] = ACTIONS(73),
  },
  [1256] = {
    [sym_string] = STATE(1256),
    [aux_sym_concatenated_string_repeat1] = STATE(1256),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1257] = {
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(2579),
    [anon_sym_or] = ACTIONS(2581),
    [sym_comment] = ACTIONS(73),
  },
  [1258] = {
    [sym__expression] = STATE(1569),
    [sym__primary_expression] = STATE(871),
    [sym_not_operator] = STATE(1569),
    [sym_boolean_operator] = STATE(1569),
    [sym_binary_operator] = STATE(871),
    [sym_unary_operator] = STATE(871),
    [sym_comparison_operator] = STATE(1569),
    [sym_lambda] = STATE(1569),
    [sym_attribute] = STATE(871),
    [sym_subscript] = STATE(871),
    [sym_call] = STATE(871),
    [sym_list] = STATE(871),
    [sym_list_comprehension] = STATE(871),
    [sym_dictionary] = STATE(871),
    [sym_dictionary_comprehension] = STATE(871),
    [sym_set] = STATE(871),
    [sym_set_comprehension] = STATE(871),
    [sym_parenthesized_expression] = STATE(871),
    [sym_tuple] = STATE(871),
    [sym_generator_expression] = STATE(871),
    [sym_conditional_expression] = STATE(1569),
    [sym_concatenated_string] = STATE(871),
    [sym_string] = STATE(873),
    [sym_await] = STATE(1569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_lambda] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1665),
    [sym_float] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1665),
    [sym_true] = ACTIONS(1665),
    [sym_false] = ACTIONS(1665),
    [sym_none] = ACTIONS(1665),
    [anon_sym_await] = ACTIONS(1667),
    [sym_comment] = ACTIONS(73),
  },
  [1259] = {
    [anon_sym_COLON] = ACTIONS(3316),
    [sym_comment] = ACTIONS(73),
  },
  [1260] = {
    [sym__expression] = STATE(1571),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1571),
    [sym_boolean_operator] = STATE(1571),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1571),
    [sym_lambda] = STATE(1571),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1571),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1571),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1261] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(871),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(871),
    [sym_unary_operator] = STATE(871),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(871),
    [sym_subscript] = STATE(871),
    [sym_call] = STATE(871),
    [sym_list] = STATE(871),
    [sym_list_comprehension] = STATE(871),
    [sym_dictionary] = STATE(871),
    [sym_dictionary_comprehension] = STATE(871),
    [sym_set] = STATE(871),
    [sym_set_comprehension] = STATE(871),
    [sym_parenthesized_expression] = STATE(871),
    [sym_tuple] = STATE(871),
    [sym_generator_expression] = STATE(871),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(871),
    [sym_string] = STATE(873),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_lambda] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1665),
    [sym_float] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1665),
    [sym_true] = ACTIONS(1665),
    [sym_false] = ACTIONS(1665),
    [sym_none] = ACTIONS(1665),
    [anon_sym_await] = ACTIONS(1667),
    [sym_comment] = ACTIONS(73),
  },
  [1262] = {
    [sym__expression] = STATE(1572),
    [sym__primary_expression] = STATE(871),
    [sym_not_operator] = STATE(1572),
    [sym_boolean_operator] = STATE(1572),
    [sym_binary_operator] = STATE(871),
    [sym_unary_operator] = STATE(871),
    [sym_comparison_operator] = STATE(1572),
    [sym_lambda] = STATE(1572),
    [sym_attribute] = STATE(871),
    [sym_subscript] = STATE(871),
    [sym_call] = STATE(871),
    [sym_list] = STATE(871),
    [sym_list_comprehension] = STATE(871),
    [sym_dictionary] = STATE(871),
    [sym_dictionary_comprehension] = STATE(871),
    [sym_set] = STATE(871),
    [sym_set_comprehension] = STATE(871),
    [sym_parenthesized_expression] = STATE(871),
    [sym_tuple] = STATE(871),
    [sym_generator_expression] = STATE(871),
    [sym_conditional_expression] = STATE(1572),
    [sym_concatenated_string] = STATE(871),
    [sym_string] = STATE(873),
    [sym_await] = STATE(1572),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_lambda] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1665),
    [sym_float] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1665),
    [sym_true] = ACTIONS(1665),
    [sym_false] = ACTIONS(1665),
    [sym_none] = ACTIONS(1665),
    [anon_sym_await] = ACTIONS(1667),
    [sym_comment] = ACTIONS(73),
  },
  [1263] = {
    [sym__primary_expression] = STATE(1573),
    [sym_binary_operator] = STATE(1573),
    [sym_unary_operator] = STATE(1573),
    [sym_attribute] = STATE(1573),
    [sym_subscript] = STATE(1573),
    [sym_call] = STATE(1573),
    [sym_list] = STATE(1573),
    [sym_list_comprehension] = STATE(1573),
    [sym_dictionary] = STATE(1573),
    [sym_dictionary_comprehension] = STATE(1573),
    [sym_set] = STATE(1573),
    [sym_set_comprehension] = STATE(1573),
    [sym_parenthesized_expression] = STATE(1573),
    [sym_tuple] = STATE(1573),
    [sym_generator_expression] = STATE(1573),
    [sym_concatenated_string] = STATE(1573),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3320),
    [sym_float] = ACTIONS(3320),
    [sym_identifier] = ACTIONS(3320),
    [sym_true] = ACTIONS(3320),
    [sym_false] = ACTIONS(3320),
    [sym_none] = ACTIONS(3320),
    [sym_comment] = ACTIONS(73),
  },
  [1264] = {
    [sym__primary_expression] = STATE(1574),
    [sym_binary_operator] = STATE(1574),
    [sym_unary_operator] = STATE(1574),
    [sym_attribute] = STATE(1574),
    [sym_subscript] = STATE(1574),
    [sym_call] = STATE(1574),
    [sym_list] = STATE(1574),
    [sym_list_comprehension] = STATE(1574),
    [sym_dictionary] = STATE(1574),
    [sym_dictionary_comprehension] = STATE(1574),
    [sym_set] = STATE(1574),
    [sym_set_comprehension] = STATE(1574),
    [sym_parenthesized_expression] = STATE(1574),
    [sym_tuple] = STATE(1574),
    [sym_generator_expression] = STATE(1574),
    [sym_concatenated_string] = STATE(1574),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3322),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3324),
    [sym_float] = ACTIONS(3324),
    [sym_identifier] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_none] = ACTIONS(3324),
    [sym_comment] = ACTIONS(73),
  },
  [1265] = {
    [sym__primary_expression] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_unary_operator] = STATE(1575),
    [sym_attribute] = STATE(1575),
    [sym_subscript] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_list] = STATE(1575),
    [sym_list_comprehension] = STATE(1575),
    [sym_dictionary] = STATE(1575),
    [sym_dictionary_comprehension] = STATE(1575),
    [sym_set] = STATE(1575),
    [sym_set_comprehension] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_tuple] = STATE(1575),
    [sym_generator_expression] = STATE(1575),
    [sym_concatenated_string] = STATE(1575),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3326),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3328),
    [sym_float] = ACTIONS(3328),
    [sym_identifier] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_none] = ACTIONS(3328),
    [sym_comment] = ACTIONS(73),
  },
  [1266] = {
    [anon_sym_in] = ACTIONS(3330),
    [sym_comment] = ACTIONS(73),
  },
  [1267] = {
    [sym__primary_expression] = STATE(1577),
    [sym_binary_operator] = STATE(1577),
    [sym_unary_operator] = STATE(1577),
    [sym_attribute] = STATE(1577),
    [sym_subscript] = STATE(1577),
    [sym_call] = STATE(1577),
    [sym_list] = STATE(1577),
    [sym_list_comprehension] = STATE(1577),
    [sym_dictionary] = STATE(1577),
    [sym_dictionary_comprehension] = STATE(1577),
    [sym_set] = STATE(1577),
    [sym_set_comprehension] = STATE(1577),
    [sym_parenthesized_expression] = STATE(1577),
    [sym_tuple] = STATE(1577),
    [sym_generator_expression] = STATE(1577),
    [sym_concatenated_string] = STATE(1577),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3334),
    [sym_float] = ACTIONS(3334),
    [sym_identifier] = ACTIONS(3334),
    [sym_true] = ACTIONS(3334),
    [sym_false] = ACTIONS(3334),
    [sym_none] = ACTIONS(3334),
    [sym_comment] = ACTIONS(73),
  },
  [1268] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [1269] = {
    [sym__primary_expression] = STATE(1578),
    [sym_binary_operator] = STATE(1578),
    [sym_unary_operator] = STATE(1578),
    [sym_attribute] = STATE(1578),
    [sym_subscript] = STATE(1578),
    [sym_call] = STATE(1578),
    [sym_list] = STATE(1578),
    [sym_list_comprehension] = STATE(1578),
    [sym_dictionary] = STATE(1578),
    [sym_dictionary_comprehension] = STATE(1578),
    [sym_set] = STATE(1578),
    [sym_set_comprehension] = STATE(1578),
    [sym_parenthesized_expression] = STATE(1578),
    [sym_tuple] = STATE(1578),
    [sym_generator_expression] = STATE(1578),
    [sym_concatenated_string] = STATE(1578),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3336),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3338),
    [sym_float] = ACTIONS(3338),
    [sym_identifier] = ACTIONS(3338),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [sym_none] = ACTIONS(3338),
    [sym_comment] = ACTIONS(73),
  },
  [1270] = {
    [sym__primary_expression] = STATE(1579),
    [sym_binary_operator] = STATE(1579),
    [sym_unary_operator] = STATE(1579),
    [sym_attribute] = STATE(1579),
    [sym_subscript] = STATE(1579),
    [sym_call] = STATE(1579),
    [sym_list] = STATE(1579),
    [sym_list_comprehension] = STATE(1579),
    [sym_dictionary] = STATE(1579),
    [sym_dictionary_comprehension] = STATE(1579),
    [sym_set] = STATE(1579),
    [sym_set_comprehension] = STATE(1579),
    [sym_parenthesized_expression] = STATE(1579),
    [sym_tuple] = STATE(1579),
    [sym_generator_expression] = STATE(1579),
    [sym_concatenated_string] = STATE(1579),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3342),
    [sym_float] = ACTIONS(3342),
    [sym_identifier] = ACTIONS(3342),
    [sym_true] = ACTIONS(3342),
    [sym_false] = ACTIONS(3342),
    [sym_none] = ACTIONS(3342),
    [sym_comment] = ACTIONS(73),
  },
  [1271] = {
    [sym__primary_expression] = STATE(1580),
    [sym_binary_operator] = STATE(1580),
    [sym_unary_operator] = STATE(1580),
    [sym_attribute] = STATE(1580),
    [sym_subscript] = STATE(1580),
    [sym_call] = STATE(1580),
    [sym_list] = STATE(1580),
    [sym_list_comprehension] = STATE(1580),
    [sym_dictionary] = STATE(1580),
    [sym_dictionary_comprehension] = STATE(1580),
    [sym_set] = STATE(1580),
    [sym_set_comprehension] = STATE(1580),
    [sym_parenthesized_expression] = STATE(1580),
    [sym_tuple] = STATE(1580),
    [sym_generator_expression] = STATE(1580),
    [sym_concatenated_string] = STATE(1580),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3346),
    [sym_float] = ACTIONS(3346),
    [sym_identifier] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_none] = ACTIONS(3346),
    [sym_comment] = ACTIONS(73),
  },
  [1272] = {
    [sym__primary_expression] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_unary_operator] = STATE(1575),
    [sym_attribute] = STATE(1575),
    [sym_subscript] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_list] = STATE(1575),
    [sym_list_comprehension] = STATE(1575),
    [sym_dictionary] = STATE(1575),
    [sym_dictionary_comprehension] = STATE(1575),
    [sym_set] = STATE(1575),
    [sym_set_comprehension] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_tuple] = STATE(1575),
    [sym_generator_expression] = STATE(1575),
    [sym_concatenated_string] = STATE(1575),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3348),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3326),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3328),
    [sym_float] = ACTIONS(3328),
    [sym_identifier] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_none] = ACTIONS(3328),
    [sym_comment] = ACTIONS(73),
  },
  [1273] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1581),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(2587),
    [anon_sym_EQ] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(2591),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(2603),
    [anon_sym_LT_EQ] = ACTIONS(2587),
    [anon_sym_EQ_EQ] = ACTIONS(2587),
    [anon_sym_BANG_EQ] = ACTIONS(2587),
    [anon_sym_GT_EQ] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(2603),
    [anon_sym_LT_GT] = ACTIONS(2587),
    [anon_sym_is] = ACTIONS(2605),
    [sym_comment] = ACTIONS(73),
  },
  [1274] = {
    [sym__expression] = STATE(1582),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1582),
    [sym_boolean_operator] = STATE(1582),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1582),
    [sym_lambda] = STATE(1582),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1582),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(1582),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [1275] = {
    [sym_string] = STATE(1583),
    [aux_sym_concatenated_string_repeat1] = STATE(1583),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [1276] = {
    [sym_default_parameter] = STATE(864),
    [sym_typed_default_parameter] = STATE(864),
    [sym_list_splat] = STATE(865),
    [sym_dictionary_splat] = STATE(865),
    [sym_typed_parameter] = STATE(864),
    [sym_tuple] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(1651),
    [anon_sym_exec] = ACTIONS(1651),
    [sym_identifier] = ACTIONS(1655),
    [sym_comment] = ACTIONS(73),
  },
  [1277] = {
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2622),
    [sym_comment] = ACTIONS(73),
  },
  [1278] = {
    [sym__expression] = STATE(1584),
    [sym__primary_expression] = STATE(882),
    [sym_not_operator] = STATE(1584),
    [sym_boolean_operator] = STATE(1584),
    [sym_binary_operator] = STATE(882),
    [sym_unary_operator] = STATE(882),
    [sym_comparison_operator] = STATE(1584),
    [sym_lambda] = STATE(1584),
    [sym_attribute] = STATE(882),
    [sym_subscript] = STATE(882),
    [sym_call] = STATE(882),
    [sym_list] = STATE(882),
    [sym_list_comprehension] = STATE(882),
    [sym_dictionary] = STATE(882),
    [sym_dictionary_comprehension] = STATE(882),
    [sym_set] = STATE(882),
    [sym_set_comprehension] = STATE(882),
    [sym_parenthesized_expression] = STATE(882),
    [sym_tuple] = STATE(882),
    [sym_generator_expression] = STATE(882),
    [sym_conditional_expression] = STATE(1584),
    [sym_concatenated_string] = STATE(882),
    [sym_string] = STATE(884),
    [sym_await] = STATE(1584),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_lambda] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1683),
    [sym_float] = ACTIONS(1683),
    [sym_identifier] = ACTIONS(1683),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_none] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1685),
    [sym_comment] = ACTIONS(73),
  },
  [1279] = {
    [anon_sym_COLON] = ACTIONS(3350),
    [sym_comment] = ACTIONS(73),
  },
  [1280] = {
    [sym__expression] = STATE(1586),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1586),
    [sym_boolean_operator] = STATE(1586),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1586),
    [sym_lambda] = STATE(1586),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1586),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1586),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1281] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(882),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(882),
    [sym_unary_operator] = STATE(882),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(882),
    [sym_subscript] = STATE(882),
    [sym_call] = STATE(882),
    [sym_list] = STATE(882),
    [sym_list_comprehension] = STATE(882),
    [sym_dictionary] = STATE(882),
    [sym_dictionary_comprehension] = STATE(882),
    [sym_set] = STATE(882),
    [sym_set_comprehension] = STATE(882),
    [sym_parenthesized_expression] = STATE(882),
    [sym_tuple] = STATE(882),
    [sym_generator_expression] = STATE(882),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(882),
    [sym_string] = STATE(884),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_lambda] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1683),
    [sym_float] = ACTIONS(1683),
    [sym_identifier] = ACTIONS(1683),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_none] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1685),
    [sym_comment] = ACTIONS(73),
  },
  [1282] = {
    [sym__expression] = STATE(1587),
    [sym__primary_expression] = STATE(882),
    [sym_not_operator] = STATE(1587),
    [sym_boolean_operator] = STATE(1587),
    [sym_binary_operator] = STATE(882),
    [sym_unary_operator] = STATE(882),
    [sym_comparison_operator] = STATE(1587),
    [sym_lambda] = STATE(1587),
    [sym_attribute] = STATE(882),
    [sym_subscript] = STATE(882),
    [sym_call] = STATE(882),
    [sym_list] = STATE(882),
    [sym_list_comprehension] = STATE(882),
    [sym_dictionary] = STATE(882),
    [sym_dictionary_comprehension] = STATE(882),
    [sym_set] = STATE(882),
    [sym_set_comprehension] = STATE(882),
    [sym_parenthesized_expression] = STATE(882),
    [sym_tuple] = STATE(882),
    [sym_generator_expression] = STATE(882),
    [sym_conditional_expression] = STATE(1587),
    [sym_concatenated_string] = STATE(882),
    [sym_string] = STATE(884),
    [sym_await] = STATE(1587),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_lambda] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1683),
    [sym_float] = ACTIONS(1683),
    [sym_identifier] = ACTIONS(1683),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_none] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1685),
    [sym_comment] = ACTIONS(73),
  },
  [1283] = {
    [sym__primary_expression] = STATE(1588),
    [sym_binary_operator] = STATE(1588),
    [sym_unary_operator] = STATE(1588),
    [sym_attribute] = STATE(1588),
    [sym_subscript] = STATE(1588),
    [sym_call] = STATE(1588),
    [sym_list] = STATE(1588),
    [sym_list_comprehension] = STATE(1588),
    [sym_dictionary] = STATE(1588),
    [sym_dictionary_comprehension] = STATE(1588),
    [sym_set] = STATE(1588),
    [sym_set_comprehension] = STATE(1588),
    [sym_parenthesized_expression] = STATE(1588),
    [sym_tuple] = STATE(1588),
    [sym_generator_expression] = STATE(1588),
    [sym_concatenated_string] = STATE(1588),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3352),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3354),
    [sym_float] = ACTIONS(3354),
    [sym_identifier] = ACTIONS(3354),
    [sym_true] = ACTIONS(3354),
    [sym_false] = ACTIONS(3354),
    [sym_none] = ACTIONS(3354),
    [sym_comment] = ACTIONS(73),
  },
  [1284] = {
    [sym__primary_expression] = STATE(1589),
    [sym_binary_operator] = STATE(1589),
    [sym_unary_operator] = STATE(1589),
    [sym_attribute] = STATE(1589),
    [sym_subscript] = STATE(1589),
    [sym_call] = STATE(1589),
    [sym_list] = STATE(1589),
    [sym_list_comprehension] = STATE(1589),
    [sym_dictionary] = STATE(1589),
    [sym_dictionary_comprehension] = STATE(1589),
    [sym_set] = STATE(1589),
    [sym_set_comprehension] = STATE(1589),
    [sym_parenthesized_expression] = STATE(1589),
    [sym_tuple] = STATE(1589),
    [sym_generator_expression] = STATE(1589),
    [sym_concatenated_string] = STATE(1589),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3358),
    [sym_float] = ACTIONS(3358),
    [sym_identifier] = ACTIONS(3358),
    [sym_true] = ACTIONS(3358),
    [sym_false] = ACTIONS(3358),
    [sym_none] = ACTIONS(3358),
    [sym_comment] = ACTIONS(73),
  },
  [1285] = {
    [sym__primary_expression] = STATE(1590),
    [sym_binary_operator] = STATE(1590),
    [sym_unary_operator] = STATE(1590),
    [sym_attribute] = STATE(1590),
    [sym_subscript] = STATE(1590),
    [sym_call] = STATE(1590),
    [sym_list] = STATE(1590),
    [sym_list_comprehension] = STATE(1590),
    [sym_dictionary] = STATE(1590),
    [sym_dictionary_comprehension] = STATE(1590),
    [sym_set] = STATE(1590),
    [sym_set_comprehension] = STATE(1590),
    [sym_parenthesized_expression] = STATE(1590),
    [sym_tuple] = STATE(1590),
    [sym_generator_expression] = STATE(1590),
    [sym_concatenated_string] = STATE(1590),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3360),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3362),
    [sym_float] = ACTIONS(3362),
    [sym_identifier] = ACTIONS(3362),
    [sym_true] = ACTIONS(3362),
    [sym_false] = ACTIONS(3362),
    [sym_none] = ACTIONS(3362),
    [sym_comment] = ACTIONS(73),
  },
  [1286] = {
    [anon_sym_in] = ACTIONS(3364),
    [sym_comment] = ACTIONS(73),
  },
  [1287] = {
    [sym__primary_expression] = STATE(1592),
    [sym_binary_operator] = STATE(1592),
    [sym_unary_operator] = STATE(1592),
    [sym_attribute] = STATE(1592),
    [sym_subscript] = STATE(1592),
    [sym_call] = STATE(1592),
    [sym_list] = STATE(1592),
    [sym_list_comprehension] = STATE(1592),
    [sym_dictionary] = STATE(1592),
    [sym_dictionary_comprehension] = STATE(1592),
    [sym_set] = STATE(1592),
    [sym_set_comprehension] = STATE(1592),
    [sym_parenthesized_expression] = STATE(1592),
    [sym_tuple] = STATE(1592),
    [sym_generator_expression] = STATE(1592),
    [sym_concatenated_string] = STATE(1592),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3366),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3368),
    [sym_float] = ACTIONS(3368),
    [sym_identifier] = ACTIONS(3368),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [sym_none] = ACTIONS(3368),
    [sym_comment] = ACTIONS(73),
  },
  [1288] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [1289] = {
    [sym__primary_expression] = STATE(1593),
    [sym_binary_operator] = STATE(1593),
    [sym_unary_operator] = STATE(1593),
    [sym_attribute] = STATE(1593),
    [sym_subscript] = STATE(1593),
    [sym_call] = STATE(1593),
    [sym_list] = STATE(1593),
    [sym_list_comprehension] = STATE(1593),
    [sym_dictionary] = STATE(1593),
    [sym_dictionary_comprehension] = STATE(1593),
    [sym_set] = STATE(1593),
    [sym_set_comprehension] = STATE(1593),
    [sym_parenthesized_expression] = STATE(1593),
    [sym_tuple] = STATE(1593),
    [sym_generator_expression] = STATE(1593),
    [sym_concatenated_string] = STATE(1593),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3370),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3372),
    [sym_float] = ACTIONS(3372),
    [sym_identifier] = ACTIONS(3372),
    [sym_true] = ACTIONS(3372),
    [sym_false] = ACTIONS(3372),
    [sym_none] = ACTIONS(3372),
    [sym_comment] = ACTIONS(73),
  },
  [1290] = {
    [sym__primary_expression] = STATE(1594),
    [sym_binary_operator] = STATE(1594),
    [sym_unary_operator] = STATE(1594),
    [sym_attribute] = STATE(1594),
    [sym_subscript] = STATE(1594),
    [sym_call] = STATE(1594),
    [sym_list] = STATE(1594),
    [sym_list_comprehension] = STATE(1594),
    [sym_dictionary] = STATE(1594),
    [sym_dictionary_comprehension] = STATE(1594),
    [sym_set] = STATE(1594),
    [sym_set_comprehension] = STATE(1594),
    [sym_parenthesized_expression] = STATE(1594),
    [sym_tuple] = STATE(1594),
    [sym_generator_expression] = STATE(1594),
    [sym_concatenated_string] = STATE(1594),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3374),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3376),
    [sym_float] = ACTIONS(3376),
    [sym_identifier] = ACTIONS(3376),
    [sym_true] = ACTIONS(3376),
    [sym_false] = ACTIONS(3376),
    [sym_none] = ACTIONS(3376),
    [sym_comment] = ACTIONS(73),
  },
  [1291] = {
    [sym__primary_expression] = STATE(1595),
    [sym_binary_operator] = STATE(1595),
    [sym_unary_operator] = STATE(1595),
    [sym_attribute] = STATE(1595),
    [sym_subscript] = STATE(1595),
    [sym_call] = STATE(1595),
    [sym_list] = STATE(1595),
    [sym_list_comprehension] = STATE(1595),
    [sym_dictionary] = STATE(1595),
    [sym_dictionary_comprehension] = STATE(1595),
    [sym_set] = STATE(1595),
    [sym_set_comprehension] = STATE(1595),
    [sym_parenthesized_expression] = STATE(1595),
    [sym_tuple] = STATE(1595),
    [sym_generator_expression] = STATE(1595),
    [sym_concatenated_string] = STATE(1595),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3378),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3380),
    [sym_float] = ACTIONS(3380),
    [sym_identifier] = ACTIONS(3380),
    [sym_true] = ACTIONS(3380),
    [sym_false] = ACTIONS(3380),
    [sym_none] = ACTIONS(3380),
    [sym_comment] = ACTIONS(73),
  },
  [1292] = {
    [sym__primary_expression] = STATE(1590),
    [sym_binary_operator] = STATE(1590),
    [sym_unary_operator] = STATE(1590),
    [sym_attribute] = STATE(1590),
    [sym_subscript] = STATE(1590),
    [sym_call] = STATE(1590),
    [sym_list] = STATE(1590),
    [sym_list_comprehension] = STATE(1590),
    [sym_dictionary] = STATE(1590),
    [sym_dictionary_comprehension] = STATE(1590),
    [sym_set] = STATE(1590),
    [sym_set_comprehension] = STATE(1590),
    [sym_parenthesized_expression] = STATE(1590),
    [sym_tuple] = STATE(1590),
    [sym_generator_expression] = STATE(1590),
    [sym_concatenated_string] = STATE(1590),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3360),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3362),
    [sym_float] = ACTIONS(3362),
    [sym_identifier] = ACTIONS(3362),
    [sym_true] = ACTIONS(3362),
    [sym_false] = ACTIONS(3362),
    [sym_none] = ACTIONS(3362),
    [sym_comment] = ACTIONS(73),
  },
  [1293] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1596),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_LT_GT] = ACTIONS(2628),
    [anon_sym_is] = ACTIONS(2646),
    [sym_comment] = ACTIONS(73),
  },
  [1294] = {
    [sym__expression] = STATE(1597),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1597),
    [sym_boolean_operator] = STATE(1597),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1597),
    [sym_lambda] = STATE(1597),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1597),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(1597),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [1295] = {
    [sym_string] = STATE(1598),
    [aux_sym_concatenated_string_repeat1] = STATE(1598),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_COLON] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [1296] = {
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(1671),
    [sym_comment] = ACTIONS(73),
  },
  [1297] = {
    [sym__expression] = STATE(1599),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(1599),
    [sym_boolean_operator] = STATE(1599),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(1599),
    [sym_lambda] = STATE(1599),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(1599),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(1599),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [1298] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3384),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1299] = {
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_RBRACK] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1300] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1301] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1709),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [anon_sym_SLASH_SLASH] = ACTIONS(1709),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1302] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1709),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [anon_sym_SLASH_SLASH] = ACTIONS(1709),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1303] = {
    [sym__primary_expression] = STATE(1601),
    [sym_binary_operator] = STATE(1601),
    [sym_unary_operator] = STATE(1601),
    [sym_attribute] = STATE(1601),
    [sym_subscript] = STATE(1601),
    [sym_call] = STATE(1601),
    [sym_list] = STATE(1601),
    [sym_list_comprehension] = STATE(1601),
    [sym_dictionary] = STATE(1601),
    [sym_dictionary_comprehension] = STATE(1601),
    [sym_set] = STATE(1601),
    [sym_set_comprehension] = STATE(1601),
    [sym_parenthesized_expression] = STATE(1601),
    [sym_tuple] = STATE(1601),
    [sym_generator_expression] = STATE(1601),
    [sym_concatenated_string] = STATE(1601),
    [sym_string] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3386),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3388),
    [sym_float] = ACTIONS(3388),
    [sym_identifier] = ACTIONS(3388),
    [sym_true] = ACTIONS(3388),
    [sym_false] = ACTIONS(3388),
    [sym_none] = ACTIONS(3388),
    [sym_comment] = ACTIONS(73),
  },
  [1304] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1709),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [anon_sym_SLASH_SLASH] = ACTIONS(1709),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1305] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1709),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [anon_sym_SLASH_SLASH] = ACTIONS(1709),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1306] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1709),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [anon_sym_SLASH_SLASH] = ACTIONS(1709),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1307] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1709),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [anon_sym_SLASH_SLASH] = ACTIONS(1709),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1308] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1308),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3390),
    [anon_sym_not] = ACTIONS(3393),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3390),
    [anon_sym_EQ_EQ] = ACTIONS(3390),
    [anon_sym_BANG_EQ] = ACTIONS(3390),
    [anon_sym_GT_EQ] = ACTIONS(3390),
    [anon_sym_GT] = ACTIONS(3396),
    [anon_sym_LT_GT] = ACTIONS(3390),
    [anon_sym_is] = ACTIONS(3399),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1309] = {
    [sym_string] = STATE(1309),
    [aux_sym_concatenated_string_repeat1] = STATE(1309),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1310] = {
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(801),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [sym_comment] = ACTIONS(73),
  },
  [1311] = {
    [sym__newline] = ACTIONS(3402),
    [anon_sym_DOT] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_STAR] = ACTIONS(3404),
    [anon_sym_GT_GT] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(3402),
    [anon_sym_COLON] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3402),
    [anon_sym_EQ] = ACTIONS(3404),
    [anon_sym_AT] = ACTIONS(3404),
    [anon_sym_not] = ACTIONS(3402),
    [anon_sym_and] = ACTIONS(3402),
    [anon_sym_or] = ACTIONS(3402),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_SLASH] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_SLASH_SLASH] = ACTIONS(3404),
    [anon_sym_STAR_STAR] = ACTIONS(3404),
    [anon_sym_PIPE] = ACTIONS(3404),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_CARET] = ACTIONS(3404),
    [anon_sym_LT_LT] = ACTIONS(3404),
    [anon_sym_LT] = ACTIONS(3404),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_GT] = ACTIONS(3404),
    [anon_sym_LT_GT] = ACTIONS(3402),
    [anon_sym_is] = ACTIONS(3402),
    [anon_sym_PLUS_EQ] = ACTIONS(3402),
    [anon_sym_DASH_EQ] = ACTIONS(3402),
    [anon_sym_STAR_EQ] = ACTIONS(3402),
    [anon_sym_SLASH_EQ] = ACTIONS(3402),
    [anon_sym_AT_EQ] = ACTIONS(3402),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3402),
    [anon_sym_PERCENT_EQ] = ACTIONS(3402),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3402),
    [anon_sym_GT_GT_EQ] = ACTIONS(3402),
    [anon_sym_LT_LT_EQ] = ACTIONS(3402),
    [anon_sym_AMP_EQ] = ACTIONS(3402),
    [anon_sym_CARET_EQ] = ACTIONS(3402),
    [anon_sym_PIPE_EQ] = ACTIONS(3402),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3402),
  },
  [1312] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(912),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(912),
    [sym_boolean_operator] = STATE(912),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(912),
    [sym_lambda] = STATE(912),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(912),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(912),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [1313] = {
    [sym__expression] = STATE(1602),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(1602),
    [sym_boolean_operator] = STATE(1602),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(1602),
    [sym_lambda] = STATE(1602),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(1602),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(1602),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1314] = {
    [anon_sym_in] = ACTIONS(3406),
    [sym_comment] = ACTIONS(73),
  },
  [1315] = {
    [sym__expression_within_for_in_clause] = STATE(1605),
    [sym__expression] = STATE(1606),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(1606),
    [sym_boolean_operator] = STATE(1606),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(1606),
    [sym_lambda] = STATE(1606),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(1606),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(1606),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1316] = {
    [sym__expression] = STATE(1607),
    [sym__primary_expression] = STATE(1321),
    [sym_not_operator] = STATE(1607),
    [sym_boolean_operator] = STATE(1607),
    [sym_binary_operator] = STATE(1321),
    [sym_unary_operator] = STATE(1321),
    [sym_comparison_operator] = STATE(1607),
    [sym_lambda] = STATE(1607),
    [sym_attribute] = STATE(1321),
    [sym_subscript] = STATE(1321),
    [sym_call] = STATE(1321),
    [sym_list] = STATE(1321),
    [sym_list_comprehension] = STATE(1321),
    [sym_dictionary] = STATE(1321),
    [sym_dictionary_comprehension] = STATE(1321),
    [sym_set] = STATE(1321),
    [sym_set_comprehension] = STATE(1321),
    [sym_parenthesized_expression] = STATE(1321),
    [sym_tuple] = STATE(1321),
    [sym_generator_expression] = STATE(1321),
    [sym_conditional_expression] = STATE(1607),
    [sym_concatenated_string] = STATE(1321),
    [sym_string] = STATE(1322),
    [sym_await] = STATE(1607),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_lambda] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2719),
    [sym_float] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2719),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [sym_none] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(2721),
    [sym_comment] = ACTIONS(73),
  },
  [1317] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [1318] = {
    [sym_lambda_parameters] = STATE(1609),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3410),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1319] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(1321),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(1321),
    [sym_unary_operator] = STATE(1321),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(1321),
    [sym_subscript] = STATE(1321),
    [sym_call] = STATE(1321),
    [sym_list] = STATE(1321),
    [sym_list_comprehension] = STATE(1321),
    [sym_dictionary] = STATE(1321),
    [sym_dictionary_comprehension] = STATE(1321),
    [sym_set] = STATE(1321),
    [sym_set_comprehension] = STATE(1321),
    [sym_parenthesized_expression] = STATE(1321),
    [sym_tuple] = STATE(1321),
    [sym_generator_expression] = STATE(1321),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(1321),
    [sym_string] = STATE(1322),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_lambda] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2719),
    [sym_float] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2719),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [sym_none] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(2721),
    [sym_comment] = ACTIONS(73),
  },
  [1320] = {
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_async] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_and] = ACTIONS(3412),
    [anon_sym_or] = ACTIONS(3414),
    [anon_sym_RBRACK] = ACTIONS(3064),
    [sym_comment] = ACTIONS(73),
  },
  [1321] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(1623),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_GT_GT] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(3420),
    [anon_sym_AT] = ACTIONS(3422),
    [anon_sym_not] = ACTIONS(3424),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(3426),
    [anon_sym_DASH] = ACTIONS(3426),
    [anon_sym_SLASH] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(3430),
    [anon_sym_AMP] = ACTIONS(3432),
    [anon_sym_CARET] = ACTIONS(3434),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(3436),
    [anon_sym_LT_EQ] = ACTIONS(3420),
    [anon_sym_EQ_EQ] = ACTIONS(3420),
    [anon_sym_BANG_EQ] = ACTIONS(3420),
    [anon_sym_GT_EQ] = ACTIONS(3420),
    [anon_sym_GT] = ACTIONS(3436),
    [anon_sym_LT_GT] = ACTIONS(3420),
    [anon_sym_is] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [1322] = {
    [sym_string] = STATE(1624),
    [aux_sym_concatenated_string_repeat1] = STATE(1624),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [1323] = {
    [sym_for_in_clause] = STATE(1323),
    [sym_if_clause] = STATE(1323),
    [aux_sym__comprehension_body_repeat1] = STATE(1323),
    [anon_sym_if] = ACTIONS(3440),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3446),
    [anon_sym_RBRACK] = ACTIONS(3094),
    [sym_comment] = ACTIONS(73),
  },
  [1324] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_async] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_SLASH_SLASH] = ACTIONS(809),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(819),
    [anon_sym_CARET] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(2951),
    [sym_comment] = ACTIONS(73),
  },
  [1325] = {
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(1777),
    [anon_sym_and] = ACTIONS(1779),
    [anon_sym_or] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(1671),
    [sym_comment] = ACTIONS(73),
  },
  [1326] = {
    [sym__expression] = STATE(1625),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(1625),
    [sym_boolean_operator] = STATE(1625),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(1625),
    [sym_lambda] = STATE(1625),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(1625),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(1625),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [1327] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3449),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1328] = {
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(1779),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_RBRACE] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1329] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1330] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1783),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1789),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1793),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_SLASH] = ACTIONS(1783),
    [anon_sym_PERCENT] = ACTIONS(1789),
    [anon_sym_SLASH_SLASH] = ACTIONS(1789),
    [anon_sym_STAR_STAR] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1331] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1783),
    [anon_sym_GT_GT] = ACTIONS(1785),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1789),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1793),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_SLASH] = ACTIONS(1783),
    [anon_sym_PERCENT] = ACTIONS(1789),
    [anon_sym_SLASH_SLASH] = ACTIONS(1789),
    [anon_sym_STAR_STAR] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_CARET] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1332] = {
    [sym__primary_expression] = STATE(1627),
    [sym_binary_operator] = STATE(1627),
    [sym_unary_operator] = STATE(1627),
    [sym_attribute] = STATE(1627),
    [sym_subscript] = STATE(1627),
    [sym_call] = STATE(1627),
    [sym_list] = STATE(1627),
    [sym_list_comprehension] = STATE(1627),
    [sym_dictionary] = STATE(1627),
    [sym_dictionary_comprehension] = STATE(1627),
    [sym_set] = STATE(1627),
    [sym_set_comprehension] = STATE(1627),
    [sym_parenthesized_expression] = STATE(1627),
    [sym_tuple] = STATE(1627),
    [sym_generator_expression] = STATE(1627),
    [sym_concatenated_string] = STATE(1627),
    [sym_string] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3453),
    [sym_float] = ACTIONS(3453),
    [sym_identifier] = ACTIONS(3453),
    [sym_true] = ACTIONS(3453),
    [sym_false] = ACTIONS(3453),
    [sym_none] = ACTIONS(3453),
    [sym_comment] = ACTIONS(73),
  },
  [1333] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1783),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1789),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1783),
    [anon_sym_PERCENT] = ACTIONS(1789),
    [anon_sym_SLASH_SLASH] = ACTIONS(1789),
    [anon_sym_STAR_STAR] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1334] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1783),
    [anon_sym_GT_GT] = ACTIONS(1785),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1789),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1793),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_SLASH] = ACTIONS(1783),
    [anon_sym_PERCENT] = ACTIONS(1789),
    [anon_sym_SLASH_SLASH] = ACTIONS(1789),
    [anon_sym_STAR_STAR] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_CARET] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1335] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1783),
    [anon_sym_GT_GT] = ACTIONS(1785),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1789),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1793),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_SLASH] = ACTIONS(1783),
    [anon_sym_PERCENT] = ACTIONS(1789),
    [anon_sym_SLASH_SLASH] = ACTIONS(1789),
    [anon_sym_STAR_STAR] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1336] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1783),
    [anon_sym_GT_GT] = ACTIONS(1785),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1789),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1793),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_SLASH] = ACTIONS(1783),
    [anon_sym_PERCENT] = ACTIONS(1789),
    [anon_sym_SLASH_SLASH] = ACTIONS(1789),
    [anon_sym_STAR_STAR] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1337] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1337),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_LT_EQ] = ACTIONS(3455),
    [anon_sym_EQ_EQ] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3455),
    [anon_sym_GT_EQ] = ACTIONS(3455),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_LT_GT] = ACTIONS(3455),
    [anon_sym_is] = ACTIONS(3464),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1338] = {
    [sym_string] = STATE(1338),
    [aux_sym_concatenated_string_repeat1] = STATE(1338),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1339] = {
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(863),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(73),
  },
  [1340] = {
    [sym__newline] = ACTIONS(3467),
    [anon_sym_DOT] = ACTIONS(3467),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COMMA] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_GT_GT] = ACTIONS(3469),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_COLON] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3467),
    [anon_sym_EQ] = ACTIONS(3469),
    [anon_sym_AT] = ACTIONS(3469),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_and] = ACTIONS(3467),
    [anon_sym_or] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3469),
    [anon_sym_SLASH] = ACTIONS(3469),
    [anon_sym_PERCENT] = ACTIONS(3469),
    [anon_sym_SLASH_SLASH] = ACTIONS(3469),
    [anon_sym_STAR_STAR] = ACTIONS(3469),
    [anon_sym_PIPE] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3469),
    [anon_sym_CARET] = ACTIONS(3469),
    [anon_sym_LT_LT] = ACTIONS(3469),
    [anon_sym_LT] = ACTIONS(3469),
    [anon_sym_LT_EQ] = ACTIONS(3467),
    [anon_sym_EQ_EQ] = ACTIONS(3467),
    [anon_sym_BANG_EQ] = ACTIONS(3467),
    [anon_sym_GT_EQ] = ACTIONS(3467),
    [anon_sym_GT] = ACTIONS(3469),
    [anon_sym_LT_GT] = ACTIONS(3467),
    [anon_sym_is] = ACTIONS(3467),
    [anon_sym_PLUS_EQ] = ACTIONS(3467),
    [anon_sym_DASH_EQ] = ACTIONS(3467),
    [anon_sym_STAR_EQ] = ACTIONS(3467),
    [anon_sym_SLASH_EQ] = ACTIONS(3467),
    [anon_sym_AT_EQ] = ACTIONS(3467),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3467),
    [anon_sym_PERCENT_EQ] = ACTIONS(3467),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3467),
    [anon_sym_GT_GT_EQ] = ACTIONS(3467),
    [anon_sym_LT_LT_EQ] = ACTIONS(3467),
    [anon_sym_AMP_EQ] = ACTIONS(3467),
    [anon_sym_CARET_EQ] = ACTIONS(3467),
    [anon_sym_PIPE_EQ] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3467),
  },
  [1341] = {
    [sym_list_splat] = STATE(911),
    [sym__expression] = STATE(955),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(955),
    [sym_boolean_operator] = STATE(955),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(955),
    [sym_lambda] = STATE(955),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(955),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(955),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [1342] = {
    [sym__expression] = STATE(1628),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(1628),
    [sym_boolean_operator] = STATE(1628),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(1628),
    [sym_lambda] = STATE(1628),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(1628),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(1628),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [1343] = {
    [sym__newline] = ACTIONS(3471),
    [anon_sym_DOT] = ACTIONS(3471),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_COMMA] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_GT_GT] = ACTIONS(3473),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_COLON] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3471),
    [anon_sym_EQ] = ACTIONS(3473),
    [anon_sym_AT] = ACTIONS(3473),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_and] = ACTIONS(3471),
    [anon_sym_or] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3473),
    [anon_sym_SLASH] = ACTIONS(3473),
    [anon_sym_PERCENT] = ACTIONS(3473),
    [anon_sym_SLASH_SLASH] = ACTIONS(3473),
    [anon_sym_STAR_STAR] = ACTIONS(3473),
    [anon_sym_PIPE] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3473),
    [anon_sym_CARET] = ACTIONS(3473),
    [anon_sym_LT_LT] = ACTIONS(3473),
    [anon_sym_LT] = ACTIONS(3473),
    [anon_sym_LT_EQ] = ACTIONS(3471),
    [anon_sym_EQ_EQ] = ACTIONS(3471),
    [anon_sym_BANG_EQ] = ACTIONS(3471),
    [anon_sym_GT_EQ] = ACTIONS(3471),
    [anon_sym_GT] = ACTIONS(3473),
    [anon_sym_LT_GT] = ACTIONS(3471),
    [anon_sym_is] = ACTIONS(3471),
    [anon_sym_PLUS_EQ] = ACTIONS(3471),
    [anon_sym_DASH_EQ] = ACTIONS(3471),
    [anon_sym_STAR_EQ] = ACTIONS(3471),
    [anon_sym_SLASH_EQ] = ACTIONS(3471),
    [anon_sym_AT_EQ] = ACTIONS(3471),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3471),
    [anon_sym_PERCENT_EQ] = ACTIONS(3471),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3471),
    [anon_sym_GT_GT_EQ] = ACTIONS(3471),
    [anon_sym_LT_LT_EQ] = ACTIONS(3471),
    [anon_sym_AMP_EQ] = ACTIONS(3471),
    [anon_sym_CARET_EQ] = ACTIONS(3471),
    [anon_sym_PIPE_EQ] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3471),
  },
  [1344] = {
    [sym_dictionary_splat] = STATE(960),
    [sym__expression] = STATE(961),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(961),
    [sym_boolean_operator] = STATE(961),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(961),
    [sym_lambda] = STATE(961),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_pair] = STATE(960),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(961),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(961),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1345] = {
    [sym__expression] = STATE(1629),
    [sym__primary_expression] = STATE(163),
    [sym_not_operator] = STATE(1629),
    [sym_boolean_operator] = STATE(1629),
    [sym_binary_operator] = STATE(163),
    [sym_unary_operator] = STATE(163),
    [sym_comparison_operator] = STATE(1629),
    [sym_lambda] = STATE(1629),
    [sym_attribute] = STATE(163),
    [sym_subscript] = STATE(163),
    [sym_call] = STATE(163),
    [sym_list] = STATE(163),
    [sym_list_comprehension] = STATE(163),
    [sym_dictionary] = STATE(163),
    [sym_dictionary_comprehension] = STATE(163),
    [sym_set] = STATE(163),
    [sym_set_comprehension] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_tuple] = STATE(163),
    [sym_generator_expression] = STATE(163),
    [sym_conditional_expression] = STATE(1629),
    [sym_concatenated_string] = STATE(163),
    [sym_string] = STATE(165),
    [sym_await] = STATE(1629),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [1346] = {
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(731),
    [sym_comment] = ACTIONS(73),
  },
  [1347] = {
    [sym__expression] = STATE(1630),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1630),
    [sym_boolean_operator] = STATE(1630),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1630),
    [sym_lambda] = STATE(1630),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1630),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1630),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1348] = {
    [anon_sym_COLON] = ACTIONS(3475),
    [sym_comment] = ACTIONS(73),
  },
  [1349] = {
    [sym__expression] = STATE(1632),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1632),
    [sym_boolean_operator] = STATE(1632),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1632),
    [sym_lambda] = STATE(1632),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1632),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1632),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1350] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1351] = {
    [sym__expression] = STATE(1633),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1633),
    [sym_boolean_operator] = STATE(1633),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1633),
    [sym_lambda] = STATE(1633),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1633),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1633),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1352] = {
    [sym__primary_expression] = STATE(1634),
    [sym_binary_operator] = STATE(1634),
    [sym_unary_operator] = STATE(1634),
    [sym_attribute] = STATE(1634),
    [sym_subscript] = STATE(1634),
    [sym_call] = STATE(1634),
    [sym_list] = STATE(1634),
    [sym_list_comprehension] = STATE(1634),
    [sym_dictionary] = STATE(1634),
    [sym_dictionary_comprehension] = STATE(1634),
    [sym_set] = STATE(1634),
    [sym_set_comprehension] = STATE(1634),
    [sym_parenthesized_expression] = STATE(1634),
    [sym_tuple] = STATE(1634),
    [sym_generator_expression] = STATE(1634),
    [sym_concatenated_string] = STATE(1634),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3477),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3479),
    [sym_float] = ACTIONS(3479),
    [sym_identifier] = ACTIONS(3479),
    [sym_true] = ACTIONS(3479),
    [sym_false] = ACTIONS(3479),
    [sym_none] = ACTIONS(3479),
    [sym_comment] = ACTIONS(73),
  },
  [1353] = {
    [sym__primary_expression] = STATE(1635),
    [sym_binary_operator] = STATE(1635),
    [sym_unary_operator] = STATE(1635),
    [sym_attribute] = STATE(1635),
    [sym_subscript] = STATE(1635),
    [sym_call] = STATE(1635),
    [sym_list] = STATE(1635),
    [sym_list_comprehension] = STATE(1635),
    [sym_dictionary] = STATE(1635),
    [sym_dictionary_comprehension] = STATE(1635),
    [sym_set] = STATE(1635),
    [sym_set_comprehension] = STATE(1635),
    [sym_parenthesized_expression] = STATE(1635),
    [sym_tuple] = STATE(1635),
    [sym_generator_expression] = STATE(1635),
    [sym_concatenated_string] = STATE(1635),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3483),
    [sym_float] = ACTIONS(3483),
    [sym_identifier] = ACTIONS(3483),
    [sym_true] = ACTIONS(3483),
    [sym_false] = ACTIONS(3483),
    [sym_none] = ACTIONS(3483),
    [sym_comment] = ACTIONS(73),
  },
  [1354] = {
    [sym__primary_expression] = STATE(1636),
    [sym_binary_operator] = STATE(1636),
    [sym_unary_operator] = STATE(1636),
    [sym_attribute] = STATE(1636),
    [sym_subscript] = STATE(1636),
    [sym_call] = STATE(1636),
    [sym_list] = STATE(1636),
    [sym_list_comprehension] = STATE(1636),
    [sym_dictionary] = STATE(1636),
    [sym_dictionary_comprehension] = STATE(1636),
    [sym_set] = STATE(1636),
    [sym_set_comprehension] = STATE(1636),
    [sym_parenthesized_expression] = STATE(1636),
    [sym_tuple] = STATE(1636),
    [sym_generator_expression] = STATE(1636),
    [sym_concatenated_string] = STATE(1636),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3487),
    [sym_float] = ACTIONS(3487),
    [sym_identifier] = ACTIONS(3487),
    [sym_true] = ACTIONS(3487),
    [sym_false] = ACTIONS(3487),
    [sym_none] = ACTIONS(3487),
    [sym_comment] = ACTIONS(73),
  },
  [1355] = {
    [anon_sym_in] = ACTIONS(3489),
    [sym_comment] = ACTIONS(73),
  },
  [1356] = {
    [sym__primary_expression] = STATE(1638),
    [sym_binary_operator] = STATE(1638),
    [sym_unary_operator] = STATE(1638),
    [sym_attribute] = STATE(1638),
    [sym_subscript] = STATE(1638),
    [sym_call] = STATE(1638),
    [sym_list] = STATE(1638),
    [sym_list_comprehension] = STATE(1638),
    [sym_dictionary] = STATE(1638),
    [sym_dictionary_comprehension] = STATE(1638),
    [sym_set] = STATE(1638),
    [sym_set_comprehension] = STATE(1638),
    [sym_parenthesized_expression] = STATE(1638),
    [sym_tuple] = STATE(1638),
    [sym_generator_expression] = STATE(1638),
    [sym_concatenated_string] = STATE(1638),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3491),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3493),
    [sym_float] = ACTIONS(3493),
    [sym_identifier] = ACTIONS(3493),
    [sym_true] = ACTIONS(3493),
    [sym_false] = ACTIONS(3493),
    [sym_none] = ACTIONS(3493),
    [sym_comment] = ACTIONS(73),
  },
  [1357] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [1358] = {
    [sym__primary_expression] = STATE(1639),
    [sym_binary_operator] = STATE(1639),
    [sym_unary_operator] = STATE(1639),
    [sym_attribute] = STATE(1639),
    [sym_subscript] = STATE(1639),
    [sym_call] = STATE(1639),
    [sym_list] = STATE(1639),
    [sym_list_comprehension] = STATE(1639),
    [sym_dictionary] = STATE(1639),
    [sym_dictionary_comprehension] = STATE(1639),
    [sym_set] = STATE(1639),
    [sym_set_comprehension] = STATE(1639),
    [sym_parenthesized_expression] = STATE(1639),
    [sym_tuple] = STATE(1639),
    [sym_generator_expression] = STATE(1639),
    [sym_concatenated_string] = STATE(1639),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3497),
    [sym_float] = ACTIONS(3497),
    [sym_identifier] = ACTIONS(3497),
    [sym_true] = ACTIONS(3497),
    [sym_false] = ACTIONS(3497),
    [sym_none] = ACTIONS(3497),
    [sym_comment] = ACTIONS(73),
  },
  [1359] = {
    [sym__primary_expression] = STATE(1640),
    [sym_binary_operator] = STATE(1640),
    [sym_unary_operator] = STATE(1640),
    [sym_attribute] = STATE(1640),
    [sym_subscript] = STATE(1640),
    [sym_call] = STATE(1640),
    [sym_list] = STATE(1640),
    [sym_list_comprehension] = STATE(1640),
    [sym_dictionary] = STATE(1640),
    [sym_dictionary_comprehension] = STATE(1640),
    [sym_set] = STATE(1640),
    [sym_set_comprehension] = STATE(1640),
    [sym_parenthesized_expression] = STATE(1640),
    [sym_tuple] = STATE(1640),
    [sym_generator_expression] = STATE(1640),
    [sym_concatenated_string] = STATE(1640),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3499),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3501),
    [sym_float] = ACTIONS(3501),
    [sym_identifier] = ACTIONS(3501),
    [sym_true] = ACTIONS(3501),
    [sym_false] = ACTIONS(3501),
    [sym_none] = ACTIONS(3501),
    [sym_comment] = ACTIONS(73),
  },
  [1360] = {
    [sym__primary_expression] = STATE(1641),
    [sym_binary_operator] = STATE(1641),
    [sym_unary_operator] = STATE(1641),
    [sym_attribute] = STATE(1641),
    [sym_subscript] = STATE(1641),
    [sym_call] = STATE(1641),
    [sym_list] = STATE(1641),
    [sym_list_comprehension] = STATE(1641),
    [sym_dictionary] = STATE(1641),
    [sym_dictionary_comprehension] = STATE(1641),
    [sym_set] = STATE(1641),
    [sym_set_comprehension] = STATE(1641),
    [sym_parenthesized_expression] = STATE(1641),
    [sym_tuple] = STATE(1641),
    [sym_generator_expression] = STATE(1641),
    [sym_concatenated_string] = STATE(1641),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3505),
    [sym_float] = ACTIONS(3505),
    [sym_identifier] = ACTIONS(3505),
    [sym_true] = ACTIONS(3505),
    [sym_false] = ACTIONS(3505),
    [sym_none] = ACTIONS(3505),
    [sym_comment] = ACTIONS(73),
  },
  [1361] = {
    [sym__primary_expression] = STATE(1636),
    [sym_binary_operator] = STATE(1636),
    [sym_unary_operator] = STATE(1636),
    [sym_attribute] = STATE(1636),
    [sym_subscript] = STATE(1636),
    [sym_call] = STATE(1636),
    [sym_list] = STATE(1636),
    [sym_list_comprehension] = STATE(1636),
    [sym_dictionary] = STATE(1636),
    [sym_dictionary_comprehension] = STATE(1636),
    [sym_set] = STATE(1636),
    [sym_set_comprehension] = STATE(1636),
    [sym_parenthesized_expression] = STATE(1636),
    [sym_tuple] = STATE(1636),
    [sym_generator_expression] = STATE(1636),
    [sym_concatenated_string] = STATE(1636),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3487),
    [sym_float] = ACTIONS(3487),
    [sym_identifier] = ACTIONS(3487),
    [sym_true] = ACTIONS(3487),
    [sym_false] = ACTIONS(3487),
    [sym_none] = ACTIONS(3487),
    [sym_comment] = ACTIONS(73),
  },
  [1362] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1642),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_async] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(2811),
    [anon_sym_not] = ACTIONS(2815),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_LT_GT] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(999),
    [sym_comment] = ACTIONS(73),
  },
  [1363] = {
    [sym_string] = STATE(1643),
    [aux_sym_concatenated_string_repeat1] = STATE(1643),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [1364] = {
    [anon_sym_in] = ACTIONS(3509),
    [sym_comment] = ACTIONS(73),
  },
  [1365] = {
    [sym__expression_within_for_in_clause] = STATE(1646),
    [sym__expression] = STATE(1647),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1647),
    [sym_boolean_operator] = STATE(1647),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1647),
    [sym_lambda] = STATE(1647),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1647),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1366] = {
    [sym__expression] = STATE(1648),
    [sym__primary_expression] = STATE(1371),
    [sym_not_operator] = STATE(1648),
    [sym_boolean_operator] = STATE(1648),
    [sym_binary_operator] = STATE(1371),
    [sym_unary_operator] = STATE(1371),
    [sym_comparison_operator] = STATE(1648),
    [sym_lambda] = STATE(1648),
    [sym_attribute] = STATE(1371),
    [sym_subscript] = STATE(1371),
    [sym_call] = STATE(1371),
    [sym_list] = STATE(1371),
    [sym_list_comprehension] = STATE(1371),
    [sym_dictionary] = STATE(1371),
    [sym_dictionary_comprehension] = STATE(1371),
    [sym_set] = STATE(1371),
    [sym_set_comprehension] = STATE(1371),
    [sym_parenthesized_expression] = STATE(1371),
    [sym_tuple] = STATE(1371),
    [sym_generator_expression] = STATE(1371),
    [sym_conditional_expression] = STATE(1648),
    [sym_concatenated_string] = STATE(1371),
    [sym_string] = STATE(1372),
    [sym_await] = STATE(1648),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2845),
    [sym_float] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [anon_sym_await] = ACTIONS(2847),
    [sym_comment] = ACTIONS(73),
  },
  [1367] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [1368] = {
    [sym_lambda_parameters] = STATE(1650),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3513),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1369] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(1371),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(1371),
    [sym_unary_operator] = STATE(1371),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(1371),
    [sym_subscript] = STATE(1371),
    [sym_call] = STATE(1371),
    [sym_list] = STATE(1371),
    [sym_list_comprehension] = STATE(1371),
    [sym_dictionary] = STATE(1371),
    [sym_dictionary_comprehension] = STATE(1371),
    [sym_set] = STATE(1371),
    [sym_set_comprehension] = STATE(1371),
    [sym_parenthesized_expression] = STATE(1371),
    [sym_tuple] = STATE(1371),
    [sym_generator_expression] = STATE(1371),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(1371),
    [sym_string] = STATE(1372),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2845),
    [sym_float] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [anon_sym_await] = ACTIONS(2847),
    [sym_comment] = ACTIONS(73),
  },
  [1370] = {
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_async] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3517),
    [anon_sym_RBRACE] = ACTIONS(3064),
    [sym_comment] = ACTIONS(73),
  },
  [1371] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(1664),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_GT_GT] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(3523),
    [anon_sym_AT] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(3527),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH] = ACTIONS(3525),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_CARET] = ACTIONS(3537),
    [anon_sym_LT_LT] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3539),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_EQ_EQ] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_GT] = ACTIONS(3539),
    [anon_sym_LT_GT] = ACTIONS(3523),
    [anon_sym_is] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [1372] = {
    [sym_string] = STATE(1665),
    [aux_sym_concatenated_string_repeat1] = STATE(1665),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [1373] = {
    [sym_for_in_clause] = STATE(1373),
    [sym_if_clause] = STATE(1373),
    [aux_sym__comprehension_body_repeat1] = STATE(1373),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_async] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3549),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [sym_comment] = ACTIONS(73),
  },
  [1374] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_async] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(873),
    [anon_sym_SLASH_SLASH] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(881),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(869),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [sym_comment] = ACTIONS(73),
  },
  [1375] = {
    [sym__newline] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(1894),
    [anon_sym_or] = ACTIONS(1896),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1671),
  },
  [1376] = {
    [sym__expression] = STATE(1666),
    [sym__primary_expression] = STATE(523),
    [sym_not_operator] = STATE(1666),
    [sym_boolean_operator] = STATE(1666),
    [sym_binary_operator] = STATE(523),
    [sym_unary_operator] = STATE(523),
    [sym_comparison_operator] = STATE(1666),
    [sym_lambda] = STATE(1666),
    [sym_attribute] = STATE(523),
    [sym_subscript] = STATE(523),
    [sym_call] = STATE(523),
    [sym_list] = STATE(523),
    [sym_list_comprehension] = STATE(523),
    [sym_dictionary] = STATE(523),
    [sym_dictionary_comprehension] = STATE(523),
    [sym_set] = STATE(523),
    [sym_set_comprehension] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_tuple] = STATE(523),
    [sym_generator_expression] = STATE(523),
    [sym_conditional_expression] = STATE(1666),
    [sym_concatenated_string] = STATE(523),
    [sym_string] = STATE(525),
    [sym_await] = STATE(1666),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_lambda] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(909),
    [sym_float] = ACTIONS(909),
    [sym_identifier] = ACTIONS(909),
    [sym_true] = ACTIONS(909),
    [sym_false] = ACTIONS(909),
    [sym_none] = ACTIONS(909),
    [anon_sym_await] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
  },
  [1377] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3552),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1378] = {
    [sym__newline] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(1894),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1968),
  },
  [1379] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1380] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_SLASH] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_SLASH_SLASH] = ACTIONS(1904),
    [anon_sym_STAR_STAR] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1381] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1900),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_SLASH] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_SLASH_SLASH] = ACTIONS(1904),
    [anon_sym_STAR_STAR] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_CARET] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1999),
  },
  [1382] = {
    [sym__primary_expression] = STATE(1668),
    [sym_binary_operator] = STATE(1668),
    [sym_unary_operator] = STATE(1668),
    [sym_attribute] = STATE(1668),
    [sym_subscript] = STATE(1668),
    [sym_call] = STATE(1668),
    [sym_list] = STATE(1668),
    [sym_list_comprehension] = STATE(1668),
    [sym_dictionary] = STATE(1668),
    [sym_dictionary_comprehension] = STATE(1668),
    [sym_set] = STATE(1668),
    [sym_set_comprehension] = STATE(1668),
    [sym_parenthesized_expression] = STATE(1668),
    [sym_tuple] = STATE(1668),
    [sym_generator_expression] = STATE(1668),
    [sym_concatenated_string] = STATE(1668),
    [sym_string] = STATE(525),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(3554),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(3556),
    [sym_float] = ACTIONS(3556),
    [sym_identifier] = ACTIONS(3556),
    [sym_true] = ACTIONS(3556),
    [sym_false] = ACTIONS(3556),
    [sym_none] = ACTIONS(3556),
    [sym_comment] = ACTIONS(73),
  },
  [1383] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_SLASH_SLASH] = ACTIONS(1904),
    [anon_sym_STAR_STAR] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1384] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1900),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_SLASH] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_SLASH_SLASH] = ACTIONS(1904),
    [anon_sym_STAR_STAR] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_CARET] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1385] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1900),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_SLASH] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_SLASH_SLASH] = ACTIONS(1904),
    [anon_sym_STAR_STAR] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1386] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1900),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_SLASH] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_SLASH_SLASH] = ACTIONS(1904),
    [anon_sym_STAR_STAR] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1995),
  },
  [1387] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1387),
    [sym__newline] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3558),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_not] = ACTIONS(3561),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3564),
    [anon_sym_LT_EQ] = ACTIONS(3558),
    [anon_sym_EQ_EQ] = ACTIONS(3558),
    [anon_sym_BANG_EQ] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(3558),
    [anon_sym_GT] = ACTIONS(3564),
    [anon_sym_LT_GT] = ACTIONS(3558),
    [anon_sym_is] = ACTIONS(3567),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1999),
  },
  [1388] = {
    [sym__newline] = ACTIONS(3570),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3570),
  },
  [1389] = {
    [sym_string] = STATE(1389),
    [aux_sym_concatenated_string_repeat1] = STATE(1389),
    [sym__newline] = ACTIONS(2061),
    [sym__string_start] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_EQ] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2061),
  },
  [1390] = {
    [sym__expression] = STATE(530),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(530),
    [sym_boolean_operator] = STATE(530),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(530),
    [sym_lambda] = STATE(530),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(530),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(530),
    [sym__newline] = ACTIONS(1972),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_COLON] = ACTIONS(1972),
    [anon_sym_EQ] = ACTIONS(1972),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(917),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(1972),
    [anon_sym_DASH_EQ] = ACTIONS(1972),
    [anon_sym_STAR_EQ] = ACTIONS(1972),
    [anon_sym_SLASH_EQ] = ACTIONS(1972),
    [anon_sym_AT_EQ] = ACTIONS(1972),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1972),
    [anon_sym_PERCENT_EQ] = ACTIONS(1972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1972),
    [anon_sym_GT_GT_EQ] = ACTIONS(1972),
    [anon_sym_LT_LT_EQ] = ACTIONS(1972),
    [anon_sym_AMP_EQ] = ACTIONS(1972),
    [anon_sym_CARET_EQ] = ACTIONS(1972),
    [anon_sym_PIPE_EQ] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1972),
  },
  [1391] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1392] = {
    [sym__expression] = STATE(1669),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1669),
    [sym_boolean_operator] = STATE(1669),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1669),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1669),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1393] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3572),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1394] = {
    [sym__newline] = ACTIONS(3574),
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(3574),
    [anon_sym_EQ] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(3574),
    [anon_sym_DASH_EQ] = ACTIONS(3574),
    [anon_sym_STAR_EQ] = ACTIONS(3574),
    [anon_sym_SLASH_EQ] = ACTIONS(3574),
    [anon_sym_AT_EQ] = ACTIONS(3574),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3574),
    [anon_sym_PERCENT_EQ] = ACTIONS(3574),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3574),
    [anon_sym_GT_GT_EQ] = ACTIONS(3574),
    [anon_sym_LT_LT_EQ] = ACTIONS(3574),
    [anon_sym_AMP_EQ] = ACTIONS(3574),
    [anon_sym_CARET_EQ] = ACTIONS(3574),
    [anon_sym_PIPE_EQ] = ACTIONS(3574),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3574),
  },
  [1395] = {
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1396] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_else] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1397] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_else] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1950),
    [anon_sym_SLASH_SLASH] = ACTIONS(1950),
    [anon_sym_STAR_STAR] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1398] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_else] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1950),
    [anon_sym_SLASH_SLASH] = ACTIONS(1950),
    [anon_sym_STAR_STAR] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1958),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1399] = {
    [sym__primary_expression] = STATE(1671),
    [sym_binary_operator] = STATE(1671),
    [sym_unary_operator] = STATE(1671),
    [sym_attribute] = STATE(1671),
    [sym_subscript] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym_list] = STATE(1671),
    [sym_list_comprehension] = STATE(1671),
    [sym_dictionary] = STATE(1671),
    [sym_dictionary_comprehension] = STATE(1671),
    [sym_set] = STATE(1671),
    [sym_set_comprehension] = STATE(1671),
    [sym_parenthesized_expression] = STATE(1671),
    [sym_tuple] = STATE(1671),
    [sym_generator_expression] = STATE(1671),
    [sym_concatenated_string] = STATE(1671),
    [sym_string] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3578),
    [sym_float] = ACTIONS(3578),
    [sym_identifier] = ACTIONS(3578),
    [sym_true] = ACTIONS(3578),
    [sym_false] = ACTIONS(3578),
    [sym_none] = ACTIONS(3578),
    [sym_comment] = ACTIONS(73),
  },
  [1400] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_else] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1950),
    [anon_sym_SLASH_SLASH] = ACTIONS(1950),
    [anon_sym_STAR_STAR] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1401] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_else] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1950),
    [anon_sym_SLASH_SLASH] = ACTIONS(1950),
    [anon_sym_STAR_STAR] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1402] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_else] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1950),
    [anon_sym_SLASH_SLASH] = ACTIONS(1950),
    [anon_sym_STAR_STAR] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1403] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_else] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1950),
    [anon_sym_SLASH_SLASH] = ACTIONS(1950),
    [anon_sym_STAR_STAR] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1404] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1404),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_else] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3580),
    [anon_sym_not] = ACTIONS(3583),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3586),
    [anon_sym_LT_EQ] = ACTIONS(3580),
    [anon_sym_EQ_EQ] = ACTIONS(3580),
    [anon_sym_BANG_EQ] = ACTIONS(3580),
    [anon_sym_GT_EQ] = ACTIONS(3580),
    [anon_sym_GT] = ACTIONS(3586),
    [anon_sym_LT_GT] = ACTIONS(3580),
    [anon_sym_is] = ACTIONS(3589),
    [sym_comment] = ACTIONS(73),
  },
  [1405] = {
    [sym_string] = STATE(1405),
    [aux_sym_concatenated_string_repeat1] = STATE(1405),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_else] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1406] = {
    [anon_sym_RPAREN] = ACTIONS(2535),
    [anon_sym_COMMA] = ACTIONS(2535),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1407] = {
    [anon_sym_RPAREN] = ACTIONS(3592),
    [anon_sym_COMMA] = ACTIONS(3592),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1408] = {
    [anon_sym_RPAREN] = ACTIONS(3594),
    [anon_sym_COMMA] = ACTIONS(3594),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1409] = {
    [sym__newline] = ACTIONS(3596),
    [anon_sym_DOT] = ACTIONS(3596),
    [anon_sym_LPAREN] = ACTIONS(3596),
    [anon_sym_COMMA] = ACTIONS(3596),
    [anon_sym_STAR] = ACTIONS(3598),
    [anon_sym_GT_GT] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(3596),
    [anon_sym_COLON] = ACTIONS(3596),
    [anon_sym_in] = ACTIONS(3596),
    [anon_sym_EQ] = ACTIONS(3598),
    [anon_sym_AT] = ACTIONS(3598),
    [anon_sym_not] = ACTIONS(3596),
    [anon_sym_and] = ACTIONS(3596),
    [anon_sym_or] = ACTIONS(3596),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_SLASH_SLASH] = ACTIONS(3598),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3598),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_CARET] = ACTIONS(3598),
    [anon_sym_LT_LT] = ACTIONS(3598),
    [anon_sym_LT] = ACTIONS(3598),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_EQ_EQ] = ACTIONS(3596),
    [anon_sym_BANG_EQ] = ACTIONS(3596),
    [anon_sym_GT_EQ] = ACTIONS(3596),
    [anon_sym_GT] = ACTIONS(3598),
    [anon_sym_LT_GT] = ACTIONS(3596),
    [anon_sym_is] = ACTIONS(3596),
    [anon_sym_PLUS_EQ] = ACTIONS(3596),
    [anon_sym_DASH_EQ] = ACTIONS(3596),
    [anon_sym_STAR_EQ] = ACTIONS(3596),
    [anon_sym_SLASH_EQ] = ACTIONS(3596),
    [anon_sym_AT_EQ] = ACTIONS(3596),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3596),
    [anon_sym_PERCENT_EQ] = ACTIONS(3596),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3596),
    [anon_sym_GT_GT_EQ] = ACTIONS(3596),
    [anon_sym_LT_LT_EQ] = ACTIONS(3596),
    [anon_sym_AMP_EQ] = ACTIONS(3596),
    [anon_sym_CARET_EQ] = ACTIONS(3596),
    [anon_sym_PIPE_EQ] = ACTIONS(3596),
    [anon_sym_LBRACK] = ACTIONS(3596),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3596),
  },
  [1410] = {
    [anon_sym_RPAREN] = ACTIONS(3600),
    [anon_sym_COMMA] = ACTIONS(3600),
    [sym_comment] = ACTIONS(73),
  },
  [1411] = {
    [anon_sym_RPAREN] = ACTIONS(3600),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1412] = {
    [sym_list_splat] = STATE(1410),
    [sym_dictionary_splat] = STATE(1410),
    [sym__expression] = STATE(1411),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1411),
    [sym_boolean_operator] = STATE(1411),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1411),
    [sym_lambda] = STATE(1411),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_keyword_argument] = STATE(1410),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1411),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1411),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3602),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1413] = {
    [aux_sym_argument_list_repeat1] = STATE(1413),
    [anon_sym_RPAREN] = ACTIONS(3600),
    [anon_sym_COMMA] = ACTIONS(3604),
    [sym_comment] = ACTIONS(73),
  },
  [1414] = {
    [anon_sym_COMMA] = ACTIONS(3607),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(3607),
    [sym_comment] = ACTIONS(73),
  },
  [1415] = {
    [sym__expression] = STATE(1674),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(1674),
    [sym_boolean_operator] = STATE(1674),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(1674),
    [sym_lambda] = STATE(1674),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(1674),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(1674),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(3607),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3607),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [1416] = {
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_RBRACK] = ACTIONS(1671),
    [sym_comment] = ACTIONS(73),
  },
  [1417] = {
    [sym__expression] = STATE(1675),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1675),
    [sym_boolean_operator] = STATE(1675),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1675),
    [sym_lambda] = STATE(1675),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1675),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1675),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1418] = {
    [sym__newline] = ACTIONS(3609),
    [anon_sym_DOT] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_COMMA] = ACTIONS(3609),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_GT_GT] = ACTIONS(3611),
    [anon_sym_if] = ACTIONS(3609),
    [anon_sym_COLON] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3609),
    [anon_sym_EQ] = ACTIONS(3611),
    [anon_sym_AT] = ACTIONS(3611),
    [anon_sym_not] = ACTIONS(3609),
    [anon_sym_and] = ACTIONS(3609),
    [anon_sym_or] = ACTIONS(3609),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3611),
    [anon_sym_SLASH_SLASH] = ACTIONS(3611),
    [anon_sym_STAR_STAR] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_CARET] = ACTIONS(3611),
    [anon_sym_LT_LT] = ACTIONS(3611),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_LT_EQ] = ACTIONS(3609),
    [anon_sym_EQ_EQ] = ACTIONS(3609),
    [anon_sym_BANG_EQ] = ACTIONS(3609),
    [anon_sym_GT_EQ] = ACTIONS(3609),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_LT_GT] = ACTIONS(3609),
    [anon_sym_is] = ACTIONS(3609),
    [anon_sym_PLUS_EQ] = ACTIONS(3609),
    [anon_sym_DASH_EQ] = ACTIONS(3609),
    [anon_sym_STAR_EQ] = ACTIONS(3609),
    [anon_sym_SLASH_EQ] = ACTIONS(3609),
    [anon_sym_AT_EQ] = ACTIONS(3609),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3609),
    [anon_sym_PERCENT_EQ] = ACTIONS(3609),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3609),
    [anon_sym_GT_GT_EQ] = ACTIONS(3609),
    [anon_sym_LT_LT_EQ] = ACTIONS(3609),
    [anon_sym_AMP_EQ] = ACTIONS(3609),
    [anon_sym_CARET_EQ] = ACTIONS(3609),
    [anon_sym_PIPE_EQ] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3609),
  },
  [1419] = {
    [anon_sym_COMMA] = ACTIONS(3613),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_RBRACK] = ACTIONS(3613),
    [sym_comment] = ACTIONS(73),
  },
  [1420] = {
    [anon_sym_COMMA] = ACTIONS(3613),
    [anon_sym_RBRACK] = ACTIONS(3613),
    [sym_comment] = ACTIONS(73),
  },
  [1421] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1422] = {
    [anon_sym_COMMA] = ACTIONS(3607),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_COLON] = ACTIONS(3617),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_RBRACK] = ACTIONS(3607),
    [sym_comment] = ACTIONS(73),
  },
  [1423] = {
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_COLON] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_RBRACK] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1424] = {
    [sym__expression] = STATE(1419),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1419),
    [sym_boolean_operator] = STATE(1419),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1419),
    [sym_lambda] = STATE(1419),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_slice] = STATE(1420),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1419),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3619),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1425] = {
    [aux_sym_subscript_repeat1] = STATE(1425),
    [anon_sym_COMMA] = ACTIONS(3621),
    [anon_sym_RBRACK] = ACTIONS(3613),
    [sym_comment] = ACTIONS(73),
  },
  [1426] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1427] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_PERCENT] = ACTIONS(2031),
    [anon_sym_SLASH_SLASH] = ACTIONS(2031),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1428] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_PERCENT] = ACTIONS(2031),
    [anon_sym_SLASH_SLASH] = ACTIONS(2031),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(2043),
    [anon_sym_LT_LT] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1429] = {
    [sym__primary_expression] = STATE(1680),
    [sym_binary_operator] = STATE(1680),
    [sym_unary_operator] = STATE(1680),
    [sym_attribute] = STATE(1680),
    [sym_subscript] = STATE(1680),
    [sym_call] = STATE(1680),
    [sym_list] = STATE(1680),
    [sym_list_comprehension] = STATE(1680),
    [sym_dictionary] = STATE(1680),
    [sym_dictionary_comprehension] = STATE(1680),
    [sym_set] = STATE(1680),
    [sym_set_comprehension] = STATE(1680),
    [sym_parenthesized_expression] = STATE(1680),
    [sym_tuple] = STATE(1680),
    [sym_generator_expression] = STATE(1680),
    [sym_concatenated_string] = STATE(1680),
    [sym_string] = STATE(567),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3624),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3626),
    [sym_float] = ACTIONS(3626),
    [sym_identifier] = ACTIONS(3626),
    [sym_true] = ACTIONS(3626),
    [sym_false] = ACTIONS(3626),
    [sym_none] = ACTIONS(3626),
    [sym_comment] = ACTIONS(73),
  },
  [1430] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_PERCENT] = ACTIONS(2031),
    [anon_sym_SLASH_SLASH] = ACTIONS(2031),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1431] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_PERCENT] = ACTIONS(2031),
    [anon_sym_SLASH_SLASH] = ACTIONS(2031),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(2043),
    [anon_sym_LT_LT] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1432] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_PERCENT] = ACTIONS(2031),
    [anon_sym_SLASH_SLASH] = ACTIONS(2031),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(2043),
    [anon_sym_LT_LT] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1433] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_PERCENT] = ACTIONS(2031),
    [anon_sym_SLASH_SLASH] = ACTIONS(2031),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1434] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1434),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3628),
    [anon_sym_not] = ACTIONS(3631),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_LT_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3628),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_LT_GT] = ACTIONS(3628),
    [anon_sym_is] = ACTIONS(3637),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1435] = {
    [sym_string] = STATE(1435),
    [aux_sym_concatenated_string_repeat1] = STATE(1435),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1436] = {
    [anon_sym_if] = ACTIONS(1119),
    [anon_sym_and] = ACTIONS(1121),
    [anon_sym_or] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [sym_type_conversion] = ACTIONS(2656),
    [sym_comment] = ACTIONS(73),
  },
  [1437] = {
    [sym__expression] = STATE(1681),
    [sym__primary_expression] = STATE(203),
    [sym_not_operator] = STATE(1681),
    [sym_boolean_operator] = STATE(1681),
    [sym_binary_operator] = STATE(203),
    [sym_unary_operator] = STATE(203),
    [sym_comparison_operator] = STATE(1681),
    [sym_lambda] = STATE(1681),
    [sym_attribute] = STATE(203),
    [sym_subscript] = STATE(203),
    [sym_call] = STATE(203),
    [sym_list] = STATE(203),
    [sym_list_comprehension] = STATE(203),
    [sym_dictionary] = STATE(203),
    [sym_dictionary_comprehension] = STATE(203),
    [sym_set] = STATE(203),
    [sym_set_comprehension] = STATE(203),
    [sym_parenthesized_expression] = STATE(203),
    [sym_tuple] = STATE(203),
    [sym_generator_expression] = STATE(203),
    [sym_conditional_expression] = STATE(1681),
    [sym_concatenated_string] = STATE(203),
    [sym_string] = STATE(204),
    [sym_await] = STATE(1681),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [1438] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_SLASH_SLASH] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [sym_type_conversion] = ACTIONS(2951),
    [sym_comment] = ACTIONS(73),
  },
  [1439] = {
    [aux_sym_dotted_name_repeat1] = STATE(1682),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(1170),
    [anon_sym_COMMA] = ACTIONS(1170),
    [anon_sym_as] = ACTIONS(1170),
    [sym_comment] = ACTIONS(73),
  },
  [1440] = {
    [sym__newline] = ACTIONS(3640),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3640),
  },
  [1441] = {
    [sym_aliased_import] = STATE(1683),
    [sym_dotted_name] = STATE(1684),
    [anon_sym_RPAREN] = ACTIONS(1172),
    [sym_identifier] = ACTIONS(2125),
    [sym_comment] = ACTIONS(73),
  },
  [1442] = {
    [aux_sym__import_list_repeat1] = STATE(1686),
    [anon_sym_RPAREN] = ACTIONS(1172),
    [anon_sym_COMMA] = ACTIONS(3642),
    [sym_comment] = ACTIONS(73),
  },
  [1443] = {
    [sym_identifier] = ACTIONS(3644),
    [sym_comment] = ACTIONS(73),
  },
  [1444] = {
    [anon_sym_DOT] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_RPAREN] = ACTIONS(3105),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_as] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_GT_GT] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3105),
    [anon_sym_else] = ACTIONS(3105),
    [anon_sym_async] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_in] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3105),
    [anon_sym_not] = ACTIONS(3105),
    [anon_sym_and] = ACTIONS(3105),
    [anon_sym_or] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_SLASH] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_SLASH_SLASH] = ACTIONS(3105),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_PIPE] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_CARET] = ACTIONS(3105),
    [anon_sym_LT_LT] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3107),
    [anon_sym_LT_EQ] = ACTIONS(3105),
    [anon_sym_EQ_EQ] = ACTIONS(3105),
    [anon_sym_BANG_EQ] = ACTIONS(3105),
    [anon_sym_GT_EQ] = ACTIONS(3105),
    [anon_sym_GT] = ACTIONS(3107),
    [anon_sym_LT_GT] = ACTIONS(3105),
    [anon_sym_is] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_RBRACK] = ACTIONS(3105),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [sym_type_conversion] = ACTIONS(3105),
    [sym_comment] = ACTIONS(73),
  },
  [1445] = {
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1446] = {
    [sym__expression] = STATE(1688),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1688),
    [sym_boolean_operator] = STATE(1688),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1688),
    [sym_lambda] = STATE(1688),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1688),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1688),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1447] = {
    [sym__expression] = STATE(1090),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1090),
    [sym_boolean_operator] = STATE(1090),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1090),
    [sym_lambda] = STATE(1090),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1090),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1090),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1448] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(1221),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_SLASH_SLASH] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1449] = {
    [anon_sym_DOT] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_RPAREN] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_as] = ACTIONS(3404),
    [anon_sym_STAR] = ACTIONS(3404),
    [anon_sym_GT_GT] = ACTIONS(3402),
    [anon_sym_if] = ACTIONS(3402),
    [anon_sym_COLON] = ACTIONS(3402),
    [anon_sym_else] = ACTIONS(3402),
    [anon_sym_async] = ACTIONS(3402),
    [anon_sym_for] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3402),
    [anon_sym_EQ] = ACTIONS(3404),
    [anon_sym_AT] = ACTIONS(3402),
    [anon_sym_not] = ACTIONS(3402),
    [anon_sym_and] = ACTIONS(3402),
    [anon_sym_or] = ACTIONS(3402),
    [anon_sym_PLUS] = ACTIONS(3402),
    [anon_sym_DASH] = ACTIONS(3402),
    [anon_sym_SLASH] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3402),
    [anon_sym_SLASH_SLASH] = ACTIONS(3402),
    [anon_sym_STAR_STAR] = ACTIONS(3402),
    [anon_sym_PIPE] = ACTIONS(3402),
    [anon_sym_AMP] = ACTIONS(3402),
    [anon_sym_CARET] = ACTIONS(3402),
    [anon_sym_LT_LT] = ACTIONS(3402),
    [anon_sym_LT] = ACTIONS(3404),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_GT] = ACTIONS(3404),
    [anon_sym_LT_GT] = ACTIONS(3402),
    [anon_sym_is] = ACTIONS(3402),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_RBRACK] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [sym_type_conversion] = ACTIONS(3402),
    [sym_comment] = ACTIONS(73),
  },
  [1450] = {
    [anon_sym_DOT] = ACTIONS(3467),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_RPAREN] = ACTIONS(3467),
    [anon_sym_COMMA] = ACTIONS(3467),
    [anon_sym_as] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_GT_GT] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_COLON] = ACTIONS(3467),
    [anon_sym_else] = ACTIONS(3467),
    [anon_sym_async] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3467),
    [anon_sym_EQ] = ACTIONS(3469),
    [anon_sym_AT] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_and] = ACTIONS(3467),
    [anon_sym_or] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_SLASH] = ACTIONS(3469),
    [anon_sym_PERCENT] = ACTIONS(3467),
    [anon_sym_SLASH_SLASH] = ACTIONS(3467),
    [anon_sym_STAR_STAR] = ACTIONS(3467),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_CARET] = ACTIONS(3467),
    [anon_sym_LT_LT] = ACTIONS(3467),
    [anon_sym_LT] = ACTIONS(3469),
    [anon_sym_LT_EQ] = ACTIONS(3467),
    [anon_sym_EQ_EQ] = ACTIONS(3467),
    [anon_sym_BANG_EQ] = ACTIONS(3467),
    [anon_sym_GT_EQ] = ACTIONS(3467),
    [anon_sym_GT] = ACTIONS(3469),
    [anon_sym_LT_GT] = ACTIONS(3467),
    [anon_sym_is] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_RBRACK] = ACTIONS(3467),
    [anon_sym_RBRACE] = ACTIONS(3467),
    [sym_type_conversion] = ACTIONS(3467),
    [sym_comment] = ACTIONS(73),
  },
  [1451] = {
    [anon_sym_DOT] = ACTIONS(3471),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_RPAREN] = ACTIONS(3471),
    [anon_sym_COMMA] = ACTIONS(3471),
    [anon_sym_as] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_GT_GT] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_COLON] = ACTIONS(3471),
    [anon_sym_else] = ACTIONS(3471),
    [anon_sym_async] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3471),
    [anon_sym_EQ] = ACTIONS(3473),
    [anon_sym_AT] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_and] = ACTIONS(3471),
    [anon_sym_or] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_SLASH] = ACTIONS(3473),
    [anon_sym_PERCENT] = ACTIONS(3471),
    [anon_sym_SLASH_SLASH] = ACTIONS(3471),
    [anon_sym_STAR_STAR] = ACTIONS(3471),
    [anon_sym_PIPE] = ACTIONS(3471),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_CARET] = ACTIONS(3471),
    [anon_sym_LT_LT] = ACTIONS(3471),
    [anon_sym_LT] = ACTIONS(3473),
    [anon_sym_LT_EQ] = ACTIONS(3471),
    [anon_sym_EQ_EQ] = ACTIONS(3471),
    [anon_sym_BANG_EQ] = ACTIONS(3471),
    [anon_sym_GT_EQ] = ACTIONS(3471),
    [anon_sym_GT] = ACTIONS(3473),
    [anon_sym_LT_GT] = ACTIONS(3471),
    [anon_sym_is] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_RBRACK] = ACTIONS(3471),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [sym_type_conversion] = ACTIONS(3471),
    [sym_comment] = ACTIONS(73),
  },
  [1452] = {
    [anon_sym_RPAREN] = ACTIONS(3574),
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(3574),
    [anon_sym_for] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [1453] = {
    [sym__expression_within_for_in_clause] = STATE(1689),
    [sym__expression] = STATE(1456),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(1456),
    [sym_boolean_operator] = STATE(1456),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(1456),
    [sym_lambda] = STATE(1456),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(1456),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(1456),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1454] = {
    [sym_lambda_parameters] = STATE(1691),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1455] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1693),
    [anon_sym_RPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3650),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_async] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3648),
    [sym_comment] = ACTIONS(73),
  },
  [1456] = {
    [anon_sym_RPAREN] = ACTIONS(3652),
    [anon_sym_COMMA] = ACTIONS(3652),
    [anon_sym_if] = ACTIONS(3652),
    [anon_sym_async] = ACTIONS(3652),
    [anon_sym_for] = ACTIONS(3652),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(447),
    [sym_comment] = ACTIONS(73),
  },
  [1457] = {
    [anon_sym_RPAREN] = ACTIONS(3654),
    [anon_sym_COMMA] = ACTIONS(3654),
    [anon_sym_if] = ACTIONS(3654),
    [anon_sym_async] = ACTIONS(3654),
    [anon_sym_for] = ACTIONS(3654),
    [anon_sym_RBRACK] = ACTIONS(3654),
    [anon_sym_RBRACE] = ACTIONS(3654),
    [sym_comment] = ACTIONS(73),
  },
  [1458] = {
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3068),
    [sym_comment] = ACTIONS(73),
  },
  [1459] = {
    [sym__expression] = STATE(1694),
    [sym__primary_expression] = STATE(1122),
    [sym_not_operator] = STATE(1694),
    [sym_boolean_operator] = STATE(1694),
    [sym_binary_operator] = STATE(1122),
    [sym_unary_operator] = STATE(1122),
    [sym_comparison_operator] = STATE(1694),
    [sym_lambda] = STATE(1694),
    [sym_attribute] = STATE(1122),
    [sym_subscript] = STATE(1122),
    [sym_call] = STATE(1122),
    [sym_list] = STATE(1122),
    [sym_list_comprehension] = STATE(1122),
    [sym_dictionary] = STATE(1122),
    [sym_dictionary_comprehension] = STATE(1122),
    [sym_set] = STATE(1122),
    [sym_set_comprehension] = STATE(1122),
    [sym_parenthesized_expression] = STATE(1122),
    [sym_tuple] = STATE(1122),
    [sym_generator_expression] = STATE(1122),
    [sym_conditional_expression] = STATE(1694),
    [sym_concatenated_string] = STATE(1122),
    [sym_string] = STATE(1123),
    [sym_await] = STATE(1694),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_lambda] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2215),
    [sym_float] = ACTIONS(2215),
    [sym_identifier] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_none] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2217),
    [sym_comment] = ACTIONS(73),
  },
  [1460] = {
    [anon_sym_COLON] = ACTIONS(3656),
    [sym_comment] = ACTIONS(73),
  },
  [1461] = {
    [sym__expression] = STATE(1696),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1696),
    [sym_boolean_operator] = STATE(1696),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1696),
    [sym_lambda] = STATE(1696),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1696),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1696),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1462] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(1122),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(1122),
    [sym_unary_operator] = STATE(1122),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(1122),
    [sym_subscript] = STATE(1122),
    [sym_call] = STATE(1122),
    [sym_list] = STATE(1122),
    [sym_list_comprehension] = STATE(1122),
    [sym_dictionary] = STATE(1122),
    [sym_dictionary_comprehension] = STATE(1122),
    [sym_set] = STATE(1122),
    [sym_set_comprehension] = STATE(1122),
    [sym_parenthesized_expression] = STATE(1122),
    [sym_tuple] = STATE(1122),
    [sym_generator_expression] = STATE(1122),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(1122),
    [sym_string] = STATE(1123),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_lambda] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2215),
    [sym_float] = ACTIONS(2215),
    [sym_identifier] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_none] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2217),
    [sym_comment] = ACTIONS(73),
  },
  [1463] = {
    [sym__expression] = STATE(1697),
    [sym__primary_expression] = STATE(1122),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1122),
    [sym_unary_operator] = STATE(1122),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_attribute] = STATE(1122),
    [sym_subscript] = STATE(1122),
    [sym_call] = STATE(1122),
    [sym_list] = STATE(1122),
    [sym_list_comprehension] = STATE(1122),
    [sym_dictionary] = STATE(1122),
    [sym_dictionary_comprehension] = STATE(1122),
    [sym_set] = STATE(1122),
    [sym_set_comprehension] = STATE(1122),
    [sym_parenthesized_expression] = STATE(1122),
    [sym_tuple] = STATE(1122),
    [sym_generator_expression] = STATE(1122),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1122),
    [sym_string] = STATE(1123),
    [sym_await] = STATE(1697),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_lambda] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2215),
    [sym_float] = ACTIONS(2215),
    [sym_identifier] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_none] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2217),
    [sym_comment] = ACTIONS(73),
  },
  [1464] = {
    [sym__primary_expression] = STATE(1698),
    [sym_binary_operator] = STATE(1698),
    [sym_unary_operator] = STATE(1698),
    [sym_attribute] = STATE(1698),
    [sym_subscript] = STATE(1698),
    [sym_call] = STATE(1698),
    [sym_list] = STATE(1698),
    [sym_list_comprehension] = STATE(1698),
    [sym_dictionary] = STATE(1698),
    [sym_dictionary_comprehension] = STATE(1698),
    [sym_set] = STATE(1698),
    [sym_set_comprehension] = STATE(1698),
    [sym_parenthesized_expression] = STATE(1698),
    [sym_tuple] = STATE(1698),
    [sym_generator_expression] = STATE(1698),
    [sym_concatenated_string] = STATE(1698),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3660),
    [sym_float] = ACTIONS(3660),
    [sym_identifier] = ACTIONS(3660),
    [sym_true] = ACTIONS(3660),
    [sym_false] = ACTIONS(3660),
    [sym_none] = ACTIONS(3660),
    [sym_comment] = ACTIONS(73),
  },
  [1465] = {
    [sym__primary_expression] = STATE(1699),
    [sym_binary_operator] = STATE(1699),
    [sym_unary_operator] = STATE(1699),
    [sym_attribute] = STATE(1699),
    [sym_subscript] = STATE(1699),
    [sym_call] = STATE(1699),
    [sym_list] = STATE(1699),
    [sym_list_comprehension] = STATE(1699),
    [sym_dictionary] = STATE(1699),
    [sym_dictionary_comprehension] = STATE(1699),
    [sym_set] = STATE(1699),
    [sym_set_comprehension] = STATE(1699),
    [sym_parenthesized_expression] = STATE(1699),
    [sym_tuple] = STATE(1699),
    [sym_generator_expression] = STATE(1699),
    [sym_concatenated_string] = STATE(1699),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3664),
    [sym_float] = ACTIONS(3664),
    [sym_identifier] = ACTIONS(3664),
    [sym_true] = ACTIONS(3664),
    [sym_false] = ACTIONS(3664),
    [sym_none] = ACTIONS(3664),
    [sym_comment] = ACTIONS(73),
  },
  [1466] = {
    [sym__primary_expression] = STATE(1700),
    [sym_binary_operator] = STATE(1700),
    [sym_unary_operator] = STATE(1700),
    [sym_attribute] = STATE(1700),
    [sym_subscript] = STATE(1700),
    [sym_call] = STATE(1700),
    [sym_list] = STATE(1700),
    [sym_list_comprehension] = STATE(1700),
    [sym_dictionary] = STATE(1700),
    [sym_dictionary_comprehension] = STATE(1700),
    [sym_set] = STATE(1700),
    [sym_set_comprehension] = STATE(1700),
    [sym_parenthesized_expression] = STATE(1700),
    [sym_tuple] = STATE(1700),
    [sym_generator_expression] = STATE(1700),
    [sym_concatenated_string] = STATE(1700),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3666),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3668),
    [sym_float] = ACTIONS(3668),
    [sym_identifier] = ACTIONS(3668),
    [sym_true] = ACTIONS(3668),
    [sym_false] = ACTIONS(3668),
    [sym_none] = ACTIONS(3668),
    [sym_comment] = ACTIONS(73),
  },
  [1467] = {
    [anon_sym_in] = ACTIONS(3670),
    [sym_comment] = ACTIONS(73),
  },
  [1468] = {
    [sym__primary_expression] = STATE(1702),
    [sym_binary_operator] = STATE(1702),
    [sym_unary_operator] = STATE(1702),
    [sym_attribute] = STATE(1702),
    [sym_subscript] = STATE(1702),
    [sym_call] = STATE(1702),
    [sym_list] = STATE(1702),
    [sym_list_comprehension] = STATE(1702),
    [sym_dictionary] = STATE(1702),
    [sym_dictionary_comprehension] = STATE(1702),
    [sym_set] = STATE(1702),
    [sym_set_comprehension] = STATE(1702),
    [sym_parenthesized_expression] = STATE(1702),
    [sym_tuple] = STATE(1702),
    [sym_generator_expression] = STATE(1702),
    [sym_concatenated_string] = STATE(1702),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3674),
    [sym_float] = ACTIONS(3674),
    [sym_identifier] = ACTIONS(3674),
    [sym_true] = ACTIONS(3674),
    [sym_false] = ACTIONS(3674),
    [sym_none] = ACTIONS(3674),
    [sym_comment] = ACTIONS(73),
  },
  [1469] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [1470] = {
    [sym__primary_expression] = STATE(1703),
    [sym_binary_operator] = STATE(1703),
    [sym_unary_operator] = STATE(1703),
    [sym_attribute] = STATE(1703),
    [sym_subscript] = STATE(1703),
    [sym_call] = STATE(1703),
    [sym_list] = STATE(1703),
    [sym_list_comprehension] = STATE(1703),
    [sym_dictionary] = STATE(1703),
    [sym_dictionary_comprehension] = STATE(1703),
    [sym_set] = STATE(1703),
    [sym_set_comprehension] = STATE(1703),
    [sym_parenthesized_expression] = STATE(1703),
    [sym_tuple] = STATE(1703),
    [sym_generator_expression] = STATE(1703),
    [sym_concatenated_string] = STATE(1703),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3678),
    [sym_float] = ACTIONS(3678),
    [sym_identifier] = ACTIONS(3678),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_none] = ACTIONS(3678),
    [sym_comment] = ACTIONS(73),
  },
  [1471] = {
    [sym__primary_expression] = STATE(1704),
    [sym_binary_operator] = STATE(1704),
    [sym_unary_operator] = STATE(1704),
    [sym_attribute] = STATE(1704),
    [sym_subscript] = STATE(1704),
    [sym_call] = STATE(1704),
    [sym_list] = STATE(1704),
    [sym_list_comprehension] = STATE(1704),
    [sym_dictionary] = STATE(1704),
    [sym_dictionary_comprehension] = STATE(1704),
    [sym_set] = STATE(1704),
    [sym_set_comprehension] = STATE(1704),
    [sym_parenthesized_expression] = STATE(1704),
    [sym_tuple] = STATE(1704),
    [sym_generator_expression] = STATE(1704),
    [sym_concatenated_string] = STATE(1704),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3680),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3682),
    [sym_float] = ACTIONS(3682),
    [sym_identifier] = ACTIONS(3682),
    [sym_true] = ACTIONS(3682),
    [sym_false] = ACTIONS(3682),
    [sym_none] = ACTIONS(3682),
    [sym_comment] = ACTIONS(73),
  },
  [1472] = {
    [sym__primary_expression] = STATE(1705),
    [sym_binary_operator] = STATE(1705),
    [sym_unary_operator] = STATE(1705),
    [sym_attribute] = STATE(1705),
    [sym_subscript] = STATE(1705),
    [sym_call] = STATE(1705),
    [sym_list] = STATE(1705),
    [sym_list_comprehension] = STATE(1705),
    [sym_dictionary] = STATE(1705),
    [sym_dictionary_comprehension] = STATE(1705),
    [sym_set] = STATE(1705),
    [sym_set_comprehension] = STATE(1705),
    [sym_parenthesized_expression] = STATE(1705),
    [sym_tuple] = STATE(1705),
    [sym_generator_expression] = STATE(1705),
    [sym_concatenated_string] = STATE(1705),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3686),
    [sym_float] = ACTIONS(3686),
    [sym_identifier] = ACTIONS(3686),
    [sym_true] = ACTIONS(3686),
    [sym_false] = ACTIONS(3686),
    [sym_none] = ACTIONS(3686),
    [sym_comment] = ACTIONS(73),
  },
  [1473] = {
    [sym__primary_expression] = STATE(1700),
    [sym_binary_operator] = STATE(1700),
    [sym_unary_operator] = STATE(1700),
    [sym_attribute] = STATE(1700),
    [sym_subscript] = STATE(1700),
    [sym_call] = STATE(1700),
    [sym_list] = STATE(1700),
    [sym_list_comprehension] = STATE(1700),
    [sym_dictionary] = STATE(1700),
    [sym_dictionary_comprehension] = STATE(1700),
    [sym_set] = STATE(1700),
    [sym_set_comprehension] = STATE(1700),
    [sym_parenthesized_expression] = STATE(1700),
    [sym_tuple] = STATE(1700),
    [sym_generator_expression] = STATE(1700),
    [sym_concatenated_string] = STATE(1700),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3666),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3668),
    [sym_float] = ACTIONS(3668),
    [sym_identifier] = ACTIONS(3668),
    [sym_true] = ACTIONS(3668),
    [sym_false] = ACTIONS(3668),
    [sym_none] = ACTIONS(3668),
    [sym_comment] = ACTIONS(73),
  },
  [1474] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1706),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_async] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(3074),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_LT_EQ] = ACTIONS(3074),
    [anon_sym_EQ_EQ] = ACTIONS(3074),
    [anon_sym_BANG_EQ] = ACTIONS(3074),
    [anon_sym_GT_EQ] = ACTIONS(3074),
    [anon_sym_GT] = ACTIONS(3090),
    [anon_sym_LT_GT] = ACTIONS(3074),
    [anon_sym_is] = ACTIONS(3092),
    [sym_comment] = ACTIONS(73),
  },
  [1475] = {
    [sym_string] = STATE(1707),
    [aux_sym_concatenated_string_repeat1] = STATE(1707),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_RPAREN] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [1476] = {
    [anon_sym_DOT] = ACTIONS(3596),
    [anon_sym_LPAREN] = ACTIONS(3596),
    [anon_sym_RPAREN] = ACTIONS(3596),
    [anon_sym_COMMA] = ACTIONS(3596),
    [anon_sym_as] = ACTIONS(3598),
    [anon_sym_STAR] = ACTIONS(3598),
    [anon_sym_GT_GT] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(3596),
    [anon_sym_COLON] = ACTIONS(3596),
    [anon_sym_else] = ACTIONS(3596),
    [anon_sym_async] = ACTIONS(3596),
    [anon_sym_for] = ACTIONS(3596),
    [anon_sym_in] = ACTIONS(3596),
    [anon_sym_EQ] = ACTIONS(3598),
    [anon_sym_AT] = ACTIONS(3596),
    [anon_sym_not] = ACTIONS(3596),
    [anon_sym_and] = ACTIONS(3596),
    [anon_sym_or] = ACTIONS(3596),
    [anon_sym_PLUS] = ACTIONS(3596),
    [anon_sym_DASH] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3596),
    [anon_sym_SLASH_SLASH] = ACTIONS(3596),
    [anon_sym_STAR_STAR] = ACTIONS(3596),
    [anon_sym_PIPE] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(3596),
    [anon_sym_CARET] = ACTIONS(3596),
    [anon_sym_LT_LT] = ACTIONS(3596),
    [anon_sym_LT] = ACTIONS(3598),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_EQ_EQ] = ACTIONS(3596),
    [anon_sym_BANG_EQ] = ACTIONS(3596),
    [anon_sym_GT_EQ] = ACTIONS(3596),
    [anon_sym_GT] = ACTIONS(3598),
    [anon_sym_LT_GT] = ACTIONS(3596),
    [anon_sym_is] = ACTIONS(3596),
    [anon_sym_LBRACK] = ACTIONS(3596),
    [anon_sym_RBRACK] = ACTIONS(3596),
    [anon_sym_RBRACE] = ACTIONS(3596),
    [sym_type_conversion] = ACTIONS(3596),
    [sym_comment] = ACTIONS(73),
  },
  [1477] = {
    [sym_list_splat] = STATE(1410),
    [sym_dictionary_splat] = STATE(1410),
    [sym__expression] = STATE(1411),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1411),
    [sym_boolean_operator] = STATE(1411),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1411),
    [sym_lambda] = STATE(1411),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_keyword_argument] = STATE(1410),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1411),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1411),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3690),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1478] = {
    [anon_sym_DOT] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3609),
    [anon_sym_COMMA] = ACTIONS(3609),
    [anon_sym_as] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_GT_GT] = ACTIONS(3609),
    [anon_sym_if] = ACTIONS(3609),
    [anon_sym_COLON] = ACTIONS(3609),
    [anon_sym_else] = ACTIONS(3609),
    [anon_sym_async] = ACTIONS(3609),
    [anon_sym_for] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3609),
    [anon_sym_EQ] = ACTIONS(3611),
    [anon_sym_AT] = ACTIONS(3609),
    [anon_sym_not] = ACTIONS(3609),
    [anon_sym_and] = ACTIONS(3609),
    [anon_sym_or] = ACTIONS(3609),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3609),
    [anon_sym_SLASH_SLASH] = ACTIONS(3609),
    [anon_sym_STAR_STAR] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_LT_LT] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_LT_EQ] = ACTIONS(3609),
    [anon_sym_EQ_EQ] = ACTIONS(3609),
    [anon_sym_BANG_EQ] = ACTIONS(3609),
    [anon_sym_GT_EQ] = ACTIONS(3609),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_LT_GT] = ACTIONS(3609),
    [anon_sym_is] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_RBRACK] = ACTIONS(3609),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [sym_type_conversion] = ACTIONS(3609),
    [sym_comment] = ACTIONS(73),
  },
  [1479] = {
    [sym__expression] = STATE(1419),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1419),
    [sym_boolean_operator] = STATE(1419),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1419),
    [sym_lambda] = STATE(1419),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_slice] = STATE(1420),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1419),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3692),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1480] = {
    [sym__newline] = ACTIONS(3105),
    [anon_sym_DOT] = ACTIONS(3105),
    [anon_sym_from] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_GT_GT] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_in] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3105),
    [anon_sym_not] = ACTIONS(3105),
    [anon_sym_and] = ACTIONS(3105),
    [anon_sym_or] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_SLASH] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_SLASH_SLASH] = ACTIONS(3105),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_PIPE] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_CARET] = ACTIONS(3105),
    [anon_sym_LT_LT] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3107),
    [anon_sym_LT_EQ] = ACTIONS(3105),
    [anon_sym_EQ_EQ] = ACTIONS(3105),
    [anon_sym_BANG_EQ] = ACTIONS(3105),
    [anon_sym_GT_EQ] = ACTIONS(3105),
    [anon_sym_GT] = ACTIONS(3107),
    [anon_sym_LT_GT] = ACTIONS(3105),
    [anon_sym_is] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3105),
  },
  [1481] = {
    [sym__newline] = ACTIONS(3402),
    [anon_sym_DOT] = ACTIONS(3402),
    [anon_sym_from] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_STAR] = ACTIONS(3404),
    [anon_sym_GT_GT] = ACTIONS(3402),
    [anon_sym_if] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3402),
    [anon_sym_EQ] = ACTIONS(3404),
    [anon_sym_AT] = ACTIONS(3402),
    [anon_sym_not] = ACTIONS(3402),
    [anon_sym_and] = ACTIONS(3402),
    [anon_sym_or] = ACTIONS(3402),
    [anon_sym_PLUS] = ACTIONS(3402),
    [anon_sym_DASH] = ACTIONS(3402),
    [anon_sym_SLASH] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3402),
    [anon_sym_SLASH_SLASH] = ACTIONS(3402),
    [anon_sym_STAR_STAR] = ACTIONS(3402),
    [anon_sym_PIPE] = ACTIONS(3402),
    [anon_sym_AMP] = ACTIONS(3402),
    [anon_sym_CARET] = ACTIONS(3402),
    [anon_sym_LT_LT] = ACTIONS(3402),
    [anon_sym_LT] = ACTIONS(3404),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_GT] = ACTIONS(3404),
    [anon_sym_LT_GT] = ACTIONS(3402),
    [anon_sym_is] = ACTIONS(3402),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3402),
  },
  [1482] = {
    [sym__newline] = ACTIONS(3467),
    [anon_sym_DOT] = ACTIONS(3467),
    [anon_sym_from] = ACTIONS(3467),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_COMMA] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_GT_GT] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3467),
    [anon_sym_EQ] = ACTIONS(3469),
    [anon_sym_AT] = ACTIONS(3467),
    [anon_sym_not] = ACTIONS(3467),
    [anon_sym_and] = ACTIONS(3467),
    [anon_sym_or] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_SLASH] = ACTIONS(3469),
    [anon_sym_PERCENT] = ACTIONS(3467),
    [anon_sym_SLASH_SLASH] = ACTIONS(3467),
    [anon_sym_STAR_STAR] = ACTIONS(3467),
    [anon_sym_PIPE] = ACTIONS(3467),
    [anon_sym_AMP] = ACTIONS(3467),
    [anon_sym_CARET] = ACTIONS(3467),
    [anon_sym_LT_LT] = ACTIONS(3467),
    [anon_sym_LT] = ACTIONS(3469),
    [anon_sym_LT_EQ] = ACTIONS(3467),
    [anon_sym_EQ_EQ] = ACTIONS(3467),
    [anon_sym_BANG_EQ] = ACTIONS(3467),
    [anon_sym_GT_EQ] = ACTIONS(3467),
    [anon_sym_GT] = ACTIONS(3469),
    [anon_sym_LT_GT] = ACTIONS(3467),
    [anon_sym_is] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3467),
  },
  [1483] = {
    [sym__newline] = ACTIONS(3471),
    [anon_sym_DOT] = ACTIONS(3471),
    [anon_sym_from] = ACTIONS(3471),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_COMMA] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_GT_GT] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3471),
    [anon_sym_EQ] = ACTIONS(3473),
    [anon_sym_AT] = ACTIONS(3471),
    [anon_sym_not] = ACTIONS(3471),
    [anon_sym_and] = ACTIONS(3471),
    [anon_sym_or] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_SLASH] = ACTIONS(3473),
    [anon_sym_PERCENT] = ACTIONS(3471),
    [anon_sym_SLASH_SLASH] = ACTIONS(3471),
    [anon_sym_STAR_STAR] = ACTIONS(3471),
    [anon_sym_PIPE] = ACTIONS(3471),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_CARET] = ACTIONS(3471),
    [anon_sym_LT_LT] = ACTIONS(3471),
    [anon_sym_LT] = ACTIONS(3473),
    [anon_sym_LT_EQ] = ACTIONS(3471),
    [anon_sym_EQ_EQ] = ACTIONS(3471),
    [anon_sym_BANG_EQ] = ACTIONS(3471),
    [anon_sym_GT_EQ] = ACTIONS(3471),
    [anon_sym_GT] = ACTIONS(3473),
    [anon_sym_LT_GT] = ACTIONS(3471),
    [anon_sym_is] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3471),
  },
  [1484] = {
    [sym__newline] = ACTIONS(3574),
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_or] = ACTIONS(511),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3574),
  },
  [1485] = {
    [sym__newline] = ACTIONS(3596),
    [anon_sym_DOT] = ACTIONS(3596),
    [anon_sym_from] = ACTIONS(3596),
    [anon_sym_LPAREN] = ACTIONS(3596),
    [anon_sym_COMMA] = ACTIONS(3596),
    [anon_sym_STAR] = ACTIONS(3598),
    [anon_sym_GT_GT] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(3596),
    [anon_sym_in] = ACTIONS(3596),
    [anon_sym_EQ] = ACTIONS(3598),
    [anon_sym_AT] = ACTIONS(3596),
    [anon_sym_not] = ACTIONS(3596),
    [anon_sym_and] = ACTIONS(3596),
    [anon_sym_or] = ACTIONS(3596),
    [anon_sym_PLUS] = ACTIONS(3596),
    [anon_sym_DASH] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3596),
    [anon_sym_SLASH_SLASH] = ACTIONS(3596),
    [anon_sym_STAR_STAR] = ACTIONS(3596),
    [anon_sym_PIPE] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(3596),
    [anon_sym_CARET] = ACTIONS(3596),
    [anon_sym_LT_LT] = ACTIONS(3596),
    [anon_sym_LT] = ACTIONS(3598),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_EQ_EQ] = ACTIONS(3596),
    [anon_sym_BANG_EQ] = ACTIONS(3596),
    [anon_sym_GT_EQ] = ACTIONS(3596),
    [anon_sym_GT] = ACTIONS(3598),
    [anon_sym_LT_GT] = ACTIONS(3596),
    [anon_sym_is] = ACTIONS(3596),
    [anon_sym_LBRACK] = ACTIONS(3596),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3596),
  },
  [1486] = {
    [sym_list_splat] = STATE(1410),
    [sym_dictionary_splat] = STATE(1410),
    [sym__expression] = STATE(1411),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1411),
    [sym_boolean_operator] = STATE(1411),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1411),
    [sym_lambda] = STATE(1411),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_keyword_argument] = STATE(1410),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1411),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1411),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3694),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1487] = {
    [sym__newline] = ACTIONS(3609),
    [anon_sym_DOT] = ACTIONS(3609),
    [anon_sym_from] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_COMMA] = ACTIONS(3609),
    [anon_sym_STAR] = ACTIONS(3611),
    [anon_sym_GT_GT] = ACTIONS(3609),
    [anon_sym_if] = ACTIONS(3609),
    [anon_sym_in] = ACTIONS(3609),
    [anon_sym_EQ] = ACTIONS(3611),
    [anon_sym_AT] = ACTIONS(3609),
    [anon_sym_not] = ACTIONS(3609),
    [anon_sym_and] = ACTIONS(3609),
    [anon_sym_or] = ACTIONS(3609),
    [anon_sym_PLUS] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3611),
    [anon_sym_PERCENT] = ACTIONS(3609),
    [anon_sym_SLASH_SLASH] = ACTIONS(3609),
    [anon_sym_STAR_STAR] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_LT_LT] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(3611),
    [anon_sym_LT_EQ] = ACTIONS(3609),
    [anon_sym_EQ_EQ] = ACTIONS(3609),
    [anon_sym_BANG_EQ] = ACTIONS(3609),
    [anon_sym_GT_EQ] = ACTIONS(3609),
    [anon_sym_GT] = ACTIONS(3611),
    [anon_sym_LT_GT] = ACTIONS(3609),
    [anon_sym_is] = ACTIONS(3609),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3609),
  },
  [1488] = {
    [sym__expression] = STATE(1419),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1419),
    [sym_boolean_operator] = STATE(1419),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1419),
    [sym_lambda] = STATE(1419),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_slice] = STATE(1420),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1419),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3696),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1489] = {
    [sym__newline] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_and] = ACTIONS(1391),
    [anon_sym_or] = ACTIONS(1393),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2656),
  },
  [1490] = {
    [sym__expression] = STATE(1712),
    [sym__primary_expression] = STATE(325),
    [sym_not_operator] = STATE(1712),
    [sym_boolean_operator] = STATE(1712),
    [sym_binary_operator] = STATE(325),
    [sym_unary_operator] = STATE(325),
    [sym_comparison_operator] = STATE(1712),
    [sym_lambda] = STATE(1712),
    [sym_attribute] = STATE(325),
    [sym_subscript] = STATE(325),
    [sym_call] = STATE(325),
    [sym_list] = STATE(325),
    [sym_list_comprehension] = STATE(325),
    [sym_dictionary] = STATE(325),
    [sym_dictionary_comprehension] = STATE(325),
    [sym_set] = STATE(325),
    [sym_set_comprehension] = STATE(325),
    [sym_parenthesized_expression] = STATE(325),
    [sym_tuple] = STATE(325),
    [sym_generator_expression] = STATE(325),
    [sym_conditional_expression] = STATE(1712),
    [sym_concatenated_string] = STATE(325),
    [sym_string] = STATE(326),
    [sym_await] = STATE(1712),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [anon_sym_lambda] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(561),
    [sym_float] = ACTIONS(561),
    [sym_identifier] = ACTIONS(561),
    [sym_true] = ACTIONS(561),
    [sym_false] = ACTIONS(561),
    [sym_none] = ACTIONS(561),
    [anon_sym_await] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
  },
  [1491] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(2951),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_SLASH_SLASH] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2951),
  },
  [1492] = {
    [sym__newline] = ACTIONS(3574),
    [anon_sym_from] = ACTIONS(3574),
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(577),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3574),
  },
  [1493] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [1494] = {
    [sym__string_start] = ACTIONS(3189),
    [ts_builtin_sym_end] = ACTIONS(3189),
    [anon_sym_import] = ACTIONS(3698),
    [anon_sym_from] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3189),
    [anon_sym_print] = ACTIONS(3698),
    [anon_sym_assert] = ACTIONS(3698),
    [anon_sym_return] = ACTIONS(3698),
    [anon_sym_del] = ACTIONS(3698),
    [anon_sym_raise] = ACTIONS(3698),
    [anon_sym_pass] = ACTIONS(3698),
    [anon_sym_break] = ACTIONS(3698),
    [anon_sym_continue] = ACTIONS(3698),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_elif] = ACTIONS(3698),
    [anon_sym_else] = ACTIONS(3698),
    [anon_sym_async] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3698),
    [anon_sym_while] = ACTIONS(3698),
    [anon_sym_try] = ACTIONS(3698),
    [anon_sym_except] = ACTIONS(3698),
    [anon_sym_finally] = ACTIONS(3698),
    [anon_sym_with] = ACTIONS(3698),
    [anon_sym_def] = ACTIONS(3698),
    [anon_sym_global] = ACTIONS(3698),
    [anon_sym_nonlocal] = ACTIONS(3698),
    [anon_sym_exec] = ACTIONS(3698),
    [anon_sym_class] = ACTIONS(3698),
    [anon_sym_AT] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_TILDE] = ACTIONS(3189),
    [anon_sym_lambda] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3698),
    [anon_sym_LBRACK] = ACTIONS(3189),
    [sym_ellipsis] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [sym_integer] = ACTIONS(3698),
    [sym_float] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3698),
    [sym_true] = ACTIONS(3698),
    [sym_false] = ACTIONS(3698),
    [sym_none] = ACTIONS(3698),
    [anon_sym_await] = ACTIONS(3698),
    [sym_comment] = ACTIONS(73),
  },
  [1495] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [1496] = {
    [sym__simple_statements] = STATE(1714),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1714),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1497] = {
    [sym__string_start] = ACTIONS(3702),
    [ts_builtin_sym_end] = ACTIONS(3702),
    [anon_sym_import] = ACTIONS(3704),
    [anon_sym_from] = ACTIONS(3704),
    [anon_sym_LPAREN] = ACTIONS(3702),
    [anon_sym_print] = ACTIONS(3704),
    [anon_sym_assert] = ACTIONS(3704),
    [anon_sym_return] = ACTIONS(3704),
    [anon_sym_del] = ACTIONS(3704),
    [anon_sym_raise] = ACTIONS(3704),
    [anon_sym_pass] = ACTIONS(3704),
    [anon_sym_break] = ACTIONS(3704),
    [anon_sym_continue] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(3704),
    [anon_sym_async] = ACTIONS(3704),
    [anon_sym_for] = ACTIONS(3704),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_try] = ACTIONS(3704),
    [anon_sym_with] = ACTIONS(3704),
    [anon_sym_def] = ACTIONS(3704),
    [anon_sym_global] = ACTIONS(3704),
    [anon_sym_nonlocal] = ACTIONS(3704),
    [anon_sym_exec] = ACTIONS(3704),
    [anon_sym_class] = ACTIONS(3704),
    [anon_sym_AT] = ACTIONS(3702),
    [anon_sym_not] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3702),
    [anon_sym_DASH] = ACTIONS(3702),
    [anon_sym_TILDE] = ACTIONS(3702),
    [anon_sym_lambda] = ACTIONS(3704),
    [anon_sym_yield] = ACTIONS(3704),
    [anon_sym_LBRACK] = ACTIONS(3702),
    [sym_ellipsis] = ACTIONS(3702),
    [anon_sym_LBRACE] = ACTIONS(3702),
    [sym_integer] = ACTIONS(3704),
    [sym_float] = ACTIONS(3704),
    [sym_identifier] = ACTIONS(3704),
    [sym_true] = ACTIONS(3704),
    [sym_false] = ACTIONS(3704),
    [sym_none] = ACTIONS(3704),
    [anon_sym_await] = ACTIONS(3704),
    [sym_comment] = ACTIONS(73),
  },
  [1498] = {
    [sym_elif_clause] = STATE(1498),
    [aux_sym_if_statement_repeat1] = STATE(1498),
    [sym__string_start] = ACTIONS(3706),
    [ts_builtin_sym_end] = ACTIONS(3706),
    [anon_sym_import] = ACTIONS(3708),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3706),
    [anon_sym_print] = ACTIONS(3708),
    [anon_sym_assert] = ACTIONS(3708),
    [anon_sym_return] = ACTIONS(3708),
    [anon_sym_del] = ACTIONS(3708),
    [anon_sym_raise] = ACTIONS(3708),
    [anon_sym_pass] = ACTIONS(3708),
    [anon_sym_break] = ACTIONS(3708),
    [anon_sym_continue] = ACTIONS(3708),
    [anon_sym_if] = ACTIONS(3708),
    [anon_sym_elif] = ACTIONS(3710),
    [anon_sym_else] = ACTIONS(3708),
    [anon_sym_async] = ACTIONS(3708),
    [anon_sym_for] = ACTIONS(3708),
    [anon_sym_while] = ACTIONS(3708),
    [anon_sym_try] = ACTIONS(3708),
    [anon_sym_with] = ACTIONS(3708),
    [anon_sym_def] = ACTIONS(3708),
    [anon_sym_global] = ACTIONS(3708),
    [anon_sym_nonlocal] = ACTIONS(3708),
    [anon_sym_exec] = ACTIONS(3708),
    [anon_sym_class] = ACTIONS(3708),
    [anon_sym_AT] = ACTIONS(3706),
    [anon_sym_not] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_TILDE] = ACTIONS(3706),
    [anon_sym_lambda] = ACTIONS(3708),
    [anon_sym_yield] = ACTIONS(3708),
    [anon_sym_LBRACK] = ACTIONS(3706),
    [sym_ellipsis] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3706),
    [sym_integer] = ACTIONS(3708),
    [sym_float] = ACTIONS(3708),
    [sym_identifier] = ACTIONS(3708),
    [sym_true] = ACTIONS(3708),
    [sym_false] = ACTIONS(3708),
    [sym_none] = ACTIONS(3708),
    [anon_sym_await] = ACTIONS(3708),
    [sym_comment] = ACTIONS(73),
  },
  [1499] = {
    [sym__simple_statements] = STATE(1715),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1715),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1500] = {
    [sym__string_start] = ACTIONS(3713),
    [ts_builtin_sym_end] = ACTIONS(3713),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_from] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3713),
    [anon_sym_print] = ACTIONS(3715),
    [anon_sym_assert] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_del] = ACTIONS(3715),
    [anon_sym_raise] = ACTIONS(3715),
    [anon_sym_pass] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_with] = ACTIONS(3715),
    [anon_sym_def] = ACTIONS(3715),
    [anon_sym_global] = ACTIONS(3715),
    [anon_sym_nonlocal] = ACTIONS(3715),
    [anon_sym_exec] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_AT] = ACTIONS(3713),
    [anon_sym_not] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_lambda] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [sym_ellipsis] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [sym_integer] = ACTIONS(3715),
    [sym_float] = ACTIONS(3715),
    [sym_identifier] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_none] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [sym_comment] = ACTIONS(73),
  },
  [1501] = {
    [sym__string_start] = ACTIONS(3717),
    [ts_builtin_sym_end] = ACTIONS(3717),
    [anon_sym_import] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3717),
    [anon_sym_print] = ACTIONS(3719),
    [anon_sym_assert] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(3719),
    [anon_sym_del] = ACTIONS(3719),
    [anon_sym_raise] = ACTIONS(3719),
    [anon_sym_pass] = ACTIONS(3719),
    [anon_sym_break] = ACTIONS(3719),
    [anon_sym_continue] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_async] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_try] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [anon_sym_def] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(3719),
    [anon_sym_nonlocal] = ACTIONS(3719),
    [anon_sym_exec] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_AT] = ACTIONS(3717),
    [anon_sym_not] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_lambda] = ACTIONS(3719),
    [anon_sym_yield] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3717),
    [sym_ellipsis] = ACTIONS(3717),
    [anon_sym_LBRACE] = ACTIONS(3717),
    [sym_integer] = ACTIONS(3719),
    [sym_float] = ACTIONS(3719),
    [sym_identifier] = ACTIONS(3719),
    [sym_true] = ACTIONS(3719),
    [sym_false] = ACTIONS(3719),
    [sym_none] = ACTIONS(3719),
    [anon_sym_await] = ACTIONS(3719),
    [sym_comment] = ACTIONS(73),
  },
  [1502] = {
    [anon_sym_COLON] = ACTIONS(3721),
    [sym_comment] = ACTIONS(73),
  },
  [1503] = {
    [sym_else_clause] = STATE(1717),
    [sym__string_start] = ACTIONS(3723),
    [ts_builtin_sym_end] = ACTIONS(3723),
    [anon_sym_import] = ACTIONS(3725),
    [anon_sym_from] = ACTIONS(3725),
    [anon_sym_LPAREN] = ACTIONS(3723),
    [anon_sym_print] = ACTIONS(3725),
    [anon_sym_assert] = ACTIONS(3725),
    [anon_sym_return] = ACTIONS(3725),
    [anon_sym_del] = ACTIONS(3725),
    [anon_sym_raise] = ACTIONS(3725),
    [anon_sym_pass] = ACTIONS(3725),
    [anon_sym_break] = ACTIONS(3725),
    [anon_sym_continue] = ACTIONS(3725),
    [anon_sym_if] = ACTIONS(3725),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(3725),
    [anon_sym_for] = ACTIONS(3725),
    [anon_sym_while] = ACTIONS(3725),
    [anon_sym_try] = ACTIONS(3725),
    [anon_sym_with] = ACTIONS(3725),
    [anon_sym_def] = ACTIONS(3725),
    [anon_sym_global] = ACTIONS(3725),
    [anon_sym_nonlocal] = ACTIONS(3725),
    [anon_sym_exec] = ACTIONS(3725),
    [anon_sym_class] = ACTIONS(3725),
    [anon_sym_AT] = ACTIONS(3723),
    [anon_sym_not] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_TILDE] = ACTIONS(3723),
    [anon_sym_lambda] = ACTIONS(3725),
    [anon_sym_yield] = ACTIONS(3725),
    [anon_sym_LBRACK] = ACTIONS(3723),
    [sym_ellipsis] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3723),
    [sym_integer] = ACTIONS(3725),
    [sym_float] = ACTIONS(3725),
    [sym_identifier] = ACTIONS(3725),
    [sym_true] = ACTIONS(3725),
    [sym_false] = ACTIONS(3725),
    [sym_none] = ACTIONS(3725),
    [anon_sym_await] = ACTIONS(3725),
    [sym_comment] = ACTIONS(73),
  },
  [1504] = {
    [anon_sym_COMMA] = ACTIONS(1932),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(1932),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [1505] = {
    [sym__expression] = STATE(1504),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1504),
    [sym_boolean_operator] = STATE(1504),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1504),
    [sym_lambda] = STATE(1504),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1504),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(1504),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(1972),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [1506] = {
    [aux_sym_print_statement_repeat1] = STATE(1506),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_COLON] = ACTIONS(1932),
    [sym_comment] = ACTIONS(73),
  },
  [1507] = {
    [sym__simple_statements] = STATE(1720),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1720),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1508] = {
    [anon_sym_in] = ACTIONS(3732),
    [sym_comment] = ACTIONS(73),
  },
  [1509] = {
    [aux_sym_with_statement_repeat1] = STATE(1723),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(3734),
    [sym_comment] = ACTIONS(73),
  },
  [1510] = {
    [sym_parameters] = STATE(1724),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym_comment] = ACTIONS(73),
  },
  [1511] = {
    [sym_expression_list] = STATE(1725),
    [sym__expression] = STATE(775),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(775),
    [sym_boolean_operator] = STATE(775),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(775),
    [sym_lambda] = STATE(775),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(775),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(775),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [1512] = {
    [sym__simple_statements] = STATE(1726),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1726),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1513] = {
    [sym_except_clause] = STATE(1730),
    [sym_finally_clause] = STATE(1729),
    [aux_sym_try_statement_repeat1] = STATE(1730),
    [anon_sym_except] = ACTIONS(3736),
    [anon_sym_finally] = ACTIONS(3738),
    [sym_comment] = ACTIONS(73),
  },
  [1514] = {
    [sym__simple_statements] = STATE(1731),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1731),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1515] = {
    [aux_sym_with_statement_repeat1] = STATE(810),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(3734),
    [sym_comment] = ACTIONS(73),
  },
  [1516] = {
    [anon_sym_COLON] = ACTIONS(3740),
    [anon_sym_DASH_GT] = ACTIONS(3742),
    [sym_comment] = ACTIONS(73),
  },
  [1517] = {
    [sym__simple_statements] = STATE(1734),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1734),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1518] = {
    [anon_sym_COLON] = ACTIONS(3744),
    [sym_comment] = ACTIONS(73),
  },
  [1519] = {
    [sym__dedent] = ACTIONS(1877),
    [sym__string_start] = ACTIONS(1877),
    [anon_sym_import] = ACTIONS(1879),
    [anon_sym_from] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_print] = ACTIONS(1879),
    [anon_sym_assert] = ACTIONS(1879),
    [anon_sym_return] = ACTIONS(1879),
    [anon_sym_del] = ACTIONS(1879),
    [anon_sym_raise] = ACTIONS(1879),
    [anon_sym_pass] = ACTIONS(1879),
    [anon_sym_break] = ACTIONS(1879),
    [anon_sym_continue] = ACTIONS(1879),
    [anon_sym_if] = ACTIONS(1879),
    [anon_sym_elif] = ACTIONS(1879),
    [anon_sym_else] = ACTIONS(1879),
    [anon_sym_async] = ACTIONS(1879),
    [anon_sym_for] = ACTIONS(1879),
    [anon_sym_while] = ACTIONS(1879),
    [anon_sym_try] = ACTIONS(1879),
    [anon_sym_except] = ACTIONS(1879),
    [anon_sym_finally] = ACTIONS(1879),
    [anon_sym_with] = ACTIONS(1879),
    [anon_sym_def] = ACTIONS(1879),
    [anon_sym_global] = ACTIONS(1879),
    [anon_sym_nonlocal] = ACTIONS(1879),
    [anon_sym_exec] = ACTIONS(1879),
    [anon_sym_class] = ACTIONS(1879),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_not] = ACTIONS(1879),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_lambda] = ACTIONS(1879),
    [anon_sym_yield] = ACTIONS(1879),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [sym_ellipsis] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1877),
    [sym_integer] = ACTIONS(1879),
    [sym_float] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_true] = ACTIONS(1879),
    [sym_false] = ACTIONS(1879),
    [sym_none] = ACTIONS(1879),
    [anon_sym_await] = ACTIONS(1879),
    [sym_comment] = ACTIONS(73),
  },
  [1520] = {
    [sym_import_statement] = STATE(515),
    [sym_import_from_statement] = STATE(515),
    [sym_print_statement] = STATE(515),
    [sym_assert_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_delete_statement] = STATE(515),
    [sym_raise_statement] = STATE(515),
    [sym_pass_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_global_statement] = STATE(515),
    [sym_nonlocal_statement] = STATE(515),
    [sym_exec_statement] = STATE(515),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(3746),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1521] = {
    [anon_sym_except] = ACTIONS(2869),
    [anon_sym_finally] = ACTIONS(2869),
    [sym_comment] = ACTIONS(73),
  },
  [1522] = {
    [sym__string_start] = ACTIONS(3748),
    [ts_builtin_sym_end] = ACTIONS(3748),
    [anon_sym_import] = ACTIONS(3750),
    [anon_sym_from] = ACTIONS(3750),
    [anon_sym_LPAREN] = ACTIONS(3748),
    [anon_sym_print] = ACTIONS(3750),
    [anon_sym_assert] = ACTIONS(3750),
    [anon_sym_return] = ACTIONS(3750),
    [anon_sym_del] = ACTIONS(3750),
    [anon_sym_raise] = ACTIONS(3750),
    [anon_sym_pass] = ACTIONS(3750),
    [anon_sym_break] = ACTIONS(3750),
    [anon_sym_continue] = ACTIONS(3750),
    [anon_sym_if] = ACTIONS(3750),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_async] = ACTIONS(3750),
    [anon_sym_for] = ACTIONS(3750),
    [anon_sym_while] = ACTIONS(3750),
    [anon_sym_try] = ACTIONS(3750),
    [anon_sym_except] = ACTIONS(3750),
    [anon_sym_finally] = ACTIONS(3750),
    [anon_sym_with] = ACTIONS(3750),
    [anon_sym_def] = ACTIONS(3750),
    [anon_sym_global] = ACTIONS(3750),
    [anon_sym_nonlocal] = ACTIONS(3750),
    [anon_sym_exec] = ACTIONS(3750),
    [anon_sym_class] = ACTIONS(3750),
    [anon_sym_AT] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3748),
    [anon_sym_TILDE] = ACTIONS(3748),
    [anon_sym_lambda] = ACTIONS(3750),
    [anon_sym_yield] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3748),
    [sym_ellipsis] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3748),
    [sym_integer] = ACTIONS(3750),
    [sym_float] = ACTIONS(3750),
    [sym_identifier] = ACTIONS(3750),
    [sym_true] = ACTIONS(3750),
    [sym_false] = ACTIONS(3750),
    [sym_none] = ACTIONS(3750),
    [anon_sym_await] = ACTIONS(3750),
    [sym_comment] = ACTIONS(73),
  },
  [1523] = {
    [sym__expression] = STATE(1737),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1737),
    [sym_boolean_operator] = STATE(1737),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1737),
    [sym_lambda] = STATE(1737),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1737),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1737),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1524] = {
    [sym__simple_statements] = STATE(1738),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1738),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1525] = {
    [sym__string_start] = ACTIONS(3752),
    [ts_builtin_sym_end] = ACTIONS(3752),
    [anon_sym_import] = ACTIONS(3754),
    [anon_sym_from] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3752),
    [anon_sym_print] = ACTIONS(3754),
    [anon_sym_assert] = ACTIONS(3754),
    [anon_sym_return] = ACTIONS(3754),
    [anon_sym_del] = ACTIONS(3754),
    [anon_sym_raise] = ACTIONS(3754),
    [anon_sym_pass] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3754),
    [anon_sym_continue] = ACTIONS(3754),
    [anon_sym_if] = ACTIONS(3754),
    [anon_sym_async] = ACTIONS(3754),
    [anon_sym_for] = ACTIONS(3754),
    [anon_sym_while] = ACTIONS(3754),
    [anon_sym_try] = ACTIONS(3754),
    [anon_sym_with] = ACTIONS(3754),
    [anon_sym_def] = ACTIONS(3754),
    [anon_sym_global] = ACTIONS(3754),
    [anon_sym_nonlocal] = ACTIONS(3754),
    [anon_sym_exec] = ACTIONS(3754),
    [anon_sym_class] = ACTIONS(3754),
    [anon_sym_AT] = ACTIONS(3752),
    [anon_sym_not] = ACTIONS(3754),
    [anon_sym_PLUS] = ACTIONS(3752),
    [anon_sym_DASH] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [anon_sym_lambda] = ACTIONS(3754),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3752),
    [sym_ellipsis] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [sym_integer] = ACTIONS(3754),
    [sym_float] = ACTIONS(3754),
    [sym_identifier] = ACTIONS(3754),
    [sym_true] = ACTIONS(3754),
    [sym_false] = ACTIONS(3754),
    [sym_none] = ACTIONS(3754),
    [anon_sym_await] = ACTIONS(3754),
    [sym_comment] = ACTIONS(73),
  },
  [1526] = {
    [sym__string_start] = ACTIONS(3756),
    [ts_builtin_sym_end] = ACTIONS(3756),
    [anon_sym_import] = ACTIONS(3758),
    [anon_sym_from] = ACTIONS(3758),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_print] = ACTIONS(3758),
    [anon_sym_assert] = ACTIONS(3758),
    [anon_sym_return] = ACTIONS(3758),
    [anon_sym_del] = ACTIONS(3758),
    [anon_sym_raise] = ACTIONS(3758),
    [anon_sym_pass] = ACTIONS(3758),
    [anon_sym_break] = ACTIONS(3758),
    [anon_sym_continue] = ACTIONS(3758),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_async] = ACTIONS(3758),
    [anon_sym_for] = ACTIONS(3758),
    [anon_sym_while] = ACTIONS(3758),
    [anon_sym_try] = ACTIONS(3758),
    [anon_sym_with] = ACTIONS(3758),
    [anon_sym_def] = ACTIONS(3758),
    [anon_sym_global] = ACTIONS(3758),
    [anon_sym_nonlocal] = ACTIONS(3758),
    [anon_sym_exec] = ACTIONS(3758),
    [anon_sym_class] = ACTIONS(3758),
    [anon_sym_AT] = ACTIONS(3756),
    [anon_sym_not] = ACTIONS(3758),
    [anon_sym_PLUS] = ACTIONS(3756),
    [anon_sym_DASH] = ACTIONS(3756),
    [anon_sym_TILDE] = ACTIONS(3756),
    [anon_sym_lambda] = ACTIONS(3758),
    [anon_sym_yield] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(3756),
    [sym_ellipsis] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [sym_integer] = ACTIONS(3758),
    [sym_float] = ACTIONS(3758),
    [sym_identifier] = ACTIONS(3758),
    [sym_true] = ACTIONS(3758),
    [sym_false] = ACTIONS(3758),
    [sym_none] = ACTIONS(3758),
    [anon_sym_await] = ACTIONS(3758),
    [sym_comment] = ACTIONS(73),
  },
  [1527] = {
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_as] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_COLON] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(679),
    [sym_comment] = ACTIONS(73),
  },
  [1528] = {
    [anon_sym_RPAREN] = ACTIONS(2535),
    [anon_sym_COMMA] = ACTIONS(2535),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_COLON] = ACTIONS(2535),
    [anon_sym_and] = ACTIONS(3236),
    [anon_sym_or] = ACTIONS(3238),
    [sym_comment] = ACTIONS(73),
  },
  [1529] = {
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(3236),
    [anon_sym_or] = ACTIONS(3238),
    [sym_comment] = ACTIONS(73),
  },
  [1530] = {
    [sym__expression] = STATE(1739),
    [sym__primary_expression] = STATE(1226),
    [sym_not_operator] = STATE(1739),
    [sym_boolean_operator] = STATE(1739),
    [sym_binary_operator] = STATE(1226),
    [sym_unary_operator] = STATE(1226),
    [sym_comparison_operator] = STATE(1739),
    [sym_lambda] = STATE(1739),
    [sym_attribute] = STATE(1226),
    [sym_subscript] = STATE(1226),
    [sym_call] = STATE(1226),
    [sym_list] = STATE(1226),
    [sym_list_comprehension] = STATE(1226),
    [sym_dictionary] = STATE(1226),
    [sym_dictionary_comprehension] = STATE(1226),
    [sym_set] = STATE(1226),
    [sym_set_comprehension] = STATE(1226),
    [sym_parenthesized_expression] = STATE(1226),
    [sym_tuple] = STATE(1226),
    [sym_generator_expression] = STATE(1226),
    [sym_conditional_expression] = STATE(1739),
    [sym_concatenated_string] = STATE(1226),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(1739),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_lambda] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2502),
    [sym_float] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_none] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [sym_comment] = ACTIONS(73),
  },
  [1531] = {
    [anon_sym_COLON] = ACTIONS(3760),
    [sym_comment] = ACTIONS(73),
  },
  [1532] = {
    [sym__expression] = STATE(1741),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1741),
    [sym_boolean_operator] = STATE(1741),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1741),
    [sym_lambda] = STATE(1741),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1741),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1741),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1533] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(1226),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(1226),
    [sym_unary_operator] = STATE(1226),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(1226),
    [sym_subscript] = STATE(1226),
    [sym_call] = STATE(1226),
    [sym_list] = STATE(1226),
    [sym_list_comprehension] = STATE(1226),
    [sym_dictionary] = STATE(1226),
    [sym_dictionary_comprehension] = STATE(1226),
    [sym_set] = STATE(1226),
    [sym_set_comprehension] = STATE(1226),
    [sym_parenthesized_expression] = STATE(1226),
    [sym_tuple] = STATE(1226),
    [sym_generator_expression] = STATE(1226),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(1226),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_lambda] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2502),
    [sym_float] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_none] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [sym_comment] = ACTIONS(73),
  },
  [1534] = {
    [sym__expression] = STATE(1742),
    [sym__primary_expression] = STATE(1226),
    [sym_not_operator] = STATE(1742),
    [sym_boolean_operator] = STATE(1742),
    [sym_binary_operator] = STATE(1226),
    [sym_unary_operator] = STATE(1226),
    [sym_comparison_operator] = STATE(1742),
    [sym_lambda] = STATE(1742),
    [sym_attribute] = STATE(1226),
    [sym_subscript] = STATE(1226),
    [sym_call] = STATE(1226),
    [sym_list] = STATE(1226),
    [sym_list_comprehension] = STATE(1226),
    [sym_dictionary] = STATE(1226),
    [sym_dictionary_comprehension] = STATE(1226),
    [sym_set] = STATE(1226),
    [sym_set_comprehension] = STATE(1226),
    [sym_parenthesized_expression] = STATE(1226),
    [sym_tuple] = STATE(1226),
    [sym_generator_expression] = STATE(1226),
    [sym_conditional_expression] = STATE(1742),
    [sym_concatenated_string] = STATE(1226),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(1742),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_lambda] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2502),
    [sym_float] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_none] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [sym_comment] = ACTIONS(73),
  },
  [1535] = {
    [sym__primary_expression] = STATE(1743),
    [sym_binary_operator] = STATE(1743),
    [sym_unary_operator] = STATE(1743),
    [sym_attribute] = STATE(1743),
    [sym_subscript] = STATE(1743),
    [sym_call] = STATE(1743),
    [sym_list] = STATE(1743),
    [sym_list_comprehension] = STATE(1743),
    [sym_dictionary] = STATE(1743),
    [sym_dictionary_comprehension] = STATE(1743),
    [sym_set] = STATE(1743),
    [sym_set_comprehension] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1743),
    [sym_tuple] = STATE(1743),
    [sym_generator_expression] = STATE(1743),
    [sym_concatenated_string] = STATE(1743),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3762),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3764),
    [sym_float] = ACTIONS(3764),
    [sym_identifier] = ACTIONS(3764),
    [sym_true] = ACTIONS(3764),
    [sym_false] = ACTIONS(3764),
    [sym_none] = ACTIONS(3764),
    [sym_comment] = ACTIONS(73),
  },
  [1536] = {
    [sym__primary_expression] = STATE(1744),
    [sym_binary_operator] = STATE(1744),
    [sym_unary_operator] = STATE(1744),
    [sym_attribute] = STATE(1744),
    [sym_subscript] = STATE(1744),
    [sym_call] = STATE(1744),
    [sym_list] = STATE(1744),
    [sym_list_comprehension] = STATE(1744),
    [sym_dictionary] = STATE(1744),
    [sym_dictionary_comprehension] = STATE(1744),
    [sym_set] = STATE(1744),
    [sym_set_comprehension] = STATE(1744),
    [sym_parenthesized_expression] = STATE(1744),
    [sym_tuple] = STATE(1744),
    [sym_generator_expression] = STATE(1744),
    [sym_concatenated_string] = STATE(1744),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3766),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3768),
    [sym_float] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_true] = ACTIONS(3768),
    [sym_false] = ACTIONS(3768),
    [sym_none] = ACTIONS(3768),
    [sym_comment] = ACTIONS(73),
  },
  [1537] = {
    [sym__primary_expression] = STATE(1745),
    [sym_binary_operator] = STATE(1745),
    [sym_unary_operator] = STATE(1745),
    [sym_attribute] = STATE(1745),
    [sym_subscript] = STATE(1745),
    [sym_call] = STATE(1745),
    [sym_list] = STATE(1745),
    [sym_list_comprehension] = STATE(1745),
    [sym_dictionary] = STATE(1745),
    [sym_dictionary_comprehension] = STATE(1745),
    [sym_set] = STATE(1745),
    [sym_set_comprehension] = STATE(1745),
    [sym_parenthesized_expression] = STATE(1745),
    [sym_tuple] = STATE(1745),
    [sym_generator_expression] = STATE(1745),
    [sym_concatenated_string] = STATE(1745),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3770),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3772),
    [sym_float] = ACTIONS(3772),
    [sym_identifier] = ACTIONS(3772),
    [sym_true] = ACTIONS(3772),
    [sym_false] = ACTIONS(3772),
    [sym_none] = ACTIONS(3772),
    [sym_comment] = ACTIONS(73),
  },
  [1538] = {
    [anon_sym_in] = ACTIONS(3774),
    [sym_comment] = ACTIONS(73),
  },
  [1539] = {
    [sym__primary_expression] = STATE(1747),
    [sym_binary_operator] = STATE(1747),
    [sym_unary_operator] = STATE(1747),
    [sym_attribute] = STATE(1747),
    [sym_subscript] = STATE(1747),
    [sym_call] = STATE(1747),
    [sym_list] = STATE(1747),
    [sym_list_comprehension] = STATE(1747),
    [sym_dictionary] = STATE(1747),
    [sym_dictionary_comprehension] = STATE(1747),
    [sym_set] = STATE(1747),
    [sym_set_comprehension] = STATE(1747),
    [sym_parenthesized_expression] = STATE(1747),
    [sym_tuple] = STATE(1747),
    [sym_generator_expression] = STATE(1747),
    [sym_concatenated_string] = STATE(1747),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3778),
    [sym_float] = ACTIONS(3778),
    [sym_identifier] = ACTIONS(3778),
    [sym_true] = ACTIONS(3778),
    [sym_false] = ACTIONS(3778),
    [sym_none] = ACTIONS(3778),
    [sym_comment] = ACTIONS(73),
  },
  [1540] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [1541] = {
    [sym__primary_expression] = STATE(1748),
    [sym_binary_operator] = STATE(1748),
    [sym_unary_operator] = STATE(1748),
    [sym_attribute] = STATE(1748),
    [sym_subscript] = STATE(1748),
    [sym_call] = STATE(1748),
    [sym_list] = STATE(1748),
    [sym_list_comprehension] = STATE(1748),
    [sym_dictionary] = STATE(1748),
    [sym_dictionary_comprehension] = STATE(1748),
    [sym_set] = STATE(1748),
    [sym_set_comprehension] = STATE(1748),
    [sym_parenthesized_expression] = STATE(1748),
    [sym_tuple] = STATE(1748),
    [sym_generator_expression] = STATE(1748),
    [sym_concatenated_string] = STATE(1748),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3782),
    [sym_float] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3782),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_none] = ACTIONS(3782),
    [sym_comment] = ACTIONS(73),
  },
  [1542] = {
    [sym__primary_expression] = STATE(1749),
    [sym_binary_operator] = STATE(1749),
    [sym_unary_operator] = STATE(1749),
    [sym_attribute] = STATE(1749),
    [sym_subscript] = STATE(1749),
    [sym_call] = STATE(1749),
    [sym_list] = STATE(1749),
    [sym_list_comprehension] = STATE(1749),
    [sym_dictionary] = STATE(1749),
    [sym_dictionary_comprehension] = STATE(1749),
    [sym_set] = STATE(1749),
    [sym_set_comprehension] = STATE(1749),
    [sym_parenthesized_expression] = STATE(1749),
    [sym_tuple] = STATE(1749),
    [sym_generator_expression] = STATE(1749),
    [sym_concatenated_string] = STATE(1749),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3786),
    [sym_float] = ACTIONS(3786),
    [sym_identifier] = ACTIONS(3786),
    [sym_true] = ACTIONS(3786),
    [sym_false] = ACTIONS(3786),
    [sym_none] = ACTIONS(3786),
    [sym_comment] = ACTIONS(73),
  },
  [1543] = {
    [sym__primary_expression] = STATE(1750),
    [sym_binary_operator] = STATE(1750),
    [sym_unary_operator] = STATE(1750),
    [sym_attribute] = STATE(1750),
    [sym_subscript] = STATE(1750),
    [sym_call] = STATE(1750),
    [sym_list] = STATE(1750),
    [sym_list_comprehension] = STATE(1750),
    [sym_dictionary] = STATE(1750),
    [sym_dictionary_comprehension] = STATE(1750),
    [sym_set] = STATE(1750),
    [sym_set_comprehension] = STATE(1750),
    [sym_parenthesized_expression] = STATE(1750),
    [sym_tuple] = STATE(1750),
    [sym_generator_expression] = STATE(1750),
    [sym_concatenated_string] = STATE(1750),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3790),
    [sym_float] = ACTIONS(3790),
    [sym_identifier] = ACTIONS(3790),
    [sym_true] = ACTIONS(3790),
    [sym_false] = ACTIONS(3790),
    [sym_none] = ACTIONS(3790),
    [sym_comment] = ACTIONS(73),
  },
  [1544] = {
    [sym__primary_expression] = STATE(1745),
    [sym_binary_operator] = STATE(1745),
    [sym_unary_operator] = STATE(1745),
    [sym_attribute] = STATE(1745),
    [sym_subscript] = STATE(1745),
    [sym_call] = STATE(1745),
    [sym_list] = STATE(1745),
    [sym_list_comprehension] = STATE(1745),
    [sym_dictionary] = STATE(1745),
    [sym_dictionary_comprehension] = STATE(1745),
    [sym_set] = STATE(1745),
    [sym_set_comprehension] = STATE(1745),
    [sym_parenthesized_expression] = STATE(1745),
    [sym_tuple] = STATE(1745),
    [sym_generator_expression] = STATE(1745),
    [sym_concatenated_string] = STATE(1745),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3770),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3772),
    [sym_float] = ACTIONS(3772),
    [sym_identifier] = ACTIONS(3772),
    [sym_true] = ACTIONS(3772),
    [sym_false] = ACTIONS(3772),
    [sym_none] = ACTIONS(3772),
    [sym_comment] = ACTIONS(73),
  },
  [1545] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1751),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(3244),
    [anon_sym_not] = ACTIONS(3248),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_LT_EQ] = ACTIONS(3244),
    [anon_sym_EQ_EQ] = ACTIONS(3244),
    [anon_sym_BANG_EQ] = ACTIONS(3244),
    [anon_sym_GT_EQ] = ACTIONS(3244),
    [anon_sym_GT] = ACTIONS(3260),
    [anon_sym_LT_GT] = ACTIONS(3244),
    [anon_sym_is] = ACTIONS(3262),
    [sym_comment] = ACTIONS(73),
  },
  [1546] = {
    [sym_string] = STATE(1752),
    [aux_sym_concatenated_string_repeat1] = STATE(1752),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_RPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_COLON] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [1547] = {
    [anon_sym_RPAREN] = ACTIONS(2571),
    [anon_sym_COMMA] = ACTIONS(2571),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_EQ] = ACTIONS(2510),
    [sym_comment] = ACTIONS(73),
  },
  [1548] = {
    [anon_sym_RPAREN] = ACTIONS(2573),
    [anon_sym_COMMA] = ACTIONS(2573),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [sym_comment] = ACTIONS(73),
  },
  [1549] = {
    [anon_sym_RPAREN] = ACTIONS(2573),
    [anon_sym_COMMA] = ACTIONS(2573),
    [anon_sym_COLON] = ACTIONS(2520),
    [sym_comment] = ACTIONS(73),
  },
  [1550] = {
    [anon_sym_EQ] = ACTIONS(3794),
    [sym_comment] = ACTIONS(73),
  },
  [1551] = {
    [anon_sym_RPAREN] = ACTIONS(2609),
    [anon_sym_COMMA] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1552] = {
    [sym_default_parameter] = STATE(864),
    [sym_typed_default_parameter] = STATE(864),
    [sym_list_splat] = STATE(1549),
    [sym_dictionary_splat] = STATE(1549),
    [sym_typed_parameter] = STATE(864),
    [sym_tuple] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_print] = ACTIONS(3264),
    [anon_sym_exec] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3266),
    [sym_comment] = ACTIONS(73),
  },
  [1553] = {
    [aux_sym__parameters_repeat1] = STATE(1553),
    [anon_sym_RPAREN] = ACTIONS(2573),
    [anon_sym_COMMA] = ACTIONS(3796),
    [sym_comment] = ACTIONS(73),
  },
  [1554] = {
    [sym__expression] = STATE(1755),
    [sym__primary_expression] = STATE(1559),
    [sym_not_operator] = STATE(1755),
    [sym_boolean_operator] = STATE(1755),
    [sym_binary_operator] = STATE(1559),
    [sym_unary_operator] = STATE(1559),
    [sym_comparison_operator] = STATE(1755),
    [sym_lambda] = STATE(1755),
    [sym_attribute] = STATE(1559),
    [sym_subscript] = STATE(1559),
    [sym_call] = STATE(1559),
    [sym_list] = STATE(1559),
    [sym_list_comprehension] = STATE(1559),
    [sym_dictionary] = STATE(1559),
    [sym_dictionary_comprehension] = STATE(1559),
    [sym_set] = STATE(1559),
    [sym_set_comprehension] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1559),
    [sym_tuple] = STATE(1559),
    [sym_generator_expression] = STATE(1559),
    [sym_conditional_expression] = STATE(1755),
    [sym_concatenated_string] = STATE(1559),
    [sym_string] = STATE(1561),
    [sym_await] = STATE(1755),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_lambda] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3278),
    [sym_float] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_none] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3280),
    [sym_comment] = ACTIONS(73),
  },
  [1555] = {
    [sym__primary_expression] = STATE(225),
    [sym_binary_operator] = STATE(225),
    [sym_unary_operator] = STATE(225),
    [sym_attribute] = STATE(225),
    [sym_subscript] = STATE(225),
    [sym_call] = STATE(225),
    [sym_list] = STATE(225),
    [sym_list_comprehension] = STATE(225),
    [sym_dictionary] = STATE(225),
    [sym_dictionary_comprehension] = STATE(225),
    [sym_set] = STATE(225),
    [sym_set_comprehension] = STATE(225),
    [sym_parenthesized_expression] = STATE(225),
    [sym_tuple] = STATE(225),
    [sym_generator_expression] = STATE(225),
    [sym_concatenated_string] = STATE(225),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(409),
    [sym_float] = ACTIONS(409),
    [sym_identifier] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_none] = ACTIONS(409),
    [sym_comment] = ACTIONS(73),
  },
  [1556] = {
    [sym_lambda_parameters] = STATE(1757),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3799),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1557] = {
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(1559),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(1559),
    [sym_unary_operator] = STATE(1559),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(1559),
    [sym_subscript] = STATE(1559),
    [sym_call] = STATE(1559),
    [sym_list] = STATE(1559),
    [sym_list_comprehension] = STATE(1559),
    [sym_dictionary] = STATE(1559),
    [sym_dictionary_comprehension] = STATE(1559),
    [sym_set] = STATE(1559),
    [sym_set_comprehension] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1559),
    [sym_tuple] = STATE(1559),
    [sym_generator_expression] = STATE(1559),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(1559),
    [sym_string] = STATE(1561),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_lambda] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3278),
    [sym_float] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_none] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3280),
    [sym_comment] = ACTIONS(73),
  },
  [1558] = {
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(1890),
    [anon_sym_if] = ACTIONS(3801),
    [anon_sym_EQ] = ACTIONS(1890),
    [anon_sym_and] = ACTIONS(3803),
    [anon_sym_or] = ACTIONS(3805),
    [sym_comment] = ACTIONS(73),
  },
  [1559] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [aux_sym_comparison_operator_repeat1] = STATE(1771),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(3809),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(3811),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(3813),
    [anon_sym_not] = ACTIONS(3815),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3817),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3819),
    [anon_sym_PIPE] = ACTIONS(3821),
    [anon_sym_AMP] = ACTIONS(3823),
    [anon_sym_CARET] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_LT_EQ] = ACTIONS(3811),
    [anon_sym_EQ_EQ] = ACTIONS(3811),
    [anon_sym_BANG_EQ] = ACTIONS(3811),
    [anon_sym_GT_EQ] = ACTIONS(3811),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_GT] = ACTIONS(3811),
    [anon_sym_is] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1560] = {
    [anon_sym_RPAREN] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(2648),
    [anon_sym_EQ] = ACTIONS(3831),
    [sym_comment] = ACTIONS(73),
  },
  [1561] = {
    [sym_string] = STATE(1773),
    [aux_sym_concatenated_string_repeat1] = STATE(1773),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [1562] = {
    [anon_sym_RPAREN] = ACTIONS(2652),
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1563] = {
    [sym_default_parameter] = STATE(864),
    [sym_typed_default_parameter] = STATE(864),
    [sym_list_splat] = STATE(1549),
    [sym_dictionary_splat] = STATE(1549),
    [sym_typed_parameter] = STATE(864),
    [sym_tuple] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_print] = ACTIONS(3264),
    [anon_sym_exec] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3266),
    [sym_comment] = ACTIONS(73),
  },
  [1564] = {
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(1890),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1565] = {
    [sym__simple_statements] = STATE(1774),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1774),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1566] = {
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [1567] = {
    [sym__expression] = STATE(1775),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1775),
    [sym_boolean_operator] = STATE(1775),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1775),
    [sym_lambda] = STATE(1775),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1775),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(1775),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [1568] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_GT_GT] = ACTIONS(1629),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(1637),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_SLASH_SLASH] = ACTIONS(1633),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1641),
    [anon_sym_AMP] = ACTIONS(1643),
    [anon_sym_CARET] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1629),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1569] = {
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(2579),
    [anon_sym_or] = ACTIONS(2581),
    [sym_comment] = ACTIONS(73),
  },
  [1570] = {
    [sym__expression] = STATE(1776),
    [sym__primary_expression] = STATE(871),
    [sym_not_operator] = STATE(1776),
    [sym_boolean_operator] = STATE(1776),
    [sym_binary_operator] = STATE(871),
    [sym_unary_operator] = STATE(871),
    [sym_comparison_operator] = STATE(1776),
    [sym_lambda] = STATE(1776),
    [sym_attribute] = STATE(871),
    [sym_subscript] = STATE(871),
    [sym_call] = STATE(871),
    [sym_list] = STATE(871),
    [sym_list_comprehension] = STATE(871),
    [sym_dictionary] = STATE(871),
    [sym_dictionary_comprehension] = STATE(871),
    [sym_set] = STATE(871),
    [sym_set_comprehension] = STATE(871),
    [sym_parenthesized_expression] = STATE(871),
    [sym_tuple] = STATE(871),
    [sym_generator_expression] = STATE(871),
    [sym_conditional_expression] = STATE(1776),
    [sym_concatenated_string] = STATE(871),
    [sym_string] = STATE(873),
    [sym_await] = STATE(1776),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_lambda] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1665),
    [sym_float] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1665),
    [sym_true] = ACTIONS(1665),
    [sym_false] = ACTIONS(1665),
    [sym_none] = ACTIONS(1665),
    [anon_sym_await] = ACTIONS(1667),
    [sym_comment] = ACTIONS(73),
  },
  [1571] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3833),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1572] = {
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(2579),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1573] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1574] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2583),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_SLASH_SLASH] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1575] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2583),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_SLASH_SLASH] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_CARET] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1576] = {
    [sym__primary_expression] = STATE(1778),
    [sym_binary_operator] = STATE(1778),
    [sym_unary_operator] = STATE(1778),
    [sym_attribute] = STATE(1778),
    [sym_subscript] = STATE(1778),
    [sym_call] = STATE(1778),
    [sym_list] = STATE(1778),
    [sym_list_comprehension] = STATE(1778),
    [sym_dictionary] = STATE(1778),
    [sym_dictionary_comprehension] = STATE(1778),
    [sym_set] = STATE(1778),
    [sym_set_comprehension] = STATE(1778),
    [sym_parenthesized_expression] = STATE(1778),
    [sym_tuple] = STATE(1778),
    [sym_generator_expression] = STATE(1778),
    [sym_concatenated_string] = STATE(1778),
    [sym_string] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3835),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3837),
    [sym_float] = ACTIONS(3837),
    [sym_identifier] = ACTIONS(3837),
    [sym_true] = ACTIONS(3837),
    [sym_false] = ACTIONS(3837),
    [sym_none] = ACTIONS(3837),
    [sym_comment] = ACTIONS(73),
  },
  [1577] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(2583),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_SLASH_SLASH] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1578] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2583),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_SLASH_SLASH] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_CARET] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1579] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2583),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_SLASH_SLASH] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1580] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2583),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_SLASH_SLASH] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1581] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1581),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_not] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_GT_EQ] = ACTIONS(3839),
    [anon_sym_GT] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(3839),
    [anon_sym_is] = ACTIONS(3848),
    [sym_comment] = ACTIONS(73),
  },
  [1582] = {
    [anon_sym_COMMA] = ACTIONS(3851),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(3851),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [1583] = {
    [sym_string] = STATE(1583),
    [aux_sym_concatenated_string_repeat1] = STATE(1583),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_EQ] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1584] = {
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(2618),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2622),
    [sym_comment] = ACTIONS(73),
  },
  [1585] = {
    [sym__expression] = STATE(1779),
    [sym__primary_expression] = STATE(882),
    [sym_not_operator] = STATE(1779),
    [sym_boolean_operator] = STATE(1779),
    [sym_binary_operator] = STATE(882),
    [sym_unary_operator] = STATE(882),
    [sym_comparison_operator] = STATE(1779),
    [sym_lambda] = STATE(1779),
    [sym_attribute] = STATE(882),
    [sym_subscript] = STATE(882),
    [sym_call] = STATE(882),
    [sym_list] = STATE(882),
    [sym_list_comprehension] = STATE(882),
    [sym_dictionary] = STATE(882),
    [sym_dictionary_comprehension] = STATE(882),
    [sym_set] = STATE(882),
    [sym_set_comprehension] = STATE(882),
    [sym_parenthesized_expression] = STATE(882),
    [sym_tuple] = STATE(882),
    [sym_generator_expression] = STATE(882),
    [sym_conditional_expression] = STATE(1779),
    [sym_concatenated_string] = STATE(882),
    [sym_string] = STATE(884),
    [sym_await] = STATE(1779),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_lambda] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1683),
    [sym_float] = ACTIONS(1683),
    [sym_identifier] = ACTIONS(1683),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_none] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1685),
    [sym_comment] = ACTIONS(73),
  },
  [1586] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3853),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1587] = {
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_COLON] = ACTIONS(1968),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1588] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1589] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_SLASH_SLASH] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1590] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_SLASH_SLASH] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1591] = {
    [sym__primary_expression] = STATE(1781),
    [sym_binary_operator] = STATE(1781),
    [sym_unary_operator] = STATE(1781),
    [sym_attribute] = STATE(1781),
    [sym_subscript] = STATE(1781),
    [sym_call] = STATE(1781),
    [sym_list] = STATE(1781),
    [sym_list_comprehension] = STATE(1781),
    [sym_dictionary] = STATE(1781),
    [sym_dictionary_comprehension] = STATE(1781),
    [sym_set] = STATE(1781),
    [sym_set_comprehension] = STATE(1781),
    [sym_parenthesized_expression] = STATE(1781),
    [sym_tuple] = STATE(1781),
    [sym_generator_expression] = STATE(1781),
    [sym_concatenated_string] = STATE(1781),
    [sym_string] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3855),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3857),
    [sym_float] = ACTIONS(3857),
    [sym_identifier] = ACTIONS(3857),
    [sym_true] = ACTIONS(3857),
    [sym_false] = ACTIONS(3857),
    [sym_none] = ACTIONS(3857),
    [sym_comment] = ACTIONS(73),
  },
  [1592] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_SLASH_SLASH] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1593] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_SLASH_SLASH] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1594] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_SLASH_SLASH] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1595] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_SLASH_SLASH] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1596] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1596),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3859),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_not] = ACTIONS(3862),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_LT_EQ] = ACTIONS(3859),
    [anon_sym_EQ_EQ] = ACTIONS(3859),
    [anon_sym_BANG_EQ] = ACTIONS(3859),
    [anon_sym_GT_EQ] = ACTIONS(3859),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_LT_GT] = ACTIONS(3859),
    [anon_sym_is] = ACTIONS(3868),
    [sym_comment] = ACTIONS(73),
  },
  [1597] = {
    [anon_sym_COMMA] = ACTIONS(3871),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(3871),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [1598] = {
    [sym_string] = STATE(1598),
    [aux_sym_concatenated_string_repeat1] = STATE(1598),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_EQ] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1599] = {
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [sym_comment] = ACTIONS(73),
  },
  [1600] = {
    [sym__expression] = STATE(1782),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(1782),
    [sym_boolean_operator] = STATE(1782),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(1782),
    [sym_lambda] = STATE(1782),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(1782),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(1782),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [1601] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(1709),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [anon_sym_SLASH_SLASH] = ACTIONS(1709),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1717),
    [anon_sym_AMP] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(2951),
    [sym_comment] = ACTIONS(73),
  },
  [1602] = {
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_async] = ACTIONS(3574),
    [anon_sym_for] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(801),
    [anon_sym_RBRACK] = ACTIONS(3574),
    [sym_comment] = ACTIONS(73),
  },
  [1603] = {
    [sym__expression_within_for_in_clause] = STATE(1783),
    [sym__expression] = STATE(1606),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(1606),
    [sym_boolean_operator] = STATE(1606),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(1606),
    [sym_lambda] = STATE(1606),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(1606),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(1606),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1604] = {
    [sym_lambda_parameters] = STATE(1785),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3873),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1605] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1787),
    [anon_sym_COMMA] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_async] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_RBRACK] = ACTIONS(3648),
    [sym_comment] = ACTIONS(73),
  },
  [1606] = {
    [anon_sym_COMMA] = ACTIONS(3652),
    [anon_sym_if] = ACTIONS(3652),
    [anon_sym_async] = ACTIONS(3652),
    [anon_sym_for] = ACTIONS(3652),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(801),
    [anon_sym_RBRACK] = ACTIONS(3652),
    [sym_comment] = ACTIONS(73),
  },
  [1607] = {
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(3412),
    [anon_sym_or] = ACTIONS(3414),
    [anon_sym_RBRACK] = ACTIONS(731),
    [sym_comment] = ACTIONS(73),
  },
  [1608] = {
    [sym__expression] = STATE(1788),
    [sym__primary_expression] = STATE(1321),
    [sym_not_operator] = STATE(1788),
    [sym_boolean_operator] = STATE(1788),
    [sym_binary_operator] = STATE(1321),
    [sym_unary_operator] = STATE(1321),
    [sym_comparison_operator] = STATE(1788),
    [sym_lambda] = STATE(1788),
    [sym_attribute] = STATE(1321),
    [sym_subscript] = STATE(1321),
    [sym_call] = STATE(1321),
    [sym_list] = STATE(1321),
    [sym_list_comprehension] = STATE(1321),
    [sym_dictionary] = STATE(1321),
    [sym_dictionary_comprehension] = STATE(1321),
    [sym_set] = STATE(1321),
    [sym_set_comprehension] = STATE(1321),
    [sym_parenthesized_expression] = STATE(1321),
    [sym_tuple] = STATE(1321),
    [sym_generator_expression] = STATE(1321),
    [sym_conditional_expression] = STATE(1788),
    [sym_concatenated_string] = STATE(1321),
    [sym_string] = STATE(1322),
    [sym_await] = STATE(1788),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_lambda] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2719),
    [sym_float] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2719),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [sym_none] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(2721),
    [sym_comment] = ACTIONS(73),
  },
  [1609] = {
    [anon_sym_COLON] = ACTIONS(3877),
    [sym_comment] = ACTIONS(73),
  },
  [1610] = {
    [sym__expression] = STATE(1790),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1790),
    [sym_boolean_operator] = STATE(1790),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1790),
    [sym_lambda] = STATE(1790),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1790),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1790),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1611] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(1321),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(1321),
    [sym_unary_operator] = STATE(1321),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(1321),
    [sym_subscript] = STATE(1321),
    [sym_call] = STATE(1321),
    [sym_list] = STATE(1321),
    [sym_list_comprehension] = STATE(1321),
    [sym_dictionary] = STATE(1321),
    [sym_dictionary_comprehension] = STATE(1321),
    [sym_set] = STATE(1321),
    [sym_set_comprehension] = STATE(1321),
    [sym_parenthesized_expression] = STATE(1321),
    [sym_tuple] = STATE(1321),
    [sym_generator_expression] = STATE(1321),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(1321),
    [sym_string] = STATE(1322),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_lambda] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2719),
    [sym_float] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2719),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [sym_none] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(2721),
    [sym_comment] = ACTIONS(73),
  },
  [1612] = {
    [sym__expression] = STATE(1791),
    [sym__primary_expression] = STATE(1321),
    [sym_not_operator] = STATE(1791),
    [sym_boolean_operator] = STATE(1791),
    [sym_binary_operator] = STATE(1321),
    [sym_unary_operator] = STATE(1321),
    [sym_comparison_operator] = STATE(1791),
    [sym_lambda] = STATE(1791),
    [sym_attribute] = STATE(1321),
    [sym_subscript] = STATE(1321),
    [sym_call] = STATE(1321),
    [sym_list] = STATE(1321),
    [sym_list_comprehension] = STATE(1321),
    [sym_dictionary] = STATE(1321),
    [sym_dictionary_comprehension] = STATE(1321),
    [sym_set] = STATE(1321),
    [sym_set_comprehension] = STATE(1321),
    [sym_parenthesized_expression] = STATE(1321),
    [sym_tuple] = STATE(1321),
    [sym_generator_expression] = STATE(1321),
    [sym_conditional_expression] = STATE(1791),
    [sym_concatenated_string] = STATE(1321),
    [sym_string] = STATE(1322),
    [sym_await] = STATE(1791),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_lambda] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2719),
    [sym_float] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2719),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [sym_none] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(2721),
    [sym_comment] = ACTIONS(73),
  },
  [1613] = {
    [sym__primary_expression] = STATE(1792),
    [sym_binary_operator] = STATE(1792),
    [sym_unary_operator] = STATE(1792),
    [sym_attribute] = STATE(1792),
    [sym_subscript] = STATE(1792),
    [sym_call] = STATE(1792),
    [sym_list] = STATE(1792),
    [sym_list_comprehension] = STATE(1792),
    [sym_dictionary] = STATE(1792),
    [sym_dictionary_comprehension] = STATE(1792),
    [sym_set] = STATE(1792),
    [sym_set_comprehension] = STATE(1792),
    [sym_parenthesized_expression] = STATE(1792),
    [sym_tuple] = STATE(1792),
    [sym_generator_expression] = STATE(1792),
    [sym_concatenated_string] = STATE(1792),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3881),
    [sym_float] = ACTIONS(3881),
    [sym_identifier] = ACTIONS(3881),
    [sym_true] = ACTIONS(3881),
    [sym_false] = ACTIONS(3881),
    [sym_none] = ACTIONS(3881),
    [sym_comment] = ACTIONS(73),
  },
  [1614] = {
    [sym__primary_expression] = STATE(1793),
    [sym_binary_operator] = STATE(1793),
    [sym_unary_operator] = STATE(1793),
    [sym_attribute] = STATE(1793),
    [sym_subscript] = STATE(1793),
    [sym_call] = STATE(1793),
    [sym_list] = STATE(1793),
    [sym_list_comprehension] = STATE(1793),
    [sym_dictionary] = STATE(1793),
    [sym_dictionary_comprehension] = STATE(1793),
    [sym_set] = STATE(1793),
    [sym_set_comprehension] = STATE(1793),
    [sym_parenthesized_expression] = STATE(1793),
    [sym_tuple] = STATE(1793),
    [sym_generator_expression] = STATE(1793),
    [sym_concatenated_string] = STATE(1793),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3885),
    [sym_float] = ACTIONS(3885),
    [sym_identifier] = ACTIONS(3885),
    [sym_true] = ACTIONS(3885),
    [sym_false] = ACTIONS(3885),
    [sym_none] = ACTIONS(3885),
    [sym_comment] = ACTIONS(73),
  },
  [1615] = {
    [sym__primary_expression] = STATE(1794),
    [sym_binary_operator] = STATE(1794),
    [sym_unary_operator] = STATE(1794),
    [sym_attribute] = STATE(1794),
    [sym_subscript] = STATE(1794),
    [sym_call] = STATE(1794),
    [sym_list] = STATE(1794),
    [sym_list_comprehension] = STATE(1794),
    [sym_dictionary] = STATE(1794),
    [sym_dictionary_comprehension] = STATE(1794),
    [sym_set] = STATE(1794),
    [sym_set_comprehension] = STATE(1794),
    [sym_parenthesized_expression] = STATE(1794),
    [sym_tuple] = STATE(1794),
    [sym_generator_expression] = STATE(1794),
    [sym_concatenated_string] = STATE(1794),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3889),
    [sym_float] = ACTIONS(3889),
    [sym_identifier] = ACTIONS(3889),
    [sym_true] = ACTIONS(3889),
    [sym_false] = ACTIONS(3889),
    [sym_none] = ACTIONS(3889),
    [sym_comment] = ACTIONS(73),
  },
  [1616] = {
    [anon_sym_in] = ACTIONS(3891),
    [sym_comment] = ACTIONS(73),
  },
  [1617] = {
    [sym__primary_expression] = STATE(1796),
    [sym_binary_operator] = STATE(1796),
    [sym_unary_operator] = STATE(1796),
    [sym_attribute] = STATE(1796),
    [sym_subscript] = STATE(1796),
    [sym_call] = STATE(1796),
    [sym_list] = STATE(1796),
    [sym_list_comprehension] = STATE(1796),
    [sym_dictionary] = STATE(1796),
    [sym_dictionary_comprehension] = STATE(1796),
    [sym_set] = STATE(1796),
    [sym_set_comprehension] = STATE(1796),
    [sym_parenthesized_expression] = STATE(1796),
    [sym_tuple] = STATE(1796),
    [sym_generator_expression] = STATE(1796),
    [sym_concatenated_string] = STATE(1796),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3893),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3895),
    [sym_float] = ACTIONS(3895),
    [sym_identifier] = ACTIONS(3895),
    [sym_true] = ACTIONS(3895),
    [sym_false] = ACTIONS(3895),
    [sym_none] = ACTIONS(3895),
    [sym_comment] = ACTIONS(73),
  },
  [1618] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [1619] = {
    [sym__primary_expression] = STATE(1797),
    [sym_binary_operator] = STATE(1797),
    [sym_unary_operator] = STATE(1797),
    [sym_attribute] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_call] = STATE(1797),
    [sym_list] = STATE(1797),
    [sym_list_comprehension] = STATE(1797),
    [sym_dictionary] = STATE(1797),
    [sym_dictionary_comprehension] = STATE(1797),
    [sym_set] = STATE(1797),
    [sym_set_comprehension] = STATE(1797),
    [sym_parenthesized_expression] = STATE(1797),
    [sym_tuple] = STATE(1797),
    [sym_generator_expression] = STATE(1797),
    [sym_concatenated_string] = STATE(1797),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3899),
    [sym_float] = ACTIONS(3899),
    [sym_identifier] = ACTIONS(3899),
    [sym_true] = ACTIONS(3899),
    [sym_false] = ACTIONS(3899),
    [sym_none] = ACTIONS(3899),
    [sym_comment] = ACTIONS(73),
  },
  [1620] = {
    [sym__primary_expression] = STATE(1798),
    [sym_binary_operator] = STATE(1798),
    [sym_unary_operator] = STATE(1798),
    [sym_attribute] = STATE(1798),
    [sym_subscript] = STATE(1798),
    [sym_call] = STATE(1798),
    [sym_list] = STATE(1798),
    [sym_list_comprehension] = STATE(1798),
    [sym_dictionary] = STATE(1798),
    [sym_dictionary_comprehension] = STATE(1798),
    [sym_set] = STATE(1798),
    [sym_set_comprehension] = STATE(1798),
    [sym_parenthesized_expression] = STATE(1798),
    [sym_tuple] = STATE(1798),
    [sym_generator_expression] = STATE(1798),
    [sym_concatenated_string] = STATE(1798),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3903),
    [sym_float] = ACTIONS(3903),
    [sym_identifier] = ACTIONS(3903),
    [sym_true] = ACTIONS(3903),
    [sym_false] = ACTIONS(3903),
    [sym_none] = ACTIONS(3903),
    [sym_comment] = ACTIONS(73),
  },
  [1621] = {
    [sym__primary_expression] = STATE(1799),
    [sym_binary_operator] = STATE(1799),
    [sym_unary_operator] = STATE(1799),
    [sym_attribute] = STATE(1799),
    [sym_subscript] = STATE(1799),
    [sym_call] = STATE(1799),
    [sym_list] = STATE(1799),
    [sym_list_comprehension] = STATE(1799),
    [sym_dictionary] = STATE(1799),
    [sym_dictionary_comprehension] = STATE(1799),
    [sym_set] = STATE(1799),
    [sym_set_comprehension] = STATE(1799),
    [sym_parenthesized_expression] = STATE(1799),
    [sym_tuple] = STATE(1799),
    [sym_generator_expression] = STATE(1799),
    [sym_concatenated_string] = STATE(1799),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3907),
    [sym_float] = ACTIONS(3907),
    [sym_identifier] = ACTIONS(3907),
    [sym_true] = ACTIONS(3907),
    [sym_false] = ACTIONS(3907),
    [sym_none] = ACTIONS(3907),
    [sym_comment] = ACTIONS(73),
  },
  [1622] = {
    [sym__primary_expression] = STATE(1794),
    [sym_binary_operator] = STATE(1794),
    [sym_unary_operator] = STATE(1794),
    [sym_attribute] = STATE(1794),
    [sym_subscript] = STATE(1794),
    [sym_call] = STATE(1794),
    [sym_list] = STATE(1794),
    [sym_list_comprehension] = STATE(1794),
    [sym_dictionary] = STATE(1794),
    [sym_dictionary_comprehension] = STATE(1794),
    [sym_set] = STATE(1794),
    [sym_set_comprehension] = STATE(1794),
    [sym_parenthesized_expression] = STATE(1794),
    [sym_tuple] = STATE(1794),
    [sym_generator_expression] = STATE(1794),
    [sym_concatenated_string] = STATE(1794),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3909),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3889),
    [sym_float] = ACTIONS(3889),
    [sym_identifier] = ACTIONS(3889),
    [sym_true] = ACTIONS(3889),
    [sym_false] = ACTIONS(3889),
    [sym_none] = ACTIONS(3889),
    [sym_comment] = ACTIONS(73),
  },
  [1623] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1800),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_async] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(3420),
    [anon_sym_not] = ACTIONS(3424),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(3436),
    [anon_sym_LT_EQ] = ACTIONS(3420),
    [anon_sym_EQ_EQ] = ACTIONS(3420),
    [anon_sym_BANG_EQ] = ACTIONS(3420),
    [anon_sym_GT_EQ] = ACTIONS(3420),
    [anon_sym_GT] = ACTIONS(3436),
    [anon_sym_LT_GT] = ACTIONS(3420),
    [anon_sym_is] = ACTIONS(3438),
    [anon_sym_RBRACK] = ACTIONS(999),
    [sym_comment] = ACTIONS(73),
  },
  [1624] = {
    [sym_string] = STATE(1801),
    [aux_sym_concatenated_string_repeat1] = STATE(1801),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_RBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [1625] = {
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(1777),
    [anon_sym_and] = ACTIONS(1779),
    [anon_sym_or] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(73),
  },
  [1626] = {
    [sym__expression] = STATE(1802),
    [sym__primary_expression] = STATE(483),
    [sym_not_operator] = STATE(1802),
    [sym_boolean_operator] = STATE(1802),
    [sym_binary_operator] = STATE(483),
    [sym_unary_operator] = STATE(483),
    [sym_comparison_operator] = STATE(1802),
    [sym_lambda] = STATE(1802),
    [sym_attribute] = STATE(483),
    [sym_subscript] = STATE(483),
    [sym_call] = STATE(483),
    [sym_list] = STATE(483),
    [sym_list_comprehension] = STATE(483),
    [sym_dictionary] = STATE(483),
    [sym_dictionary_comprehension] = STATE(483),
    [sym_set] = STATE(483),
    [sym_set_comprehension] = STATE(483),
    [sym_parenthesized_expression] = STATE(483),
    [sym_tuple] = STATE(483),
    [sym_generator_expression] = STATE(483),
    [sym_conditional_expression] = STATE(1802),
    [sym_concatenated_string] = STATE(483),
    [sym_string] = STATE(484),
    [sym_await] = STATE(1802),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_lambda] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_identifier] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_none] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(841),
    [sym_comment] = ACTIONS(73),
  },
  [1627] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(1783),
    [anon_sym_GT_GT] = ACTIONS(1785),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(1789),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(1793),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_SLASH] = ACTIONS(1783),
    [anon_sym_PERCENT] = ACTIONS(1789),
    [anon_sym_SLASH_SLASH] = ACTIONS(1789),
    [anon_sym_STAR_STAR] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_CARET] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [sym_comment] = ACTIONS(73),
  },
  [1628] = {
    [anon_sym_COMMA] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(1777),
    [anon_sym_and] = ACTIONS(1779),
    [anon_sym_or] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [sym_comment] = ACTIONS(73),
  },
  [1629] = {
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_COLON] = ACTIONS(3574),
    [anon_sym_async] = ACTIONS(3574),
    [anon_sym_for] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(863),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(3574),
    [sym_comment] = ACTIONS(73),
  },
  [1630] = {
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(1671),
    [sym_comment] = ACTIONS(73),
  },
  [1631] = {
    [sym__expression] = STATE(1803),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1803),
    [sym_boolean_operator] = STATE(1803),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1803),
    [sym_lambda] = STATE(1803),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1803),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1803),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1632] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3911),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1633] = {
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_RBRACE] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1634] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1635] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1636] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1637] = {
    [sym__primary_expression] = STATE(1805),
    [sym_binary_operator] = STATE(1805),
    [sym_unary_operator] = STATE(1805),
    [sym_attribute] = STATE(1805),
    [sym_subscript] = STATE(1805),
    [sym_call] = STATE(1805),
    [sym_list] = STATE(1805),
    [sym_list_comprehension] = STATE(1805),
    [sym_dictionary] = STATE(1805),
    [sym_dictionary_comprehension] = STATE(1805),
    [sym_set] = STATE(1805),
    [sym_set_comprehension] = STATE(1805),
    [sym_parenthesized_expression] = STATE(1805),
    [sym_tuple] = STATE(1805),
    [sym_generator_expression] = STATE(1805),
    [sym_concatenated_string] = STATE(1805),
    [sym_string] = STATE(971),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3913),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3915),
    [sym_float] = ACTIONS(3915),
    [sym_identifier] = ACTIONS(3915),
    [sym_true] = ACTIONS(3915),
    [sym_false] = ACTIONS(3915),
    [sym_none] = ACTIONS(3915),
    [sym_comment] = ACTIONS(73),
  },
  [1638] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1639] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1640] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1641] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1642] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1642),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3917),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_LT_EQ] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_GT_EQ] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_LT_GT] = ACTIONS(3917),
    [anon_sym_is] = ACTIONS(3926),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1643] = {
    [sym_string] = STATE(1643),
    [aux_sym_concatenated_string_repeat1] = STATE(1643),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_async] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1644] = {
    [sym__expression_within_for_in_clause] = STATE(1806),
    [sym__expression] = STATE(1647),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1647),
    [sym_boolean_operator] = STATE(1647),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1647),
    [sym_lambda] = STATE(1647),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1647),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1645] = {
    [sym_lambda_parameters] = STATE(1808),
    [sym__parameters] = STATE(137),
    [sym_default_parameter] = STATE(138),
    [sym_typed_default_parameter] = STATE(138),
    [sym_list_splat] = STATE(139),
    [sym_dictionary_splat] = STATE(139),
    [sym_typed_parameter] = STATE(138),
    [sym_tuple] = STATE(138),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1646] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1810),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_async] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_RBRACE] = ACTIONS(3648),
    [sym_comment] = ACTIONS(73),
  },
  [1647] = {
    [anon_sym_COMMA] = ACTIONS(3652),
    [anon_sym_if] = ACTIONS(3652),
    [anon_sym_async] = ACTIONS(3652),
    [anon_sym_for] = ACTIONS(3652),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(3652),
    [sym_comment] = ACTIONS(73),
  },
  [1648] = {
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3517),
    [anon_sym_RBRACE] = ACTIONS(731),
    [sym_comment] = ACTIONS(73),
  },
  [1649] = {
    [sym__expression] = STATE(1811),
    [sym__primary_expression] = STATE(1371),
    [sym_not_operator] = STATE(1811),
    [sym_boolean_operator] = STATE(1811),
    [sym_binary_operator] = STATE(1371),
    [sym_unary_operator] = STATE(1371),
    [sym_comparison_operator] = STATE(1811),
    [sym_lambda] = STATE(1811),
    [sym_attribute] = STATE(1371),
    [sym_subscript] = STATE(1371),
    [sym_call] = STATE(1371),
    [sym_list] = STATE(1371),
    [sym_list_comprehension] = STATE(1371),
    [sym_dictionary] = STATE(1371),
    [sym_dictionary_comprehension] = STATE(1371),
    [sym_set] = STATE(1371),
    [sym_set_comprehension] = STATE(1371),
    [sym_parenthesized_expression] = STATE(1371),
    [sym_tuple] = STATE(1371),
    [sym_generator_expression] = STATE(1371),
    [sym_conditional_expression] = STATE(1811),
    [sym_concatenated_string] = STATE(1371),
    [sym_string] = STATE(1372),
    [sym_await] = STATE(1811),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2845),
    [sym_float] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [anon_sym_await] = ACTIONS(2847),
    [sym_comment] = ACTIONS(73),
  },
  [1650] = {
    [anon_sym_COLON] = ACTIONS(3933),
    [sym_comment] = ACTIONS(73),
  },
  [1651] = {
    [sym__expression] = STATE(1813),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1813),
    [sym_boolean_operator] = STATE(1813),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1813),
    [sym_lambda] = STATE(1813),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1813),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1813),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1652] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(1371),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(1371),
    [sym_unary_operator] = STATE(1371),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(1371),
    [sym_subscript] = STATE(1371),
    [sym_call] = STATE(1371),
    [sym_list] = STATE(1371),
    [sym_list_comprehension] = STATE(1371),
    [sym_dictionary] = STATE(1371),
    [sym_dictionary_comprehension] = STATE(1371),
    [sym_set] = STATE(1371),
    [sym_set_comprehension] = STATE(1371),
    [sym_parenthesized_expression] = STATE(1371),
    [sym_tuple] = STATE(1371),
    [sym_generator_expression] = STATE(1371),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(1371),
    [sym_string] = STATE(1372),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2845),
    [sym_float] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [anon_sym_await] = ACTIONS(2847),
    [sym_comment] = ACTIONS(73),
  },
  [1653] = {
    [sym__expression] = STATE(1814),
    [sym__primary_expression] = STATE(1371),
    [sym_not_operator] = STATE(1814),
    [sym_boolean_operator] = STATE(1814),
    [sym_binary_operator] = STATE(1371),
    [sym_unary_operator] = STATE(1371),
    [sym_comparison_operator] = STATE(1814),
    [sym_lambda] = STATE(1814),
    [sym_attribute] = STATE(1371),
    [sym_subscript] = STATE(1371),
    [sym_call] = STATE(1371),
    [sym_list] = STATE(1371),
    [sym_list_comprehension] = STATE(1371),
    [sym_dictionary] = STATE(1371),
    [sym_dictionary_comprehension] = STATE(1371),
    [sym_set] = STATE(1371),
    [sym_set_comprehension] = STATE(1371),
    [sym_parenthesized_expression] = STATE(1371),
    [sym_tuple] = STATE(1371),
    [sym_generator_expression] = STATE(1371),
    [sym_conditional_expression] = STATE(1814),
    [sym_concatenated_string] = STATE(1371),
    [sym_string] = STATE(1372),
    [sym_await] = STATE(1814),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2845),
    [sym_float] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [anon_sym_await] = ACTIONS(2847),
    [sym_comment] = ACTIONS(73),
  },
  [1654] = {
    [sym__primary_expression] = STATE(1815),
    [sym_binary_operator] = STATE(1815),
    [sym_unary_operator] = STATE(1815),
    [sym_attribute] = STATE(1815),
    [sym_subscript] = STATE(1815),
    [sym_call] = STATE(1815),
    [sym_list] = STATE(1815),
    [sym_list_comprehension] = STATE(1815),
    [sym_dictionary] = STATE(1815),
    [sym_dictionary_comprehension] = STATE(1815),
    [sym_set] = STATE(1815),
    [sym_set_comprehension] = STATE(1815),
    [sym_parenthesized_expression] = STATE(1815),
    [sym_tuple] = STATE(1815),
    [sym_generator_expression] = STATE(1815),
    [sym_concatenated_string] = STATE(1815),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3937),
    [sym_float] = ACTIONS(3937),
    [sym_identifier] = ACTIONS(3937),
    [sym_true] = ACTIONS(3937),
    [sym_false] = ACTIONS(3937),
    [sym_none] = ACTIONS(3937),
    [sym_comment] = ACTIONS(73),
  },
  [1655] = {
    [sym__primary_expression] = STATE(1816),
    [sym_binary_operator] = STATE(1816),
    [sym_unary_operator] = STATE(1816),
    [sym_attribute] = STATE(1816),
    [sym_subscript] = STATE(1816),
    [sym_call] = STATE(1816),
    [sym_list] = STATE(1816),
    [sym_list_comprehension] = STATE(1816),
    [sym_dictionary] = STATE(1816),
    [sym_dictionary_comprehension] = STATE(1816),
    [sym_set] = STATE(1816),
    [sym_set_comprehension] = STATE(1816),
    [sym_parenthesized_expression] = STATE(1816),
    [sym_tuple] = STATE(1816),
    [sym_generator_expression] = STATE(1816),
    [sym_concatenated_string] = STATE(1816),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3941),
    [sym_float] = ACTIONS(3941),
    [sym_identifier] = ACTIONS(3941),
    [sym_true] = ACTIONS(3941),
    [sym_false] = ACTIONS(3941),
    [sym_none] = ACTIONS(3941),
    [sym_comment] = ACTIONS(73),
  },
  [1656] = {
    [sym__primary_expression] = STATE(1817),
    [sym_binary_operator] = STATE(1817),
    [sym_unary_operator] = STATE(1817),
    [sym_attribute] = STATE(1817),
    [sym_subscript] = STATE(1817),
    [sym_call] = STATE(1817),
    [sym_list] = STATE(1817),
    [sym_list_comprehension] = STATE(1817),
    [sym_dictionary] = STATE(1817),
    [sym_dictionary_comprehension] = STATE(1817),
    [sym_set] = STATE(1817),
    [sym_set_comprehension] = STATE(1817),
    [sym_parenthesized_expression] = STATE(1817),
    [sym_tuple] = STATE(1817),
    [sym_generator_expression] = STATE(1817),
    [sym_concatenated_string] = STATE(1817),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3945),
    [sym_float] = ACTIONS(3945),
    [sym_identifier] = ACTIONS(3945),
    [sym_true] = ACTIONS(3945),
    [sym_false] = ACTIONS(3945),
    [sym_none] = ACTIONS(3945),
    [sym_comment] = ACTIONS(73),
  },
  [1657] = {
    [anon_sym_in] = ACTIONS(3947),
    [sym_comment] = ACTIONS(73),
  },
  [1658] = {
    [sym__primary_expression] = STATE(1819),
    [sym_binary_operator] = STATE(1819),
    [sym_unary_operator] = STATE(1819),
    [sym_attribute] = STATE(1819),
    [sym_subscript] = STATE(1819),
    [sym_call] = STATE(1819),
    [sym_list] = STATE(1819),
    [sym_list_comprehension] = STATE(1819),
    [sym_dictionary] = STATE(1819),
    [sym_dictionary_comprehension] = STATE(1819),
    [sym_set] = STATE(1819),
    [sym_set_comprehension] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1819),
    [sym_tuple] = STATE(1819),
    [sym_generator_expression] = STATE(1819),
    [sym_concatenated_string] = STATE(1819),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3951),
    [sym_float] = ACTIONS(3951),
    [sym_identifier] = ACTIONS(3951),
    [sym_true] = ACTIONS(3951),
    [sym_false] = ACTIONS(3951),
    [sym_none] = ACTIONS(3951),
    [sym_comment] = ACTIONS(73),
  },
  [1659] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [1660] = {
    [sym__primary_expression] = STATE(1820),
    [sym_binary_operator] = STATE(1820),
    [sym_unary_operator] = STATE(1820),
    [sym_attribute] = STATE(1820),
    [sym_subscript] = STATE(1820),
    [sym_call] = STATE(1820),
    [sym_list] = STATE(1820),
    [sym_list_comprehension] = STATE(1820),
    [sym_dictionary] = STATE(1820),
    [sym_dictionary_comprehension] = STATE(1820),
    [sym_set] = STATE(1820),
    [sym_set_comprehension] = STATE(1820),
    [sym_parenthesized_expression] = STATE(1820),
    [sym_tuple] = STATE(1820),
    [sym_generator_expression] = STATE(1820),
    [sym_concatenated_string] = STATE(1820),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3955),
    [sym_float] = ACTIONS(3955),
    [sym_identifier] = ACTIONS(3955),
    [sym_true] = ACTIONS(3955),
    [sym_false] = ACTIONS(3955),
    [sym_none] = ACTIONS(3955),
    [sym_comment] = ACTIONS(73),
  },
  [1661] = {
    [sym__primary_expression] = STATE(1821),
    [sym_binary_operator] = STATE(1821),
    [sym_unary_operator] = STATE(1821),
    [sym_attribute] = STATE(1821),
    [sym_subscript] = STATE(1821),
    [sym_call] = STATE(1821),
    [sym_list] = STATE(1821),
    [sym_list_comprehension] = STATE(1821),
    [sym_dictionary] = STATE(1821),
    [sym_dictionary_comprehension] = STATE(1821),
    [sym_set] = STATE(1821),
    [sym_set_comprehension] = STATE(1821),
    [sym_parenthesized_expression] = STATE(1821),
    [sym_tuple] = STATE(1821),
    [sym_generator_expression] = STATE(1821),
    [sym_concatenated_string] = STATE(1821),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3957),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3959),
    [sym_float] = ACTIONS(3959),
    [sym_identifier] = ACTIONS(3959),
    [sym_true] = ACTIONS(3959),
    [sym_false] = ACTIONS(3959),
    [sym_none] = ACTIONS(3959),
    [sym_comment] = ACTIONS(73),
  },
  [1662] = {
    [sym__primary_expression] = STATE(1822),
    [sym_binary_operator] = STATE(1822),
    [sym_unary_operator] = STATE(1822),
    [sym_attribute] = STATE(1822),
    [sym_subscript] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym_list] = STATE(1822),
    [sym_list_comprehension] = STATE(1822),
    [sym_dictionary] = STATE(1822),
    [sym_dictionary_comprehension] = STATE(1822),
    [sym_set] = STATE(1822),
    [sym_set_comprehension] = STATE(1822),
    [sym_parenthesized_expression] = STATE(1822),
    [sym_tuple] = STATE(1822),
    [sym_generator_expression] = STATE(1822),
    [sym_concatenated_string] = STATE(1822),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3961),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3963),
    [sym_float] = ACTIONS(3963),
    [sym_identifier] = ACTIONS(3963),
    [sym_true] = ACTIONS(3963),
    [sym_false] = ACTIONS(3963),
    [sym_none] = ACTIONS(3963),
    [sym_comment] = ACTIONS(73),
  },
  [1663] = {
    [sym__primary_expression] = STATE(1817),
    [sym_binary_operator] = STATE(1817),
    [sym_unary_operator] = STATE(1817),
    [sym_attribute] = STATE(1817),
    [sym_subscript] = STATE(1817),
    [sym_call] = STATE(1817),
    [sym_list] = STATE(1817),
    [sym_list_comprehension] = STATE(1817),
    [sym_dictionary] = STATE(1817),
    [sym_dictionary_comprehension] = STATE(1817),
    [sym_set] = STATE(1817),
    [sym_set_comprehension] = STATE(1817),
    [sym_parenthesized_expression] = STATE(1817),
    [sym_tuple] = STATE(1817),
    [sym_generator_expression] = STATE(1817),
    [sym_concatenated_string] = STATE(1817),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3945),
    [sym_float] = ACTIONS(3945),
    [sym_identifier] = ACTIONS(3945),
    [sym_true] = ACTIONS(3945),
    [sym_false] = ACTIONS(3945),
    [sym_none] = ACTIONS(3945),
    [sym_comment] = ACTIONS(73),
  },
  [1664] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1823),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_async] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(3523),
    [anon_sym_not] = ACTIONS(3527),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(3539),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_EQ_EQ] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_GT] = ACTIONS(3539),
    [anon_sym_LT_GT] = ACTIONS(3523),
    [anon_sym_is] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(999),
    [sym_comment] = ACTIONS(73),
  },
  [1665] = {
    [sym_string] = STATE(1824),
    [aux_sym_concatenated_string_repeat1] = STATE(1824),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [1666] = {
    [sym__newline] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_EQ] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(1894),
    [anon_sym_or] = ACTIONS(1896),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2656),
  },
  [1667] = {
    [sym__expression] = STATE(1825),
    [sym__primary_expression] = STATE(523),
    [sym_not_operator] = STATE(1825),
    [sym_boolean_operator] = STATE(1825),
    [sym_binary_operator] = STATE(523),
    [sym_unary_operator] = STATE(523),
    [sym_comparison_operator] = STATE(1825),
    [sym_lambda] = STATE(1825),
    [sym_attribute] = STATE(523),
    [sym_subscript] = STATE(523),
    [sym_call] = STATE(523),
    [sym_list] = STATE(523),
    [sym_list_comprehension] = STATE(523),
    [sym_dictionary] = STATE(523),
    [sym_dictionary_comprehension] = STATE(523),
    [sym_set] = STATE(523),
    [sym_set_comprehension] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_tuple] = STATE(523),
    [sym_generator_expression] = STATE(523),
    [sym_conditional_expression] = STATE(1825),
    [sym_concatenated_string] = STATE(523),
    [sym_string] = STATE(525),
    [sym_await] = STATE(1825),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_lambda] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(909),
    [sym_float] = ACTIONS(909),
    [sym_identifier] = ACTIONS(909),
    [sym_true] = ACTIONS(909),
    [sym_false] = ACTIONS(909),
    [sym_none] = ACTIONS(909),
    [anon_sym_await] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
  },
  [1668] = {
    [sym_argument_list] = STATE(313),
    [sym_generator_expression] = STATE(313),
    [sym__newline] = ACTIONS(2951),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1900),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_SLASH] = ACTIONS(1898),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_SLASH_SLASH] = ACTIONS(1904),
    [anon_sym_STAR_STAR] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_CARET] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2951),
  },
  [1669] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1670] = {
    [sym__expression] = STATE(1826),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1826),
    [sym_boolean_operator] = STATE(1826),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1826),
    [sym_lambda] = STATE(1826),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1826),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1826),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1671] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_GT_GT] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_else] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1950),
    [anon_sym_SLASH_SLASH] = ACTIONS(1950),
    [anon_sym_STAR_STAR] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1958),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1672] = {
    [sym__newline] = ACTIONS(3967),
    [anon_sym_DOT] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3967),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_STAR] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3967),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_EQ] = ACTIONS(3969),
    [anon_sym_AT] = ACTIONS(3969),
    [anon_sym_not] = ACTIONS(3967),
    [anon_sym_and] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_SLASH] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_SLASH_SLASH] = ACTIONS(3969),
    [anon_sym_STAR_STAR] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_LT_LT] = ACTIONS(3969),
    [anon_sym_LT] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3969),
    [anon_sym_LT_GT] = ACTIONS(3967),
    [anon_sym_is] = ACTIONS(3967),
    [anon_sym_PLUS_EQ] = ACTIONS(3967),
    [anon_sym_DASH_EQ] = ACTIONS(3967),
    [anon_sym_STAR_EQ] = ACTIONS(3967),
    [anon_sym_SLASH_EQ] = ACTIONS(3967),
    [anon_sym_AT_EQ] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3967),
    [anon_sym_PERCENT_EQ] = ACTIONS(3967),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3967),
    [anon_sym_GT_GT_EQ] = ACTIONS(3967),
    [anon_sym_LT_LT_EQ] = ACTIONS(3967),
    [anon_sym_AMP_EQ] = ACTIONS(3967),
    [anon_sym_CARET_EQ] = ACTIONS(3967),
    [anon_sym_PIPE_EQ] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3967),
  },
  [1673] = {
    [sym_list_splat] = STATE(1410),
    [sym_dictionary_splat] = STATE(1410),
    [sym__expression] = STATE(1411),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1411),
    [sym_boolean_operator] = STATE(1411),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1411),
    [sym_lambda] = STATE(1411),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_keyword_argument] = STATE(1410),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1411),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1411),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(941),
    [anon_sym_exec] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1674] = {
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(3971),
    [sym_comment] = ACTIONS(73),
  },
  [1675] = {
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [sym_comment] = ACTIONS(73),
  },
  [1676] = {
    [sym__expression] = STATE(1827),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1827),
    [sym_boolean_operator] = STATE(1827),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1827),
    [sym_lambda] = STATE(1827),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1827),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1827),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1677] = {
    [sym__expression] = STATE(1828),
    [sym__primary_expression] = STATE(450),
    [sym_not_operator] = STATE(1828),
    [sym_boolean_operator] = STATE(1828),
    [sym_binary_operator] = STATE(450),
    [sym_unary_operator] = STATE(450),
    [sym_comparison_operator] = STATE(1828),
    [sym_lambda] = STATE(1828),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(450),
    [sym_list] = STATE(450),
    [sym_list_comprehension] = STATE(450),
    [sym_dictionary] = STATE(450),
    [sym_dictionary_comprehension] = STATE(450),
    [sym_set] = STATE(450),
    [sym_set_comprehension] = STATE(450),
    [sym_parenthesized_expression] = STATE(450),
    [sym_tuple] = STATE(450),
    [sym_generator_expression] = STATE(450),
    [sym_conditional_expression] = STATE(1828),
    [sym_concatenated_string] = STATE(450),
    [sym_string] = STATE(451),
    [sym_await] = STATE(1828),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_lambda] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3971),
    [sym_ellipsis] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(781),
    [sym_float] = ACTIONS(781),
    [sym_identifier] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_none] = ACTIONS(781),
    [anon_sym_await] = ACTIONS(783),
    [sym_comment] = ACTIONS(73),
  },
  [1678] = {
    [sym__newline] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_GT_GT] = ACTIONS(3975),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_in] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_AT] = ACTIONS(3975),
    [anon_sym_not] = ACTIONS(3973),
    [anon_sym_and] = ACTIONS(3973),
    [anon_sym_or] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3975),
    [anon_sym_DASH] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3975),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_SLASH_SLASH] = ACTIONS(3975),
    [anon_sym_STAR_STAR] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3975),
    [anon_sym_LT_LT] = ACTIONS(3975),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_LT_EQ] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_LT_GT] = ACTIONS(3973),
    [anon_sym_is] = ACTIONS(3973),
    [anon_sym_PLUS_EQ] = ACTIONS(3973),
    [anon_sym_DASH_EQ] = ACTIONS(3973),
    [anon_sym_STAR_EQ] = ACTIONS(3973),
    [anon_sym_SLASH_EQ] = ACTIONS(3973),
    [anon_sym_AT_EQ] = ACTIONS(3973),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3973),
    [anon_sym_PERCENT_EQ] = ACTIONS(3973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3973),
    [anon_sym_GT_GT_EQ] = ACTIONS(3973),
    [anon_sym_LT_LT_EQ] = ACTIONS(3973),
    [anon_sym_AMP_EQ] = ACTIONS(3973),
    [anon_sym_CARET_EQ] = ACTIONS(3973),
    [anon_sym_PIPE_EQ] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3973),
  },
  [1679] = {
    [sym__expression] = STATE(1419),
    [sym__primary_expression] = STATE(565),
    [sym_not_operator] = STATE(1419),
    [sym_boolean_operator] = STATE(1419),
    [sym_binary_operator] = STATE(565),
    [sym_unary_operator] = STATE(565),
    [sym_comparison_operator] = STATE(1419),
    [sym_lambda] = STATE(1419),
    [sym_attribute] = STATE(565),
    [sym_subscript] = STATE(565),
    [sym_slice] = STATE(1420),
    [sym_call] = STATE(565),
    [sym_list] = STATE(565),
    [sym_list_comprehension] = STATE(565),
    [sym_dictionary] = STATE(565),
    [sym_dictionary_comprehension] = STATE(565),
    [sym_set] = STATE(565),
    [sym_set_comprehension] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_tuple] = STATE(565),
    [sym_generator_expression] = STATE(565),
    [sym_conditional_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(565),
    [sym_string] = STATE(567),
    [sym_await] = STATE(1419),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_lambda] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [sym_identifier] = ACTIONS(991),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_none] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(73),
  },
  [1680] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_PERCENT] = ACTIONS(2031),
    [anon_sym_SLASH_SLASH] = ACTIONS(2031),
    [anon_sym_STAR_STAR] = ACTIONS(2037),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_CARET] = ACTIONS(2043),
    [anon_sym_LT_LT] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(2951),
    [sym_comment] = ACTIONS(73),
  },
  [1681] = {
    [anon_sym_if] = ACTIONS(1119),
    [anon_sym_and] = ACTIONS(1121),
    [anon_sym_or] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(3574),
    [sym_type_conversion] = ACTIONS(3574),
    [sym_comment] = ACTIONS(73),
  },
  [1682] = {
    [aux_sym_dotted_name_repeat1] = STATE(1682),
    [anon_sym_DOT] = ACTIONS(2122),
    [anon_sym_RPAREN] = ACTIONS(2108),
    [anon_sym_COMMA] = ACTIONS(2108),
    [anon_sym_as] = ACTIONS(2108),
    [sym_comment] = ACTIONS(73),
  },
  [1683] = {
    [anon_sym_RPAREN] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2113),
    [sym_comment] = ACTIONS(73),
  },
  [1684] = {
    [anon_sym_RPAREN] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2113),
    [anon_sym_as] = ACTIONS(3027),
    [sym_comment] = ACTIONS(73),
  },
  [1685] = {
    [sym_aliased_import] = STATE(1683),
    [sym_dotted_name] = STATE(1684),
    [anon_sym_RPAREN] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2125),
    [sym_comment] = ACTIONS(73),
  },
  [1686] = {
    [aux_sym__import_list_repeat1] = STATE(1686),
    [anon_sym_RPAREN] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(3977),
    [sym_comment] = ACTIONS(73),
  },
  [1687] = {
    [anon_sym_RPAREN] = ACTIONS(2120),
    [anon_sym_COMMA] = ACTIONS(2120),
    [sym_comment] = ACTIONS(73),
  },
  [1688] = {
    [anon_sym_RPAREN] = ACTIONS(3574),
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1689] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1831),
    [anon_sym_RPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_async] = ACTIONS(3980),
    [anon_sym_for] = ACTIONS(3980),
    [sym_comment] = ACTIONS(73),
  },
  [1690] = {
    [sym__expression_within_for_in_clause] = STATE(1832),
    [sym__expression] = STATE(1456),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(1456),
    [sym_boolean_operator] = STATE(1456),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(1456),
    [sym_lambda] = STATE(1456),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(1456),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(1456),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1691] = {
    [anon_sym_COLON] = ACTIONS(3984),
    [sym_comment] = ACTIONS(73),
  },
  [1692] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1456),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(1456),
    [sym_boolean_operator] = STATE(1456),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(1456),
    [sym_lambda] = STATE(1456),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(1456),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(1456),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3980),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(3986),
    [anon_sym_async] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3986),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1693] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1835),
    [anon_sym_RPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_async] = ACTIONS(3980),
    [anon_sym_for] = ACTIONS(3980),
    [sym_comment] = ACTIONS(73),
  },
  [1694] = {
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3068),
    [sym_comment] = ACTIONS(73),
  },
  [1695] = {
    [sym__expression] = STATE(1836),
    [sym__primary_expression] = STATE(1122),
    [sym_not_operator] = STATE(1836),
    [sym_boolean_operator] = STATE(1836),
    [sym_binary_operator] = STATE(1122),
    [sym_unary_operator] = STATE(1122),
    [sym_comparison_operator] = STATE(1836),
    [sym_lambda] = STATE(1836),
    [sym_attribute] = STATE(1122),
    [sym_subscript] = STATE(1122),
    [sym_call] = STATE(1122),
    [sym_list] = STATE(1122),
    [sym_list_comprehension] = STATE(1122),
    [sym_dictionary] = STATE(1122),
    [sym_dictionary_comprehension] = STATE(1122),
    [sym_set] = STATE(1122),
    [sym_set_comprehension] = STATE(1122),
    [sym_parenthesized_expression] = STATE(1122),
    [sym_tuple] = STATE(1122),
    [sym_generator_expression] = STATE(1122),
    [sym_conditional_expression] = STATE(1836),
    [sym_concatenated_string] = STATE(1122),
    [sym_string] = STATE(1123),
    [sym_await] = STATE(1836),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_lambda] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2215),
    [sym_float] = ACTIONS(2215),
    [sym_identifier] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_none] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2217),
    [sym_comment] = ACTIONS(73),
  },
  [1696] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3990),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1697] = {
    [anon_sym_RPAREN] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1698] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1699] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_SLASH_SLASH] = ACTIONS(3076),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1700] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_GT_GT] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_SLASH_SLASH] = ACTIONS(3076),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_CARET] = ACTIONS(3088),
    [anon_sym_LT_LT] = ACTIONS(3072),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1701] = {
    [sym__primary_expression] = STATE(1838),
    [sym_binary_operator] = STATE(1838),
    [sym_unary_operator] = STATE(1838),
    [sym_attribute] = STATE(1838),
    [sym_subscript] = STATE(1838),
    [sym_call] = STATE(1838),
    [sym_list] = STATE(1838),
    [sym_list_comprehension] = STATE(1838),
    [sym_dictionary] = STATE(1838),
    [sym_dictionary_comprehension] = STATE(1838),
    [sym_set] = STATE(1838),
    [sym_set_comprehension] = STATE(1838),
    [sym_parenthesized_expression] = STATE(1838),
    [sym_tuple] = STATE(1838),
    [sym_generator_expression] = STATE(1838),
    [sym_concatenated_string] = STATE(1838),
    [sym_string] = STATE(1123),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3992),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3994),
    [sym_float] = ACTIONS(3994),
    [sym_identifier] = ACTIONS(3994),
    [sym_true] = ACTIONS(3994),
    [sym_false] = ACTIONS(3994),
    [sym_none] = ACTIONS(3994),
    [sym_comment] = ACTIONS(73),
  },
  [1702] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_SLASH_SLASH] = ACTIONS(3076),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1703] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_GT_GT] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_SLASH_SLASH] = ACTIONS(3076),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_CARET] = ACTIONS(3088),
    [anon_sym_LT_LT] = ACTIONS(3072),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1704] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_GT_GT] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_SLASH_SLASH] = ACTIONS(3076),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(3088),
    [anon_sym_LT_LT] = ACTIONS(3072),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1705] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_GT_GT] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_SLASH_SLASH] = ACTIONS(3076),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(3072),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1706] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1706),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(3996),
    [anon_sym_EQ_EQ] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_GT_EQ] = ACTIONS(3996),
    [anon_sym_GT] = ACTIONS(4002),
    [anon_sym_LT_GT] = ACTIONS(3996),
    [anon_sym_is] = ACTIONS(4005),
    [sym_comment] = ACTIONS(73),
  },
  [1707] = {
    [sym_string] = STATE(1707),
    [aux_sym_concatenated_string_repeat1] = STATE(1707),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_async] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1708] = {
    [anon_sym_DOT] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3967),
    [anon_sym_RPAREN] = ACTIONS(3967),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_STAR] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3967),
    [anon_sym_if] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3967),
    [anon_sym_else] = ACTIONS(3967),
    [anon_sym_async] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3967),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_EQ] = ACTIONS(3969),
    [anon_sym_AT] = ACTIONS(3967),
    [anon_sym_not] = ACTIONS(3967),
    [anon_sym_and] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_SLASH] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH] = ACTIONS(3967),
    [anon_sym_STAR_STAR] = ACTIONS(3967),
    [anon_sym_PIPE] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_CARET] = ACTIONS(3967),
    [anon_sym_LT_LT] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3969),
    [anon_sym_LT_GT] = ACTIONS(3967),
    [anon_sym_is] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_RBRACK] = ACTIONS(3967),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [sym_type_conversion] = ACTIONS(3967),
    [sym_comment] = ACTIONS(73),
  },
  [1709] = {
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_RPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_as] = ACTIONS(3975),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_GT_GT] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_COLON] = ACTIONS(3973),
    [anon_sym_else] = ACTIONS(3973),
    [anon_sym_async] = ACTIONS(3973),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_in] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_AT] = ACTIONS(3973),
    [anon_sym_not] = ACTIONS(3973),
    [anon_sym_and] = ACTIONS(3973),
    [anon_sym_or] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_SLASH] = ACTIONS(3975),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_SLASH_SLASH] = ACTIONS(3973),
    [anon_sym_STAR_STAR] = ACTIONS(3973),
    [anon_sym_PIPE] = ACTIONS(3973),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_CARET] = ACTIONS(3973),
    [anon_sym_LT_LT] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_LT_EQ] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_LT_GT] = ACTIONS(3973),
    [anon_sym_is] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_RBRACK] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(3973),
    [sym_type_conversion] = ACTIONS(3973),
    [sym_comment] = ACTIONS(73),
  },
  [1710] = {
    [sym__newline] = ACTIONS(3967),
    [anon_sym_DOT] = ACTIONS(3967),
    [anon_sym_from] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3967),
    [anon_sym_COMMA] = ACTIONS(3967),
    [anon_sym_STAR] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3967),
    [anon_sym_if] = ACTIONS(3967),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_EQ] = ACTIONS(3969),
    [anon_sym_AT] = ACTIONS(3967),
    [anon_sym_not] = ACTIONS(3967),
    [anon_sym_and] = ACTIONS(3967),
    [anon_sym_or] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_SLASH] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3967),
    [anon_sym_SLASH_SLASH] = ACTIONS(3967),
    [anon_sym_STAR_STAR] = ACTIONS(3967),
    [anon_sym_PIPE] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_CARET] = ACTIONS(3967),
    [anon_sym_LT_LT] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3969),
    [anon_sym_LT_GT] = ACTIONS(3967),
    [anon_sym_is] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3967),
  },
  [1711] = {
    [sym__newline] = ACTIONS(3973),
    [anon_sym_DOT] = ACTIONS(3973),
    [anon_sym_from] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(3973),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_GT_GT] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_in] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_AT] = ACTIONS(3973),
    [anon_sym_not] = ACTIONS(3973),
    [anon_sym_and] = ACTIONS(3973),
    [anon_sym_or] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_SLASH] = ACTIONS(3975),
    [anon_sym_PERCENT] = ACTIONS(3973),
    [anon_sym_SLASH_SLASH] = ACTIONS(3973),
    [anon_sym_STAR_STAR] = ACTIONS(3973),
    [anon_sym_PIPE] = ACTIONS(3973),
    [anon_sym_AMP] = ACTIONS(3973),
    [anon_sym_CARET] = ACTIONS(3973),
    [anon_sym_LT_LT] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(3975),
    [anon_sym_LT_EQ] = ACTIONS(3973),
    [anon_sym_EQ_EQ] = ACTIONS(3973),
    [anon_sym_BANG_EQ] = ACTIONS(3973),
    [anon_sym_GT_EQ] = ACTIONS(3973),
    [anon_sym_GT] = ACTIONS(3975),
    [anon_sym_LT_GT] = ACTIONS(3973),
    [anon_sym_is] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3973),
  },
  [1712] = {
    [sym__newline] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_and] = ACTIONS(1391),
    [anon_sym_or] = ACTIONS(1393),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3574),
  },
  [1713] = {
    [sym__simple_statements] = STATE(1839),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1839),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1714] = {
    [sym__string_start] = ACTIONS(4008),
    [ts_builtin_sym_end] = ACTIONS(4008),
    [anon_sym_import] = ACTIONS(4010),
    [anon_sym_from] = ACTIONS(4010),
    [anon_sym_LPAREN] = ACTIONS(4008),
    [anon_sym_print] = ACTIONS(4010),
    [anon_sym_assert] = ACTIONS(4010),
    [anon_sym_return] = ACTIONS(4010),
    [anon_sym_del] = ACTIONS(4010),
    [anon_sym_raise] = ACTIONS(4010),
    [anon_sym_pass] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4010),
    [anon_sym_continue] = ACTIONS(4010),
    [anon_sym_if] = ACTIONS(4010),
    [anon_sym_async] = ACTIONS(4010),
    [anon_sym_for] = ACTIONS(4010),
    [anon_sym_while] = ACTIONS(4010),
    [anon_sym_try] = ACTIONS(4010),
    [anon_sym_finally] = ACTIONS(4010),
    [anon_sym_with] = ACTIONS(4010),
    [anon_sym_def] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4010),
    [anon_sym_nonlocal] = ACTIONS(4010),
    [anon_sym_exec] = ACTIONS(4010),
    [anon_sym_class] = ACTIONS(4010),
    [anon_sym_AT] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_PLUS] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(4008),
    [anon_sym_TILDE] = ACTIONS(4008),
    [anon_sym_lambda] = ACTIONS(4010),
    [anon_sym_yield] = ACTIONS(4010),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [sym_ellipsis] = ACTIONS(4008),
    [anon_sym_LBRACE] = ACTIONS(4008),
    [sym_integer] = ACTIONS(4010),
    [sym_float] = ACTIONS(4010),
    [sym_identifier] = ACTIONS(4010),
    [sym_true] = ACTIONS(4010),
    [sym_false] = ACTIONS(4010),
    [sym_none] = ACTIONS(4010),
    [anon_sym_await] = ACTIONS(4010),
    [sym_comment] = ACTIONS(73),
  },
  [1715] = {
    [sym_else_clause] = STATE(1840),
    [sym__string_start] = ACTIONS(4012),
    [ts_builtin_sym_end] = ACTIONS(4012),
    [anon_sym_import] = ACTIONS(4014),
    [anon_sym_from] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(4012),
    [anon_sym_print] = ACTIONS(4014),
    [anon_sym_assert] = ACTIONS(4014),
    [anon_sym_return] = ACTIONS(4014),
    [anon_sym_del] = ACTIONS(4014),
    [anon_sym_raise] = ACTIONS(4014),
    [anon_sym_pass] = ACTIONS(4014),
    [anon_sym_break] = ACTIONS(4014),
    [anon_sym_continue] = ACTIONS(4014),
    [anon_sym_if] = ACTIONS(4014),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(4014),
    [anon_sym_for] = ACTIONS(4014),
    [anon_sym_while] = ACTIONS(4014),
    [anon_sym_try] = ACTIONS(4014),
    [anon_sym_with] = ACTIONS(4014),
    [anon_sym_def] = ACTIONS(4014),
    [anon_sym_global] = ACTIONS(4014),
    [anon_sym_nonlocal] = ACTIONS(4014),
    [anon_sym_exec] = ACTIONS(4014),
    [anon_sym_class] = ACTIONS(4014),
    [anon_sym_AT] = ACTIONS(4012),
    [anon_sym_not] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [anon_sym_lambda] = ACTIONS(4014),
    [anon_sym_yield] = ACTIONS(4014),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [sym_ellipsis] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [sym_integer] = ACTIONS(4014),
    [sym_float] = ACTIONS(4014),
    [sym_identifier] = ACTIONS(4014),
    [sym_true] = ACTIONS(4014),
    [sym_false] = ACTIONS(4014),
    [sym_none] = ACTIONS(4014),
    [anon_sym_await] = ACTIONS(4014),
    [sym_comment] = ACTIONS(73),
  },
  [1716] = {
    [sym__simple_statements] = STATE(1841),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1841),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1717] = {
    [sym__string_start] = ACTIONS(4012),
    [ts_builtin_sym_end] = ACTIONS(4012),
    [anon_sym_import] = ACTIONS(4014),
    [anon_sym_from] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(4012),
    [anon_sym_print] = ACTIONS(4014),
    [anon_sym_assert] = ACTIONS(4014),
    [anon_sym_return] = ACTIONS(4014),
    [anon_sym_del] = ACTIONS(4014),
    [anon_sym_raise] = ACTIONS(4014),
    [anon_sym_pass] = ACTIONS(4014),
    [anon_sym_break] = ACTIONS(4014),
    [anon_sym_continue] = ACTIONS(4014),
    [anon_sym_if] = ACTIONS(4014),
    [anon_sym_async] = ACTIONS(4014),
    [anon_sym_for] = ACTIONS(4014),
    [anon_sym_while] = ACTIONS(4014),
    [anon_sym_try] = ACTIONS(4014),
    [anon_sym_with] = ACTIONS(4014),
    [anon_sym_def] = ACTIONS(4014),
    [anon_sym_global] = ACTIONS(4014),
    [anon_sym_nonlocal] = ACTIONS(4014),
    [anon_sym_exec] = ACTIONS(4014),
    [anon_sym_class] = ACTIONS(4014),
    [anon_sym_AT] = ACTIONS(4012),
    [anon_sym_not] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [anon_sym_lambda] = ACTIONS(4014),
    [anon_sym_yield] = ACTIONS(4014),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [sym_ellipsis] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [sym_integer] = ACTIONS(4014),
    [sym_float] = ACTIONS(4014),
    [sym_identifier] = ACTIONS(4014),
    [sym_true] = ACTIONS(4014),
    [sym_false] = ACTIONS(4014),
    [sym_none] = ACTIONS(4014),
    [anon_sym_await] = ACTIONS(4014),
    [sym_comment] = ACTIONS(73),
  },
  [1718] = {
    [sym__expression] = STATE(1504),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(1504),
    [sym_boolean_operator] = STATE(1504),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(1504),
    [sym_lambda] = STATE(1504),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(1504),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(1504),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [1719] = {
    [sym__statement] = STATE(1843),
    [sym__simple_statements] = STATE(1843),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_if_statement] = STATE(1843),
    [sym_for_statement] = STATE(1843),
    [sym_while_statement] = STATE(1843),
    [sym_try_statement] = STATE(1843),
    [sym_with_statement] = STATE(1843),
    [sym_function_definition] = STATE(1843),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym_class_definition] = STATE(1843),
    [sym_decorated_definition] = STATE(1843),
    [sym_decorator] = STATE(798),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1843),
    [aux_sym_decorated_definition_repeat1] = STATE(798),
    [sym__dedent] = ACTIONS(4016),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_try] = ACTIONS(1541),
    [anon_sym_with] = ACTIONS(1543),
    [anon_sym_def] = ACTIONS(1545),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1720] = {
    [sym_elif_clause] = STATE(1847),
    [sym_else_clause] = STATE(1846),
    [aux_sym_if_statement_repeat1] = STATE(1847),
    [sym__dedent] = ACTIONS(2374),
    [sym__string_start] = ACTIONS(2374),
    [anon_sym_import] = ACTIONS(2376),
    [anon_sym_from] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2374),
    [anon_sym_print] = ACTIONS(2376),
    [anon_sym_assert] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_del] = ACTIONS(2376),
    [anon_sym_raise] = ACTIONS(2376),
    [anon_sym_pass] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_elif] = ACTIONS(4018),
    [anon_sym_else] = ACTIONS(4020),
    [anon_sym_async] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_with] = ACTIONS(2376),
    [anon_sym_def] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2376),
    [anon_sym_nonlocal] = ACTIONS(2376),
    [anon_sym_exec] = ACTIONS(2376),
    [anon_sym_class] = ACTIONS(2376),
    [anon_sym_AT] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_TILDE] = ACTIONS(2374),
    [anon_sym_lambda] = ACTIONS(2376),
    [anon_sym_yield] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [sym_ellipsis] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2374),
    [sym_integer] = ACTIONS(2376),
    [sym_float] = ACTIONS(2376),
    [sym_identifier] = ACTIONS(2376),
    [sym_true] = ACTIONS(2376),
    [sym_false] = ACTIONS(2376),
    [sym_none] = ACTIONS(2376),
    [anon_sym_await] = ACTIONS(2376),
    [sym_comment] = ACTIONS(73),
  },
  [1721] = {
    [sym_expression_list] = STATE(1848),
    [sym__expression] = STATE(775),
    [sym__primary_expression] = STATE(430),
    [sym_not_operator] = STATE(775),
    [sym_boolean_operator] = STATE(775),
    [sym_binary_operator] = STATE(430),
    [sym_unary_operator] = STATE(430),
    [sym_comparison_operator] = STATE(775),
    [sym_lambda] = STATE(775),
    [sym_attribute] = STATE(430),
    [sym_subscript] = STATE(430),
    [sym_call] = STATE(430),
    [sym_list] = STATE(430),
    [sym_list_comprehension] = STATE(430),
    [sym_dictionary] = STATE(430),
    [sym_dictionary_comprehension] = STATE(430),
    [sym_set] = STATE(430),
    [sym_set_comprehension] = STATE(430),
    [sym_parenthesized_expression] = STATE(430),
    [sym_tuple] = STATE(430),
    [sym_generator_expression] = STATE(430),
    [sym_conditional_expression] = STATE(775),
    [sym_concatenated_string] = STATE(430),
    [sym_string] = STATE(431),
    [sym_await] = STATE(775),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_lambda] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [sym_identifier] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_none] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
  },
  [1722] = {
    [sym__simple_statements] = STATE(1849),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1849),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1723] = {
    [aux_sym_with_statement_repeat1] = STATE(810),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(4022),
    [sym_comment] = ACTIONS(73),
  },
  [1724] = {
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_DASH_GT] = ACTIONS(4026),
    [sym_comment] = ACTIONS(73),
  },
  [1725] = {
    [anon_sym_COLON] = ACTIONS(4028),
    [sym_comment] = ACTIONS(73),
  },
  [1726] = {
    [sym_else_clause] = STATE(1854),
    [sym__dedent] = ACTIONS(2415),
    [sym__string_start] = ACTIONS(2415),
    [anon_sym_import] = ACTIONS(2417),
    [anon_sym_from] = ACTIONS(2417),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_print] = ACTIONS(2417),
    [anon_sym_assert] = ACTIONS(2417),
    [anon_sym_return] = ACTIONS(2417),
    [anon_sym_del] = ACTIONS(2417),
    [anon_sym_raise] = ACTIONS(2417),
    [anon_sym_pass] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2417),
    [anon_sym_continue] = ACTIONS(2417),
    [anon_sym_if] = ACTIONS(2417),
    [anon_sym_else] = ACTIONS(4020),
    [anon_sym_async] = ACTIONS(2417),
    [anon_sym_for] = ACTIONS(2417),
    [anon_sym_while] = ACTIONS(2417),
    [anon_sym_try] = ACTIONS(2417),
    [anon_sym_with] = ACTIONS(2417),
    [anon_sym_def] = ACTIONS(2417),
    [anon_sym_global] = ACTIONS(2417),
    [anon_sym_nonlocal] = ACTIONS(2417),
    [anon_sym_exec] = ACTIONS(2417),
    [anon_sym_class] = ACTIONS(2417),
    [anon_sym_AT] = ACTIONS(2415),
    [anon_sym_not] = ACTIONS(2417),
    [anon_sym_PLUS] = ACTIONS(2415),
    [anon_sym_DASH] = ACTIONS(2415),
    [anon_sym_TILDE] = ACTIONS(2415),
    [anon_sym_lambda] = ACTIONS(2417),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [sym_ellipsis] = ACTIONS(2415),
    [anon_sym_LBRACE] = ACTIONS(2415),
    [sym_integer] = ACTIONS(2417),
    [sym_float] = ACTIONS(2417),
    [sym_identifier] = ACTIONS(2417),
    [sym_true] = ACTIONS(2417),
    [sym_false] = ACTIONS(2417),
    [sym_none] = ACTIONS(2417),
    [anon_sym_await] = ACTIONS(2417),
    [sym_comment] = ACTIONS(73),
  },
  [1727] = {
    [sym__expression] = STATE(1856),
    [sym__primary_expression] = STATE(118),
    [sym_not_operator] = STATE(1856),
    [sym_boolean_operator] = STATE(1856),
    [sym_binary_operator] = STATE(118),
    [sym_unary_operator] = STATE(118),
    [sym_comparison_operator] = STATE(1856),
    [sym_lambda] = STATE(1856),
    [sym_attribute] = STATE(118),
    [sym_subscript] = STATE(118),
    [sym_call] = STATE(118),
    [sym_list] = STATE(118),
    [sym_list_comprehension] = STATE(118),
    [sym_dictionary] = STATE(118),
    [sym_dictionary_comprehension] = STATE(118),
    [sym_set] = STATE(118),
    [sym_set_comprehension] = STATE(118),
    [sym_parenthesized_expression] = STATE(118),
    [sym_tuple] = STATE(118),
    [sym_generator_expression] = STATE(118),
    [sym_conditional_expression] = STATE(1856),
    [sym_concatenated_string] = STATE(118),
    [sym_string] = STATE(119),
    [sym_await] = STATE(1856),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(4030),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [1728] = {
    [anon_sym_COLON] = ACTIONS(4032),
    [sym_comment] = ACTIONS(73),
  },
  [1729] = {
    [sym__dedent] = ACTIONS(2453),
    [sym__string_start] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_from] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_print] = ACTIONS(2455),
    [anon_sym_assert] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_del] = ACTIONS(2455),
    [anon_sym_raise] = ACTIONS(2455),
    [anon_sym_pass] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_with] = ACTIONS(2455),
    [anon_sym_def] = ACTIONS(2455),
    [anon_sym_global] = ACTIONS(2455),
    [anon_sym_nonlocal] = ACTIONS(2455),
    [anon_sym_exec] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_lambda] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [sym_ellipsis] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [sym_integer] = ACTIONS(2455),
    [sym_float] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [sym_false] = ACTIONS(2455),
    [sym_none] = ACTIONS(2455),
    [anon_sym_await] = ACTIONS(2455),
    [sym_comment] = ACTIONS(73),
  },
  [1730] = {
    [sym_else_clause] = STATE(1858),
    [sym_except_clause] = STATE(1860),
    [sym_finally_clause] = STATE(1859),
    [aux_sym_try_statement_repeat1] = STATE(1860),
    [sym__dedent] = ACTIONS(2453),
    [sym__string_start] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_from] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_print] = ACTIONS(2455),
    [anon_sym_assert] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_del] = ACTIONS(2455),
    [anon_sym_raise] = ACTIONS(2455),
    [anon_sym_pass] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_else] = ACTIONS(4020),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_except] = ACTIONS(4034),
    [anon_sym_finally] = ACTIONS(4036),
    [anon_sym_with] = ACTIONS(2455),
    [anon_sym_def] = ACTIONS(2455),
    [anon_sym_global] = ACTIONS(2455),
    [anon_sym_nonlocal] = ACTIONS(2455),
    [anon_sym_exec] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_TILDE] = ACTIONS(2453),
    [anon_sym_lambda] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [sym_ellipsis] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2453),
    [sym_integer] = ACTIONS(2455),
    [sym_float] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [sym_false] = ACTIONS(2455),
    [sym_none] = ACTIONS(2455),
    [anon_sym_await] = ACTIONS(2455),
    [sym_comment] = ACTIONS(73),
  },
  [1731] = {
    [sym__dedent] = ACTIONS(2463),
    [sym__string_start] = ACTIONS(2463),
    [anon_sym_import] = ACTIONS(2465),
    [anon_sym_from] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2463),
    [anon_sym_print] = ACTIONS(2465),
    [anon_sym_assert] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_del] = ACTIONS(2465),
    [anon_sym_raise] = ACTIONS(2465),
    [anon_sym_pass] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_async] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_while] = ACTIONS(2465),
    [anon_sym_try] = ACTIONS(2465),
    [anon_sym_with] = ACTIONS(2465),
    [anon_sym_def] = ACTIONS(2465),
    [anon_sym_global] = ACTIONS(2465),
    [anon_sym_nonlocal] = ACTIONS(2465),
    [anon_sym_exec] = ACTIONS(2465),
    [anon_sym_class] = ACTIONS(2465),
    [anon_sym_AT] = ACTIONS(2463),
    [anon_sym_not] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2463),
    [anon_sym_DASH] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_lambda] = ACTIONS(2465),
    [anon_sym_yield] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [sym_ellipsis] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [sym_integer] = ACTIONS(2465),
    [sym_float] = ACTIONS(2465),
    [sym_identifier] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_none] = ACTIONS(2465),
    [anon_sym_await] = ACTIONS(2465),
    [sym_comment] = ACTIONS(73),
  },
  [1732] = {
    [sym__simple_statements] = STATE(1861),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1861),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1733] = {
    [sym__expression] = STATE(1239),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1239),
    [sym_boolean_operator] = STATE(1239),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1239),
    [sym_lambda] = STATE(1239),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_type] = STATE(1862),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1239),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1239),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1734] = {
    [sym__dedent] = ACTIONS(2529),
    [sym__string_start] = ACTIONS(2529),
    [anon_sym_import] = ACTIONS(2531),
    [anon_sym_from] = ACTIONS(2531),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_print] = ACTIONS(2531),
    [anon_sym_assert] = ACTIONS(2531),
    [anon_sym_return] = ACTIONS(2531),
    [anon_sym_del] = ACTIONS(2531),
    [anon_sym_raise] = ACTIONS(2531),
    [anon_sym_pass] = ACTIONS(2531),
    [anon_sym_break] = ACTIONS(2531),
    [anon_sym_continue] = ACTIONS(2531),
    [anon_sym_if] = ACTIONS(2531),
    [anon_sym_async] = ACTIONS(2531),
    [anon_sym_for] = ACTIONS(2531),
    [anon_sym_while] = ACTIONS(2531),
    [anon_sym_try] = ACTIONS(2531),
    [anon_sym_with] = ACTIONS(2531),
    [anon_sym_def] = ACTIONS(2531),
    [anon_sym_global] = ACTIONS(2531),
    [anon_sym_nonlocal] = ACTIONS(2531),
    [anon_sym_exec] = ACTIONS(2531),
    [anon_sym_class] = ACTIONS(2531),
    [anon_sym_AT] = ACTIONS(2529),
    [anon_sym_not] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_lambda] = ACTIONS(2531),
    [anon_sym_yield] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [sym_ellipsis] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(2529),
    [sym_integer] = ACTIONS(2531),
    [sym_float] = ACTIONS(2531),
    [sym_identifier] = ACTIONS(2531),
    [sym_true] = ACTIONS(2531),
    [sym_false] = ACTIONS(2531),
    [sym_none] = ACTIONS(2531),
    [anon_sym_await] = ACTIONS(2531),
    [sym_comment] = ACTIONS(73),
  },
  [1735] = {
    [sym__simple_statements] = STATE(1863),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1863),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1736] = {
    [sym__dedent] = ACTIONS(2869),
    [sym__string_start] = ACTIONS(2869),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_from] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2869),
    [anon_sym_print] = ACTIONS(2871),
    [anon_sym_assert] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_del] = ACTIONS(2871),
    [anon_sym_raise] = ACTIONS(2871),
    [anon_sym_pass] = ACTIONS(2871),
    [anon_sym_break] = ACTIONS(2871),
    [anon_sym_continue] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_elif] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2871),
    [anon_sym_async] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_except] = ACTIONS(2871),
    [anon_sym_finally] = ACTIONS(2871),
    [anon_sym_with] = ACTIONS(2871),
    [anon_sym_def] = ACTIONS(2871),
    [anon_sym_global] = ACTIONS(2871),
    [anon_sym_nonlocal] = ACTIONS(2871),
    [anon_sym_exec] = ACTIONS(2871),
    [anon_sym_class] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_not] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2869),
    [anon_sym_lambda] = ACTIONS(2871),
    [anon_sym_yield] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2869),
    [sym_ellipsis] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [sym_integer] = ACTIONS(2871),
    [sym_float] = ACTIONS(2871),
    [sym_identifier] = ACTIONS(2871),
    [sym_true] = ACTIONS(2871),
    [sym_false] = ACTIONS(2871),
    [sym_none] = ACTIONS(2871),
    [anon_sym_await] = ACTIONS(2871),
    [sym_comment] = ACTIONS(73),
  },
  [1737] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(4038),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [1738] = {
    [sym__string_start] = ACTIONS(4040),
    [ts_builtin_sym_end] = ACTIONS(4040),
    [anon_sym_import] = ACTIONS(4042),
    [anon_sym_from] = ACTIONS(4042),
    [anon_sym_LPAREN] = ACTIONS(4040),
    [anon_sym_print] = ACTIONS(4042),
    [anon_sym_assert] = ACTIONS(4042),
    [anon_sym_return] = ACTIONS(4042),
    [anon_sym_del] = ACTIONS(4042),
    [anon_sym_raise] = ACTIONS(4042),
    [anon_sym_pass] = ACTIONS(4042),
    [anon_sym_break] = ACTIONS(4042),
    [anon_sym_continue] = ACTIONS(4042),
    [anon_sym_if] = ACTIONS(4042),
    [anon_sym_else] = ACTIONS(4042),
    [anon_sym_async] = ACTIONS(4042),
    [anon_sym_for] = ACTIONS(4042),
    [anon_sym_while] = ACTIONS(4042),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_except] = ACTIONS(4042),
    [anon_sym_finally] = ACTIONS(4042),
    [anon_sym_with] = ACTIONS(4042),
    [anon_sym_def] = ACTIONS(4042),
    [anon_sym_global] = ACTIONS(4042),
    [anon_sym_nonlocal] = ACTIONS(4042),
    [anon_sym_exec] = ACTIONS(4042),
    [anon_sym_class] = ACTIONS(4042),
    [anon_sym_AT] = ACTIONS(4040),
    [anon_sym_not] = ACTIONS(4042),
    [anon_sym_PLUS] = ACTIONS(4040),
    [anon_sym_DASH] = ACTIONS(4040),
    [anon_sym_TILDE] = ACTIONS(4040),
    [anon_sym_lambda] = ACTIONS(4042),
    [anon_sym_yield] = ACTIONS(4042),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [sym_ellipsis] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(4040),
    [sym_integer] = ACTIONS(4042),
    [sym_float] = ACTIONS(4042),
    [sym_identifier] = ACTIONS(4042),
    [sym_true] = ACTIONS(4042),
    [sym_false] = ACTIONS(4042),
    [sym_none] = ACTIONS(4042),
    [anon_sym_await] = ACTIONS(4042),
    [sym_comment] = ACTIONS(73),
  },
  [1739] = {
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(3236),
    [anon_sym_or] = ACTIONS(3238),
    [sym_comment] = ACTIONS(73),
  },
  [1740] = {
    [sym__expression] = STATE(1865),
    [sym__primary_expression] = STATE(1226),
    [sym_not_operator] = STATE(1865),
    [sym_boolean_operator] = STATE(1865),
    [sym_binary_operator] = STATE(1226),
    [sym_unary_operator] = STATE(1226),
    [sym_comparison_operator] = STATE(1865),
    [sym_lambda] = STATE(1865),
    [sym_attribute] = STATE(1226),
    [sym_subscript] = STATE(1226),
    [sym_call] = STATE(1226),
    [sym_list] = STATE(1226),
    [sym_list_comprehension] = STATE(1226),
    [sym_dictionary] = STATE(1226),
    [sym_dictionary_comprehension] = STATE(1226),
    [sym_set] = STATE(1226),
    [sym_set_comprehension] = STATE(1226),
    [sym_parenthesized_expression] = STATE(1226),
    [sym_tuple] = STATE(1226),
    [sym_generator_expression] = STATE(1226),
    [sym_conditional_expression] = STATE(1865),
    [sym_concatenated_string] = STATE(1226),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(1865),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_lambda] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2502),
    [sym_float] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_none] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [sym_comment] = ACTIONS(73),
  },
  [1741] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1742] = {
    [anon_sym_RPAREN] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_COLON] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(3236),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1743] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(3252),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1744] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3252),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1745] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3252),
    [anon_sym_PIPE] = ACTIONS(3254),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3242),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1746] = {
    [sym__primary_expression] = STATE(1867),
    [sym_binary_operator] = STATE(1867),
    [sym_unary_operator] = STATE(1867),
    [sym_attribute] = STATE(1867),
    [sym_subscript] = STATE(1867),
    [sym_call] = STATE(1867),
    [sym_list] = STATE(1867),
    [sym_list_comprehension] = STATE(1867),
    [sym_dictionary] = STATE(1867),
    [sym_dictionary_comprehension] = STATE(1867),
    [sym_set] = STATE(1867),
    [sym_set_comprehension] = STATE(1867),
    [sym_parenthesized_expression] = STATE(1867),
    [sym_tuple] = STATE(1867),
    [sym_generator_expression] = STATE(1867),
    [sym_concatenated_string] = STATE(1867),
    [sym_string] = STATE(1227),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4046),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4048),
    [sym_float] = ACTIONS(4048),
    [sym_identifier] = ACTIONS(4048),
    [sym_true] = ACTIONS(4048),
    [sym_false] = ACTIONS(4048),
    [sym_none] = ACTIONS(4048),
    [sym_comment] = ACTIONS(73),
  },
  [1747] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3252),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1748] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3252),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3242),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1749] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3252),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3242),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1750] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3252),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(3242),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1751] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1751),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(4050),
    [anon_sym_not] = ACTIONS(4053),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_GT_EQ] = ACTIONS(4050),
    [anon_sym_GT] = ACTIONS(4056),
    [anon_sym_LT_GT] = ACTIONS(4050),
    [anon_sym_is] = ACTIONS(4059),
    [sym_comment] = ACTIONS(73),
  },
  [1752] = {
    [sym_string] = STATE(1752),
    [aux_sym_concatenated_string_repeat1] = STATE(1752),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1753] = {
    [sym__expression] = STATE(1868),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1868),
    [sym_boolean_operator] = STATE(1868),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1868),
    [sym_lambda] = STATE(1868),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1868),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1868),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1754] = {
    [sym_default_parameter] = STATE(864),
    [sym_typed_default_parameter] = STATE(864),
    [sym_list_splat] = STATE(1549),
    [sym_dictionary_splat] = STATE(1549),
    [sym_typed_parameter] = STATE(864),
    [sym_tuple] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_print] = ACTIONS(3264),
    [anon_sym_exec] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3266),
    [sym_comment] = ACTIONS(73),
  },
  [1755] = {
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(3803),
    [anon_sym_or] = ACTIONS(3805),
    [sym_comment] = ACTIONS(73),
  },
  [1756] = {
    [sym__expression] = STATE(1869),
    [sym__primary_expression] = STATE(1559),
    [sym_not_operator] = STATE(1869),
    [sym_boolean_operator] = STATE(1869),
    [sym_binary_operator] = STATE(1559),
    [sym_unary_operator] = STATE(1559),
    [sym_comparison_operator] = STATE(1869),
    [sym_lambda] = STATE(1869),
    [sym_attribute] = STATE(1559),
    [sym_subscript] = STATE(1559),
    [sym_call] = STATE(1559),
    [sym_list] = STATE(1559),
    [sym_list_comprehension] = STATE(1559),
    [sym_dictionary] = STATE(1559),
    [sym_dictionary_comprehension] = STATE(1559),
    [sym_set] = STATE(1559),
    [sym_set_comprehension] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1559),
    [sym_tuple] = STATE(1559),
    [sym_generator_expression] = STATE(1559),
    [sym_conditional_expression] = STATE(1869),
    [sym_concatenated_string] = STATE(1559),
    [sym_string] = STATE(1561),
    [sym_await] = STATE(1869),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_lambda] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3278),
    [sym_float] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_none] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3280),
    [sym_comment] = ACTIONS(73),
  },
  [1757] = {
    [anon_sym_COLON] = ACTIONS(4062),
    [sym_comment] = ACTIONS(73),
  },
  [1758] = {
    [sym__expression] = STATE(1871),
    [sym__primary_expression] = STATE(536),
    [sym_not_operator] = STATE(1871),
    [sym_boolean_operator] = STATE(1871),
    [sym_binary_operator] = STATE(536),
    [sym_unary_operator] = STATE(536),
    [sym_comparison_operator] = STATE(1871),
    [sym_lambda] = STATE(1871),
    [sym_attribute] = STATE(536),
    [sym_subscript] = STATE(536),
    [sym_call] = STATE(536),
    [sym_list] = STATE(536),
    [sym_list_comprehension] = STATE(536),
    [sym_dictionary] = STATE(536),
    [sym_dictionary_comprehension] = STATE(536),
    [sym_set] = STATE(536),
    [sym_set_comprehension] = STATE(536),
    [sym_parenthesized_expression] = STATE(536),
    [sym_tuple] = STATE(536),
    [sym_generator_expression] = STATE(536),
    [sym_conditional_expression] = STATE(1871),
    [sym_concatenated_string] = STATE(536),
    [sym_string] = STATE(537),
    [sym_await] = STATE(1871),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_lambda] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [sym_identifier] = ACTIONS(927),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_none] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(929),
    [sym_comment] = ACTIONS(73),
  },
  [1759] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(1559),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(1559),
    [sym_unary_operator] = STATE(1559),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(1559),
    [sym_subscript] = STATE(1559),
    [sym_call] = STATE(1559),
    [sym_list] = STATE(1559),
    [sym_list_comprehension] = STATE(1559),
    [sym_dictionary] = STATE(1559),
    [sym_dictionary_comprehension] = STATE(1559),
    [sym_set] = STATE(1559),
    [sym_set_comprehension] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1559),
    [sym_tuple] = STATE(1559),
    [sym_generator_expression] = STATE(1559),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(1559),
    [sym_string] = STATE(1561),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_lambda] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3278),
    [sym_float] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_none] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3280),
    [sym_comment] = ACTIONS(73),
  },
  [1760] = {
    [sym__expression] = STATE(1872),
    [sym__primary_expression] = STATE(1559),
    [sym_not_operator] = STATE(1872),
    [sym_boolean_operator] = STATE(1872),
    [sym_binary_operator] = STATE(1559),
    [sym_unary_operator] = STATE(1559),
    [sym_comparison_operator] = STATE(1872),
    [sym_lambda] = STATE(1872),
    [sym_attribute] = STATE(1559),
    [sym_subscript] = STATE(1559),
    [sym_call] = STATE(1559),
    [sym_list] = STATE(1559),
    [sym_list_comprehension] = STATE(1559),
    [sym_dictionary] = STATE(1559),
    [sym_dictionary_comprehension] = STATE(1559),
    [sym_set] = STATE(1559),
    [sym_set_comprehension] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1559),
    [sym_tuple] = STATE(1559),
    [sym_generator_expression] = STATE(1559),
    [sym_conditional_expression] = STATE(1872),
    [sym_concatenated_string] = STATE(1559),
    [sym_string] = STATE(1561),
    [sym_await] = STATE(1872),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_lambda] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3278),
    [sym_float] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_none] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3280),
    [sym_comment] = ACTIONS(73),
  },
  [1761] = {
    [sym__primary_expression] = STATE(1873),
    [sym_binary_operator] = STATE(1873),
    [sym_unary_operator] = STATE(1873),
    [sym_attribute] = STATE(1873),
    [sym_subscript] = STATE(1873),
    [sym_call] = STATE(1873),
    [sym_list] = STATE(1873),
    [sym_list_comprehension] = STATE(1873),
    [sym_dictionary] = STATE(1873),
    [sym_dictionary_comprehension] = STATE(1873),
    [sym_set] = STATE(1873),
    [sym_set_comprehension] = STATE(1873),
    [sym_parenthesized_expression] = STATE(1873),
    [sym_tuple] = STATE(1873),
    [sym_generator_expression] = STATE(1873),
    [sym_concatenated_string] = STATE(1873),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4064),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4066),
    [sym_float] = ACTIONS(4066),
    [sym_identifier] = ACTIONS(4066),
    [sym_true] = ACTIONS(4066),
    [sym_false] = ACTIONS(4066),
    [sym_none] = ACTIONS(4066),
    [sym_comment] = ACTIONS(73),
  },
  [1762] = {
    [sym__primary_expression] = STATE(1874),
    [sym_binary_operator] = STATE(1874),
    [sym_unary_operator] = STATE(1874),
    [sym_attribute] = STATE(1874),
    [sym_subscript] = STATE(1874),
    [sym_call] = STATE(1874),
    [sym_list] = STATE(1874),
    [sym_list_comprehension] = STATE(1874),
    [sym_dictionary] = STATE(1874),
    [sym_dictionary_comprehension] = STATE(1874),
    [sym_set] = STATE(1874),
    [sym_set_comprehension] = STATE(1874),
    [sym_parenthesized_expression] = STATE(1874),
    [sym_tuple] = STATE(1874),
    [sym_generator_expression] = STATE(1874),
    [sym_concatenated_string] = STATE(1874),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4070),
    [sym_float] = ACTIONS(4070),
    [sym_identifier] = ACTIONS(4070),
    [sym_true] = ACTIONS(4070),
    [sym_false] = ACTIONS(4070),
    [sym_none] = ACTIONS(4070),
    [sym_comment] = ACTIONS(73),
  },
  [1763] = {
    [sym__primary_expression] = STATE(1875),
    [sym_binary_operator] = STATE(1875),
    [sym_unary_operator] = STATE(1875),
    [sym_attribute] = STATE(1875),
    [sym_subscript] = STATE(1875),
    [sym_call] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_list_comprehension] = STATE(1875),
    [sym_dictionary] = STATE(1875),
    [sym_dictionary_comprehension] = STATE(1875),
    [sym_set] = STATE(1875),
    [sym_set_comprehension] = STATE(1875),
    [sym_parenthesized_expression] = STATE(1875),
    [sym_tuple] = STATE(1875),
    [sym_generator_expression] = STATE(1875),
    [sym_concatenated_string] = STATE(1875),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4074),
    [sym_float] = ACTIONS(4074),
    [sym_identifier] = ACTIONS(4074),
    [sym_true] = ACTIONS(4074),
    [sym_false] = ACTIONS(4074),
    [sym_none] = ACTIONS(4074),
    [sym_comment] = ACTIONS(73),
  },
  [1764] = {
    [anon_sym_in] = ACTIONS(4076),
    [sym_comment] = ACTIONS(73),
  },
  [1765] = {
    [sym__primary_expression] = STATE(1877),
    [sym_binary_operator] = STATE(1877),
    [sym_unary_operator] = STATE(1877),
    [sym_attribute] = STATE(1877),
    [sym_subscript] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_list] = STATE(1877),
    [sym_list_comprehension] = STATE(1877),
    [sym_dictionary] = STATE(1877),
    [sym_dictionary_comprehension] = STATE(1877),
    [sym_set] = STATE(1877),
    [sym_set_comprehension] = STATE(1877),
    [sym_parenthesized_expression] = STATE(1877),
    [sym_tuple] = STATE(1877),
    [sym_generator_expression] = STATE(1877),
    [sym_concatenated_string] = STATE(1877),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4078),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4080),
    [sym_float] = ACTIONS(4080),
    [sym_identifier] = ACTIONS(4080),
    [sym_true] = ACTIONS(4080),
    [sym_false] = ACTIONS(4080),
    [sym_none] = ACTIONS(4080),
    [sym_comment] = ACTIONS(73),
  },
  [1766] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1295),
    [sym_float] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_none] = ACTIONS(1295),
    [sym_comment] = ACTIONS(73),
  },
  [1767] = {
    [sym__primary_expression] = STATE(1878),
    [sym_binary_operator] = STATE(1878),
    [sym_unary_operator] = STATE(1878),
    [sym_attribute] = STATE(1878),
    [sym_subscript] = STATE(1878),
    [sym_call] = STATE(1878),
    [sym_list] = STATE(1878),
    [sym_list_comprehension] = STATE(1878),
    [sym_dictionary] = STATE(1878),
    [sym_dictionary_comprehension] = STATE(1878),
    [sym_set] = STATE(1878),
    [sym_set_comprehension] = STATE(1878),
    [sym_parenthesized_expression] = STATE(1878),
    [sym_tuple] = STATE(1878),
    [sym_generator_expression] = STATE(1878),
    [sym_concatenated_string] = STATE(1878),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4082),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4084),
    [sym_float] = ACTIONS(4084),
    [sym_identifier] = ACTIONS(4084),
    [sym_true] = ACTIONS(4084),
    [sym_false] = ACTIONS(4084),
    [sym_none] = ACTIONS(4084),
    [sym_comment] = ACTIONS(73),
  },
  [1768] = {
    [sym__primary_expression] = STATE(1879),
    [sym_binary_operator] = STATE(1879),
    [sym_unary_operator] = STATE(1879),
    [sym_attribute] = STATE(1879),
    [sym_subscript] = STATE(1879),
    [sym_call] = STATE(1879),
    [sym_list] = STATE(1879),
    [sym_list_comprehension] = STATE(1879),
    [sym_dictionary] = STATE(1879),
    [sym_dictionary_comprehension] = STATE(1879),
    [sym_set] = STATE(1879),
    [sym_set_comprehension] = STATE(1879),
    [sym_parenthesized_expression] = STATE(1879),
    [sym_tuple] = STATE(1879),
    [sym_generator_expression] = STATE(1879),
    [sym_concatenated_string] = STATE(1879),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4088),
    [sym_float] = ACTIONS(4088),
    [sym_identifier] = ACTIONS(4088),
    [sym_true] = ACTIONS(4088),
    [sym_false] = ACTIONS(4088),
    [sym_none] = ACTIONS(4088),
    [sym_comment] = ACTIONS(73),
  },
  [1769] = {
    [sym__primary_expression] = STATE(1880),
    [sym_binary_operator] = STATE(1880),
    [sym_unary_operator] = STATE(1880),
    [sym_attribute] = STATE(1880),
    [sym_subscript] = STATE(1880),
    [sym_call] = STATE(1880),
    [sym_list] = STATE(1880),
    [sym_list_comprehension] = STATE(1880),
    [sym_dictionary] = STATE(1880),
    [sym_dictionary_comprehension] = STATE(1880),
    [sym_set] = STATE(1880),
    [sym_set_comprehension] = STATE(1880),
    [sym_parenthesized_expression] = STATE(1880),
    [sym_tuple] = STATE(1880),
    [sym_generator_expression] = STATE(1880),
    [sym_concatenated_string] = STATE(1880),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4090),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4092),
    [sym_float] = ACTIONS(4092),
    [sym_identifier] = ACTIONS(4092),
    [sym_true] = ACTIONS(4092),
    [sym_false] = ACTIONS(4092),
    [sym_none] = ACTIONS(4092),
    [sym_comment] = ACTIONS(73),
  },
  [1770] = {
    [sym__primary_expression] = STATE(1875),
    [sym_binary_operator] = STATE(1875),
    [sym_unary_operator] = STATE(1875),
    [sym_attribute] = STATE(1875),
    [sym_subscript] = STATE(1875),
    [sym_call] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_list_comprehension] = STATE(1875),
    [sym_dictionary] = STATE(1875),
    [sym_dictionary_comprehension] = STATE(1875),
    [sym_set] = STATE(1875),
    [sym_set_comprehension] = STATE(1875),
    [sym_parenthesized_expression] = STATE(1875),
    [sym_tuple] = STATE(1875),
    [sym_generator_expression] = STATE(1875),
    [sym_concatenated_string] = STATE(1875),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4074),
    [sym_float] = ACTIONS(4074),
    [sym_identifier] = ACTIONS(4074),
    [sym_true] = ACTIONS(4074),
    [sym_false] = ACTIONS(4074),
    [sym_none] = ACTIONS(4074),
    [sym_comment] = ACTIONS(73),
  },
  [1771] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1881),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(3811),
    [anon_sym_EQ] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(3815),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(3827),
    [anon_sym_LT_EQ] = ACTIONS(3811),
    [anon_sym_EQ_EQ] = ACTIONS(3811),
    [anon_sym_BANG_EQ] = ACTIONS(3811),
    [anon_sym_GT_EQ] = ACTIONS(3811),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_LT_GT] = ACTIONS(3811),
    [anon_sym_is] = ACTIONS(3829),
    [sym_comment] = ACTIONS(73),
  },
  [1772] = {
    [sym__expression] = STATE(1882),
    [sym__primary_expression] = STATE(235),
    [sym_not_operator] = STATE(1882),
    [sym_boolean_operator] = STATE(1882),
    [sym_binary_operator] = STATE(235),
    [sym_unary_operator] = STATE(235),
    [sym_comparison_operator] = STATE(1882),
    [sym_lambda] = STATE(1882),
    [sym_attribute] = STATE(235),
    [sym_subscript] = STATE(235),
    [sym_call] = STATE(235),
    [sym_list] = STATE(235),
    [sym_list_comprehension] = STATE(235),
    [sym_dictionary] = STATE(235),
    [sym_dictionary_comprehension] = STATE(235),
    [sym_set] = STATE(235),
    [sym_set_comprehension] = STATE(235),
    [sym_parenthesized_expression] = STATE(235),
    [sym_tuple] = STATE(235),
    [sym_generator_expression] = STATE(235),
    [sym_conditional_expression] = STATE(1882),
    [sym_concatenated_string] = STATE(235),
    [sym_string] = STATE(236),
    [sym_await] = STATE(1882),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_lambda] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(423),
    [sym_float] = ACTIONS(423),
    [sym_identifier] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_none] = ACTIONS(423),
    [anon_sym_await] = ACTIONS(425),
    [sym_comment] = ACTIONS(73),
  },
  [1773] = {
    [sym_string] = STATE(1883),
    [aux_sym_concatenated_string_repeat1] = STATE(1883),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_RPAREN] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1003),
    [anon_sym_SLASH_SLASH] = ACTIONS(1003),
    [anon_sym_STAR_STAR] = ACTIONS(1003),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1003),
    [anon_sym_LT_LT] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_GT_EQ] = ACTIONS(1003),
    [anon_sym_GT] = ACTIONS(1005),
    [anon_sym_LT_GT] = ACTIONS(1003),
    [anon_sym_is] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_comment] = ACTIONS(73),
  },
  [1774] = {
    [sym__string_start] = ACTIONS(4096),
    [ts_builtin_sym_end] = ACTIONS(4096),
    [anon_sym_import] = ACTIONS(4098),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4096),
    [anon_sym_print] = ACTIONS(4098),
    [anon_sym_assert] = ACTIONS(4098),
    [anon_sym_return] = ACTIONS(4098),
    [anon_sym_del] = ACTIONS(4098),
    [anon_sym_raise] = ACTIONS(4098),
    [anon_sym_pass] = ACTIONS(4098),
    [anon_sym_break] = ACTIONS(4098),
    [anon_sym_continue] = ACTIONS(4098),
    [anon_sym_if] = ACTIONS(4098),
    [anon_sym_async] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4098),
    [anon_sym_while] = ACTIONS(4098),
    [anon_sym_try] = ACTIONS(4098),
    [anon_sym_with] = ACTIONS(4098),
    [anon_sym_def] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_nonlocal] = ACTIONS(4098),
    [anon_sym_exec] = ACTIONS(4098),
    [anon_sym_class] = ACTIONS(4098),
    [anon_sym_AT] = ACTIONS(4096),
    [anon_sym_not] = ACTIONS(4098),
    [anon_sym_PLUS] = ACTIONS(4096),
    [anon_sym_DASH] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [anon_sym_lambda] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(4096),
    [sym_ellipsis] = ACTIONS(4096),
    [anon_sym_LBRACE] = ACTIONS(4096),
    [sym_integer] = ACTIONS(4098),
    [sym_float] = ACTIONS(4098),
    [sym_identifier] = ACTIONS(4098),
    [sym_true] = ACTIONS(4098),
    [sym_false] = ACTIONS(4098),
    [sym_none] = ACTIONS(4098),
    [anon_sym_await] = ACTIONS(4098),
    [sym_comment] = ACTIONS(73),
  },
  [1775] = {
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(1623),
    [anon_sym_or] = ACTIONS(1625),
    [sym_comment] = ACTIONS(73),
  },
  [1776] = {
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_EQ] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(2579),
    [anon_sym_or] = ACTIONS(2581),
    [sym_comment] = ACTIONS(73),
  },
  [1777] = {
    [sym__expression] = STATE(1884),
    [sym__primary_expression] = STATE(871),
    [sym_not_operator] = STATE(1884),
    [sym_boolean_operator] = STATE(1884),
    [sym_binary_operator] = STATE(871),
    [sym_unary_operator] = STATE(871),
    [sym_comparison_operator] = STATE(1884),
    [sym_lambda] = STATE(1884),
    [sym_attribute] = STATE(871),
    [sym_subscript] = STATE(871),
    [sym_call] = STATE(871),
    [sym_list] = STATE(871),
    [sym_list_comprehension] = STATE(871),
    [sym_dictionary] = STATE(871),
    [sym_dictionary_comprehension] = STATE(871),
    [sym_set] = STATE(871),
    [sym_set_comprehension] = STATE(871),
    [sym_parenthesized_expression] = STATE(871),
    [sym_tuple] = STATE(871),
    [sym_generator_expression] = STATE(871),
    [sym_conditional_expression] = STATE(1884),
    [sym_concatenated_string] = STATE(871),
    [sym_string] = STATE(873),
    [sym_await] = STATE(1884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1659),
    [anon_sym_lambda] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1665),
    [sym_float] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1665),
    [sym_true] = ACTIONS(1665),
    [sym_false] = ACTIONS(1665),
    [sym_none] = ACTIONS(1665),
    [anon_sym_await] = ACTIONS(1667),
    [sym_comment] = ACTIONS(73),
  },
  [1778] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2583),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_SLASH_SLASH] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_CARET] = ACTIONS(2601),
    [anon_sym_LT_LT] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1779] = {
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2618),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2622),
    [sym_comment] = ACTIONS(73),
  },
  [1780] = {
    [sym__expression] = STATE(1885),
    [sym__primary_expression] = STATE(882),
    [sym_not_operator] = STATE(1885),
    [sym_boolean_operator] = STATE(1885),
    [sym_binary_operator] = STATE(882),
    [sym_unary_operator] = STATE(882),
    [sym_comparison_operator] = STATE(1885),
    [sym_lambda] = STATE(1885),
    [sym_attribute] = STATE(882),
    [sym_subscript] = STATE(882),
    [sym_call] = STATE(882),
    [sym_list] = STATE(882),
    [sym_list_comprehension] = STATE(882),
    [sym_dictionary] = STATE(882),
    [sym_dictionary_comprehension] = STATE(882),
    [sym_set] = STATE(882),
    [sym_set_comprehension] = STATE(882),
    [sym_parenthesized_expression] = STATE(882),
    [sym_tuple] = STATE(882),
    [sym_generator_expression] = STATE(882),
    [sym_conditional_expression] = STATE(1885),
    [sym_concatenated_string] = STATE(882),
    [sym_string] = STATE(884),
    [sym_await] = STATE(1885),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_lambda] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1683),
    [sym_float] = ACTIONS(1683),
    [sym_identifier] = ACTIONS(1683),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_none] = ACTIONS(1683),
    [anon_sym_await] = ACTIONS(1685),
    [sym_comment] = ACTIONS(73),
  },
  [1781] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_SLASH_SLASH] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1782] = {
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(3574),
    [sym_comment] = ACTIONS(73),
  },
  [1783] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1887),
    [anon_sym_COMMA] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_async] = ACTIONS(3980),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_RBRACK] = ACTIONS(3980),
    [sym_comment] = ACTIONS(73),
  },
  [1784] = {
    [sym__expression_within_for_in_clause] = STATE(1832),
    [sym__expression] = STATE(1606),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(1606),
    [sym_boolean_operator] = STATE(1606),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(1606),
    [sym_lambda] = STATE(1606),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(1606),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(1606),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1785] = {
    [anon_sym_COLON] = ACTIONS(4102),
    [sym_comment] = ACTIONS(73),
  },
  [1786] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1606),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(1606),
    [sym_boolean_operator] = STATE(1606),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(1606),
    [sym_lambda] = STATE(1606),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(1606),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(1606),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(3986),
    [anon_sym_async] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3986),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3980),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1787] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1889),
    [anon_sym_COMMA] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_async] = ACTIONS(3980),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_RBRACK] = ACTIONS(3980),
    [sym_comment] = ACTIONS(73),
  },
  [1788] = {
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(3412),
    [anon_sym_or] = ACTIONS(3414),
    [anon_sym_RBRACK] = ACTIONS(1671),
    [sym_comment] = ACTIONS(73),
  },
  [1789] = {
    [sym__expression] = STATE(1890),
    [sym__primary_expression] = STATE(1321),
    [sym_not_operator] = STATE(1890),
    [sym_boolean_operator] = STATE(1890),
    [sym_binary_operator] = STATE(1321),
    [sym_unary_operator] = STATE(1321),
    [sym_comparison_operator] = STATE(1890),
    [sym_lambda] = STATE(1890),
    [sym_attribute] = STATE(1321),
    [sym_subscript] = STATE(1321),
    [sym_call] = STATE(1321),
    [sym_list] = STATE(1321),
    [sym_list_comprehension] = STATE(1321),
    [sym_dictionary] = STATE(1321),
    [sym_dictionary_comprehension] = STATE(1321),
    [sym_set] = STATE(1321),
    [sym_set_comprehension] = STATE(1321),
    [sym_parenthesized_expression] = STATE(1321),
    [sym_tuple] = STATE(1321),
    [sym_generator_expression] = STATE(1321),
    [sym_conditional_expression] = STATE(1890),
    [sym_concatenated_string] = STATE(1321),
    [sym_string] = STATE(1322),
    [sym_await] = STATE(1890),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_lambda] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2719),
    [sym_float] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2719),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [sym_none] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(2721),
    [sym_comment] = ACTIONS(73),
  },
  [1790] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(4106),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1791] = {
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(3412),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_RBRACK] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1792] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1793] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3422),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3426),
    [anon_sym_DASH] = ACTIONS(3426),
    [anon_sym_SLASH] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1794] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_GT_GT] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(3422),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(3426),
    [anon_sym_DASH] = ACTIONS(3426),
    [anon_sym_SLASH] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(3430),
    [anon_sym_AMP] = ACTIONS(3432),
    [anon_sym_CARET] = ACTIONS(3434),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1795] = {
    [sym__primary_expression] = STATE(1892),
    [sym_binary_operator] = STATE(1892),
    [sym_unary_operator] = STATE(1892),
    [sym_attribute] = STATE(1892),
    [sym_subscript] = STATE(1892),
    [sym_call] = STATE(1892),
    [sym_list] = STATE(1892),
    [sym_list_comprehension] = STATE(1892),
    [sym_dictionary] = STATE(1892),
    [sym_dictionary_comprehension] = STATE(1892),
    [sym_set] = STATE(1892),
    [sym_set_comprehension] = STATE(1892),
    [sym_parenthesized_expression] = STATE(1892),
    [sym_tuple] = STATE(1892),
    [sym_generator_expression] = STATE(1892),
    [sym_concatenated_string] = STATE(1892),
    [sym_string] = STATE(1322),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4108),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4110),
    [sym_float] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(4110),
    [sym_true] = ACTIONS(4110),
    [sym_false] = ACTIONS(4110),
    [sym_none] = ACTIONS(4110),
    [sym_comment] = ACTIONS(73),
  },
  [1796] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3422),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1797] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_GT_GT] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3422),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3426),
    [anon_sym_DASH] = ACTIONS(3426),
    [anon_sym_SLASH] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(3432),
    [anon_sym_CARET] = ACTIONS(3434),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1798] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_GT_GT] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3422),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3426),
    [anon_sym_DASH] = ACTIONS(3426),
    [anon_sym_SLASH] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(3434),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1799] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_GT_GT] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3422),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3426),
    [anon_sym_DASH] = ACTIONS(3426),
    [anon_sym_SLASH] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1800] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1800),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(4112),
    [anon_sym_not] = ACTIONS(4115),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4118),
    [anon_sym_LT_EQ] = ACTIONS(4112),
    [anon_sym_EQ_EQ] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_GT_EQ] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_LT_GT] = ACTIONS(4112),
    [anon_sym_is] = ACTIONS(4121),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1801] = {
    [sym_string] = STATE(1801),
    [aux_sym_concatenated_string_repeat1] = STATE(1801),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_async] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1802] = {
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(1777),
    [anon_sym_and] = ACTIONS(1779),
    [anon_sym_or] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(3574),
    [sym_comment] = ACTIONS(73),
  },
  [1803] = {
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(73),
  },
  [1804] = {
    [sym__expression] = STATE(1893),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1893),
    [sym_boolean_operator] = STATE(1893),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1893),
    [sym_lambda] = STATE(1893),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1893),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1893),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1805] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_async] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(2813),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [sym_comment] = ACTIONS(73),
  },
  [1806] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1895),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_async] = ACTIONS(3980),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_RBRACE] = ACTIONS(3980),
    [sym_comment] = ACTIONS(73),
  },
  [1807] = {
    [sym__expression_within_for_in_clause] = STATE(1832),
    [sym__expression] = STATE(1647),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1647),
    [sym_boolean_operator] = STATE(1647),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1647),
    [sym_lambda] = STATE(1647),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1647),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1808] = {
    [anon_sym_COLON] = ACTIONS(4126),
    [sym_comment] = ACTIONS(73),
  },
  [1809] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1647),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1647),
    [sym_boolean_operator] = STATE(1647),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1647),
    [sym_lambda] = STATE(1647),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1647),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(3986),
    [anon_sym_async] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3986),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3980),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1810] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1897),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_async] = ACTIONS(3980),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_RBRACE] = ACTIONS(3980),
    [sym_comment] = ACTIONS(73),
  },
  [1811] = {
    [anon_sym_if] = ACTIONS(4128),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3517),
    [anon_sym_RBRACE] = ACTIONS(1671),
    [sym_comment] = ACTIONS(73),
  },
  [1812] = {
    [sym__expression] = STATE(1898),
    [sym__primary_expression] = STATE(1371),
    [sym_not_operator] = STATE(1898),
    [sym_boolean_operator] = STATE(1898),
    [sym_binary_operator] = STATE(1371),
    [sym_unary_operator] = STATE(1371),
    [sym_comparison_operator] = STATE(1898),
    [sym_lambda] = STATE(1898),
    [sym_attribute] = STATE(1371),
    [sym_subscript] = STATE(1371),
    [sym_call] = STATE(1371),
    [sym_list] = STATE(1371),
    [sym_list_comprehension] = STATE(1371),
    [sym_dictionary] = STATE(1371),
    [sym_dictionary_comprehension] = STATE(1371),
    [sym_set] = STATE(1371),
    [sym_set_comprehension] = STATE(1371),
    [sym_parenthesized_expression] = STATE(1371),
    [sym_tuple] = STATE(1371),
    [sym_generator_expression] = STATE(1371),
    [sym_conditional_expression] = STATE(1898),
    [sym_concatenated_string] = STATE(1371),
    [sym_string] = STATE(1372),
    [sym_await] = STATE(1898),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2845),
    [sym_float] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [anon_sym_await] = ACTIONS(2847),
    [sym_comment] = ACTIONS(73),
  },
  [1813] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(4130),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1814] = {
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(1968),
    [anon_sym_RBRACE] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1815] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1816] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH] = ACTIONS(3525),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1817] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_GT_GT] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH] = ACTIONS(3525),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_CARET] = ACTIONS(3537),
    [anon_sym_LT_LT] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1818] = {
    [sym__primary_expression] = STATE(1900),
    [sym_binary_operator] = STATE(1900),
    [sym_unary_operator] = STATE(1900),
    [sym_attribute] = STATE(1900),
    [sym_subscript] = STATE(1900),
    [sym_call] = STATE(1900),
    [sym_list] = STATE(1900),
    [sym_list_comprehension] = STATE(1900),
    [sym_dictionary] = STATE(1900),
    [sym_dictionary_comprehension] = STATE(1900),
    [sym_set] = STATE(1900),
    [sym_set_comprehension] = STATE(1900),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_tuple] = STATE(1900),
    [sym_generator_expression] = STATE(1900),
    [sym_concatenated_string] = STATE(1900),
    [sym_string] = STATE(1372),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4132),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4134),
    [sym_float] = ACTIONS(4134),
    [sym_identifier] = ACTIONS(4134),
    [sym_true] = ACTIONS(4134),
    [sym_false] = ACTIONS(4134),
    [sym_none] = ACTIONS(4134),
    [sym_comment] = ACTIONS(73),
  },
  [1819] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH] = ACTIONS(3525),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1820] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_GT_GT] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH] = ACTIONS(3525),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_CARET] = ACTIONS(3537),
    [anon_sym_LT_LT] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1821] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_GT_GT] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH] = ACTIONS(3525),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(3537),
    [anon_sym_LT_LT] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1822] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_GT_GT] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH] = ACTIONS(3525),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1823] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1823),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4139),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_LT_GT] = ACTIONS(4136),
    [anon_sym_is] = ACTIONS(4145),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(73),
  },
  [1824] = {
    [sym_string] = STATE(1824),
    [aux_sym_concatenated_string_repeat1] = STATE(1824),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_async] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1825] = {
    [sym__newline] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_EQ] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(1894),
    [anon_sym_or] = ACTIONS(1896),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3574),
  },
  [1826] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1827] = {
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_COLON] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_RBRACK] = ACTIONS(3574),
    [sym_comment] = ACTIONS(73),
  },
  [1828] = {
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [sym_comment] = ACTIONS(73),
  },
  [1829] = {
    [sym_aliased_import] = STATE(1683),
    [sym_dotted_name] = STATE(1684),
    [sym_identifier] = ACTIONS(2125),
    [sym_comment] = ACTIONS(73),
  },
  [1830] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1456),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(1456),
    [sym_boolean_operator] = STATE(1456),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(1456),
    [sym_lambda] = STATE(1456),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(1456),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(1456),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(4150),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4152),
    [anon_sym_async] = ACTIONS(4152),
    [anon_sym_for] = ACTIONS(4152),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1831] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1835),
    [anon_sym_RPAREN] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_async] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [sym_comment] = ACTIONS(73),
  },
  [1832] = {
    [anon_sym_RPAREN] = ACTIONS(4156),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_if] = ACTIONS(4156),
    [anon_sym_async] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4156),
    [anon_sym_RBRACK] = ACTIONS(4156),
    [anon_sym_RBRACE] = ACTIONS(4156),
    [sym_comment] = ACTIONS(73),
  },
  [1833] = {
    [sym__expression_within_for_in_clause] = STATE(1902),
    [sym__expression] = STATE(1456),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(1456),
    [sym_boolean_operator] = STATE(1456),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(1456),
    [sym_lambda] = STATE(1456),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(1456),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(1456),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1834] = {
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_async] = ACTIONS(4158),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_RBRACK] = ACTIONS(4158),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [sym_comment] = ACTIONS(73),
  },
  [1835] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1835),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_async] = ACTIONS(4158),
    [anon_sym_for] = ACTIONS(4158),
    [sym_comment] = ACTIONS(73),
  },
  [1836] = {
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3068),
    [sym_comment] = ACTIONS(73),
  },
  [1837] = {
    [sym__expression] = STATE(1904),
    [sym__primary_expression] = STATE(1122),
    [sym_not_operator] = STATE(1904),
    [sym_boolean_operator] = STATE(1904),
    [sym_binary_operator] = STATE(1122),
    [sym_unary_operator] = STATE(1122),
    [sym_comparison_operator] = STATE(1904),
    [sym_lambda] = STATE(1904),
    [sym_attribute] = STATE(1122),
    [sym_subscript] = STATE(1122),
    [sym_call] = STATE(1122),
    [sym_list] = STATE(1122),
    [sym_list_comprehension] = STATE(1122),
    [sym_dictionary] = STATE(1122),
    [sym_dictionary_comprehension] = STATE(1122),
    [sym_set] = STATE(1122),
    [sym_set_comprehension] = STATE(1122),
    [sym_parenthesized_expression] = STATE(1122),
    [sym_tuple] = STATE(1122),
    [sym_generator_expression] = STATE(1122),
    [sym_conditional_expression] = STATE(1904),
    [sym_concatenated_string] = STATE(1122),
    [sym_string] = STATE(1123),
    [sym_await] = STATE(1904),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2209),
    [anon_sym_lambda] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2215),
    [sym_float] = ACTIONS(2215),
    [sym_identifier] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_none] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2217),
    [sym_comment] = ACTIONS(73),
  },
  [1838] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_GT_GT] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_async] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_SLASH_SLASH] = ACTIONS(3076),
    [anon_sym_STAR_STAR] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_CARET] = ACTIONS(3088),
    [anon_sym_LT_LT] = ACTIONS(3072),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1839] = {
    [sym__string_start] = ACTIONS(4163),
    [ts_builtin_sym_end] = ACTIONS(4163),
    [anon_sym_import] = ACTIONS(4165),
    [anon_sym_from] = ACTIONS(4165),
    [anon_sym_LPAREN] = ACTIONS(4163),
    [anon_sym_print] = ACTIONS(4165),
    [anon_sym_assert] = ACTIONS(4165),
    [anon_sym_return] = ACTIONS(4165),
    [anon_sym_del] = ACTIONS(4165),
    [anon_sym_raise] = ACTIONS(4165),
    [anon_sym_pass] = ACTIONS(4165),
    [anon_sym_break] = ACTIONS(4165),
    [anon_sym_continue] = ACTIONS(4165),
    [anon_sym_if] = ACTIONS(4165),
    [anon_sym_elif] = ACTIONS(4165),
    [anon_sym_else] = ACTIONS(4165),
    [anon_sym_async] = ACTIONS(4165),
    [anon_sym_for] = ACTIONS(4165),
    [anon_sym_while] = ACTIONS(4165),
    [anon_sym_try] = ACTIONS(4165),
    [anon_sym_with] = ACTIONS(4165),
    [anon_sym_def] = ACTIONS(4165),
    [anon_sym_global] = ACTIONS(4165),
    [anon_sym_nonlocal] = ACTIONS(4165),
    [anon_sym_exec] = ACTIONS(4165),
    [anon_sym_class] = ACTIONS(4165),
    [anon_sym_AT] = ACTIONS(4163),
    [anon_sym_not] = ACTIONS(4165),
    [anon_sym_PLUS] = ACTIONS(4163),
    [anon_sym_DASH] = ACTIONS(4163),
    [anon_sym_TILDE] = ACTIONS(4163),
    [anon_sym_lambda] = ACTIONS(4165),
    [anon_sym_yield] = ACTIONS(4165),
    [anon_sym_LBRACK] = ACTIONS(4163),
    [sym_ellipsis] = ACTIONS(4163),
    [anon_sym_LBRACE] = ACTIONS(4163),
    [sym_integer] = ACTIONS(4165),
    [sym_float] = ACTIONS(4165),
    [sym_identifier] = ACTIONS(4165),
    [sym_true] = ACTIONS(4165),
    [sym_false] = ACTIONS(4165),
    [sym_none] = ACTIONS(4165),
    [anon_sym_await] = ACTIONS(4165),
    [sym_comment] = ACTIONS(73),
  },
  [1840] = {
    [sym__string_start] = ACTIONS(4167),
    [ts_builtin_sym_end] = ACTIONS(4167),
    [anon_sym_import] = ACTIONS(4169),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_print] = ACTIONS(4169),
    [anon_sym_assert] = ACTIONS(4169),
    [anon_sym_return] = ACTIONS(4169),
    [anon_sym_del] = ACTIONS(4169),
    [anon_sym_raise] = ACTIONS(4169),
    [anon_sym_pass] = ACTIONS(4169),
    [anon_sym_break] = ACTIONS(4169),
    [anon_sym_continue] = ACTIONS(4169),
    [anon_sym_if] = ACTIONS(4169),
    [anon_sym_async] = ACTIONS(4169),
    [anon_sym_for] = ACTIONS(4169),
    [anon_sym_while] = ACTIONS(4169),
    [anon_sym_try] = ACTIONS(4169),
    [anon_sym_with] = ACTIONS(4169),
    [anon_sym_def] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_nonlocal] = ACTIONS(4169),
    [anon_sym_exec] = ACTIONS(4169),
    [anon_sym_class] = ACTIONS(4169),
    [anon_sym_AT] = ACTIONS(4167),
    [anon_sym_not] = ACTIONS(4169),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_DASH] = ACTIONS(4167),
    [anon_sym_TILDE] = ACTIONS(4167),
    [anon_sym_lambda] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [sym_ellipsis] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4167),
    [sym_integer] = ACTIONS(4169),
    [sym_float] = ACTIONS(4169),
    [sym_identifier] = ACTIONS(4169),
    [sym_true] = ACTIONS(4169),
    [sym_false] = ACTIONS(4169),
    [sym_none] = ACTIONS(4169),
    [anon_sym_await] = ACTIONS(4169),
    [sym_comment] = ACTIONS(73),
  },
  [1841] = {
    [sym__string_start] = ACTIONS(4171),
    [ts_builtin_sym_end] = ACTIONS(4171),
    [anon_sym_import] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4173),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_print] = ACTIONS(4173),
    [anon_sym_assert] = ACTIONS(4173),
    [anon_sym_return] = ACTIONS(4173),
    [anon_sym_del] = ACTIONS(4173),
    [anon_sym_raise] = ACTIONS(4173),
    [anon_sym_pass] = ACTIONS(4173),
    [anon_sym_break] = ACTIONS(4173),
    [anon_sym_continue] = ACTIONS(4173),
    [anon_sym_if] = ACTIONS(4173),
    [anon_sym_async] = ACTIONS(4173),
    [anon_sym_for] = ACTIONS(4173),
    [anon_sym_while] = ACTIONS(4173),
    [anon_sym_try] = ACTIONS(4173),
    [anon_sym_with] = ACTIONS(4173),
    [anon_sym_def] = ACTIONS(4173),
    [anon_sym_global] = ACTIONS(4173),
    [anon_sym_nonlocal] = ACTIONS(4173),
    [anon_sym_exec] = ACTIONS(4173),
    [anon_sym_class] = ACTIONS(4173),
    [anon_sym_AT] = ACTIONS(4171),
    [anon_sym_not] = ACTIONS(4173),
    [anon_sym_PLUS] = ACTIONS(4171),
    [anon_sym_DASH] = ACTIONS(4171),
    [anon_sym_TILDE] = ACTIONS(4171),
    [anon_sym_lambda] = ACTIONS(4173),
    [anon_sym_yield] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [sym_ellipsis] = ACTIONS(4171),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [sym_integer] = ACTIONS(4173),
    [sym_float] = ACTIONS(4173),
    [sym_identifier] = ACTIONS(4173),
    [sym_true] = ACTIONS(4173),
    [sym_false] = ACTIONS(4173),
    [sym_none] = ACTIONS(4173),
    [anon_sym_await] = ACTIONS(4173),
    [sym_comment] = ACTIONS(73),
  },
  [1842] = {
    [sym__dedent] = ACTIONS(2419),
    [sym__string_start] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(3151),
    [anon_sym_from] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [anon_sym_print] = ACTIONS(3151),
    [anon_sym_assert] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_del] = ACTIONS(3151),
    [anon_sym_raise] = ACTIONS(3151),
    [anon_sym_pass] = ACTIONS(3151),
    [anon_sym_break] = ACTIONS(3151),
    [anon_sym_continue] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_elif] = ACTIONS(3151),
    [anon_sym_else] = ACTIONS(3151),
    [anon_sym_async] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [anon_sym_try] = ACTIONS(3151),
    [anon_sym_except] = ACTIONS(3151),
    [anon_sym_finally] = ACTIONS(3151),
    [anon_sym_with] = ACTIONS(3151),
    [anon_sym_def] = ACTIONS(3151),
    [anon_sym_global] = ACTIONS(3151),
    [anon_sym_nonlocal] = ACTIONS(3151),
    [anon_sym_exec] = ACTIONS(3151),
    [anon_sym_class] = ACTIONS(3151),
    [anon_sym_AT] = ACTIONS(2419),
    [anon_sym_not] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(2419),
    [anon_sym_DASH] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2419),
    [anon_sym_lambda] = ACTIONS(3151),
    [anon_sym_yield] = ACTIONS(3151),
    [anon_sym_LBRACK] = ACTIONS(2419),
    [sym_ellipsis] = ACTIONS(2419),
    [anon_sym_LBRACE] = ACTIONS(2419),
    [sym_integer] = ACTIONS(3151),
    [sym_float] = ACTIONS(3151),
    [sym_identifier] = ACTIONS(3151),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_none] = ACTIONS(3151),
    [anon_sym_await] = ACTIONS(3151),
    [sym_comment] = ACTIONS(73),
  },
  [1843] = {
    [sym__statement] = STATE(1206),
    [sym__simple_statements] = STATE(1206),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_if_statement] = STATE(1206),
    [sym_for_statement] = STATE(1206),
    [sym_while_statement] = STATE(1206),
    [sym_try_statement] = STATE(1206),
    [sym_with_statement] = STATE(1206),
    [sym_function_definition] = STATE(1206),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym_class_definition] = STATE(1206),
    [sym_decorated_definition] = STATE(1206),
    [sym_decorator] = STATE(798),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1206),
    [aux_sym_decorated_definition_repeat1] = STATE(798),
    [sym__dedent] = ACTIONS(4175),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_try] = ACTIONS(1541),
    [anon_sym_with] = ACTIONS(1543),
    [anon_sym_def] = ACTIONS(1545),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1844] = {
    [sym__expression] = STATE(1906),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1906),
    [sym_boolean_operator] = STATE(1906),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1906),
    [sym_lambda] = STATE(1906),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1906),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1906),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1845] = {
    [anon_sym_COLON] = ACTIONS(4177),
    [sym_comment] = ACTIONS(73),
  },
  [1846] = {
    [sym__dedent] = ACTIONS(3157),
    [sym__string_start] = ACTIONS(3157),
    [anon_sym_import] = ACTIONS(3159),
    [anon_sym_from] = ACTIONS(3159),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [anon_sym_print] = ACTIONS(3159),
    [anon_sym_assert] = ACTIONS(3159),
    [anon_sym_return] = ACTIONS(3159),
    [anon_sym_del] = ACTIONS(3159),
    [anon_sym_raise] = ACTIONS(3159),
    [anon_sym_pass] = ACTIONS(3159),
    [anon_sym_break] = ACTIONS(3159),
    [anon_sym_continue] = ACTIONS(3159),
    [anon_sym_if] = ACTIONS(3159),
    [anon_sym_async] = ACTIONS(3159),
    [anon_sym_for] = ACTIONS(3159),
    [anon_sym_while] = ACTIONS(3159),
    [anon_sym_try] = ACTIONS(3159),
    [anon_sym_with] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(3159),
    [anon_sym_global] = ACTIONS(3159),
    [anon_sym_nonlocal] = ACTIONS(3159),
    [anon_sym_exec] = ACTIONS(3159),
    [anon_sym_class] = ACTIONS(3159),
    [anon_sym_AT] = ACTIONS(3157),
    [anon_sym_not] = ACTIONS(3159),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_lambda] = ACTIONS(3159),
    [anon_sym_yield] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [sym_ellipsis] = ACTIONS(3157),
    [anon_sym_LBRACE] = ACTIONS(3157),
    [sym_integer] = ACTIONS(3159),
    [sym_float] = ACTIONS(3159),
    [sym_identifier] = ACTIONS(3159),
    [sym_true] = ACTIONS(3159),
    [sym_false] = ACTIONS(3159),
    [sym_none] = ACTIONS(3159),
    [anon_sym_await] = ACTIONS(3159),
    [sym_comment] = ACTIONS(73),
  },
  [1847] = {
    [sym_elif_clause] = STATE(1909),
    [sym_else_clause] = STATE(1908),
    [aux_sym_if_statement_repeat1] = STATE(1909),
    [sym__dedent] = ACTIONS(3157),
    [sym__string_start] = ACTIONS(3157),
    [anon_sym_import] = ACTIONS(3159),
    [anon_sym_from] = ACTIONS(3159),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [anon_sym_print] = ACTIONS(3159),
    [anon_sym_assert] = ACTIONS(3159),
    [anon_sym_return] = ACTIONS(3159),
    [anon_sym_del] = ACTIONS(3159),
    [anon_sym_raise] = ACTIONS(3159),
    [anon_sym_pass] = ACTIONS(3159),
    [anon_sym_break] = ACTIONS(3159),
    [anon_sym_continue] = ACTIONS(3159),
    [anon_sym_if] = ACTIONS(3159),
    [anon_sym_elif] = ACTIONS(4018),
    [anon_sym_else] = ACTIONS(4020),
    [anon_sym_async] = ACTIONS(3159),
    [anon_sym_for] = ACTIONS(3159),
    [anon_sym_while] = ACTIONS(3159),
    [anon_sym_try] = ACTIONS(3159),
    [anon_sym_with] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(3159),
    [anon_sym_global] = ACTIONS(3159),
    [anon_sym_nonlocal] = ACTIONS(3159),
    [anon_sym_exec] = ACTIONS(3159),
    [anon_sym_class] = ACTIONS(3159),
    [anon_sym_AT] = ACTIONS(3157),
    [anon_sym_not] = ACTIONS(3159),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_lambda] = ACTIONS(3159),
    [anon_sym_yield] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3157),
    [sym_ellipsis] = ACTIONS(3157),
    [anon_sym_LBRACE] = ACTIONS(3157),
    [sym_integer] = ACTIONS(3159),
    [sym_float] = ACTIONS(3159),
    [sym_identifier] = ACTIONS(3159),
    [sym_true] = ACTIONS(3159),
    [sym_false] = ACTIONS(3159),
    [sym_none] = ACTIONS(3159),
    [anon_sym_await] = ACTIONS(3159),
    [sym_comment] = ACTIONS(73),
  },
  [1848] = {
    [anon_sym_COLON] = ACTIONS(4179),
    [sym_comment] = ACTIONS(73),
  },
  [1849] = {
    [sym__dedent] = ACTIONS(3163),
    [sym__string_start] = ACTIONS(3163),
    [anon_sym_import] = ACTIONS(3165),
    [anon_sym_from] = ACTIONS(3165),
    [anon_sym_LPAREN] = ACTIONS(3163),
    [anon_sym_print] = ACTIONS(3165),
    [anon_sym_assert] = ACTIONS(3165),
    [anon_sym_return] = ACTIONS(3165),
    [anon_sym_del] = ACTIONS(3165),
    [anon_sym_raise] = ACTIONS(3165),
    [anon_sym_pass] = ACTIONS(3165),
    [anon_sym_break] = ACTIONS(3165),
    [anon_sym_continue] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_async] = ACTIONS(3165),
    [anon_sym_for] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [anon_sym_try] = ACTIONS(3165),
    [anon_sym_with] = ACTIONS(3165),
    [anon_sym_def] = ACTIONS(3165),
    [anon_sym_global] = ACTIONS(3165),
    [anon_sym_nonlocal] = ACTIONS(3165),
    [anon_sym_exec] = ACTIONS(3165),
    [anon_sym_class] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3163),
    [anon_sym_not] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_TILDE] = ACTIONS(3163),
    [anon_sym_lambda] = ACTIONS(3165),
    [anon_sym_yield] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3163),
    [sym_ellipsis] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3163),
    [sym_integer] = ACTIONS(3165),
    [sym_float] = ACTIONS(3165),
    [sym_identifier] = ACTIONS(3165),
    [sym_true] = ACTIONS(3165),
    [sym_false] = ACTIONS(3165),
    [sym_none] = ACTIONS(3165),
    [anon_sym_await] = ACTIONS(3165),
    [sym_comment] = ACTIONS(73),
  },
  [1850] = {
    [sym__simple_statements] = STATE(1911),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1911),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1851] = {
    [sym__simple_statements] = STATE(1912),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1912),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1852] = {
    [sym__expression] = STATE(1239),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1239),
    [sym_boolean_operator] = STATE(1239),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1239),
    [sym_lambda] = STATE(1239),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_type] = STATE(1913),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1239),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1239),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1853] = {
    [sym__simple_statements] = STATE(1914),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1914),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1854] = {
    [sym__dedent] = ACTIONS(3169),
    [sym__string_start] = ACTIONS(3169),
    [anon_sym_import] = ACTIONS(3171),
    [anon_sym_from] = ACTIONS(3171),
    [anon_sym_LPAREN] = ACTIONS(3169),
    [anon_sym_print] = ACTIONS(3171),
    [anon_sym_assert] = ACTIONS(3171),
    [anon_sym_return] = ACTIONS(3171),
    [anon_sym_del] = ACTIONS(3171),
    [anon_sym_raise] = ACTIONS(3171),
    [anon_sym_pass] = ACTIONS(3171),
    [anon_sym_break] = ACTIONS(3171),
    [anon_sym_continue] = ACTIONS(3171),
    [anon_sym_if] = ACTIONS(3171),
    [anon_sym_async] = ACTIONS(3171),
    [anon_sym_for] = ACTIONS(3171),
    [anon_sym_while] = ACTIONS(3171),
    [anon_sym_try] = ACTIONS(3171),
    [anon_sym_with] = ACTIONS(3171),
    [anon_sym_def] = ACTIONS(3171),
    [anon_sym_global] = ACTIONS(3171),
    [anon_sym_nonlocal] = ACTIONS(3171),
    [anon_sym_exec] = ACTIONS(3171),
    [anon_sym_class] = ACTIONS(3171),
    [anon_sym_AT] = ACTIONS(3169),
    [anon_sym_not] = ACTIONS(3171),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_TILDE] = ACTIONS(3169),
    [anon_sym_lambda] = ACTIONS(3171),
    [anon_sym_yield] = ACTIONS(3171),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [sym_ellipsis] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [sym_integer] = ACTIONS(3171),
    [sym_float] = ACTIONS(3171),
    [sym_identifier] = ACTIONS(3171),
    [sym_true] = ACTIONS(3171),
    [sym_false] = ACTIONS(3171),
    [sym_none] = ACTIONS(3171),
    [anon_sym_await] = ACTIONS(3171),
    [sym_comment] = ACTIONS(73),
  },
  [1855] = {
    [sym__simple_statements] = STATE(1915),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1915),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1856] = {
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_as] = ACTIONS(4181),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_COLON] = ACTIONS(4183),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(679),
    [sym_comment] = ACTIONS(73),
  },
  [1857] = {
    [sym__simple_statements] = STATE(1918),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1918),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1858] = {
    [sym_finally_clause] = STATE(1919),
    [sym__dedent] = ACTIONS(3221),
    [sym__string_start] = ACTIONS(3221),
    [anon_sym_import] = ACTIONS(3223),
    [anon_sym_from] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_print] = ACTIONS(3223),
    [anon_sym_assert] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_del] = ACTIONS(3223),
    [anon_sym_raise] = ACTIONS(3223),
    [anon_sym_pass] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_finally] = ACTIONS(4036),
    [anon_sym_with] = ACTIONS(3223),
    [anon_sym_def] = ACTIONS(3223),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_nonlocal] = ACTIONS(3223),
    [anon_sym_exec] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_AT] = ACTIONS(3221),
    [anon_sym_not] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_lambda] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [sym_ellipsis] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [sym_integer] = ACTIONS(3223),
    [sym_float] = ACTIONS(3223),
    [sym_identifier] = ACTIONS(3223),
    [sym_true] = ACTIONS(3223),
    [sym_false] = ACTIONS(3223),
    [sym_none] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [sym_comment] = ACTIONS(73),
  },
  [1859] = {
    [sym__dedent] = ACTIONS(3221),
    [sym__string_start] = ACTIONS(3221),
    [anon_sym_import] = ACTIONS(3223),
    [anon_sym_from] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_print] = ACTIONS(3223),
    [anon_sym_assert] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_del] = ACTIONS(3223),
    [anon_sym_raise] = ACTIONS(3223),
    [anon_sym_pass] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_with] = ACTIONS(3223),
    [anon_sym_def] = ACTIONS(3223),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_nonlocal] = ACTIONS(3223),
    [anon_sym_exec] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_AT] = ACTIONS(3221),
    [anon_sym_not] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_lambda] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [sym_ellipsis] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [sym_integer] = ACTIONS(3223),
    [sym_float] = ACTIONS(3223),
    [sym_identifier] = ACTIONS(3223),
    [sym_true] = ACTIONS(3223),
    [sym_false] = ACTIONS(3223),
    [sym_none] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [sym_comment] = ACTIONS(73),
  },
  [1860] = {
    [sym_except_clause] = STATE(1860),
    [aux_sym_try_statement_repeat1] = STATE(1860),
    [sym__dedent] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(3225),
    [anon_sym_import] = ACTIONS(3227),
    [anon_sym_from] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_print] = ACTIONS(3227),
    [anon_sym_assert] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_del] = ACTIONS(3227),
    [anon_sym_raise] = ACTIONS(3227),
    [anon_sym_pass] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_except] = ACTIONS(4185),
    [anon_sym_finally] = ACTIONS(3227),
    [anon_sym_with] = ACTIONS(3227),
    [anon_sym_def] = ACTIONS(3227),
    [anon_sym_global] = ACTIONS(3227),
    [anon_sym_nonlocal] = ACTIONS(3227),
    [anon_sym_exec] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_AT] = ACTIONS(3225),
    [anon_sym_not] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_lambda] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [sym_ellipsis] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [sym_integer] = ACTIONS(3227),
    [sym_float] = ACTIONS(3227),
    [sym_identifier] = ACTIONS(3227),
    [sym_true] = ACTIONS(3227),
    [sym_false] = ACTIONS(3227),
    [sym_none] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [sym_comment] = ACTIONS(73),
  },
  [1861] = {
    [sym__dedent] = ACTIONS(3286),
    [sym__string_start] = ACTIONS(3286),
    [anon_sym_import] = ACTIONS(3288),
    [anon_sym_from] = ACTIONS(3288),
    [anon_sym_LPAREN] = ACTIONS(3286),
    [anon_sym_print] = ACTIONS(3288),
    [anon_sym_assert] = ACTIONS(3288),
    [anon_sym_return] = ACTIONS(3288),
    [anon_sym_del] = ACTIONS(3288),
    [anon_sym_raise] = ACTIONS(3288),
    [anon_sym_pass] = ACTIONS(3288),
    [anon_sym_break] = ACTIONS(3288),
    [anon_sym_continue] = ACTIONS(3288),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_async] = ACTIONS(3288),
    [anon_sym_for] = ACTIONS(3288),
    [anon_sym_while] = ACTIONS(3288),
    [anon_sym_try] = ACTIONS(3288),
    [anon_sym_with] = ACTIONS(3288),
    [anon_sym_def] = ACTIONS(3288),
    [anon_sym_global] = ACTIONS(3288),
    [anon_sym_nonlocal] = ACTIONS(3288),
    [anon_sym_exec] = ACTIONS(3288),
    [anon_sym_class] = ACTIONS(3288),
    [anon_sym_AT] = ACTIONS(3286),
    [anon_sym_not] = ACTIONS(3288),
    [anon_sym_PLUS] = ACTIONS(3286),
    [anon_sym_DASH] = ACTIONS(3286),
    [anon_sym_TILDE] = ACTIONS(3286),
    [anon_sym_lambda] = ACTIONS(3288),
    [anon_sym_yield] = ACTIONS(3288),
    [anon_sym_LBRACK] = ACTIONS(3286),
    [sym_ellipsis] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3286),
    [sym_integer] = ACTIONS(3288),
    [sym_float] = ACTIONS(3288),
    [sym_identifier] = ACTIONS(3288),
    [sym_true] = ACTIONS(3288),
    [sym_false] = ACTIONS(3288),
    [sym_none] = ACTIONS(3288),
    [anon_sym_await] = ACTIONS(3288),
    [sym_comment] = ACTIONS(73),
  },
  [1862] = {
    [anon_sym_COLON] = ACTIONS(4188),
    [sym_comment] = ACTIONS(73),
  },
  [1863] = {
    [sym__dedent] = ACTIONS(3294),
    [sym__string_start] = ACTIONS(3294),
    [anon_sym_import] = ACTIONS(3296),
    [anon_sym_from] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3294),
    [anon_sym_print] = ACTIONS(3296),
    [anon_sym_assert] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_del] = ACTIONS(3296),
    [anon_sym_raise] = ACTIONS(3296),
    [anon_sym_pass] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_async] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_def] = ACTIONS(3296),
    [anon_sym_global] = ACTIONS(3296),
    [anon_sym_nonlocal] = ACTIONS(3296),
    [anon_sym_exec] = ACTIONS(3296),
    [anon_sym_class] = ACTIONS(3296),
    [anon_sym_AT] = ACTIONS(3294),
    [anon_sym_not] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [anon_sym_lambda] = ACTIONS(3296),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [sym_ellipsis] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3294),
    [sym_integer] = ACTIONS(3296),
    [sym_float] = ACTIONS(3296),
    [sym_identifier] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_none] = ACTIONS(3296),
    [anon_sym_await] = ACTIONS(3296),
    [sym_comment] = ACTIONS(73),
  },
  [1864] = {
    [sym__simple_statements] = STATE(1921),
    [sym_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1921),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1459),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1865] = {
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(3236),
    [anon_sym_or] = ACTIONS(3238),
    [sym_comment] = ACTIONS(73),
  },
  [1866] = {
    [sym__expression] = STATE(1922),
    [sym__primary_expression] = STATE(1226),
    [sym_not_operator] = STATE(1922),
    [sym_boolean_operator] = STATE(1922),
    [sym_binary_operator] = STATE(1226),
    [sym_unary_operator] = STATE(1226),
    [sym_comparison_operator] = STATE(1922),
    [sym_lambda] = STATE(1922),
    [sym_attribute] = STATE(1226),
    [sym_subscript] = STATE(1226),
    [sym_call] = STATE(1226),
    [sym_list] = STATE(1226),
    [sym_list_comprehension] = STATE(1226),
    [sym_dictionary] = STATE(1226),
    [sym_dictionary_comprehension] = STATE(1226),
    [sym_set] = STATE(1226),
    [sym_set_comprehension] = STATE(1226),
    [sym_parenthesized_expression] = STATE(1226),
    [sym_tuple] = STATE(1226),
    [sym_generator_expression] = STATE(1226),
    [sym_conditional_expression] = STATE(1922),
    [sym_concatenated_string] = STATE(1226),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(1922),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_lambda] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2502),
    [sym_float] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_none] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [sym_comment] = ACTIONS(73),
  },
  [1867] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(3246),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_SLASH_SLASH] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3252),
    [anon_sym_PIPE] = ACTIONS(3254),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3242),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1868] = {
    [anon_sym_RPAREN] = ACTIONS(3851),
    [anon_sym_COMMA] = ACTIONS(3851),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1869] = {
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(3801),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(3803),
    [anon_sym_or] = ACTIONS(3805),
    [sym_comment] = ACTIONS(73),
  },
  [1870] = {
    [sym__expression] = STATE(1923),
    [sym__primary_expression] = STATE(1559),
    [sym_not_operator] = STATE(1923),
    [sym_boolean_operator] = STATE(1923),
    [sym_binary_operator] = STATE(1559),
    [sym_unary_operator] = STATE(1559),
    [sym_comparison_operator] = STATE(1923),
    [sym_lambda] = STATE(1923),
    [sym_attribute] = STATE(1559),
    [sym_subscript] = STATE(1559),
    [sym_call] = STATE(1559),
    [sym_list] = STATE(1559),
    [sym_list_comprehension] = STATE(1559),
    [sym_dictionary] = STATE(1559),
    [sym_dictionary_comprehension] = STATE(1559),
    [sym_set] = STATE(1559),
    [sym_set_comprehension] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1559),
    [sym_tuple] = STATE(1559),
    [sym_generator_expression] = STATE(1559),
    [sym_conditional_expression] = STATE(1923),
    [sym_concatenated_string] = STATE(1559),
    [sym_string] = STATE(1561),
    [sym_await] = STATE(1923),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_lambda] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3278),
    [sym_float] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_none] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3280),
    [sym_comment] = ACTIONS(73),
  },
  [1871] = {
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(4190),
    [anon_sym_and] = ACTIONS(1940),
    [anon_sym_or] = ACTIONS(1942),
    [sym_comment] = ACTIONS(73),
  },
  [1872] = {
    [anon_sym_RPAREN] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_and] = ACTIONS(3803),
    [anon_sym_or] = ACTIONS(1968),
    [sym_comment] = ACTIONS(73),
  },
  [1873] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_SLASH_SLASH] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(3819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1874] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(3813),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3817),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1875] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(3809),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(1999),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_AT] = ACTIONS(3813),
    [anon_sym_not] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3817),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3819),
    [anon_sym_PIPE] = ACTIONS(3821),
    [anon_sym_AMP] = ACTIONS(3823),
    [anon_sym_CARET] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_is] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1876] = {
    [sym__primary_expression] = STATE(1925),
    [sym_binary_operator] = STATE(1925),
    [sym_unary_operator] = STATE(1925),
    [sym_attribute] = STATE(1925),
    [sym_subscript] = STATE(1925),
    [sym_call] = STATE(1925),
    [sym_list] = STATE(1925),
    [sym_list_comprehension] = STATE(1925),
    [sym_dictionary] = STATE(1925),
    [sym_dictionary_comprehension] = STATE(1925),
    [sym_set] = STATE(1925),
    [sym_set_comprehension] = STATE(1925),
    [sym_parenthesized_expression] = STATE(1925),
    [sym_tuple] = STATE(1925),
    [sym_generator_expression] = STATE(1925),
    [sym_concatenated_string] = STATE(1925),
    [sym_string] = STATE(1561),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4194),
    [sym_float] = ACTIONS(4194),
    [sym_identifier] = ACTIONS(4194),
    [sym_true] = ACTIONS(4194),
    [sym_false] = ACTIONS(4194),
    [sym_none] = ACTIONS(4194),
    [sym_comment] = ACTIONS(73),
  },
  [1877] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(3813),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1878] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(3809),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(3813),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3817),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(3823),
    [anon_sym_CARET] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1879] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(3809),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(3813),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3817),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1880] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(3809),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(3813),
    [anon_sym_not] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3817),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3819),
    [anon_sym_PIPE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1995),
    [anon_sym_BANG_EQ] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_is] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [sym_comment] = ACTIONS(73),
  },
  [1881] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1881),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_not] = ACTIONS(4199),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4202),
    [anon_sym_LT_EQ] = ACTIONS(4196),
    [anon_sym_EQ_EQ] = ACTIONS(4196),
    [anon_sym_BANG_EQ] = ACTIONS(4196),
    [anon_sym_GT_EQ] = ACTIONS(4196),
    [anon_sym_GT] = ACTIONS(4202),
    [anon_sym_LT_GT] = ACTIONS(4196),
    [anon_sym_is] = ACTIONS(4205),
    [sym_comment] = ACTIONS(73),
  },
  [1882] = {
    [anon_sym_RPAREN] = ACTIONS(3871),
    [anon_sym_COMMA] = ACTIONS(3871),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1213),
    [sym_comment] = ACTIONS(73),
  },
  [1883] = {
    [sym_string] = STATE(1883),
    [aux_sym_concatenated_string_repeat1] = STATE(1883),
    [sym__string_start] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_EQ] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_not] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2066),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_SLASH_SLASH] = ACTIONS(2061),
    [anon_sym_STAR_STAR] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2066),
    [anon_sym_LT_GT] = ACTIONS(2061),
    [anon_sym_is] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [sym_comment] = ACTIONS(73),
  },
  [1884] = {
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_EQ] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(2579),
    [anon_sym_or] = ACTIONS(2581),
    [sym_comment] = ACTIONS(73),
  },
  [1885] = {
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(2618),
    [anon_sym_COLON] = ACTIONS(3574),
    [anon_sym_EQ] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2622),
    [sym_comment] = ACTIONS(73),
  },
  [1886] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1606),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(1606),
    [sym_boolean_operator] = STATE(1606),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(1606),
    [sym_lambda] = STATE(1606),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(1606),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(1606),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4152),
    [anon_sym_async] = ACTIONS(4152),
    [anon_sym_for] = ACTIONS(4152),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(4150),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1887] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1889),
    [anon_sym_COMMA] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_async] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_RBRACK] = ACTIONS(4150),
    [sym_comment] = ACTIONS(73),
  },
  [1888] = {
    [sym__expression_within_for_in_clause] = STATE(1902),
    [sym__expression] = STATE(1606),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(1606),
    [sym_boolean_operator] = STATE(1606),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(1606),
    [sym_lambda] = STATE(1606),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(1606),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(1606),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1889] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1889),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_async] = ACTIONS(4158),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_RBRACK] = ACTIONS(4158),
    [sym_comment] = ACTIONS(73),
  },
  [1890] = {
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(3412),
    [anon_sym_or] = ACTIONS(3414),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [sym_comment] = ACTIONS(73),
  },
  [1891] = {
    [sym__expression] = STATE(1928),
    [sym__primary_expression] = STATE(1321),
    [sym_not_operator] = STATE(1928),
    [sym_boolean_operator] = STATE(1928),
    [sym_binary_operator] = STATE(1321),
    [sym_unary_operator] = STATE(1321),
    [sym_comparison_operator] = STATE(1928),
    [sym_lambda] = STATE(1928),
    [sym_attribute] = STATE(1321),
    [sym_subscript] = STATE(1321),
    [sym_call] = STATE(1321),
    [sym_list] = STATE(1321),
    [sym_list_comprehension] = STATE(1321),
    [sym_dictionary] = STATE(1321),
    [sym_dictionary_comprehension] = STATE(1321),
    [sym_set] = STATE(1321),
    [sym_set_comprehension] = STATE(1321),
    [sym_parenthesized_expression] = STATE(1321),
    [sym_tuple] = STATE(1321),
    [sym_generator_expression] = STATE(1321),
    [sym_conditional_expression] = STATE(1928),
    [sym_concatenated_string] = STATE(1321),
    [sym_string] = STATE(1322),
    [sym_await] = STATE(1928),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2711),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2713),
    [anon_sym_lambda] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2719),
    [sym_float] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2719),
    [sym_true] = ACTIONS(2719),
    [sym_false] = ACTIONS(2719),
    [sym_none] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(2721),
    [sym_comment] = ACTIONS(73),
  },
  [1892] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_GT_GT] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_async] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(3422),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(3426),
    [anon_sym_DASH] = ACTIONS(3426),
    [anon_sym_SLASH] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3422),
    [anon_sym_SLASH_SLASH] = ACTIONS(3422),
    [anon_sym_STAR_STAR] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(3430),
    [anon_sym_AMP] = ACTIONS(3432),
    [anon_sym_CARET] = ACTIONS(3434),
    [anon_sym_LT_LT] = ACTIONS(3418),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(2951),
    [sym_comment] = ACTIONS(73),
  },
  [1893] = {
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(3574),
    [anon_sym_for] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(2803),
    [anon_sym_or] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(3574),
    [sym_comment] = ACTIONS(73),
  },
  [1894] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1647),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1647),
    [sym_boolean_operator] = STATE(1647),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1647),
    [sym_lambda] = STATE(1647),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1647),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4152),
    [anon_sym_async] = ACTIONS(4152),
    [anon_sym_for] = ACTIONS(4152),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(4150),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1895] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1897),
    [anon_sym_COMMA] = ACTIONS(4213),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_async] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_RBRACE] = ACTIONS(4150),
    [sym_comment] = ACTIONS(73),
  },
  [1896] = {
    [sym__expression_within_for_in_clause] = STATE(1902),
    [sym__expression] = STATE(1647),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1647),
    [sym_boolean_operator] = STATE(1647),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1647),
    [sym_lambda] = STATE(1647),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1647),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1897] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1897),
    [anon_sym_COMMA] = ACTIONS(4215),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_async] = ACTIONS(4158),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [sym_comment] = ACTIONS(73),
  },
  [1898] = {
    [anon_sym_if] = ACTIONS(4128),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3517),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(73),
  },
  [1899] = {
    [sym__expression] = STATE(1931),
    [sym__primary_expression] = STATE(1371),
    [sym_not_operator] = STATE(1931),
    [sym_boolean_operator] = STATE(1931),
    [sym_binary_operator] = STATE(1371),
    [sym_unary_operator] = STATE(1371),
    [sym_comparison_operator] = STATE(1931),
    [sym_lambda] = STATE(1931),
    [sym_attribute] = STATE(1371),
    [sym_subscript] = STATE(1371),
    [sym_call] = STATE(1371),
    [sym_list] = STATE(1371),
    [sym_list_comprehension] = STATE(1371),
    [sym_dictionary] = STATE(1371),
    [sym_dictionary_comprehension] = STATE(1371),
    [sym_set] = STATE(1371),
    [sym_set_comprehension] = STATE(1371),
    [sym_parenthesized_expression] = STATE(1371),
    [sym_tuple] = STATE(1371),
    [sym_generator_expression] = STATE(1371),
    [sym_conditional_expression] = STATE(1931),
    [sym_concatenated_string] = STATE(1371),
    [sym_string] = STATE(1372),
    [sym_await] = STATE(1931),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_lambda] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2845),
    [sym_float] = ACTIONS(2845),
    [sym_identifier] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_none] = ACTIONS(2845),
    [anon_sym_await] = ACTIONS(2847),
    [sym_comment] = ACTIONS(73),
  },
  [1900] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_GT_GT] = ACTIONS(3521),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_async] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(3525),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_SLASH_SLASH] = ACTIONS(3525),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_CARET] = ACTIONS(3537),
    [anon_sym_LT_LT] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [sym_comment] = ACTIONS(73),
  },
  [1901] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1456),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(1456),
    [sym_boolean_operator] = STATE(1456),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(1456),
    [sym_lambda] = STATE(1456),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(1456),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(1456),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(4218),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_async] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1902] = {
    [anon_sym_RPAREN] = ACTIONS(4222),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_if] = ACTIONS(4222),
    [anon_sym_async] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_RBRACK] = ACTIONS(4222),
    [anon_sym_RBRACE] = ACTIONS(4222),
    [sym_comment] = ACTIONS(73),
  },
  [1903] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1456),
    [sym__primary_expression] = STATE(66),
    [sym_not_operator] = STATE(1456),
    [sym_boolean_operator] = STATE(1456),
    [sym_binary_operator] = STATE(66),
    [sym_unary_operator] = STATE(66),
    [sym_comparison_operator] = STATE(1456),
    [sym_lambda] = STATE(1456),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(66),
    [sym_subscript] = STATE(66),
    [sym_call] = STATE(66),
    [sym_list] = STATE(66),
    [sym_list_comprehension] = STATE(66),
    [sym_dictionary] = STATE(66),
    [sym_dictionary_comprehension] = STATE(66),
    [sym_set] = STATE(66),
    [sym_set_comprehension] = STATE(66),
    [sym_parenthesized_expression] = STATE(66),
    [sym_tuple] = STATE(66),
    [sym_generator_expression] = STATE(66),
    [sym_conditional_expression] = STATE(1456),
    [sym_concatenated_string] = STATE(66),
    [sym_string] = STATE(68),
    [sym_await] = STATE(1456),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1904] = {
    [anon_sym_RPAREN] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_async] = ACTIONS(3574),
    [anon_sym_for] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3068),
    [sym_comment] = ACTIONS(73),
  },
  [1905] = {
    [sym__dedent] = ACTIONS(3189),
    [sym__string_start] = ACTIONS(3189),
    [anon_sym_import] = ACTIONS(3698),
    [anon_sym_from] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3189),
    [anon_sym_print] = ACTIONS(3698),
    [anon_sym_assert] = ACTIONS(3698),
    [anon_sym_return] = ACTIONS(3698),
    [anon_sym_del] = ACTIONS(3698),
    [anon_sym_raise] = ACTIONS(3698),
    [anon_sym_pass] = ACTIONS(3698),
    [anon_sym_break] = ACTIONS(3698),
    [anon_sym_continue] = ACTIONS(3698),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_elif] = ACTIONS(3698),
    [anon_sym_else] = ACTIONS(3698),
    [anon_sym_async] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3698),
    [anon_sym_while] = ACTIONS(3698),
    [anon_sym_try] = ACTIONS(3698),
    [anon_sym_except] = ACTIONS(3698),
    [anon_sym_finally] = ACTIONS(3698),
    [anon_sym_with] = ACTIONS(3698),
    [anon_sym_def] = ACTIONS(3698),
    [anon_sym_global] = ACTIONS(3698),
    [anon_sym_nonlocal] = ACTIONS(3698),
    [anon_sym_exec] = ACTIONS(3698),
    [anon_sym_class] = ACTIONS(3698),
    [anon_sym_AT] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_TILDE] = ACTIONS(3189),
    [anon_sym_lambda] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3698),
    [anon_sym_LBRACK] = ACTIONS(3189),
    [sym_ellipsis] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [sym_integer] = ACTIONS(3698),
    [sym_float] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3698),
    [sym_true] = ACTIONS(3698),
    [sym_false] = ACTIONS(3698),
    [sym_none] = ACTIONS(3698),
    [anon_sym_await] = ACTIONS(3698),
    [sym_comment] = ACTIONS(73),
  },
  [1906] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [1907] = {
    [sym__simple_statements] = STATE(1933),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1933),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1908] = {
    [sym__dedent] = ACTIONS(3702),
    [sym__string_start] = ACTIONS(3702),
    [anon_sym_import] = ACTIONS(3704),
    [anon_sym_from] = ACTIONS(3704),
    [anon_sym_LPAREN] = ACTIONS(3702),
    [anon_sym_print] = ACTIONS(3704),
    [anon_sym_assert] = ACTIONS(3704),
    [anon_sym_return] = ACTIONS(3704),
    [anon_sym_del] = ACTIONS(3704),
    [anon_sym_raise] = ACTIONS(3704),
    [anon_sym_pass] = ACTIONS(3704),
    [anon_sym_break] = ACTIONS(3704),
    [anon_sym_continue] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(3704),
    [anon_sym_async] = ACTIONS(3704),
    [anon_sym_for] = ACTIONS(3704),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_try] = ACTIONS(3704),
    [anon_sym_with] = ACTIONS(3704),
    [anon_sym_def] = ACTIONS(3704),
    [anon_sym_global] = ACTIONS(3704),
    [anon_sym_nonlocal] = ACTIONS(3704),
    [anon_sym_exec] = ACTIONS(3704),
    [anon_sym_class] = ACTIONS(3704),
    [anon_sym_AT] = ACTIONS(3702),
    [anon_sym_not] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3702),
    [anon_sym_DASH] = ACTIONS(3702),
    [anon_sym_TILDE] = ACTIONS(3702),
    [anon_sym_lambda] = ACTIONS(3704),
    [anon_sym_yield] = ACTIONS(3704),
    [anon_sym_LBRACK] = ACTIONS(3702),
    [sym_ellipsis] = ACTIONS(3702),
    [anon_sym_LBRACE] = ACTIONS(3702),
    [sym_integer] = ACTIONS(3704),
    [sym_float] = ACTIONS(3704),
    [sym_identifier] = ACTIONS(3704),
    [sym_true] = ACTIONS(3704),
    [sym_false] = ACTIONS(3704),
    [sym_none] = ACTIONS(3704),
    [anon_sym_await] = ACTIONS(3704),
    [sym_comment] = ACTIONS(73),
  },
  [1909] = {
    [sym_elif_clause] = STATE(1909),
    [aux_sym_if_statement_repeat1] = STATE(1909),
    [sym__dedent] = ACTIONS(3706),
    [sym__string_start] = ACTIONS(3706),
    [anon_sym_import] = ACTIONS(3708),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3706),
    [anon_sym_print] = ACTIONS(3708),
    [anon_sym_assert] = ACTIONS(3708),
    [anon_sym_return] = ACTIONS(3708),
    [anon_sym_del] = ACTIONS(3708),
    [anon_sym_raise] = ACTIONS(3708),
    [anon_sym_pass] = ACTIONS(3708),
    [anon_sym_break] = ACTIONS(3708),
    [anon_sym_continue] = ACTIONS(3708),
    [anon_sym_if] = ACTIONS(3708),
    [anon_sym_elif] = ACTIONS(4226),
    [anon_sym_else] = ACTIONS(3708),
    [anon_sym_async] = ACTIONS(3708),
    [anon_sym_for] = ACTIONS(3708),
    [anon_sym_while] = ACTIONS(3708),
    [anon_sym_try] = ACTIONS(3708),
    [anon_sym_with] = ACTIONS(3708),
    [anon_sym_def] = ACTIONS(3708),
    [anon_sym_global] = ACTIONS(3708),
    [anon_sym_nonlocal] = ACTIONS(3708),
    [anon_sym_exec] = ACTIONS(3708),
    [anon_sym_class] = ACTIONS(3708),
    [anon_sym_AT] = ACTIONS(3706),
    [anon_sym_not] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_TILDE] = ACTIONS(3706),
    [anon_sym_lambda] = ACTIONS(3708),
    [anon_sym_yield] = ACTIONS(3708),
    [anon_sym_LBRACK] = ACTIONS(3706),
    [sym_ellipsis] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3706),
    [sym_integer] = ACTIONS(3708),
    [sym_float] = ACTIONS(3708),
    [sym_identifier] = ACTIONS(3708),
    [sym_true] = ACTIONS(3708),
    [sym_false] = ACTIONS(3708),
    [sym_none] = ACTIONS(3708),
    [anon_sym_await] = ACTIONS(3708),
    [sym_comment] = ACTIONS(73),
  },
  [1910] = {
    [sym__simple_statements] = STATE(1934),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1934),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1911] = {
    [sym__dedent] = ACTIONS(3713),
    [sym__string_start] = ACTIONS(3713),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_from] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3713),
    [anon_sym_print] = ACTIONS(3715),
    [anon_sym_assert] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_del] = ACTIONS(3715),
    [anon_sym_raise] = ACTIONS(3715),
    [anon_sym_pass] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_with] = ACTIONS(3715),
    [anon_sym_def] = ACTIONS(3715),
    [anon_sym_global] = ACTIONS(3715),
    [anon_sym_nonlocal] = ACTIONS(3715),
    [anon_sym_exec] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_AT] = ACTIONS(3713),
    [anon_sym_not] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_lambda] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [sym_ellipsis] = ACTIONS(3713),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [sym_integer] = ACTIONS(3715),
    [sym_float] = ACTIONS(3715),
    [sym_identifier] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_none] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [sym_comment] = ACTIONS(73),
  },
  [1912] = {
    [sym__dedent] = ACTIONS(3717),
    [sym__string_start] = ACTIONS(3717),
    [anon_sym_import] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3717),
    [anon_sym_print] = ACTIONS(3719),
    [anon_sym_assert] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(3719),
    [anon_sym_del] = ACTIONS(3719),
    [anon_sym_raise] = ACTIONS(3719),
    [anon_sym_pass] = ACTIONS(3719),
    [anon_sym_break] = ACTIONS(3719),
    [anon_sym_continue] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_async] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_try] = ACTIONS(3719),
    [anon_sym_with] = ACTIONS(3719),
    [anon_sym_def] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(3719),
    [anon_sym_nonlocal] = ACTIONS(3719),
    [anon_sym_exec] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_AT] = ACTIONS(3717),
    [anon_sym_not] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_lambda] = ACTIONS(3719),
    [anon_sym_yield] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3717),
    [sym_ellipsis] = ACTIONS(3717),
    [anon_sym_LBRACE] = ACTIONS(3717),
    [sym_integer] = ACTIONS(3719),
    [sym_float] = ACTIONS(3719),
    [sym_identifier] = ACTIONS(3719),
    [sym_true] = ACTIONS(3719),
    [sym_false] = ACTIONS(3719),
    [sym_none] = ACTIONS(3719),
    [anon_sym_await] = ACTIONS(3719),
    [sym_comment] = ACTIONS(73),
  },
  [1913] = {
    [anon_sym_COLON] = ACTIONS(4229),
    [sym_comment] = ACTIONS(73),
  },
  [1914] = {
    [sym_else_clause] = STATE(1936),
    [sym__dedent] = ACTIONS(3723),
    [sym__string_start] = ACTIONS(3723),
    [anon_sym_import] = ACTIONS(3725),
    [anon_sym_from] = ACTIONS(3725),
    [anon_sym_LPAREN] = ACTIONS(3723),
    [anon_sym_print] = ACTIONS(3725),
    [anon_sym_assert] = ACTIONS(3725),
    [anon_sym_return] = ACTIONS(3725),
    [anon_sym_del] = ACTIONS(3725),
    [anon_sym_raise] = ACTIONS(3725),
    [anon_sym_pass] = ACTIONS(3725),
    [anon_sym_break] = ACTIONS(3725),
    [anon_sym_continue] = ACTIONS(3725),
    [anon_sym_if] = ACTIONS(3725),
    [anon_sym_else] = ACTIONS(4020),
    [anon_sym_async] = ACTIONS(3725),
    [anon_sym_for] = ACTIONS(3725),
    [anon_sym_while] = ACTIONS(3725),
    [anon_sym_try] = ACTIONS(3725),
    [anon_sym_with] = ACTIONS(3725),
    [anon_sym_def] = ACTIONS(3725),
    [anon_sym_global] = ACTIONS(3725),
    [anon_sym_nonlocal] = ACTIONS(3725),
    [anon_sym_exec] = ACTIONS(3725),
    [anon_sym_class] = ACTIONS(3725),
    [anon_sym_AT] = ACTIONS(3723),
    [anon_sym_not] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_TILDE] = ACTIONS(3723),
    [anon_sym_lambda] = ACTIONS(3725),
    [anon_sym_yield] = ACTIONS(3725),
    [anon_sym_LBRACK] = ACTIONS(3723),
    [sym_ellipsis] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3723),
    [sym_integer] = ACTIONS(3725),
    [sym_float] = ACTIONS(3725),
    [sym_identifier] = ACTIONS(3725),
    [sym_true] = ACTIONS(3725),
    [sym_false] = ACTIONS(3725),
    [sym_none] = ACTIONS(3725),
    [anon_sym_await] = ACTIONS(3725),
    [sym_comment] = ACTIONS(73),
  },
  [1915] = {
    [sym__dedent] = ACTIONS(3748),
    [sym__string_start] = ACTIONS(3748),
    [anon_sym_import] = ACTIONS(3750),
    [anon_sym_from] = ACTIONS(3750),
    [anon_sym_LPAREN] = ACTIONS(3748),
    [anon_sym_print] = ACTIONS(3750),
    [anon_sym_assert] = ACTIONS(3750),
    [anon_sym_return] = ACTIONS(3750),
    [anon_sym_del] = ACTIONS(3750),
    [anon_sym_raise] = ACTIONS(3750),
    [anon_sym_pass] = ACTIONS(3750),
    [anon_sym_break] = ACTIONS(3750),
    [anon_sym_continue] = ACTIONS(3750),
    [anon_sym_if] = ACTIONS(3750),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_async] = ACTIONS(3750),
    [anon_sym_for] = ACTIONS(3750),
    [anon_sym_while] = ACTIONS(3750),
    [anon_sym_try] = ACTIONS(3750),
    [anon_sym_except] = ACTIONS(3750),
    [anon_sym_finally] = ACTIONS(3750),
    [anon_sym_with] = ACTIONS(3750),
    [anon_sym_def] = ACTIONS(3750),
    [anon_sym_global] = ACTIONS(3750),
    [anon_sym_nonlocal] = ACTIONS(3750),
    [anon_sym_exec] = ACTIONS(3750),
    [anon_sym_class] = ACTIONS(3750),
    [anon_sym_AT] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_PLUS] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3748),
    [anon_sym_TILDE] = ACTIONS(3748),
    [anon_sym_lambda] = ACTIONS(3750),
    [anon_sym_yield] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3748),
    [sym_ellipsis] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3748),
    [sym_integer] = ACTIONS(3750),
    [sym_float] = ACTIONS(3750),
    [sym_identifier] = ACTIONS(3750),
    [sym_true] = ACTIONS(3750),
    [sym_false] = ACTIONS(3750),
    [sym_none] = ACTIONS(3750),
    [anon_sym_await] = ACTIONS(3750),
    [sym_comment] = ACTIONS(73),
  },
  [1916] = {
    [sym__expression] = STATE(1937),
    [sym__primary_expression] = STATE(101),
    [sym_not_operator] = STATE(1937),
    [sym_boolean_operator] = STATE(1937),
    [sym_binary_operator] = STATE(101),
    [sym_unary_operator] = STATE(101),
    [sym_comparison_operator] = STATE(1937),
    [sym_lambda] = STATE(1937),
    [sym_attribute] = STATE(101),
    [sym_subscript] = STATE(101),
    [sym_call] = STATE(101),
    [sym_list] = STATE(101),
    [sym_list_comprehension] = STATE(101),
    [sym_dictionary] = STATE(101),
    [sym_dictionary_comprehension] = STATE(101),
    [sym_set] = STATE(101),
    [sym_set_comprehension] = STATE(101),
    [sym_parenthesized_expression] = STATE(101),
    [sym_tuple] = STATE(101),
    [sym_generator_expression] = STATE(101),
    [sym_conditional_expression] = STATE(1937),
    [sym_concatenated_string] = STATE(101),
    [sym_string] = STATE(102),
    [sym_await] = STATE(1937),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1917] = {
    [sym__simple_statements] = STATE(1938),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1938),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1918] = {
    [sym__dedent] = ACTIONS(3752),
    [sym__string_start] = ACTIONS(3752),
    [anon_sym_import] = ACTIONS(3754),
    [anon_sym_from] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3752),
    [anon_sym_print] = ACTIONS(3754),
    [anon_sym_assert] = ACTIONS(3754),
    [anon_sym_return] = ACTIONS(3754),
    [anon_sym_del] = ACTIONS(3754),
    [anon_sym_raise] = ACTIONS(3754),
    [anon_sym_pass] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3754),
    [anon_sym_continue] = ACTIONS(3754),
    [anon_sym_if] = ACTIONS(3754),
    [anon_sym_async] = ACTIONS(3754),
    [anon_sym_for] = ACTIONS(3754),
    [anon_sym_while] = ACTIONS(3754),
    [anon_sym_try] = ACTIONS(3754),
    [anon_sym_with] = ACTIONS(3754),
    [anon_sym_def] = ACTIONS(3754),
    [anon_sym_global] = ACTIONS(3754),
    [anon_sym_nonlocal] = ACTIONS(3754),
    [anon_sym_exec] = ACTIONS(3754),
    [anon_sym_class] = ACTIONS(3754),
    [anon_sym_AT] = ACTIONS(3752),
    [anon_sym_not] = ACTIONS(3754),
    [anon_sym_PLUS] = ACTIONS(3752),
    [anon_sym_DASH] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [anon_sym_lambda] = ACTIONS(3754),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3752),
    [sym_ellipsis] = ACTIONS(3752),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [sym_integer] = ACTIONS(3754),
    [sym_float] = ACTIONS(3754),
    [sym_identifier] = ACTIONS(3754),
    [sym_true] = ACTIONS(3754),
    [sym_false] = ACTIONS(3754),
    [sym_none] = ACTIONS(3754),
    [anon_sym_await] = ACTIONS(3754),
    [sym_comment] = ACTIONS(73),
  },
  [1919] = {
    [sym__dedent] = ACTIONS(3756),
    [sym__string_start] = ACTIONS(3756),
    [anon_sym_import] = ACTIONS(3758),
    [anon_sym_from] = ACTIONS(3758),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_print] = ACTIONS(3758),
    [anon_sym_assert] = ACTIONS(3758),
    [anon_sym_return] = ACTIONS(3758),
    [anon_sym_del] = ACTIONS(3758),
    [anon_sym_raise] = ACTIONS(3758),
    [anon_sym_pass] = ACTIONS(3758),
    [anon_sym_break] = ACTIONS(3758),
    [anon_sym_continue] = ACTIONS(3758),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_async] = ACTIONS(3758),
    [anon_sym_for] = ACTIONS(3758),
    [anon_sym_while] = ACTIONS(3758),
    [anon_sym_try] = ACTIONS(3758),
    [anon_sym_with] = ACTIONS(3758),
    [anon_sym_def] = ACTIONS(3758),
    [anon_sym_global] = ACTIONS(3758),
    [anon_sym_nonlocal] = ACTIONS(3758),
    [anon_sym_exec] = ACTIONS(3758),
    [anon_sym_class] = ACTIONS(3758),
    [anon_sym_AT] = ACTIONS(3756),
    [anon_sym_not] = ACTIONS(3758),
    [anon_sym_PLUS] = ACTIONS(3756),
    [anon_sym_DASH] = ACTIONS(3756),
    [anon_sym_TILDE] = ACTIONS(3756),
    [anon_sym_lambda] = ACTIONS(3758),
    [anon_sym_yield] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(3756),
    [sym_ellipsis] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [sym_integer] = ACTIONS(3758),
    [sym_float] = ACTIONS(3758),
    [sym_identifier] = ACTIONS(3758),
    [sym_true] = ACTIONS(3758),
    [sym_false] = ACTIONS(3758),
    [sym_none] = ACTIONS(3758),
    [anon_sym_await] = ACTIONS(3758),
    [sym_comment] = ACTIONS(73),
  },
  [1920] = {
    [sym__simple_statements] = STATE(1939),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1939),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1921] = {
    [sym__string_start] = ACTIONS(4231),
    [ts_builtin_sym_end] = ACTIONS(4231),
    [anon_sym_import] = ACTIONS(4233),
    [anon_sym_from] = ACTIONS(4233),
    [anon_sym_LPAREN] = ACTIONS(4231),
    [anon_sym_print] = ACTIONS(4233),
    [anon_sym_assert] = ACTIONS(4233),
    [anon_sym_return] = ACTIONS(4233),
    [anon_sym_del] = ACTIONS(4233),
    [anon_sym_raise] = ACTIONS(4233),
    [anon_sym_pass] = ACTIONS(4233),
    [anon_sym_break] = ACTIONS(4233),
    [anon_sym_continue] = ACTIONS(4233),
    [anon_sym_if] = ACTIONS(4233),
    [anon_sym_else] = ACTIONS(4233),
    [anon_sym_async] = ACTIONS(4233),
    [anon_sym_for] = ACTIONS(4233),
    [anon_sym_while] = ACTIONS(4233),
    [anon_sym_try] = ACTIONS(4233),
    [anon_sym_except] = ACTIONS(4233),
    [anon_sym_finally] = ACTIONS(4233),
    [anon_sym_with] = ACTIONS(4233),
    [anon_sym_def] = ACTIONS(4233),
    [anon_sym_global] = ACTIONS(4233),
    [anon_sym_nonlocal] = ACTIONS(4233),
    [anon_sym_exec] = ACTIONS(4233),
    [anon_sym_class] = ACTIONS(4233),
    [anon_sym_AT] = ACTIONS(4231),
    [anon_sym_not] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4231),
    [anon_sym_DASH] = ACTIONS(4231),
    [anon_sym_TILDE] = ACTIONS(4231),
    [anon_sym_lambda] = ACTIONS(4233),
    [anon_sym_yield] = ACTIONS(4233),
    [anon_sym_LBRACK] = ACTIONS(4231),
    [sym_ellipsis] = ACTIONS(4231),
    [anon_sym_LBRACE] = ACTIONS(4231),
    [sym_integer] = ACTIONS(4233),
    [sym_float] = ACTIONS(4233),
    [sym_identifier] = ACTIONS(4233),
    [sym_true] = ACTIONS(4233),
    [sym_false] = ACTIONS(4233),
    [sym_none] = ACTIONS(4233),
    [anon_sym_await] = ACTIONS(4233),
    [sym_comment] = ACTIONS(73),
  },
  [1922] = {
    [anon_sym_RPAREN] = ACTIONS(3574),
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_COLON] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(3236),
    [anon_sym_or] = ACTIONS(3238),
    [sym_comment] = ACTIONS(73),
  },
  [1923] = {
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(3801),
    [anon_sym_EQ] = ACTIONS(2656),
    [anon_sym_and] = ACTIONS(3803),
    [anon_sym_or] = ACTIONS(3805),
    [sym_comment] = ACTIONS(73),
  },
  [1924] = {
    [sym__expression] = STATE(1940),
    [sym__primary_expression] = STATE(1559),
    [sym_not_operator] = STATE(1940),
    [sym_boolean_operator] = STATE(1940),
    [sym_binary_operator] = STATE(1559),
    [sym_unary_operator] = STATE(1559),
    [sym_comparison_operator] = STATE(1940),
    [sym_lambda] = STATE(1940),
    [sym_attribute] = STATE(1559),
    [sym_subscript] = STATE(1559),
    [sym_call] = STATE(1559),
    [sym_list] = STATE(1559),
    [sym_list_comprehension] = STATE(1559),
    [sym_dictionary] = STATE(1559),
    [sym_dictionary_comprehension] = STATE(1559),
    [sym_set] = STATE(1559),
    [sym_set_comprehension] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1559),
    [sym_tuple] = STATE(1559),
    [sym_generator_expression] = STATE(1559),
    [sym_conditional_expression] = STATE(1940),
    [sym_concatenated_string] = STATE(1559),
    [sym_string] = STATE(1561),
    [sym_await] = STATE(1940),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3270),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_lambda] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3278),
    [sym_float] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_none] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3280),
    [sym_comment] = ACTIONS(73),
  },
  [1925] = {
    [sym_argument_list] = STATE(271),
    [sym_generator_expression] = STATE(271),
    [anon_sym_DOT] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(3807),
    [anon_sym_GT_GT] = ACTIONS(3809),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(3813),
    [anon_sym_not] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3817),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_SLASH_SLASH] = ACTIONS(3813),
    [anon_sym_STAR_STAR] = ACTIONS(3819),
    [anon_sym_PIPE] = ACTIONS(3821),
    [anon_sym_AMP] = ACTIONS(3823),
    [anon_sym_CARET] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(3809),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_LT_GT] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(477),
    [sym_comment] = ACTIONS(73),
  },
  [1926] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1606),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(1606),
    [sym_boolean_operator] = STATE(1606),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(1606),
    [sym_lambda] = STATE(1606),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(1606),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(1606),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_async] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(4218),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1927] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1606),
    [sym__primary_expression] = STATE(151),
    [sym_not_operator] = STATE(1606),
    [sym_boolean_operator] = STATE(1606),
    [sym_binary_operator] = STATE(151),
    [sym_unary_operator] = STATE(151),
    [sym_comparison_operator] = STATE(1606),
    [sym_lambda] = STATE(1606),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(151),
    [sym_subscript] = STATE(151),
    [sym_call] = STATE(151),
    [sym_list] = STATE(151),
    [sym_list_comprehension] = STATE(151),
    [sym_dictionary] = STATE(151),
    [sym_dictionary_comprehension] = STATE(151),
    [sym_set] = STATE(151),
    [sym_set_comprehension] = STATE(151),
    [sym_parenthesized_expression] = STATE(151),
    [sym_tuple] = STATE(151),
    [sym_generator_expression] = STATE(151),
    [sym_conditional_expression] = STATE(1606),
    [sym_concatenated_string] = STATE(151),
    [sym_string] = STATE(152),
    [sym_await] = STATE(1606),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1928] = {
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_async] = ACTIONS(3574),
    [anon_sym_for] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(3412),
    [anon_sym_or] = ACTIONS(3414),
    [anon_sym_RBRACK] = ACTIONS(3574),
    [sym_comment] = ACTIONS(73),
  },
  [1929] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1647),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1647),
    [sym_boolean_operator] = STATE(1647),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1647),
    [sym_lambda] = STATE(1647),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1647),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_async] = ACTIONS(4220),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(4218),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1930] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1647),
    [sym__primary_expression] = STATE(970),
    [sym_not_operator] = STATE(1647),
    [sym_boolean_operator] = STATE(1647),
    [sym_binary_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [sym_comparison_operator] = STATE(1647),
    [sym_lambda] = STATE(1647),
    [sym_lambda_within_for_in_clause] = STATE(1457),
    [sym_attribute] = STATE(970),
    [sym_subscript] = STATE(970),
    [sym_call] = STATE(970),
    [sym_list] = STATE(970),
    [sym_list_comprehension] = STATE(970),
    [sym_dictionary] = STATE(970),
    [sym_dictionary_comprehension] = STATE(970),
    [sym_set] = STATE(970),
    [sym_set_comprehension] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple] = STATE(970),
    [sym_generator_expression] = STATE(970),
    [sym_conditional_expression] = STATE(1647),
    [sym_concatenated_string] = STATE(970),
    [sym_string] = STATE(971),
    [sym_await] = STATE(1647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_lambda] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1833),
    [sym_float] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(1833),
    [sym_true] = ACTIONS(1833),
    [sym_false] = ACTIONS(1833),
    [sym_none] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
  },
  [1931] = {
    [anon_sym_if] = ACTIONS(4128),
    [anon_sym_async] = ACTIONS(3574),
    [anon_sym_for] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3517),
    [anon_sym_RBRACE] = ACTIONS(3574),
    [sym_comment] = ACTIONS(73),
  },
  [1932] = {
    [sym__simple_statements] = STATE(1941),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1941),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1933] = {
    [sym__dedent] = ACTIONS(4008),
    [sym__string_start] = ACTIONS(4008),
    [anon_sym_import] = ACTIONS(4010),
    [anon_sym_from] = ACTIONS(4010),
    [anon_sym_LPAREN] = ACTIONS(4008),
    [anon_sym_print] = ACTIONS(4010),
    [anon_sym_assert] = ACTIONS(4010),
    [anon_sym_return] = ACTIONS(4010),
    [anon_sym_del] = ACTIONS(4010),
    [anon_sym_raise] = ACTIONS(4010),
    [anon_sym_pass] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4010),
    [anon_sym_continue] = ACTIONS(4010),
    [anon_sym_if] = ACTIONS(4010),
    [anon_sym_async] = ACTIONS(4010),
    [anon_sym_for] = ACTIONS(4010),
    [anon_sym_while] = ACTIONS(4010),
    [anon_sym_try] = ACTIONS(4010),
    [anon_sym_finally] = ACTIONS(4010),
    [anon_sym_with] = ACTIONS(4010),
    [anon_sym_def] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4010),
    [anon_sym_nonlocal] = ACTIONS(4010),
    [anon_sym_exec] = ACTIONS(4010),
    [anon_sym_class] = ACTIONS(4010),
    [anon_sym_AT] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_PLUS] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(4008),
    [anon_sym_TILDE] = ACTIONS(4008),
    [anon_sym_lambda] = ACTIONS(4010),
    [anon_sym_yield] = ACTIONS(4010),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [sym_ellipsis] = ACTIONS(4008),
    [anon_sym_LBRACE] = ACTIONS(4008),
    [sym_integer] = ACTIONS(4010),
    [sym_float] = ACTIONS(4010),
    [sym_identifier] = ACTIONS(4010),
    [sym_true] = ACTIONS(4010),
    [sym_false] = ACTIONS(4010),
    [sym_none] = ACTIONS(4010),
    [anon_sym_await] = ACTIONS(4010),
    [sym_comment] = ACTIONS(73),
  },
  [1934] = {
    [sym_else_clause] = STATE(1942),
    [sym__dedent] = ACTIONS(4012),
    [sym__string_start] = ACTIONS(4012),
    [anon_sym_import] = ACTIONS(4014),
    [anon_sym_from] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(4012),
    [anon_sym_print] = ACTIONS(4014),
    [anon_sym_assert] = ACTIONS(4014),
    [anon_sym_return] = ACTIONS(4014),
    [anon_sym_del] = ACTIONS(4014),
    [anon_sym_raise] = ACTIONS(4014),
    [anon_sym_pass] = ACTIONS(4014),
    [anon_sym_break] = ACTIONS(4014),
    [anon_sym_continue] = ACTIONS(4014),
    [anon_sym_if] = ACTIONS(4014),
    [anon_sym_else] = ACTIONS(4020),
    [anon_sym_async] = ACTIONS(4014),
    [anon_sym_for] = ACTIONS(4014),
    [anon_sym_while] = ACTIONS(4014),
    [anon_sym_try] = ACTIONS(4014),
    [anon_sym_with] = ACTIONS(4014),
    [anon_sym_def] = ACTIONS(4014),
    [anon_sym_global] = ACTIONS(4014),
    [anon_sym_nonlocal] = ACTIONS(4014),
    [anon_sym_exec] = ACTIONS(4014),
    [anon_sym_class] = ACTIONS(4014),
    [anon_sym_AT] = ACTIONS(4012),
    [anon_sym_not] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [anon_sym_lambda] = ACTIONS(4014),
    [anon_sym_yield] = ACTIONS(4014),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [sym_ellipsis] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [sym_integer] = ACTIONS(4014),
    [sym_float] = ACTIONS(4014),
    [sym_identifier] = ACTIONS(4014),
    [sym_true] = ACTIONS(4014),
    [sym_false] = ACTIONS(4014),
    [sym_none] = ACTIONS(4014),
    [anon_sym_await] = ACTIONS(4014),
    [sym_comment] = ACTIONS(73),
  },
  [1935] = {
    [sym__simple_statements] = STATE(1943),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1943),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1936] = {
    [sym__dedent] = ACTIONS(4012),
    [sym__string_start] = ACTIONS(4012),
    [anon_sym_import] = ACTIONS(4014),
    [anon_sym_from] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(4012),
    [anon_sym_print] = ACTIONS(4014),
    [anon_sym_assert] = ACTIONS(4014),
    [anon_sym_return] = ACTIONS(4014),
    [anon_sym_del] = ACTIONS(4014),
    [anon_sym_raise] = ACTIONS(4014),
    [anon_sym_pass] = ACTIONS(4014),
    [anon_sym_break] = ACTIONS(4014),
    [anon_sym_continue] = ACTIONS(4014),
    [anon_sym_if] = ACTIONS(4014),
    [anon_sym_async] = ACTIONS(4014),
    [anon_sym_for] = ACTIONS(4014),
    [anon_sym_while] = ACTIONS(4014),
    [anon_sym_try] = ACTIONS(4014),
    [anon_sym_with] = ACTIONS(4014),
    [anon_sym_def] = ACTIONS(4014),
    [anon_sym_global] = ACTIONS(4014),
    [anon_sym_nonlocal] = ACTIONS(4014),
    [anon_sym_exec] = ACTIONS(4014),
    [anon_sym_class] = ACTIONS(4014),
    [anon_sym_AT] = ACTIONS(4012),
    [anon_sym_not] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [anon_sym_lambda] = ACTIONS(4014),
    [anon_sym_yield] = ACTIONS(4014),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [sym_ellipsis] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [sym_integer] = ACTIONS(4014),
    [sym_float] = ACTIONS(4014),
    [sym_identifier] = ACTIONS(4014),
    [sym_true] = ACTIONS(4014),
    [sym_false] = ACTIONS(4014),
    [sym_none] = ACTIONS(4014),
    [anon_sym_await] = ACTIONS(4014),
    [sym_comment] = ACTIONS(73),
  },
  [1937] = {
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_COLON] = ACTIONS(4235),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(611),
    [sym_comment] = ACTIONS(73),
  },
  [1938] = {
    [sym__dedent] = ACTIONS(4040),
    [sym__string_start] = ACTIONS(4040),
    [anon_sym_import] = ACTIONS(4042),
    [anon_sym_from] = ACTIONS(4042),
    [anon_sym_LPAREN] = ACTIONS(4040),
    [anon_sym_print] = ACTIONS(4042),
    [anon_sym_assert] = ACTIONS(4042),
    [anon_sym_return] = ACTIONS(4042),
    [anon_sym_del] = ACTIONS(4042),
    [anon_sym_raise] = ACTIONS(4042),
    [anon_sym_pass] = ACTIONS(4042),
    [anon_sym_break] = ACTIONS(4042),
    [anon_sym_continue] = ACTIONS(4042),
    [anon_sym_if] = ACTIONS(4042),
    [anon_sym_else] = ACTIONS(4042),
    [anon_sym_async] = ACTIONS(4042),
    [anon_sym_for] = ACTIONS(4042),
    [anon_sym_while] = ACTIONS(4042),
    [anon_sym_try] = ACTIONS(4042),
    [anon_sym_except] = ACTIONS(4042),
    [anon_sym_finally] = ACTIONS(4042),
    [anon_sym_with] = ACTIONS(4042),
    [anon_sym_def] = ACTIONS(4042),
    [anon_sym_global] = ACTIONS(4042),
    [anon_sym_nonlocal] = ACTIONS(4042),
    [anon_sym_exec] = ACTIONS(4042),
    [anon_sym_class] = ACTIONS(4042),
    [anon_sym_AT] = ACTIONS(4040),
    [anon_sym_not] = ACTIONS(4042),
    [anon_sym_PLUS] = ACTIONS(4040),
    [anon_sym_DASH] = ACTIONS(4040),
    [anon_sym_TILDE] = ACTIONS(4040),
    [anon_sym_lambda] = ACTIONS(4042),
    [anon_sym_yield] = ACTIONS(4042),
    [anon_sym_LBRACK] = ACTIONS(4040),
    [sym_ellipsis] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(4040),
    [sym_integer] = ACTIONS(4042),
    [sym_float] = ACTIONS(4042),
    [sym_identifier] = ACTIONS(4042),
    [sym_true] = ACTIONS(4042),
    [sym_false] = ACTIONS(4042),
    [sym_none] = ACTIONS(4042),
    [anon_sym_await] = ACTIONS(4042),
    [sym_comment] = ACTIONS(73),
  },
  [1939] = {
    [sym__dedent] = ACTIONS(4096),
    [sym__string_start] = ACTIONS(4096),
    [anon_sym_import] = ACTIONS(4098),
    [anon_sym_from] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4096),
    [anon_sym_print] = ACTIONS(4098),
    [anon_sym_assert] = ACTIONS(4098),
    [anon_sym_return] = ACTIONS(4098),
    [anon_sym_del] = ACTIONS(4098),
    [anon_sym_raise] = ACTIONS(4098),
    [anon_sym_pass] = ACTIONS(4098),
    [anon_sym_break] = ACTIONS(4098),
    [anon_sym_continue] = ACTIONS(4098),
    [anon_sym_if] = ACTIONS(4098),
    [anon_sym_async] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4098),
    [anon_sym_while] = ACTIONS(4098),
    [anon_sym_try] = ACTIONS(4098),
    [anon_sym_with] = ACTIONS(4098),
    [anon_sym_def] = ACTIONS(4098),
    [anon_sym_global] = ACTIONS(4098),
    [anon_sym_nonlocal] = ACTIONS(4098),
    [anon_sym_exec] = ACTIONS(4098),
    [anon_sym_class] = ACTIONS(4098),
    [anon_sym_AT] = ACTIONS(4096),
    [anon_sym_not] = ACTIONS(4098),
    [anon_sym_PLUS] = ACTIONS(4096),
    [anon_sym_DASH] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [anon_sym_lambda] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4098),
    [anon_sym_LBRACK] = ACTIONS(4096),
    [sym_ellipsis] = ACTIONS(4096),
    [anon_sym_LBRACE] = ACTIONS(4096),
    [sym_integer] = ACTIONS(4098),
    [sym_float] = ACTIONS(4098),
    [sym_identifier] = ACTIONS(4098),
    [sym_true] = ACTIONS(4098),
    [sym_false] = ACTIONS(4098),
    [sym_none] = ACTIONS(4098),
    [anon_sym_await] = ACTIONS(4098),
    [sym_comment] = ACTIONS(73),
  },
  [1940] = {
    [anon_sym_RPAREN] = ACTIONS(3574),
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_if] = ACTIONS(3801),
    [anon_sym_EQ] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(3803),
    [anon_sym_or] = ACTIONS(3805),
    [sym_comment] = ACTIONS(73),
  },
  [1941] = {
    [sym__dedent] = ACTIONS(4163),
    [sym__string_start] = ACTIONS(4163),
    [anon_sym_import] = ACTIONS(4165),
    [anon_sym_from] = ACTIONS(4165),
    [anon_sym_LPAREN] = ACTIONS(4163),
    [anon_sym_print] = ACTIONS(4165),
    [anon_sym_assert] = ACTIONS(4165),
    [anon_sym_return] = ACTIONS(4165),
    [anon_sym_del] = ACTIONS(4165),
    [anon_sym_raise] = ACTIONS(4165),
    [anon_sym_pass] = ACTIONS(4165),
    [anon_sym_break] = ACTIONS(4165),
    [anon_sym_continue] = ACTIONS(4165),
    [anon_sym_if] = ACTIONS(4165),
    [anon_sym_elif] = ACTIONS(4165),
    [anon_sym_else] = ACTIONS(4165),
    [anon_sym_async] = ACTIONS(4165),
    [anon_sym_for] = ACTIONS(4165),
    [anon_sym_while] = ACTIONS(4165),
    [anon_sym_try] = ACTIONS(4165),
    [anon_sym_with] = ACTIONS(4165),
    [anon_sym_def] = ACTIONS(4165),
    [anon_sym_global] = ACTIONS(4165),
    [anon_sym_nonlocal] = ACTIONS(4165),
    [anon_sym_exec] = ACTIONS(4165),
    [anon_sym_class] = ACTIONS(4165),
    [anon_sym_AT] = ACTIONS(4163),
    [anon_sym_not] = ACTIONS(4165),
    [anon_sym_PLUS] = ACTIONS(4163),
    [anon_sym_DASH] = ACTIONS(4163),
    [anon_sym_TILDE] = ACTIONS(4163),
    [anon_sym_lambda] = ACTIONS(4165),
    [anon_sym_yield] = ACTIONS(4165),
    [anon_sym_LBRACK] = ACTIONS(4163),
    [sym_ellipsis] = ACTIONS(4163),
    [anon_sym_LBRACE] = ACTIONS(4163),
    [sym_integer] = ACTIONS(4165),
    [sym_float] = ACTIONS(4165),
    [sym_identifier] = ACTIONS(4165),
    [sym_true] = ACTIONS(4165),
    [sym_false] = ACTIONS(4165),
    [sym_none] = ACTIONS(4165),
    [anon_sym_await] = ACTIONS(4165),
    [sym_comment] = ACTIONS(73),
  },
  [1942] = {
    [sym__dedent] = ACTIONS(4167),
    [sym__string_start] = ACTIONS(4167),
    [anon_sym_import] = ACTIONS(4169),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_print] = ACTIONS(4169),
    [anon_sym_assert] = ACTIONS(4169),
    [anon_sym_return] = ACTIONS(4169),
    [anon_sym_del] = ACTIONS(4169),
    [anon_sym_raise] = ACTIONS(4169),
    [anon_sym_pass] = ACTIONS(4169),
    [anon_sym_break] = ACTIONS(4169),
    [anon_sym_continue] = ACTIONS(4169),
    [anon_sym_if] = ACTIONS(4169),
    [anon_sym_async] = ACTIONS(4169),
    [anon_sym_for] = ACTIONS(4169),
    [anon_sym_while] = ACTIONS(4169),
    [anon_sym_try] = ACTIONS(4169),
    [anon_sym_with] = ACTIONS(4169),
    [anon_sym_def] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_nonlocal] = ACTIONS(4169),
    [anon_sym_exec] = ACTIONS(4169),
    [anon_sym_class] = ACTIONS(4169),
    [anon_sym_AT] = ACTIONS(4167),
    [anon_sym_not] = ACTIONS(4169),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_DASH] = ACTIONS(4167),
    [anon_sym_TILDE] = ACTIONS(4167),
    [anon_sym_lambda] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [sym_ellipsis] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4167),
    [sym_integer] = ACTIONS(4169),
    [sym_float] = ACTIONS(4169),
    [sym_identifier] = ACTIONS(4169),
    [sym_true] = ACTIONS(4169),
    [sym_false] = ACTIONS(4169),
    [sym_none] = ACTIONS(4169),
    [anon_sym_await] = ACTIONS(4169),
    [sym_comment] = ACTIONS(73),
  },
  [1943] = {
    [sym__dedent] = ACTIONS(4171),
    [sym__string_start] = ACTIONS(4171),
    [anon_sym_import] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4173),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_print] = ACTIONS(4173),
    [anon_sym_assert] = ACTIONS(4173),
    [anon_sym_return] = ACTIONS(4173),
    [anon_sym_del] = ACTIONS(4173),
    [anon_sym_raise] = ACTIONS(4173),
    [anon_sym_pass] = ACTIONS(4173),
    [anon_sym_break] = ACTIONS(4173),
    [anon_sym_continue] = ACTIONS(4173),
    [anon_sym_if] = ACTIONS(4173),
    [anon_sym_async] = ACTIONS(4173),
    [anon_sym_for] = ACTIONS(4173),
    [anon_sym_while] = ACTIONS(4173),
    [anon_sym_try] = ACTIONS(4173),
    [anon_sym_with] = ACTIONS(4173),
    [anon_sym_def] = ACTIONS(4173),
    [anon_sym_global] = ACTIONS(4173),
    [anon_sym_nonlocal] = ACTIONS(4173),
    [anon_sym_exec] = ACTIONS(4173),
    [anon_sym_class] = ACTIONS(4173),
    [anon_sym_AT] = ACTIONS(4171),
    [anon_sym_not] = ACTIONS(4173),
    [anon_sym_PLUS] = ACTIONS(4171),
    [anon_sym_DASH] = ACTIONS(4171),
    [anon_sym_TILDE] = ACTIONS(4171),
    [anon_sym_lambda] = ACTIONS(4173),
    [anon_sym_yield] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [sym_ellipsis] = ACTIONS(4171),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [sym_integer] = ACTIONS(4173),
    [sym_float] = ACTIONS(4173),
    [sym_identifier] = ACTIONS(4173),
    [sym_true] = ACTIONS(4173),
    [sym_false] = ACTIONS(4173),
    [sym_none] = ACTIONS(4173),
    [anon_sym_await] = ACTIONS(4173),
    [sym_comment] = ACTIONS(73),
  },
  [1944] = {
    [sym__simple_statements] = STATE(1945),
    [sym_import_statement] = STATE(796),
    [sym_import_from_statement] = STATE(796),
    [sym_print_statement] = STATE(796),
    [sym_assert_statement] = STATE(796),
    [sym_expression_statement] = STATE(796),
    [sym_return_statement] = STATE(796),
    [sym_delete_statement] = STATE(796),
    [sym_raise_statement] = STATE(796),
    [sym_pass_statement] = STATE(796),
    [sym_break_statement] = STATE(796),
    [sym_continue_statement] = STATE(796),
    [sym_global_statement] = STATE(796),
    [sym_nonlocal_statement] = STATE(796),
    [sym_exec_statement] = STATE(796),
    [sym__suite] = STATE(1945),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3730),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1945] = {
    [sym__dedent] = ACTIONS(4231),
    [sym__string_start] = ACTIONS(4231),
    [anon_sym_import] = ACTIONS(4233),
    [anon_sym_from] = ACTIONS(4233),
    [anon_sym_LPAREN] = ACTIONS(4231),
    [anon_sym_print] = ACTIONS(4233),
    [anon_sym_assert] = ACTIONS(4233),
    [anon_sym_return] = ACTIONS(4233),
    [anon_sym_del] = ACTIONS(4233),
    [anon_sym_raise] = ACTIONS(4233),
    [anon_sym_pass] = ACTIONS(4233),
    [anon_sym_break] = ACTIONS(4233),
    [anon_sym_continue] = ACTIONS(4233),
    [anon_sym_if] = ACTIONS(4233),
    [anon_sym_else] = ACTIONS(4233),
    [anon_sym_async] = ACTIONS(4233),
    [anon_sym_for] = ACTIONS(4233),
    [anon_sym_while] = ACTIONS(4233),
    [anon_sym_try] = ACTIONS(4233),
    [anon_sym_except] = ACTIONS(4233),
    [anon_sym_finally] = ACTIONS(4233),
    [anon_sym_with] = ACTIONS(4233),
    [anon_sym_def] = ACTIONS(4233),
    [anon_sym_global] = ACTIONS(4233),
    [anon_sym_nonlocal] = ACTIONS(4233),
    [anon_sym_exec] = ACTIONS(4233),
    [anon_sym_class] = ACTIONS(4233),
    [anon_sym_AT] = ACTIONS(4231),
    [anon_sym_not] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(4231),
    [anon_sym_DASH] = ACTIONS(4231),
    [anon_sym_TILDE] = ACTIONS(4231),
    [anon_sym_lambda] = ACTIONS(4233),
    [anon_sym_yield] = ACTIONS(4233),
    [anon_sym_LBRACK] = ACTIONS(4231),
    [sym_ellipsis] = ACTIONS(4231),
    [anon_sym_LBRACE] = ACTIONS(4231),
    [sym_integer] = ACTIONS(4233),
    [sym_float] = ACTIONS(4233),
    [sym_identifier] = ACTIONS(4233),
    [sym_true] = ACTIONS(4233),
    [sym_false] = ACTIONS(4233),
    [sym_none] = ACTIONS(4233),
    [anon_sym_await] = ACTIONS(4233),
    [sym_comment] = ACTIONS(73),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, REDUCE(sym_module, 0),
  [9] = {.count = 1, .reusable = false}, SHIFT(3),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = true}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = false}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = false}, SHIFT(11),
  [27] = {.count = 1, .reusable = false}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = false}, SHIFT(16),
  [37] = {.count = 1, .reusable = false}, SHIFT(17),
  [39] = {.count = 1, .reusable = false}, SHIFT(18),
  [41] = {.count = 1, .reusable = false}, SHIFT(19),
  [43] = {.count = 1, .reusable = false}, SHIFT(20),
  [45] = {.count = 1, .reusable = false}, SHIFT(21),
  [47] = {.count = 1, .reusable = false}, SHIFT(22),
  [49] = {.count = 1, .reusable = false}, SHIFT(23),
  [51] = {.count = 1, .reusable = false}, SHIFT(24),
  [53] = {.count = 1, .reusable = true}, SHIFT(25),
  [55] = {.count = 1, .reusable = false}, SHIFT(26),
  [57] = {.count = 1, .reusable = true}, SHIFT(27),
  [59] = {.count = 1, .reusable = false}, SHIFT(28),
  [61] = {.count = 1, .reusable = false}, SHIFT(29),
  [63] = {.count = 1, .reusable = true}, SHIFT(30),
  [65] = {.count = 1, .reusable = true}, SHIFT(37),
  [67] = {.count = 1, .reusable = true}, SHIFT(31),
  [69] = {.count = 1, .reusable = false}, SHIFT(37),
  [71] = {.count = 1, .reusable = false}, SHIFT(32),
  [73] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [75] = {.count = 1, .reusable = true}, SHIFT(44),
  [77] = {.count = 1, .reusable = true}, SHIFT(42),
  [79] = {.count = 1, .reusable = false}, SHIFT(43),
  [81] = {.count = 1, .reusable = false}, SHIFT(44),
  [83] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [85] = {.count = 1, .reusable = true}, SHIFT(45),
  [87] = {.count = 1, .reusable = true}, SHIFT(52),
  [89] = {.count = 1, .reusable = true}, SHIFT(49),
  [91] = {.count = 1, .reusable = true}, SHIFT(53),
  [93] = {.count = 1, .reusable = true}, SHIFT(54),
  [95] = {.count = 1, .reusable = true}, SHIFT(55),
  [97] = {.count = 1, .reusable = true}, SHIFT(56),
  [99] = {.count = 1, .reusable = false}, SHIFT(57),
  [101] = {.count = 1, .reusable = false}, SHIFT(58),
  [103] = {.count = 1, .reusable = true}, SHIFT(59),
  [105] = {.count = 1, .reusable = false}, SHIFT(60),
  [107] = {.count = 1, .reusable = false}, SHIFT(61),
  [109] = {.count = 1, .reusable = true}, SHIFT(62),
  [111] = {.count = 1, .reusable = true}, SHIFT(66),
  [113] = {.count = 1, .reusable = true}, SHIFT(63),
  [115] = {.count = 1, .reusable = false}, SHIFT(66),
  [117] = {.count = 1, .reusable = false}, SHIFT(64),
  [119] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1, .alias_sequence_id = 1),
  [121] = {.count = 1, .reusable = true}, SHIFT(69),
  [123] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1, .alias_sequence_id = 1),
  [125] = {.count = 1, .reusable = false}, SHIFT(71),
  [127] = {.count = 1, .reusable = false}, SHIFT(72),
  [129] = {.count = 1, .reusable = true}, SHIFT(74),
  [131] = {.count = 1, .reusable = false}, SHIFT(75),
  [133] = {.count = 1, .reusable = true}, SHIFT(81),
  [135] = {.count = 1, .reusable = true}, SHIFT(77),
  [137] = {.count = 1, .reusable = false}, SHIFT(81),
  [139] = {.count = 1, .reusable = false}, SHIFT(78),
  [141] = {.count = 1, .reusable = true}, SHIFT(70),
  [143] = {.count = 1, .reusable = false}, SHIFT(73),
  [145] = {.count = 1, .reusable = true}, SHIFT(76),
  [147] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 1),
  [149] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 1),
  [151] = {.count = 1, .reusable = false}, SHIFT(87),
  [153] = {.count = 1, .reusable = false}, SHIFT(88),
  [155] = {.count = 1, .reusable = true}, SHIFT(89),
  [157] = {.count = 1, .reusable = false}, SHIFT(90),
  [159] = {.count = 1, .reusable = true}, SHIFT(94),
  [161] = {.count = 1, .reusable = false}, SHIFT(94),
  [163] = {.count = 1, .reusable = false}, SHIFT(91),
  [165] = {.count = 1, .reusable = true}, REDUCE(sym_pass_statement, 1),
  [167] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 1),
  [169] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 1),
  [171] = {.count = 1, .reusable = false}, SHIFT(96),
  [173] = {.count = 1, .reusable = true}, SHIFT(97),
  [175] = {.count = 1, .reusable = false}, SHIFT(98),
  [177] = {.count = 1, .reusable = true}, SHIFT(101),
  [179] = {.count = 1, .reusable = false}, SHIFT(101),
  [181] = {.count = 1, .reusable = false}, SHIFT(99),
  [183] = {.count = 1, .reusable = true}, SHIFT(103),
  [185] = {.count = 1, .reusable = true}, SHIFT(104),
  [187] = {.count = 1, .reusable = true}, SHIFT(105),
  [189] = {.count = 1, .reusable = true}, SHIFT(106),
  [191] = {.count = 1, .reusable = true}, SHIFT(108),
  [193] = {.count = 1, .reusable = false}, SHIFT(108),
  [195] = {.count = 1, .reusable = true}, SHIFT(111),
  [197] = {.count = 1, .reusable = false}, SHIFT(112),
  [199] = {.count = 1, .reusable = true}, SHIFT(113),
  [201] = {.count = 1, .reusable = false}, SHIFT(114),
  [203] = {.count = 1, .reusable = true}, SHIFT(118),
  [205] = {.count = 1, .reusable = false}, SHIFT(118),
  [207] = {.count = 1, .reusable = false}, SHIFT(115),
  [209] = {.count = 1, .reusable = true}, SHIFT(120),
  [211] = {.count = 1, .reusable = true}, SHIFT(121),
  [213] = {.count = 1, .reusable = true}, SHIFT(122),
  [215] = {.count = 1, .reusable = true}, SHIFT(123),
  [217] = {.count = 1, .reusable = true}, SHIFT(125),
  [219] = {.count = 1, .reusable = true}, SHIFT(126),
  [221] = {.count = 1, .reusable = false}, SHIFT(128),
  [223] = {.count = 1, .reusable = true}, SHIFT(130),
  [225] = {.count = 1, .reusable = false}, SHIFT(130),
  [227] = {.count = 1, .reusable = true}, SHIFT(131),
  [229] = {.count = 1, .reusable = true}, SHIFT(132),
  [231] = {.count = 1, .reusable = false}, SHIFT(133),
  [233] = {.count = 1, .reusable = true}, SHIFT(134),
  [235] = {.count = 1, .reusable = false}, SHIFT(135),
  [237] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [239] = {.count = 1, .reusable = false}, SHIFT(140),
  [241] = {.count = 1, .reusable = true}, SHIFT(142),
  [243] = {.count = 1, .reusable = true}, SHIFT(143),
  [245] = {.count = 1, .reusable = false}, SHIFT(144),
  [247] = {.count = 1, .reusable = true}, SHIFT(145),
  [249] = {.count = 1, .reusable = false}, SHIFT(146),
  [251] = {.count = 1, .reusable = true}, SHIFT(147),
  [253] = {.count = 1, .reusable = true}, SHIFT(151),
  [255] = {.count = 1, .reusable = false}, SHIFT(151),
  [257] = {.count = 1, .reusable = false}, SHIFT(148),
  [259] = {.count = 1, .reusable = true}, SHIFT(153),
  [261] = {.count = 1, .reusable = true}, SHIFT(154),
  [263] = {.count = 1, .reusable = false}, SHIFT(155),
  [265] = {.count = 1, .reusable = true}, SHIFT(156),
  [267] = {.count = 1, .reusable = false}, SHIFT(157),
  [269] = {.count = 1, .reusable = true}, SHIFT(163),
  [271] = {.count = 1, .reusable = true}, SHIFT(158),
  [273] = {.count = 1, .reusable = false}, SHIFT(163),
  [275] = {.count = 1, .reusable = false}, SHIFT(159),
  [277] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [279] = {.count = 1, .reusable = true}, SHIFT(167),
  [281] = {.count = 1, .reusable = true}, SHIFT(168),
  [283] = {.count = 1, .reusable = true}, SHIFT(170),
  [285] = {.count = 1, .reusable = true}, SHIFT(171),
  [287] = {.count = 1, .reusable = true}, SHIFT(172),
  [289] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 1),
  [291] = {.count = 1, .reusable = true}, SHIFT(173),
  [293] = {.count = 1, .reusable = true}, SHIFT(174),
  [295] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 1),
  [297] = {.count = 1, .reusable = true}, SHIFT(175),
  [299] = {.count = 1, .reusable = true}, SHIFT(176),
  [301] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [303] = {.count = 1, .reusable = true}, SHIFT(178),
  [305] = {.count = 1, .reusable = true}, SHIFT(179),
  [307] = {.count = 1, .reusable = false}, SHIFT(180),
  [309] = {.count = 1, .reusable = false}, SHIFT(181),
  [311] = {.count = 1, .reusable = true}, SHIFT(182),
  [313] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [315] = {.count = 1, .reusable = true}, SHIFT(183),
  [317] = {.count = 1, .reusable = false}, SHIFT(184),
  [319] = {.count = 1, .reusable = false}, SHIFT(185),
  [321] = {.count = 1, .reusable = false}, SHIFT(186),
  [323] = {.count = 1, .reusable = false}, SHIFT(187),
  [325] = {.count = 1, .reusable = false}, SHIFT(188),
  [327] = {.count = 1, .reusable = false}, SHIFT(182),
  [329] = {.count = 1, .reusable = true}, SHIFT(189),
  [331] = {.count = 1, .reusable = true}, SHIFT(190),
  [333] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1),
  [335] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1),
  [337] = {.count = 1, .reusable = true}, REDUCE(sym_module, 1),
  [339] = {.count = 1, .reusable = true}, SHIFT(195),
  [341] = {.count = 1, .reusable = true}, SHIFT(20),
  [343] = {.count = 1, .reusable = true}, SHIFT(24),
  [345] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2, .alias_sequence_id = 2),
  [347] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2, .alias_sequence_id = 2),
  [349] = {.count = 1, .reusable = false}, SHIFT(198),
  [351] = {.count = 1, .reusable = true}, SHIFT(199),
  [353] = {.count = 1, .reusable = false}, SHIFT(200),
  [355] = {.count = 1, .reusable = true}, SHIFT(203),
  [357] = {.count = 1, .reusable = false}, SHIFT(203),
  [359] = {.count = 1, .reusable = false}, SHIFT(201),
  [361] = {.count = 1, .reusable = true}, SHIFT(206),
  [363] = {.count = 1, .reusable = true}, SHIFT(205),
  [365] = {.count = 1, .reusable = false}, SHIFT(206),
  [367] = {.count = 1, .reusable = true}, REDUCE(sym_dotted_name, 1),
  [369] = {.count = 1, .reusable = true}, SHIFT(207),
  [371] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 2),
  [373] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 1),
  [375] = {.count = 1, .reusable = true}, SHIFT(209),
  [377] = {.count = 1, .reusable = true}, SHIFT(211),
  [379] = {.count = 1, .reusable = true}, SHIFT(212),
  [381] = {.count = 1, .reusable = false}, REDUCE(sym_relative_import, 1),
  [383] = {.count = 1, .reusable = false}, SHIFT(49),
  [385] = {.count = 1, .reusable = true}, SHIFT(215),
  [387] = {.count = 1, .reusable = false}, REDUCE(sym_import_prefix, 1),
  [389] = {.count = 1, .reusable = true}, SHIFT(216),
  [391] = {.count = 1, .reusable = true}, SHIFT(218),
  [393] = {.count = 1, .reusable = true}, SHIFT(217),
  [395] = {.count = 1, .reusable = false}, SHIFT(218),
  [397] = {.count = 1, .reusable = true}, SHIFT(219),
  [399] = {.count = 1, .reusable = true}, SHIFT(220),
  [401] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 2),
  [403] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 2),
  [405] = {.count = 1, .reusable = true}, SHIFT(223),
  [407] = {.count = 1, .reusable = true}, SHIFT(225),
  [409] = {.count = 1, .reusable = false}, SHIFT(225),
  [411] = {.count = 1, .reusable = true}, SHIFT(226),
  [413] = {.count = 1, .reusable = false}, SHIFT(228),
  [415] = {.count = 1, .reusable = false}, SHIFT(229),
  [417] = {.count = 1, .reusable = true}, SHIFT(230),
  [419] = {.count = 1, .reusable = false}, SHIFT(231),
  [421] = {.count = 1, .reusable = true}, SHIFT(235),
  [423] = {.count = 1, .reusable = false}, SHIFT(235),
  [425] = {.count = 1, .reusable = false}, SHIFT(232),
  [427] = {.count = 1, .reusable = true}, SHIFT(237),
  [429] = {.count = 1, .reusable = true}, SHIFT(238),
  [431] = {.count = 1, .reusable = true}, SHIFT(241),
  [433] = {.count = 1, .reusable = true}, SHIFT(242),
  [435] = {.count = 1, .reusable = true}, SHIFT(248),
  [437] = {.count = 1, .reusable = true}, SHIFT(249),
  [439] = {.count = 1, .reusable = true}, SHIFT(250),
  [441] = {.count = 1, .reusable = true}, SHIFT(251),
  [443] = {.count = 1, .reusable = true}, SHIFT(252),
  [445] = {.count = 1, .reusable = true}, SHIFT(253),
  [447] = {.count = 1, .reusable = true}, SHIFT(254),
  [449] = {.count = 1, .reusable = true}, SHIFT(258),
  [451] = {.count = 1, .reusable = true}, SHIFT(259),
  [453] = {.count = 1, .reusable = false}, SHIFT(260),
  [455] = {.count = 1, .reusable = true}, SHIFT(261),
  [457] = {.count = 1, .reusable = true}, SHIFT(262),
  [459] = {.count = 1, .reusable = true}, SHIFT(260),
  [461] = {.count = 1, .reusable = true}, SHIFT(263),
  [463] = {.count = 1, .reusable = true}, SHIFT(264),
  [465] = {.count = 1, .reusable = true}, SHIFT(265),
  [467] = {.count = 1, .reusable = true}, SHIFT(266),
  [469] = {.count = 1, .reusable = true}, SHIFT(267),
  [471] = {.count = 1, .reusable = true}, SHIFT(268),
  [473] = {.count = 1, .reusable = false}, SHIFT(262),
  [475] = {.count = 1, .reusable = true}, SHIFT(269),
  [477] = {.count = 1, .reusable = true}, SHIFT(270),
  [479] = {.count = 1, .reusable = true}, SHIFT(275),
  [481] = {.count = 1, .reusable = true}, SHIFT(274),
  [483] = {.count = 1, .reusable = false}, SHIFT(275),
  [485] = {.count = 1, .reusable = true}, SHIFT(276),
  [487] = {.count = 1, .reusable = true}, SHIFT(277),
  [489] = {.count = 1, .reusable = true}, SHIFT(282),
  [491] = {.count = 1, .reusable = false}, SHIFT(282),
  [493] = {.count = 1, .reusable = true}, SHIFT(283),
  [495] = {.count = 1, .reusable = true}, SHIFT(285),
  [497] = {.count = 1, .reusable = true}, SHIFT(286),
  [499] = {.count = 1, .reusable = true}, SHIFT(289),
  [501] = {.count = 1, .reusable = true}, SHIFT(290),
  [503] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 2),
  [505] = {.count = 1, .reusable = true}, SHIFT(295),
  [507] = {.count = 1, .reusable = true}, SHIFT(297),
  [509] = {.count = 1, .reusable = true}, SHIFT(298),
  [511] = {.count = 1, .reusable = true}, SHIFT(299),
  [513] = {.count = 1, .reusable = true}, SHIFT(300),
  [515] = {.count = 1, .reusable = true}, SHIFT(301),
  [517] = {.count = 1, .reusable = false}, SHIFT(302),
  [519] = {.count = 1, .reusable = true}, SHIFT(303),
  [521] = {.count = 1, .reusable = true}, SHIFT(304),
  [523] = {.count = 1, .reusable = true}, SHIFT(302),
  [525] = {.count = 1, .reusable = true}, SHIFT(305),
  [527] = {.count = 1, .reusable = true}, SHIFT(306),
  [529] = {.count = 1, .reusable = true}, SHIFT(307),
  [531] = {.count = 1, .reusable = true}, SHIFT(308),
  [533] = {.count = 1, .reusable = true}, SHIFT(309),
  [535] = {.count = 1, .reusable = true}, SHIFT(310),
  [537] = {.count = 1, .reusable = false}, SHIFT(304),
  [539] = {.count = 1, .reusable = true}, SHIFT(311),
  [541] = {.count = 1, .reusable = true}, SHIFT(312),
  [543] = {.count = 1, .reusable = true}, REDUCE(sym_assert_statement, 2),
  [545] = {.count = 1, .reusable = true}, SHIFT(316),
  [547] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [549] = {.count = 1, .reusable = true}, SHIFT(318),
  [551] = {.count = 1, .reusable = true}, REDUCE(sym_delete_statement, 2),
  [553] = {.count = 1, .reusable = false}, SHIFT(320),
  [555] = {.count = 1, .reusable = true}, SHIFT(321),
  [557] = {.count = 1, .reusable = false}, SHIFT(322),
  [559] = {.count = 1, .reusable = true}, SHIFT(325),
  [561] = {.count = 1, .reusable = false}, SHIFT(325),
  [563] = {.count = 1, .reusable = false}, SHIFT(323),
  [565] = {.count = 1, .reusable = true}, SHIFT(328),
  [567] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 2),
  [569] = {.count = 1, .reusable = true}, SHIFT(330),
  [571] = {.count = 1, .reusable = true}, SHIFT(331),
  [573] = {.count = 1, .reusable = true}, SHIFT(332),
  [575] = {.count = 1, .reusable = true}, SHIFT(333),
  [577] = {.count = 1, .reusable = true}, SHIFT(334),
  [579] = {.count = 1, .reusable = false}, SHIFT(336),
  [581] = {.count = 1, .reusable = true}, SHIFT(337),
  [583] = {.count = 1, .reusable = true}, SHIFT(338),
  [585] = {.count = 1, .reusable = true}, SHIFT(336),
  [587] = {.count = 1, .reusable = true}, SHIFT(339),
  [589] = {.count = 1, .reusable = true}, SHIFT(340),
  [591] = {.count = 1, .reusable = true}, SHIFT(341),
  [593] = {.count = 1, .reusable = true}, SHIFT(342),
  [595] = {.count = 1, .reusable = true}, SHIFT(343),
  [597] = {.count = 1, .reusable = true}, SHIFT(344),
  [599] = {.count = 1, .reusable = false}, SHIFT(338),
  [601] = {.count = 1, .reusable = true}, SHIFT(345),
  [603] = {.count = 1, .reusable = true}, SHIFT(349),
  [605] = {.count = 1, .reusable = true}, SHIFT(351),
  [607] = {.count = 1, .reusable = true}, SHIFT(352),
  [609] = {.count = 1, .reusable = true}, SHIFT(353),
  [611] = {.count = 1, .reusable = true}, SHIFT(354),
  [613] = {.count = 1, .reusable = false}, SHIFT(355),
  [615] = {.count = 1, .reusable = true}, SHIFT(356),
  [617] = {.count = 1, .reusable = true}, SHIFT(357),
  [619] = {.count = 1, .reusable = true}, SHIFT(355),
  [621] = {.count = 1, .reusable = true}, SHIFT(358),
  [623] = {.count = 1, .reusable = true}, SHIFT(359),
  [625] = {.count = 1, .reusable = true}, SHIFT(360),
  [627] = {.count = 1, .reusable = true}, SHIFT(361),
  [629] = {.count = 1, .reusable = true}, SHIFT(362),
  [631] = {.count = 1, .reusable = true}, SHIFT(363),
  [633] = {.count = 1, .reusable = false}, SHIFT(357),
  [635] = {.count = 1, .reusable = true}, SHIFT(364),
  [637] = {.count = 1, .reusable = true}, SHIFT(369),
  [639] = {.count = 1, .reusable = true}, SHIFT(370),
  [641] = {.count = 1, .reusable = true}, SHIFT(371),
  [643] = {.count = 1, .reusable = false}, SHIFT(372),
  [645] = {.count = 1, .reusable = true}, SHIFT(373),
  [647] = {.count = 1, .reusable = true}, REDUCE(sym_variables, 1),
  [649] = {.count = 1, .reusable = true}, SHIFT(372),
  [651] = {.count = 1, .reusable = true}, SHIFT(374),
  [653] = {.count = 1, .reusable = true}, SHIFT(375),
  [655] = {.count = 1, .reusable = true}, SHIFT(376),
  [657] = {.count = 1, .reusable = true}, SHIFT(377),
  [659] = {.count = 1, .reusable = true}, SHIFT(378),
  [661] = {.count = 1, .reusable = true}, SHIFT(381),
  [663] = {.count = 1, .reusable = true}, SHIFT(382),
  [665] = {.count = 1, .reusable = true}, SHIFT(386),
  [667] = {.count = 1, .reusable = true}, SHIFT(388),
  [669] = {.count = 1, .reusable = true}, SHIFT(389),
  [671] = {.count = 1, .reusable = true}, REDUCE(sym_with_item, 1),
  [673] = {.count = 1, .reusable = true}, SHIFT(391),
  [675] = {.count = 1, .reusable = true}, SHIFT(392),
  [677] = {.count = 1, .reusable = true}, SHIFT(393),
  [679] = {.count = 1, .reusable = true}, SHIFT(394),
  [681] = {.count = 1, .reusable = false}, SHIFT(395),
  [683] = {.count = 1, .reusable = true}, SHIFT(396),
  [685] = {.count = 1, .reusable = true}, SHIFT(397),
  [687] = {.count = 1, .reusable = true}, SHIFT(395),
  [689] = {.count = 1, .reusable = true}, SHIFT(398),
  [691] = {.count = 1, .reusable = true}, SHIFT(399),
  [693] = {.count = 1, .reusable = true}, SHIFT(400),
  [695] = {.count = 1, .reusable = true}, SHIFT(401),
  [697] = {.count = 1, .reusable = true}, SHIFT(402),
  [699] = {.count = 1, .reusable = true}, SHIFT(403),
  [701] = {.count = 1, .reusable = false}, SHIFT(397),
  [703] = {.count = 1, .reusable = true}, SHIFT(404),
  [705] = {.count = 1, .reusable = true}, SHIFT(407),
  [707] = {.count = 1, .reusable = true}, REDUCE(sym_global_statement, 2),
  [709] = {.count = 1, .reusable = true}, SHIFT(409),
  [711] = {.count = 1, .reusable = true}, REDUCE(sym_nonlocal_statement, 2),
  [713] = {.count = 1, .reusable = true}, SHIFT(413),
  [715] = {.count = 1, .reusable = true}, SHIFT(412),
  [717] = {.count = 1, .reusable = false}, SHIFT(413),
  [719] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 2),
  [721] = {.count = 1, .reusable = true}, SHIFT(414),
  [723] = {.count = 1, .reusable = true}, SHIFT(415),
  [725] = {.count = 1, .reusable = true}, SHIFT(416),
  [727] = {.count = 1, .reusable = true}, SHIFT(419),
  [729] = {.count = 1, .reusable = true}, SHIFT(420),
  [731] = {.count = 1, .reusable = true}, REDUCE(sym_not_operator, 2),
  [733] = {.count = 1, .reusable = true}, REDUCE(sym_unary_operator, 2),
  [735] = {.count = 1, .reusable = false}, REDUCE(sym_unary_operator, 2),
  [737] = {.count = 1, .reusable = true}, REDUCE(sym_list_splat, 1),
  [739] = {.count = 1, .reusable = true}, SHIFT(424),
  [741] = {.count = 1, .reusable = false}, SHIFT(425),
  [743] = {.count = 1, .reusable = true}, SHIFT(426),
  [745] = {.count = 1, .reusable = false}, SHIFT(427),
  [747] = {.count = 1, .reusable = true}, SHIFT(430),
  [749] = {.count = 1, .reusable = false}, SHIFT(430),
  [751] = {.count = 1, .reusable = false}, SHIFT(428),
  [753] = {.count = 1, .reusable = true}, SHIFT(432),
  [755] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1, .alias_sequence_id = 1),
  [757] = {.count = 1, .reusable = true}, SHIFT(434),
  [759] = {.count = 1, .reusable = true}, SHIFT(437),
  [761] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1),
  [763] = {.count = 1, .reusable = true}, SHIFT(439),
  [765] = {.count = 1, .reusable = true}, SHIFT(441),
  [767] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 1),
  [769] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [771] = {.count = 1, .reusable = true}, SHIFT(444),
  [773] = {.count = 1, .reusable = false}, SHIFT(445),
  [775] = {.count = 1, .reusable = true}, SHIFT(446),
  [777] = {.count = 1, .reusable = false}, SHIFT(447),
  [779] = {.count = 1, .reusable = true}, SHIFT(450),
  [781] = {.count = 1, .reusable = false}, SHIFT(450),
  [783] = {.count = 1, .reusable = false}, SHIFT(448),
  [785] = {.count = 1, .reusable = true}, SHIFT(453),
  [787] = {.count = 1, .reusable = true}, REDUCE(sym_list, 2),
  [789] = {.count = 1, .reusable = false}, REDUCE(sym_list, 2),
  [791] = {.count = 1, .reusable = true}, SHIFT(455),
  [793] = {.count = 1, .reusable = true}, SHIFT(457),
  [795] = {.count = 1, .reusable = true}, SHIFT(458),
  [797] = {.count = 1, .reusable = true}, SHIFT(459),
  [799] = {.count = 1, .reusable = true}, SHIFT(460),
  [801] = {.count = 1, .reusable = true}, SHIFT(461),
  [803] = {.count = 1, .reusable = false}, SHIFT(464),
  [805] = {.count = 1, .reusable = true}, SHIFT(465),
  [807] = {.count = 1, .reusable = true}, SHIFT(466),
  [809] = {.count = 1, .reusable = true}, SHIFT(464),
  [811] = {.count = 1, .reusable = true}, SHIFT(467),
  [813] = {.count = 1, .reusable = true}, SHIFT(468),
  [815] = {.count = 1, .reusable = true}, SHIFT(469),
  [817] = {.count = 1, .reusable = true}, SHIFT(470),
  [819] = {.count = 1, .reusable = true}, SHIFT(471),
  [821] = {.count = 1, .reusable = true}, SHIFT(472),
  [823] = {.count = 1, .reusable = false}, SHIFT(466),
  [825] = {.count = 1, .reusable = true}, SHIFT(473),
  [827] = {.count = 1, .reusable = true}, SHIFT(476),
  [829] = {.count = 1, .reusable = true}, SHIFT(477),
  [831] = {.count = 1, .reusable = false}, SHIFT(478),
  [833] = {.count = 1, .reusable = true}, SHIFT(479),
  [835] = {.count = 1, .reusable = false}, SHIFT(480),
  [837] = {.count = 1, .reusable = true}, SHIFT(483),
  [839] = {.count = 1, .reusable = false}, SHIFT(483),
  [841] = {.count = 1, .reusable = false}, SHIFT(481),
  [843] = {.count = 1, .reusable = true}, SHIFT(486),
  [845] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 2),
  [847] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 2),
  [849] = {.count = 1, .reusable = true}, SHIFT(488),
  [851] = {.count = 1, .reusable = true}, SHIFT(489),
  [853] = {.count = 1, .reusable = true}, SHIFT(491),
  [855] = {.count = 1, .reusable = true}, SHIFT(493),
  [857] = {.count = 1, .reusable = true}, SHIFT(494),
  [859] = {.count = 1, .reusable = true}, SHIFT(495),
  [861] = {.count = 1, .reusable = true}, SHIFT(496),
  [863] = {.count = 1, .reusable = true}, SHIFT(497),
  [865] = {.count = 1, .reusable = true}, SHIFT(498),
  [867] = {.count = 1, .reusable = false}, SHIFT(501),
  [869] = {.count = 1, .reusable = true}, SHIFT(502),
  [871] = {.count = 1, .reusable = true}, SHIFT(503),
  [873] = {.count = 1, .reusable = true}, SHIFT(501),
  [875] = {.count = 1, .reusable = true}, SHIFT(504),
  [877] = {.count = 1, .reusable = true}, SHIFT(505),
  [879] = {.count = 1, .reusable = true}, SHIFT(506),
  [881] = {.count = 1, .reusable = true}, SHIFT(507),
  [883] = {.count = 1, .reusable = true}, SHIFT(508),
  [885] = {.count = 1, .reusable = true}, SHIFT(509),
  [887] = {.count = 1, .reusable = false}, SHIFT(503),
  [889] = {.count = 1, .reusable = true}, SHIFT(510),
  [891] = {.count = 1, .reusable = true}, REDUCE(sym_await, 2),
  [893] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 2),
  [895] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 2),
  [897] = {.count = 1, .reusable = true}, SHIFT(514),
  [899] = {.count = 1, .reusable = true}, SHIFT(516),
  [901] = {.count = 1, .reusable = false}, SHIFT(518),
  [903] = {.count = 1, .reusable = true}, SHIFT(519),
  [905] = {.count = 1, .reusable = false}, SHIFT(520),
  [907] = {.count = 1, .reusable = true}, SHIFT(523),
  [909] = {.count = 1, .reusable = false}, SHIFT(523),
  [911] = {.count = 1, .reusable = false}, SHIFT(521),
  [913] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [915] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 2),
  [917] = {.count = 1, .reusable = false}, SHIFT(27),
  [919] = {.count = 1, .reusable = false}, SHIFT(531),
  [921] = {.count = 1, .reusable = true}, SHIFT(532),
  [923] = {.count = 1, .reusable = false}, SHIFT(533),
  [925] = {.count = 1, .reusable = true}, SHIFT(536),
  [927] = {.count = 1, .reusable = false}, SHIFT(536),
  [929] = {.count = 1, .reusable = false}, SHIFT(534),
  [931] = {.count = 1, .reusable = true}, SHIFT(540),
  [933] = {.count = 1, .reusable = true}, SHIFT(542),
  [935] = {.count = 1, .reusable = true}, SHIFT(543),
  [937] = {.count = 1, .reusable = true}, SHIFT(544),
  [939] = {.count = 1, .reusable = true}, SHIFT(545),
  [941] = {.count = 1, .reusable = false}, SHIFT(546),
  [943] = {.count = 1, .reusable = false}, SHIFT(547),
  [945] = {.count = 1, .reusable = true}, SHIFT(550),
  [947] = {.count = 1, .reusable = false}, SHIFT(550),
  [949] = {.count = 1, .reusable = true}, SHIFT(551),
  [951] = {.count = 1, .reusable = false}, SHIFT(551),
  [953] = {.count = 1, .reusable = true}, SHIFT(552),
  [955] = {.count = 1, .reusable = false}, SHIFT(552),
  [957] = {.count = 1, .reusable = true}, SHIFT(553),
  [959] = {.count = 1, .reusable = true}, SHIFT(554),
  [961] = {.count = 1, .reusable = false}, SHIFT(554),
  [963] = {.count = 1, .reusable = true}, SHIFT(555),
  [965] = {.count = 1, .reusable = false}, SHIFT(555),
  [967] = {.count = 1, .reusable = true}, SHIFT(556),
  [969] = {.count = 1, .reusable = false}, SHIFT(556),
  [971] = {.count = 1, .reusable = true}, SHIFT(557),
  [973] = {.count = 1, .reusable = false}, SHIFT(557),
  [975] = {.count = 1, .reusable = true}, SHIFT(558),
  [977] = {.count = 1, .reusable = false}, SHIFT(558),
  [979] = {.count = 1, .reusable = false}, SHIFT(553),
  [981] = {.count = 1, .reusable = true}, SHIFT(559),
  [983] = {.count = 1, .reusable = false}, SHIFT(560),
  [985] = {.count = 1, .reusable = true}, SHIFT(561),
  [987] = {.count = 1, .reusable = false}, SHIFT(562),
  [989] = {.count = 1, .reusable = true}, SHIFT(565),
  [991] = {.count = 1, .reusable = false}, SHIFT(565),
  [993] = {.count = 1, .reusable = false}, SHIFT(563),
  [995] = {.count = 1, .reusable = true}, REDUCE(sym_call, 2),
  [997] = {.count = 1, .reusable = false}, REDUCE(sym_call, 2),
  [999] = {.count = 1, .reusable = true}, REDUCE(sym_comparison_operator, 2),
  [1001] = {.count = 1, .reusable = false}, REDUCE(sym_comparison_operator, 2),
  [1003] = {.count = 1, .reusable = true}, REDUCE(sym_concatenated_string, 2),
  [1005] = {.count = 1, .reusable = false}, REDUCE(sym_concatenated_string, 2),
  [1007] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2),
  [1010] = {.count = 1, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2),
  [1012] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3),
  [1015] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(4),
  [1018] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(5),
  [1021] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(6),
  [1024] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(7),
  [1027] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(8),
  [1030] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(9),
  [1033] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(10),
  [1036] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(11),
  [1039] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(12),
  [1042] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(13),
  [1045] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(14),
  [1048] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(15),
  [1051] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(16),
  [1054] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(17),
  [1057] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(18),
  [1060] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(19),
  [1063] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(20),
  [1066] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(21),
  [1069] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(22),
  [1072] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(23),
  [1075] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(24),
  [1078] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(25),
  [1081] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(26),
  [1084] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(27),
  [1087] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(28),
  [1090] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(29),
  [1093] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(30),
  [1096] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(37),
  [1099] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(31),
  [1102] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(37),
  [1105] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(32),
  [1108] = {.count = 1, .reusable = true}, REDUCE(sym_decorated_definition, 2),
  [1110] = {.count = 1, .reusable = false}, REDUCE(sym_decorated_definition, 2),
  [1112] = {.count = 1, .reusable = true}, REDUCE(aux_sym_decorated_definition_repeat1, 2),
  [1114] = {.count = 2, .reusable = true}, REDUCE(aux_sym_decorated_definition_repeat1, 2), SHIFT_REPEAT(25),
  [1117] = {.count = 1, .reusable = true}, SHIFT(571),
  [1119] = {.count = 1, .reusable = true}, SHIFT(573),
  [1121] = {.count = 1, .reusable = true}, SHIFT(574),
  [1123] = {.count = 1, .reusable = true}, SHIFT(575),
  [1125] = {.count = 1, .reusable = true}, SHIFT(576),
  [1127] = {.count = 1, .reusable = true}, SHIFT(577),
  [1129] = {.count = 1, .reusable = false}, SHIFT(578),
  [1131] = {.count = 1, .reusable = true}, SHIFT(579),
  [1133] = {.count = 1, .reusable = true}, SHIFT(580),
  [1135] = {.count = 1, .reusable = true}, SHIFT(578),
  [1137] = {.count = 1, .reusable = true}, SHIFT(581),
  [1139] = {.count = 1, .reusable = true}, SHIFT(582),
  [1141] = {.count = 1, .reusable = true}, SHIFT(583),
  [1143] = {.count = 1, .reusable = true}, SHIFT(584),
  [1145] = {.count = 1, .reusable = true}, SHIFT(585),
  [1147] = {.count = 1, .reusable = true}, SHIFT(586),
  [1149] = {.count = 1, .reusable = false}, SHIFT(580),
  [1151] = {.count = 1, .reusable = true}, SHIFT(587),
  [1153] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3, .alias_sequence_id = 3),
  [1155] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3, .alias_sequence_id = 3),
  [1157] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(206),
  [1160] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1162] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(43),
  [1165] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(206),
  [1168] = {.count = 1, .reusable = true}, SHIFT(590),
  [1170] = {.count = 1, .reusable = true}, REDUCE(sym_dotted_name, 2),
  [1172] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 2),
  [1174] = {.count = 1, .reusable = true}, SHIFT(594),
  [1176] = {.count = 1, .reusable = true}, SHIFT(596),
  [1178] = {.count = 1, .reusable = true}, SHIFT(597),
  [1180] = {.count = 1, .reusable = true}, REDUCE(sym_relative_import, 2),
  [1182] = {.count = 1, .reusable = true}, SHIFT(599),
  [1184] = {.count = 1, .reusable = true}, SHIFT(600),
  [1186] = {.count = 1, .reusable = false}, REDUCE(aux_sym_import_prefix_repeat1, 2),
  [1188] = {.count = 2, .reusable = true}, REDUCE(aux_sym_import_prefix_repeat1, 2), SHIFT_REPEAT(216),
  [1191] = {.count = 1, .reusable = true}, SHIFT(602),
  [1193] = {.count = 1, .reusable = true}, SHIFT(603),
  [1195] = {.count = 1, .reusable = true}, SHIFT(604),
  [1197] = {.count = 1, .reusable = true}, SHIFT(605),
  [1199] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 3),
  [1201] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 3),
  [1203] = {.count = 1, .reusable = true}, SHIFT(609),
  [1205] = {.count = 1, .reusable = true}, SHIFT(612),
  [1207] = {.count = 1, .reusable = true}, SHIFT(614),
  [1209] = {.count = 1, .reusable = true}, SHIFT(615),
  [1211] = {.count = 1, .reusable = true}, SHIFT(616),
  [1213] = {.count = 1, .reusable = true}, SHIFT(617),
  [1215] = {.count = 1, .reusable = false}, SHIFT(619),
  [1217] = {.count = 1, .reusable = true}, SHIFT(620),
  [1219] = {.count = 1, .reusable = true}, SHIFT(621),
  [1221] = {.count = 1, .reusable = true}, SHIFT(619),
  [1223] = {.count = 1, .reusable = true}, SHIFT(622),
  [1225] = {.count = 1, .reusable = true}, SHIFT(623),
  [1227] = {.count = 1, .reusable = true}, SHIFT(624),
  [1229] = {.count = 1, .reusable = true}, SHIFT(625),
  [1231] = {.count = 1, .reusable = true}, SHIFT(626),
  [1233] = {.count = 1, .reusable = true}, SHIFT(627),
  [1235] = {.count = 1, .reusable = false}, SHIFT(621),
  [1237] = {.count = 1, .reusable = true}, SHIFT(628),
  [1239] = {.count = 1, .reusable = true}, SHIFT(631),
  [1241] = {.count = 1, .reusable = true}, SHIFT(632),
  [1243] = {.count = 1, .reusable = true}, SHIFT(635),
  [1245] = {.count = 1, .reusable = true}, SHIFT(636),
  [1247] = {.count = 1, .reusable = true}, SHIFT(637),
  [1249] = {.count = 1, .reusable = true}, SHIFT(639),
  [1251] = {.count = 1, .reusable = false}, REDUCE(sym_await, 2),
  [1253] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [1255] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [1257] = {.count = 1, .reusable = true}, SHIFT(643),
  [1259] = {.count = 1, .reusable = true}, SHIFT(647),
  [1261] = {.count = 1, .reusable = true}, SHIFT(651),
  [1263] = {.count = 1, .reusable = true}, REDUCE(sym__comprehension_body, 1),
  [1265] = {.count = 1, .reusable = true}, SHIFT(652),
  [1267] = {.count = 1, .reusable = true}, SHIFT(654),
  [1269] = {.count = 1, .reusable = true}, SHIFT(656),
  [1271] = {.count = 1, .reusable = true}, SHIFT(657),
  [1273] = {.count = 1, .reusable = true}, SHIFT(658),
  [1275] = {.count = 1, .reusable = true}, SHIFT(661),
  [1277] = {.count = 1, .reusable = false}, SHIFT(661),
  [1279] = {.count = 1, .reusable = true}, SHIFT(662),
  [1281] = {.count = 1, .reusable = false}, SHIFT(662),
  [1283] = {.count = 1, .reusable = true}, SHIFT(663),
  [1285] = {.count = 1, .reusable = false}, SHIFT(663),
  [1287] = {.count = 1, .reusable = true}, SHIFT(664),
  [1289] = {.count = 1, .reusable = true}, SHIFT(665),
  [1291] = {.count = 1, .reusable = false}, SHIFT(665),
  [1293] = {.count = 1, .reusable = true}, SHIFT(666),
  [1295] = {.count = 1, .reusable = false}, SHIFT(666),
  [1297] = {.count = 1, .reusable = true}, SHIFT(667),
  [1299] = {.count = 1, .reusable = false}, SHIFT(667),
  [1301] = {.count = 1, .reusable = true}, SHIFT(668),
  [1303] = {.count = 1, .reusable = false}, SHIFT(668),
  [1305] = {.count = 1, .reusable = true}, SHIFT(669),
  [1307] = {.count = 1, .reusable = false}, SHIFT(669),
  [1309] = {.count = 1, .reusable = false}, SHIFT(664),
  [1311] = {.count = 1, .reusable = true}, SHIFT(674),
  [1313] = {.count = 1, .reusable = true}, SHIFT(675),
  [1315] = {.count = 1, .reusable = true}, SHIFT(676),
  [1317] = {.count = 1, .reusable = true}, SHIFT(677),
  [1319] = {.count = 1, .reusable = true}, REDUCE(sym_chevron, 2),
  [1321] = {.count = 1, .reusable = true}, SHIFT(681),
  [1323] = {.count = 1, .reusable = true}, SHIFT(682),
  [1325] = {.count = 1, .reusable = true}, SHIFT(683),
  [1327] = {.count = 1, .reusable = true}, SHIFT(686),
  [1329] = {.count = 1, .reusable = true}, SHIFT(687),
  [1331] = {.count = 1, .reusable = true}, SHIFT(688),
  [1333] = {.count = 1, .reusable = true}, SHIFT(690),
  [1335] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3),
  [1337] = {.count = 1, .reusable = true}, SHIFT(695),
  [1339] = {.count = 1, .reusable = true}, SHIFT(699),
  [1341] = {.count = 1, .reusable = true}, SHIFT(700),
  [1343] = {.count = 1, .reusable = true}, SHIFT(701),
  [1345] = {.count = 1, .reusable = true}, SHIFT(704),
  [1347] = {.count = 1, .reusable = false}, SHIFT(704),
  [1349] = {.count = 1, .reusable = true}, SHIFT(705),
  [1351] = {.count = 1, .reusable = false}, SHIFT(705),
  [1353] = {.count = 1, .reusable = true}, SHIFT(706),
  [1355] = {.count = 1, .reusable = false}, SHIFT(706),
  [1357] = {.count = 1, .reusable = true}, SHIFT(707),
  [1359] = {.count = 1, .reusable = true}, SHIFT(708),
  [1361] = {.count = 1, .reusable = false}, SHIFT(708),
  [1363] = {.count = 1, .reusable = true}, SHIFT(709),
  [1365] = {.count = 1, .reusable = false}, SHIFT(709),
  [1367] = {.count = 1, .reusable = true}, SHIFT(710),
  [1369] = {.count = 1, .reusable = false}, SHIFT(710),
  [1371] = {.count = 1, .reusable = true}, SHIFT(711),
  [1373] = {.count = 1, .reusable = false}, SHIFT(711),
  [1375] = {.count = 1, .reusable = true}, SHIFT(712),
  [1377] = {.count = 1, .reusable = false}, SHIFT(712),
  [1379] = {.count = 1, .reusable = false}, SHIFT(707),
  [1381] = {.count = 1, .reusable = true}, REDUCE(sym_assert_statement, 3),
  [1383] = {.count = 1, .reusable = true}, SHIFT(717),
  [1385] = {.count = 1, .reusable = true}, SHIFT(719),
  [1387] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 3),
  [1389] = {.count = 1, .reusable = true}, SHIFT(721),
  [1391] = {.count = 1, .reusable = true}, SHIFT(722),
  [1393] = {.count = 1, .reusable = true}, SHIFT(723),
  [1395] = {.count = 1, .reusable = false}, SHIFT(724),
  [1397] = {.count = 1, .reusable = true}, SHIFT(725),
  [1399] = {.count = 1, .reusable = true}, SHIFT(726),
  [1401] = {.count = 1, .reusable = true}, SHIFT(724),
  [1403] = {.count = 1, .reusable = true}, SHIFT(727),
  [1405] = {.count = 1, .reusable = true}, SHIFT(728),
  [1407] = {.count = 1, .reusable = true}, SHIFT(729),
  [1409] = {.count = 1, .reusable = true}, SHIFT(730),
  [1411] = {.count = 1, .reusable = true}, SHIFT(731),
  [1413] = {.count = 1, .reusable = true}, SHIFT(732),
  [1415] = {.count = 1, .reusable = false}, SHIFT(726),
  [1417] = {.count = 1, .reusable = true}, SHIFT(733),
  [1419] = {.count = 1, .reusable = true}, SHIFT(737),
  [1421] = {.count = 1, .reusable = false}, REDUCE(sym_expression_list, 2),
  [1423] = {.count = 1, .reusable = true}, SHIFT(742),
  [1425] = {.count = 1, .reusable = true}, SHIFT(744),
  [1427] = {.count = 1, .reusable = false}, SHIFT(744),
  [1429] = {.count = 1, .reusable = true}, SHIFT(745),
  [1431] = {.count = 1, .reusable = false}, SHIFT(745),
  [1433] = {.count = 1, .reusable = true}, SHIFT(746),
  [1435] = {.count = 1, .reusable = false}, SHIFT(746),
  [1437] = {.count = 1, .reusable = true}, SHIFT(747),
  [1439] = {.count = 1, .reusable = true}, SHIFT(748),
  [1441] = {.count = 1, .reusable = false}, SHIFT(748),
  [1443] = {.count = 1, .reusable = true}, SHIFT(749),
  [1445] = {.count = 1, .reusable = false}, SHIFT(749),
  [1447] = {.count = 1, .reusable = true}, SHIFT(750),
  [1449] = {.count = 1, .reusable = false}, SHIFT(750),
  [1451] = {.count = 1, .reusable = true}, SHIFT(751),
  [1453] = {.count = 1, .reusable = false}, SHIFT(751),
  [1455] = {.count = 1, .reusable = false}, SHIFT(747),
  [1457] = {.count = 1, .reusable = true}, SHIFT(755),
  [1459] = {.count = 1, .reusable = true}, SHIFT(757),
  [1461] = {.count = 1, .reusable = true}, SHIFT(760),
  [1463] = {.count = 1, .reusable = false}, SHIFT(760),
  [1465] = {.count = 1, .reusable = true}, SHIFT(761),
  [1467] = {.count = 1, .reusable = false}, SHIFT(761),
  [1469] = {.count = 1, .reusable = true}, SHIFT(762),
  [1471] = {.count = 1, .reusable = false}, SHIFT(762),
  [1473] = {.count = 1, .reusable = true}, SHIFT(763),
  [1475] = {.count = 1, .reusable = true}, SHIFT(764),
  [1477] = {.count = 1, .reusable = false}, SHIFT(764),
  [1479] = {.count = 1, .reusable = true}, SHIFT(765),
  [1481] = {.count = 1, .reusable = false}, SHIFT(765),
  [1483] = {.count = 1, .reusable = true}, SHIFT(766),
  [1485] = {.count = 1, .reusable = false}, SHIFT(766),
  [1487] = {.count = 1, .reusable = true}, SHIFT(767),
  [1489] = {.count = 1, .reusable = false}, SHIFT(767),
  [1491] = {.count = 1, .reusable = false}, SHIFT(763),
  [1493] = {.count = 1, .reusable = true}, SHIFT(770),
  [1495] = {.count = 1, .reusable = true}, SHIFT(771),
  [1497] = {.count = 1, .reusable = false}, REDUCE(sym_variables, 2),
  [1499] = {.count = 1, .reusable = true}, SHIFT(776),
  [1501] = {.count = 1, .reusable = false}, SHIFT(776),
  [1503] = {.count = 1, .reusable = true}, SHIFT(777),
  [1505] = {.count = 1, .reusable = false}, SHIFT(777),
  [1507] = {.count = 1, .reusable = true}, SHIFT(778),
  [1509] = {.count = 1, .reusable = false}, SHIFT(778),
  [1511] = {.count = 1, .reusable = true}, SHIFT(779),
  [1513] = {.count = 1, .reusable = false}, SHIFT(779),
  [1515] = {.count = 1, .reusable = true}, SHIFT(780),
  [1517] = {.count = 1, .reusable = false}, SHIFT(780),
  [1519] = {.count = 1, .reusable = true}, SHIFT(781),
  [1521] = {.count = 1, .reusable = false}, SHIFT(781),
  [1523] = {.count = 1, .reusable = true}, SHIFT(782),
  [1525] = {.count = 1, .reusable = false}, SHIFT(782),
  [1527] = {.count = 1, .reusable = true}, SHIFT(783),
  [1529] = {.count = 1, .reusable = true}, REDUCE(sym_variables, 2),
  [1531] = {.count = 1, .reusable = true}, SHIFT(787),
  [1533] = {.count = 1, .reusable = false}, SHIFT(788),
  [1535] = {.count = 1, .reusable = false}, SHIFT(789),
  [1537] = {.count = 1, .reusable = false}, SHIFT(790),
  [1539] = {.count = 1, .reusable = false}, SHIFT(791),
  [1541] = {.count = 1, .reusable = false}, SHIFT(792),
  [1543] = {.count = 1, .reusable = false}, SHIFT(793),
  [1545] = {.count = 1, .reusable = false}, SHIFT(794),
  [1547] = {.count = 1, .reusable = false}, SHIFT(795),
  [1549] = {.count = 1, .reusable = true}, SHIFT(799),
  [1551] = {.count = 1, .reusable = true}, SHIFT(800),
  [1553] = {.count = 1, .reusable = true}, SHIFT(802),
  [1555] = {.count = 1, .reusable = true}, SHIFT(803),
  [1557] = {.count = 1, .reusable = true}, SHIFT(807),
  [1559] = {.count = 1, .reusable = true}, SHIFT(814),
  [1561] = {.count = 1, .reusable = false}, SHIFT(814),
  [1563] = {.count = 1, .reusable = true}, SHIFT(815),
  [1565] = {.count = 1, .reusable = false}, SHIFT(815),
  [1567] = {.count = 1, .reusable = true}, SHIFT(816),
  [1569] = {.count = 1, .reusable = false}, SHIFT(816),
  [1571] = {.count = 1, .reusable = true}, SHIFT(817),
  [1573] = {.count = 1, .reusable = true}, SHIFT(818),
  [1575] = {.count = 1, .reusable = false}, SHIFT(818),
  [1577] = {.count = 1, .reusable = true}, SHIFT(819),
  [1579] = {.count = 1, .reusable = false}, SHIFT(819),
  [1581] = {.count = 1, .reusable = true}, SHIFT(820),
  [1583] = {.count = 1, .reusable = false}, SHIFT(820),
  [1585] = {.count = 1, .reusable = true}, SHIFT(821),
  [1587] = {.count = 1, .reusable = false}, SHIFT(821),
  [1589] = {.count = 1, .reusable = false}, SHIFT(817),
  [1591] = {.count = 1, .reusable = true}, SHIFT(824),
  [1593] = {.count = 1, .reusable = true}, SHIFT(825),
  [1595] = {.count = 1, .reusable = false}, SHIFT(826),
  [1597] = {.count = 1, .reusable = false}, SHIFT(827),
  [1599] = {.count = 1, .reusable = true}, SHIFT(831),
  [1601] = {.count = 1, .reusable = true}, SHIFT(832),
  [1603] = {.count = 1, .reusable = true}, SHIFT(833),
  [1605] = {.count = 1, .reusable = true}, REDUCE(sym_global_statement, 3),
  [1607] = {.count = 1, .reusable = true}, REDUCE(sym_nonlocal_statement, 3),
  [1609] = {.count = 1, .reusable = true}, SHIFT(835),
  [1611] = {.count = 1, .reusable = true}, SHIFT(839),
  [1613] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 3),
  [1615] = {.count = 1, .reusable = true}, SHIFT(842),
  [1617] = {.count = 1, .reusable = true}, SHIFT(845),
  [1619] = {.count = 1, .reusable = true}, REDUCE(sym_list_splat, 2),
  [1621] = {.count = 1, .reusable = true}, SHIFT(847),
  [1623] = {.count = 1, .reusable = true}, SHIFT(848),
  [1625] = {.count = 1, .reusable = true}, SHIFT(849),
  [1627] = {.count = 1, .reusable = false}, SHIFT(850),
  [1629] = {.count = 1, .reusable = true}, SHIFT(851),
  [1631] = {.count = 1, .reusable = true}, SHIFT(852),
  [1633] = {.count = 1, .reusable = true}, SHIFT(850),
  [1635] = {.count = 1, .reusable = true}, SHIFT(853),
  [1637] = {.count = 1, .reusable = true}, SHIFT(854),
  [1639] = {.count = 1, .reusable = true}, SHIFT(855),
  [1641] = {.count = 1, .reusable = true}, SHIFT(856),
  [1643] = {.count = 1, .reusable = true}, SHIFT(857),
  [1645] = {.count = 1, .reusable = true}, SHIFT(858),
  [1647] = {.count = 1, .reusable = false}, SHIFT(852),
  [1649] = {.count = 1, .reusable = true}, SHIFT(859),
  [1651] = {.count = 1, .reusable = false}, SHIFT(862),
  [1653] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2, .alias_sequence_id = 1),
  [1655] = {.count = 1, .reusable = false}, SHIFT(863),
  [1657] = {.count = 1, .reusable = false}, SHIFT(866),
  [1659] = {.count = 1, .reusable = true}, SHIFT(867),
  [1661] = {.count = 1, .reusable = false}, SHIFT(868),
  [1663] = {.count = 1, .reusable = true}, SHIFT(871),
  [1665] = {.count = 1, .reusable = false}, SHIFT(871),
  [1667] = {.count = 1, .reusable = false}, SHIFT(869),
  [1669] = {.count = 1, .reusable = true}, SHIFT(875),
  [1671] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3),
  [1673] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2),
  [1675] = {.count = 1, .reusable = false}, SHIFT(877),
  [1677] = {.count = 1, .reusable = true}, SHIFT(878),
  [1679] = {.count = 1, .reusable = false}, SHIFT(879),
  [1681] = {.count = 1, .reusable = true}, SHIFT(882),
  [1683] = {.count = 1, .reusable = false}, SHIFT(882),
  [1685] = {.count = 1, .reusable = false}, SHIFT(880),
  [1687] = {.count = 1, .reusable = true}, SHIFT(886),
  [1689] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 3),
  [1691] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [1693] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [1695] = {.count = 1, .reusable = true}, SHIFT(891),
  [1697] = {.count = 1, .reusable = true}, SHIFT(893),
  [1699] = {.count = 1, .reusable = true}, SHIFT(894),
  [1701] = {.count = 1, .reusable = true}, SHIFT(895),
  [1703] = {.count = 1, .reusable = false}, SHIFT(896),
  [1705] = {.count = 1, .reusable = true}, SHIFT(897),
  [1707] = {.count = 1, .reusable = true}, SHIFT(898),
  [1709] = {.count = 1, .reusable = true}, SHIFT(896),
  [1711] = {.count = 1, .reusable = true}, SHIFT(899),
  [1713] = {.count = 1, .reusable = true}, SHIFT(900),
  [1715] = {.count = 1, .reusable = true}, SHIFT(901),
  [1717] = {.count = 1, .reusable = true}, SHIFT(902),
  [1719] = {.count = 1, .reusable = true}, SHIFT(903),
  [1721] = {.count = 1, .reusable = true}, SHIFT(904),
  [1723] = {.count = 1, .reusable = false}, SHIFT(898),
  [1725] = {.count = 1, .reusable = true}, SHIFT(905),
  [1727] = {.count = 1, .reusable = true}, SHIFT(909),
  [1729] = {.count = 1, .reusable = true}, SHIFT(910),
  [1731] = {.count = 1, .reusable = true}, SHIFT(913),
  [1733] = {.count = 1, .reusable = true}, SHIFT(916),
  [1735] = {.count = 1, .reusable = true}, SHIFT(919),
  [1737] = {.count = 1, .reusable = true}, SHIFT(920),
  [1739] = {.count = 1, .reusable = true}, SHIFT(922),
  [1741] = {.count = 1, .reusable = false}, SHIFT(922),
  [1743] = {.count = 1, .reusable = true}, SHIFT(923),
  [1745] = {.count = 1, .reusable = false}, SHIFT(923),
  [1747] = {.count = 1, .reusable = true}, SHIFT(924),
  [1749] = {.count = 1, .reusable = false}, SHIFT(924),
  [1751] = {.count = 1, .reusable = true}, SHIFT(925),
  [1753] = {.count = 1, .reusable = true}, SHIFT(926),
  [1755] = {.count = 1, .reusable = false}, SHIFT(926),
  [1757] = {.count = 1, .reusable = true}, SHIFT(927),
  [1759] = {.count = 1, .reusable = false}, SHIFT(927),
  [1761] = {.count = 1, .reusable = true}, SHIFT(928),
  [1763] = {.count = 1, .reusable = false}, SHIFT(928),
  [1765] = {.count = 1, .reusable = true}, SHIFT(929),
  [1767] = {.count = 1, .reusable = false}, SHIFT(929),
  [1769] = {.count = 1, .reusable = false}, SHIFT(925),
  [1771] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 3),
  [1773] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 3),
  [1775] = {.count = 1, .reusable = true}, SHIFT(934),
  [1777] = {.count = 1, .reusable = true}, SHIFT(936),
  [1779] = {.count = 1, .reusable = true}, SHIFT(937),
  [1781] = {.count = 1, .reusable = true}, SHIFT(938),
  [1783] = {.count = 1, .reusable = false}, SHIFT(939),
  [1785] = {.count = 1, .reusable = true}, SHIFT(940),
  [1787] = {.count = 1, .reusable = true}, SHIFT(941),
  [1789] = {.count = 1, .reusable = true}, SHIFT(939),
  [1791] = {.count = 1, .reusable = true}, SHIFT(942),
  [1793] = {.count = 1, .reusable = true}, SHIFT(943),
  [1795] = {.count = 1, .reusable = true}, SHIFT(944),
  [1797] = {.count = 1, .reusable = true}, SHIFT(945),
  [1799] = {.count = 1, .reusable = true}, SHIFT(946),
  [1801] = {.count = 1, .reusable = true}, SHIFT(947),
  [1803] = {.count = 1, .reusable = false}, SHIFT(941),
  [1805] = {.count = 1, .reusable = true}, SHIFT(948),
  [1807] = {.count = 1, .reusable = true}, SHIFT(952),
  [1809] = {.count = 1, .reusable = true}, SHIFT(953),
  [1811] = {.count = 1, .reusable = true}, SHIFT(954),
  [1813] = {.count = 1, .reusable = true}, REDUCE(sym_set, 3),
  [1815] = {.count = 1, .reusable = false}, REDUCE(sym_set, 3),
  [1817] = {.count = 1, .reusable = true}, SHIFT(956),
  [1819] = {.count = 1, .reusable = true}, SHIFT(958),
  [1821] = {.count = 1, .reusable = true}, SHIFT(959),
  [1823] = {.count = 1, .reusable = true}, SHIFT(962),
  [1825] = {.count = 1, .reusable = false}, SHIFT(965),
  [1827] = {.count = 1, .reusable = true}, SHIFT(966),
  [1829] = {.count = 1, .reusable = false}, SHIFT(967),
  [1831] = {.count = 1, .reusable = true}, SHIFT(970),
  [1833] = {.count = 1, .reusable = false}, SHIFT(970),
  [1835] = {.count = 1, .reusable = false}, SHIFT(968),
  [1837] = {.count = 1, .reusable = true}, SHIFT(972),
  [1839] = {.count = 1, .reusable = true}, SHIFT(975),
  [1841] = {.count = 1, .reusable = true}, SHIFT(976),
  [1843] = {.count = 1, .reusable = true}, SHIFT(978),
  [1845] = {.count = 1, .reusable = false}, SHIFT(978),
  [1847] = {.count = 1, .reusable = true}, SHIFT(979),
  [1849] = {.count = 1, .reusable = false}, SHIFT(979),
  [1851] = {.count = 1, .reusable = true}, SHIFT(980),
  [1853] = {.count = 1, .reusable = false}, SHIFT(980),
  [1855] = {.count = 1, .reusable = true}, SHIFT(981),
  [1857] = {.count = 1, .reusable = true}, SHIFT(982),
  [1859] = {.count = 1, .reusable = false}, SHIFT(982),
  [1861] = {.count = 1, .reusable = true}, SHIFT(983),
  [1863] = {.count = 1, .reusable = false}, SHIFT(983),
  [1865] = {.count = 1, .reusable = true}, SHIFT(984),
  [1867] = {.count = 1, .reusable = false}, SHIFT(984),
  [1869] = {.count = 1, .reusable = true}, SHIFT(985),
  [1871] = {.count = 1, .reusable = false}, SHIFT(985),
  [1873] = {.count = 1, .reusable = false}, SHIFT(981),
  [1875] = {.count = 1, .reusable = true}, SHIFT(987),
  [1877] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 3),
  [1879] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 3),
  [1881] = {.count = 1, .reusable = true}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [1883] = {.count = 1, .reusable = true}, SHIFT(989),
  [1885] = {.count = 2, .reusable = true}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(990),
  [1888] = {.count = 1, .reusable = true}, SHIFT(992),
  [1890] = {.count = 1, .reusable = true}, REDUCE(sym_type, 1),
  [1892] = {.count = 1, .reusable = true}, SHIFT(994),
  [1894] = {.count = 1, .reusable = true}, SHIFT(995),
  [1896] = {.count = 1, .reusable = true}, SHIFT(996),
  [1898] = {.count = 1, .reusable = false}, SHIFT(997),
  [1900] = {.count = 1, .reusable = true}, SHIFT(998),
  [1902] = {.count = 1, .reusable = true}, SHIFT(999),
  [1904] = {.count = 1, .reusable = true}, SHIFT(997),
  [1906] = {.count = 1, .reusable = true}, SHIFT(1000),
  [1908] = {.count = 1, .reusable = true}, SHIFT(1001),
  [1910] = {.count = 1, .reusable = true}, SHIFT(1002),
  [1912] = {.count = 1, .reusable = true}, SHIFT(1003),
  [1914] = {.count = 1, .reusable = true}, SHIFT(1004),
  [1916] = {.count = 1, .reusable = true}, SHIFT(1005),
  [1918] = {.count = 1, .reusable = false}, SHIFT(999),
  [1920] = {.count = 1, .reusable = true}, SHIFT(1006),
  [1922] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3),
  [1924] = {.count = 1, .reusable = true}, SHIFT(1008),
  [1926] = {.count = 1, .reusable = true}, REDUCE(sym__right_hand_side, 1),
  [1928] = {.count = 1, .reusable = true}, SHIFT(1010),
  [1930] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment, 3),
  [1932] = {.count = 1, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2),
  [1934] = {.count = 1, .reusable = true}, SHIFT(1013),
  [1936] = {.count = 1, .reusable = true}, SHIFT(1015),
  [1938] = {.count = 1, .reusable = true}, SHIFT(1016),
  [1940] = {.count = 1, .reusable = true}, SHIFT(1017),
  [1942] = {.count = 1, .reusable = true}, SHIFT(1018),
  [1944] = {.count = 1, .reusable = false}, SHIFT(1019),
  [1946] = {.count = 1, .reusable = true}, SHIFT(1020),
  [1948] = {.count = 1, .reusable = true}, SHIFT(1021),
  [1950] = {.count = 1, .reusable = true}, SHIFT(1019),
  [1952] = {.count = 1, .reusable = true}, SHIFT(1022),
  [1954] = {.count = 1, .reusable = true}, SHIFT(1023),
  [1956] = {.count = 1, .reusable = true}, SHIFT(1024),
  [1958] = {.count = 1, .reusable = true}, SHIFT(1025),
  [1960] = {.count = 1, .reusable = true}, SHIFT(1026),
  [1962] = {.count = 1, .reusable = true}, SHIFT(1027),
  [1964] = {.count = 1, .reusable = false}, SHIFT(1021),
  [1966] = {.count = 1, .reusable = true}, SHIFT(1028),
  [1968] = {.count = 1, .reusable = true}, REDUCE(sym_boolean_operator, 3),
  [1970] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 3),
  [1972] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 3),
  [1974] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1031),
  [1977] = {.count = 1, .reusable = true}, REDUCE(sym_attribute, 3),
  [1979] = {.count = 1, .reusable = false}, REDUCE(sym_attribute, 3),
  [1981] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [1983] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [1985] = {.count = 1, .reusable = true}, SHIFT(1032),
  [1987] = {.count = 1, .reusable = true}, SHIFT(1033),
  [1989] = {.count = 1, .reusable = false}, SHIFT(1035),
  [1991] = {.count = 1, .reusable = false}, SHIFT(1036),
  [1993] = {.count = 1, .reusable = true}, SHIFT(1037),
  [1995] = {.count = 1, .reusable = true}, REDUCE(sym_binary_operator, 3),
  [1997] = {.count = 1, .reusable = false}, REDUCE(sym_binary_operator, 3),
  [1999] = {.count = 1, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [2001] = {.count = 1, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [2003] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2005] = {.count = 1, .reusable = false}, SHIFT(1039),
  [2007] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 1),
  [2009] = {.count = 1, .reusable = true}, SHIFT(1040),
  [2011] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2013] = {.count = 1, .reusable = true}, SHIFT(1045),
  [2015] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2017] = {.count = 1, .reusable = true}, SHIFT(1047),
  [2019] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2021] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2023] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2025] = {.count = 1, .reusable = false}, SHIFT(1052),
  [2027] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2029] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2031] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2035] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2037] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2039] = {.count = 1, .reusable = true}, SHIFT(1058),
  [2041] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2043] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2045] = {.count = 1, .reusable = false}, SHIFT(1054),
  [2047] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2049] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(182),
  [2052] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(183),
  [2055] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(182),
  [2058] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(189),
  [2061] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2063] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2),
  [2066] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2068] = {.count = 1, .reusable = true}, SHIFT(1065),
  [2070] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 3),
  [2072] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 3),
  [2074] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2076] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2078] = {.count = 1, .reusable = false}, SHIFT(1069),
  [2080] = {.count = 1, .reusable = true}, SHIFT(1070),
  [2082] = {.count = 1, .reusable = false}, SHIFT(1070),
  [2084] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2086] = {.count = 1, .reusable = false}, SHIFT(1071),
  [2088] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2090] = {.count = 1, .reusable = true}, SHIFT(1073),
  [2092] = {.count = 1, .reusable = false}, SHIFT(1073),
  [2094] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2096] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2098] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2100] = {.count = 1, .reusable = false}, SHIFT(1075),
  [2102] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2104] = {.count = 1, .reusable = false}, SHIFT(1076),
  [2106] = {.count = 1, .reusable = false}, SHIFT(1072),
  [2108] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2),
  [2110] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(207),
  [2113] = {.count = 1, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2),
  [2115] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 3),
  [2117] = {.count = 2, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2), SHIFT_REPEAT(1079),
  [2120] = {.count = 1, .reusable = true}, REDUCE(sym_aliased_import, 3),
  [2122] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(212),
  [2125] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2127] = {.count = 1, .reusable = true}, REDUCE(sym_wildcard_import, 1),
  [2129] = {.count = 1, .reusable = true}, REDUCE(sym_import_from_statement, 4),
  [2131] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2133] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2135] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2137] = {.count = 1, .reusable = true}, SHIFT(1089),
  [2139] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2141] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2143] = {.count = 1, .reusable = false}, SHIFT(1095),
  [2145] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2147] = {.count = 1, .reusable = false}, SHIFT(1096),
  [2149] = {.count = 1, .reusable = true}, SHIFT(1097),
  [2151] = {.count = 1, .reusable = false}, SHIFT(1097),
  [2153] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2155] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2157] = {.count = 1, .reusable = false}, SHIFT(1099),
  [2159] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2161] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2163] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2165] = {.count = 1, .reusable = false}, SHIFT(1101),
  [2167] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2169] = {.count = 1, .reusable = false}, SHIFT(1102),
  [2171] = {.count = 1, .reusable = false}, SHIFT(1098),
  [2173] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2175] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2177] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2179] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2181] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2183] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2187] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2189] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2191] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 4),
  [2193] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 4),
  [2195] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2),
  [2197] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2199] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2201] = {.count = 1, .reusable = false}, REDUCE(sym_boolean_operator, 3),
  [2203] = {.count = 1, .reusable = true}, REDUCE(sym_generator_expression, 4),
  [2205] = {.count = 1, .reusable = false}, REDUCE(sym_generator_expression, 4),
  [2207] = {.count = 1, .reusable = false}, SHIFT(1117),
  [2209] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2211] = {.count = 1, .reusable = false}, SHIFT(1119),
  [2213] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2215] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2217] = {.count = 1, .reusable = false}, SHIFT(1120),
  [2219] = {.count = 1, .reusable = true}, REDUCE(sym__comprehension_body, 2),
  [2221] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2223] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2), SHIFT_REPEAT(1126),
  [2226] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2228] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2230] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2232] = {.count = 1, .reusable = false}, SHIFT(1130),
  [2234] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2236] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2238] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(262),
  [2241] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(263),
  [2244] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(262),
  [2247] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(269),
  [2250] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(53),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2257] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2261] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2263] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2265] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2267] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2269] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2271] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2273] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2275] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2277] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 4),
  [2279] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(316),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2284] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2286] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2288] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2290] = {.count = 1, .reusable = false}, SHIFT(1151),
  [2292] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2296] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(304),
  [2299] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(305),
  [2302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(304),
  [2305] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(311),
  [2308] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(69),
  [2311] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2315] = {.count = 1, .reusable = false}, SHIFT(1159),
  [2317] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2319] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2323] = {.count = 1, .reusable = false}, SHIFT(1161),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2329] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2333] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2335] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2337] = {.count = 1, .reusable = false}, SHIFT(1165),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2341] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2343] = {.count = 1, .reusable = false}, SHIFT(1162),
  [2345] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 4),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2349] = {.count = 1, .reusable = false}, REDUCE(sym_expression_list, 3),
  [2351] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1171),
  [2354] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2356] = {.count = 1, .reusable = false}, SHIFT(1172),
  [2358] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(338),
  [2361] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(339),
  [2364] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(338),
  [2367] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(345),
  [2370] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2372] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2374] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [2376] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [2378] = {.count = 1, .reusable = false}, SHIFT(1177),
  [2380] = {.count = 1, .reusable = false}, SHIFT(1178),
  [2382] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2384] = {.count = 1, .reusable = false}, SHIFT(1181),
  [2386] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(357),
  [2389] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(358),
  [2392] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(357),
  [2395] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(364),
  [2398] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2400] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2402] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2404] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2406] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2408] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variables_repeat1, 2),
  [2410] = {.count = 1, .reusable = false}, REDUCE(sym_variables, 3),
  [2412] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variables_repeat1, 2), SHIFT_REPEAT(1190),
  [2415] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 4),
  [2417] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 4),
  [2419] = {.count = 1, .reusable = true}, REDUCE(sym__suite, 2),
  [2421] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2423] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2425] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2427] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2429] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2431] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2433] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2435] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2437] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2439] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2441] = {.count = 1, .reusable = true}, SHIFT(794),
  [2443] = {.count = 1, .reusable = true}, SHIFT(795),
  [2445] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2447] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2449] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2451] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2453] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4),
  [2455] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4),
  [2457] = {.count = 1, .reusable = false}, SHIFT(802),
  [2459] = {.count = 1, .reusable = false}, SHIFT(803),
  [2461] = {.count = 1, .reusable = true}, REDUCE(aux_sym_with_statement_repeat1, 2),
  [2463] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 4),
  [2465] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 4),
  [2467] = {.count = 2, .reusable = true}, REDUCE(aux_sym_with_statement_repeat1, 2), SHIFT_REPEAT(388),
  [2470] = {.count = 1, .reusable = true}, REDUCE(sym_with_item, 3),
  [2472] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2474] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2476] = {.count = 1, .reusable = false}, SHIFT(1219),
  [2478] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(397),
  [2481] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(398),
  [2484] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(397),
  [2487] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(404),
  [2490] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 2),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2494] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2496] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2498] = {.count = 1, .reusable = false}, SHIFT(1223),
  [2500] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2502] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2504] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2506] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2508] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2510] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2512] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2514] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2516] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2518] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2520] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2522] = {.count = 1, .reusable = true}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [2524] = {.count = 2, .reusable = true}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(409),
  [2527] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 4),
  [2529] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 4),
  [2531] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 4),
  [2533] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 4),
  [2535] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary_splat, 3),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2539] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2541] = {.count = 1, .reusable = false}, SHIFT(1247),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2545] = {.count = 1, .reusable = false}, SHIFT(1248),
  [2547] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2549] = {.count = 1, .reusable = false}, SHIFT(1249),
  [2551] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2555] = {.count = 1, .reusable = false}, SHIFT(1251),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2559] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2561] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2563] = {.count = 1, .reusable = false}, SHIFT(1253),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2567] = {.count = 1, .reusable = false}, SHIFT(1254),
  [2569] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2571] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2, .alias_sequence_id = 4),
  [2573] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2),
  [2575] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2577] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2579] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2581] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2583] = {.count = 1, .reusable = false}, SHIFT(1263),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2587] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2589] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2591] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2593] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2595] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2597] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2599] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2601] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2603] = {.count = 1, .reusable = false}, SHIFT(1265),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2609] = {.count = 1, .reusable = true}, REDUCE(sym_default_parameter, 3, .alias_sequence_id = 1),
  [2611] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3, .alias_sequence_id = 1),
  [2613] = {.count = 2, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(1276),
  [2616] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2618] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2620] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2622] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2624] = {.count = 1, .reusable = false}, SHIFT(1283),
  [2626] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2628] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2630] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2632] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2634] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2636] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2638] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2640] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2642] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2644] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2646] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2648] = {.count = 1, .reusable = true}, REDUCE(sym_typed_parameter, 3),
  [2650] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2652] = {.count = 1, .reusable = true}, REDUCE(sym_default_parameter, 3),
  [2654] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3),
  [2656] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 4),
  [2658] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2660] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2662] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2664] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2666] = {.count = 1, .reusable = false}, SHIFT(1301),
  [2668] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2670] = {.count = 1, .reusable = false}, SHIFT(1302),
  [2672] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2674] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2676] = {.count = 1, .reusable = false}, SHIFT(1304),
  [2678] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2680] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2682] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2684] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2686] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2688] = {.count = 1, .reusable = false}, SHIFT(1307),
  [2690] = {.count = 1, .reusable = false}, SHIFT(1303),
  [2692] = {.count = 1, .reusable = true}, REDUCE(sym_list, 4),
  [2694] = {.count = 1, .reusable = false}, REDUCE(sym_list, 4),
  [2696] = {.count = 1, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2),
  [2698] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2700] = {.count = 2, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(1312),
  [2703] = {.count = 1, .reusable = true}, SHIFT(1313),
  [2705] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2707] = {.count = 1, .reusable = true}, REDUCE(sym_list_comprehension, 4),
  [2709] = {.count = 1, .reusable = false}, REDUCE(sym_list_comprehension, 4),
  [2711] = {.count = 1, .reusable = false}, SHIFT(1316),
  [2713] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2715] = {.count = 1, .reusable = false}, SHIFT(1318),
  [2717] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2719] = {.count = 1, .reusable = false}, SHIFT(1321),
  [2721] = {.count = 1, .reusable = false}, SHIFT(1319),
  [2723] = {.count = 1, .reusable = true}, SHIFT(1324),
  [2725] = {.count = 1, .reusable = false}, SHIFT(1324),
  [2727] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(466),
  [2730] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(467),
  [2733] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(466),
  [2736] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(473),
  [2739] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2741] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2743] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2745] = {.count = 1, .reusable = true}, SHIFT(1330),
  [2747] = {.count = 1, .reusable = false}, SHIFT(1330),
  [2749] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2751] = {.count = 1, .reusable = false}, SHIFT(1331),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2755] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2757] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2761] = {.count = 1, .reusable = false}, SHIFT(1334),
  [2763] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2765] = {.count = 1, .reusable = false}, SHIFT(1335),
  [2767] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2769] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2771] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2773] = {.count = 1, .reusable = true}, REDUCE(sym_set, 4),
  [2775] = {.count = 1, .reusable = false}, REDUCE(sym_set, 4),
  [2777] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2779] = {.count = 2, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(1341),
  [2782] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 4),
  [2784] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 4),
  [2786] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dictionary_repeat1, 2),
  [2788] = {.count = 1, .reusable = true}, SHIFT(1342),
  [2790] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2792] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dictionary_repeat1, 2), SHIFT_REPEAT(1344),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2797] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2799] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [2801] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2803] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2807] = {.count = 1, .reusable = false}, SHIFT(1352),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2811] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2815] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2817] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2819] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2821] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2823] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2825] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2827] = {.count = 1, .reusable = false}, SHIFT(1354),
  [2829] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2831] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2833] = {.count = 1, .reusable = true}, REDUCE(sym_set_comprehension, 4),
  [2835] = {.count = 1, .reusable = false}, REDUCE(sym_set_comprehension, 4),
  [2837] = {.count = 1, .reusable = false}, SHIFT(1366),
  [2839] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2841] = {.count = 1, .reusable = false}, SHIFT(1368),
  [2843] = {.count = 1, .reusable = true}, SHIFT(1371),
  [2845] = {.count = 1, .reusable = false}, SHIFT(1371),
  [2847] = {.count = 1, .reusable = false}, SHIFT(1369),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1374),
  [2851] = {.count = 1, .reusable = false}, SHIFT(1374),
  [2853] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(503),
  [2856] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(504),
  [2859] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(503),
  [2862] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(510),
  [2865] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary_comprehension, 4),
  [2867] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary_comprehension, 4),
  [2869] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 4),
  [2871] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 4),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1379),
  [2877] = {.count = 1, .reusable = false}, SHIFT(1379),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1380),
  [2881] = {.count = 1, .reusable = false}, SHIFT(1380),
  [2883] = {.count = 1, .reusable = true}, SHIFT(1381),
  [2885] = {.count = 1, .reusable = false}, SHIFT(1381),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1382),
  [2889] = {.count = 1, .reusable = true}, SHIFT(1383),
  [2891] = {.count = 1, .reusable = false}, SHIFT(1383),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1384),
  [2895] = {.count = 1, .reusable = false}, SHIFT(1384),
  [2897] = {.count = 1, .reusable = true}, SHIFT(1385),
  [2899] = {.count = 1, .reusable = false}, SHIFT(1385),
  [2901] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2903] = {.count = 1, .reusable = false}, SHIFT(1386),
  [2905] = {.count = 1, .reusable = false}, SHIFT(1382),
  [2907] = {.count = 1, .reusable = true}, SHIFT(1390),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1392),
  [2911] = {.count = 1, .reusable = true}, SHIFT(1396),
  [2913] = {.count = 1, .reusable = false}, SHIFT(1396),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1397),
  [2917] = {.count = 1, .reusable = false}, SHIFT(1397),
  [2919] = {.count = 1, .reusable = true}, SHIFT(1398),
  [2921] = {.count = 1, .reusable = false}, SHIFT(1398),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1399),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1400),
  [2927] = {.count = 1, .reusable = false}, SHIFT(1400),
  [2929] = {.count = 1, .reusable = true}, SHIFT(1401),
  [2931] = {.count = 1, .reusable = false}, SHIFT(1401),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1402),
  [2935] = {.count = 1, .reusable = false}, SHIFT(1402),
  [2937] = {.count = 1, .reusable = true}, SHIFT(1403),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1403),
  [2941] = {.count = 1, .reusable = false}, SHIFT(1399),
  [2943] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [2945] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [2947] = {.count = 1, .reusable = true}, SHIFT(1409),
  [2949] = {.count = 1, .reusable = true}, SHIFT(1412),
  [2951] = {.count = 1, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [2953] = {.count = 1, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [2955] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 2),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1415),
  [2959] = {.count = 1, .reusable = true}, SHIFT(1417),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1418),
  [2963] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2965] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [2967] = {.count = 1, .reusable = true}, SHIFT(1424),
  [2969] = {.count = 1, .reusable = true}, SHIFT(1426),
  [2971] = {.count = 1, .reusable = false}, SHIFT(1426),
  [2973] = {.count = 1, .reusable = true}, SHIFT(1427),
  [2975] = {.count = 1, .reusable = false}, SHIFT(1427),
  [2977] = {.count = 1, .reusable = true}, SHIFT(1428),
  [2979] = {.count = 1, .reusable = false}, SHIFT(1428),
  [2981] = {.count = 1, .reusable = true}, SHIFT(1429),
  [2983] = {.count = 1, .reusable = true}, SHIFT(1430),
  [2985] = {.count = 1, .reusable = false}, SHIFT(1430),
  [2987] = {.count = 1, .reusable = true}, SHIFT(1431),
  [2989] = {.count = 1, .reusable = false}, SHIFT(1431),
  [2991] = {.count = 1, .reusable = true}, SHIFT(1432),
  [2993] = {.count = 1, .reusable = false}, SHIFT(1432),
  [2995] = {.count = 1, .reusable = true}, SHIFT(1433),
  [2997] = {.count = 1, .reusable = false}, SHIFT(1433),
  [2999] = {.count = 1, .reusable = false}, SHIFT(1429),
  [3001] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3003] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 4),
  [3005] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 4),
  [3007] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3009] = {.count = 1, .reusable = false}, SHIFT(1438),
  [3011] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(580),
  [3014] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(581),
  [3017] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(580),
  [3020] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(587),
  [3023] = {.count = 1, .reusable = true}, SHIFT(1440),
  [3025] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3027] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3029] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3031] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3033] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1447),
  [3036] = {.count = 1, .reusable = true}, SHIFT(1448),
  [3038] = {.count = 1, .reusable = false}, SHIFT(1448),
  [3040] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(621),
  [3043] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(622),
  [3046] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(621),
  [3049] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(628),
  [3052] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3054] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3056] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3058] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3060] = {.count = 1, .reusable = false}, SHIFT(1454),
  [3062] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3064] = {.count = 1, .reusable = true}, REDUCE(sym_if_clause, 2),
  [3066] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3068] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3070] = {.count = 1, .reusable = false}, SHIFT(1464),
  [3072] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3074] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3076] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3078] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3080] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3082] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3084] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3086] = {.count = 1, .reusable = true}, SHIFT(1471),
  [3088] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3090] = {.count = 1, .reusable = false}, SHIFT(1466),
  [3092] = {.count = 1, .reusable = true}, SHIFT(1473),
  [3094] = {.count = 1, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2),
  [3096] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(652),
  [3099] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(251),
  [3102] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(252),
  [3105] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 5),
  [3107] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 5),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3115] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3117] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3119] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3121] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3123] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3127] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3131] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3133] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3135] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3137] = {.count = 1, .reusable = false}, SHIFT(1491),
  [3139] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(726),
  [3142] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(727),
  [3145] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(726),
  [3148] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(733),
  [3151] = {.count = 1, .reusable = false}, REDUCE(sym__suite, 2),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3155] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3157] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3159] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3161] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3163] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 5),
  [3165] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 5),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3169] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [3171] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [3173] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3175] = {.count = 1, .reusable = true}, SHIFT(1510),
  [3177] = {.count = 1, .reusable = true}, SHIFT(1511),
  [3179] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3181] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3183] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3185] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3187] = {.count = 1, .reusable = true}, SHIFT(1520),
  [3189] = {.count = 1, .reusable = true}, REDUCE(sym__suite, 3),
  [3191] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(788),
  [3194] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(789),
  [3197] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(790),
  [3200] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(791),
  [3203] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(792),
  [3206] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(793),
  [3209] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(794),
  [3212] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(795),
  [3215] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3221] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 5),
  [3223] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 5),
  [3225] = {.count = 1, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [3227] = {.count = 1, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [3229] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(802),
  [3232] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3234] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3236] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3238] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3240] = {.count = 1, .reusable = false}, SHIFT(1535),
  [3242] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3244] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3246] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3248] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3250] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3252] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3254] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3256] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3258] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3260] = {.count = 1, .reusable = false}, SHIFT(1537),
  [3262] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3264] = {.count = 1, .reusable = false}, SHIFT(1547),
  [3266] = {.count = 1, .reusable = false}, SHIFT(1548),
  [3268] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3270] = {.count = 1, .reusable = false}, SHIFT(1554),
  [3272] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3274] = {.count = 1, .reusable = false}, SHIFT(1556),
  [3276] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3278] = {.count = 1, .reusable = false}, SHIFT(1559),
  [3280] = {.count = 1, .reusable = false}, SHIFT(1557),
  [3282] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3284] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 3),
  [3286] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3288] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3290] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3292] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 5),
  [3294] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 5),
  [3296] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 5),
  [3298] = {.count = 1, .reusable = true}, SHIFT(1567),
  [3300] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3302] = {.count = 1, .reusable = false}, SHIFT(1568),
  [3304] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(852),
  [3307] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(853),
  [3310] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(852),
  [3313] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(859),
  [3316] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3318] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3320] = {.count = 1, .reusable = false}, SHIFT(1573),
  [3322] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3324] = {.count = 1, .reusable = false}, SHIFT(1574),
  [3326] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3328] = {.count = 1, .reusable = false}, SHIFT(1575),
  [3330] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3332] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3334] = {.count = 1, .reusable = false}, SHIFT(1577),
  [3336] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3338] = {.count = 1, .reusable = false}, SHIFT(1578),
  [3340] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3342] = {.count = 1, .reusable = false}, SHIFT(1579),
  [3344] = {.count = 1, .reusable = true}, SHIFT(1580),
  [3346] = {.count = 1, .reusable = false}, SHIFT(1580),
  [3348] = {.count = 1, .reusable = false}, SHIFT(1576),
  [3350] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3352] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3354] = {.count = 1, .reusable = false}, SHIFT(1588),
  [3356] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3358] = {.count = 1, .reusable = false}, SHIFT(1589),
  [3360] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3362] = {.count = 1, .reusable = false}, SHIFT(1590),
  [3364] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3366] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3368] = {.count = 1, .reusable = false}, SHIFT(1592),
  [3370] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3372] = {.count = 1, .reusable = false}, SHIFT(1593),
  [3374] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3376] = {.count = 1, .reusable = false}, SHIFT(1594),
  [3378] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3380] = {.count = 1, .reusable = false}, SHIFT(1595),
  [3382] = {.count = 1, .reusable = false}, SHIFT(1591),
  [3384] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3386] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3388] = {.count = 1, .reusable = false}, SHIFT(1601),
  [3390] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(898),
  [3393] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(899),
  [3396] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(898),
  [3399] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(905),
  [3402] = {.count = 1, .reusable = true}, REDUCE(sym_list, 5),
  [3404] = {.count = 1, .reusable = false}, REDUCE(sym_list, 5),
  [3406] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3408] = {.count = 1, .reusable = false}, SHIFT(1604),
  [3410] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3412] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3414] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3416] = {.count = 1, .reusable = false}, SHIFT(1613),
  [3418] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3420] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3422] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3424] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3426] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3428] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3430] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3432] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3434] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3436] = {.count = 1, .reusable = false}, SHIFT(1615),
  [3438] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3440] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(920),
  [3443] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(458),
  [3446] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(459),
  [3449] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3451] = {.count = 1, .reusable = true}, SHIFT(1627),
  [3453] = {.count = 1, .reusable = false}, SHIFT(1627),
  [3455] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(941),
  [3458] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(942),
  [3461] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(941),
  [3464] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(948),
  [3467] = {.count = 1, .reusable = true}, REDUCE(sym_set, 5),
  [3469] = {.count = 1, .reusable = false}, REDUCE(sym_set, 5),
  [3471] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 5),
  [3473] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 5),
  [3475] = {.count = 1, .reusable = true}, SHIFT(1631),
  [3477] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3479] = {.count = 1, .reusable = false}, SHIFT(1634),
  [3481] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3483] = {.count = 1, .reusable = false}, SHIFT(1635),
  [3485] = {.count = 1, .reusable = true}, SHIFT(1636),
  [3487] = {.count = 1, .reusable = false}, SHIFT(1636),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1637),
  [3491] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3493] = {.count = 1, .reusable = false}, SHIFT(1638),
  [3495] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3497] = {.count = 1, .reusable = false}, SHIFT(1639),
  [3499] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3501] = {.count = 1, .reusable = false}, SHIFT(1640),
  [3503] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3505] = {.count = 1, .reusable = false}, SHIFT(1641),
  [3507] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3509] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3511] = {.count = 1, .reusable = false}, SHIFT(1645),
  [3513] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3515] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3517] = {.count = 1, .reusable = true}, SHIFT(1653),
  [3519] = {.count = 1, .reusable = false}, SHIFT(1654),
  [3521] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3523] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3525] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3527] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3529] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3531] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3533] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3535] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3537] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3539] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3541] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3543] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(976),
  [3546] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(495),
  [3549] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(496),
  [3552] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3554] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3556] = {.count = 1, .reusable = false}, SHIFT(1668),
  [3558] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(999),
  [3561] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1000),
  [3564] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(999),
  [3567] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1006),
  [3570] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 5),
  [3572] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3574] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5),
  [3576] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3578] = {.count = 1, .reusable = false}, SHIFT(1671),
  [3580] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1021),
  [3583] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1022),
  [3586] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1021),
  [3589] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1028),
  [3592] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_argument, 3, .alias_sequence_id = 1),
  [3594] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_argument, 3),
  [3596] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 4),
  [3598] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 4),
  [3600] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [3602] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3604] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1673),
  [3607] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 3),
  [3609] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [3611] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [3613] = {.count = 1, .reusable = true}, REDUCE(aux_sym_subscript_repeat1, 2),
  [3615] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3619] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3621] = {.count = 2, .reusable = true}, REDUCE(aux_sym_subscript_repeat1, 2), SHIFT_REPEAT(1679),
  [3624] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3626] = {.count = 1, .reusable = false}, SHIFT(1680),
  [3628] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1054),
  [3631] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1055),
  [3634] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1054),
  [3637] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1061),
  [3640] = {.count = 1, .reusable = true}, REDUCE(sym_import_from_statement, 6),
  [3642] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3644] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3646] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3648] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 4),
  [3650] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3652] = {.count = 1, .reusable = true}, REDUCE(sym__expression_within_for_in_clause, 1),
  [3654] = {.count = 1, .reusable = true}, REDUCE(sym__expression_within_for_in_clause, 1, .alias_sequence_id = 5),
  [3656] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3658] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3660] = {.count = 1, .reusable = false}, SHIFT(1698),
  [3662] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3664] = {.count = 1, .reusable = false}, SHIFT(1699),
  [3666] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3668] = {.count = 1, .reusable = false}, SHIFT(1700),
  [3670] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3672] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3674] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3676] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3678] = {.count = 1, .reusable = false}, SHIFT(1703),
  [3680] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3682] = {.count = 1, .reusable = false}, SHIFT(1704),
  [3684] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3686] = {.count = 1, .reusable = false}, SHIFT(1705),
  [3688] = {.count = 1, .reusable = false}, SHIFT(1701),
  [3690] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3692] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3694] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3696] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3698] = {.count = 1, .reusable = false}, REDUCE(sym__suite, 3),
  [3700] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3702] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [3704] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [3706] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3708] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3710] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(1177),
  [3713] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 6),
  [3715] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 6),
  [3717] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6),
  [3719] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6),
  [3721] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3723] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [3725] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [3727] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1718),
  [3730] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3732] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3734] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3736] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3738] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3740] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3742] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3744] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3746] = {.count = 1, .reusable = true}, SHIFT(1736),
  [3748] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 3),
  [3750] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 3),
  [3752] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 3),
  [3754] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 3),
  [3756] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 6),
  [3758] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 6),
  [3760] = {.count = 1, .reusable = true}, SHIFT(1740),
  [3762] = {.count = 1, .reusable = true}, SHIFT(1743),
  [3764] = {.count = 1, .reusable = false}, SHIFT(1743),
  [3766] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3768] = {.count = 1, .reusable = false}, SHIFT(1744),
  [3770] = {.count = 1, .reusable = true}, SHIFT(1745),
  [3772] = {.count = 1, .reusable = false}, SHIFT(1745),
  [3774] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3776] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3778] = {.count = 1, .reusable = false}, SHIFT(1747),
  [3780] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3782] = {.count = 1, .reusable = false}, SHIFT(1748),
  [3784] = {.count = 1, .reusable = true}, SHIFT(1749),
  [3786] = {.count = 1, .reusable = false}, SHIFT(1749),
  [3788] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3790] = {.count = 1, .reusable = false}, SHIFT(1750),
  [3792] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3794] = {.count = 1, .reusable = true}, SHIFT(1753),
  [3796] = {.count = 2, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(1754),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1756),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3803] = {.count = 1, .reusable = true}, SHIFT(1759),
  [3805] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3807] = {.count = 1, .reusable = false}, SHIFT(1761),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3811] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3813] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3815] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3819] = {.count = 1, .reusable = true}, SHIFT(1766),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3823] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3825] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3827] = {.count = 1, .reusable = false}, SHIFT(1763),
  [3829] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1772),
  [3833] = {.count = 1, .reusable = true}, SHIFT(1777),
  [3835] = {.count = 1, .reusable = true}, SHIFT(1778),
  [3837] = {.count = 1, .reusable = false}, SHIFT(1778),
  [3839] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1265),
  [3842] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1266),
  [3845] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1265),
  [3848] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1272),
  [3851] = {.count = 1, .reusable = true}, REDUCE(sym_typed_default_parameter, 5, .alias_sequence_id = 1),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3855] = {.count = 1, .reusable = true}, SHIFT(1781),
  [3857] = {.count = 1, .reusable = false}, SHIFT(1781),
  [3859] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1285),
  [3862] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1286),
  [3865] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1285),
  [3868] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1292),
  [3871] = {.count = 1, .reusable = true}, REDUCE(sym_typed_default_parameter, 5),
  [3873] = {.count = 1, .reusable = true}, SHIFT(1784),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1786),
  [3877] = {.count = 1, .reusable = true}, SHIFT(1789),
  [3879] = {.count = 1, .reusable = true}, SHIFT(1792),
  [3881] = {.count = 1, .reusable = false}, SHIFT(1792),
  [3883] = {.count = 1, .reusable = true}, SHIFT(1793),
  [3885] = {.count = 1, .reusable = false}, SHIFT(1793),
  [3887] = {.count = 1, .reusable = true}, SHIFT(1794),
  [3889] = {.count = 1, .reusable = false}, SHIFT(1794),
  [3891] = {.count = 1, .reusable = true}, SHIFT(1795),
  [3893] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3895] = {.count = 1, .reusable = false}, SHIFT(1796),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1797),
  [3899] = {.count = 1, .reusable = false}, SHIFT(1797),
  [3901] = {.count = 1, .reusable = true}, SHIFT(1798),
  [3903] = {.count = 1, .reusable = false}, SHIFT(1798),
  [3905] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3907] = {.count = 1, .reusable = false}, SHIFT(1799),
  [3909] = {.count = 1, .reusable = false}, SHIFT(1795),
  [3911] = {.count = 1, .reusable = true}, SHIFT(1804),
  [3913] = {.count = 1, .reusable = true}, SHIFT(1805),
  [3915] = {.count = 1, .reusable = false}, SHIFT(1805),
  [3917] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1354),
  [3920] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1355),
  [3923] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1354),
  [3926] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1361),
  [3929] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3931] = {.count = 1, .reusable = true}, SHIFT(1809),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1812),
  [3935] = {.count = 1, .reusable = true}, SHIFT(1815),
  [3937] = {.count = 1, .reusable = false}, SHIFT(1815),
  [3939] = {.count = 1, .reusable = true}, SHIFT(1816),
  [3941] = {.count = 1, .reusable = false}, SHIFT(1816),
  [3943] = {.count = 1, .reusable = true}, SHIFT(1817),
  [3945] = {.count = 1, .reusable = false}, SHIFT(1817),
  [3947] = {.count = 1, .reusable = true}, SHIFT(1818),
  [3949] = {.count = 1, .reusable = true}, SHIFT(1819),
  [3951] = {.count = 1, .reusable = false}, SHIFT(1819),
  [3953] = {.count = 1, .reusable = true}, SHIFT(1820),
  [3955] = {.count = 1, .reusable = false}, SHIFT(1820),
  [3957] = {.count = 1, .reusable = true}, SHIFT(1821),
  [3959] = {.count = 1, .reusable = false}, SHIFT(1821),
  [3961] = {.count = 1, .reusable = true}, SHIFT(1822),
  [3963] = {.count = 1, .reusable = false}, SHIFT(1822),
  [3965] = {.count = 1, .reusable = false}, SHIFT(1818),
  [3967] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 5),
  [3969] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 5),
  [3971] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 4),
  [3973] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [3975] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [3977] = {.count = 2, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2), SHIFT_REPEAT(1829),
  [3980] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 5),
  [3982] = {.count = 1, .reusable = true}, SHIFT(1830),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1833),
  [3986] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 5),
  [3988] = {.count = 1, .reusable = true}, SHIFT(1461),
  [3990] = {.count = 1, .reusable = true}, SHIFT(1837),
  [3992] = {.count = 1, .reusable = true}, SHIFT(1838),
  [3994] = {.count = 1, .reusable = false}, SHIFT(1838),
  [3996] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1466),
  [3999] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1467),
  [4002] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1466),
  [4005] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1473),
  [4008] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 3),
  [4010] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 3),
  [4012] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [4014] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4018] = {.count = 1, .reusable = false}, SHIFT(1844),
  [4020] = {.count = 1, .reusable = false}, SHIFT(1845),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4024] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4026] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1853),
  [4030] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4032] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4034] = {.count = 1, .reusable = false}, SHIFT(1727),
  [4036] = {.count = 1, .reusable = false}, SHIFT(1728),
  [4038] = {.count = 1, .reusable = true}, SHIFT(1864),
  [4040] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 4),
  [4042] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 4),
  [4044] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4046] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4048] = {.count = 1, .reusable = false}, SHIFT(1867),
  [4050] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1537),
  [4053] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1538),
  [4056] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1537),
  [4059] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1544),
  [4062] = {.count = 1, .reusable = true}, SHIFT(1870),
  [4064] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4066] = {.count = 1, .reusable = false}, SHIFT(1873),
  [4068] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4070] = {.count = 1, .reusable = false}, SHIFT(1874),
  [4072] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4074] = {.count = 1, .reusable = false}, SHIFT(1875),
  [4076] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4080] = {.count = 1, .reusable = false}, SHIFT(1877),
  [4082] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4084] = {.count = 1, .reusable = false}, SHIFT(1878),
  [4086] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4088] = {.count = 1, .reusable = false}, SHIFT(1879),
  [4090] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4092] = {.count = 1, .reusable = false}, SHIFT(1880),
  [4094] = {.count = 1, .reusable = false}, SHIFT(1876),
  [4096] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 7),
  [4098] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 7),
  [4100] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4102] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1610),
  [4106] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4110] = {.count = 1, .reusable = false}, SHIFT(1892),
  [4112] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1615),
  [4115] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1616),
  [4118] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1615),
  [4121] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1622),
  [4124] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4126] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4128] = {.count = 1, .reusable = true}, SHIFT(1651),
  [4130] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4132] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4134] = {.count = 1, .reusable = false}, SHIFT(1900),
  [4136] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1656),
  [4139] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1657),
  [4142] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1656),
  [4145] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1663),
  [4148] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 5),
  [4150] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 6),
  [4152] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 6),
  [4154] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4156] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_within_for_in_clause, 3),
  [4158] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2),
  [4160] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(1903),
  [4163] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 4),
  [4165] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [4167] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8),
  [4169] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8),
  [4171] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 8),
  [4173] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 8),
  [4175] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4177] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4179] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4181] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4183] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4185] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1727),
  [4188] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1924),
  [4192] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4194] = {.count = 1, .reusable = false}, SHIFT(1925),
  [4196] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1763),
  [4199] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1764),
  [4202] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1763),
  [4205] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1770),
  [4208] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4210] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(1927),
  [4213] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4215] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(1930),
  [4218] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 7),
  [4220] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 7),
  [4222] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_within_for_in_clause, 4),
  [4224] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4226] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(1844),
  [4229] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4231] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 6),
  [4233] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 6),
  [4235] = {.count = 1, .reusable = true}, SHIFT(1944),
};

void *tree_sitter_python_external_scanner_create();
void tree_sitter_python_external_scanner_destroy(void *);
bool tree_sitter_python_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_python_external_scanner_serialize(void *, char *);
void tree_sitter_python_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_python() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_python_external_scanner_create,
      tree_sitter_python_external_scanner_destroy,
      tree_sitter_python_external_scanner_scan,
      tree_sitter_python_external_scanner_serialize,
      tree_sitter_python_external_scanner_deserialize,
    },
  };
  return &language;
}
